/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode
      || !register_operand (operands[1], E_TImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      if (!memory_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4QImode:
      res = pattern15 (x3, 
E_V4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_V8QImode:
      res = pattern16 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      res = pattern15 (x3, 
E_V4HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V2HImode:
      if (!memory_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 8;

    case E_V2SImode:
      if (!memory_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern5 (x3, 
E_V32QImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 4;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 8;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 9;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 10;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern45 (x5); /* [-1, 3] */
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!mask_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !mask_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mask_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !mask_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!mask_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mask_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !mask_reg_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern63 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern102 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern104 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern119 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern119 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern119 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern119 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern119 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern119 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern119 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern119 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern119 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        case E_V16SImode:
          if (pattern120 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 9;

        case E_V8SImode:
          if (pattern120 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern121 (x1, 
E_QImode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8DImode:
          if (pattern120 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 12;

        case E_V4DImode:
          if (pattern120 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 13;

        case E_V2DImode:
          if (pattern120 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 14;

        case E_V64QImode:
          if (pattern120 (x1, 
E_V64QImode, 
E_DImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern121 (x1, 
E_HImode, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern120 (x1, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 17;

        case E_V32HImode:
          if (pattern120 (x1, 
E_V32HImode, 
E_SImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern120 (x1, 
E_V16HImode, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_V8HImode:
          if (pattern120 (x1, 
E_V8HImode, 
E_QImode) != 0)
            return -1;
          return 20;

        case E_V32BFmode:
          if (pattern122 (x1, 
E_V32BFmode, 
E_SImode) != 0)
            return -1;
          return 21;

        case E_V16BFmode:
          if (pattern122 (x1, 
E_V16BFmode, 
E_HImode) != 0)
            return -1;
          return 22;

        case E_V8BFmode:
          if (pattern122 (x1, 
E_V8BFmode, 
E_QImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern124 (x1);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern163 (x3, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern163 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern163 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x6, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      return pattern179 (x1); /* [-1, 0] */

    case 8:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x4, 0, 5);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x4, 0, 6);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x4, 0, 7);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x7, 0, 4);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      x25 = XVECEXP (x7, 0, 5);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x7, 0, 6);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x27 = XVECEXP (x7, 0, 7);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (XWINT (x14, 0))
        {
        case 4L:
          if (XWINT (x15, 0) != 6L
              || XWINT (x16, 0) != 8L
              || XWINT (x17, 0) != 10L
              || XWINT (x22, 0) != 5L
              || XWINT (x23, 0) != 7L
              || XWINT (x24, 0) != 9L
              || XWINT (x25, 0) != 11L
              || pattern180 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case 8L:
          if (XWINT (x15, 0) != 10L
              || XWINT (x16, 0) != 4L
              || XWINT (x17, 0) != 6L
              || XWINT (x22, 0) != 9L
              || XWINT (x23, 0) != 11L
              || XWINT (x24, 0) != 5L
              || XWINT (x25, 0) != 7L
              || pattern178 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 4:
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x4, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x14 = XVECEXP (x4, 0, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x15 = XVECEXP (x4, 0, 3);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x20 = XVECEXP (x7, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XVECEXP (x7, 0, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x22 = XVECEXP (x7, 0, 2);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x23 = XVECEXP (x7, 0, 3);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern180 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MOD)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      return 0;

    case CONST_INT:
      return 1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern231 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      return pattern230 (x1); /* [-1, 0] */

    default:
      return -1;
    }
}

int
pattern241 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  return pattern41 (x4); /* [-1, 1] */
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return pattern243 (x2); /* [-1, 1] */

    case PLUS:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern243 (x2);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern2 (x2);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  return pattern262 (x1); /* [-1, 2] */
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern268 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern268 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern268 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != SIGN_EXTEND)
    return -1;
  return 0;
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern298 (x1, 
E_V4DImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern298 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!nonimmediate_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return pattern309 (x2); /* [-1, 3] */
}

int
pattern316 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case SET:
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_QImode:
          return pattern315 (x10, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern315 (x10, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern315 (x10, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !const_1_to_63_operand (operands[2], E_QImode)
              || !nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x10) != E_DImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      switch (GET_MODE (x6))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_HImode))
            return -1;
          return 5;

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !const_1_to_31_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 6;

        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !const_1_to_63_operand (operands[2], E_QImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!int_nonimmediate_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern362 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ZERO_EXTRACT)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x3 = XEXP (x1, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern368 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern368 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern385 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern384 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern384 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern396 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern396 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern396 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern405 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i4)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern417 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  operands[2] = x4;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern431 (x1, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern431 (x1, 
E_V16HFmode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V32HImode:
      if (pattern431 (x1, 
E_V32HFmode, 
E_V32HImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 3;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 5;

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 7;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 8;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern453 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern458 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i2)
      || !const0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern463 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XINT (x2, 1) != 151)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (XVECLEN (x5, 0))
    {
    case 16:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          return pattern462 (x1, 
E_V32HImode, 
E_V16HImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern462 (x1, 
E_V32QImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 8:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern462 (x1, 
E_V16HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V8SImode:
          if (pattern462 (x1, 
E_V16SImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 32:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x5, 0, 4);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x5, 0, 8);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x5, 0, 9);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x16 = XVECEXP (x5, 0, 10);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x17 = XVECEXP (x5, 0, 11);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x18 = XVECEXP (x5, 0, 12);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x19 = XVECEXP (x5, 0, 13);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x20 = XVECEXP (x5, 0, 14);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x21 = XVECEXP (x5, 0, 15);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x22 = XVECEXP (x5, 0, 16);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x23 = XVECEXP (x5, 0, 17);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x24 = XVECEXP (x5, 0, 18);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
        return -1;
      x25 = XVECEXP (x5, 0, 19);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
        return -1;
      x26 = XVECEXP (x5, 0, 20);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
        return -1;
      x27 = XVECEXP (x5, 0, 21);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
        return -1;
      x28 = XVECEXP (x5, 0, 22);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
        return -1;
      x29 = XVECEXP (x5, 0, 23);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
        return -1;
      x30 = XVECEXP (x5, 0, 24);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x31 = XVECEXP (x5, 0, 25);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x32 = XVECEXP (x5, 0, 26);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x33 = XVECEXP (x5, 0, 27);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x34 = XVECEXP (x5, 0, 28);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x35 = XVECEXP (x5, 0, 29);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x36 = XVECEXP (x5, 0, 30);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x37 = XVECEXP (x5, 0, 31);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern462 (x1, 
E_V64QImode, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case 4:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern462 (x1, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern530 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !const_int_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !const_int_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !const_int_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !const_int_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern540 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern539 (x1, 
E_V32HFmode, 
E_V16SFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern539 (x1, 
E_V16HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern539 (x1, 
E_V8HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern547 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  return 0;
}

int
pattern550 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern556 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SFmode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_V4SFmode)
          || !nonimm_or_0_operand (operands[2], E_V2DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern581 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern584 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  operands[4] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[5] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern580 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern580 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V8DFmode:
      if (pattern580 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern593 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern592 (x1, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern592 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern599 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern599 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern599 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  return 0;
}

int
pattern640 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i1
      || GET_MODE (x6) != E_CCCmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCOmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x3) != E_CCOmode)
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  x12 = XEXP (x9, 0);
  operands[0] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x10, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x4, 1);
  switch (GET_CODE (x15))
    {
    case SIGN_EXTEND:
      x16 = XEXP (x15, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return -1;
      x18 = XEXP (x10, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_TImode:
          return pattern652 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

        case E_POImode:
          if (pattern652 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x15;
      x17 = XEXP (x7, 1);
      operands[2] = x17;
      x18 = XEXP (x10, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_TImode:
          if (pattern653 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 2;

        case E_POImode:
          if (pattern653 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern685 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern692 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern699 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern706 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern705 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern705 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern705 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern719 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern728 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern734 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern743 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern752 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 17
          || GET_MODE (x2) != E_CCmode)
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 174)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        case E_SImode:
          return 3;

        case E_DImode:
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern757 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern761 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern632 (x5, 
E_V2BFmode); /* [-1, 0] */

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern632 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 1;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 2;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 5;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 6;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 7;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 10;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 11;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 12;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern788 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern798 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (XWINT (x2, 0) != 1L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern562 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern562 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern804 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern812 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  return pattern811 (x3); /* [-1, 0] */
}

int
pattern816 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != E_V2DImode
      || GET_MODE (x3) != i2)
    return -1;
  x7 = XEXP (x3, 0);
  if (GET_MODE (x7) != i1
      || !nonimm_or_0_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern826 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern830 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_VECTOR
      || XVECLEN (x4, 0) != 2
      || GET_MODE (x4) != E_V2SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return pattern441 (x2); /* [-1, 1] */
}

int
pattern836 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern842 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern845 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern850 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern850 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern851 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern851 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern865 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !float_vector_all_ones_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern871 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[4] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 2);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x1, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern876 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimm_or_0_operand (operands[1], E_V16QImode)
              || !nonimm_or_0_operand (operands[2], E_V16QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!nonimm_or_0_operand (operands[1], E_V16HImode)
              || !nonimm_or_0_operand (operands[2], E_V16HImode))
            return -1;
          return 1;

        case E_V16SImode:
          if (!nonimm_or_0_operand (operands[1], E_V16SImode)
              || !nonimm_or_0_operand (operands[2], E_V16SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimm_or_0_operand (operands[1], E_V8HImode)
              || !nonimm_or_0_operand (operands[2], E_V8HImode))
            return -1;
          return 3;

        case E_V8SImode:
          if (!nonimm_or_0_operand (operands[1], E_V8SImode)
              || !nonimm_or_0_operand (operands[2], E_V8SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!nonimm_or_0_operand (operands[1], E_V4SImode)
              || !nonimm_or_0_operand (operands[2], E_V4SImode))
            return -1;
          return 5;

        case E_V8DImode:
          if (!nonimm_or_0_operand (operands[1], E_V8DImode)
              || !nonimm_or_0_operand (operands[2], E_V8DImode))
            return -1;
          return 6;

        case E_V4DImode:
          if (!nonimm_or_0_operand (operands[1], E_V4DImode)
              || !nonimm_or_0_operand (operands[2], E_V4DImode))
            return -1;
          return 7;

        case E_V2DImode:
          if (!nonimm_or_0_operand (operands[1], E_V2DImode)
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern894 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern900 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern908 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern917 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern927 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern921 (x1, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern921 (x1, 
E_V8DFmode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern946 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != SUBREG
          || maybe_ne (SUBREG_BYTE (x7), 0)
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          return pattern945 (x1); /* [-1, 4] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern960 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern971 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  return pattern680 (); /* [-1, 2] */
}

int
pattern979 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode))
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1044 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1052 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern195 (x1); /* [-1, 3] */
}

int
pattern1056 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 109
      || GET_MODE (x6) != E_CCZmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern1066 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1074 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!ix86_carry_flag_operator (x5, i1))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!flags_reg_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!memory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  return pattern1073 (x12, 
i1); /* [-1, 1] */
}

int
pattern1087 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x1, operands[1]))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1096 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || GET_MODE (x5) != E_V16QImode
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (GET_MODE (x4) != E_V4SImode
              || !vector_all_ones_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (GET_MODE (x4) != E_V2DImode
              || !vector_all_ones_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !register_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x5) != E_V32QImode
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (GET_MODE (x4) != E_V8SImode
              || !vector_all_ones_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (GET_MODE (x4) != E_V4DImode
              || !vector_all_ones_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case AND:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case PLUS:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    case MINUS:
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1141 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!general_reg_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!general_reg_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !ix86_carry_flag_unset_operator (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !ix86_carry_flag_unset_operator (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  operands[5] = x3;
  if (!const_0_to_31_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern1171 (x1, 
E_V8SFmode, 
E_V8SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1171 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern1171 (x1, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1171 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SImode
      || !nonimm_or_0_operand (operands[2], E_V8SImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1197 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  if (XVECLEN (x10, 0) != 2)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x10, 0, 1);
  if (GET_CODE (x12) != CONST_INT
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != E_V2DImode
      || GET_MODE (x3) != E_V2DImode
      || GET_MODE (x4) != E_V2SImode
      || !nonimmediate_operand (operands[1], E_V4SImode))
    return -1;
  return 0;
}

int
pattern1216 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern505 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1223 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1241 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1248 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1247 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1257 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1266 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1255 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1283 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      x4 = XVECEXP (x1, 0, 1);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return 0;

        case E_V16SFmode:
          return 1;

        case E_V8DFmode:
          return 2;

        case E_V16HFmode:
          return 3;

        case E_V8HFmode:
          return 4;

        case E_V8SFmode:
          return 5;

        case E_V4SFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 9;

        case E_V4SFmode:
          return 10;

        case E_V2DFmode:
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1303 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      return pattern1312 (x3, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1312 (x3, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1325 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

int
pattern1342 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 7);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 8);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 9);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 10);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || pattern1334 (x1) != 0)
    return -1;
  return 0;
}

int
pattern1355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1365 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_carry_flag_unset_operator (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1386 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      x4 = XEXP (x3, 0);
      if (!plusminuslogic_operator (x4, i1))
        return -1;
      operands[3] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], i1))
        return -1;
      x9 = XEXP (x4, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      if (peep2_current_count < 4)
        return -1;
      operands[3] = x3;
      if (!plusminuslogic_operator (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[4]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern1425 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern1425 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1434 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1449 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern1459 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1458 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1458 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1471 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 4)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1499 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[4]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1526 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LTU:
    case UNLT:
      operands[5] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern1536 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 16);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  return 0;
}

int
pattern1544 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[5], i3))
    return -1;
  return 0;
}

int
pattern1554 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[2], E_VOIDmode)
      || !const_0_to_7_operand (operands[3], E_VOIDmode)
      || !const_0_to_7_operand (operands[4], E_VOIDmode)
      || !const_0_to_7_operand (operands[5], E_VOIDmode)
      || !const_0_to_7_operand (operands[6], E_VOIDmode)
      || !const_0_to_7_operand (operands[7], E_VOIDmode)
      || !const_0_to_7_operand (operands[8], E_VOIDmode)
      || !const_0_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1564 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[6]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      return pattern1563 (x3, 
E_HImode, 
E_V16SImode); /* [-1, 1] */

    case E_QImode:
      x2 = XVECEXP (x1, 0, 2);
      x3 = XEXP (x2, 0);
      res = pattern1563 (x3, 
E_QImode, 
E_V8DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x1, 0);
      switch (GET_MODE (x9))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1594 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1603 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[4]))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[5]))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1613 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      if (!register_operand (operands[2], E_V16SImode)
          || !register_operand (operands[6], E_HImode)
          || !register_operand (operands[3], E_V16SImode)
          || !scratch_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (pattern1612 (
E_QImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1621 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1632 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1631 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1631 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1643 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern1650 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !const_4_to_7_operand (operands[7], E_VOIDmode)
      || !const_4_to_7_operand (operands[8], E_VOIDmode)
      || !const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1660 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_V8SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1668 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1674 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23L)
    return -1;
  return 0;
}

int
pattern1678 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1686 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[5], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1697 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_0_to_15_operand (operands[11], E_VOIDmode)
      || !const_0_to_15_operand (operands[12], E_VOIDmode)
      || !const_0_to_15_operand (operands[13], E_VOIDmode)
      || !const_0_to_15_operand (operands[14], E_VOIDmode)
      || !const_0_to_15_operand (operands[15], E_VOIDmode)
      || !const_0_to_15_operand (operands[16], E_VOIDmode)
      || !const_0_to_15_operand (operands[17], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1705 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_reg_operand (operands[0], i1)
      || !memory_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2
      || !ix86_carry_flag_operator (operands[3], i2))
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = PATTERN (peep2_next_insn (1));
  x13 = XEXP (x12, 1);
  switch (GET_CODE (x13))
    {
    case REG:
      if (!rtx_equal_p (x13, operands[0]))
        return -1;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 0;

    case LTU:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x13) != E_QImode)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 17
          || GET_MODE (x15) != E_CCCmode)
        return -1;
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x12, 0);
      operands[5] = x14;
      if (!general_reg_operand (operands[5], E_QImode))
        return -1;
      x17 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != ZERO_EXTEND
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x17, 0);
      operands[6] = x19;
      if (!general_reg_operand (operands[6], i1))
        return -1;
      x20 = XEXP (x18, 0);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x21) != SET)
        return -1;
      x22 = XEXP (x21, 1);
      if (!rtx_equal_p (x22, operands[0]))
        return -1;
      x23 = XEXP (x21, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 1
          || XINT (x9, 1) != 109
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!flags_reg_operand (operands[0], E_CCmode)
          || GET_MODE (x2) != E_CCmode
          || !comparison_operator (operands[1], E_VOIDmode)
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XVECEXP (x9, 0, 0);
      operands[4] = x13;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[2], E_QImode)
              || !general_operand (operands[3], E_QImode)
              || !
#line 1539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 1; /* ccmpqi */

        case E_HImode:
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !general_operand (operands[3], E_HImode)
              || !
#line 1539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 2; /* ccmphi */

        case E_SImode:
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !x86_64_general_operand (operands[3], E_SImode)
              || !
#line 1539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_CCMP))
            return -1;
          return 3; /* ccmpsi */

        default:
          return -1;
        }

    case LABEL_REF:
      x9 = XEXP (x2, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != PC
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      return 1203; /* *jcc */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x6;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1078 (x2, 
E_HImode) != 0
              || !
#line 26339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1452; /* *movhicc_noc */

        case E_QImode:
          if (pattern1079 (x2) != 0
              || !
#line 26413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
            return -1;
          return 1454; /* *movqicc_noc */

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !fcmov_comparison_operator (operands[1], E_VOIDmode)
              || !register_operand (operands[2], E_XFmode)
              || !register_operand (operands[3], E_XFmode)
              || !
#line 26607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
            return -1;
          return 1456; /* *movxfcc_1 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || pattern1138 (x2, 
E_DFmode) != 0
              || !
#line 26622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1457; /* *movdfcc_1 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || pattern1138 (x2, 
E_SFmode) != 0
              || !
#line 26657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          return 1458; /* *movsfcc_1_387 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 24:
          return recog_6 (x1, insn, pnum_clobbers);

        case 25:
          if (pattern58 (x1, 
E_HImode, 
E_CCmode) != 0
              || !
#line 1994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SAHF))
            return -1;
          return 46; /* x86_sahf_1 */

        case 26:
          return recog_5 (x1, insn, pnum_clobbers);

        case 44:
          if (GET_MODE (x2) != E_CCFPmode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x3) != COMPARE
              || GET_MODE (x3) != E_CCFPmode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 17
              || GET_MODE (x4) != E_CCFPmode)
            return -1;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !
#line 2045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 49; /* *cmpxsf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 2045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 51; /* *cmpxdf */

            case E_HFmode:
              if (!register_operand (operands[0], E_HFmode)
                  || !nonimmediate_operand (operands[1], E_HFmode)
                  || !
#line 2058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 53; /* *cmpxhf */

            default:
              return -1;
            }

        case 41:
          if (pattern60 (x1, 
E_CCCmode) != 0)
            return -1;
          return 62; /* x86_stc */

        case 42:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!flags_reg_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!push_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !(
#line 2323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
                return -1;
              return 74; /* pushflsi2 */

            case E_DImode:
              if (!push_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 2323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
                return -1;
              return 75; /* pushfldi2 */

            default:
              return -1;
            }

        case 43:
          if (GET_MODE (x2) != E_CCmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!flags_reg_operand (operands[0], E_CCmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!pop_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 76; /* popflsi1 */

            case E_DImode:
              if (!pop_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 77; /* popfldi1 */

            default:
              return -1;
            }

        case 60:
          if (GET_MODE (x2) != E_SFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_BFmode)
              || !
#line 5471 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE2))
            return -1;
          return 164; /* extendbfsf2_1 */

        case 28:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_HImode)
              || !
#line 6045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 190; /* x86_fnstcw_1 */

        case 97:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 21738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return 1271; /* tzcnt_hi_nf */
          if (pnum_clobbers == NULL
              || !(
#line 21738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(true) && 
#line 21648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI)))
            return -1;
          *pnum_clobbers = 1;
          return 1272; /* tzcnt_hi */

        case 96:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 21738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return 1273; /* lzcnt_hi_nf */
          if (pnum_clobbers == NULL
              || !(
#line 21738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(true) && 
#line 21649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LZCNT)))
            return -1;
          *pnum_clobbers = 1;
          return 1274; /* lzcnt_hi */

        case 27:
          if (pattern58 (x1, 
E_QImode, 
E_CCmode) != 0)
            return -1;
          return 1320; /* parityqi2_cmp */

        case 54:
          switch (pattern61 (x1))
            {
            case 0:
              if (!
#line 23475 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && TARGET_SSE_MATH))
                return -1;
              return 1340; /* *rcpsf2_sse */

            case 1:
              if (!
#line 23501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              return 1341; /* rcphf2 */

            default:
              return -1;
            }

        case 31:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !
#line 23718 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
                return -1;
              return 1366; /* truncxfsf2_i387_noop_unspec */

            case E_DFmode:
              if (!nonimmediate_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !
#line 23718 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
                return -1;
              return 1367; /* truncxfdf2_i387_noop_unspec */

            default:
              return -1;
            }

        case 55:
          switch (pattern61 (x1))
            {
            case 0:
              if (!
#line 23738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 1369; /* *rsqrtsf2_sse */

            case 1:
              if (!
#line 23774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              return 1370; /* rsqrthf2 */

            default:
              return -1;
            }

        case 64:
          if (GET_MODE (x2) != E_XFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_XFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 24041 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1377; /* sinxf2 */

        case 65:
          if (GET_MODE (x2) != E_XFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_XFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 24041 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1378; /* cosxf2 */

        case 71:
          if (GET_MODE (x2) != E_XFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_XFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 24667 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1385; /* *f2xm1xf2_i387 */

        case 69:
          if (GET_MODE (x2) != E_XFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_XFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 25001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1392; /* rintxf2 */

        case 70:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 25142 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1394; /* lrintxfhi2 */

        case 74:
          if (pattern62 (x1, pnum_clobbers) != 0
              || !
#line 25232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1396; /* frndintxf2_roundeven */

        case 75:
          if (pattern62 (x1, pnum_clobbers) != 0
              || !
#line 25232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1397; /* frndintxf2_floor */

        case 76:
          if (pattern62 (x1, pnum_clobbers) != 0
              || !
#line 25232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1398; /* frndintxf2_ceil */

        case 77:
          if (pattern62 (x1, pnum_clobbers) != 0
              || !
#line 25232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1399; /* frndintxf2_trunc */

        case 78:
          if (pattern63 (x1, pnum_clobbers) != 0
              || !
#line 25349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1404; /* *fisthi2_floor_1 */

        case 79:
          if (pattern63 (x1, pnum_clobbers) != 0
              || !
#line 25349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1405; /* *fisthi2_ceil_1 */

        case 73:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 25451 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
                return -1;
              return 1416; /* fxamsf2_i387 */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 25451 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
                return -1;
              return 1417; /* fxamdf2_i387 */

            case E_XFmode:
              if (!register_operand (operands[1], E_XFmode)
                  || !
#line 25451 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
                return -1;
              return 1418; /* fxamxf2_i387 */

            default:
              return -1;
            }

        case 112:
          if (GET_MODE (x2) != E_V2SFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_V2SFmode)
              || !
#line 900 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
            return -1;
          return 1633; /* mmx_rcpv2sf2 */

        case 115:
          if (GET_MODE (x2) != E_V2SFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V2SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_V2SFmode)
              || !
#line 948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
            return -1;
          return 1636; /* mmx_rsqrtv2sf2 */

        case 172:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 8441 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
                return -1;
              return 4176; /* unspec_sse_cvttps2pi */

            case E_V2DFmode:
              if (!vector_operand (operands[1], E_V2DFmode)
                  || !
#line 8905 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4272; /* unspec_sse2_cvttpd2pi */

            default:
              return -1;
            }

        case 46:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V2SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 8887 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4271; /* sse2_cvtpd2pi */

        case 191:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[1], E_V16QImode)
                      || !(
#line 10246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4521; /* avx512vl_cvtb2maskv16qi */

                case E_V16HImode:
                  if (!register_operand (operands[1], E_V16HImode)
                      || !(
#line 10246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4524; /* avx512vl_cvtw2maskv16hi */

                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4526; /* avx512f_cvtd2maskv16si */

                default:
                  return -1;
                }

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !(
#line 10246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4525; /* avx512vl_cvtw2maskv8hi */

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4527; /* avx512vl_cvtd2maskv8si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4528; /* avx512vl_cvtd2maskv4si */

                case E_V8DImode:
                  if (!register_operand (operands[1], E_V8DImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4529; /* avx512f_cvtq2maskv8di */

                case E_V4DImode:
                  if (!register_operand (operands[1], E_V4DImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4530; /* avx512vl_cvtq2maskv4di */

                case E_V2DImode:
                  if (!register_operand (operands[1], E_V2DImode)
                      || !(
#line 10256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4531; /* avx512vl_cvtq2maskv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 117:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case REG:
            case SUBREG:
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (!memory_operand (operands[0], E_SFmode)
                      || GET_MODE (x2) != E_SFmode
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 23402 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                    return -1;
                  return 7965; /* sse4a_movntsf */

                case E_DFmode:
                  if (!memory_operand (operands[0], E_DFmode)
                      || GET_MODE (x2) != E_DFmode
                      || !register_operand (operands[1], E_DFmode)
                      || !
#line 23402 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                    return -1;
                  return 7966; /* sse4a_movntdf */

                default:
                  return -1;
                }

            case VEC_SELECT:
              x6 = XEXP (x3, 1);
              if (GET_CODE (x6) != PARALLEL
                  || XVECLEN (x6, 0) != 1)
                return -1;
              x7 = XVECEXP (x6, 0, 0);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern964 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 23414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
                    return -1;
                  return 7967; /* sse4a_vmmovntv4sf */

                case E_DFmode:
                  if (pattern964 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                      || !(
#line 23414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 7968; /* sse4a_vmmovntv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 136:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8347; /* xop_frczsf2 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8348; /* xop_frczdf2 */

            default:
              return -1;
            }

        case 283:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !
#line 346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(TARGET_80387))
            return -1;
          return 10262; /* loaddi_via_fpu */

        case 285:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !
#line 369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(TARGET_SSE))
            return -1;
          return 10264; /* loaddi_via_sse */

        default:
          return -1;
        }

    case 2:
      return recog_11 (x1, insn, pnum_clobbers);

    case 3:
      return recog_10 (x1, insn, pnum_clobbers);

    case 5:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 131
          || pattern229 (x1) != 0
          || !register_operand (operands[3], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 2);
      operands[4] = x8;
      if (!nonimmediate_operand (operands[4], E_V16QImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[5] = x9;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x10 = XVECEXP (x2, 0, 4);
      operands[6] = x10;
      if (!const_0_to_255_operand (operands[6], E_SImode)
          || !
#line 25936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      *pnum_clobbers = 2;
      return 8274; /* sse4_2_pcmpestr_cconly */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern683 (x2, 
E_HImode) != 0
              || !
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 678; /* *notxorhi_1 */

        case E_QImode:
          if (pattern683 (x2, 
E_QImode) != 0
              || !
#line 13809 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 708; /* *notxorqi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern42 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 841; /* *one_cmplti2_doubleword */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 842; /* *one_cmplhi2_1 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 850; /* *one_cmplqi2_1 */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode))
                return -1;
              return 1787; /* one_cmplv4qi2 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x2) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode))
                return -1;
              return 1788; /* one_cmplv2qi2 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode))
                return -1;
              return 1789; /* one_cmplv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 15061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 851; /* *one_cmplqi_1_slp */

        case 2:
          if (!
#line 15061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 852; /* *one_cmplhi_1_slp */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x3, 0, 2);
      operands[3] = x9;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern879 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2860; /* *avx512f_cmpv16si3 */

                case 1:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 2867; /* *avx512vl_cmpv16hf3 */

                case 2:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2869; /* *avx512f_cmpv16sf3 */

                case 3:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2925; /* *avx512vl_cmpv16qi3 */

                case 4:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2931; /* *avx512vl_cmpv16hi3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern880 (x2))
                {
                case 0:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2861; /* *avx512vl_cmpv8si3 */

                case 1:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2862; /* *avx512vl_cmpv4si3 */

                case 2:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2863; /* *avx512f_cmpv8di3 */

                case 3:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2864; /* *avx512vl_cmpv4di3 */

                case 4:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2865; /* *avx512vl_cmpv2di3 */

                case 5:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 2868; /* *avx512fp16_cmpv8hf3 */

                case 6:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2870; /* *avx512vl_cmpv8sf3 */

                case 7:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2871; /* *avx512vl_cmpv4sf3 */

                case 8:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2872; /* *avx512f_cmpv8df3 */

                case 9:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2873; /* *avx512vl_cmpv4df3 */

                case 10:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2874; /* *avx512vl_cmpv2df3 */

                case 11:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2933; /* *avx512vl_cmpv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern971 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2926; /* *avx512vl_cmpv16qi3 */

                case 1:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2932; /* *avx512vl_cmpv16hi3 */

                case 2:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3079; /* *avx512f_ucmpv16si3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern972 (x2))
                {
                case 0:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2934; /* *avx512vl_cmpv8hi3 */

                case 1:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3080; /* *avx512vl_ucmpv8si3 */

                case 2:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3081; /* *avx512vl_ucmpv4si3 */

                case 3:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3082; /* *avx512f_ucmpv8di3 */

                case 4:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3083; /* *avx512vl_ucmpv4di3 */

                case 5:
                  if (!(
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3084; /* *avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern92 (x3, 
E_V2SFmode, 
E_SFmode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_V2SFmode)
          || pattern1693 (x3) != 0
          || !
#line 995 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW
   && INTVAL (operands[3]) != INTVAL (operands[4])
   && INTVAL (operands[5]) != INTVAL (operands[6])))
        return -1;
      return 1638; /* *mmx_haddv2sf3 */

    case MINUS:
      if (pattern93 (x4, 
E_SFmode) != 0
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x8 = XEXP (x4, 0);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_CODE (x5))
        {
        case MINUS:
          if (pattern1407 (x5, 
E_SFmode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x12 = XEXP (x5, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1043 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
            return -1;
          return 1639; /* mmx_hsubv2sf3 */

        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_SELECT
              || GET_MODE (x6) != E_SFmode)
            return -1;
          x14 = XEXP (x6, 1);
          if (GET_CODE (x14) != PARALLEL
              || XVECLEN (x14, 0) != 1)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_SFmode)
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2SFmode))
            return -1;
          x16 = XVECEXP (x14, 0, 0);
          operands[3] = x16;
          if (!const_0_to_1_operand (operands[3], E_SImode))
            return -1;
          x17 = XVECEXP (x15, 0, 0);
          operands[4] = x17;
          if (!const_0_to_1_operand (operands[4], E_SImode))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2])
              || !
#line 1105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A
   && INTVAL (operands[3]) != INTVAL (operands[4])))
            return -1;
          return 1640; /* *mmx_haddsubv2sf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SFmode))
            {
              if (
#line 1755 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 1650; /* *mmx_concatv2sf */
              if (
#line 11739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 4611; /* *vec_concatv2sf_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SFmode)
              || !
#line 11803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 4612; /* *vec_concatv2sf_sse */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (nonimm_or_0_operand (operands[2], E_SImode))
            {
              if (
#line 5701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX && !TARGET_SSE))
                return 1845; /* *mmx_concatv2si */
              if (
#line 21493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 7815; /* *vec_concatv2si_sse4_1 */
            }
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !
#line 21542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !TARGET_SSE4_1))
            return -1;
          return 7816; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      switch (pattern247 (x3))
        {
        case 0:
          if (!
#line 4771 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 1814; /* mmx_packsswb */

        case 1:
          if (!
#line 4812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 1816; /* mmx_packssdw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern379 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 212; /* *adddi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 6615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 224; /* *adddi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 6615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 225; /* *adddi_1 */
                }
            }
          break;

        case 1:
          if (
#line 6615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 222; /* *addsi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 6615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            {
              *pnum_clobbers = 1;
              return 223; /* *addsi_1 */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_SImode)
          || pattern380 (x3, 
22) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!tls_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 23292 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1330; /* *tls_dynamic_gnu2_lea_32 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (!nonimmediate_operand (x8, E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          operands[2] = x8;
          if (!(
#line 6511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 214; /* *adddi3_doubleword_zext */

        case ASHIFT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          operands[1] = x8;
          switch (pattern109 (x5))
            {
            case 0:
              if (!(
#line 14079 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 728; /* *concatsidi3_2 */

            case 1:
              if (!(
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 737; /* *concatsidi3_4 */

            case 2:
              if (!(
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 740; /* *concatsidi3_4 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
          operands[2] = x5;
          if (!const_scalar_int_operand (operands[2], E_DImode))
            return -1;
          operands[1] = x8;
          if (!(
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 761; /* *concatsidi3_7 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          switch (pattern99 (x3))
            {
            case 0:
              if (!(
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 216; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 219; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x8;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1154 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 377; /* addsi3_carry */

            case E_DImode:
              if (pattern1154 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 378; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1083 (x3, 
E_SImode) != 0
                  || !
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 465; /* *addsi3_eq */

            case E_DImode:
              if (pattern1083 (x3, 
E_DImode) != 0
                  || !(
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 466; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1084 (x3, 
E_SImode) != 0
                  || !
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 469; /* *addsi3_ne */

            case E_DImode:
              if (pattern1084 (x3, 
E_DImode) != 0
                  || !(
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 470; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern100 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 217; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 220; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern100 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 218; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 221; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern101 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern975 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 381; /* *addsi3_carry_0 */

        case 1:
          if (pattern975 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern101 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern976 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *addsi3_carry_0r */

        case 1:
          if (pattern976 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 386; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 473; /* *addsi3_eq_0 */

        case 1:
          if (!(
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 474; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 477; /* *addsi3_ne_0 */

        case 1:
          if (!(
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 478; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case NE:
          switch (pattern690 (x3))
            {
            case 0:
              if (!
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 485; /* *subsi3_ne */

            case 1:
              if (!(
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 486; /* *subdi3_ne */

            default:
              return -1;
            }

        case EQ:
          switch (pattern690 (x3))
            {
            case 0:
              if (!
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 489; /* *subsi3_eq_1 */

            case 1:
              if (!(
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 490; /* *subdi3_eq_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (pattern249 (x5))
            {
            case 0:
              if (!(
#line 14062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 725; /* *concatsidi3_1 */

            case 1:
              if (!(
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 743; /* *concatsidi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern887 (x3))
            {
            case 0:
              if (!(
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 731; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 749; /* *concatsidi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern887 (x3))
            {
            case 0:
              if (!(
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 734; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 752; /* *concatsidi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern549 (x5, 
E_CCCmode, 
E_SImode, 
ASHIFT) != 0)
        return -1;
      x12 = XEXP (x5, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 1142; /* rcrsi2 */

    case UNSPEC:
      if (pnum_clobbers == NULL)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 21
              || GET_MODE (x4) != E_SImode)
            return -1;
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7
              || GET_MODE (x13) != E_SImode
              || pattern380 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[2] = x15;
          if (!constant_call_address_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[3] = x7;
          if (!tls_symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          *pnum_clobbers = 3;
          return 1323; /* *tls_local_dynamic_32_once */

        case 1:
          if (XINT (x4, 1) != 19)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern888 (x3, 
E_SImode) != 0
                  || !
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1327; /* *add_tp_si */

            case E_DImode:
              if (pattern888 (x3, 
E_DImode) != 0
                  || !
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1328; /* *add_tp_di */

            default:
              return -1;
            }

        case 4:
          if (XINT (x4, 1) != 22
              || GET_MODE (x4) != E_SImode)
            return -1;
          x16 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 7
              || GET_MODE (x16) != E_SImode
              || pattern380 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[3] = x14;
          if (!tls_modbase_operand (operands[3], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[4] = x15;
          x13 = XVECEXP (x4, 0, 2);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[1] = x7;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 23326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1332; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern697 (x3, 
E_SImode) != 0
              || !
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 679; /* *notxorsi_1 */

        case E_DImode:
          if (pattern697 (x3, 
E_DImode) != 0
              || !(
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 680; /* *notxordi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern114 (x3))
        {
        case 0:
          if ((
#line 14978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 840; /* *one_cmpldi2_doubleword */
          if (!(
#line 14991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 844; /* *one_cmpldi2_1 */

        case 1:
          if (!
#line 14991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 843; /* *one_cmplsi2_1 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern890 (x3))
                {
                case 0:
                  if (!(
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return -1;
                  return 2866; /* *avx512bw_cmpv32hf3 */

                case 1:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2927; /* *avx512vl_cmpv32qi3 */

                case 2:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2929; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            case E_DImode:
              if (pattern891 (x3) != 0
                  || !(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2923; /* *avx512bw_cmpv64qi3 */

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern985 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2924; /* *avx512bw_cmpv64qi3 */

            case E_SImode:
              switch (pattern986 (x3))
                {
                case 0:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 2928; /* *avx512vl_cmpv32qi3 */

                case 1:
                  if (!(
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 2930; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pnum_clobbers != NULL)
        {
          x2 = XEXP (x1, 1);
          if (pattern663 (x2, 
E_DImode, 
E_QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 922; /* ashrdi3_doubleword */
            }
        }
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      if (const_int_operand (operands[2], E_QImode))
        {
          if ((
#line 17246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 945; /* ashrdi3_cvt_nf */
          if (pnum_clobbers != NULL
              && (
#line 17246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 946; /* ashrdi3_cvt */
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      if ((
#line 17325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return 951; /* *ashrdi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 17325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 952; /* *ashrdi3_1 */

    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern678 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 17325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 949; /* *ashrsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 17325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 950; /* *ashrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode
          || pattern391 (x2) != 0)
        return -1;
      if ((
#line 16738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 923; /* lshrdi3_doubleword_lowpart_nf */
      if (pnum_clobbers == NULL
          || !(
#line 16759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 925; /* lshrdi3_doubleword_lowpart */

    case ASHIFTRT:
      if (GET_MODE (x4) != E_DImode
          || pattern391 (x2) != 0)
        return -1;
      if ((
#line 16738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 924; /* ashrdi3_doubleword_lowpart_nf */
      if (pnum_clobbers == NULL
          || !(
#line 16759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 926; /* ashrdi3_doubleword_lowpart */

    case SS_TRUNCATE:
      switch (pattern259 (x2))
        {
        case 0:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6664; /* *avx512vl_ss_truncatev4siv4qi2_store_2 */

        case 1:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6667; /* *avx512vl_ss_truncatev4div4qi2_store_2 */

        case 2:
          if (!
#line 15844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6761; /* *avx512vl_ss_truncatev2div2hi2_store_2 */

        case 3:
          if (!(
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6694; /* *avx512vl_ss_truncatev8hiv8qi2_store_2 */

        case 4:
          if (!
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6697; /* *avx512vl_ss_truncatev8siv8qi2_store_2 */

        case 5:
          if (!
#line 16107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 6798; /* *avx512f_ss_truncatev8div16qi2_store_2 */

        case 6:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6734; /* *avx512vl_ss_truncatev4siv4hi2_store_2 */

        case 7:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6737; /* *avx512vl_ss_truncatev4div4hi2_store_2 */

        case 8:
          if (!
#line 15994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6780; /* *avx512vl_ss_truncatev2div2si2_store_2 */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern259 (x2))
        {
        case 0:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6665; /* *avx512vl_truncatev4siv4qi2_store_2 */

        case 1:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6668; /* *avx512vl_truncatev4div4qi2_store_2 */

        case 2:
          if (!
#line 15844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6762; /* *avx512vl_truncatev2div2hi2_store_2 */

        case 3:
          if (!(
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6695; /* *avx512vl_truncatev8hiv8qi2_store_2 */

        case 4:
          if (!
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6698; /* *avx512vl_truncatev8siv8qi2_store_2 */

        case 5:
          if (!
#line 16107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 6799; /* *avx512f_truncatev8div16qi2_store_2 */

        case 6:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6735; /* *avx512vl_truncatev4siv4hi2_store_2 */

        case 7:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6738; /* *avx512vl_truncatev4div4hi2_store_2 */

        case 8:
          if (!
#line 15994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6781; /* *avx512vl_truncatev2div2si2_store_2 */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern259 (x2))
        {
        case 0:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6666; /* *avx512vl_us_truncatev4siv4qi2_store_2 */

        case 1:
          if (!
#line 15493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6669; /* *avx512vl_us_truncatev4div4qi2_store_2 */

        case 2:
          if (!
#line 15844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6763; /* *avx512vl_us_truncatev2div2hi2_store_2 */

        case 3:
          if (!(
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6696; /* *avx512vl_us_truncatev8hiv8qi2_store_2 */

        case 4:
          if (!
#line 15591 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6699; /* *avx512vl_us_truncatev8siv8qi2_store_2 */

        case 5:
          if (!
#line 16107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 6800; /* *avx512f_us_truncatev8div16qi2_store_2 */

        case 6:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6736; /* *avx512vl_us_truncatev4siv4hi2_store_2 */

        case 7:
          if (!
#line 15753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6739; /* *avx512vl_us_truncatev4div4hi2_store_2 */

        case 8:
          if (!
#line 15994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return -1;
          return 6782; /* *avx512vl_us_truncatev2div2si2_store_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern564 (x2))
    {
    case 0:
      if (pattern567 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3821; /* avx512fp16_vcvtph2w_v32hi_mask */

    case 1:
      switch (pattern895 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3829; /* avx512fp16_vcvtph2dq_v16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4216; /* avx512f_fix_notruncv16sfv16si_mask */

        default:
          return -1;
        }

    case 2:
      switch (pattern894 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3837; /* avx512fp16_vcvtph2qq_v8di_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8707 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4232; /* avx512dq_cvtps2qqv8di_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4434; /* fix_notruncv8dfv8di2_mask */

        default:
          return -1;
        }

    case 3:
      if (pattern567 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3845; /* avx512fp16_vcvtph2w_v16hi_mask */

    case 4:
      if (pattern128 (x2, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3853; /* avx512fp16_vcvtph2dq_v8si_mask */

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL)) && 
#line 665 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4211; /* avx_fix_notruncv8sfv8si_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9388 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4352; /* avx512f_cvtpd2dq512_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern993 (x2, 
E_V4DImode))
        {
        case 0:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3861; /* avx512fp16_vcvtph2qq_v4di_mask */

        case 1:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8707 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4235; /* avx512dq_cvtps2qqv4di_mask */

        case 2:
          if (!vector_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4437; /* fix_notruncv4dfv4di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern567 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3869; /* avx512fp16_vcvtph2w_v8hi_mask */

    case 7:
      switch (pattern993 (x2, 
E_V4SImode))
        {
        case 0:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3877; /* avx512fp16_vcvtph2dq_v4si_mask */

        case 1:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL))))
            return -1;
          return 4213; /* sse2_fix_notruncv4sfv4si_mask */

        case 2:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4355; /* avx_cvtpd2dq256_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern992 (x2))
        {
        case 0:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3885; /* avx512fp16_vcvtph2qq_v2di_mask */

        case 1:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4439; /* fix_notruncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8720 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 4237; /* avx512dq_cvtps2qqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern407 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 6485; /* avx512bw_rndscalev32hf_mask */

        case E_V16HFmode:
          if (pattern407 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6489; /* avx512vl_rndscalev16hf_mask */

        case E_V8HFmode:
          if (pattern407 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 6493; /* avx512fp16_rndscalev8hf_mask */

        case E_V16SFmode:
          if (pattern407 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6497; /* avx512f_rndscalev16sf_mask */

        case E_V8SFmode:
          if (pattern407 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6501; /* avx512vl_rndscalev8sf_mask */

        case E_V4SFmode:
          if (pattern407 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6505; /* avx512vl_rndscalev4sf_mask */

        case E_V8DFmode:
          if (pattern407 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6509; /* avx512f_rndscalev8df_mask */

        case E_V4DFmode:
          if (pattern407 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6513; /* avx512vl_rndscalev4df_mask */

        case E_V2DFmode:
          if (pattern407 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6517; /* avx512vl_rndscalev2df_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L)
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1096 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (const_0_to_255_operand (operands[3], E_SImode)
              && (
#line 14225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return 6519; /* avx512f_rndscalev8hf */
          if (!const_0_to_15_operand (operands[3], E_SImode)
              || !(
#line 25563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 8265; /* sse4_1_roundsh */

        case E_V4SFmode:
          if (pattern1096 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (const_0_to_255_operand (operands[3], E_SImode)
              && 
#line 14225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 6523; /* avx512f_rndscalev4sf */
          if (!const_0_to_15_operand (operands[3], E_SImode)
              || !
#line 25563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8266; /* sse4_1_roundss */

        case E_V2DFmode:
          if (pattern1096 (x2, 
E_V2DFmode) != 0)
            return -1;
          if (const_0_to_255_operand (operands[3], E_SImode)
              && (
#line 14225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 6527; /* avx512f_rndscalev2df */
          if (!const_0_to_15_operand (operands[3], E_SImode)
              || !(
#line 25563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8267; /* sse4_1_roundsd */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[5] = x7;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern412 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9253; /* avx512dq_rangepv16sf_mask */

        case E_V8SFmode:
          if (pattern412 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9256; /* avx512dq_rangepv8sf_mask */

        case E_V4SFmode:
          if (pattern412 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9258; /* avx512dq_rangepv4sf_mask */

        case E_V8DFmode:
          if (pattern412 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9261; /* avx512dq_rangepv8df_mask */

        case E_V4DFmode:
          if (pattern412 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9264; /* avx512dq_rangepv4df_mask */

        case E_V2DFmode:
          if (pattern412 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9266; /* avx512dq_rangepv2df_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x7, 0) != 1L)
        return -1;
      switch (pattern999 (x2))
        {
        case 0:
          if (!
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ))
            return -1;
          return 9267; /* avx512dq_rangesv4sf */

        case 1:
          if (!(
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9271; /* avx512dq_rangesv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 192:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2674; /* reducesv8hf */

        case 1:
          if (!
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))
            return -1;
          return 2678; /* reducesv4sf */

        case 2:
          if (!(
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2682; /* reducesv2df */

        default:
          return -1;
        }

    case 59:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!cmpps_imm_operand (operands[3], E_SImode))
        return -1;
      switch (pattern999 (x2))
        {
        case 0:
          if (!
#line 4317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2718; /* avx_vmcmpv4sf3 */

        case 1:
          if (!(
#line 4317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2719; /* avx_vmcmpv2df3 */

        default:
          return -1;
        }

    case 133:
      return recog_117 (x1, insn, pnum_clobbers);

    case 217:
      switch (pattern411 (x2))
        {
        case 0:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3733; /* fma_fmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3740; /* fma_fmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3744; /* fma_fmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3771; /* avx512bw_fmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3775; /* avx512vl_fmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3777; /* avx512fp16_fmaddc_v8hf_mask */

        case 6:
          if (!
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3795; /* avx512fp16_fma_fmaddcsh_v8hf */

        default:
          return -1;
        }

    case 219:
      switch (pattern411 (x2))
        {
        case 0:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3737; /* fma_fcmaddc_v32hf_maskz_1 */

        case 1:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3742; /* fma_fcmaddc_v16hf_maskz_1 */

        case 2:
          if (!(
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3746; /* fma_fcmaddc_v8hf_maskz_1 */

        case 3:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3773; /* avx512bw_fcmaddc_v32hf_mask */

        case 4:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3776; /* avx512vl_fcmaddc_v16hf_mask */

        case 5:
          if (!(
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3778; /* avx512fp16_fcmaddc_v8hf_mask */

        case 6:
          if (!
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3799; /* avx512fp16_fma_fcmaddcsh_v8hf */

        default:
          return -1;
        }

    case 167:
      return recog_124 (x1, insn, pnum_clobbers);

    case 121:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern417 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 23213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7934; /* avx512bw_palignrv64qi_mask */

        case E_V32QImode:
          if (pattern417 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 23213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7935; /* avx2_palignrv32qi_mask */

        case E_V16QImode:
          if (pattern417 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !
#line 23213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)))
            return -1;
          return 7936; /* ssse3_palignrv16qi_mask */

        default:
          return -1;
        }

    case 128:
      switch (pattern413 (x2, 
E_SImode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 8017; /* avx10_2_mpsadbw_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8019; /* avx2_mpsadbw_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 8021; /* sse4_1_mpsadbw_mask */

        default:
          return -1;
        }

    case 155:
      return recog_116 (x1, insn, pnum_clobbers);

    case 194:
      return recog_121 (x1, insn, pnum_clobbers);

    case 166:
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_15_operand (operands[3], E_SImode))
        return -1;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 9335; /* avx512f_vgetmantv8hf */

        case 1:
          if (!
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 9339; /* avx512f_vgetmantv4sf */

        case 2:
          if (!(
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 9343; /* avx512f_vgetmantv2df */

        default:
          return -1;
        }

    case 186:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern1162 (x2, 
E_QImode, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9348; /* avx512bw_dbpsadbwv8hi_mask */

        case E_V16HImode:
          if (pattern1162 (x2, 
E_HImode, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9350; /* avx512bw_dbpsadbwv16hi_mask */

        case E_V32HImode:
          if (pattern1162 (x2, 
E_SImode, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9352; /* avx512bw_dbpsadbwv32hi_mask */

        default:
          return -1;
        }

    case 195:
      switch (pattern416 (x2))
        {
        case 0:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9408; /* vpmadd52luqv8di_maskz_1 */

        case 1:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9410; /* vpmadd52luqv4di_maskz_1 */

        case 2:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9412; /* vpmadd52luqv2di_maskz_1 */

        case 3:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9414; /* vpmadd52luqv8di_mask */

        case 4:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9416; /* vpmadd52luqv4di_mask */

        case 5:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9418; /* vpmadd52luqv2di_mask */

        default:
          return -1;
        }

    case 196:
      switch (pattern416 (x2))
        {
        case 0:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9409; /* vpmadd52huqv8di_maskz_1 */

        case 1:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9411; /* vpmadd52huqv4di_maskz_1 */

        case 2:
          if (!(
#line 30232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9413; /* vpmadd52huqv2di_maskz_1 */

        case 3:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9415; /* vpmadd52huqv8di_mask */

        case 4:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9417; /* vpmadd52huqv4di_mask */

        case 5:
          if (!(
#line 30248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512IFMA) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9419; /* vpmadd52huqv2di_mask */

        default:
          return -1;
        }

    case 198:
      switch (pattern413 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9451; /* vgf2p8affineinvqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9453; /* vgf2p8affineinvqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 9455; /* vgf2p8affineinvqb_v16qi_mask */

        default:
          return -1;
        }

    case 199:
      switch (pattern413 (x2, 
E_VOIDmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30353 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9457; /* vgf2p8affineqb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30353 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9459; /* vgf2p8affineqb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30353 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 9461; /* vgf2p8affineqb_v16qi_mask */

        default:
          return -1;
        }

    case 202:
      return recog_125 (x1, insn, pnum_clobbers);

    case 201:
      return recog_126 (x1, insn, pnum_clobbers);

    case 203:
      return recog_120 (x1, insn, pnum_clobbers);

    case 204:
      return recog_119 (x1, insn, pnum_clobbers);

    case 205:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30599 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9561; /* vpdpbusd_v16si_mask */

        case 1:
          if (!(
#line 30599 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9562; /* vpdpbusd_v8si_mask */

        case 2:
          if (!(
#line 30599 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9563; /* vpdpbusd_v4si_mask */

        case 3:
          if (!(
#line 30628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9564; /* vpdpbusd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9565; /* vpdpbusd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9566; /* vpdpbusd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 206:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9570; /* vpdpbusds_v16si_mask */

        case 1:
          if (!(
#line 30668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9571; /* vpdpbusds_v8si_mask */

        case 2:
          if (!(
#line 30668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9572; /* vpdpbusds_v4si_mask */

        case 3:
          if (!(
#line 30697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9573; /* vpdpbusds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9574; /* vpdpbusds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9575; /* vpdpbusds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 207:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9579; /* vpdpwssd_v16si_mask */

        case 1:
          if (!(
#line 30737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9580; /* vpdpwssd_v8si_mask */

        case 2:
          if (!(
#line 30737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9581; /* vpdpwssd_v4si_mask */

        case 3:
          if (!(
#line 30766 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9582; /* vpdpwssd_v16si_maskz_1 */

        case 4:
          if (!(
#line 30766 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9583; /* vpdpwssd_v8si_maskz_1 */

        case 5:
          if (!(
#line 30766 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9584; /* vpdpwssd_v4si_maskz_1 */

        default:
          return -1;
        }

    case 208:
      switch (pattern423 (x2))
        {
        case 0:
          if (!(
#line 30806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9588; /* vpdpwssds_v16si_mask */

        case 1:
          if (!(
#line 30806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9589; /* vpdpwssds_v8si_mask */

        case 2:
          if (!(
#line 30806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9590; /* vpdpwssds_v4si_mask */

        case 3:
          if (!(
#line 30835 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9591; /* vpdpwssds_v16si_maskz_1 */

        case 4:
          if (!(
#line 30835 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9592; /* vpdpwssds_v8si_maskz_1 */

        case 5:
          if (!(
#line 30835 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VNNI) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9593; /* vpdpwssds_v4si_maskz_1 */

        default:
          return -1;
        }

    case 216:
      return recog_122 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9674; /* vpdpbssd_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9680; /* vpdpbssd_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9686; /* vpdpbssd_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9692; /* *vpdpbssd_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9698; /* *vpdpbssd_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9704; /* *vpdpbssd_v4si_maskz */

        default:
          return -1;
        }

    case 228:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9675; /* vpdpbssds_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9681; /* vpdpbssds_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9687; /* vpdpbssds_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9693; /* *vpdpbssds_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9699; /* *vpdpbssds_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9705; /* *vpdpbssds_v4si_maskz */

        default:
          return -1;
        }

    case 229:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9676; /* vpdpbsud_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9682; /* vpdpbsud_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9688; /* vpdpbsud_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9694; /* *vpdpbsud_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9700; /* *vpdpbsud_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9706; /* *vpdpbsud_v4si_maskz */

        default:
          return -1;
        }

    case 230:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9677; /* vpdpbsuds_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9683; /* vpdpbsuds_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9689; /* vpdpbsuds_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9695; /* *vpdpbsuds_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9701; /* *vpdpbsuds_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9707; /* *vpdpbsuds_v4si_maskz */

        default:
          return -1;
        }

    case 231:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9678; /* vpdpbuud_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9684; /* vpdpbuud_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9690; /* vpdpbuud_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9696; /* *vpdpbuud_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9702; /* *vpdpbuud_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9708; /* *vpdpbuud_v4si_maskz */

        default:
          return -1;
        }

    case 232:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9679; /* vpdpbuuds_v16si_mask */

        case 1:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9685; /* vpdpbuuds_v8si_mask */

        case 2:
          if (!
#line 31594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9691; /* vpdpbuuds_v4si_mask */

        case 3:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9697; /* *vpdpbuuds_v16si_maskz */

        case 4:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9703; /* *vpdpbuuds_v8si_maskz */

        case 5:
          if (!
#line 31621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9709; /* *vpdpbuuds_v4si_maskz */

        default:
          return -1;
        }

    case 233:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9826; /* vpdpwusd_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9832; /* vpdpwusd_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9838; /* vpdpwusd_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9844; /* *vpdpwusd_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9850; /* *vpdpwusd_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9856; /* *vpdpwusd_v4si_maskz */

        default:
          return -1;
        }

    case 234:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9827; /* vpdpwusds_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9833; /* vpdpwusds_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9839; /* vpdpwusds_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9845; /* *vpdpwusds_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9851; /* *vpdpwusds_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9857; /* *vpdpwusds_v4si_maskz */

        default:
          return -1;
        }

    case 235:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9828; /* vpdpwsud_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9834; /* vpdpwsud_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9840; /* vpdpwsud_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9846; /* *vpdpwsud_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9852; /* *vpdpwsud_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9858; /* *vpdpwsud_v4si_maskz */

        default:
          return -1;
        }

    case 236:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9829; /* vpdpwsuds_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9835; /* vpdpwsuds_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9841; /* vpdpwsuds_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9847; /* *vpdpwsuds_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9853; /* *vpdpwsuds_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9859; /* *vpdpwsuds_v4si_maskz */

        default:
          return -1;
        }

    case 237:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9830; /* vpdpwuud_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9836; /* vpdpwuud_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9842; /* vpdpwuud_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9848; /* *vpdpwuud_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9854; /* *vpdpwuud_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9860; /* *vpdpwuud_v4si_maskz */

        default:
          return -1;
        }

    case 238:
      switch (pattern425 (x2))
        {
        case 0:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9831; /* vpdpwuuds_v16si_mask */

        case 1:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9837; /* vpdpwuuds_v8si_mask */

        case 2:
          if (!
#line 32003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9843; /* vpdpwuuds_v4si_mask */

        case 3:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9849; /* *vpdpwuuds_v16si_maskz */

        case 4:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9855; /* *vpdpwuuds_v8si_maskz */

        case 5:
          if (!
#line 32030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9861; /* *vpdpwuuds_v4si_maskz */

        default:
          return -1;
        }

    case 244:
      return recog_123 (x1, insn, pnum_clobbers);

    case 277:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[4] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern1163 (x2, 
E_SImode, 
E_V32BFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10176; /* avx10_2_minmaxbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern1163 (x2, 
E_HImode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10178; /* avx10_2_minmaxbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern1163 (x2, 
E_QImode, 
E_V8BFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10180; /* avx10_2_minmaxbf16_v8bf_mask */

        default:
          return -1;
        }

    case 278:
      return recog_118 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  res = recog_152 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 0L:
      if (XWINT (x6, 0) != 1L
          || XWINT (x7, 0) != 2L
          || XWINT (x8, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || pattern1398 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 12608 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4669; /* vec_extract_lo_v8df_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || pattern1398 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 12608 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4670; /* vec_extract_lo_v8di_mask */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || pattern1398 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 12942 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 4693; /* vec_extract_lo_v8si_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || pattern1398 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 12942 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 4694; /* vec_extract_lo_v8sf_mask */

        default:
          return -1;
        }

    case 4L:
      if (XWINT (x6, 0) != 5L
          || XWINT (x7, 0) != 6L
          || XWINT (x8, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DFmode:
          if (!nonimmediate_operand (operands[0], E_V4DFmode)
              || pattern1398 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !(
#line 12645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4673; /* vec_extract_hi_v8df_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[0], E_V4DImode)
              || pattern1398 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 12645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4674; /* vec_extract_hi_v8di_mask */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || pattern1398 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 12974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 4697; /* vec_extract_hi_v8si_mask */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || pattern1398 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 12974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[2]))))
            return -1;
          return 4698; /* vec_extract_hi_v8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_140 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern277 (x2))
        {
        case 0:
          res = recog_141 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 1:
          if (vector_all_ones_operand (operands[1], E_V16QImode)
              && const0_operand (operands[2], E_V16QImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7256; /* *avx2_pcmpv16qi3_6 */
          if (const0_operand (operands[1], E_V16QImode)
              && vector_all_ones_operand (operands[2], E_V16QImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7279; /* *avx2_pcmpv16qi3_8 */
          break;

        case 2:
          if (vector_all_ones_operand (operands[1], E_V8HImode)
              && const0_operand (operands[2], E_V8HImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7258; /* *avx2_pcmpv8hi3_6 */
          if (const0_operand (operands[1], E_V8HImode)
              && vector_all_ones_operand (operands[2], E_V8HImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7280; /* *avx2_pcmpv8hi3_8 */
          break;

        case 3:
          if (vector_all_ones_operand (operands[1], E_V4SImode)
              && const0_operand (operands[2], E_V4SImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7260; /* *avx2_pcmpv4si3_6 */
          if (const0_operand (operands[1], E_V4SImode)
              && vector_all_ones_operand (operands[2], E_V4SImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7281; /* *avx2_pcmpv4si3_8 */
          break;

        case 4:
          if (vector_all_ones_operand (operands[1], E_V2DImode)
              && const0_operand (operands[2], E_V2DImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7262; /* *avx2_pcmpv2di3_6 */
          if (const0_operand (operands[1], E_V2DImode)
              && vector_all_ones_operand (operands[2], E_V2DImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7282; /* *avx2_pcmpv2di3_8 */
          break;

        case 5:
          if (vector_all_ones_operand (operands[1], E_V32QImode)
              && const0_operand (operands[2], E_V32QImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7264; /* *avx2_pcmpv32qi3_6 */
          if (const0_operand (operands[1], E_V32QImode)
              && vector_all_ones_operand (operands[2], E_V32QImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7283; /* *avx2_pcmpv32qi3_8 */
          break;

        case 6:
          if (vector_all_ones_operand (operands[1], E_V16HImode)
              && const0_operand (operands[2], E_V16HImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7266; /* *avx2_pcmpv16hi3_6 */
          if (const0_operand (operands[1], E_V16HImode)
              && vector_all_ones_operand (operands[2], E_V16HImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7284; /* *avx2_pcmpv16hi3_8 */
          break;

        case 7:
          if (vector_all_ones_operand (operands[1], E_V8SImode)
              && const0_operand (operands[2], E_V8SImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7268; /* *avx2_pcmpv8si3_6 */
          if (const0_operand (operands[1], E_V8SImode)
              && vector_all_ones_operand (operands[2], E_V8SImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7285; /* *avx2_pcmpv8si3_8 */
          break;

        case 8:
          if (vector_all_ones_operand (operands[1], E_V4DImode)
              && const0_operand (operands[2], E_V4DImode)
              && 
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)))
            return 7270; /* *avx2_pcmpv4di3_6 */
          if (const0_operand (operands[1], E_V4DImode)
              && vector_all_ones_operand (operands[2], E_V4DImode)
              && 
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4))
            return 7286; /* *avx2_pcmpv4di3_8 */
          break;

        case 9:
          if ((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2694; /* *avx_cmpv8sf3_2 */
          break;

        case 10:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7247; /* *avx2_pcmpv8si3_2 */
          break;

        case 11:
          if (
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
            return 2695; /* *avx_cmpv4sf3_2 */
          break;

        case 12:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7243; /* *avx2_pcmpv4si3_2 */
          break;

        case 13:
          if ((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2696; /* *avx_cmpv4df3_2 */
          break;

        case 14:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7248; /* *avx2_pcmpv4di3_2 */
          break;

        case 15:
          if ((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 2697; /* *avx_cmpv2df3_2 */
          break;

        case 16:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7244; /* *avx2_pcmpv2di3_2 */
          break;

        case 17:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7241; /* *avx2_pcmpv16qi3_2 */
          break;

        case 18:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7242; /* *avx2_pcmpv8hi3_2 */
          break;

        case 19:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7245; /* *avx2_pcmpv32qi3_2 */
          break;

        case 20:
          if (
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))))
            return 7246; /* *avx2_pcmpv16hi3_2 */
          break;

        case 21:
          switch (GET_MODE (operands[0]))
            {
            case E_V64QImode:
              if (register_operand (operands[0], E_V64QImode)
                  && GET_MODE (x2) == E_V64QImode
                  && register_operand (operands[1], E_DImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V64QImode)
                      && const0_operand (operands[3], E_V64QImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4532; /* *avx512bw_cvtmask2bv64qi */
                  if (const0_operand (operands[2], E_V64QImode)
                      && vector_all_ones_operand (operands[3], E_V64QImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 4544; /* *avx512bw_cvtmask2bv64qi_not */
                }
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x2) == E_V16QImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16QImode)
                      && const0_operand (operands[3], E_V16QImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4533; /* *avx512vl_cvtmask2bv16qi */
                  if (const0_operand (operands[2], E_V16QImode)
                      && vector_all_ones_operand (operands[3], E_V16QImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4546; /* *avx512vl_cvtmask2bv16qi_not */
                }
              break;

            case E_V32QImode:
              if (register_operand (operands[0], E_V32QImode)
                  && GET_MODE (x2) == E_V32QImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32QImode)
                      && const0_operand (operands[3], E_V32QImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4534; /* *avx512vl_cvtmask2bv32qi */
                  if (const0_operand (operands[2], E_V32QImode)
                      && vector_all_ones_operand (operands[3], E_V32QImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4545; /* *avx512vl_cvtmask2bv32qi_not */
                }
              break;

            case E_V32HImode:
              if (register_operand (operands[0], E_V32HImode)
                  && GET_MODE (x2) == E_V32HImode
                  && register_operand (operands[1], E_SImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V32HImode)
                      && const0_operand (operands[3], E_V32HImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4535; /* *avx512bw_cvtmask2wv32hi */
                  if (const0_operand (operands[2], E_V32HImode)
                      && vector_all_ones_operand (operands[3], E_V32HImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return 4547; /* *avx512bw_cvtmask2wv32hi_not */
                }
              break;

            case E_V16HImode:
              if (register_operand (operands[0], E_V16HImode)
                  && GET_MODE (x2) == E_V16HImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16HImode)
                      && const0_operand (operands[3], E_V16HImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4536; /* *avx512vl_cvtmask2wv16hi */
                  if (const0_operand (operands[2], E_V16HImode)
                      && vector_all_ones_operand (operands[3], E_V16HImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4548; /* *avx512vl_cvtmask2wv16hi_not */
                }
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x2) == E_V8HImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8HImode)
                      && const0_operand (operands[3], E_V8HImode)
                      && (
#line 10279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4537; /* *avx512vl_cvtmask2wv8hi */
                  if (const0_operand (operands[2], E_V8HImode)
                      && vector_all_ones_operand (operands[3], E_V8HImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return 4549; /* *avx512vl_cvtmask2wv8hi_not */
                }
              break;

            case E_V16SImode:
              if (register_operand (operands[0], E_V16SImode)
                  && GET_MODE (x2) == E_V16SImode
                  && register_operand (operands[1], E_HImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V16SImode)
                      && const0_operand (operands[3], E_V16SImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4538; /* *avx512f_cvtmask2dv16si */
                  if (const0_operand (operands[2], E_V16SImode)
                      && vector_all_ones_operand (operands[3], E_V16SImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4550; /* *avx512f_cvtmask2dv16si_not */
                }
              break;

            case E_V8SImode:
              if (register_operand (operands[0], E_V8SImode)
                  && GET_MODE (x2) == E_V8SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8SImode)
                      && const0_operand (operands[3], E_V8SImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4539; /* *avx512vl_cvtmask2dv8si */
                  if (const0_operand (operands[2], E_V8SImode)
                      && vector_all_ones_operand (operands[3], E_V8SImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4551; /* *avx512vl_cvtmask2dv8si_not */
                }
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x2) == E_V4SImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4SImode)
                      && const0_operand (operands[3], E_V4SImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4540; /* *avx512vl_cvtmask2dv4si */
                  if (const0_operand (operands[2], E_V4SImode)
                      && vector_all_ones_operand (operands[3], E_V4SImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4552; /* *avx512vl_cvtmask2dv4si_not */
                }
              break;

            case E_V8DImode:
              if (register_operand (operands[0], E_V8DImode)
                  && GET_MODE (x2) == E_V8DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V8DImode)
                      && const0_operand (operands[3], E_V8DImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4541; /* *avx512f_cvtmask2qv8di */
                  if (const0_operand (operands[2], E_V8DImode)
                      && vector_all_ones_operand (operands[3], E_V8DImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 4553; /* *avx512f_cvtmask2qv8di_not */
                }
              break;

            case E_V4DImode:
              if (register_operand (operands[0], E_V4DImode)
                  && GET_MODE (x2) == E_V4DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V4DImode)
                      && const0_operand (operands[3], E_V4DImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4542; /* *avx512vl_cvtmask2qv4di */
                  if (const0_operand (operands[2], E_V4DImode)
                      && vector_all_ones_operand (operands[3], E_V4DImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4554; /* *avx512vl_cvtmask2qv4di_not */
                }
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && register_operand (operands[1], E_QImode))
                {
                  if (vector_all_ones_operand (operands[2], E_V2DImode)
                      && const0_operand (operands[3], E_V2DImode)
                      && (
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4543; /* *avx512vl_cvtmask2qv2di */
                  if (const0_operand (operands[2], E_V2DImode)
                      && vector_all_ones_operand (operands[3], E_V2DImode)
                      && (
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 4555; /* *avx512vl_cvtmask2qv2di_not */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (pattern280 (x2))
    {
    case 0:
      if (!(
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2698; /* *avx_cmpv8sf3_3 */

    case 1:
      if (!
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 2699; /* *avx_cmpv4sf3_3 */

    case 2:
      if (!(
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2700; /* *avx_cmpv4df3_3 */

    case 3:
      if (!(
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2701; /* *avx_cmpv2df3_3 */

    case 4:
      if (!(
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2702; /* *avx_cmpv8sf3_4 */

    case 5:
      if (!
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 2703; /* *avx_cmpv4sf3_4 */

    case 6:
      if (!(
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2704; /* *avx_cmpv4df3_4 */

    case 7:
      if (!(
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2705; /* *avx_cmpv2df3_4 */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      switch (pattern806 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3893; /* avx512fp16_vcvtuw2ph_v8hi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3917; /* avx512fp16_vcvtudq2ph_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3933; /* avx512fp16_vcvtuqq2ph_v8di_mask */

        default:
          return -1;
        }

    case 1:
      switch (pattern807 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3901; /* avx512fp16_vcvtuw2ph_v16hi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3925; /* avx512fp16_vcvtudq2ph_v16si_mask */

        default:
          return -1;
        }

    case 2:
      if (pattern127 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3909; /* avx512fp16_vcvtuw2ph_v32hi_mask */

    case 3:
      if (pattern141 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4200; /* floatunsv16siv16sf2_mask */

    case 4:
      switch (pattern808 (x2, 
E_V8SFmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4204; /* floatunsv8siv8sf2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4328; /* floatunsv8div8sf2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern809 (x2, 
E_V4SFmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4208; /* floatunsv4siv4sf2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4333; /* floatunsv4div4sf2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4304; /* floatunsv8div8df2_mask */

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4341; /* floatunsv8siv8df2_mask */

        default:
          return -1;
        }

    case 7:
      if (pattern128 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4312; /* floatunsv4div4df2_mask */

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9325 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4343; /* floatunsv4siv4df2_mask */

        default:
          return -1;
        }

    case 8:
      if (pattern141 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4320; /* floatunsv2div2df2_mask */

    case 9:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4345; /* floatunsv2siv2df2_mask */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x2) != E_V64QImode
          || !memory_operand (operands[1], E_V64QImode)
          || !(
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 514 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10229; /* avx10_2_vmovrsbv64qi */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || !memory_operand (operands[1], E_V32QImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10231; /* avx10_2_vmovrsbv32qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10233; /* avx10_2_vmovrsbv16qi */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !memory_operand (operands[1], E_V32HImode)
          || !(
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10235; /* avx10_2_vmovrswv32hi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !memory_operand (operands[1], E_V16HImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10237; /* avx10_2_vmovrswv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10239; /* avx10_2_vmovrswv8hi */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode
          || !memory_operand (operands[1], E_V16SImode)
          || !(
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 516 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10241; /* avx10_2_vmovrsdv16si */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x2) != E_V8SImode
          || !memory_operand (operands[1], E_V8SImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10243; /* avx10_2_vmovrsdv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10245; /* avx10_2_vmovrsdv4si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x2) != E_V8DImode
          || !memory_operand (operands[1], E_V8DImode)
          || !(
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 10247; /* avx10_2_vmovrsqv8di */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x2) != E_V4DImode
          || !memory_operand (operands[1], E_V4DImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10249; /* avx10_2_vmovrsqv4di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS))
        return -1;
      return 10251; /* avx10_2_vmovrsqv2di */

    default:
      return -1;
    }
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 3138 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2431; /* avx_rsqrtv8sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 3138 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2432; /* sse_rsqrtv4sf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 3150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2433; /* avx512fp16_rsqrtv32hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 3150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2435; /* avx512fp16_rsqrtv16hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 3150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2437; /* avx512fp16_rsqrtv8hf2 */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9961; /* avx10_2_rsqrtbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9963; /* avx10_2_rsqrtbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9965; /* avx10_2_rsqrtbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x4, 2);
          operands[5] = x8;
          operands[6] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1492 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3506; /* fma_fmaddsub_v32hf_maskz_1_round */

            case E_V16SFmode:
              if (pattern1492 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3514; /* fma_fmaddsub_v16sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1492 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3522; /* fma_fmaddsub_v8df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x4, 2);
          operands[4] = x8;
          operands[5] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1437 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V32HFmode)
                  && register_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return 3528; /* avx512bw_fmaddsub_v32hf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3546; /* avx512bw_fmaddsub_v32hf_mask3_round */

            case E_V16HFmode:
              if (pattern1437 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16HFmode)
                  && register_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3530; /* avx512vl_fmaddsub_v16hf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3548; /* avx512vl_fmaddsub_v16hf_mask3_round */

            case E_V8HFmode:
              if (pattern1437 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3532; /* avx512fp16_fmaddsub_v8hf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3550; /* avx512fp16_fmaddsub_v8hf_mask3_round */

            case E_V16SFmode:
              if (pattern1437 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16SFmode)
                  && register_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3534; /* avx512f_fmaddsub_v16sf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3552; /* avx512f_fmaddsub_v16sf_mask3_round */

            case E_V8SFmode:
              if (pattern1437 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8SFmode)
                  && register_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3536; /* avx512vl_fmaddsub_v8sf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3554; /* avx512vl_fmaddsub_v8sf_mask3_round */

            case E_V4SFmode:
              if (pattern1437 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3538; /* avx512vl_fmaddsub_v4sf_mask_round */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3556; /* avx512vl_fmaddsub_v4sf_mask3_round */

            case E_V8DFmode:
              if (pattern1437 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8DFmode)
                  && register_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3540; /* avx512f_fmaddsub_v8df_mask_round */
              if (!nonimmediate_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3558; /* avx512f_fmaddsub_v8df_mask3_round */

            case E_V4DFmode:
              if (pattern1437 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4DFmode)
                  && register_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3542; /* avx512vl_fmaddsub_v4df_mask_round */
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3560; /* avx512vl_fmaddsub_v4df_mask3_round */

            case E_V2DFmode:
              if (pattern1437 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V2DFmode)
                  && register_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3544; /* avx512vl_fmaddsub_v2df_mask_round */
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6462 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3562; /* avx512vl_fmaddsub_v2df_mask3_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x4, 2);
          operands[5] = x8;
          operands[6] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1493 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3570; /* fma_fmsubadd_v32hf_maskz_1_round */

            case E_V16SFmode:
              if (pattern1493 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3578; /* fma_fmsubadd_v16sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1493 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3586; /* fma_fmsubadd_v8df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x4, 2);
          operands[4] = x8;
          operands[5] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1438 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return 3592; /* avx512bw_fmsubadd_v32hf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 3610; /* avx512bw_fmsubadd_v32hf_mask3_round */

            case E_V16HFmode:
              if (pattern1438 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3594; /* avx512vl_fmsubadd_v16hf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3612; /* avx512vl_fmsubadd_v16hf_mask3_round */

            case E_V8HFmode:
              if (pattern1438 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return 3596; /* avx512fp16_fmsubadd_v8hf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 3614; /* avx512fp16_fmsubadd_v8hf_mask3_round */

            case E_V16SFmode:
              if (pattern1438 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3598; /* avx512f_fmsubadd_v16sf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3616; /* avx512f_fmsubadd_v16sf_mask3_round */

            case E_V8SFmode:
              if (pattern1438 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3600; /* avx512vl_fmsubadd_v8sf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3618; /* avx512vl_fmsubadd_v8sf_mask3_round */

            case E_V4SFmode:
              if (pattern1438 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3602; /* avx512vl_fmsubadd_v4sf_mask_round */
              if (!nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3620; /* avx512vl_fmsubadd_v4sf_mask3_round */

            case E_V8DFmode:
              if (pattern1438 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return 3604; /* avx512f_fmsubadd_v8df_mask_round */
              if (!nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3622; /* avx512f_fmsubadd_v8df_mask3_round */

            case E_V4DFmode:
              if (pattern1438 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3606; /* avx512vl_fmsubadd_v4df_mask_round */
              if (!nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3624; /* avx512vl_fmsubadd_v4df_mask3_round */

            case E_V2DFmode:
              if (pattern1438 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return 3608; /* avx512vl_fmsubadd_v2df_mask_round */
              if (!nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3626; /* avx512vl_fmsubadd_v2df_mask3_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 154)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!const1248_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  x8 = XEXP (x1, 1);
  x9 = XVECEXP (x8, 0, 1);
  operands[3] = x9;
  x10 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x10, operands[6]))
    return -1;
  switch (GET_MODE (operands[5]))
    {
    case E_V16SImode:
      if (!vsib_mem_operator (operands[5], E_V16SImode)
          || GET_MODE (x8) != E_V16SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1546 (
E_SImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9131; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9155; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1546 (
E_DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9143; /* *avx512f_scattersiv16si */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9167; /* *avx512f_scatterdiv16si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!vsib_mem_operator (operands[5], E_V16SFmode)
          || GET_MODE (x8) != E_V16SFmode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          switch (pattern1547 (
E_SImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9132; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9156; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern1547 (
E_DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9144; /* *avx512f_scattersiv16sf */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              *pnum_clobbers = 1;
              return 9168; /* *avx512f_scatterdiv16sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern1454 (x1, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9133; /* *avx512f_scattersiv8di */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9157; /* *avx512f_scatterdiv8di */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9145; /* *avx512f_scattersiv8di */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9169; /* *avx512f_scatterdiv8di */

        default:
          return -1;
        }

    case E_V8DFmode:
      switch (pattern1454 (x1, 
E_V8DFmode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9134; /* *avx512f_scattersiv8df */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9158; /* *avx512f_scatterdiv8df */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9146; /* *avx512f_scattersiv8df */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          *pnum_clobbers = 1;
          return 9170; /* *avx512f_scatterdiv8df */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern1455 (x1, 
E_V8SImode))
        {
        case 0:
          switch (pattern1583 (
E_SImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9135; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9159; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        case 1:
          switch (pattern1583 (
E_DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9147; /* *avx512f_scattersiv8si */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9171; /* *avx512f_scatterdiv8si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8SFmode:
      switch (pattern1455 (x1, 
E_V8SFmode))
        {
        case 0:
          switch (pattern1584 (
E_SImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9136; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9160; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        case 1:
          switch (pattern1584 (
E_DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9148; /* *avx512f_scattersiv8sf */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              *pnum_clobbers = 1;
              return 9172; /* *avx512f_scatterdiv8sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern1457 (x1, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9137; /* *avx512f_scattersiv4di */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9161; /* *avx512f_scatterdiv4di */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9149; /* *avx512f_scattersiv4di */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9173; /* *avx512f_scatterdiv4di */

        default:
          return -1;
        }

    case E_V4DFmode:
      switch (pattern1457 (x1, 
E_V4DFmode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9138; /* *avx512f_scattersiv4df */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9162; /* *avx512f_scatterdiv4df */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9150; /* *avx512f_scattersiv4df */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9174; /* *avx512f_scatterdiv4df */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern1459 (x1, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9139; /* *avx512f_scattersiv4si */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9163; /* *avx512f_scatterdiv4si */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9151; /* *avx512f_scattersiv4si */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9175; /* *avx512f_scatterdiv4si */

        default:
          return -1;
        }

    case E_V4SFmode:
      switch (pattern1459 (x1, 
E_V4SFmode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9140; /* *avx512f_scattersiv4sf */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9164; /* *avx512f_scatterdiv4sf */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9152; /* *avx512f_scattersiv4sf */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9176; /* *avx512f_scatterdiv4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern1459 (x1, 
E_V2DImode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9141; /* *avx512f_scattersiv2di */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9165; /* *avx512f_scatterdiv2di */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9153; /* *avx512f_scattersiv2di */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9177; /* *avx512f_scatterdiv2di */

        default:
          return -1;
        }

    case E_V2DFmode:
      switch (pattern1459 (x1, 
E_V2DFmode))
        {
        case 0:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9142; /* *avx512f_scattersiv2df */

        case 1:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9166; /* *avx512f_scatterdiv2df */

        case 2:
          if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9154; /* *avx512f_scattersiv2df */

        case 3:
          if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          *pnum_clobbers = 1;
          return 9178; /* *avx512f_scatterdiv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1))
    {
    case 0:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9468; /* vpshrd_v32hi */

    case 1:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9470; /* vpshrd_v16si */

    case 2:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9472; /* vpshrd_v8di */

    case 3:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9474; /* vpshrd_v16hi */

    case 4:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9476; /* vpshrd_v8si */

    case 5:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9478; /* vpshrd_v4di */

    case 6:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9480; /* vpshrd_v8hi */

    case 7:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9482; /* vpshrd_v4si */

    case 8:
      if (!(
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9484; /* vpshrd_v2di */

    default:
      return -1;
    }
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern728 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11818 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4613; /* *vec_concatv4sf */
          break;

        case E_V8HFmode:
          if (pattern728 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11818 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4614; /* *vec_concatv8hf */
          break;

        case E_V8BFmode:
          if (pattern728 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11818 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 4615; /* *vec_concatv8bf */
          break;

        case E_V16QImode:
          if (pattern728 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21560 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7817; /* *vec_concatv16qi */
          break;

        case E_V8HImode:
          if (pattern728 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21560 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7818; /* *vec_concatv8hi */
          break;

        case E_V4SImode:
          if (pattern728 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21560 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7819; /* *vec_concatv4si */
          break;

        case E_V2DImode:
          if (pattern728 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 7825; /* vec_concatv2di */
          break;

        case E_V32QImode:
          if (register_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 27877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8586; /* avx2_vbroadcasti128_v32qi */
              if (nonimmediate_operand (operands[1], E_V16QImode)
                  && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8605; /* avx_vbroadcastf128_v32qi */
            }
          break;

        case E_V16HImode:
          if (register_operand (operands[0], E_V16HImode)
              && GET_MODE (x2) == E_V16HImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 27877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8587; /* avx2_vbroadcasti128_v16hi */
              if (nonimmediate_operand (operands[1], E_V8HImode)
                  && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8606; /* avx_vbroadcastf128_v16hi */
            }
          break;

        case E_V8SImode:
          if (register_operand (operands[0], E_V8SImode)
              && GET_MODE (x2) == E_V8SImode
              && rtx_equal_p (x4, operands[1]))
            {
              if (memory_operand (operands[1], E_V4SImode)
                  && 
#line 27877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8588; /* avx2_vbroadcasti128_v8si */
              if (nonimmediate_operand (operands[1], E_V4SImode)
                  && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 8607; /* avx_vbroadcastf128_v8si */
            }
          break;

        case E_V4DImode:
          if (register_operand (operands[0], E_V4DImode)
              && GET_MODE (x2) == E_V4DImode
              && memory_operand (operands[1], E_V2DImode)
              && rtx_equal_p (x4, operands[1])
              && 
#line 27877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8589; /* avx2_vbroadcasti128_v4di */
          break;

        case E_V8SFmode:
          if (pattern729 (x2, 
E_V4SFmode, 
E_V8SFmode) == 0
              && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8609; /* avx_vbroadcastf128_v8sf */
          break;

        case E_V4DFmode:
          if (pattern729 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
              && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8610; /* avx_vbroadcastf128_v4df */
          break;

        case E_V16HFmode:
          if (pattern729 (x2, 
E_V8HFmode, 
E_V16HFmode) == 0
              && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8611; /* avx_vbroadcastf128_v16hf */
          break;

        case E_V16BFmode:
          if (pattern729 (x2, 
E_V8BFmode, 
E_V16BFmode) == 0
              && 
#line 27991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8612; /* avx_vbroadcastf128_v16bf */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern833 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 11834 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4616; /* *vec_concatv4sf_0 */
          break;

        case E_V8HFmode:
          if (pattern833 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 11834 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4617; /* *vec_concatv8hf_0 */
          break;

        case E_V8BFmode:
          if (pattern833 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 11834 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 4618; /* *vec_concatv8bf_0 */
          break;

        case E_V16QImode:
          if (pattern833 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 21631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7822; /* *vec_concatv16qi_0 */
          break;

        case E_V8HImode:
          if (pattern833 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 21631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7823; /* *vec_concatv8hi_0 */
          break;

        case E_V4SImode:
          if (pattern833 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 21631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7824; /* *vec_concatv4si_0 */
          break;

        case E_V2DImode:
          if (pattern833 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 21709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 7826; /* *vec_concatv2di_0 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern730 (x2, 
E_DFmode, 
E_V2DFmode) != 0
          || !
#line 14895 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 6568; /* vec_concatv2df */

    case E_V32QImode:
      if (pattern730 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16QImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8900; /* avx_vec_concatv32qi */

    case E_V16HImode:
      if (pattern730 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8901; /* avx_vec_concatv16hi */

    case E_V16HFmode:
      if (pattern730 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8HFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8902; /* avx_vec_concatv16hf */

    case E_V16BFmode:
      if (pattern730 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8BFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8903; /* avx_vec_concatv16bf */

    case E_V8SImode:
      if (pattern730 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SImode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8904; /* avx_vec_concatv8si */

    case E_V8SFmode:
      if (pattern730 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4SFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8906; /* avx_vec_concatv8sf */

    case E_V4DFmode:
      if (pattern730 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V2DFmode)
       || !MEM_P (operands[1]))))
        return -1;
      return 8907; /* avx_vec_concatv4df */

    case E_V64QImode:
      if (pattern730 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V32QImode)
       || !MEM_P (operands[1]))) && 
#line 363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8908; /* avx_vec_concatv64qi */

    case E_V32HImode:
      if (pattern730 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HImode)
       || !MEM_P (operands[1]))) && 
#line 364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8909; /* avx_vec_concatv32hi */

    case E_V32HFmode:
      if (pattern730 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16HFmode)
       || !MEM_P (operands[1]))) && 
#line 365 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8910; /* avx_vec_concatv32hf */

    case E_V32BFmode:
      if (pattern730 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V16BFmode)
       || !MEM_P (operands[1]))) && 
#line 366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8911; /* avx_vec_concatv32bf */

    case E_V16SImode:
      if (pattern730 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SImode)
       || !MEM_P (operands[1]))) && 
#line 367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8912; /* avx_vec_concatv16si */

    case E_V8DImode:
      if (pattern730 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DImode)
       || !MEM_P (operands[1]))) && 
#line 368 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8913; /* avx_vec_concatv8di */

    case E_V16SFmode:
      if (pattern730 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V8SFmode)
       || !MEM_P (operands[1]))) && 
#line 369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8914; /* avx_vec_concatv16sf */

    case E_V8DFmode:
      if (pattern730 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
          || !(
#line 28936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (operands[2] == CONST0_RTX (V4DFmode)
       || !MEM_P (operands[1]))) && 
#line 370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8915; /* avx_vec_concatv8df */

    default:
      return -1;
    }
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  x6 = XVECEXP (x5, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[5] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[6] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern1374 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 11542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 4598; /* sse_shufps_v4si */

    case E_V4SFmode:
      if (pattern1374 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 11542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 4599; /* sse_shufps_v4sf */

    case E_V4DFmode:
      if (pattern1289 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_4_to_5_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_6_to_7_operand (operands[6], E_VOIDmode)
          && 
#line 14384 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
        return 6541; /* avx_shufpd256_1 */
      if (!const_0_to_3_operand (operands[3], E_VOIDmode)
          || !const_0_to_3_operand (operands[4], E_VOIDmode)
          || !const_4_to_7_operand (operands[5], E_VOIDmode)
          || !const_4_to_7_operand (operands[6], E_VOIDmode)
          || !
#line 20165 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 7758; /* *avx512dq_shuf_f64x2_1 */

    case E_V4DImode:
      if (pattern1289 (x2, 
E_V4DImode, 
E_V8DImode) != 0
          || pattern1373 () != 0
          || !
#line 20165 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1))
        return -1;
      return 7756; /* *avx512dq_shuf_i64x2_1 */

    default:
      return -1;
    }
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_256 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  res = recog_257 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT
      || pattern1201 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 2L:
      if (XWINT (x5, 0) != 6L
          || XWINT (x6, 0) != 3L
          || XWINT (x7, 0) != 7L
          || !
#line 19745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 7714; /* vec_interleave_highv4si */

    case 0L:
      if (XWINT (x5, 0) != 4L
          || XWINT (x6, 0) != 1L
          || XWINT (x7, 0) != 5L
          || !
#line 19799 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
        return -1;
      return 7720; /* vec_interleave_lowv4si */

    default:
      return -1;
    }
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_259 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern1289 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_8_to_11_operand (operands[5], E_VOIDmode)
          && const_8_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_12_to_15_operand (operands[9], E_VOIDmode)
          && const_12_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 11463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && 1
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4))))
        return 4595; /* avx_shufps256_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1524 () != 0
          || !
#line 20321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 7770; /* avx512vl_shuf_f32x4_1 */

    case E_V8DFmode:
      if (pattern1289 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
        return -1;
      if (const_0_to_1_operand (operands[3], E_VOIDmode)
          && const_8_to_9_operand (operands[4], E_VOIDmode)
          && const_2_to_3_operand (operands[5], E_VOIDmode)
          && const_10_to_11_operand (operands[6], E_VOIDmode)
          && const_4_to_5_operand (operands[7], E_VOIDmode)
          && const_12_to_13_operand (operands[8], E_VOIDmode)
          && const_6_to_7_operand (operands[9], E_VOIDmode)
          && const_14_to_15_operand (operands[10], E_VOIDmode)
          && 
#line 14335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 6539; /* avx512f_shufpd512_1 */
      if (!const_0_to_7_operand (operands[3], E_VOIDmode)
          || pattern1524 () != 0
          || !(
#line 20223 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7760; /* avx512f_shuf_f64x2_1 */

    case E_V8DImode:
      if (pattern1525 (x2, 
E_V8DImode, 
E_V16DImode) != 0
          || !(
#line 20223 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7762; /* avx512f_shuf_i64x2_1 */

    case E_V8SImode:
      if (pattern1525 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 20321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3))
        return -1;
      return 7768; /* avx512vl_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      x6 = XEXP (x2, 0);
      x7 = XEXP (x6, 1);
      operands[2] = x7;
      switch (XWINT (x4, 0))
        {
        case 1L:
          if (XWINT (x5, 0) == 3L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1345 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 1)))
                    return 4730; /* *vec_interleave_highv2df */
                  break;

                case E_V2DImode:
                  if (pattern1346 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14481 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 6548; /* vec_interleave_highv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        case 0L:
          if (XWINT (x5, 0) == 2L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DFmode:
                  if (pattern1345 (x2, 
E_V2DFmode, 
E_V4DFmode) == 0
                      && 
#line 13541 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_vec_interleave_v2df_operator_ok (operands, 0)))
                    return 4740; /* *vec_interleave_lowv2df */
                  break;

                case E_V2DImode:
                  if (pattern1346 (x2, 
E_V2DImode, 
E_V4DImode) == 0
                      && 
#line 14531 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                    return 6554; /* vec_interleave_lowv2di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  operands[3] = x4;
  if (!const_0_to_1_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  if (!const_2_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern1346 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 14549 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 6556; /* sse2_shufpd_v2di */

    case E_V2DFmode:
      if (pattern1346 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 14549 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 6557; /* sse2_shufpd_v2df */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern607 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 8L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 40L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 41L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 10L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 42L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 11L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 43L
          || pattern1725 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 24L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 56L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 25L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 57L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 26L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 58L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 27L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 59L
          || pattern1731 (x3) != 0
          || pattern1289 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !
#line 19438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 7664; /* avx2_interleave_highv32qi */

    case 0L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 32L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 33L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 2L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 34L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 3L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 35L)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 16L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 48L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 17L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 49L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 18L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 50L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 19L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 51L)
        return -1;
      x22 = XVECEXP (x3, 0, 8);
      switch (XWINT (x22, 0))
        {
        case 4L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 36L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 5L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 37L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 6L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 38L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 7L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 39L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 20L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 52L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 21L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 53L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 22L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 54L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 23L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 55L
              || pattern1289 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !
#line 19534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 7670; /* avx2_interleave_lowv32qi */

        case 8L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 40L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 9L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 41L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 10L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 42L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 11L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 43L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 24L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 56L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 25L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 57L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 26L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 58L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 27L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 59L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1289 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 7692; /* *avx512bw_interleave_lowv32hi */

            case E_V32HFmode:
              if (pattern1289 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 7694; /* *avx512bw_interleave_lowv32hf */

            case E_V32BFmode:
              if (pattern1289 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 7696; /* *avx512bw_interleave_lowv32bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 36L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 5L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 37L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 6L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 38L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 7L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 39L
          || pattern1725 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 20L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 52L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 21L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 53L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 22L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 54L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 23L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 55L
          || pattern1731 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1289 (x2, 
E_V32HImode, 
E_V64HImode) != 0
              || !(
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7674; /* avx512bw_interleave_highv32hi */

        case E_V32HFmode:
          if (pattern1289 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
              || !(
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7676; /* avx512bw_interleave_highv32hf */

        case E_V32BFmode:
          if (pattern1289 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
              || !(
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7678; /* avx512bw_interleave_highv32bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_270 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_272 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0L
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || !register_operand (operands[0], E_V8HImode)
      || GET_MODE (x2) != E_V8HImode
      || !vector_operand (operands[1], E_V8HImode)
      || pattern1348 (x3) != 0
      || !
#line 20991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
    return -1;
  return 7796; /* sse2_pshufhw_1 */
}

 int
recog_279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode))
        {
          if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
              && 
#line 27351 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 8448; /* *avx_vperm_broadcast_v4sf */
          if (
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4SFmode)))
            return 8455; /* *avx_vpermilpv4sf */
        }
      if (!register_operand (operands[1], E_V4SFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8753; /* *ssse3_palignrv4sf_perm */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 8449; /* *avx_vperm_broadcast_v8sf */
      if (!(
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8SFmode)) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8453; /* *avx_vpermilpv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      if (avx_vbroadcast_operand (operands[2], E_VOIDmode)
          && 
#line 27379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)))
        return 8450; /* *avx_vperm_broadcast_v4df */
      if (!(
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V4DFmode)) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8459; /* *avx_vpermilpv4df */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V16SFmode)) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8451; /* *avx512f_vpermilpv16sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !nonimmediate_operand (operands[1], E_V8DFmode)
          || !(
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V8DFmode)) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8457; /* *avx512f_vpermilpv8df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && (
#line 27488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1
   && avx_vpermilp_parallel (operands[2], V2DFmode)) && 
#line 376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 8461; /* *avx_vpermilpv2df */
      if (!register_operand (operands[1], E_V2DFmode)
          || !palignr_operand (operands[2], E_VOIDmode)
          || !(
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8754; /* *ssse3_palignrv2df_perm */

    case E_V16QImode:
      if (pattern1032 (x2, 
E_V16QImode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8747; /* *ssse3_palignrv16qi_perm */

    case E_V8HImode:
      if (pattern1032 (x2, 
E_V8HImode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8748; /* *ssse3_palignrv8hi_perm */

    case E_V8HFmode:
      if (pattern1032 (x2, 
E_V8HFmode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8749; /* *ssse3_palignrv8hf_perm */

    case E_V8BFmode:
      if (pattern1032 (x2, 
E_V8BFmode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8750; /* *ssse3_palignrv8bf_perm */

    case E_V4SImode:
      if (pattern1032 (x2, 
E_V4SImode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8751; /* *ssse3_palignrv4si_perm */

    case E_V2DImode:
      if (pattern1032 (x2, 
E_V2DImode) != 0
          || !
#line 28340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 8752; /* *ssse3_palignrv2di_perm */

    default:
      return -1;
    }
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4860; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4887; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4914; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4941; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4968; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4995; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5022; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5049; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5076; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5103; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5130; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5157; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4863; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4890; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4917; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4944; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4971; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4998; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5025; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5052; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5079; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5106; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5133; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5160; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4866; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4893; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4920; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4947; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4974; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5001; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5028; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5055; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5082; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5109; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5136; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5163; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6150; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6159; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6168; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6177; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6186; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6195; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6204; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6213; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6222; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6231; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6240; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6249; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5508; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5535; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5562; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5589; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5616; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5643; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5670; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5697; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5724; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5751; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5778; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5805; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5511; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5538; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5565; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5592; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5619; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5646; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5673; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5700; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5727; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5754; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5781; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5808; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5514; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5541; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5568; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5595; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5622; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5649; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5676; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5703; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5730; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5757; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5784; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5811; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 32
      || pattern1234 (x5, 
E_V32HImode) != 0)
    return -1;
  x6 = XVECEXP (x5, 0, 8);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 9);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 10);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x5, 0, 11);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x5, 0, 12);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x5, 0, 13);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x5, 0, 14);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x5, 0, 15);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x5, 0, 16);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x5, 0, 17);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x5, 0, 18);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x5, 0, 19);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x5, 0, 20);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x5, 0, 21);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x5, 0, 22);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x5, 0, 23);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x5, 0, 24);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x5, 0, 25);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x5, 0, 26);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x5, 0, 27);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x5, 0, 28);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x5, 0, 29);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x5, 0, 30);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x5, 0, 31);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32SImode
      || pattern1366 (x4, 
E_V32SImode) != 0)
    return -1;
  x30 = XEXP (x4, 0);
  x31 = XEXP (x30, 0);
  x32 = XEXP (x31, 1);
  if (GET_MODE (x32) != E_V32SImode)
    return -1;
  x33 = XEXP (x32, 0);
  operands[2] = x33;
  if (!nonimmediate_operand (operands[2], E_V32HImode)
      || !
#line 22817 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
    return -1;
  return 7906; /* avx512bw_umulhrswv32hi3 */
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 177:
          return recog_200 (x1, insn, pnum_clobbers);

        case 118:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 1881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(!TARGET_64BIT && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          *pnum_clobbers = 1;
          return 2047; /* movdi_to_sse */

        case 119:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x2) != E_V32QImode
                  || !memory_operand (operands[1], E_V32QImode)
                  || !(
#line 1989 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3) && 
#line 600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2048; /* avx_lddqu256 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !memory_operand (operands[1], E_V16QImode)
                  || !
#line 1989 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3))
                return -1;
              return 2049; /* sse3_lddqu */

            default:
              return -1;
            }

        case 117:
          return recog_196 (x1, insn, pnum_clobbers);

        case 54:
          return recog_198 (x1, insn, pnum_clobbers);

        case 161:
          switch (pattern282 (x2))
            {
            case 0:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2367; /* *rcp14v16sf */

            case 1:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2369; /* *rcp14v8sf */

            case 2:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2371; /* *rcp14v4sf */

            case 3:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2373; /* *rcp14v8df */

            case 4:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2375; /* *rcp14v4df */

            case 5:
              if (!(
#line 3007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2377; /* *rcp14v2df */

            default:
              return -1;
            }

        case 55:
          return recog_197 (x1, insn, pnum_clobbers);

        case 162:
          switch (pattern282 (x2))
            {
            case 0:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2439; /* *rsqrt14v16sf */

            case 1:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2441; /* *rsqrt14v8sf */

            case 2:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2443; /* *rsqrt14v4sf */

            case 3:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2445; /* *rsqrt14v8df */

            case 4:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2447; /* *rsqrt14v4df */

            case 5:
              if (!(
#line 3161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2449; /* *rsqrt14v2df */

            default:
              return -1;
            }

        case 156:
          return recog_194 (x1, insn, pnum_clobbers);

        case 46:
          return recog_190 (x1, insn, pnum_clobbers);

        case 172:
          return recog_195 (x1, insn, pnum_clobbers);

        case 173:
          return recog_193 (x1, insn, pnum_clobbers);

        case 165:
          return recog_192 (x1, insn, pnum_clobbers);

        case 127:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DImode:
              if (!register_operand (operands[0], E_V8DImode)
                  || GET_MODE (x2) != E_V8DImode
                  || !memory_operand (operands[1], E_V8DImode)
                  || !(
#line 23769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8011; /* avx512f_movntdqa */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x2) != E_V4DImode
                  || !memory_operand (operands[1], E_V4DImode)
                  || !(
#line 23769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 707 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 8012; /* avx2_movntdqa */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || !memory_operand (operands[1], E_V2DImode)
                  || !
#line 23769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8013; /* sse4_1_movntdqa */

            default:
              return -1;
            }

        case 129:
          if (GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V8HImode)
              || !
#line 24095 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8046; /* sse4_1_phminposuw */

        case 136:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8349; /* xop_frczv4sf2 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8350; /* xop_frczv2df2 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8SFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8351; /* xop_frczv8sf2 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x2) != E_V4DFmode
                  || !nonimmediate_operand (operands[1], E_V4DFmode)
                  || !
#line 26982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8352; /* xop_frczv4df2 */

            default:
              return -1;
            }

        case 134:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x4;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              x6 = XEXP (x4, 1);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern919 (x2, 
E_V16QImode) != 0
                      || !
#line 27045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8363; /* xop_maskcmp_uns2v16qi3 */

                case E_V8HImode:
                  if (pattern919 (x2, 
E_V8HImode) != 0
                      || !
#line 27045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8364; /* xop_maskcmp_uns2v8hi3 */

                case E_V4SImode:
                  if (pattern919 (x2, 
E_V4SImode) != 0
                      || !
#line 27045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8365; /* xop_maskcmp_uns2v4si3 */

                case E_V2DImode:
                  if (pattern919 (x2, 
E_V2DImode) != 0
                      || !
#line 27045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8366; /* xop_maskcmp_uns2v2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 141:
          if (GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[0], E_V2DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_operand (operands[1], E_V2DImode)
              || !
#line 27159 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES))
            return -1;
          return 8379; /* aesimc */

        case 149:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !memory_operand (operands[1], E_V4HImode)
                  || !
#line 29077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 8942; /* *vcvtph2ps_load */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x2) != E_V8SFmode
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 29087 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
                return -1;
              return 8944; /* vcvtph2ps256 */

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x2) != E_V16SFmode
                  || !vector_operand (operands[1], E_V16HImode)
                  || !
#line 29099 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 8946; /* *avx512f_vcvtph2ps512 */

            default:
              return -1;
            }

        case 168:
          return recog_199 (x1, insn, pnum_clobbers);

        case 253:
          switch (pattern284 (x2))
            {
            case 0:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9786; /* vcvtph2bf8v16hf */

            case 1:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9794; /* vcvtph2bf8v32hf */

            default:
              return -1;
            }

        case 254:
          switch (pattern284 (x2))
            {
            case 0:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9788; /* vcvtph2bf8sv16hf */

            case 1:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9796; /* vcvtph2bf8sv32hf */

            default:
              return -1;
            }

        case 255:
          switch (pattern284 (x2))
            {
            case 0:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9790; /* vcvtph2hf8v16hf */

            case 1:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9798; /* vcvtph2hf8v32hf */

            default:
              return -1;
            }

        case 256:
          switch (pattern284 (x2))
            {
            case 0:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9792; /* vcvtph2hf8sv16hf */

            case 1:
              if (!
#line 31909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9800; /* vcvtph2hf8sv32hf */

            default:
              return -1;
            }

        case 257:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x2) != E_V32HFmode
                  || !nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 31918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9802; /* vcvthf82phv32hf */

            case E_V16HFmode:
              if (!register_operand (operands[0], E_V16HFmode)
                  || GET_MODE (x2) != E_V16HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9804; /* vcvthf82phv16hf */

            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !nonimmediate_operand (operands[1], E_V16QImode)
                  || !
#line 31918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9806; /* vcvthf82phv8hf */

            default:
              return -1;
            }

        case 263:
          switch (pattern285 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10015; /* avx10_2_cvtbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10023; /* avx10_2_cvtbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10031; /* avx10_2_cvtbf162ibsv8bf */

            default:
              return -1;
            }

        case 264:
          switch (pattern285 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10017; /* avx10_2_cvtbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10025; /* avx10_2_cvtbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10033; /* avx10_2_cvtbf162iubsv8bf */

            default:
              return -1;
            }

        case 269:
          switch (pattern285 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10019; /* avx10_2_cvttbf162ibsv32bf */

            case 1:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10027; /* avx10_2_cvttbf162ibsv16bf */

            case 2:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10035; /* avx10_2_cvttbf162ibsv8bf */

            default:
              return -1;
            }

        case 270:
          switch (pattern285 (x2, 
E_V32BFmode, 
E_V16BFmode, 
E_V8BFmode))
            {
            case 0:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10021; /* avx10_2_cvttbf162iubsv32bf */

            case 1:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10029; /* avx10_2_cvttbf162iubsv16bf */

            case 2:
              if (!
#line 32491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 10037; /* avx10_2_cvttbf162iubsv8bf */

            default:
              return -1;
            }

        case 265:
          switch (pattern285 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10039; /* avx10_2_cvtph2ibsv32hf */

            case 1:
              if (!
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10047; /* avx10_2_cvtph2ibsv16hf */

            case 2:
              if (!
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10051; /* avx10_2_cvtph2ibsv8hf */

            default:
              return -1;
            }

        case 266:
          switch (pattern285 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10043; /* avx10_2_cvtph2iubsv32hf */

            case 1:
              if (!
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10049; /* avx10_2_cvtph2iubsv16hf */

            case 2:
              if (!
#line 32506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10053; /* avx10_2_cvtph2iubsv8hf */

            default:
              return -1;
            }

        case 271:
          switch (pattern285 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10055; /* avx10_2_cvttph2ibsv32hf */

            case 1:
              if (!
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10063; /* avx10_2_cvttph2ibsv16hf */

            case 2:
              if (!
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10067; /* avx10_2_cvttph2ibsv8hf */

            default:
              return -1;
            }

        case 272:
          switch (pattern285 (x2, 
E_V32HFmode, 
E_V16HFmode, 
E_V8HFmode))
            {
            case 0:
              if (!(
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 561 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10059; /* avx10_2_cvttph2iubsv32hf */

            case 1:
              if (!
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10065; /* avx10_2_cvttph2iubsv16hf */

            case 2:
              if (!
#line 32521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10069; /* avx10_2_cvttph2iubsv8hf */

            default:
              return -1;
            }

        case 267:
          switch (pattern286 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10071; /* avx10_2_cvtps2ibsv16sf */

            case 1:
              if (!
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10079; /* avx10_2_cvtps2ibsv8sf */

            case 2:
              if (!
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10083; /* avx10_2_cvtps2ibsv4sf */

            default:
              return -1;
            }

        case 268:
          switch (pattern286 (x2))
            {
            case 0:
              if (!(
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10075; /* avx10_2_cvtps2iubsv16sf */

            case 1:
              if (!
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10081; /* avx10_2_cvtps2iubsv8sf */

            case 2:
              if (!
#line 32536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10085; /* avx10_2_cvtps2iubsv4sf */

            default:
              return -1;
            }

        case 273:
          switch (pattern286 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10087; /* avx10_2_cvttps2ibsv16sf */

            case 1:
              if (!
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10095; /* avx10_2_cvttps2ibsv8sf */

            case 2:
              if (!
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10099; /* avx10_2_cvttps2ibsv4sf */

            default:
              return -1;
            }

        case 274:
          switch (pattern286 (x2))
            {
            case 0:
              if (!(
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10091; /* avx10_2_cvttps2iubsv16sf */

            case 1:
              if (!
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10097; /* avx10_2_cvttps2iubsv8sf */

            case 2:
              if (!
#line 32551 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10101; /* avx10_2_cvttps2iubsv4sf */

            default:
              return -1;
            }

        case 275:
          switch (pattern287 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10103; /* avx10_2_vcvttps2dqsv16sf */

            case 1:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10111; /* avx10_2_vcvttps2dqsv8sf */

            case 2:
              if (!(
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10119; /* avx10_2_vcvttpd2dqsv8df */

            case 3:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10115; /* avx10_2_vcvttps2dqsv4sf */

            case 4:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10127; /* avx10_2_vcvttpd2dqsv4df */

            case 5:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10131; /* avx10_2_vcvttpd2dqsv2df */

            case 6:
              if (!(
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10135; /* avx10_2_vcvttpd2qqsv8df */

            case 7:
              if (!(
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10151; /* avx10_2_vcvttps2qqsv8di */

            case 8:
              if (!
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10143; /* avx10_2_vcvttpd2qqsv4df */

            case 9:
              if (!
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10159; /* avx10_2_vcvttps2qqsv4di */

            case 10:
              if (!
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10147; /* avx10_2_vcvttpd2qqsv2df */

            case 11:
              if (!
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10163; /* avx10_2_vcvttps2qqsv2di */

            default:
              return -1;
            }

        case 276:
          switch (pattern287 (x2))
            {
            case 0:
              if (!(
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10107; /* avx10_2_vcvttps2udqsv16sf */

            case 1:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10113; /* avx10_2_vcvttps2udqsv8sf */

            case 2:
              if (!(
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10123; /* avx10_2_vcvttpd2udqsv8df */

            case 3:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10117; /* avx10_2_vcvttps2udqsv4sf */

            case 4:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10129; /* avx10_2_vcvttpd2udqsv4df */

            case 5:
              if (!
#line 32570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10133; /* avx10_2_vcvttpd2udqsv2df */

            case 6:
              if (!(
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10139; /* avx10_2_vcvttpd2uqqsv8df */

            case 7:
              if (!(
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1) && 
#line 617 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10155; /* avx10_2_vcvttps2uqqsv8di */

            case 8:
              if (!
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10145; /* avx10_2_vcvttpd2uqqsv4df */

            case 9:
              if (!
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10161; /* avx10_2_vcvttps2uqqsv4di */

            case 10:
              if (!
#line 32581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10149; /* avx10_2_vcvttpd2uqqsv2df */

            case 11:
              if (!
#line 32592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && 1))
                return -1;
              return 10165; /* avx10_2_vcvttps2uqqsv2di */

            default:
              return -1;
            }

        case 279:
          return recog_191 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 2:
      return recog_248 (x1, insn, pnum_clobbers);

    case 3:
      return recog_247 (x1, insn, pnum_clobbers);

    case 4:
      return recog_246 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_281 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !nonimmediate_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 14872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return 6566; /* vec_dupv2df */
          if (!(
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8581; /* *avx512vl_vec_dup_gprv2df */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8527; /* *avx512f_broadcastv16sf */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8571; /* *avx512f_vec_dup_gprv16sf */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 28053 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8627; /* *avx512dq_broadcastv16sf_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 27733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8529; /* *avx512f_broadcastv16si */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8559; /* *avx512f_vec_dup_gprv16si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 28053 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8629; /* *avx512dq_broadcastv16si_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 27745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8531; /* *avx512f_broadcastv8df */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8577; /* *avx512f_vec_dup_gprv8df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8633; /* *avx512dq_broadcastv8df_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 27745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8533; /* *avx512f_broadcastv8di */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8565; /* *avx512f_vec_dup_gprv8di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8631; /* *avx512dq_broadcastv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x3) != E_V64QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8535; /* *avx512bw_vec_dup_gprv64qi */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8537; /* *avx512vl_vec_dup_gprv16qi */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8592; /* *vec_dupv16qi */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8539; /* *avx512vl_vec_dup_gprv32qi */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8591; /* *vec_dupv32qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !(
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8541; /* *avx512bw_vec_dup_gprv32hi */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8543; /* *avx512vl_vec_dup_gprv16hi */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8593; /* *vec_dupv16hi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8545; /* *avx512vl_vec_dup_gprv8hi */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8594; /* *vec_dupv8hi */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !(
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8547; /* *avx512bw_vec_dup_gprv32hf */

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x3) != E_V16HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8549; /* *avx512vl_vec_dup_gprv16hf */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8597; /* *vec_dupv16hf */

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !nonimmediate_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8551; /* *avx512fp16_vec_dup_gprv8hf */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8598; /* *vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x3) != E_V32BFmode
              || !nonimmediate_operand (operands[1], E_BFmode)
              || !(
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8553; /* *avx512bw_vec_dup_gprv32bf */

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x3) != E_V16BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8555; /* *avx512vl_vec_dup_gprv16bf */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8599; /* *vec_dupv16bf */

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !nonimmediate_operand (operands[1], E_BFmode))
            return -1;
          if ((
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8557; /* *avx512vl_vec_dup_gprv8bf */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8600; /* *vec_dupv8bf */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8561; /* *avx512vl_vec_dup_gprv8si */
              if (
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8595; /* *vec_dupv8si */
              if (!
#line 27939 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 8601; /* vec_dupv8si */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !
#line 28040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 8623; /* *avx512vl_broadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8563; /* *avx512vl_vec_dup_gprv4si */
          if (
#line 27816 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 8584; /* *vec_dupv4si */
          if (!
#line 27919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8596; /* *vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8567; /* *avx512vl_vec_dup_gprv4di */
              if (!
#line 27939 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 8603; /* vec_dupv4di */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8635; /* *avx512dq_broadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8569; /* *avx512vl_vec_dup_gprv2di */
          if (!
#line 27844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8585; /* *vec_dupv2di */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8573; /* *avx512vl_vec_dup_gprv8sf */
              if (!
#line 27939 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 8602; /* vec_dupv8sf */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 28040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                return -1;
              return 8625; /* *avx512vl_broadcastv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 8575; /* *avx512vl_vec_dup_gprv4sf */
          if (!
#line 27784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8583; /* vec_dupv4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode))
                return -1;
              if ((
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8579; /* *avx512vl_vec_dup_gprv4df */
              if (!
#line 27939 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return -1;
              return 8604; /* vec_dupv4df */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8637; /* *avx512dq_broadcastv4df_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          switch (pattern610 (x3, 
E_V8SFmode))
            {
            case 0:
              if (!(
#line 31630 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9710; /* vbcstnebf162ps_v8sf */

            case 1:
              if (!(
#line 31641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 9712; /* vbcstnesh2ps_v8sf */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern610 (x3, 
E_V4SFmode))
            {
            case 0:
              if (!
#line 31630 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 9711; /* vbcstnebf162ps_v4sf */

            case 1:
              if (!
#line 31641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                return -1;
              return 9713; /* vbcstnesh2ps_v4sf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern31 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6993; /* *lshrv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7016; /* lshrv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8894; /* avx512vl_lshrvv16hi */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6997; /* *lshrv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7018; /* lshrv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8890; /* avx512vl_lshrvv8hi */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7001; /* *lshrv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7020; /* lshrv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8870; /* avx2_lshrvv8si */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7005; /* *lshrv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7022; /* lshrv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8874; /* avx2_lshrvv4si */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7009; /* *lshrv4di3 */
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 776 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7024; /* lshrv4di3 */
      if (!nonimmediate_operand (operands[2], E_V4DImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8882; /* avx2_lshrvv4di */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7013; /* *lshrv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7026; /* lshrv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8886; /* avx2_lshrvv2di */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7033; /* lshrv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8898; /* avx512bw_lshrvv32hi */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7037; /* lshrv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8866; /* avx512f_lshrvv16si */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7041; /* lshrv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8878; /* avx512f_lshrvv8di */

    case 9:
      if (!(
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7044; /* avx512bw_lshrv4ti3 */

    case 10:
      if (nonimmediate_operand (operands[1], E_V2TImode)
          && (
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7046; /* avx512bw_lshrv2ti3 */
      if (!register_operand (operands[1], E_V2TImode)
          || !(
#line 17598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 732 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7050; /* avx2_lshrv2ti3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V1TImode)
          && (
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7048; /* avx512bw_lshrv1ti3 */
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 17598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7052; /* sse2_lshrv1ti3 */

    default:
      return -1;
    }
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern35 (x1))
    {
    case 0:
      if (!
#line 24108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8049; /* avx2_zero_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24162 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8057; /* avx512bw_zero_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8069; /* *sse4_1_zero_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8081; /* *avx512f_zero_extendv16qiv16si2 */

    case 4:
      if (!
#line 24500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8109; /* avx512f_zero_extendv16hiv16si2 */

    case 5:
      if (!
#line 24389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8089; /* *avx2_zero_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24553 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8117; /* avx2_zero_extendv8hiv8si2 */

    case 7:
      if (!
#line 24450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8101; /* *sse4_1_zero_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8129; /* *sse4_1_zero_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8145; /* *avx512f_zero_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8176; /* avx512f_zero_extendv8hiv8di2 */

    case 11:
      if (!
#line 25062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8204; /* avx512f_zero_extendv8siv8di2 */

    case 12:
      if (!
#line 24812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8157; /* *avx2_zero_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24955 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8184; /* *avx2_zero_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8210; /* avx2_zero_extendv4siv4di2 */

    case 15:
      if (!
#line 24874 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8169; /* *sse4_1_zero_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8196; /* *sse4_1_zero_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8220; /* *sse4_1_zero_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern475 (x2))
        {
        case 0:
          if (
#line 24220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8065; /* sse4_1_zero_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24378 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8085; /* avx2_zero_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24744 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8141; /* avx512f_zero_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8097; /* sse4_1_zero_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8125; /* sse4_1_zero_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24801 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8153; /* avx2_zero_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24944 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8180; /* avx2_zero_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8165; /* sse4_1_zero_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8192; /* sse4_1_zero_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8216; /* sse4_1_zero_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_CONCAT:
          switch (pattern613 (x2))
            {
            case 0:
              if (!
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8073; /* *sse4_1_zero_extendv8qiv8hi2_2 */

            case 1:
              if (!
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8093; /* *avx2_zero_extendv8qiv8si2_2 */

            case 2:
              if (!
#line 24772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 8149; /* *avx512f_zero_extendv8qiv8di2_2 */

            case 3:
              if (!
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8133; /* *sse4_1_zero_extendv4hiv4si2_2 */

            case 4:
              if (!
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8188; /* *avx2_zero_extendv4hiv4di2_2 */

            case 5:
              if (!
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                return -1;
              return 8224; /* *sse4_1_zero_extendv2siv2di2_2 */

            default:
              return -1;
            }

        case VEC_MERGE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != VEC_DUPLICATE)
            return -1;
          if (GET_MODE (x6) == E_V4SImode)
            {
              switch (pattern939 (x2))
                {
                case 0:
                  if (
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8105; /* *sse4_1_zero_extendv4qiv4si2_2 */
                  break;

                case 1:
                  if (
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
                    return 8161; /* *avx2_zero_extendv4qiv4di2_2 */
                  break;

                case 2:
                  if (
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
                    return 8200; /* *sse4_1_zero_extendv2hiv2di2_2 */
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          switch (pattern940 (x2))
            {
            case 0:
              if (!
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8171; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 1:
              if (!
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8172; /* *sse4_1_zero_extendv2qiv2di2_2 */

            case 2:
              if (!
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                return -1;
              return 8173; /* *sse4_1_zero_extendv2qiv2di2_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_285 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      res = recog_297 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_290 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NOT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == XOR)
        {
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern742 (x3, 
E_V16SImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 7416; /* *xnorv16si3 */
              break;

            case E_V8DImode:
              if (pattern742 (x3, 
E_V8DImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 7417; /* *xnorv8di3 */
              break;

            case E_V64QImode:
              if (pattern742 (x3, 
E_V64QImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 7418; /* *xnorv64qi3 */
              break;

            case E_V32QImode:
              if (pattern742 (x3, 
E_V32QImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 7419; /* *xnorv32qi3 */
              break;

            case E_V16QImode:
              if (pattern742 (x3, 
E_V16QImode) == 0
                  && 
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
                return 7420; /* *xnorv16qi3 */
              break;

            case E_V32HImode:
              if (pattern742 (x3, 
E_V32HImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 7421; /* *xnorv32hi3 */
              break;

            case E_V16HImode:
              if (pattern742 (x3, 
E_V16HImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 7422; /* *xnorv16hi3 */
              break;

            case E_V8HImode:
              if (pattern742 (x3, 
E_V8HImode) == 0
                  && 
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
                return 7423; /* *xnorv8hi3 */
              break;

            case E_V8SImode:
              if (pattern742 (x3, 
E_V8SImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 7424; /* *xnorv8si3 */
              break;

            case E_V4SImode:
              if (pattern742 (x3, 
E_V4SImode) == 0
                  && 
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
                return 7425; /* *xnorv4si3 */
              break;

            case E_V4DImode:
              if (pattern742 (x3, 
E_V4DImode) == 0
                  && (
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 7426; /* *xnorv4di3 */
              break;

            case E_V2DImode:
              if (pattern742 (x3, 
E_V2DImode) == 0
                  && 
#line 18976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
                return 7427; /* *xnorv2di3 */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  switch (pattern186 ())
    {
    case 0:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 4837; /* *avx512bw_vpternlogv32hf_0 */
      break;

    case 1:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 4838; /* *avx512vl_vpternlogv16hf_0 */
      break;

    case 2:
      if (
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return 4839; /* *avx512fp16_vpternlogv8hf_0 */
      break;

    case 3:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 4840; /* *avx512bw_vpternlogv32bf_0 */
      break;

    case 4:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 4841; /* *avx512vl_vpternlogv16bf_0 */
      break;

    case 5:
      if (
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return 4842; /* *avx512vl_vpternlogv8bf_0 */
      break;

    case 6:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 4843; /* *avx512f_vpternlogv16sf_0 */
      break;

    case 7:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 4844; /* *avx512vl_vpternlogv8sf_0 */
      break;

    case 8:
      if (
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return 4845; /* *avx512vl_vpternlogv4sf_0 */
      break;

    case 9:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 4846; /* *avx512f_vpternlogv8df_0 */
      break;

    case 10:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 4847; /* *avx512vl_vpternlogv4df_0 */
      break;

    case 11:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return 4848; /* *avx512vl_vpternlogv2df_0 */
      break;

    default:
      break;
    }
  switch (GET_CODE (x3))
    {
    case AND:
      return recog_296 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_295 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_294 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern453 (x3, 
E_V32HFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2330; /* avx512fp16_divv32hf3 */

    case E_V16HFmode:
      if (pattern453 (x3, 
E_V16HFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2334; /* avx512fp16_divv16hf3 */

    case E_V8HFmode:
      if (pattern453 (x3, 
E_V8HFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2336; /* avx512fp16_divv8hf3 */

    case E_V16SFmode:
      if (pattern453 (x3, 
E_V16SFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2338; /* avx512f_divv16sf3 */

    case E_V8SFmode:
      if (pattern453 (x3, 
E_V8SFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2342; /* avx_divv8sf3 */

    case E_V4SFmode:
      if (pattern453 (x3, 
E_V4SFmode) != 0
          || !
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1))
        return -1;
      return 2344; /* sse_divv4sf3 */

    case E_V8DFmode:
      if (pattern453 (x3, 
E_V8DFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2346; /* avx512f_divv8df3 */

    case E_V4DFmode:
      if (pattern453 (x3, 
E_V4DFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2350; /* avx_divv4df3 */

    case E_V2DFmode:
      if (pattern453 (x3, 
E_V2DFmode) != 0
          || !(
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2352; /* sse2_divv2df3 */

    case E_V32BFmode:
      if (pattern27 (x3, 
E_V32BFmode) != 0
          || !
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9895; /* avx10_2_divbf16_v32bf */

    case E_V16BFmode:
      if (pattern27 (x3, 
E_V16BFmode) != 0
          || !
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9903; /* avx10_2_divbf16_v16bf */

    case E_V8BFmode:
      if (pattern27 (x3, 
E_V8BFmode) != 0
          || !
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9911; /* avx10_2_divbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern300 (x5, 
E_CCmode, 
17) != 0)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  res = recog_340 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 8L
      || pattern650 (x2) != 0)
    return -1;
  switch (pattern1293 (x2))
    {
    case 0:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 648; /* *andqi_exthi_3 */

    case 1:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 651; /* *andqi_extsi_3 */

    case 2:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 649; /* *iorqi_exthi_3 */

    case 3:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 652; /* *iorqi_extsi_3 */

    case 4:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 650; /* *xorqi_exthi_3 */

    case 5:
      if (!
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[1]) == GET_MODE (operands[2])))
        return -1;
      return 653; /* *xorqi_extsi_3 */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 39:
      if (GET_MODE (x3) != E_CCGZmode)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != LTU
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern617 (x1, 
CLOBBER, 
E_CCGZmode, 
17) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!x86_64_general_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 435; /* subsi3_carry_ccgz */

    case 52:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      if (pattern846 (x1) != 0
          || !
#line 23140 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 7924; /* *ssse3_pshufbv8qi3 */

    case 132:
      if (pattern483 (x1, 
132, 
3) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      operands[3] = x4;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x12, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (pattern1615 (x3))
        {
        case 0:
          if (!
#line 26017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8276; /* sse4_2_pcmpistri */

        case 1:
          if (!
#line 26041 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2))
            return -1;
          return 8277; /* sse4_2_pcmpistrm */

        default:
          return -1;
        }

    case 153:
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 154)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x11 = XEXP (x2, 0);
      operands[0] = x11;
      x16 = XVECEXP (x5, 0, 2);
      if (!const1248_operand (x16, E_SImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x8 = XVECEXP (x3, 0, 1);
          operands[7] = x8;
          operands[6] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[4] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[3] = x18;
          operands[5] = x16;
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (!register_operand (operands[0], E_V16SImode)
                  || GET_MODE (x3) != E_V16SImode
                  || !vsib_mem_operator (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode))
                    return -1;
                  switch (pattern1665 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9035; /* *avx512f_gathersiv16si */

                    case 1:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9047; /* *avx512f_gathersiv16si */

                    default:
                      return -1;
                    }

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1665 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9083; /* *avx512f_gatherdiv16si */

                    case 1:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9095; /* *avx512f_gatherdiv16si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (!register_operand (operands[0], E_V16SFmode)
                  || GET_MODE (x3) != E_V16SFmode
                  || !vsib_mem_operator (operands[6], E_SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode))
                    return -1;
                  switch (pattern1665 (x5, 
E_HImode, 
E_V16SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9036; /* *avx512f_gathersiv16sf */

                    case 1:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9048; /* *avx512f_gathersiv16sf */

                    default:
                      return -1;
                    }

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1665 (x5, 
E_QImode, 
E_V8DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9084; /* *avx512f_gatherdiv16sf */

                    case 1:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9096; /* *avx512f_gatherdiv16sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1590 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9037; /* *avx512f_gathersiv8di */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9085; /* *avx512f_gatherdiv8di */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9049; /* *avx512f_gathersiv8di */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9097; /* *avx512f_gatherdiv8di */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1590 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9038; /* *avx512f_gathersiv8df */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9086; /* *avx512f_gatherdiv8df */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9050; /* *avx512f_gathersiv8df */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9098; /* *avx512f_gatherdiv8df */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (pattern1591 (x3, 
E_SImode, 
E_V8SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  switch (pattern1677 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9039; /* *avx512f_gathersiv8si */

                    case 1:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9051; /* *avx512f_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode))
                    return -1;
                  switch (pattern1677 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9087; /* *avx512f_gatherdiv8si */

                    case 1:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9099; /* *avx512f_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (pattern1591 (x3, 
E_SFmode, 
E_V8SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode))
                    return -1;
                  switch (pattern1677 (x5, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9040; /* *avx512f_gathersiv8sf */

                    case 1:
                      if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9052; /* *avx512f_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode))
                    return -1;
                  switch (pattern1677 (x5, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                        return -1;
                      return 9088; /* *avx512f_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                        return -1;
                      return 9100; /* *avx512f_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1593 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9041; /* *avx512f_gathersiv4di */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9089; /* *avx512f_gatherdiv4di */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9053; /* *avx512f_gathersiv4di */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9101; /* *avx512f_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1593 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9042; /* *avx512f_gathersiv4df */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9090; /* *avx512f_gatherdiv4df */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9054; /* *avx512f_gathersiv4df */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9102; /* *avx512f_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1595 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9043; /* *avx512f_gathersiv4si */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9091; /* *avx512f_gatherdiv4si */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9055; /* *avx512f_gathersiv4si */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9103; /* *avx512f_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1595 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9044; /* *avx512f_gathersiv4sf */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9092; /* *avx512f_gatherdiv4sf */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9056; /* *avx512f_gathersiv4sf */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9104; /* *avx512f_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1595 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9045; /* *avx512f_gathersiv2di */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9093; /* *avx512f_gatherdiv2di */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9057; /* *avx512f_gathersiv2di */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9105; /* *avx512f_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1595 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9046; /* *avx512f_gathersiv2df */

                case 1:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9094; /* *avx512f_gatherdiv2df */

                case 2:
                  if (!(
#line 29457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9058; /* *avx512f_gathersiv2df */

                case 3:
                  if (!(
#line 29519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9106; /* *avx512f_gatherdiv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          x8 = XVECEXP (x3, 0, 1);
          operands[6] = x8;
          operands[5] = x4;
          x17 = XVECEXP (x5, 0, 0);
          operands[3] = x17;
          x18 = XVECEXP (x5, 0, 1);
          operands[2] = x18;
          operands[4] = x16;
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              switch (pattern1564 (x3, 
E_SImode, 
E_V16SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9059; /* *avx512f_gathersiv16si_2 */

                case 1:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9071; /* *avx512f_gathersiv16si_2 */

                case 2:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9107; /* *avx512f_gatherdiv16si_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9119; /* *avx512f_gatherdiv16si_2 */

                default:
                  return -1;
                }

            case E_V16SFmode:
              switch (pattern1564 (x3, 
E_SFmode, 
E_V16SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9060; /* *avx512f_gathersiv16sf_2 */

                case 1:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9072; /* *avx512f_gathersiv16sf_2 */

                case 2:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9108; /* *avx512f_gatherdiv16sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9120; /* *avx512f_gatherdiv16sf_2 */

                default:
                  return -1;
                }

            case E_V8DImode:
              switch (pattern1566 (x3, 
E_DImode, 
E_V8DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9061; /* *avx512f_gathersiv8di_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9109; /* *avx512f_gatherdiv8di_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9073; /* *avx512f_gathersiv8di_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9121; /* *avx512f_gatherdiv8di_2 */

                default:
                  return -1;
                }

            case E_V8DFmode:
              switch (pattern1566 (x3, 
E_DFmode, 
E_V8DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9062; /* *avx512f_gathersiv8df_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9110; /* *avx512f_gatherdiv8df_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9074; /* *avx512f_gathersiv8df_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9122; /* *avx512f_gatherdiv8df_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1568 (x3, 
E_SImode, 
E_V8SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9063; /* *avx512f_gathersiv8si_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9111; /* *avx512f_gatherdiv8si_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9075; /* *avx512f_gathersiv8si_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9123; /* *avx512f_gatherdiv8si_2 */

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1568 (x3, 
E_SFmode, 
E_V8SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9064; /* *avx512f_gathersiv8sf_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9112; /* *avx512f_gatherdiv8sf_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9076; /* *avx512f_gathersiv8sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9124; /* *avx512f_gatherdiv8sf_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1570 (x3, 
E_DImode, 
E_V4DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9065; /* *avx512f_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9113; /* *avx512f_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9077; /* *avx512f_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9125; /* *avx512f_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1570 (x3, 
E_DFmode, 
E_V4DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9066; /* *avx512f_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9114; /* *avx512f_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9078; /* *avx512f_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9126; /* *avx512f_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1572 (x3, 
E_SImode, 
E_V4SImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9067; /* *avx512f_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9115; /* *avx512f_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9079; /* *avx512f_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9127; /* *avx512f_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1572 (x3, 
E_SFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9068; /* *avx512f_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9116; /* *avx512f_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9080; /* *avx512f_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9128; /* *avx512f_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern1572 (x3, 
E_DImode, 
E_V2DImode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9069; /* *avx512f_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9117; /* *avx512f_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9081; /* *avx512f_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9129; /* *avx512f_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1572 (x3, 
E_DFmode, 
E_V2DFmode))
                {
                case 0:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9070; /* *avx512f_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return -1;
                  return 9118; /* *avx512f_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9082; /* *avx512f_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return -1;
                  return 9130; /* *avx512f_gatherdiv2df_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern37 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 28
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 29
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 30
      || GET_MODE (x9) != E_DImode)
    return -1;
  x10 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 31
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 32
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 33
      || GET_MODE (x15) != E_DImode)
    return -1;
  x16 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 34
      || GET_MODE (x17) != E_DImode)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 35
      || GET_MODE (x19) != E_DImode)
    return -1;
  switch (XINT (x2, 1))
    {
    case 90:
      if (!
#line 6868 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX))
        return -1;
      return 1879; /* *mmx_emms */

    case 91:
      if (!
#line 6869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1880; /* *mmx_femms */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_402 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_391 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_397 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_398 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_399 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_400 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 9:
          if (pattern37 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case SET:
                  x3 = XEXP (x2, 1);
                  if (GET_CODE (x3) == UNSPEC_VOLATILE
                      && XVECLEN (x3, 0) == 1
                      && XINT (x3, 1) == 40
                      && GET_MODE (x3) == E_BLKmode)
                    {
                      x4 = XVECEXP (x3, 0, 0);
                      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        {
                          x5 = XEXP (x2, 0);
                          operands[0] = x5;
                          if (memory_operand (operands[0], E_BLKmode)
                              && 
#line 29365 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                            return 1546; /* fnstenv */
                        }
                    }
                  break;

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x2, 0) == 1
                      && XINT (x2, 1) == 41)
                    {
                      x6 = XVECEXP (x2, 0, 0);
                      operands[0] = x6;
                      if (memory_operand (operands[0], E_BLKmode)
                          && 
#line 29383 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                        return 1547; /* fldenv */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case 17:
          res = recog_401 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 97)
            return -1;
          x6 = XVECEXP (x2, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x1;
          if (!vzeroall_operation (operands[0], E_VOIDmode)
              || !
#line 27222 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8382; /* *avx_vzeroall */

        case SET:
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC_VOLATILE)
            return -1;
          switch (XVECLEN (x3, 0))
            {
            case 2:
              if (pattern333 (x3, 
107) != 0)
                return -1;
              operands[2] = x1;
              if (!encodekey128_operation (operands[2], E_VOIDmode))
                return -1;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x4 = XVECEXP (x3, 0, 0);
              operands[1] = x4;
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 31275 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
                return -1;
              return 9646; /* *encodekey128u32 */

            case 3:
              if (pattern333 (x3, 
108) != 0)
                return -1;
              x7 = XVECEXP (x3, 0, 2);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 21
                  || GET_MODE (x7) != E_V2DImode)
                return -1;
              operands[2] = x1;
              if (!encodekey256_operation (operands[2], E_VOIDmode))
                return -1;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x4 = XVECEXP (x3, 0, 0);
              operands[1] = x4;
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 31333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
                return -1;
              return 9647; /* *encodekey256u32 */

            case 1:
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 17
                  || GET_MODE (x5) != E_CCZmode)
                return -1;
              operands[1] = x1;
              if (!aeswidekl_operation (operands[1], E_VOIDmode)
                  || GET_MODE (x3) != E_CCZmode)
                return -1;
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (!memory_operand (operands[0], E_BLKmode))
                return -1;
              switch (XINT (x3, 1))
                {
                case 103:
                  if (!
#line 31417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                    return -1;
                  return 9652; /* *aesdecwide128klu8 */

                case 105:
                  if (!
#line 31417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                    return -1;
                  return 9653; /* *aesdecwide256klu8 */

                case 104:
                  if (!
#line 31417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                    return -1;
                  return 9654; /* *aesencwide128klu8 */

                case 106:
                  if (!
#line 31417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_WIDEKL))
                    return -1;
                  return 9655; /* *aesencwide256klu8 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x1, 1);
      operands[1] = x10;
      if (call_insn_operand (operands[0], E_SImode)
          && (
#line 20147 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return 1209; /* *call */
      if (call_insn_operand (operands[0], E_DImode)
          && (
#line 20147 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return 1210; /* *call */
      switch (GET_CODE (x9))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_DImode)
            {
              x11 = XEXP (x9, 0);
              operands[0] = x11;
              if (GOT_memory_operand (operands[0], E_SImode))
                {
                  operands[1] = x10;
                  if (
#line 20156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER))
                    return 1211; /* *call_got_x32 */
                }
            }
          break;

        case MEM:
          if (GET_MODE (x9) == E_SImode)
            {
              x11 = XEXP (x9, 0);
              if (GET_CODE (x11) == PLUS
                  && GET_MODE (x11) == E_SImode)
                {
                  x12 = XEXP (x11, 0);
                  operands[0] = x12;
                  if (register_no_elim_operand (operands[0], E_SImode))
                    {
                      x13 = XEXP (x11, 1);
                      operands[1] = x13;
                      if (GOT32_symbol_operand (operands[1], E_SImode))
                        {
                          operands[2] = x10;
                          if (
#line 20171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_MACHO
  && !TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER
  && SIBLING_CALL_P (insn)))
                            return 1212; /* *sibcall_GOT_32 */
                        }
                    }
                }
            }
          break;

        default:
          break;
        }
      operands[0] = x9;
      operands[1] = x10;
      if (sibcall_insn_operand (operands[0], E_SImode)
          && (
#line 20184 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return 1213; /* *sibcall */
      if (!sibcall_insn_operand (operands[0], E_DImode)
          || !(
#line 20184 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      return 1214; /* *sibcall */

    case UNSPEC_VOLATILE:
      return recog_403 (x1, insn, pnum_clobbers);

    case SIMPLE_RETURN:
      if (!
#line 20645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
        return -1;
      return 1234; /* simple_return_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 1240; /* nop */

    case EH_RETURN:
      return 1246; /* eh_return_internal */

    case TRAP_IF:
      x8 = XEXP (x1, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XEXP (x1, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      return 1525; /* trap */

    case PREFETCH:
      x10 = XEXP (x1, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0L:
          x14 = XEXP (x1, 2);
          operands[1] = x14;
          if (const_int_operand (operands[1], E_SImode)
              && 
#line 28985 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_PREFETCH_SSE))
            return 1527; /* *prefetch_sse */
          break;

        case 2L:
          x14 = XEXP (x1, 2);
          if (x14 == const_int_rtx[MAX_SAVED_CONST_INT + 1]
              && 
#line 29042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_MOVRS))
            return 1529; /* *prefetch_rst2 */
          break;

        default:
          break;
        }
      x14 = XEXP (x1, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[1] = x10;
      if (!const_int_operand (operands[1], E_SImode)
          || !
#line 29006 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_3DNOW || TARGET_PRFCHW))
        return -1;
      return 1528; /* *prefetch_3dnow */

    default:
      return -1;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pattern335 (x3) != 0
          || !(
#line 3748 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_14 (insn, operands);

    case ASHIFT:
      switch (pattern340 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern775 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_131 (insn, operands);

                case E_HImode:
                  if (pattern775 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_133 (insn, operands);

                case E_SImode:
                  if (pattern775 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_135 (insn, operands);

                case E_DImode:
                  if (pattern776 (x3, 
E_DImode) != 0
                      || !((
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_373 (insn, operands);

                case E_TImode:
                  if (pattern776 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_376 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (pattern693 (x3) != 0
                  || !((
#line 14062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_355 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!((
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_361 (insn, operands);

        case 2:
          if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_379 (insn, operands);

        case 3:
          if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_385 (insn, operands);

        case 4:
          if (!((
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_364 (insn, operands);

        case 5:
          if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_382 (insn, operands);

        case 6:
          if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_388 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern342 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_358 (insn, operands);

        case 1:
          if (!((
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_367 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_370 (insn, operands);

        case 3:
          if (!((
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_391 (insn, operands);

        case 4:
          if (!((
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_394 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern300 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      switch (pattern1060 (x3))
        {
        case 0:
          if ((
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12747 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_234 (insn, operands);
          break;

        case 1:
          if ((
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12747 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])
	|| rtx_equal_p (operands[0], operands[2])))))
            return gen_split_237 (insn, operands);
          break;

        case 2:
          if (nonimmediate_operand (operands[0], E_DImode)
              && nonimmediate_operand (operands[1], E_DImode)
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && ((
#line 13529 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 13531 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_322 (insn, operands);
          if (const_int_operand (operands[2], E_DImode))
            {
              if (QIreg_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_DImode)
                  && (
#line 13954 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_346 (insn, operands);
              if (any_QIreg_operand (operands[0], E_DImode)
                  && general_operand (operands[1], E_DImode)
                  && (
#line 13992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~255)
    && (INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_352 (insn, operands);
            }
          break;

        case 3:
          if (((
#line 13529 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13531 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_324 (insn, operands);
          break;

        case 4:
          if (QIreg_operand (operands[0], E_HImode)
              && register_operand (operands[1], E_HImode)
              && 
#line 13954 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
            return gen_split_342 (insn, operands);
          if (any_QIreg_operand (operands[0], E_HImode)
              && general_operand (operands[1], E_HImode)
              && 
#line 13992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~255)
    && (INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_348 (insn, operands);
          break;

        case 5:
          if (QIreg_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 13954 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
            return gen_split_344 (insn, operands);
          if (any_QIreg_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 13992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(INTVAL (operands[2]) & ~255)
    && (INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_350 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG
          || pattern1059 (x4) != 0)
        return NULL;
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (pattern1529 (x3))
        {
        case 0:
          if ((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_240 (insn, operands);
          break;

        case 1:
          if ((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_243 (insn, operands);
          break;

        case 2:
          if (((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_246 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x7;
      switch (pattern1530 (x3))
        {
        case 0:
          if (!(
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12805 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 1:
          if (!(
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 12805 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 2:
          if (!((
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 12805 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 13046 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        case 4:
          if (!
#line 13046 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_272 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != IOR
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (nonimmediate_operand (operands[3], E_SImode))
        {
          if (nonimmediate_operand (operands[2], E_SImode))
            {
              x11 = XEXP (x5, 1);
              if (rtx_equal_p (x11, operands[1])
                  && 
#line 13438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
                return gen_split_317 (insn, operands);
            }
          if (register_operand (operands[2], E_SImode))
            {
              x11 = XEXP (x5, 1);
              if (rtx_equal_p (x11, operands[2])
                  && 
#line 13457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
                return gen_split_318 (insn, operands);
            }
        }
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return NULL;
      if (nonimmediate_operand (operands[2], E_SImode)
          && rtx_equal_p (x10, operands[1])
          && 
#line 13476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
        return gen_split_319 (insn, operands);
      if (!register_operand (operands[2], E_SImode)
          || !rtx_equal_p (x10, operands[2])
          || !
#line 13495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
        return NULL;
      return gen_split_320 (insn, operands);

    case AND:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != XOR)
        return NULL;
      switch (pattern949 (x3))
        {
        case 0:
          if (!(
#line 13686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()) && 
#line 13688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_328 (insn, operands);

        case 1:
          if (!(
#line 13686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()) && 
#line 13688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_329 (insn, operands);

        case 2:
          if (!((
#line 13686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_330 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern955 (x3, 
1))
        {
        case 0:
          if (!(
#line 18844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18849 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_659 (insn, operands);

        case 1:
          if (!((
#line 18844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18849 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_661 (insn, operands);

        case 2:
          if (!(
#line 18872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_663 (insn, operands);

        case 3:
          if (!((
#line 18872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_665 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x10 = XEXP (x4, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1360 (x4, 
E_SImode) != 0
              || !
#line 21885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
            return NULL;
          return gen_split_743 (insn, operands);

        case E_DImode:
          if (pattern1360 (x4, 
E_DImode) != 0
              || !(
#line 21885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_744 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_26 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      switch (pattern630 (x7))
        {
        case 0:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !general_operand (operands[1], E_DImode))
            return NULL;
          if (((
#line 14602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_402 (insn, operands);
          if (!((
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_409 (insn, operands);

        case 1:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || !general_operand (operands[1], E_TImode)
              || !((
#line 14602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_403 (insn, operands);

        case 2:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x4) != E_QImode
              || !general_operand (operands[1], E_QImode)
              || !(
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_406 (insn, operands);

        case 3:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !general_operand (operands[1], E_HImode)
              || !(
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 4:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !general_operand (operands[1], E_SImode)
              || !(
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_408 (insn, operands);

        case 5:
          if (GET_MODE (x4) != E_SFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_SFmode)
              && fp_register_operand (operands[1], E_SFmode)
              && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_417 (insn, operands);
          if (!general_reg_operand (operands[0], E_SFmode)
              || !general_reg_operand (operands[1], E_SFmode)
              || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_423 (insn, operands);

        case 6:
          if (GET_MODE (x4) != E_DFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_DFmode)
              && fp_register_operand (operands[1], E_DFmode)
              && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_419 (insn, operands);
          if (!general_reg_operand (operands[0], E_DFmode)
              || !general_reg_operand (operands[1], E_DFmode)
              || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_425 (insn, operands);

        case 7:
          if (GET_MODE (x4) != E_XFmode)
            return NULL;
          if (fp_register_operand (operands[0], E_XFmode)
              && fp_register_operand (operands[1], E_XFmode)
              && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return gen_split_421 (insn, operands);
          if (!general_reg_operand (operands[0], E_XFmode)
              || !general_reg_operand (operands[1], E_XFmode)
              || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
            return NULL;
          return gen_split_427 (insn, operands);

        default:
          return NULL;
        }

    case USE:
      if (pattern760 (x1) != 0
          || !(
#line 14750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_414 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (promotable_binary_operator (operands[3], E_VOIDmode)
      && pattern302 (x1) == 0
      && general_reg_operand (operands[0], E_VOIDmode))
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_VOIDmode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (aligned_operand (operands[2], E_VOIDmode)
              && 
#line 27670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && ((GET_MODE (operands[0]) == HImode
	&& ((optimize_function_for_speed_p (cfun) && !TARGET_FAST_PREFIX)
            /* ??? next two lines just !satisfies_constraint_K (...) */
	    || !CONST_INT_P (operands[2])
	    || satisfies_constraint_K (operands[2])))
       || (GET_MODE (operands[0]) == QImode
	   && (TARGET_PROMOTE_QImode || optimize_function_for_size_p (cfun))))))
            return gen_split_814 (insn, operands);
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return NULL;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (GET_MODE (x3) != E_V2QImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && general_reg_operand (operands[2], E_V2QImode)
          && 
#line 3260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
        return gen_split_850 (insn, operands);
      if (!sse_reg_operand (operands[1], E_V2QImode)
          || !sse_reg_operand (operands[0], E_V2QImode)
          || !sse_reg_operand (operands[2], E_V2QImode)
          || !
#line 3294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_852 (insn, operands);

    case MINUS:
      if (GET_MODE (x3) != E_V2QImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && general_reg_operand (operands[2], E_V2QImode)
          && 
#line 3260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
        return gen_split_851 (insn, operands);
      if (!sse_reg_operand (operands[1], E_V2QImode)
          || !sse_reg_operand (operands[0], E_V2QImode)
          || !sse_reg_operand (operands[2], E_V2QImode)
          || !
#line 3294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return NULL;
      return gen_split_853 (insn, operands);

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2QImode:
          if (pattern1221 (x3) != 0
              || !
#line 4009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
            return NULL;
          return gen_split_856 (insn, operands);

        case E_QImode:
          if (pattern1222 (x3, 
E_QImode) != 0
              || !
#line 2296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1012 (insn, operands);

        case E_HImode:
          if (pattern1222 (x3, 
E_HImode) != 0
              || !
#line 2296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_1014 (insn, operands);

        case E_SImode:
          if (pattern1222 (x3, 
E_SImode) != 0
              || !(
#line 2296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1016 (insn, operands);

        case E_DImode:
          if (pattern1222 (x3, 
E_DImode) != 0
              || !(
#line 2296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_1018 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NOT:
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V4QImode:
              if (GET_MODE (x3) != E_V4QImode
                  || GET_MODE (x4) != E_V4QImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V4QImode)
                  && general_reg_operand (operands[1], E_V4QImode)
                  && general_reg_operand (operands[2], E_V4QImode))
                {
                  if (
#line 4622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_869 (insn, operands);
                  if (
#line 4639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_872 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V4QImode)
                  || !sse_reg_operand (operands[1], E_V4QImode)
                  || !sse_reg_operand (operands[2], E_V4QImode)
                  || !
#line 4658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_875 (insn, operands);

            case E_V2QImode:
              if (GET_MODE (x3) != E_V2QImode
                  || GET_MODE (x4) != E_V2QImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V2QImode)
                  && general_reg_operand (operands[1], E_V2QImode)
                  && general_reg_operand (operands[2], E_V2QImode))
                {
                  if (
#line 4622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_870 (insn, operands);
                  if (
#line 4639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_873 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V2QImode)
                  || !sse_reg_operand (operands[1], E_V2QImode)
                  || !sse_reg_operand (operands[2], E_V2QImode)
                  || !
#line 4658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_876 (insn, operands);

            case E_V2HImode:
              if (GET_MODE (x3) != E_V2HImode
                  || GET_MODE (x4) != E_V2HImode)
                return NULL;
              if (general_reg_operand (operands[0], E_V2HImode)
                  && general_reg_operand (operands[1], E_V2HImode)
                  && general_reg_operand (operands[2], E_V2HImode))
                {
                  if (
#line 4622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_BMI && reload_completed))
                    return gen_split_871 (insn, operands);
                  if (
#line 4639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_BMI && reload_completed))
                    return gen_split_874 (insn, operands);
                }
              if (!sse_reg_operand (operands[0], E_V2HImode)
                  || !sse_reg_operand (operands[1], E_V2HImode)
                  || !sse_reg_operand (operands[2], E_V2HImode)
                  || !
#line 4658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_877 (insn, operands);

            case E_QImode:
              if (pattern1362 (x3, 
E_QImode) != 0
                  || !
#line 2166 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_995 (insn, operands);

            case E_HImode:
              if (pattern1362 (x3, 
E_HImode) != 0
                  || !
#line 2166 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_996 (insn, operands);

            case E_SImode:
              if (pattern1362 (x3, 
E_SImode) != 0
                  || !(
#line 2166 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_997 (insn, operands);

            case E_DImode:
              if (pattern1362 (x3, 
E_DImode) != 0
                  || !(
#line 2166 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_998 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern1132 (x3))
            {
            case 0:
              if (nonimmediate_gr_operand (operands[0], E_V4QImode)
                  && nonimmediate_gr_operand (operands[1], E_V4QImode)
                  && reg_or_const_vector_operand (operands[2], E_V4QImode)
                  && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_878 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V4QImode)
                  || !sse_reg_operand (operands[1], E_V4QImode)
                  || !sse_reg_operand (operands[2], E_V4QImode)
                  || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_887 (insn, operands);

            case 1:
              if (nonimmediate_gr_operand (operands[0], E_V2QImode)
                  && nonimmediate_gr_operand (operands[1], E_V2QImode)
                  && reg_or_const_vector_operand (operands[2], E_V2QImode)
                  && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_881 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V2QImode)
                  || !sse_reg_operand (operands[1], E_V2QImode)
                  || !sse_reg_operand (operands[2], E_V2QImode)
                  || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_890 (insn, operands);

            case 2:
              if (nonimmediate_gr_operand (operands[0], E_V2HImode)
                  && nonimmediate_gr_operand (operands[1], E_V2HImode)
                  && reg_or_const_vector_operand (operands[2], E_V2HImode)
                  && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
                return gen_split_884 (insn, operands);
              if (!sse_reg_operand (operands[0], E_V2HImode)
                  || !sse_reg_operand (operands[1], E_V2HImode)
                  || !sse_reg_operand (operands[2], E_V2HImode)
                  || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
                return NULL;
              return gen_split_893 (insn, operands);

            case 3:
              if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_983 (insn, operands);

            case 4:
              if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
                return NULL;
              return gen_split_986 (insn, operands);

            case 5:
              if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_989 (insn, operands);

            case 6:
              if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return NULL;
              return gen_split_992 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      switch (pattern1132 (x3))
        {
        case 0:
          if (nonimmediate_gr_operand (operands[0], E_V4QImode)
              && nonimmediate_gr_operand (operands[1], E_V4QImode)
              && reg_or_const_vector_operand (operands[2], E_V4QImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_879 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V4QImode)
              || !sse_reg_operand (operands[1], E_V4QImode)
              || !sse_reg_operand (operands[2], E_V4QImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_888 (insn, operands);

        case 1:
          if (nonimmediate_gr_operand (operands[0], E_V2QImode)
              && nonimmediate_gr_operand (operands[1], E_V2QImode)
              && reg_or_const_vector_operand (operands[2], E_V2QImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_882 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2QImode)
              || !sse_reg_operand (operands[1], E_V2QImode)
              || !sse_reg_operand (operands[2], E_V2QImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_891 (insn, operands);

        case 2:
          if (nonimmediate_gr_operand (operands[0], E_V2HImode)
              && nonimmediate_gr_operand (operands[1], E_V2HImode)
              && reg_or_const_vector_operand (operands[2], E_V2HImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_885 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2HImode)
              || !sse_reg_operand (operands[1], E_V2HImode)
              || !sse_reg_operand (operands[2], E_V2HImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_894 (insn, operands);

        case 3:
          if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_984 (insn, operands);

        case 4:
          if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_987 (insn, operands);

        case 5:
          if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_990 (insn, operands);

        case 6:
          if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_993 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern1132 (x3))
        {
        case 0:
          if (nonimmediate_gr_operand (operands[0], E_V4QImode)
              && nonimmediate_gr_operand (operands[1], E_V4QImode)
              && reg_or_const_vector_operand (operands[2], E_V4QImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_880 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V4QImode)
              || !sse_reg_operand (operands[1], E_V4QImode)
              || !sse_reg_operand (operands[2], E_V4QImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_889 (insn, operands);

        case 1:
          if (nonimmediate_gr_operand (operands[0], E_V2QImode)
              && nonimmediate_gr_operand (operands[1], E_V2QImode)
              && reg_or_const_vector_operand (operands[2], E_V2QImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_883 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2QImode)
              || !sse_reg_operand (operands[1], E_V2QImode)
              || !sse_reg_operand (operands[2], E_V2QImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_892 (insn, operands);

        case 2:
          if (nonimmediate_gr_operand (operands[0], E_V2HImode)
              && nonimmediate_gr_operand (operands[1], E_V2HImode)
              && reg_or_const_vector_operand (operands[2], E_V2HImode)
              && 
#line 4725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
            return gen_split_886 (insn, operands);
          if (!sse_reg_operand (operands[0], E_V2HImode)
              || !sse_reg_operand (operands[1], E_V2HImode)
              || !sse_reg_operand (operands[2], E_V2HImode)
              || !
#line 4749 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_895 (insn, operands);

        case 3:
          if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_985 (insn, operands);

        case 4:
          if (!
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
            return NULL;
          return gen_split_988 (insn, operands);

        case 5:
          if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_991 (insn, operands);

        case 6:
          if (!(
#line 2130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return NULL;
          return gen_split_994 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x4, operands[1]))
        return NULL;
      x5 = XEXP (x2, 1);
      if (XVECLEN (x5, 0) != 2)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT
          || GET_MODE (x2) != E_V2DFmode
          || GET_MODE (x3) != E_V4DFmode)
        return NULL;
      if (XWINT (x6, 0) == 0L)
        {
          x7 = XVECEXP (x5, 0, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 2]
              && memory_operand (operands[0], E_V2DFmode)
              && register_operand (operands[1], E_V2DFmode)
              && 
#line 13565 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3 && reload_completed))
            return gen_split_1364 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return NULL;
      operands[2] = x6;
      if (!const_0_to_1_operand (operands[2], E_SImode))
        return NULL;
      x7 = XVECEXP (x5, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 13583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3 && INTVAL (operands[2]) + 2 == INTVAL (operands[3])))
        return NULL;
      return gen_split_1365 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern739 (x2))
        {
        case 0:
          if (!(
#line 24123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3251 (insn, operands);

        case 1:
          if (!(
#line 24176 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 24178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3255 (insn, operands);

        case 2:
          if (!(
#line 24272 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24274 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3263 (insn, operands);

        case 3:
          if (!(
#line 24520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512) && 
#line 24522 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3275 (insn, operands);

        case 4:
          if (!(
#line 24574 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 24576 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3279 (insn, operands);

        case 5:
          if (!(
#line 24679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 24681 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return NULL;
          return gen_split_3287 (insn, operands);

        case 6:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512) && 
#line 25078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3310 (insn, operands);
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3503 (insn, operands);

        case 7:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 25130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3312 (insn, operands);
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3504 (insn, operands);

        case 8:
          if (vector_operand (operands[1], E_V4SImode)
              && pmovzx_parallel (operands[3], E_VOIDmode)
              && (
#line 25213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 25215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
            return gen_split_3318 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3505 (insn, operands);

        case 9:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3506 (insn, operands);

        case 10:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3507 (insn, operands);

        case 11:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3508 (insn, operands);

        case 12:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3509 (insn, operands);

        case 13:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3510 (insn, operands);

        case 14:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3511 (insn, operands);

        case 15:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3512 (insn, operands);

        case 16:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3513 (insn, operands);

        case 17:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3514 (insn, operands);

        case 18:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3515 (insn, operands);

        case 19:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3516 (insn, operands);

        case 20:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3517 (insn, operands);

        case 21:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3518 (insn, operands);

        case 22:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3519 (insn, operands);

        case 23:
          if (!((
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 29052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3520 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern467 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1447 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1474 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1501 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1528 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1555 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1582 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1609 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1636 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1663 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1690 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1717 (insn, operands);

        case 11:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1744 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1450 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1477 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1504 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1531 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1558 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1585 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1612 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1639 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1666 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1693 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1720 (insn, operands);

        case 23:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1747 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1453 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1480 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1507 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1534 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1561 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1588 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1615 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1642 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1669 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1696 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1723 (insn, operands);

        case 35:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1750 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2737 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2746 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2755 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2764 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2773 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2782 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2791 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2809 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2818 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2827 (insn, operands);

        case 47:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2836 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2095 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2122 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2149 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2176 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2203 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2230 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2257 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2284 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2311 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2338 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2365 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2392 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2098 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2125 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2152 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2179 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2206 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2233 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2260 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2287 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2314 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2341 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2368 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2395 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2101 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2128 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2155 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2182 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2209 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2236 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2263 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2290 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2317 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2344 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2371 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2398 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_67 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern471 (x2))
            {
            case 0:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1763 (insn, operands);

            case 1:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1790 (insn, operands);

            case 2:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1817 (insn, operands);

            case 3:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1844 (insn, operands);

            case 4:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1871 (insn, operands);

            case 5:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1898 (insn, operands);

            case 6:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1925 (insn, operands);

            case 7:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1952 (insn, operands);

            case 8:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1979 (insn, operands);

            case 9:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2006 (insn, operands);

            case 10:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2033 (insn, operands);

            case 11:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 12:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1766 (insn, operands);

            case 13:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1793 (insn, operands);

            case 14:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1820 (insn, operands);

            case 15:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1847 (insn, operands);

            case 16:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1874 (insn, operands);

            case 17:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1901 (insn, operands);

            case 18:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1928 (insn, operands);

            case 19:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1955 (insn, operands);

            case 20:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1982 (insn, operands);

            case 21:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2009 (insn, operands);

            case 22:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2036 (insn, operands);

            case 23:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 24:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1769 (insn, operands);

            case 25:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1796 (insn, operands);

            case 26:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1823 (insn, operands);

            case 27:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1850 (insn, operands);

            case 28:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1877 (insn, operands);

            case 29:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1904 (insn, operands);

            case 30:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1931 (insn, operands);

            case 31:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1958 (insn, operands);

            case 32:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1985 (insn, operands);

            case 33:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2012 (insn, operands);

            case 34:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2039 (insn, operands);

            case 35:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 36:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2843 (insn, operands);

            case 37:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2852 (insn, operands);

            case 38:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2861 (insn, operands);

            case 39:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2870 (insn, operands);

            case 40:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2879 (insn, operands);

            case 41:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2888 (insn, operands);

            case 42:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2897 (insn, operands);

            case 43:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2906 (insn, operands);

            case 44:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2915 (insn, operands);

            case 45:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2924 (insn, operands);

            case 46:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2933 (insn, operands);

            case 47:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2942 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2411 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2438 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2465 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2492 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2519 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2546 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2573 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2600 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2627 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2654 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2681 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2708 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2414 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2441 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2468 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2495 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2522 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2549 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2576 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2603 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2630 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2657 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2684 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2711 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2417 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2444 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2471 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2498 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2525 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2552 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2579 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2606 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2633 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2660 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2687 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2714 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern471 (x2))
            {
            case 0:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1772 (insn, operands);

            case 1:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1799 (insn, operands);

            case 2:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1826 (insn, operands);

            case 3:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1853 (insn, operands);

            case 4:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1880 (insn, operands);

            case 5:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1907 (insn, operands);

            case 6:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1934 (insn, operands);

            case 7:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1961 (insn, operands);

            case 8:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1988 (insn, operands);

            case 9:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2015 (insn, operands);

            case 10:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2042 (insn, operands);

            case 11:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2069 (insn, operands);

            case 12:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1775 (insn, operands);

            case 13:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1802 (insn, operands);

            case 14:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1829 (insn, operands);

            case 15:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1856 (insn, operands);

            case 16:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1883 (insn, operands);

            case 17:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1910 (insn, operands);

            case 18:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1937 (insn, operands);

            case 19:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1964 (insn, operands);

            case 20:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1991 (insn, operands);

            case 21:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2018 (insn, operands);

            case 22:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2045 (insn, operands);

            case 23:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2072 (insn, operands);

            case 24:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1778 (insn, operands);

            case 25:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1805 (insn, operands);

            case 26:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1832 (insn, operands);

            case 27:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1859 (insn, operands);

            case 28:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1886 (insn, operands);

            case 29:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1913 (insn, operands);

            case 30:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1940 (insn, operands);

            case 31:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1967 (insn, operands);

            case 32:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1994 (insn, operands);

            case 33:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2021 (insn, operands);

            case 34:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 35:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2075 (insn, operands);

            case 36:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2846 (insn, operands);

            case 37:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2855 (insn, operands);

            case 38:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2864 (insn, operands);

            case 39:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2873 (insn, operands);

            case 40:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2882 (insn, operands);

            case 41:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2891 (insn, operands);

            case 42:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2900 (insn, operands);

            case 43:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2909 (insn, operands);

            case 44:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2918 (insn, operands);

            case 45:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2927 (insn, operands);

            case 46:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2936 (insn, operands);

            case 47:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2945 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2420 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2447 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2474 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2501 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2528 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2555 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2582 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2609 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2636 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2663 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2690 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2717 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2423 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2450 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2477 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2504 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2531 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2558 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2585 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2612 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2639 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2666 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2693 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2720 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2426 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2453 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2480 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2507 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2534 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2561 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2588 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2615 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2642 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2669 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2696 (insn, operands);

            case 11:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2723 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      return split_63 (x1, insn);

    default:
      return NULL;
    }
}
