/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern10 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_TImode) != 0)
        return -1;
      return 0;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern7 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V4QImode:
      if (pattern8 (x3, 
E_V4QImode) != 0)
        return -1;
      return 4;

    case E_V2QImode:
      if (pattern8 (x3, 
E_V2QImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern8 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vector_operand (operands[1], E_V8HFmode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !vector_operand (operands[1], E_V16HFmode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x3) != E_V32HImode
              || !vector_operand (operands[1], E_V32HFmode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode)
            return -1;
          return 3;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!vector_operand (operands[1], E_V16HFmode))
                return -1;
              return 4;

            case E_V16SFmode:
              if (!vector_operand (operands[1], E_V16SFmode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x3) != E_V8DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode))
                return -1;
              return 6;

            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode))
                return -1;
              return 7;

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          return 9;

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode))
                return -1;
              return 10;

            case E_V4DFmode:
              if (!vector_operand (operands[1], E_V4DFmode))
                return -1;
              return 11;

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode))
                return -1;
              return 12;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode))
                return -1;
              return 13;

            case E_V2DFmode:
              if (!vector_operand (operands[1], E_V2DFmode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || GET_MODE (x4) != E_V4HFmode
              || !register_operand (operands[1], E_V8HFmode))
            return -1;
          res = pattern29 (x3);
          if (res >= 0)
            return res + 15; /* [15, 16] */
          return -1;

        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_V2HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              return 17;

            case E_V2SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode))
                return -1;
              return 18;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!nonimmediate_operand (operands[0], E_QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!general_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], E_V2DImode))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!nonimmediate_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      return pattern109 (x4); /* [-1, 2] */

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x4;
      if (!const_scalar_int_operand (operands[2], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (XWINT (x2, 0) != 1L)
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern123 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern123 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern123 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      return pattern121 (x1, 
E_HImode, 
E_V16HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern121 (x1, 
E_QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8SImode:
      if (pattern121 (x1, 
E_QImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern121 (x1, 
E_QImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern121 (x1, 
E_QImode, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern121 (x1, 
E_QImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V32HImode:
      if (pattern121 (x1, 
E_SImode, 
E_V32HImode) != 0)
        return -1;
      return 6;

    case E_V16SImode:
      if (pattern121 (x1, 
E_HImode, 
E_V16SImode) != 0)
        return -1;
      return 7;

    case E_V8DImode:
      if (pattern121 (x1, 
E_QImode, 
E_V8DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern144 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern144 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern144 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern144 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern144 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern144 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern144 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern144 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern144 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern156 (x3, 
E_V32HFmode, 
E_V64QImode, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern156 (x3, 
E_V16HFmode, 
E_V32QImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern64 (x3, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern64 (x3, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern64 (x3, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern64 (x3, 
E_V16HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern64 (x3, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern64 (x3, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern185 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern184 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V8DImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern184 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x5) != E_V2DImode
          || GET_MODE (x6) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  return pattern213 (x1); /* [-1, 0] */
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i1))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      return 0;

    case STRICT_LOW_PART:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      x4 = XEXP (x1, 1);
      res = pattern41 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      return pattern2 (x3); /* [-1, 1] */

    case STRICT_LOW_PART:
      res = pattern241 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0))
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != MINUS
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != AND
      || GET_MODE (x10) != E_QImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XEXP (x3, 0);
  if (!nonmemory_operand (x12, E_QImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 63L:
      if (XWINT (x9, 0) != 64L
          || XWINT (x11, 0) != 63L
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode)
        return -1;
      x13 = XEXP (x2, 0);
      operands[1] = x13;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      operands[3] = x12;
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_TImode
          || GET_MODE (x7) != E_TImode)
        return -1;
      x14 = XEXP (x7, 0);
      operands[2] = x14;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      return 0;

    case 31L:
      if (XWINT (x9, 0) != 32L
          || XWINT (x11, 0) != 31L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !memory_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !memory_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !memory_operand (operands[1], E_V8DImode))
        return -1;
      return 3;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !memory_operand (operands[1], E_V4DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !memory_operand (operands[1], E_V16SFmode))
        return -1;
      return 6;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !memory_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !memory_operand (operands[1], E_V8DFmode))
        return -1;
      return 9;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !memory_operand (operands[1], E_V4DFmode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 11;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !memory_operand (operands[1], E_V64QImode))
        return -1;
      return 12;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 13;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !memory_operand (operands[1], E_V32QImode))
        return -1;
      return 14;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !memory_operand (operands[1], E_V32HImode))
        return -1;
      return 15;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !memory_operand (operands[1], E_V16HImode))
        return -1;
      return 16;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 17;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !memory_operand (operands[1], E_V32HFmode))
        return -1;
      return 18;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !memory_operand (operands[1], E_V16HFmode))
        return -1;
      return 19;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !memory_operand (operands[1], E_V8HFmode))
        return -1;
      return 20;

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x1) != E_V32BFmode
          || !memory_operand (operands[1], E_V32BFmode))
        return -1;
      return 21;

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x1) != E_V16BFmode
          || !memory_operand (operands[1], E_V16BFmode))
        return -1;
      return 22;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x1) != E_V8BFmode
          || !memory_operand (operands[1], E_V8BFmode))
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern333 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 20
      || GET_MODE (x2) != E_V2DImode)
    return -1;
  return 0;
}

int
pattern338 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const_scalar_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern353 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[3], i1))
    return -1;
  operands[0] = x1;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!memory_operand (operands[1], i1))
    return -1;
  x5 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!memory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern386 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern400 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 223)
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HFmode)
              || !vector_operand (operands[2], E_V32HFmode)
              || !nonimm_or_0_operand (operands[3], E_V32HFmode)
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[4], E_HImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (pattern399 (x1, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern399 (x1, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x5, 0) != 3L
          || !register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !vector_operand (operands[2], E_V8HFmode))
        return -1;
      x6 = XEXP (x1, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  x7 = XEXP (x1, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern419 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern419 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern419 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[5] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern424 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SImode:
          if (pattern424 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern424 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern437 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V2HFmode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_MODE (x7) != E_V2HFmode
          || !vector_operand (operands[1], i1)
          || GET_MODE (x3) != E_V2HFmode
          || !nonimm_or_0_operand (operands[2], E_V8HFmode)
          || !const0_operand (operands[4], E_V6HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (pattern436 (x1, 
E_V2SFmode, 
E_V4SFmode, 
i1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern445 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern450 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 151)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  switch (XVECLEN (x6, 0))
    {
    case 16:
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x12 = XVECEXP (x6, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x6, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x6, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x15 = XVECEXP (x6, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x16 = XVECEXP (x6, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x17 = XVECEXP (x6, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x18 = XVECEXP (x6, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x19 = XVECEXP (x6, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x20 = XVECEXP (x6, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x21 = XVECEXP (x6, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x22 = XVECEXP (x6, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern460 (x1, 
E_V32HImode, 
E_V32HFmode, 
E_V16HFmode) != 0)
        return -1;
      return 0;

    case 8:
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x12 = XVECEXP (x6, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x6, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x14 = XVECEXP (x6, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern460 (x1, 
E_V16HImode, 
E_V16HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern484 (x1, 
E_SImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_DImode:
      res = pattern484 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern494 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern493 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (!commutative_operator (x2, E_VOIDmode))
    return -1;
  operands[3] = x2;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XEXP (x1, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern570 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern567 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8SImode
          || !nonimm_or_0_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 1;

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode
          || !nonimm_or_0_operand (operands[2], E_V4SImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 3;

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 4;

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8DImode
          || !nonimm_or_0_operand (operands[2], E_V8DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 6;

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4DImode
          || !nonimm_or_0_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || !nonimm_or_0_operand (operands[2], E_V2DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 10;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern604 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern610 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_BFmode:
      if (!memory_operand (operands[1], E_BFmode))
        return -1;
      return 0;

    case E_HFmode:
      if (!memory_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern616 (rtx x1, machine_mode i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern622 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return pattern357 (x1); /* [-1, 3] */
}

int
pattern627 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case ZERO_EXTRACT:
      return 1;

    default:
      return -1;
    }
}

int
pattern632 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern639 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return pattern638 (x2); /* [-1, 5] */
}

int
pattern643 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern655 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return 0;
}

int
pattern660 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != i2
      || XINT (x7, 1) != i1
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x6, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  return 0;
}

int
pattern670 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x2, 0);
  operands[4] = x4;
  if (!register_operand (operands[4], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  return pattern668 (x6, 
i1); /* [-1, 0] */
}

int
pattern683 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern691 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern700 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 59)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          return pattern699 (x2, 
E_V32QImode, 
E_SImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern699 (x2, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (x1))
        {
        case E_V16QImode:
          if (!vector_all_ones_operand (operands[2], E_V16QImode)
              || !const0_operand (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        case E_V32QImode:
          if (!vector_all_ones_operand (operands[2], E_V32QImode)
              || !const0_operand (operands[3], E_V32QImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern729 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  return 0;
}

int
pattern735 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !pmovzx_parallel (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern746 (rtx x1, machine_mode i1, int i2, int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || XVECLEN (x1, 0) != i3
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern749 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern762 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern768 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x2, operands[0]))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      return 0;

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern775 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern778 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern782 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !binary_fp_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern795 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern794 (x1, 
E_DImode, 
E_V64QImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      res = pattern792 ();
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern806 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!vector_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!vector_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!vector_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern815 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || GET_MODE (x3) != i2)
    return -1;
  x9 = XEXP (x3, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern129 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V4DImode:
      if (pattern129 (x1, 
E_V4DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern829 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern833 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern835 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern838 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern844 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern851 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern858 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != SUBREG
          || maybe_ne (SUBREG_BYTE (x10), 0))
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != i1
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != ZERO_EXTRACT)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x14, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x2, 0);
          operands[4] = x17;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          x18 = XEXP (x6, 0);
          operands[1] = x18;
          if (!int248_register_operand (operands[1], E_VOIDmode))
            return -1;
          return pattern534 (x9); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern883 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_HFmode)
      || GET_MODE (x1) != E_HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32HFmode:
      if (!nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern886 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HFmode:
      return pattern11 (x1, 
E_V2HFmode, 
E_V4HFmode); /* [-1, 0] */

    case E_V2BFmode:
      if (pattern11 (x1, 
E_V2BFmode, 
E_V4BFmode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern11 (x1, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern893 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern896 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8DImode
      || !nonimm_or_0_operand (operands[2], E_V8DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern905 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern904 (x1, 
E_V8HFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern904 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V2DFmode:
          if (pattern904 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x3;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      x9 = XEXP (x1, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern930 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern936 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern944 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_CODE (x6))
    {
    case STRICT_LOW_PART:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!extract_operator (operands[3], E_DImode)
              || !extract_operator (operands[4], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode)
              || !extract_operator (operands[4], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode)
              || !extract_operator (operands[4], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern966 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern972 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  return pattern681 (); /* [-1, 5] */
}

int
pattern981 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 1;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 2;

        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 4;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 6;

        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 7;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 9;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 10;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1018 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (XWINT (x3, 0) != 1L)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const48_operand (operands[5], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1017 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1017 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1017 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1034 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern1033 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1033 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1033 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1033 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1046 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1054 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern1053 (x2); /* [-1, 11] */
}

int
pattern1060 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      return pattern498 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          return 2;

        case E_TImode:
          if (pattern508 (x2, 
E_TImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[2], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1076 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case COMPARE:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      x10 = XEXP (x2, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x5, 0);
      switch (GET_CODE (x11))
        {
        case REG:
          return pattern1071 (x1, 
i1); /* [-1, 0] */

        case ZERO_EXTEND:
          if (GET_MODE (x11) != i2)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != i2)
            return -1;
          x13 = XEXP (x12, 0);
          if (!ix86_carry_flag_operator (x13, i2))
            return -1;
          operands[4] = x13;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x15 = XEXP (x12, 1);
          if (GET_CODE (x15) != ZERO_EXTEND
              || GET_MODE (x15) != i2
              || GET_MODE (x6) != E_CCCmode
              || GET_MODE (x5) != E_CCCmode)
            return -1;
          x16 = XEXP (x11, 0);
          switch (GET_CODE (x16))
            {
            case PLUS:
              if (GET_MODE (x16) != i1)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != PLUS
                  || GET_MODE (x17) != i1)
                return -1;
              x18 = XEXP (x17, 0);
              if (!ix86_carry_flag_operator (x18, i1))
                return -1;
              operands[5] = x18;
              x19 = XEXP (x18, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x8) != PLUS)
                return -1;
              x20 = XEXP (x8, 0);
              if (GET_CODE (x20) != PLUS
                  || GET_MODE (x20) != i1)
                return -1;
              x21 = XEXP (x20, 0);
              switch (GET_CODE (x21))
                {
                case LTU:
                case UNLT:
                  if (!rtx_equal_p (x21, operands[5]))
                    return -1;
                  x22 = XEXP (x18, 0);
                  operands[3] = x22;
                  if (!flags_reg_operand (operands[3], E_VOIDmode))
                    return -1;
                  x23 = XEXP (x16, 1);
                  operands[2] = x23;
                  if (!memory_operand (operands[2], i1))
                    return -1;
                  x24 = XEXP (x17, 1);
                  if (!rtx_equal_p (x24, operands[0]))
                    return -1;
                  x25 = XEXP (x13, 0);
                  if (!rtx_equal_p (x25, operands[3]))
                    return -1;
                  x26 = XEXP (x15, 0);
                  if (!rtx_equal_p (x26, operands[2]))
                    return -1;
                  x27 = XEXP (x20, 1);
                  if (!rtx_equal_p (x27, operands[0]))
                    return -1;
                  x28 = XEXP (x8, 1);
                  if (!rtx_equal_p (x28, operands[2]))
                    return -1;
                  return 1;

                default:
                  return -1;
                }

            case REG:
              if (!rtx_equal_p (x16, operands[0])
                  || GET_CODE (x8) != MINUS)
                return -1;
              x20 = XEXP (x8, 0);
              if (GET_CODE (x20) != MINUS
                  || GET_MODE (x20) != i1)
                return -1;
              x27 = XEXP (x20, 1);
              if (!ix86_carry_flag_operator (x27, i1))
                return -1;
              operands[5] = x27;
              x29 = XEXP (x27, 1);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x25 = XEXP (x13, 0);
              operands[3] = x25;
              if (!flags_reg_operand (operands[3], E_VOIDmode))
                return -1;
              x26 = XEXP (x15, 0);
              operands[2] = x26;
              if (!memory_operand (operands[2], i1))
                return -1;
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[0]))
                return -1;
              x30 = XEXP (x27, 0);
              if (!rtx_equal_p (x30, operands[3]))
                return -1;
              x28 = XEXP (x8, 1);
              if (!rtx_equal_p (x28, operands[2]))
                return -1;
              return 2;

            default:
              return -1;
            }

        case PLUS:
          if (pattern1072 (x1, 
i1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case PLUS:
      res = pattern1074 (x1, 
i1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case MINUS:
      res = pattern1075 (x1, 
i1);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1140 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 109)
    return -1;
  return 0;
}

int
pattern1146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1159 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1165 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i3))
    return -1;
  return 0;
}

int
pattern1176 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1191 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern1199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x13 = XEXP (x1, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 1);
  return pattern1198 (x15, 
8); /* [-1, 0] */
}

int
pattern1212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 2);
  switch (GET_CODE (x9))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 0;

    case AND:
      if (GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 0);
      operands[4] = x12;
      switch (GET_MODE (x7))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1247 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1255 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1265 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !bcst_vector_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1253 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern1274 (x1, 
E_V8HFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern1274 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V2DFmode:
          if (pattern1274 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x4;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      x5 = XEXP (x3, 2);
      operands[5] = x5;
      x6 = XVECEXP (x1, 0, 1);
      operands[6] = x6;
      x11 = XEXP (x2, 1);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1298 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1298 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1311 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1318 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i2))
    return -1;
  return 0;
}

int
pattern1329 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1340 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1347 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1368 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[5], i3))
    return -1;
  return 0;
}

int
pattern1377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_carry_flag_operator (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern1392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1397 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1404 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1414 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !sext_operand (operands[2], i1)
      || pattern651 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x1, operands[1]))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SFmode
      || !vector_operand (operands[1], E_V4SFmode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!nonimm_or_0_operand (operands[2], E_V4SFmode))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern1440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || pattern1439 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2)
      || pattern1439 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1454 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1453 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1453 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1465 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1464 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1464 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1477 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1494 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1509 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x2, 0);
      return pattern1508 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x2, 0);
      if (pattern1508 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1520 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1530 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern944 (x1); /* [-1, 4] */

    default:
      return -1;
    }
}

int
pattern1539 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode)
          || !register_operand (operands[2], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1551 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1550 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1550 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1561 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1569 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (XWINT (x4, 0) != 6L)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (XWINT (x5, 0) != 14L)
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (XWINT (x6, 0) != 7L)
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (XWINT (x7, 0) != 15L)
    return -1;
  x8 = XEXP (x2, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  operands[3] = x10;
  x11 = XEXP (x1, 2);
  operands[4] = x11;
  return 0;
}

int
pattern1585 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[4], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1591 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1)
      || !scratch_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1597 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1607 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1616 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern1633 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1639 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1648 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!nonimm_or_0_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern1657 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76, x77, x78, x79;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_SFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_SFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XEXP (x3, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != VEC_SELECT
      || GET_MODE (x12) != E_SFmode)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PARALLEL
      || XVECLEN (x13, 0) != 1)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x15 = XEXP (x11, 1);
  if (GET_CODE (x15) != VEC_SELECT
      || GET_MODE (x15) != E_SFmode)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PARALLEL
      || XVECLEN (x16, 0) != 1)
    return -1;
  x17 = XVECEXP (x16, 0, 0);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x18 = XEXP (x2, 1);
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != VEC_SELECT
      || GET_MODE (x20) != E_SFmode)
    return -1;
  x21 = XEXP (x20, 1);
  if (GET_CODE (x21) != PARALLEL
      || XVECLEN (x21, 0) != 1)
    return -1;
  x22 = XVECEXP (x21, 0, 0);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x23 = XEXP (x19, 1);
  if (GET_CODE (x23) != VEC_SELECT
      || GET_MODE (x23) != E_SFmode)
    return -1;
  x24 = XEXP (x23, 1);
  if (GET_CODE (x24) != PARALLEL
      || XVECLEN (x24, 0) != 1)
    return -1;
  x25 = XVECEXP (x24, 0, 0);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XEXP (x18, 1);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != VEC_SELECT
      || GET_MODE (x27) != E_SFmode)
    return -1;
  x28 = XEXP (x27, 1);
  if (GET_CODE (x28) != PARALLEL
      || XVECLEN (x28, 0) != 1)
    return -1;
  x29 = XVECEXP (x28, 0, 0);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x30 = XEXP (x26, 1);
  if (GET_CODE (x30) != VEC_SELECT
      || GET_MODE (x30) != E_SFmode)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != PARALLEL
      || XVECLEN (x31, 0) != 1)
    return -1;
  x32 = XVECEXP (x31, 0, 0);
  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x33 = XEXP (x1, 1);
  x34 = XEXP (x33, 0);
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != i1)
    return -1;
  x36 = XEXP (x35, 0);
  if (GET_CODE (x36) != VEC_SELECT
      || GET_MODE (x36) != E_SFmode)
    return -1;
  x37 = XEXP (x36, 1);
  if (GET_CODE (x37) != PARALLEL
      || XVECLEN (x37, 0) != 1)
    return -1;
  x38 = XVECEXP (x37, 0, 0);
  if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x39 = XEXP (x35, 1);
  if (GET_CODE (x39) != VEC_SELECT
      || GET_MODE (x39) != E_SFmode)
    return -1;
  x40 = XEXP (x39, 1);
  if (GET_CODE (x40) != PARALLEL
      || XVECLEN (x40, 0) != 1)
    return -1;
  x41 = XVECEXP (x40, 0, 0);
  if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x42 = XEXP (x34, 1);
  if (GET_CODE (x42) != i1)
    return -1;
  x43 = XEXP (x42, 0);
  if (GET_CODE (x43) != VEC_SELECT
      || GET_MODE (x43) != E_SFmode)
    return -1;
  x44 = XEXP (x43, 1);
  if (GET_CODE (x44) != PARALLEL
      || XVECLEN (x44, 0) != 1)
    return -1;
  x45 = XVECEXP (x44, 0, 0);
  if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_CODE (x46) != VEC_SELECT
      || GET_MODE (x46) != E_SFmode)
    return -1;
  x47 = XEXP (x46, 1);
  if (GET_CODE (x47) != PARALLEL
      || XVECLEN (x47, 0) != 1)
    return -1;
  x48 = XVECEXP (x47, 0, 0);
  if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x49 = XEXP (x33, 1);
  x50 = XEXP (x49, 0);
  if (GET_CODE (x50) != i1)
    return -1;
  x51 = XEXP (x50, 0);
  if (GET_CODE (x51) != VEC_SELECT
      || GET_MODE (x51) != E_SFmode)
    return -1;
  x52 = XEXP (x51, 1);
  if (GET_CODE (x52) != PARALLEL
      || XVECLEN (x52, 0) != 1)
    return -1;
  x53 = XVECEXP (x52, 0, 0);
  if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x54 = XEXP (x50, 1);
  if (GET_CODE (x54) != VEC_SELECT
      || GET_MODE (x54) != E_SFmode)
    return -1;
  x55 = XEXP (x54, 1);
  if (GET_CODE (x55) != PARALLEL
      || XVECLEN (x55, 0) != 1)
    return -1;
  x56 = XVECEXP (x55, 0, 0);
  if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x57 = XEXP (x49, 1);
  if (GET_CODE (x57) != i1)
    return -1;
  x58 = XEXP (x57, 0);
  if (GET_CODE (x58) != VEC_SELECT
      || GET_MODE (x58) != E_SFmode)
    return -1;
  x59 = XEXP (x58, 1);
  if (GET_CODE (x59) != PARALLEL
      || XVECLEN (x59, 0) != 1)
    return -1;
  x60 = XVECEXP (x59, 0, 0);
  if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x61 = XEXP (x57, 1);
  if (GET_CODE (x61) != VEC_SELECT
      || GET_MODE (x61) != E_SFmode)
    return -1;
  x62 = XEXP (x61, 1);
  if (GET_CODE (x62) != PARALLEL
      || XVECLEN (x62, 0) != 1)
    return -1;
  x63 = XVECEXP (x62, 0, 0);
  if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x64 = XEXP (x5, 0);
  operands[1] = x64;
  if (!register_operand (operands[1], E_V8SFmode))
    return -1;
  x65 = XEXP (x20, 0);
  operands[2] = x65;
  if (!nonimmediate_operand (operands[2], E_V8SFmode))
    return -1;
  x66 = XEXP (x8, 0);
  if (!rtx_equal_p (x66, operands[1]))
    return -1;
  x67 = XEXP (x12, 0);
  if (!rtx_equal_p (x67, operands[1]))
    return -1;
  x68 = XEXP (x15, 0);
  if (!rtx_equal_p (x68, operands[1]))
    return -1;
  x69 = XEXP (x23, 0);
  if (!rtx_equal_p (x69, operands[2]))
    return -1;
  x70 = XEXP (x27, 0);
  if (!rtx_equal_p (x70, operands[2]))
    return -1;
  x71 = XEXP (x30, 0);
  if (!rtx_equal_p (x71, operands[2]))
    return -1;
  x72 = XEXP (x36, 0);
  if (!rtx_equal_p (x72, operands[1]))
    return -1;
  x73 = XEXP (x39, 0);
  if (!rtx_equal_p (x73, operands[1]))
    return -1;
  x74 = XEXP (x43, 0);
  if (!rtx_equal_p (x74, operands[1]))
    return -1;
  x75 = XEXP (x46, 0);
  if (!rtx_equal_p (x75, operands[1]))
    return -1;
  x76 = XEXP (x51, 0);
  if (!rtx_equal_p (x76, operands[2]))
    return -1;
  x77 = XEXP (x54, 0);
  if (!rtx_equal_p (x77, operands[2]))
    return -1;
  x78 = XEXP (x58, 0);
  if (!rtx_equal_p (x78, operands[2]))
    return -1;
  x79 = XEXP (x61, 0);
  if (!rtx_equal_p (x79, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 39:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_CCGZmode)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x3) != LTU
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCGZmode)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!x86_64_general_operand (operands[2], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 435; /* subsi3_carry_ccgz */

    case 59:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != CONST_INT)
            return -1;
          operands[3] = x3;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          switch (pattern875 (x2))
            {
            case 0:
              switch (GET_MODE (operands[1]))
                {
                case E_HFmode:
                  if (register_operand (operands[1], E_HFmode)
                      && nonimmediate_operand (operands[2], E_HFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && 
#line 19714 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                    return 1202; /* setcc_hf_mask */
                  break;

                case E_V8SImode:
                  if (register_operand (operands[1], E_V8SImode)
                      && nonimmediate_operand (operands[2], E_V8SImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2734; /* avx512vl_cmpv8si3 */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && nonimmediate_operand (operands[2], E_V4SImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2736; /* avx512vl_cmpv4si3 */
                  break;

                case E_V8DImode:
                  if (register_operand (operands[1], E_V8DImode)
                      && nonimmediate_operand (operands[2], E_V8DImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 2738; /* avx512f_cmpv8di3 */
                  break;

                case E_V4DImode:
                  if (register_operand (operands[1], E_V4DImode)
                      && nonimmediate_operand (operands[2], E_V4DImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2742; /* avx512vl_cmpv4di3 */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[1], E_V2DImode)
                      && nonimmediate_operand (operands[2], E_V2DImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2744; /* avx512vl_cmpv2di3 */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && nonimmediate_operand (operands[2], E_V8HFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 2752; /* avx512fp16_cmpv8hf3 */
                  break;

                case E_V8SFmode:
                  if (register_operand (operands[1], E_V8SFmode)
                      && nonimmediate_operand (operands[2], E_V8SFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2758; /* avx512vl_cmpv8sf3 */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && nonimmediate_operand (operands[2], E_V4SFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2760; /* avx512vl_cmpv4sf3 */
                  break;

                case E_V8DFmode:
                  if (register_operand (operands[1], E_V8DFmode)
                      && nonimmediate_operand (operands[2], E_V8DFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 2762; /* avx512f_cmpv8df3 */
                  break;

                case E_V4DFmode:
                  if (register_operand (operands[1], E_V4DFmode)
                      && nonimmediate_operand (operands[2], E_V4DFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2766; /* avx512vl_cmpv4df3 */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[1], E_V2DFmode)
                      && nonimmediate_operand (operands[2], E_V2DFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2768; /* avx512vl_cmpv2df3 */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && nonimmediate_operand (operands[2], E_V8HImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2885; /* avx512vl_cmpv8hi3 */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[1], E_V8BFmode)
                      && nonimmediate_operand (operands[2], E_V8BFmode)
                      && const_0_to_31_operand (operands[3], E_VOIDmode)
                      && 
#line 32454 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                    return 10013; /* avx10_2_cmpbf16_v8bf */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (register_operand (operands[1], E_V16SImode)
                      && nonimmediate_operand (operands[2], E_V16SImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 2730; /* avx512f_cmpv16si3 */
                  break;

                case E_V16HFmode:
                  if (register_operand (operands[1], E_V16HFmode)
                      && nonimmediate_operand (operands[2], E_V16HFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 2750; /* avx512vl_cmpv16hf3 */
                  break;

                case E_V16SFmode:
                  if (register_operand (operands[1], E_V16SFmode)
                      && nonimmediate_operand (operands[2], E_V16SFmode)
                      && const_0_to_31_operand (operands[3], E_SImode)
                      && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 2754; /* avx512f_cmpv16sf3 */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && nonimmediate_operand (operands[2], E_V16QImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2877; /* avx512vl_cmpv16qi3 */
                  break;

                case E_V16HImode:
                  if (register_operand (operands[1], E_V16HImode)
                      && nonimmediate_operand (operands[2], E_V16HImode)
                      && const_0_to_7_operand (operands[3], E_SImode)
                      && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2883; /* avx512vl_cmpv16hi3 */
                  break;

                case E_V16BFmode:
                  if (register_operand (operands[1], E_V16BFmode)
                      && nonimmediate_operand (operands[2], E_V16BFmode)
                      && const_0_to_31_operand (operands[3], E_VOIDmode)
                      && 
#line 32454 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                    return 10011; /* avx10_2_cmpbf16_v16bf */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (XWINT (x3, 0) != 0L)
            return -1;
          operands[2] = x8;
          switch (pattern876 (x2))
            {
            case 0:
              if (!(
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2939; /* *avx512vl_eqv16qi3_1 */

            case 1:
              if (!(
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2951; /* *avx512vl_eqv16hi3_1 */

            case 2:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3007; /* *avx512f_eqv16si3_1 */

            case 3:
              if (!(
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2955; /* *avx512vl_eqv8hi3_1 */

            case 4:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3011; /* *avx512vl_eqv8si3_1 */

            case 5:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3015; /* *avx512vl_eqv4si3_1 */

            case 6:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3019; /* *avx512f_eqv8di3_1 */

            case 7:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3023; /* *avx512vl_eqv4di3_1 */

            case 8:
              if (!(
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3027; /* *avx512vl_eqv2di3_1 */

            default:
              return -1;
            }

        case US_MINUS:
          switch (pattern361 (x2))
            {
            case 0:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3087; /* *avx512vl_ucmpv16qi3_1 */

            case 1:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3093; /* *avx512vl_ucmpv16hi3_1 */

            case 2:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3095; /* *avx512vl_ucmpv8hi3_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 48:
      if (GET_MODE (x2) != E_HFmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_HFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!nonimmediate_operand (operands[1], E_HFmode))
        return -1;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!nonimm_or_0_operand (operands[2], E_HFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 26573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 1455; /* movhf_mask */

    case 51:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      x3 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x3))
        {
        case LT:
          switch (pattern674 (x2))
            {
            case 0:
              if (
#line 26806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                return 1473; /* *ieee_maxsf3_1 */
              if (!
#line 26827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                return -1;
              return 1475; /* *ieee_minsf3_1 */

            case 1:
              if (
#line 26806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()))
                return 1474; /* *ieee_maxdf3_1 */
              if (!
#line 26827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()))
                return -1;
              return 1476; /* *ieee_mindf3_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V4QImode:
              if (pattern877 (x2, 
E_V4QImode) == 0
                  && 
#line 4390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return 1774; /* mmx_pblendvb_v4qi */
              break;

            case E_V2QImode:
              if (pattern877 (x2, 
E_V2QImode) == 0
                  && 
#line 4390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return 1775; /* mmx_pblendvb_v2qi */
              break;

            case E_V2HImode:
              if (pattern877 (x2, 
E_V2HImode) == 0
                  && 
#line 4390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return 1776; /* mmx_pblendvb_v2hi */
              break;

            case E_SFmode:
              if (pattern877 (x2, 
E_SFmode) == 0
                  && 
#line 23534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 7981; /* sse4_1_blendvss */
              break;

            case E_DFmode:
              if (pattern877 (x2, 
E_DFmode) == 0
                  && 
#line 23534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 7982; /* sse4_1_blendvsd */
              break;

            default:
              break;
            }
          if (GET_CODE (x3) != SUBREG
              || pattern774 (x2) != 0
              || !
#line 4442 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 1780; /* *mmx_pblendvb_v4qi_2 */

        case EQ:
          switch (pattern676 (x2))
            {
            case 0:
              if (!
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 1777; /* *mmx_pblendvb_v4qi_1 */

            case 1:
              if (!
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 1778; /* *mmx_pblendvb_v2qi_1 */

            case 2:
              if (!
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 1779; /* *mmx_pblendvb_v2hi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 53:
      if (pattern71 (x1, 
E_V4QImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[3] = x3;
      if (!nonimmediate_operand (operands[3], E_V16QImode)
          || !
#line 4524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
        return -1;
      return 1786; /* mmx_ppermv32 */

    case 47:
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      switch (pattern965 (x2, 
E_V8QImode))
        {
        case 0:
          if (!(
#line 6860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1877; /* *mmx_maskmovq */

        case 1:
          if (!(
#line 6860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE || TARGET_3DNOW_A) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1878; /* *mmx_maskmovq */

        default:
          return -1;
        }

    case 157:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x3 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x3) != CONST_INT)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          operands[2] = x8;
          if (XWINT (x3, 0) == 0L)
            {
              switch (pattern876 (x2))
                {
                case 0:
                  if ((
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2941; /* *avx512vl_eqv16qi3_1 */
                  break;

                case 1:
                  if ((
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2953; /* *avx512vl_eqv16hi3_1 */
                  break;

                case 2:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 3009; /* *avx512f_eqv16si3_1 */
                  break;

                case 3:
                  if ((
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 2957; /* *avx512vl_eqv8hi3_1 */
                  break;

                case 4:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 3013; /* *avx512vl_eqv8si3_1 */
                  break;

                case 5:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 3017; /* *avx512vl_eqv4si3_1 */
                  break;

                case 6:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 3021; /* *avx512f_eqv8di3_1 */
                  break;

                case 7:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 3025; /* *avx512vl_eqv4di3_1 */
                  break;

                case 8:
                  if ((
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 3029; /* *avx512vl_eqv2di3_1 */
                  break;

                default:
                  break;
                }
            }
          operands[3] = x3;
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (pattern69 (x2))
            {
            case 0:
              if (!(
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2961; /* avx512vl_ucmpv16qi3 */

            case 1:
              if (!(
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2967; /* avx512vl_ucmpv16hi3 */

            case 2:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3031; /* avx512f_ucmpv16si3 */

            case 3:
              if (!(
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2969; /* avx512vl_ucmpv8hi3 */

            case 4:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3033; /* avx512vl_ucmpv8si3 */

            case 5:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3035; /* avx512vl_ucmpv4si3 */

            case 6:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3037; /* avx512f_ucmpv8di3 */

            case 7:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3039; /* avx512vl_ucmpv4di3 */

            case 8:
              if (!(
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3041; /* avx512vl_ucmpv2di3 */

            default:
              return -1;
            }

        case US_MINUS:
          switch (pattern361 (x2))
            {
            case 0:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3088; /* *avx512vl_ucmpv16qi3_1 */

            case 1:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3094; /* *avx512vl_ucmpv16hi3_1 */

            case 2:
              if (!(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3096; /* *avx512vl_ucmpv8hi3_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 52:
      if (pnum_clobbers == NULL
          || pattern67 (x1, 
E_V8QImode) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[4] = x3;
      if (!reg_or_const_vector_operand (operands[4], E_V4SImode)
          || !
#line 23140 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      *pnum_clobbers = 1;
      return 7924; /* *ssse3_pshufbv8qi3 */

    case 132:
      if (pnum_clobbers == NULL
          || pattern229 (x1) != 0
          || !nonimmediate_operand (operands[3], E_V16QImode))
        return -1;
      x3 = XVECEXP (x2, 0, 2);
      operands[4] = x3;
      if (!const_0_to_255_operand (operands[4], E_SImode)
          || !
#line 26061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      *pnum_clobbers = 2;
      return 8278; /* sse4_2_pcmpistr_cconly */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1, pnum_clobbers))
    {
    case 0:
      if (pnum_clobbers != NULL)
        {
          switch (pattern244 (x1))
            {
            case 0:
              if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1049; /* *rotrqi3_mask */
                }
              break;

            case 1:
              if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1051; /* *rotrhi3_mask */
                }
              break;

            case 2:
              if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1065; /* *rotrqi3_add */
                }
              break;

            case 3:
              if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1067; /* *rotrhi3_add */
                }
              break;

            case 4:
              if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1081; /* *rotrqi3_sub */
                }
              break;

            case 5:
              if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1083; /* *rotrhi3_sub */
                }
              break;

            default:
              break;
            }
        }
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (pattern245 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1132; /* *rotrqi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1133; /* *rotrqi3_1 */

        case 1:
          if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1136; /* *rotrhi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1137; /* *rotrhi3_1 */

        case 2:
          if (!
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1139; /* *rotrqi3_1_slp */

        case 3:
          if (!
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 1141; /* *rotrhi3_1_slp */

        default:
          return -1;
        }

    case 1:
      if (!
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1057; /* *rotrqi3_mask_1 */

    case 2:
      if (!
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1059; /* *rotrhi3_mask_1 */

    case 3:
      if (!
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1073; /* *rotrqi3_add_1 */

    case 4:
      if (!
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1075; /* *rotrhi3_add_1 */

    case 5:
      if (!
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1089; /* *rotrqi3_sub_1 */

    case 6:
      if (!
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1091; /* *rotrhi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LTU:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG
      && REGNO (x3) == 17)
    {
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (operands[1]))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern685 (
E_V8QImode) != 0
              || !
#line 4218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1768; /* *xop_maskcmp_unsv8qi3 */

        case E_V4HImode:
          if (pattern685 (
E_V4HImode) != 0
              || !
#line 4218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1769; /* *xop_maskcmp_unsv4hi3 */

        case E_V2SImode:
          if (pattern685 (
E_V2SImode) != 0
              || !
#line 4218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1770; /* *xop_maskcmp_unsv2si3 */

        case E_V4QImode:
          if (pattern685 (
E_V4QImode) != 0
              || !
#line 4228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1771; /* *xop_maskcmp_unsv4qi3 */

        case E_V2QImode:
          if (pattern685 (
E_V2QImode) != 0
              || !
#line 4228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1772; /* *xop_maskcmp_unsv2qi3 */

        case E_V2HImode:
          if (pattern685 (
E_V2HImode) != 0
              || !
#line 4228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1773; /* *xop_maskcmp_unsv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x3 = XEXP (x1, 1);
          if (pattern74 (x3, pnum_clobbers, 
E_TImode) != 0
              || !(
#line 8069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 310; /* *subti3_doubleword */

        case E_QImode:
          x3 = XEXP (x1, 1);
          if (pattern75 (x3, 
E_QImode) != 0)
            return -1;
          if (
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 313; /* *subqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 314; /* *subqi_1 */

        case E_HImode:
          x3 = XEXP (x1, 1);
          if (pattern75 (x3, 
E_HImode) != 0)
            return -1;
          if (
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 315; /* *subhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 316; /* *subhi_1 */

        case E_HFmode:
          x3 = XEXP (x1, 1);
          if (pattern5 (x3, 
E_HFmode) != 0
              || !
#line 23465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 1337; /* *subhf */

        case E_V8QImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V8QImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V8QImode, operands)))
            return -1;
          return 1669; /* *mmx_subv8qi3 */

        case E_V4HImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V4HImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V4HImode, operands)))
            return -1;
          return 1671; /* *mmx_subv4hi3 */

        case E_V2SImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V2SImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V2SImode, operands)))
            return -1;
          return 1673; /* *mmx_subv2si3 */

        case E_V1DImode:
          x3 = XEXP (x1, 1);
          if (pattern7 (x3, 
E_V1DImode) != 0
              || !(
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (MINUS, V1DImode, operands)) && 
#line 50 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2)))
            return -1;
          return 1675; /* *mmx_subv1di3 */

        case E_V4QImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V4QImode) != 0
              || !
#line 3227 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1677; /* subv4qi3 */

        case E_V2HImode:
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V2HImode) != 0
              || !
#line 3227 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1679; /* subv2hi3 */

        case E_V2QImode:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XEXP (x1, 1);
          if (pattern8 (x3, 
E_V2QImode) != 0
              || !
#line 3241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          *pnum_clobbers = 1;
          return 1681; /* subv2qi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          x3 = XEXP (x1, 1);
          if (pattern973 (x3, 
E_QImode) != 0
              || !
#line 8189 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 331; /* *subqi_1_slp */

        case E_HImode:
          x3 = XEXP (x1, 1);
          if (pattern973 (x3, 
E_HImode) != 0
              || !
#line 8189 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 332; /* *subhi_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern14 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x6) == CONST_INT)
            {
              switch (XWINT (x5, 0))
                {
                case 1L:
                  if (XWINT (x6, 0) == 0L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_V2SFmode:
                          if (register_operand (operands[0], E_V2SFmode)
                              && GET_MODE (x2) == E_V2SFmode
                              && register_mmxmem_operand (operands[1], E_V2SFmode)
                              && 
#line 1641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A || TARGET_MMX_WITH_SSE))
                            return 1648; /* mmx_pswapdv2sf2 */
                          break;

                        case E_V2SImode:
                          if (register_operand (operands[0], E_V2SImode)
                              && GET_MODE (x2) == E_V2SImode
                              && register_mmxmem_operand (operands[1], E_V2SImode)
                              && 
#line 5643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
                            return 1842; /* mmx_pswapdv2si2 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case 2L:
                  if (XWINT (x6, 0) == 3L
                      && nonimmediate_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x2) == E_V2SFmode
                      && nonimmediate_operand (operands[1], E_V4SFmode)
                      && 
#line 11572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 4600; /* sse_storehps */
                  break;

                case 0L:
                  if (XWINT (x6, 0) == 1L
                      && nonimmediate_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x2) == E_V2SFmode
                      && nonimmediate_operand (operands[1], E_V4SFmode)
                      && 
#line 11625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 4602; /* sse_storelps */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x5;
          if (!const_0_to_1_operand (operands[2], E_VOIDmode))
            return -1;
          operands[3] = x6;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HFmode:
              if (!register_operand (operands[0], E_V2HFmode)
                  || GET_MODE (x2) != E_V2HFmode
                  || !register_operand (operands[1], E_V2HFmode)
                  || !
#line 6236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1863; /* *pshufwv2hf_1 */

            case E_V2BFmode:
              if (!register_operand (operands[0], E_V2BFmode)
                  || GET_MODE (x2) != E_V2BFmode
                  || !register_operand (operands[1], E_V2BFmode)
                  || !
#line 6236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1864; /* *pshufwv2bf_1 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode)
                  || !
#line 6236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1865; /* *pshufwv2hi_1 */

            default:
              return -1;
            }

        case 1:
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          switch (XWINT (x5, 0))
            {
            case 0L:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  switch (pattern882 (x2))
                    {
                    case 0:
                      if (
#line 1783 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 1651; /* *vec_extractv2sf_0 */
                      break;

                    case 1:
                      if (
#line 12309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 4658; /* *vec_extractv4sf_0 */
                      break;

                    default:
                      break;
                    }
                  break;

                case E_HFmode:
                  switch (pattern883 (x2))
                    {
                    case 0:
                      if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 548 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 4717; /* *vec_extractv32hf_0 */
                      break;

                    case 1:
                      if (
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 4718; /* *vec_extractv16hf_0 */
                      break;

                    case 2:
                      if (
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 4719; /* *vec_extractv8hf_0 */
                      break;

                    default:
                      break;
                    }
                  break;

                case E_BFmode:
                  switch (pattern884 (x2))
                    {
                    case 0:
                      if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 549 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return 4720; /* *vec_extractv32bf_0 */
                      break;

                    case 1:
                      if (
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 4721; /* *vec_extractv16bf_0 */
                      break;

                    case 2:
                      if (
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 4722; /* *vec_extractv8bf_0 */
                      break;

                    default:
                      break;
                    }
                  break;

                case E_DFmode:
                  if (nonimmediate_operand (operands[0], E_DFmode)
                      && GET_MODE (x2) == E_DFmode
                      && nonimmediate_operand (operands[1], E_V2DFmode))
                    {
                      if (
#line 14636 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 6560; /* sse2_storelpd */
                      if (
#line 14665 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(!TARGET_SSE2 && TARGET_SSE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 6561; /* *vec_extractv2df_0_sse */
                    }
                  break;

                case E_QImode:
                  if (memory_operand (operands[0], E_QImode)
                      && GET_MODE (x2) == E_QImode
                      && register_operand (operands[1], E_V16QImode)
                      && (
#line 21052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                    return 7799; /* *vec_extractv16qi_0_mem */
                  break;

                case E_HImode:
                  if (memory_operand (operands[0], E_HImode)
                      && GET_MODE (x2) == E_HImode
                      && register_operand (operands[1], E_V8HImode)
                      && 
#line 21052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()))
                    return 7800; /* *vec_extractv8hi_0_mem */
                  break;

                default:
                  break;
                }
              break;

            case 1L:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (nonimmediate_operand (operands[0], E_SFmode)
                      && GET_MODE (x2) == E_SFmode
                      && nonimmediate_operand (operands[1], E_V2SFmode)
                      && 
#line 1798 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                    return 1652; /* *vec_extractv2sf_1 */
                  break;

                case E_DFmode:
                  if (nonimmediate_operand (operands[0], E_DFmode)
                      && GET_MODE (x2) == E_DFmode
                      && nonimmediate_operand (operands[1], E_V2DFmode))
                    {
                      if (
#line 14579 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 6558; /* sse2_storehpd */
                      if (
#line 14612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(!TARGET_SSE2 && TARGET_SSE
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                        return 6559; /* *vec_extractv2df_1_sse */
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (GET_MODE (x2) != E_HImode)
                return -1;
              if (register_sse4nonimm_operand (operands[0], E_HImode))
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (register_operand (operands[1], E_V4HImode)
                          && const_0_to_3_operand (operands[2], E_SImode)
                          && 
#line 5381 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                        return 1831; /* *mmx_pextrw */
                      break;

                    case E_V2HImode:
                      if (register_operand (operands[1], E_V2HImode)
                          && const_0_to_1_operand (operands[2], E_SImode)
                          && 
#line 6047 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                        return 1853; /* *pextrw */
                      break;

                    case E_V8HImode:
                      if (register_operand (operands[1], E_V8HImode)
                          && const_0_to_7_operand (operands[2], E_SImode)
                          && 
#line 21076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                        return 7802; /* *vec_extractv8hi */
                      break;

                    default:
                      break;
                    }
                }
              if (!register_operand (operands[0], E_HImode)
                  || !memory_operand (operands[1], E_V8HImode)
                  || !const_0_to_7_operand (operands[2], E_VOIDmode)
                  || !
#line 21137 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 7807; /* *vec_extractv8hi_mem */

            case E_HFmode:
              if (!register_sse4nonimm_operand (operands[0], E_HFmode)
                  || GET_MODE (x2) != E_HFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (!register_operand (operands[1], E_V4HFmode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 5401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                    return -1;
                  return 1832; /* *mmx_pextrwv4hf */

                case E_V2HFmode:
                  if (!register_operand (operands[1], E_V2HFmode)
                      || !const_0_to_1_operand (operands[2], E_SImode)
                      || !
#line 6064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 1854; /* *pextrwv2hf */

                case E_V8HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4723; /* *vec_extracthf */

                default:
                  return -1;
                }

            case E_BFmode:
              if (!register_sse4nonimm_operand (operands[0], E_BFmode)
                  || GET_MODE (x2) != E_BFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[1], E_V4BFmode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 5401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                    return -1;
                  return 1833; /* *mmx_pextrwv4bf */

                case E_V2BFmode:
                  if (!register_operand (operands[1], E_V2BFmode)
                      || !const_0_to_1_operand (operands[2], E_SImode)
                      || !
#line 6064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                    return -1;
                  return 1855; /* *pextrwv2bf */

                case E_V8BFmode:
                  if (!register_operand (operands[1], E_V8BFmode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 13230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4724; /* *vec_extractbf */

                default:
                  return -1;
                }

            case E_QImode:
              if (GET_MODE (x2) != E_QImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && register_operand (operands[1], E_V4QImode)
                  && const_0_to_3_operand (operands[2], E_SImode)
                  && 
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE4_1))
                return 1857; /* *pextrb */
              if (register_sse4nonimm_operand (operands[0], E_QImode)
                  && register_operand (operands[1], E_V16QImode)
                  && const_0_to_15_operand (operands[2], E_SImode)
                  && (
#line 21076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 21045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 7801; /* *vec_extractv16qi */
              if (!register_operand (operands[0], E_QImode)
                  || !memory_operand (operands[1], E_V16QImode)
                  || !const_0_to_15_operand (operands[2], E_VOIDmode)
                  || !
#line 21137 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 7806; /* *vec_extractv16qi_mem */

            case E_SFmode:
              if (GET_MODE (x2) != E_SFmode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && const_0_to_3_operand (operands[2], E_SImode)
                  && 
#line 12320 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 4659; /* *sse4_1_extractps */
              if (!register_operand (operands[0], E_SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (!memory_operand (operands[1], E_V4SFmode)
                      || !const_0_to_3_operand (operands[2], E_VOIDmode)
                      || !
#line 12363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 4660; /* *vec_extractv4sf_mem */

                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !const_0_to_15_operand (operands[2], E_VOIDmode)
                      || !(
#line 14058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SFmode) >= 16) && 
#line 302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6431; /* *vec_extractv16sfsf_valign */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !const_0_to_7_operand (operands[2], E_VOIDmode)
                      || !(
#line 14058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (SFmode) >= 16) && 
#line 302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6432; /* *vec_extractv8sfsf_valign */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8DFmode:
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !const_0_to_7_operand (operands[2], E_VOIDmode)
                      || !(
#line 14058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DFmode) >= 16) && 
#line 303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6433; /* *vec_extractv8dfdf_valign */

                case E_V4DFmode:
                  if (!register_operand (operands[1], E_V4DFmode)
                      || !const_0_to_3_operand (operands[2], E_VOIDmode)
                      || !(
#line 14058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL(operands[2]) * GET_MODE_SIZE (DFmode) >= 16) && 
#line 303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6434; /* *vec_extractv4dfdf_valign */

                default:
                  return -1;
                }

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2TImode:
                  if (!register_operand (operands[1], E_V2TImode)
                      || !const_0_to_1_operand (operands[2], E_SImode)
                      || !
#line 21393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                    return -1;
                  return 7813; /* *vec_extractv2ti */

                case E_V4TImode:
                  if (!register_operand (operands[1], E_V4TImode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 21411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                    return -1;
                  return 7814; /* *vec_extractv4ti */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (pattern608 (x4) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HFmode:
              if (!register_operand (operands[0], E_V4HFmode)
                  || GET_MODE (x2) != E_V4HFmode
                  || !register_mmxmem_operand (operands[1], E_V4HFmode)
                  || !
#line 5543 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                return -1;
              return 1836; /* mmx_pshufwv4hf_1 */

            case E_V4BFmode:
              if (!register_operand (operands[0], E_V4BFmode)
                  || GET_MODE (x2) != E_V4BFmode
                  || !register_mmxmem_operand (operands[1], E_V4BFmode)
                  || !
#line 5543 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                return -1;
              return 1837; /* mmx_pshufwv4bf_1 */

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x2) != E_V4HImode
                  || !register_mmxmem_operand (operands[1], E_V4HImode)
                  || !
#line 5543 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
                return -1;
              return 1838; /* mmx_pshufwv4hi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!
#line 4850 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 1817; /* mmx_punpckhbw */

    case 2:
      if (!
#line 4890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 1819; /* mmx_punpcklbw */

    case 3:
      if (!
#line 4871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
        return -1;
      return 1818; /* mmx_punpckhbw_low */

    case 4:
      if (!
#line 4928 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 1821; /* mmx_punpckhwd */

    case 5:
      if (!
#line 4911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
        return -1;
      return 1820; /* mmx_punpcklbw_low */

    case 6:
      if (!
#line 4949 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
        return -1;
      return 1822; /* mmx_punpcklwd */

    case 7:
      x2 = XEXP (x1, 1);
      x4 = XEXP (x2, 1);
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) == CONST_INT)
        {
          switch (pattern885 (x2))
            {
            case 0:
              if (
#line 4970 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return 1823; /* mmx_punpckhdq */
              break;

            case 1:
              if (
#line 4991 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return 1824; /* mmx_punpckldq */
              break;

            default:
              break;
            }
        }
      x5 = XVECEXP (x4, 0, 0);
      operands[3] = x5;
      switch (pattern886 (x2))
        {
        case 0:
          if (!
#line 6197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1860; /* *punpckwd */

        case 1:
          if (!
#line 6197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1861; /* *punpckwd */

        case 2:
          if (!
#line 6197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1862; /* *punpckwd */

        default:
          return -1;
        }

    case 8:
      if (!
#line 8409 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4175; /* sse_cvtps2pi */

    case 9:
      if (!
#line 8473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
        return -1;
      return 4177; /* sse_cvttps2pi */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = recog_72 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CLZ
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_LZCNT))
        return -1;
      *pnum_clobbers = 1;
      return 1256; /* bsr_1 */

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern256 (x3))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1157 (x3, 
E_SImode) != 0
                  || !
#line 9277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* subsi3_carry */

            case E_DImode:
              if (pattern1157 (x3, 
E_DImode) != 0
                  || !(
#line 9277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* subdi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1090 (x3, 
E_SImode) != 0
                  || !
#line 10230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 481; /* *subsi3_eq */

            case E_DImode:
              if (pattern1090 (x3, 
E_DImode) != 0
                  || !(
#line 10230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 482; /* *subdi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pnum_clobbers != NULL)
        {
          res = recog_75 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!ix86_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonimmediate_operand (operands[3], E_SImode)
          || !
#line 26339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
        return -1;
      return 1453; /* *movsicc_noc */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern114 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && (
#line 14239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 767; /* *negdi2_doubleword */
            }
          if ((
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 775; /* *negdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 776; /* *negdi_1 */

        case 1:
          if (
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 773; /* *negsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 774; /* *negsi_1 */

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern557 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 14646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 807; /* *nabsdi2_doubleword */
            }
          if (!(
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 816; /* *nabsdi2_1 */

        case E_SImode:
          if (pattern557 (x3, 
E_SImode) != 0
              || !
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 815; /* *nabssi2_1 */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 17)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 1451; /* *x86_movsicc_0_m1_neg */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern48 (x3, pnum_clobbers))
    {
    case 0:
      if (pnum_clobbers != NULL
          && pattern387 (x3) == 0
          && (
#line 16584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 913; /* *lshrdi3_doubleword_mask */
        }
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      res = recog_85 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern390 (x3))
        {
        case 0:
          if (!
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1010; /* *lshrsi3_mask */

        case 1:
          if (!(
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1013; /* *lshrdi3_mask */

        case 2:
          if (!
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1022; /* *lshrsi3_add */

        case 3:
          if (!(
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1025; /* *lshrdi3_add */

        case 4:
          if (!
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1034; /* *lshrsi3_sub */

        case 5:
          if (!(
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1037; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 917; /* *lshrdi3_doubleword_mask_1 */
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1019; /* *lshrdi3_mask_1 */

    case 2:
      if (!
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1016; /* *lshrsi3_mask_1 */

    case 3:
      if (!
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1028; /* *lshrsi3_add_1 */

    case 4:
      if (!(
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1031; /* *lshrdi3_add_1 */

    case 5:
      if (!
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1040; /* *lshrsi3_sub_1 */

    case 6:
      if (!(
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1043; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == SUBREG
      && known_eq (SUBREG_BYTE (x2), 0))
    {
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (register_operand (operands[0], E_QImode))
        {
          x4 = XEXP (x1, 1);
          x5 = XEXP (x4, 2);
          operands[2] = x5;
          if (register_operand (operands[2], E_QImode))
            {
              switch (GET_MODE (x2))
                {
                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1181; /* *btsi_setcqi */
                    }
                  break;

                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 1182; /* *btdi_setcqi */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != AND)
    return -1;
  operands[0] = x2;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1316 (x4, 
E_SImode) != 0
          || !
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1189; /* *btsi_setcsi_mask */

    case E_DImode:
      if (pattern1316 (x4, 
E_DImode) != 0
          || !(
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1190; /* *btdi_setcdi_mask */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (call_insn_operand (operands[1], E_SImode)
      && (
#line 20346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1220; /* *call_value */
  if (call_insn_operand (operands[1], E_DImode)
      && (
#line 20346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
    return 1221; /* *call_value */
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) == E_DImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (GOT_memory_operand (operands[1], E_SImode))
            {
              operands[2] = x6;
              if (
#line 20357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER))
                return 1222; /* *call_value_got_x32 */
            }
        }
      break;

    case MEM:
      if (GET_MODE (x5) == E_SImode)
        {
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) == PLUS
              && GET_MODE (x7) == E_SImode)
            {
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (register_no_elim_operand (operands[1], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  if (GOT32_symbol_operand (operands[2], E_SImode))
                    {
                      operands[3] = x6;
                      if (
#line 20373 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_MACHO
   && !TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (insn)))
                        return 1223; /* *sibcall_value_GOT_32 */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x5;
  operands[2] = x6;
  if (sibcall_insn_operand (operands[1], E_SImode)
      && (
#line 20387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1224; /* *sibcall_value */
  if (!sibcall_insn_operand (operands[1], E_DImode)
      || !(
#line 20387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
    return -1;
  return 1225; /* *sibcall_value */
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (XWINT (x5, 0) != 0L
      || GET_MODE (x2) != E_DImode)
    return -1;
  x6 = XEXP (x3, 0);
  switch (pattern1094 (x6))
    {
    case 0:
      if (pshufb_truncv8hiv8qi_operand (operands[2], E_V16QImode)
          && 
#line 15368 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()))
        return 6642; /* *avx512f_pshufb_truncv8hiv8qi_1 */
      if (!pshufb_truncv4siv4hi_operand (operands[2], E_V16QImode)
          || !
#line 15723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 6727; /* *avx512f_pshufb_truncv4siv4hi_1 */

    case 1:
      if (!
#line 15964 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
        return -1;
      return 6776; /* *avx512f_pshufd_truncv2div2si_1 */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern893 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1938; /* *avx512f_loadv16si_mask */

    case E_V8SImode:
      if (pattern893 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1939; /* *avx512vl_loadv8si_mask */

    case E_V4SImode:
      if (pattern893 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1940; /* *avx512vl_loadv4si_mask */

    case E_V8DImode:
      if (pattern893 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1941; /* *avx512f_loadv8di_mask */

    case E_V4DImode:
      if (pattern893 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1942; /* *avx512vl_loadv4di_mask */

    case E_V2DImode:
      if (pattern893 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1943; /* *avx512vl_loadv2di_mask */

    case E_V16SFmode:
      if (pattern893 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1944; /* *avx512f_loadv16sf_mask */

    case E_V8SFmode:
      if (pattern893 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1945; /* *avx512vl_loadv8sf_mask */

    case E_V4SFmode:
      if (pattern893 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1946; /* *avx512vl_loadv4sf_mask */

    case E_V8DFmode:
      if (pattern893 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1947; /* *avx512f_loadv8df_mask */

    case E_V4DFmode:
      if (pattern893 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1948; /* *avx512vl_loadv4df_mask */

    case E_V2DFmode:
      if (pattern893 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 1611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1949; /* *avx512vl_loadv2df_mask */

    case E_V64QImode:
      if (pattern893 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1962; /* *avx512bw_loadv64qi_mask */

    case E_V16QImode:
      if (pattern893 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1963; /* *avx512vl_loadv16qi_mask */

    case E_V32QImode:
      if (pattern893 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1964; /* *avx512vl_loadv32qi_mask */

    case E_V32HImode:
      if (pattern893 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1965; /* *avx512bw_loadv32hi_mask */

    case E_V16HImode:
      if (pattern893 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1966; /* *avx512vl_loadv16hi_mask */

    case E_V8HImode:
      if (pattern893 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1967; /* *avx512vl_loadv8hi_mask */

    case E_V32HFmode:
      if (pattern893 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1968; /* *avx512bw_loadv32hf_mask */

    case E_V16HFmode:
      if (pattern893 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1969; /* *avx512vl_loadv16hf_mask */

    case E_V8HFmode:
      if (pattern893 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1970; /* *avx512fp16_loadv8hf_mask */

    case E_V32BFmode:
      if (pattern893 (x2, 
E_V32BFmode, 
E_SImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 1971; /* *avx512bw_loadv32bf_mask */

    case E_V16BFmode:
      if (pattern893 (x2, 
E_V16BFmode, 
E_HImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1972; /* *avx512vl_loadv16bf_mask */

    case E_V8BFmode:
      if (pattern893 (x2, 
E_V8BFmode, 
E_QImode) != 0
          || !(
#line 1670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 1973; /* *avx512vl_loadv8bf_mask */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (pattern995 (x2, 
E_QImode, 
E_V8SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8409; /* avx2_permvarv8si_mask */

    case E_V8SFmode:
      if (pattern996 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8411; /* avx2_permvarv8sf_mask */

    case E_V16SImode:
      if (pattern995 (x2, 
E_HImode, 
E_V16SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 997 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8413; /* avx512f_permvarv16si_mask */

    case E_V16SFmode:
      if (pattern996 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 998 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8415; /* avx512f_permvarv16sf_mask */

    case E_V8DImode:
      if (pattern995 (x2, 
E_QImode, 
E_V8DImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 999 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8417; /* avx512f_permvarv8di_mask */

    case E_V8DFmode:
      if (pattern996 (x2, 
E_QImode, 
E_V8DFmode, 
E_V8DImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 1000 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8419; /* avx512f_permvarv8df_mask */

    case E_V4DImode:
      if (pattern995 (x2, 
E_QImode, 
E_V4DImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL)) && 
#line 1001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8421; /* avx2_permvarv4di_mask */

    case E_V4DFmode:
      if (pattern996 (x2, 
E_QImode, 
E_V4DFmode, 
E_V4DImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27305 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL)) && 
#line 1001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8423; /* avx2_permvarv4df_mask */

    case E_V64QImode:
      if (pattern995 (x2, 
E_DImode, 
E_V64QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && (64 == 64 || TARGET_AVX512VL)) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8425; /* avx512bw_permvarv64qi_mask */

    case E_V16QImode:
      if (pattern995 (x2, 
E_HImode, 
E_V16QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && (16 == 64 || TARGET_AVX512VL)) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8427; /* avx512vl_permvarv16qi_mask */

    case E_V32QImode:
      if (pattern995 (x2, 
E_SImode, 
E_V32QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && (32 == 64 || TARGET_AVX512VL)) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8429; /* avx512vl_permvarv32qi_mask */

    case E_V8HImode:
      if (pattern995 (x2, 
E_QImode, 
E_V8HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)) && 
#line 688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8431; /* avx512vl_permvarv8hi_mask */

    case E_V16HImode:
      if (pattern995 (x2, 
E_HImode, 
E_V16HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8433; /* avx512vl_permvarv16hi_mask */

    case E_V32HImode:
      if (pattern995 (x2, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8435; /* avx512bw_permvarv32hi_mask */

    case E_V8HFmode:
      if (pattern996 (x2, 
E_QImode, 
E_V8HFmode, 
E_V8HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)) && 
#line 689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8437; /* avx512fp16_permvarv8hf_mask */

    case E_V16HFmode:
      if (pattern996 (x2, 
E_HImode, 
E_V16HFmode, 
E_V16HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8439; /* avx512vl_permvarv16hf_mask */

    case E_V32HFmode:
      if (pattern996 (x2, 
E_SImode, 
E_V32HFmode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8441; /* avx512bw_permvarv32hf_mask */

    case E_V8BFmode:
      if (pattern996 (x2, 
E_QImode, 
E_V8BFmode, 
E_V8HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL)) && 
#line 690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8443; /* avx512vl_permvarv8bf_mask */

    case E_V16BFmode:
      if (pattern996 (x2, 
E_HImode, 
E_V16BFmode, 
E_V16HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8445; /* avx512vl_permvarv16bf_mask */

    case E_V32BFmode:
      if (pattern996 (x2, 
E_SImode, 
E_V32BFmode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8447; /* avx512bw_permvarv32bf_mask */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern419 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !
#line 32055 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9865; /* vdpphps_v16sf_mask */

        case E_V8SFmode:
          if (pattern419 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !
#line 32055 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9866; /* vdpphps_v8sf_mask */

        case E_V4SFmode:
          if (pattern419 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !
#line 32055 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9867; /* vdpphps_v4sf_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern421 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !
#line 32082 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9868; /* vdpphps_v16sf_maskz_1 */

        case E_V8SFmode:
          if (pattern421 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !
#line 32082 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9869; /* vdpphps_v8sf_maskz_1 */

        case E_V4SFmode:
          if (pattern421 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !
#line 32082 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9870; /* vdpphps_v4sf_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 63:
      switch (pattern398 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2524; /* ieee_maxv32hf3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2531; /* ieee_maxv16hf3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2535; /* ieee_maxv8hf3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2540; /* ieee_maxv16sf3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2547; /* ieee_maxv8sf3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
            return -1;
          return 2551; /* ieee_maxv4sf3_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2556; /* ieee_maxv8df3_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2563; /* ieee_maxv4df3_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2567; /* ieee_maxv2df3_mask */

        case 9:
          if (!(
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2600; /* avx512fp16_ieee_vmmaxv8hf3 */

        case 10:
          if (!
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2608; /* sse_ieee_vmmaxv4sf3 */

        case 11:
          if (!(
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2616; /* sse2_ieee_vmmaxv2df3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern398 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2528; /* ieee_minv32hf3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2533; /* ieee_minv16hf3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2537; /* ieee_minv8hf3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2544; /* ieee_minv16sf3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2549; /* ieee_minv8sf3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
            return -1;
          return 2553; /* ieee_minv4sf3_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2560; /* ieee_minv8df3_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2565; /* ieee_minv4df3_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2569; /* ieee_minv2df3_mask */

        case 9:
          if (!(
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2604; /* avx512fp16_ieee_vmminv8hf3 */

        case 10:
          if (!
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2612; /* sse_ieee_vmminv4sf3 */

        case 11:
          if (!(
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2620; /* sse2_ieee_vmminv2df3 */

        default:
          return -1;
        }

    case 192:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1095 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2640; /* reducepv32hf_mask */

        case E_V16HFmode:
          if (pattern1095 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2644; /* reducepv16hf_mask */

        case E_V8HFmode:
          if (pattern1095 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2648; /* reducepv8hf_mask */

        case E_V16SFmode:
          if (pattern1095 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 2652; /* reducepv16sf_mask */

        case E_V8SFmode:
          if (pattern1095 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 2656; /* reducepv8sf_mask */

        case E_V4SFmode:
          if (pattern1095 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 2660; /* reducepv4sf_mask */

        case E_V8DFmode:
          if (pattern1095 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 2664; /* reducepv8df_mask */

        case E_V4DFmode:
          if (pattern1095 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 2668; /* reducepv4df_mask */

        case E_V2DFmode:
          if (pattern1095 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 2672; /* reducepv2df_mask */

        default:
          return -1;
        }

    case 221:
      switch (pattern400 (x2))
        {
        case 0:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3780; /* avx512bw_fmulc_v32hf_mask */

        case 1:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3788; /* avx512vl_fmulc_v16hf_mask */

        case 2:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3792; /* avx512fp16_fmulc_v8hf_mask */

        case 3:
          if (!
#line 7526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3807; /* avx512fp16_fmulcsh_v8hf */

        default:
          return -1;
        }

    case 222:
      switch (pattern400 (x2))
        {
        case 0:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3784; /* avx512bw_fcmulc_v32hf_mask */

        case 1:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3790; /* avx512vl_fcmulc_v16hf_mask */

        case 2:
          if (!(
#line 106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3794; /* avx512fp16_fcmulc_v8hf_mask */

        case 3:
          if (!
#line 7526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3811; /* avx512fp16_fcmulcsh_v8hf */

        default:
          return -1;
        }

    case 58:
      return recog_114 (x1, insn, pnum_clobbers);

    case 165:
      x7 = XEXP (x2, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 14031 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 6403; /* avx512f_sgetexpv8hf */

        case 1:
          if (!
#line 14031 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 6407; /* avx512f_sgetexpv4sf */

        case 2:
          if (!(
#line 14031 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6411; /* avx512f_sgetexpv2df */

        default:
          return -1;
        }

    case 94:
      return recog_113 (x1, insn, pnum_clobbers);

    case 188:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern403 (x2, 
E_HImode, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (64 == 64 || TARGET_AVX512VL)) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6937; /* avx512bw_pmaddwd512v32hi_mask */

        case E_V8SImode:
          if (pattern403 (x2, 
E_QImode, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (32 == 64 || TARGET_AVX512VL)) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6939; /* avx512bw_pmaddwd512v16hi_mask */

        case E_V4SImode:
          if (pattern403 (x2, 
E_QImode, 
E_V4SImode, 
E_V8HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && (16 == 64 || TARGET_AVX512VL))))
            return -1;
          return 6941; /* avx512bw_pmaddwd512v8hi_mask */

        default:
          return -1;
        }

    case 57:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern994 (x2, 
E_DImode, 
E_V64QImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7657; /* avx512bw_packuswb_mask */

        case E_V32QImode:
          if (pattern994 (x2, 
E_SImode, 
E_V32QImode, 
E_V16HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7659; /* avx2_packuswb_mask */

        case E_V16QImode:
          if (pattern994 (x2, 
E_HImode, 
E_V16QImode, 
E_V8HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 7661; /* sse2_packuswb_mask */

        case E_V32HImode:
          if (pattern994 (x2, 
E_SImode, 
E_V32HImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 8023; /* avx512bw_packusdw_mask */

        case E_V16HImode:
          if (pattern994 (x2, 
E_HImode, 
E_V16HImode, 
E_V8SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 8025; /* avx2_packusdw_mask */

        case E_V8HImode:
          if (pattern994 (x2, 
E_QImode, 
E_V8HImode, 
E_V4SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 8027; /* sse4_1_packusdw_mask */

        default:
          return -1;
        }

    case 190:
      if (pattern401 (x2) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 7787; /* avx512bw_pshuflwv32hi_mask */

    case 189:
      if (pattern401 (x2) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 7793; /* avx512bw_pshufhwv32hi_mask */

    case 187:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern403 (x2, 
E_QImode, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7901; /* avx512bw_pmaddubsw512v8hi_mask */

        case E_V16HImode:
          if (pattern403 (x2, 
E_HImode, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7903; /* avx512bw_pmaddubsw512v16hi_mask */

        case E_V32HImode:
          if (pattern403 (x2, 
E_SImode, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7905; /* avx512bw_pmaddubsw512v32hi_mask */

        default:
          return -1;
        }

    case 52:
      switch (pattern402 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7919; /* avx512bw_pshufbv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7921; /* avx2_pshufbv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
            return -1;
          return 7923; /* ssse3_pshufbv16qi3_mask */

        default:
          return -1;
        }

    case 151:
      return recog_112 (x1, insn, pnum_clobbers);

    case 144:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern997 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8646; /* avx512f_vpermilvarv16sf3_mask */

        case E_V8SFmode:
          if (pattern997 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL)) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8648; /* avx_vpermilvarv8sf3_mask */

        case E_V4SFmode:
          if (pattern997 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (16 == 64 || TARGET_AVX512VL))))
            return -1;
          return 8650; /* avx_vpermilvarv4sf3_mask */

        case E_V8DFmode:
          if (pattern997 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8652; /* avx512f_vpermilvarv8df3_mask */

        case E_V4DFmode:
          if (pattern997 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL)) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8654; /* avx_vpermilvarv4df3_mask */

        case E_V2DFmode:
          if (pattern997 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (16 == 64 || TARGET_AVX512VL)) && 
#line 376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 8656; /* avx_vpermilvarv2df3_mask */

        default:
          return -1;
        }

    case 150:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern901 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8HImode) != 0)
            return -1;
          x7 = XEXP (x2, 2);
          operands[4] = x7;
          if (register_operand (operands[0], E_V8HImode))
            {
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (nonimm_or_0_operand (operands[3], E_V8HImode)
                  && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL)))
                return 8954; /* vcvtps2ph256_mask */
            }
          operands[3] = x7;
          if (!memory_operand (operands[0], E_V8HImode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[0])
              || !(
#line 96 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL)))
            return -1;
          return 8956; /* *vcvtps2ph256_merge_mask */

        case E_V16HImode:
          if (pattern901 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16HImode) != 0)
            return -1;
          x7 = XEXP (x2, 2);
          operands[4] = x7;
          if (register_operand (operands[0], E_V16HImode))
            {
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (nonimm_or_0_operand (operands[3], E_V16HImode)
                  && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29208 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 8959; /* avx512f_vcvtps2ph512_mask */
            }
          operands[3] = x7;
          if (!memory_operand (operands[0], E_V16HImode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[0])
              || !(
#line 96 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8962; /* *avx512f_vcvtps2ph512_merge_mask */

        default:
          return -1;
        }

    case 166:
      return recog_115 (x1, insn, pnum_clobbers);

    case 197:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern998 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9421; /* vpmultishiftqbv64qi_mask */

        case E_V16QImode:
          if (pattern998 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9423; /* vpmultishiftqbv16qi_mask */

        case E_V32QImode:
          if (pattern998 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9425; /* vpmultishiftqbv32qi_mask */

        default:
          return -1;
        }

    case 200:
      switch (pattern402 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 9463; /* vgf2p8mulb_v64qi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 9465; /* vgf2p8mulb_v32qi_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI)))
            return -1;
          return 9467; /* vgf2p8mulb_v16qi_mask */

        default:
          return -1;
        }

    case 249:
      switch (pattern404 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9731; /* vcvt2ph2bf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9739; /* vcvt2ph2bf8v16hf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9747; /* vcvt2ph2bf8v8hf_mask */

        default:
          return -1;
        }

    case 250:
      switch (pattern404 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9733; /* vcvt2ph2bf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9741; /* vcvt2ph2bf8sv16hf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9749; /* vcvt2ph2bf8sv8hf_mask */

        default:
          return -1;
        }

    case 251:
      switch (pattern404 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9735; /* vcvt2ph2hf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9743; /* vcvt2ph2hf8v16hf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9751; /* vcvt2ph2hf8v8hf_mask */

        default:
          return -1;
        }

    case 252:
      switch (pattern404 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9737; /* vcvt2ph2hf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9745; /* vcvt2ph2hf8sv16hf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9753; /* vcvt2ph2hf8sv8hf_mask */

        default:
          return -1;
        }

    case 245:
      switch (pattern406 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9763; /* vcvtbiasph2bf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9771; /* vcvtbiasph2bf8v16hf_mask */

        default:
          return -1;
        }

    case 246:
      switch (pattern406 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9765; /* vcvtbiasph2bf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9773; /* vcvtbiasph2bf8sv16hf_mask */

        default:
          return -1;
        }

    case 247:
      switch (pattern406 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9767; /* vcvtbiasph2hf8v32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9775; /* vcvtbiasph2hf8v16hf_mask */

        default:
          return -1;
        }

    case 248:
      switch (pattern406 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9769; /* vcvtbiasph2hf8sv32hf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9777; /* vcvtbiasph2hf8sv16hf_mask */

        default:
          return -1;
        }

    case 258:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern998 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9872; /* avx10_2_scalefbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern998 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9874; /* avx10_2_scalefbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern998 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9876; /* avx10_2_scalefbf16_v8bf_mask */

        default:
          return -1;
        }

    case 259:
      switch (pattern408 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9986; /* avx10_2_rndscalebf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9992; /* avx10_2_rndscalebf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9998; /* avx10_2_rndscalebf16_v8bf_mask */

        default:
          return -1;
        }

    case 260:
      switch (pattern408 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9988; /* avx10_2_reducebf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9994; /* avx10_2_reducebf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10000; /* avx10_2_reducebf16_v8bf_mask */

        default:
          return -1;
        }

    case 261:
      switch (pattern408 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9990; /* avx10_2_getmantbf16_v32bf_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9996; /* avx10_2_getmantbf16_v16bf_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 10002; /* avx10_2_getmantbf16_v8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_VECTOR
      || XVECLEN (x6, 0) != 32
      || GET_MODE (x6) != E_V32HImode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x6, 0, 4);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x6, 0, 5);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x6, 0, 6);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x6, 0, 7);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x6, 0, 8);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x6, 0, 9);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x6, 0, 10);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x6, 0, 11);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x6, 0, 12);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x6, 0, 13);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x6, 0, 14);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x6, 0, 15);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x6, 0, 16);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x6, 0, 17);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x6, 0, 18);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x6, 0, 19);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x6, 0, 20);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x6, 0, 21);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x6, 0, 22);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x30 = XVECEXP (x6, 0, 23);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x31 = XVECEXP (x6, 0, 24);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x32 = XVECEXP (x6, 0, 25);
  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x33 = XVECEXP (x6, 0, 26);
  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x34 = XVECEXP (x6, 0, 27);
  if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x35 = XVECEXP (x6, 0, 28);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x36 = XVECEXP (x6, 0, 29);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x37 = XVECEXP (x6, 0, 30);
  if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x38 = XVECEXP (x6, 0, 31);
  if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32HImode
      || GET_MODE (x4) != E_V32SImode
      || GET_MODE (x5) != E_V32SImode)
    return -1;
  x39 = XEXP (x5, 0);
  if (GET_MODE (x39) != E_V32SImode)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != E_V32SImode)
    return -1;
  x41 = XEXP (x40, 0);
  if (GET_MODE (x41) != E_V32SImode)
    return -1;
  x42 = XEXP (x40, 1);
  if (GET_MODE (x42) != E_V32SImode)
    return -1;
  x43 = XEXP (x42, 0);
  operands[2] = x43;
  if (!nonimmediate_operand (operands[2], E_V32HImode))
    return -1;
  x44 = XEXP (x2, 1);
  operands[3] = x44;
  if (!nonimm_or_0_operand (operands[3], E_V32HImode))
    return -1;
  x45 = XEXP (x2, 2);
  operands[4] = x45;
  if (!register_operand (operands[4], E_SImode)
      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 22817 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
    return -1;
  return 7907; /* avx512bw_umulhrswv32hi3_mask */
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[4] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern426 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2266; /* *mulv32hf3_mask */

            case E_V16HFmode:
              if (pattern426 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2270; /* *mulv16hf3_mask */

            case E_V8HFmode:
              if (pattern426 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2274; /* *mulv8hf3_mask */

            case E_V16SFmode:
              if (pattern426 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2278; /* *mulv16sf3_mask */

            case E_V8SFmode:
              if (pattern426 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2282; /* *mulv8sf3_mask */

            case E_V4SFmode:
              if (pattern426 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1)))
                return -1;
              return 2286; /* *mulv4sf3_mask */

            case E_V8DFmode:
              if (pattern426 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2290; /* *mulv8df3_mask */

            case E_V4DFmode:
              if (pattern426 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2294; /* *mulv4df3_mask */

            case E_V2DFmode:
              if (pattern426 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2298; /* *mulv2df3_mask */

            case E_V32HImode:
              if (pattern119 (x2, 
E_V32HImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16371 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                return -1;
              return 6907; /* *mulv32hi3_mask */

            case E_V16HImode:
              if (pattern119 (x2, 
E_V16HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16371 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                return -1;
              return 6909; /* *mulv16hi3_mask */

            case E_V8HImode:
              if (pattern119 (x2, 
E_V8HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16371 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
                return -1;
              return 6911; /* *mulv8hi3_mask */

            case E_V8DImode:
              if (pattern426 (x2, 
E_V8DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (64 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V8DImode, operands)) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6945; /* *avx512dq_mulv8di3_mask */

            case E_V4DImode:
              if (pattern426 (x2, 
E_V4DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (32 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V4DImode, operands)) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6947; /* *avx512dq_mulv4di3_mask */

            case E_V2DImode:
              if (pattern426 (x2, 
E_V2DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (16 == 64 || TARGET_AVX512VL)
  && ix86_binary_operator_ok (MULT, V2DImode, operands)) && 
#line 623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6949; /* *avx512dq_mulv2di3_mask */

            case E_V16SImode:
              if (pattern426 (x2, 
E_V16SImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16884 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V16SImode, operands)
  && (64 == 64 || TARGET_AVX512VL)) && 
#line 671 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 6951; /* *avx512f_mulv16si3_mask */

            case E_V8SImode:
              if (pattern426 (x2, 
E_V8SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16884 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V8SImode, operands)
  && (32 == 64 || TARGET_AVX512VL)) && 
#line 671 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                return -1;
              return 6953; /* *avx2_mulv8si3_mask */

            case E_V4SImode:
              if (pattern426 (x2, 
E_V4SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16884 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_binary_operator_ok (MULT, V4SImode, operands)
  && (16 == 64 || TARGET_AVX512VL))))
                return -1;
              return 6955; /* *sse4_1_mulv4si3_mask */

            case E_V32BFmode:
              if (pattern122 (x2, 
E_V32BFmode, 
E_SImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 9894; /* avx10_2_mulbf16_v32bf_mask */

            case E_V16BFmode:
              if (pattern122 (x2, 
E_V16BFmode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 9902; /* avx10_2_mulbf16_v16bf_mask */

            case E_V8BFmode:
              if (pattern122 (x2, 
E_V8BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 9910; /* avx10_2_mulbf16_v8bf_mask */

            default:
              return -1;
            }

        case CONST_INT:
          switch (pattern124 (x2))
            {
            case 0:
              if (!(
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 2306; /* avx512fp16_vmmulv8hf3 */

            case 1:
              if (!
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2314; /* sse_vmmulv4sf3 */

            case 2:
              if (!(
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2322; /* sse2_vmmulv2df3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern274 (x2, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16454 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6925; /* *vec_widen_umult_even_v16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6927; /* *vec_widen_umult_even_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16522 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6929; /* *vec_widen_umult_even_v4si_mask */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern274 (x2, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6931; /* *vec_widen_smult_even_v16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6933; /* *vec_widen_smult_even_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 6935; /* *sse4_1_mulv2siv2di3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 2);
  operands[4] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case NOT:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern916 (x2, 
E_V8SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)) && 
#line 428 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3139; /* avx_andnotv8sf3_mask */

        case E_V4SFmode:
          if (pattern916 (x2, 
E_V4SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16))))
            return -1;
          return 3141; /* sse_andnotv4sf3_mask */

        case E_V4DFmode:
          if (pattern916 (x2, 
E_V4DFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3143; /* avx_andnotv4df3_mask */

        case E_V2DFmode:
          if (pattern916 (x2, 
E_V2DFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3145; /* sse2_andnotv2df3_mask */

        case E_V16SFmode:
          if (pattern917 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 32 != 16)) && 
#line 493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3149; /* avx512f_andnotv16sf3_mask */

        case E_V8DFmode:
          if (pattern917 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 64 != 16)) && 
#line 494 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3151; /* avx512f_andnotv8df3_mask */

        case E_V16SImode:
          if (pattern917 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7341; /* *andnotv16si3_mask */

        case E_V8SImode:
          if (pattern917 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7342; /* *andnotv8si3_mask */

        case E_V4SImode:
          if (pattern917 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7343; /* *andnotv4si3_mask */

        case E_V8DImode:
          if (pattern917 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7344; /* *andnotv8di3_mask */

        case E_V4DImode:
          if (pattern917 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7345; /* *andnotv4di3_mask */

        case E_V2DImode:
          if (pattern917 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 18666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7346; /* *andnotv2di3_mask */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern119 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3165; /* *andv8sf3_mask */

        case E_V4SFmode:
          if (pattern119 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 3171; /* *andv4sf3_mask */

        case E_V4DFmode:
          if (pattern119 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3177; /* *andv4df3_mask */

        case E_V2DFmode:
          if (pattern119 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3183; /* *andv2df3_mask */

        case E_V16SFmode:
          if (pattern120 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3195; /* *andv16sf3_mask */

        case E_V8DFmode:
          if (pattern120 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3201; /* *andv8df3_mask */

        case E_V16SImode:
          if (pattern426 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7348; /* *andv16si3_mask */

        case E_V8SImode:
          if (pattern426 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7354; /* *andv8si3_mask */

        case E_V4SImode:
          if (pattern426 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4SImode, operands))))
            return -1;
          return 7360; /* *andv4si3_mask */

        case E_V8DImode:
          if (pattern426 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 7366; /* *andv8di3_mask */

        case E_V4DImode:
          if (pattern426 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 7372; /* *andv4di3_mask */

        case E_V2DImode:
          if (pattern426 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V2DImode, operands))))
            return -1;
          return 7378; /* *andv2di3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern126 (x2))
    {
    case 0:
      switch (pattern806 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3889; /* avx512fp16_vcvtw2ph_v8hi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3913; /* avx512fp16_vcvtdq2ph_v8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3929; /* avx512fp16_vcvtqq2ph_v8di_mask */

        default:
          return -1;
        }

    case 1:
      switch (pattern807 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3897; /* avx512fp16_vcvtw2ph_v16hi_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3921; /* avx512fp16_vcvtdq2ph_v16si_mask */

        default:
          return -1;
        }

    case 2:
      if (pattern127 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3905; /* avx512fp16_vcvtw2ph_v32hi_mask */

    case 3:
      if (pattern127 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 4192; /* floatv16siv16sf2_mask */

    case 4:
      if (pattern128 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!vector_operand (operands[1], E_V8SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4195; /* floatv8siv8sf2_mask */

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4324; /* floatv8div8sf2_mask */

        default:
          return -1;
        }

    case 5:
      if (pattern128 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!vector_operand (operands[1], E_V4SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 4197; /* floatv4siv4sf2_mask */

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4331; /* floatv4div4sf2_mask */

        default:
          return -1;
        }

    case 6:
      switch (pattern808 (x2, 
E_V8DFmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9151 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL)) && 
#line 467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4295; /* floatv8siv8df2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4300; /* floatv8div8df2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern809 (x2, 
E_V4DFmode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9151 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL))))
            return -1;
          return 4297; /* floatv4siv4df2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4308; /* floatv4div4df2_mask */

        default:
          return -1;
        }

    case 8:
      if (pattern141 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4316; /* floatv2div2df2_mask */

    case 9:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
        return -1;
      return 4349; /* sse2_cvtdq2pd_mask */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern283 (x2))
    {
    case 0:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3815; /* avx512fp16_vcvtph2uw_v32hi */

    case 1:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!vector_operand (operands[1], E_V16HFmode)
              || !(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3823; /* avx512fp16_vcvtph2udq_v16si */

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !(
#line 8697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4218; /* *avx512f_fixuns_notruncv16sfv16si */

        default:
          return -1;
        }

    case 2:
      switch (pattern708 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3831; /* avx512fp16_vcvtph2uqq_v8di */

        case 1:
          if (!(
#line 8730 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4238; /* *avx512dq_cvtps2uqqv8di */

        case 2:
          if (!(
#line 9708 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4440; /* fixuns_notruncv8dfv8di2 */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3839; /* avx512fp16_vcvtph2uw_v16hi */

    case 4:
      switch (pattern708 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3847; /* avx512fp16_vcvtph2udq_v8si */

        case 1:
          if (!(
#line 8697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4222; /* *avx512vl_fixuns_notruncv8sfv8si */

        case 2:
          if (!(
#line 9489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4360; /* fixuns_notruncv8dfv8si2 */

        default:
          return -1;
        }

    case 5:
      switch (pattern709 (x2, 
E_V4DImode))
        {
        case 0:
          if (!(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3855; /* avx512fp16_vcvtph2uqq_v4di */

        case 1:
          if (!(
#line 8730 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4242; /* *avx512dq_cvtps2uqqv4di */

        case 2:
          if (!(
#line 9708 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4444; /* fixuns_notruncv4dfv4di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3863; /* avx512fp16_vcvtph2uw_v8hi */

    case 7:
      switch (pattern709 (x2, 
E_V4SImode))
        {
        case 0:
          if (!(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3871; /* avx512fp16_vcvtph2udq_v4si */

        case 1:
          if (!(
#line 8697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4226; /* *avx512vl_fixuns_notruncv4sfv4si */

        case 2:
          if (!(
#line 9489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4364; /* fixuns_notruncv4dfv4si2 */

        default:
          return -1;
        }

    case 8:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3879; /* avx512fp16_vcvtph2uqq_v2di */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 9708 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4446; /* fixuns_notruncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 8743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4244; /* *avx512dq_cvtps2uqqv2di */

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      return recog_203 (x1, insn, pnum_clobbers);

    case 3:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      switch (XINT (x4, 1))
        {
        case 192:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1282 (x2))
            {
            case 0:
              if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2676; /* reducesv8hf_round */

            case 1:
              if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode)))))
                return -1;
              return 2680; /* reducesv4sf_round */

            case 2:
              if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2684; /* reducesv2df_round */

            default:
              return -1;
            }

        case 133:
          return recog_202 (x1, insn, pnum_clobbers);

        case 217:
          switch (pattern1020 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3734; /* fma_fmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3772; /* avx512bw_fmaddc_v32hf_mask_round */

            case 2:
              if (!(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3797; /* avx512fp16_fma_fmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 219:
          switch (pattern1020 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3738; /* fma_fcmaddc_v32hf_maskz_1_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3774; /* avx512bw_fcmaddc_v32hf_mask_round */

            case 2:
              if (!(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3801; /* avx512fp16_fma_fcmaddcsh_v8hf_round */

            default:
              return -1;
            }

        case 194:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1494 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9254; /* avx512dq_rangepv16sf_mask_round */

                case E_V8DFmode:
                  if (pattern1494 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 9262; /* avx512dq_rangepv8df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1280 (x2, 
E_V4SFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                    return -1;
                  return 9269; /* avx512dq_rangesv4sf_round */

                case E_V2DFmode:
                  if (pattern1280 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 9273; /* avx512dq_rangesv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 166:
          x7 = XEXP (x3, 2);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_15_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1282 (x2))
            {
            case 0:
              if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 9337; /* avx512f_vgetmantv8hf_round */

            case 1:
              if (!
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 9341; /* avx512f_vgetmantv4sf_round */

            case 2:
              if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 9345; /* avx512f_vgetmantv2df_round */

            default:
              return -1;
            }

        case 278:
          x8 = XVECEXP (x4, 0, 2);
          operands[3] = x8;
          if (!const_0_to_255_operand (operands[3], E_SImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x9, E_SImode))
            return -1;
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              x10 = XEXP (x3, 1);
              operands[4] = x10;
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1494 (x2, 
E_V32HFmode, 
E_SImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10184; /* avx10_2_minmaxpv32hf_mask_round */

                case E_V16HFmode:
                  if (pattern1494 (x2, 
E_V16HFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10188; /* avx10_2_minmaxpv16hf_mask_round */

                case E_V8HFmode:
                  if (pattern1494 (x2, 
E_V8HFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10192; /* avx10_2_minmaxpv8hf_mask_round */

                case E_V16SFmode:
                  if (pattern1494 (x2, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10196; /* avx10_2_minmaxpv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1494 (x2, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10200; /* avx10_2_minmaxpv8sf_mask_round */

                case E_V4SFmode:
                  if (pattern1494 (x2, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10204; /* avx10_2_minmaxpv4sf_mask_round */

                case E_V8DFmode:
                  if (pattern1494 (x2, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10208; /* avx10_2_minmaxpv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1494 (x2, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10212; /* avx10_2_minmaxpv4df_mask_round */

                case E_V2DFmode:
                  if (pattern1494 (x2, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10216; /* avx10_2_minmaxpv2df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[4] = x9;
              switch (pattern1281 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 10219; /* avx10_2_minmaxsv8hf_round */

                case 1:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10223; /* avx10_2_minmaxsv4sf_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 10227; /* avx10_2_minmaxsv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_204 (x1, insn, pnum_clobbers);

    case 4:
      if (XINT (x4, 1) != 163)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      x11 = XVECEXP (x4, 0, 3);
      operands[4] = x11;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[5] = x10;
          x7 = XEXP (x3, 2);
          operands[6] = x7;
          operands[7] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1523 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6438; /* avx512f_fixupimmv16sf_maskz_1_round */

            case E_V8SFmode:
              if (pattern1523 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6442; /* avx512vl_fixupimmv8sf_maskz_1_round */

            case E_V4SFmode:
              if (pattern1523 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6446; /* avx512vl_fixupimmv4sf_maskz_1_round */

            case E_V8DFmode:
              if (pattern1523 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6450; /* avx512f_fixupimmv8df_maskz_1_round */

            case E_V4DFmode:
              if (pattern1523 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6454; /* avx512vl_fixupimmv4df_maskz_1_round */

            case E_V2DFmode:
              if (pattern1523 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6458; /* avx512vl_fixupimmv2df_maskz_1_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[5] = x7;
              operands[6] = x9;
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1544 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 6460; /* avx512f_fixupimmv16sf_mask_round */

                case E_V8SFmode:
                  if (pattern1544 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 6462; /* avx512vl_fixupimmv8sf_mask_round */

                case E_V4SFmode:
                  if (pattern1544 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 6464; /* avx512vl_fixupimmv4sf_mask_round */

                case E_V8DFmode:
                  if (pattern1544 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 6466; /* avx512f_fixupimmv8df_mask_round */

                case E_V4DFmode:
                  if (pattern1544 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 6468; /* avx512vl_fixupimmv4df_mask_round */

                case E_V2DFmode:
                  if (pattern1544 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 6470; /* avx512vl_fixupimmv2df_mask_round */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x7, 0) != 1L)
                return -1;
              operands[5] = x9;
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1545 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6472; /* avx512f_sfixupimmv4sf_round */

                case E_V2DFmode:
                  if (pattern1545 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14180 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 6476; /* avx512f_sfixupimmv2df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8232; /* *sse4_1_ptestv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8233; /* *sse4_1_ptestv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8234; /* *sse4_1_ptestv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8235; /* *sse4_1_ptestv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8236; /* *sse4_1_ptestv1ti */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8237; /* *sse4_1_ptestv4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)))
        return -1;
      return 8238; /* *sse4_1_ptestv2df */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8239; /* *avx_ptestv32qi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8240; /* *avx_ptestv16hi */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8241; /* *avx_ptestv8si */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8242; /* *avx_ptestv4di */

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8243; /* *avx_ptestv2ti */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8244; /* *avx_ptestv8sf */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 25306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_match_ptest_ccmode (insn)) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8245; /* *avx_ptestv4df */

    default:
      return -1;
    }
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern714 (x3, 
E_V32HFmode) != 0
          || !(
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 6483; /* avx512bw_rndscalev32hf */

    case E_V16HFmode:
      if (pattern714 (x3, 
E_V16HFmode) != 0
          || !(
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6487; /* avx512vl_rndscalev16hf */

    case E_V8HFmode:
      if (pattern714 (x3, 
E_V8HFmode) != 0
          || !(
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6491; /* avx512fp16_rndscalev8hf */

    case E_V16SFmode:
      if (pattern714 (x3, 
E_V16SFmode) != 0
          || !(
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6495; /* avx512f_rndscalev16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6499; /* avx512vl_rndscalev8sf */
      if (!vector_operand (operands[1], E_V8SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8261; /* avx_roundps256 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6503; /* avx512vl_rndscalev4sf */
      if (!vector_operand (operands[1], E_V4SFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !
#line 25467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return -1;
      return 8262; /* sse4_1_roundps */

    case E_V8DFmode:
      if (pattern714 (x3, 
E_V8DFmode) != 0
          || !(
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6507; /* avx512f_rndscalev8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6511; /* avx512vl_rndscalev4df */
      if (!vector_operand (operands[1], E_V4DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8263; /* avx_roundpd256 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 6515; /* avx512vl_rndscalev2df */
      if (!vector_operand (operands[1], E_V2DFmode)
          || !const_0_to_15_operand (operands[2], E_SImode)
          || !(
#line 25467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8264; /* sse4_1_roundpd */

    default:
      return -1;
    }
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2638; /* *reducepv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2642; /* *reducepv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2646; /* *reducepv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2650; /* *reducepv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2654; /* *reducepv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2658; /* *reducepv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2662; /* *reducepv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2666; /* *reducepv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2670; /* *reducepv2df */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      if (register_operand (operands[0], E_V8HImode)
          && 
#line 29157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return 8953; /* vcvtps2ph256 */
      if (!memory_operand (operands[0], E_V8HImode)
          || !
#line 29169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
        return -1;
      return 8955; /* *vcvtps2ph256 */

    case E_V16HImode:
      if (GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      if (register_operand (operands[0], E_V16HImode)
          && 
#line 29208 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return 8957; /* *avx512f_vcvtps2ph512 */
      if (!memory_operand (operands[0], E_V16HImode)
          || !
#line 29220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8961; /* *avx512f_vcvtps2ph512 */

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  switch (pattern965 (x2, 
E_V16QImode))
    {
    case 0:
      if (!(
#line 22451 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
        return -1;
      return 7873; /* *sse2_maskmovdqu */

    case 1:
      if (!(
#line 22451 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
        return -1;
      return 7874; /* *sse2_maskmovdqu */

    default:
      return -1;
    }
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x4))
    {
    case LT:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (pattern591 (x3))
        {
        case 0:
          if ((
#line 3364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2518; /* *minmaxv8sf3_2 */
          break;

        case 1:
          if (
#line 3364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
            return 2519; /* *minmaxv4sf3_2 */
          break;

        case 2:
          if ((
#line 3364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 2520; /* *minmaxv4df3_2 */
          break;

        case 3:
          if ((
#line 3364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 2521; /* *minmaxv2df3_2 */
          break;

        case 4:
          if ((
#line 23571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7983; /* *avx_blendvps256_lt */
          break;

        case 5:
          if (
#line 23571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 7984; /* *sse4_1_blendvps_lt */
          break;

        case 6:
          if ((
#line 23571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7985; /* *avx_blendvpd256_lt */
          break;

        case 7:
          if ((
#line 23571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 7986; /* *sse4_1_blendvpd_lt */
          break;

        case 8:
          if ((
#line 23901 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 8030; /* *avx2_pblendvb_lt */
          break;

        case 9:
          if (
#line 23901 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 8031; /* *sse4_1_pblendvb_lt */
          break;

        default:
          break;
        }
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SUBREG)
        return -1;
      switch (pattern593 (x3))
        {
        case 0:
          if (!(
#line 23951 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
   && ix86_pre_reload_split ()) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8034; /* *avx2_pblendvb_lt_subreg_not */

        case 1:
          if (!
#line 23951 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
   && ix86_pre_reload_split ()))
            return -1;
          return 8035; /* *sse4_1_pblendvb_lt_subreg_not */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern931 (x3, 
E_V8SFmode) == 0
              && (
#line 23507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7977; /* avx_blendvps256 */
          break;

        case E_V4SFmode:
          if (pattern931 (x3, 
E_V4SFmode) == 0
              && 
#line 23507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 7978; /* sse4_1_blendvps */
          break;

        case E_V4DFmode:
          if (pattern931 (x3, 
E_V4DFmode) == 0
              && (
#line 23507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7979; /* avx_blendvpd256 */
          break;

        case E_V2DFmode:
          if (pattern931 (x3, 
E_V2DFmode) == 0
              && (
#line 23507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 7980; /* sse4_1_blendvpd */
          break;

        default:
          break;
        }
      operands[1] = x5;
      operands[2] = x7;
      if (GET_CODE (x4) == SUBREG
          && known_eq (SUBREG_BYTE (x4), 0))
        {
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case LT:
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              switch (pattern1106 (x3))
                {
                case 0:
                  if (
#line 23631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 7991; /* *sse4_1_blendvps_ltint */
                  break;

                case 1:
                  if (
#line 23631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 7992; /* *sse4_1_blendvpd_ltint */
                  break;

                case 2:
                  if ((
#line 23631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 7993; /* *avx_blendvps256_ltint */
                  break;

                case 3:
                  if ((
#line 23631 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 7994; /* *avx_blendvpd256_ltint */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x8) == SUBREG)
                {
                  switch (pattern1107 (x3))
                    {
                    case 0:
                      if (
#line 23698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                        return 7999; /* *sse4_1_blendvps_not_ltint */
                      break;

                    case 1:
                      if (
#line 23698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                        return 8000; /* *sse4_1_blendvpd_not_ltint */
                      break;

                    case 2:
                      if ((
#line 23698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                        return 8001; /* *avx_blendvps256_not_ltint */
                      break;

                    case 3:
                      if ((
#line 23698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                        return 8002; /* *avx_blendvpd256_not_ltint */
                      break;

                    default:
                      break;
                    }
                }
              break;

            case GT:
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              switch (pattern1108 (x3))
                {
                case 0:
                  if (
#line 23663 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 7995; /* *sse4_1_blendvps_gtint */
                  break;

                case 1:
                  if (
#line 23663 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return 7996; /* *sse4_1_blendvpd_gtint */
                  break;

                case 2:
                  if ((
#line 23663 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 7997; /* *avx_blendvps256_gtint */
                  break;

                case 3:
                  if ((
#line 23663 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 7998; /* *avx_blendvpd256_gtint */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x8) == SUBREG)
                {
                  switch (pattern1109 (x3))
                    {
                    case 0:
                      if (
#line 23724 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                        return 8003; /* *sse4_1_blendvps_not_gtint */
                      break;

                    case 1:
                      if (
#line 23724 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()))
                        return 8004; /* *sse4_1_blendvpd_not_gtint */
                      break;

                    case 2:
                      if ((
#line 23724 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                        return 8005; /* *avx_blendvps256_not_gtint */
                      break;

                    case 3:
                      if ((
#line 23724 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                        return 8006; /* *avx_blendvpd256_not_gtint */
                      break;

                    default:
                      break;
                    }
                }
              break;

            default:
              break;
            }
        }
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern931 (x3, 
E_V32QImode) != 0
              || !(
#line 23850 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8028; /* avx2_pblendvb */

        case E_V16QImode:
          if (pattern931 (x3, 
E_V16QImode) != 0
              || !
#line 23850 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8029; /* sse4_1_pblendvb */

        default:
          return -1;
        }

    case GT:
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (pattern596 (x3))
        {
        case 0:
          if ((
#line 23597 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7987; /* *avx_blendvps256_gt */
          break;

        case 1:
          if (
#line 23597 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 7988; /* *sse4_1_blendvps_gt */
          break;

        case 2:
          if ((
#line 23597 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 7989; /* *avx_blendvpd256_gt */
          break;

        case 3:
          if ((
#line 23597 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 7990; /* *sse4_1_blendvpd_gt */
          break;

        case 4:
          if ((
#line 23925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return 8032; /* *avx2_pblendvb_gt */
          break;

        case 5:
          if (
#line 23925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 8033; /* *sse4_1_pblendvb_gt */
          break;

        default:
          break;
        }
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SUBREG)
        return -1;
      switch (pattern598 (x3))
        {
        case 0:
          if (!(
#line 23973 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
   && ix86_pre_reload_split ()) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8036; /* *avx2_pblendvb_gt_subreg_not */

        case 1:
          if (!
#line 23973 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
   && ix86_pre_reload_split ()))
            return -1;
          return 8037; /* *sse4_1_pblendvb_gt_subreg_not */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9531; /* vpshldv_v32hi */

    case 1:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9532; /* vpshldv_v16si */

    case 2:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9533; /* vpshldv_v8di */

    case 3:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9534; /* vpshldv_v16hi */

    case 4:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9535; /* vpshldv_v8si */

    case 5:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9536; /* vpshldv_v4di */

    case 6:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9537; /* vpshldv_v8hi */

    case 7:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9538; /* vpshldv_v4si */

    case 8:
      if (!(
#line 30465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9539; /* vpshldv_v2di */

    default:
      return -1;
    }
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      if (pattern144 (x3, 
E_V32QImode) != 0)
        return -1;
      if ((
#line 23785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 8014; /* avx2_mpsadbw */
      if (!(
#line 23819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8018; /* *avx2_mpsadbw */

    case E_V16QImode:
      if (pattern144 (x3, 
E_V16QImode) != 0)
        return -1;
      if (
#line 23785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return 8015; /* sse4_1_mpsadbw */
      if (!
#line 23819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8020; /* *sse4_1_mpsadbw */

    case E_V64QImode:
      if (pattern144 (x3, 
E_V64QImode) != 0
          || !
#line 23807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 8016; /* avx10_2_mpsadbw */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 175:
      return recog_221 (x1, insn, pnum_clobbers);

    case 178:
      return recog_214 (x1, insn, pnum_clobbers);

    case 63:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2522; /* ieee_maxv32hf3 */

        case 1:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2530; /* ieee_maxv16hf3 */

        case 2:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2534; /* ieee_maxv8hf3 */

        case 3:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2538; /* ieee_maxv16sf3 */

        case 4:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2546; /* ieee_maxv8sf3 */

        case 5:
          if (!
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2550; /* ieee_maxv4sf3 */

        case 6:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2554; /* ieee_maxv8df3 */

        case 7:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2562; /* ieee_maxv4df3 */

        case 8:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2566; /* ieee_maxv2df3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2526; /* ieee_minv32hf3 */

        case 1:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2532; /* ieee_minv16hf3 */

        case 2:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2536; /* ieee_minv8hf3 */

        case 3:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2542; /* ieee_minv16sf3 */

        case 4:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2548; /* ieee_minv8sf3 */

        case 5:
          if (!
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2552; /* ieee_minv4sf3 */

        case 6:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2558; /* ieee_minv8df3 */

        case 7:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2564; /* ieee_minv4df3 */

        case 8:
          if (!(
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2568; /* ieee_minv2df3 */

        default:
          return -1;
        }

    case 192:
      return recog_220 (x1, insn, pnum_clobbers);

    case 221:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3779; /* avx512bw_fmulc_v32hf */

        case 1:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3787; /* avx512vl_fmulc_v16hf */

        case 2:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3791; /* avx512fp16_fmulc_v8hf */

        default:
          return -1;
        }

    case 222:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3783; /* avx512bw_fcmulc_v32hf */

        case 1:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3789; /* avx512vl_fcmulc_v16hf */

        case 2:
          if (!(
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3793; /* avx512fp16_fcmulc_v8hf */

        default:
          return -1;
        }

    case 58:
      return recog_222 (x1, insn, pnum_clobbers);

    case 94:
      return recog_217 (x1, insn, pnum_clobbers);

    case 188:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern154 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6936; /* avx512bw_pmaddwd512v32hi */

        case E_V8SImode:
          if (pattern154 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6938; /* avx512bw_pmaddwd512v16hi */

        case E_V4SImode:
          if (pattern154 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 16657 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1))
            return -1;
          return 6940; /* avx512bw_pmaddwd512v8hi */

        default:
          return -1;
        }

    case 57:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern672 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7656; /* avx512bw_packuswb */

        case E_V32QImode:
          if (pattern672 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7658; /* avx2_packuswb */

        case E_V16QImode:
          if (pattern672 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 19362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7660; /* sse2_packuswb */

        case E_V32HImode:
          if (pattern672 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8022; /* avx512bw_packusdw */

        case E_V16HImode:
          if (pattern672 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8024; /* avx2_packusdw */

        case E_V8HImode:
          if (pattern672 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 23831 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return -1;
          return 8026; /* sse4_1_packusdw */

        default:
          return -1;
        }

    case 190:
      if (pattern148 (x1) != 0
          || !
#line 20701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7786; /* *avx512bw_pshuflwv32hi */

    case 189:
      if (pattern148 (x1) != 0
          || !
#line 20877 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7792; /* *avx512bw_pshufhwv32hi */

    case 56:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DImode:
          if (pattern715 (x2, 
E_V64QImode, 
E_V8DImode) != 0
              || !(
#line 21904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7841; /* *avx512f_psadbw */

        case E_V4DImode:
          if (pattern715 (x2, 
E_V32QImode, 
E_V4DImode) != 0
              || !(
#line 21904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7842; /* *avx2_psadbw */

        case E_V2DImode:
          if (pattern715 (x2, 
E_V16QImode, 
E_V2DImode) != 0
              || !
#line 21904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 7843; /* *sse2_psadbw */

        default:
          return -1;
        }

    case 187:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern154 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7900; /* avx512bw_pmaddubsw512v8hi */

        case E_V16HImode:
          if (pattern154 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7902; /* avx512bw_pmaddubsw512v16hi */

        case E_V32HImode:
          if (pattern154 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 22782 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7904; /* avx512bw_pmaddubsw512v32hi */

        default:
          return -1;
        }

    case 52:
      switch (pattern149 (x1))
        {
        case 0:
          if (!(
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7918; /* avx512bw_pshufbv64qi3 */

        case 1:
          if (!(
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7920; /* avx2_pshufbv32qi3 */

        case 2:
          if (!
#line 23107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1))
            return -1;
          return 7922; /* ssse3_pshufbv16qi3 */

        default:
          return -1;
        }

    case 120:
      return recog_225 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern150 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 23437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 7970; /* sse4a_extrq */

    case 125:
      if (pattern71 (x1, 
E_V2DImode) != 0
          || !
#line 23463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 7972; /* sse4a_insertq */

    case 130:
      return recog_216 (x1, insn, pnum_clobbers);

    case 137:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27088 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8375; /* aesenc */

    case 138:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8376; /* aesenclast */

    case 139:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27124 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8377; /* aesdec */

    case 140:
      if (pattern151 (x1, 
E_V2DImode) != 0
          || !
#line 27142 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8378; /* aesdeclast */

    case 142:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vector_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode)
          || !
#line 27172 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AES))
        return -1;
      return 8380; /* aeskeygenassist */

    case 151:
      return recog_218 (x1, insn, pnum_clobbers);

    case 144:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern718 (x2, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8645; /* avx512f_vpermilvarv16sf3 */

        case E_V8SFmode:
          if (pattern718 (x2, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8647; /* avx_vpermilvarv8sf3 */

        case E_V4SFmode:
          if (pattern718 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 8649; /* avx_vpermilvarv4sf3 */

        case E_V8DFmode:
          if (pattern718 (x2, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8651; /* avx512f_vpermilvarv8df3 */

        case E_V4DFmode:
          if (pattern718 (x2, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8653; /* avx_vpermilvarv4df3 */

        case E_V2DFmode:
          if (pattern718 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 28112 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8655; /* avx_vpermilvarv2df3 */

        default:
          return -1;
        }

    case 47:
      return recog_223 (x1, insn, pnum_clobbers);

    case 150:
      return recog_224 (x1, insn, pnum_clobbers);

    case 160:
      return recog_215 (x1, insn, pnum_clobbers);

    case 166:
      return recog_219 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9377; /* sha1msg1 */

    case 180:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9378; /* sha1msg2 */

    case 181:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29970 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9379; /* sha1nexte */

    case 183:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 29994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9381; /* sha256msg1 */

    case 184:
      if (pattern151 (x1, 
E_V4SImode) != 0
          || !
#line 30005 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9382; /* sha256msg2 */

    case 239:
      if (pattern150 (x1, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 30067 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9387; /* vsha512msg1 */

    case 240:
      if (pattern71 (x1, 
E_V4DImode) != 0
          || !
#line 30078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9388; /* vsha512msg2 */

    case 242:
      switch (pattern152 (x1))
        {
        case 0:
          if (!(
#line 30101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9390; /* vsm4key4_v16si */

        case 1:
          if (!
#line 30101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9391; /* vsm4key4_v8si */

        case 2:
          if (!
#line 30101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9392; /* vsm4key4_v4si */

        default:
          return -1;
        }

    case 243:
      switch (pattern152 (x1))
        {
        case 0:
          if (!(
#line 30114 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9393; /* vsm4rnds4_v16si */

        case 1:
          if (!
#line 30114 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9394; /* vsm4rnds4_v8si */

        case 2:
          if (!
#line 30114 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9395; /* vsm4rnds4_v4si */

        default:
          return -1;
        }

    case 197:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern64 (x2, 
E_V64QImode) != 0
              || !(
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9420; /* vpmultishiftqbv64qi */

        case E_V16QImode:
          if (pattern64 (x2, 
E_V16QImode) != 0
              || !(
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9422; /* vpmultishiftqbv16qi */

        case E_V32QImode:
          if (pattern64 (x2, 
E_V32QImode) != 0
              || !(
#line 30260 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9424; /* vpmultishiftqbv32qi */

        default:
          return -1;
        }

    case 200:
      switch (pattern149 (x1))
        {
        case 0:
          if (!(
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9462; /* vgf2p8mulb_v64qi */

        case 1:
          if (!(
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9464; /* vgf2p8mulb_v32qi */

        case 2:
          if (!
#line 30369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 9466; /* vgf2p8mulb_v16qi */

        default:
          return -1;
        }

    case 209:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30845 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9594; /* vaesdec_v32qi */

        case 1:
          if (!(
#line 30845 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9595; /* vaesdec_v16qi */

        case 2:
          if (!(
#line 30845 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9596; /* vaesdec_v64qi */

        default:
          return -1;
        }

    case 210:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30863 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9597; /* vaesdeclast_v32qi */

        case 1:
          if (!(
#line 30863 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9598; /* vaesdeclast_v16qi */

        case 2:
          if (!(
#line 30863 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9599; /* vaesdeclast_v64qi */

        default:
          return -1;
        }

    case 211:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9600; /* vaesenc_v32qi */

        case 1:
          if (!(
#line 30881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9601; /* vaesenc_v16qi */

        case 2:
          if (!(
#line 30881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9602; /* vaesenc_v64qi */

        default:
          return -1;
        }

    case 212:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 30899 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9603; /* vaesenclast_v32qi */

        case 1:
          if (!(
#line 30899 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9604; /* vaesenclast_v16qi */

        case 2:
          if (!(
#line 30899 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9605; /* vaesenclast_v64qi */

        default:
          return -1;
        }

    case 249:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9730; /* vcvt2ph2bf8v32hf */

        case 1:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9738; /* vcvt2ph2bf8v16hf */

        case 2:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9746; /* vcvt2ph2bf8v8hf */

        default:
          return -1;
        }

    case 250:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9732; /* vcvt2ph2bf8sv32hf */

        case 1:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9740; /* vcvt2ph2bf8sv16hf */

        case 2:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9748; /* vcvt2ph2bf8sv8hf */

        default:
          return -1;
        }

    case 251:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9734; /* vcvt2ph2hf8v32hf */

        case 1:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9742; /* vcvt2ph2hf8v16hf */

        case 2:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9750; /* vcvt2ph2hf8v8hf */

        default:
          return -1;
        }

    case 252:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9736; /* vcvt2ph2hf8sv32hf */

        case 1:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9744; /* vcvt2ph2hf8sv16hf */

        case 2:
          if (!
#line 31736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9752; /* vcvt2ph2hf8sv8hf */

        default:
          return -1;
        }

    case 245:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9762; /* vcvtbiasph2bf8v32hf */

        case 1:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9770; /* vcvtbiasph2bf8v16hf */

        default:
          return -1;
        }

    case 246:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9764; /* vcvtbiasph2bf8sv32hf */

        case 1:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9772; /* vcvtbiasph2bf8sv16hf */

        default:
          return -1;
        }

    case 247:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9766; /* vcvtbiasph2hf8v32hf */

        case 1:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9774; /* vcvtbiasph2hf8v16hf */

        default:
          return -1;
        }

    case 248:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9768; /* vcvtbiasph2hf8sv32hf */

        case 1:
          if (!
#line 31825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9776; /* vcvtbiasph2hf8sv16hf */

        default:
          return -1;
        }

    case 258:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern64 (x2, 
E_V32BFmode) != 0
              || !
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9871; /* avx10_2_scalefbf16_v32bf */

        case E_V16BFmode:
          if (pattern64 (x2, 
E_V16BFmode) != 0
              || !
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9873; /* avx10_2_scalefbf16_v16bf */

        case E_V8BFmode:
          if (pattern64 (x2, 
E_V8BFmode) != 0
              || !
#line 32092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9875; /* avx10_2_scalefbf16_v8bf */

        default:
          return -1;
        }

    case 259:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9985; /* avx10_2_rndscalebf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9991; /* avx10_2_rndscalebf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9997; /* avx10_2_rndscalebf16_v8bf */

        default:
          return -1;
        }

    case 260:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9987; /* avx10_2_reducebf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9993; /* avx10_2_reducebf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9999; /* avx10_2_reducebf16_v8bf */

        default:
          return -1;
        }

    case 261:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9989; /* avx10_2_getmantbf16_v32bf */

        case 1:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9995; /* avx10_2_getmantbf16_v16bf */

        case 2:
          if (!
#line 32433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 10001; /* avx10_2_getmantbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (register_operand (operands[1], E_V4SFmode)
                  && (
#line 11699 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 4606; /* avx2_vec_dupv8sf */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8493; /* avx512vl_vec_dupv8sf */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !
#line 11711 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 4608; /* avx2_vec_dupv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 11699 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 4607; /* avx2_vec_dupv4sf */
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8495; /* avx512vl_vec_dupv4sf */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !(
#line 11723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4609; /* avx512f_vec_dupv16sf_1 */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8491; /* avx512f_vec_dupv16sf */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x2) != E_V8DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 11723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4610; /* avx512f_vec_dupv8df_1 */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8497; /* avx512f_vec_dupv8df */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 577 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 8384; /* avx2_pbroadcastv16si */
              if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8479; /* avx512f_vec_dupv16si */

            case E_V16SImode:
              if (!nonimmediate_operand (operands[1], E_V16SImode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8473; /* avx512f_vec_dupv16si_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 578 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 8385; /* avx2_pbroadcastv8di */
              if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8485; /* avx512f_vec_dupv8di */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8474; /* avx512f_vec_dupv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x2) != E_V64QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8386; /* avx2_pbroadcastv64qi */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8503; /* avx512bw_vec_dupv64qi */

            case E_V64QImode:
              if (!nonimmediate_operand (operands[1], E_V64QImode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8476; /* avx512bw_vec_dupv64qi_1 */

            default:
              return -1;
            }

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8387; /* avx2_pbroadcastv32qi */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8507; /* avx512vl_vec_dupv32qi */

            case E_V32QImode:
              if (!nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8402; /* avx2_pbroadcastv32qi_1 */

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern842 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8388; /* avx2_pbroadcastv16qi */
          if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8505; /* avx512vl_vec_dupv16qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x2) != E_V32HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8389; /* avx2_pbroadcastv32hi */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8509; /* avx512bw_vec_dupv32hi */

            case E_V32HImode:
              if (!nonimmediate_operand (operands[1], E_V32HImode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 977 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8475; /* avx512bw_vec_dupv32hi_1 */

            default:
              return -1;
            }

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8390; /* avx2_pbroadcastv16hi */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8511; /* avx512vl_vec_dupv16hi */

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8403; /* avx2_pbroadcastv16hi_1 */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern842 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8391; /* avx2_pbroadcastv8hi */
          if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8513; /* avx512vl_vec_dupv8hi */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 581 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8392; /* avx2_pbroadcastv8si */
              if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8481; /* avx512vl_vec_dupv8si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8404; /* avx2_pbroadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern842 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8393; /* avx2_pbroadcastv4si */
          if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8483; /* avx512vl_vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 582 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8394; /* avx2_pbroadcastv4di */
              if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8487; /* avx512vl_vec_dupv4di */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8405; /* avx2_pbroadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern842 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8395; /* avx2_pbroadcastv2di */
          if (!(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8489; /* avx512vl_vec_dupv2di */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x2) != E_V32HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8396; /* avx2_pbroadcastv32hf */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8515; /* avx512bw_vec_dupv32hf */

            case E_V32HFmode:
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8477; /* avx512bw_vec_dupv32hf_1 */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8397; /* avx2_pbroadcastv16hf */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8517; /* avx512vl_vec_dupv16hf */

            case E_V16HFmode:
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8406; /* avx2_pbroadcastv16hf_1 */

            default:
              return -1;
            }

        case E_V8HFmode:
          if (pattern842 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8398; /* avx2_pbroadcastv8hf */
          if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8519; /* avx512fp16_vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x2) != E_V32BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8399; /* avx2_pbroadcastv32bf */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8521; /* avx512bw_vec_dupv32bf */

            case E_V32BFmode:
              if (!nonimmediate_operand (operands[1], E_V32BFmode)
                  || !(
#line 27690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 980 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 8478; /* avx512bw_vec_dupv32bf_1 */

            default:
              return -1;
            }

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 8400; /* avx2_pbroadcastv16bf */
              if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8523; /* avx512vl_vec_dupv16bf */

            case E_V16BFmode:
              if (!nonimmediate_operand (operands[1], E_V16BFmode)
                  || !
#line 27287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8407; /* avx2_pbroadcastv16bf_1 */

            default:
              return -1;
            }

        case E_V8BFmode:
          if (pattern842 (x2, 
E_V8BFmode, 
E_BFmode) != 0)
            return -1;
          if (
#line 27273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8401; /* avx2_pbroadcastv8bf */
          if (!(
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8525; /* avx512vl_vec_dupv8bf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (register_operand (operands[1], E_V2DFmode)
              && 
#line 27678 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8472; /* avx2_vec_dupv4df */
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8499; /* avx512vl_vec_dupv4df */

        case E_V2DFmode:
          if (pattern842 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8501; /* avx512vl_vec_dupv2df */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern838 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V16SImode) != 0
              || !(
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8613; /* *avx512dq_broadcastv16si */

        case E_V8SImode:
          if (pattern838 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V8SImode) != 0
              || !(
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8615; /* *avx512dq_broadcastv8si */

        case E_V4SImode:
          if (pattern842 (x2, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8617; /* *avx512dq_broadcastv4si */

        case E_V16SFmode:
          if (pattern838 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V16SFmode) != 0
              || !(
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8619; /* *avx512dq_broadcastv16sf */

        case E_V8SFmode:
          if (pattern838 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V8SFmode) != 0
              || !(
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8621; /* *avx512dq_broadcastv8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5192; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5219; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5246; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5273; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5300; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5327; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5354; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5381; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5408; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5435; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5462; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5489; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5195; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5222; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5249; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5276; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5303; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5330; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5357; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5384; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5411; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5438; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5465; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5492; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5198; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5225; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5252; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5279; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5306; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5333; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5360; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5387; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5414; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5441; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5468; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5495; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6260; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6269; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6278; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6287; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6296; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6305; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6314; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6323; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6332; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6341; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6350; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6359; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5840; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5867; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5894; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5921; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5948; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5975; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6002; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6029; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6056; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6083; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6110; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6137; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5843; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5870; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5897; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5924; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5951; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5978; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6005; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6032; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6059; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6086; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6113; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6140; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5846; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5873; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5900; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5927; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5954; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5981; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6008; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6035; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6062; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6089; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6116; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6143; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          res = recog_266 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XVECLEN (x3, 0) < 1)
            return -1;
          operands[4] = x3;
          switch (pattern740 (x2))
            {
            case 0:
              if (
#line 24143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8052; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 1:
              if (
#line 24143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8053; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 2:
              if (
#line 24143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8054; /* *avx2_zero_extendv16qiv16hi2_2 */
              break;

            case 3:
              if ((
#line 24196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8060; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 4:
              if ((
#line 24196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8061; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 5:
              if ((
#line 24196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 953 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8062; /* *avx512bw_zero_extendv32qiv32hi2_2 */
              break;

            case 6:
              if (
#line 24307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8076; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 7:
              if (
#line 24307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8077; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 8:
              if (
#line 24307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8078; /* *sse4_1_zero_extendv8qiv8hi2_4 */
              break;

            case 9:
              if ((
#line 24540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8112; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 10:
              if ((
#line 24540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8113; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 11:
              if ((
#line 24540 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8114; /* *avx512f_zero_extendv16hiv16si2_2 */
              break;

            case 12:
              if (
#line 24594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8120; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 13:
              if (
#line 24594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8121; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 14:
              if (
#line 24594 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return 8122; /* *avx2_zero_extendv8hiv8si2_2 */
              break;

            case 15:
              if (
#line 24712 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8136; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            case 16:
              if (
#line 24712 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8137; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            case 17:
              if (
#line 24712 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return 8138; /* *sse4_1_zero_extendv4hiv4si2_4 */
              break;

            default:
              break;
            }
          operands[3] = x3;
          switch (pattern741 (x2))
            {
            case 0:
              if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8916; /* *vec_concatv64qi_0_1 */

            case 1:
              if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8917; /* *vec_concatv32qi_0_1 */

            case 2:
              if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 8918; /* *vec_concatv16qi_0_1 */

            case 3:
              if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 8919; /* *vec_concatv32hi_0_1 */

            case 4:
              if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8920; /* *vec_concatv16hi_0_1 */

            case 5:
              if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 8921; /* *vec_concatv8hi_0_1 */

            default:
              return -1;
            }

        case SS_TRUNCATE:
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != SS_TRUNCATE)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (XVECLEN (x3, 0))
            {
            case 32:
              if (pattern762 (x3) != 0)
                return -1;
              x10 = XVECEXP (x3, 0, 4);
              if (GET_CODE (x10) != CONST_INT)
                return -1;
              x11 = XVECEXP (x3, 0, 5);
              if (GET_CODE (x11) != CONST_INT)
                return -1;
              x12 = XVECEXP (x3, 0, 6);
              if (GET_CODE (x12) != CONST_INT)
                return -1;
              x13 = XVECEXP (x3, 0, 7);
              if (GET_CODE (x13) != CONST_INT)
                return -1;
              x14 = XVECEXP (x3, 0, 8);
              if (GET_CODE (x14) != CONST_INT)
                return -1;
              x15 = XVECEXP (x3, 0, 9);
              if (GET_CODE (x15) != CONST_INT)
                return -1;
              x16 = XVECEXP (x3, 0, 10);
              if (GET_CODE (x16) != CONST_INT)
                return -1;
              x17 = XVECEXP (x3, 0, 11);
              if (GET_CODE (x17) != CONST_INT
                  || pattern1536 (x3, 
23, 
22, 
21, 
20, 
8) != 0)
                return -1;
              x18 = XVECEXP (x3, 0, 17);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
                return -1;
              x19 = XVECEXP (x3, 0, 18);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
                return -1;
              x20 = XVECEXP (x3, 0, 19);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
                return -1;
              x21 = XVECEXP (x3, 0, 20);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x22 = XVECEXP (x3, 0, 21);
              if (GET_CODE (x22) != CONST_INT)
                return -1;
              x23 = XVECEXP (x3, 0, 22);
              if (GET_CODE (x23) != CONST_INT)
                return -1;
              x24 = XVECEXP (x3, 0, 23);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XVECEXP (x3, 0, 24);
              if (GET_CODE (x25) != CONST_INT)
                return -1;
              x26 = XVECEXP (x3, 0, 25);
              if (GET_CODE (x26) != CONST_INT)
                return -1;
              x27 = XVECEXP (x3, 0, 26);
              if (GET_CODE (x27) != CONST_INT)
                return -1;
              x28 = XVECEXP (x3, 0, 27);
              if (GET_CODE (x28) != CONST_INT
                  || pattern1704 (x3, 
31, 
30, 
29, 
28) != 0)
                return -1;
              switch (XWINT (x10, 0))
                {
                case 4L:
                  if (XWINT (x11, 0) != 5L
                      || XWINT (x12, 0) != 6L
                      || XWINT (x13, 0) != 7L
                      || XWINT (x14, 0) != 16L
                      || XWINT (x15, 0) != 17L
                      || XWINT (x16, 0) != 18L
                      || XWINT (x17, 0) != 19L
                      || XWINT (x21, 0) != 12L
                      || XWINT (x22, 0) != 13L
                      || XWINT (x23, 0) != 14L
                      || XWINT (x24, 0) != 15L
                      || pattern1728 (x3) != 0
                      || pattern1659 (x2, 
E_V16HImode, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 19232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                    return -1;
                  return 7646; /* avx2_packsswb */

                case 16L:
                  if (XWINT (x11, 0) != 17L
                      || XWINT (x12, 0) != 18L
                      || XWINT (x13, 0) != 19L
                      || XWINT (x14, 0) != 4L
                      || XWINT (x15, 0) != 5L
                      || XWINT (x16, 0) != 6L
                      || XWINT (x17, 0) != 7L
                      || XWINT (x21, 0) != 24L
                      || XWINT (x22, 0) != 25L
                      || XWINT (x23, 0) != 26L
                      || XWINT (x24, 0) != 27L
                      || XWINT (x25, 0) != 12L
                      || XWINT (x26, 0) != 13L
                      || XWINT (x27, 0) != 14L
                      || XWINT (x28, 0) != 15L
                      || pattern1659 (x2, 
E_V16SImode, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 19348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
                    return -1;
                  return 7654; /* avx512bw_packssdw */

                default:
                  return -1;
                }

            case 64:
              if (pattern765 (x3, 
35, 
34, 
33, 
32) != 0
                  || pattern1536 (x3, 
39, 
38, 
37, 
36, 
8) != 0
                  || pattern1642 (x3, 
13, 
12, 
11, 
10, 
9) != 0
                  || pattern1687 (x3, 
42, 
41, 
40, 
15, 
14) != 0)
                return -1;
              x28 = XVECEXP (x3, 0, 27);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 43]
                  || pattern1704 (x3, 
47, 
46, 
45, 
44) != 0)
                return -1;
              x29 = XVECEXP (x3, 0, 32);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x30 = XVECEXP (x3, 0, 33);
              if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
                return -1;
              x31 = XVECEXP (x3, 0, 34);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
                return -1;
              x32 = XVECEXP (x3, 0, 35);
              if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
                return -1;
              x33 = XVECEXP (x3, 0, 36);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
                return -1;
              x34 = XVECEXP (x3, 0, 37);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
                return -1;
              x35 = XVECEXP (x3, 0, 38);
              if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
                return -1;
              x36 = XVECEXP (x3, 0, 39);
              if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                return -1;
              x37 = XVECEXP (x3, 0, 40);
              if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 48])
                return -1;
              x38 = XVECEXP (x3, 0, 41);
              if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 49])
                return -1;
              x39 = XVECEXP (x3, 0, 42);
              if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 50])
                return -1;
              x40 = XVECEXP (x3, 0, 43);
              if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 51])
                return -1;
              x41 = XVECEXP (x3, 0, 44);
              if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 52])
                return -1;
              x42 = XVECEXP (x3, 0, 45);
              if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 53])
                return -1;
              x43 = XVECEXP (x3, 0, 46);
              if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 54])
                return -1;
              x44 = XVECEXP (x3, 0, 47);
              if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 55])
                return -1;
              x45 = XVECEXP (x3, 0, 48);
              if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
                return -1;
              x46 = XVECEXP (x3, 0, 49);
              if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
                return -1;
              x47 = XVECEXP (x3, 0, 50);
              if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
                return -1;
              x48 = XVECEXP (x3, 0, 51);
              if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
                return -1;
              x49 = XVECEXP (x3, 0, 52);
              if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
                return -1;
              x50 = XVECEXP (x3, 0, 53);
              if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
                return -1;
              x51 = XVECEXP (x3, 0, 54);
              if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
                return -1;
              x52 = XVECEXP (x3, 0, 55);
              if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
                return -1;
              x53 = XVECEXP (x3, 0, 56);
              if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + 56])
                return -1;
              x54 = XVECEXP (x3, 0, 57);
              if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 57])
                return -1;
              x55 = XVECEXP (x3, 0, 58);
              if (x55 != const_int_rtx[MAX_SAVED_CONST_INT + 58])
                return -1;
              x56 = XVECEXP (x3, 0, 59);
              if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 59])
                return -1;
              x57 = XVECEXP (x3, 0, 60);
              if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 60])
                return -1;
              x58 = XVECEXP (x3, 0, 61);
              if (x58 != const_int_rtx[MAX_SAVED_CONST_INT + 61])
                return -1;
              x59 = XVECEXP (x3, 0, 62);
              if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 62])
                return -1;
              x60 = XVECEXP (x3, 0, 63);
              if (x60 != const_int_rtx[MAX_SAVED_CONST_INT + 63]
                  || pattern1659 (x2, 
E_V32HImode, 
E_V32QImode, 
E_V64QImode) != 0
                  || !
#line 19279 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
                return -1;
              return 7648; /* avx512bw_packsswb */

            case 16:
              if (pattern763 (x3, 
10, 
9, 
8) != 0
                  || pattern1363 (x3, 
7, 
6, 
5, 
4, 
11) != 0
                  || pattern1659 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 19318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
                return -1;
              return 7652; /* avx2_packssdw */

            default:
              return -1;
            }

        case VEC_CONCAT:
          switch (pattern459 (x2))
            {
            case 0:
              if (!
#line 25095 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 8207; /* *avx512f_zero_extendv8siv8di2_2 */

            case 1:
              if (!
#line 25147 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8213; /* *avx2_zero_extendv4siv4di2_2 */

            case 2:
              if (!
#line 25243 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8227; /* *sse4_1_zero_extendv2siv2di2_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      res = recog_280 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern461 (x2))
        {
        case 0:
          if (!
#line 15021 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 6584; /* *avx512bw_permvar_truncv16siv16hi_1_hf */

        case 1:
          if (!
#line 15074 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()))
            return -1;
          return 6586; /* *avx512f_permvar_truncv8siv8hi_1_hf */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          switch (pattern463 (x2))
            {
            case 0:
              if (!
#line 14996 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 6583; /* *avx512bw_permvar_truncv16siv16hi_1 */

            case 1:
              if (!
#line 15258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512VBMI
   && ix86_pre_reload_split ()))
                return -1;
              return 6616; /* *avx512f_permvar_truncv16hiv16qi_1 */

            case 2:
              if (!
#line 15053 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW && ix86_pre_reload_split ()))
                return -1;
              return 6585; /* *avx512f_permvar_truncv8siv8hi_1 */

            case 3:
              if (!
#line 15105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 6587; /* *avx512f_vpermvar_truncv8div8si_1 */

            case 4:
              if (!
#line 15177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512 && ix86_pre_reload_split ()))
                return -1;
              return 6603; /* *avx512f_permvar_truncv32hiv32qi_1 */

            case 5:
              if (!
#line 15277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()))
                return -1;
              return 6617; /* *avx512f_permvar_truncv4div4si_1 */

            default:
              return -1;
            }

        case 1:
          if (XINT (x5, 1) != 149
              || GET_MODE (x5) != E_V8SFmode
              || XVECLEN (x3, 0) != 4
              || pattern762 (x3) != 0
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          x61 = XVECEXP (x5, 0, 0);
          operands[1] = x61;
          if (!register_operand (operands[1], E_V8HImode)
              || !
#line 29067 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_F16C || TARGET_AVX512VL))
            return -1;
          return 8940; /* vcvtph2ps */

        case 4:
          if (pnum_clobbers == NULL
              || XINT (x5, 1) != 153)
            return -1;
          x62 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x62) != MEM)
            return -1;
          x63 = XEXP (x62, 0);
          if (GET_CODE (x63) != UNSPEC
              || XVECLEN (x63, 0) != 3
              || XINT (x63, 1) != 154)
            return -1;
          x64 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x64) != MEM
              || GET_MODE (x64) != E_BLKmode)
            return -1;
          x65 = XEXP (x64, 0);
          if (GET_CODE (x65) != SCRATCH
              || XVECLEN (x3, 0) != 4
              || pattern762 (x3) != 0)
            return -1;
          x66 = XVECEXP (x63, 0, 1);
          if (!register_operand (x66, E_V4DImode))
            return -1;
          x67 = XVECEXP (x63, 0, 2);
          if (!const1248_operand (x67, E_SImode))
            return -1;
          x61 = XVECEXP (x5, 0, 0);
          switch (GET_CODE (x61))
            {
            case REG:
            case SUBREG:
              operands[2] = x61;
              operands[7] = x62;
              x68 = XVECEXP (x63, 0, 0);
              operands[3] = x68;
              operands[4] = x66;
              operands[6] = x67;
              x69 = XVECEXP (x5, 0, 3);
              operands[5] = x69;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  switch (pattern1681 (x2, 
E_V4SImode, 
E_SImode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9027; /* *avx2_gatherdiv8si_3 */

                    case 1:
                      if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9029; /* *avx2_gatherdiv8si_3 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1681 (x2, 
E_V4SFmode, 
E_SFmode, 
E_V8SFmode))
                    {
                    case 0:
                      if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9028; /* *avx2_gatherdiv8sf_3 */

                    case 1:
                      if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9030; /* *avx2_gatherdiv8sf_3 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case PC:
              operands[6] = x62;
              x68 = XVECEXP (x63, 0, 0);
              operands[2] = x68;
              operands[3] = x66;
              operands[5] = x67;
              x69 = XVECEXP (x5, 0, 3);
              operands[4] = x69;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  switch (pattern1676 (x2, 
E_V4SImode, 
E_SImode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9031; /* *avx2_gatherdiv8si_4 */

                    case 1:
                      if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9033; /* *avx2_gatherdiv8si_4 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1676 (x2, 
E_V4SFmode, 
E_SFmode, 
E_V8SFmode))
                    {
                    case 0:
                      if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9032; /* *avx2_gatherdiv8sf_4 */

                    case 1:
                      if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9034; /* *avx2_gatherdiv8sf_4 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      return recog_255 (x1, insn, pnum_clobbers);

    case NEG:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x5) != E_V4SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3367; /* *fma_fnmadd_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3387; /* *fma_fnmadd_v4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x5) != E_V2DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3368; /* *fma_fnmadd_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3396; /* *fma_fnmadd_v2df */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || GET_MODE (x5) != E_V8SFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3369; /* *fma_fnmadd_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3385; /* *fma_fnmadd_v8sf */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x3) != E_V4DFmode
                  || GET_MODE (x5) != E_V4DFmode)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3370; /* *fma_fnmadd_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3394; /* *fma_fnmadd_v4df */

            case E_V32HFmode:
              if (pattern789 (x3, 
E_V32HFmode) != 0
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3371; /* *fma_fnmadd_v32hf */

            case E_V16HFmode:
              if (pattern789 (x3, 
E_V16HFmode) != 0
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3375; /* *fma_fnmadd_v16hf */

            case E_V8HFmode:
              if (pattern789 (x3, 
E_V8HFmode) != 0
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3377; /* *fma_fnmadd_v8hf */

            case E_V16SFmode:
              if (pattern789 (x3, 
E_V16SFmode) != 0
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3381; /* *fma_fnmadd_v16sf */

            case E_V8DFmode:
              if (pattern789 (x3, 
E_V8DFmode) != 0
                  || !(
#line 6155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3390; /* *fma_fnmadd_v8df */

            case E_V32BFmode:
              if (pattern836 (x3, 
E_V32BFmode) != 0
                  || !
#line 32206 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9925; /* avx10_2_fnmaddbf16_v32bf */

            case E_V16BFmode:
              if (pattern836 (x3, 
E_V16BFmode) != 0
                  || !
#line 32206 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9927; /* avx10_2_fnmaddbf16_v16bf */

            case E_V8BFmode:
              if (pattern836 (x3, 
E_V8BFmode) != 0
                  || !
#line 32206 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9929; /* avx10_2_fnmaddbf16_v8bf */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern790 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3426; /* *fma_fnmsub_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3458; /* *fma_fnmsub_v4sf */

            case E_V2DFmode:
              if (pattern790 (x3, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3430; /* *fma_fnmsub_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3467; /* *fma_fnmsub_v2df */

            case E_V8SFmode:
              if (pattern790 (x3, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3434; /* *fma_fnmsub_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3456; /* *fma_fnmsub_v8sf */

            case E_V4DFmode:
              if (pattern790 (x3, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3438; /* *fma_fnmsub_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3465; /* *fma_fnmsub_v4df */

            case E_V32HFmode:
              if (pattern791 (x3, 
E_V32HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3442; /* *fma_fnmsub_v32hf */

            case E_V16HFmode:
              if (pattern791 (x3, 
E_V16HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3446; /* *fma_fnmsub_v16hf */

            case E_V8HFmode:
              if (pattern791 (x3, 
E_V8HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3448; /* *fma_fnmsub_v8hf */

            case E_V16SFmode:
              if (pattern791 (x3, 
E_V16SFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3452; /* *fma_fnmsub_v16sf */

            case E_V8DFmode:
              if (pattern791 (x3, 
E_V8DFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3461; /* *fma_fnmsub_v8df */

            case E_V32BFmode:
              if (pattern837 (x3, 
E_V32BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9949; /* avx10_2_fnmsubbf16_v32bf */

            case E_V16BFmode:
              if (pattern837 (x3, 
E_V16BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9951; /* avx10_2_fnmsubbf16_v16bf */

            case E_V8BFmode:
              if (pattern837 (x3, 
E_V8BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9953; /* avx10_2_fnmsubbf16_v8bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern454 (x3))
            {
            case 0:
              if (!(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3887; /* avx512fp16_vcvtw2ph_v8hi */

            case 1:
              if (!(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3911; /* avx512fp16_vcvtdq2ph_v8si */

            case 2:
              if (!(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3927; /* avx512fp16_vcvtqq2ph_v8di */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern455 (x3))
            {
            case 0:
              if (!(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3895; /* avx512fp16_vcvtw2ph_v16hi */

            case 1:
              if (!(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3919; /* avx512fp16_vcvtdq2ph_v16si */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x3) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HImode)
              || !(
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3903; /* avx512fp16_vcvtw2ph_v32hi */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode
              || !vector_operand (operands[1], E_V16SImode)
              || !(
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4190; /* floatv16siv16sf2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!vector_operand (operands[1], E_V8SImode)
                  || !(
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4194; /* floatv8siv8sf2 */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4322; /* floatv8div8sf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!vector_operand (operands[1], E_V4SImode)
                  || !
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
                return -1;
              return 4196; /* floatv4siv4sf2 */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4330; /* floatv4div4sf2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SImode:
              if (!nonimmediate_operand (operands[1], E_V2SImode)
                  || !
#line 8857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4270; /* sse2_cvtpi2pd */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4314; /* floatv2div2df2 */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern456 (x3, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 9151 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4294; /* floatv8siv8df2 */

            case 1:
              if (!(
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4298; /* floatv8div8df2 */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern457 (x3, 
E_V4DFmode))
            {
            case 0:
              if (!
#line 9151 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
                return -1;
              return 4296; /* floatv4siv4df2 */

            case 1:
              if (!(
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4306; /* floatv4div4df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 8:
          if (pattern605 (x5) != 0
              || pattern838 (x3, 
E_V16SImode, 
E_V8SImode, 
E_V8DFmode) != 0
              || !
#line 9352 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4346; /* avx512f_cvtdq2pd512_2 */

        case 4:
          if (pattern606 (x5, 
3, 
2, 
1) != 0
              || pattern838 (x3, 
E_V8SImode, 
E_V4SImode, 
E_V4DFmode) != 0
              || !
#line 9365 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 4347; /* avx_cvtdq2pd256_2 */

        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern838 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DFmode) != 0
              || !
#line 9377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4348; /* sse2_cvtdq2pd */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2383; /* avx512fp16_sqrtv32hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2387; /* avx512fp16_sqrtv16hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2389; /* avx512fp16_sqrtv8hf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2391; /* avx512f_sqrtv16sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2395; /* avx_sqrtv8sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1))
        return -1;
      return 2397; /* sse_sqrtv4sf2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2399; /* avx512f_sqrtv8df2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2403; /* avx_sqrtv4df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2405; /* sse2_sqrtv2df2 */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x3) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9967; /* avx10_2_sqrtbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x3) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9969; /* avx10_2_sqrtbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9971; /* avx10_2_sqrtbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_323 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern35 (x1))
    {
    case 0:
      if (!
#line 24108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8047; /* avx2_sign_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24162 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8055; /* avx512bw_sign_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8067; /* *sse4_1_sign_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8079; /* *avx512f_sign_extendv16qiv16si2 */

    case 4:
      if (!
#line 24500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8107; /* avx512f_sign_extendv16hiv16si2 */

    case 5:
      if (!
#line 24389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8087; /* *avx2_sign_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24553 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8115; /* avx2_sign_extendv8hiv8si2 */

    case 7:
      if (!
#line 24450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8099; /* *sse4_1_sign_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8127; /* *sse4_1_sign_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8143; /* *avx512f_sign_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8174; /* avx512f_sign_extendv8hiv8di2 */

    case 11:
      if (!
#line 25062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8202; /* avx512f_sign_extendv8siv8di2 */

    case 12:
      if (!
#line 24812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8155; /* *avx2_sign_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24955 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8182; /* *avx2_sign_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8208; /* avx2_sign_extendv4siv4di2 */

    case 15:
      if (!
#line 24874 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8167; /* *sse4_1_sign_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8194; /* *sse4_1_sign_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8218; /* *sse4_1_sign_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern475 (x2))
        {
        case 0:
          if (
#line 24220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8063; /* sse4_1_sign_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24378 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8083; /* avx2_sign_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24744 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8139; /* avx512f_sign_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8095; /* sse4_1_sign_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8123; /* sse4_1_sign_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24801 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8151; /* avx2_sign_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24944 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8178; /* avx2_sign_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8163; /* sse4_1_sign_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8190; /* sse4_1_sign_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8214; /* sse4_1_sign_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (pattern615 (x2))
        {
        case 0:
          if (!
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8071; /* *sse4_1_sign_extendv8qiv8hi2_2 */

        case 1:
          if (!
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8091; /* *avx2_sign_extendv8qiv8si2_2 */

        case 2:
          if (!
#line 24772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 8147; /* *avx512f_sign_extendv8qiv8di2_2 */

        case 3:
          if (!
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8131; /* *sse4_1_sign_extendv4hiv4si2_2 */

        case 4:
          if (!
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8186; /* *avx2_sign_extendv4hiv4di2_2 */

        case 5:
          if (!
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8222; /* *sse4_1_sign_extendv2siv2di2_2 */

        case 6:
          if (!
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8103; /* *sse4_1_sign_extendv4qiv4si2_2 */

        case 7:
          if (!
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8159; /* *avx2_sign_extendv4qiv4di2_2 */

        case 8:
          if (!
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8198; /* *sse4_1_sign_extendv2hiv2di2_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7104; /* *avx2_uminv32qi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7183; /* *avx512bw_uminv32qi3 */

    case 1:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7108; /* *avx2_uminv16hi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7199; /* *avx512bw_uminv16hi3 */

    case 2:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7112; /* *avx2_uminv8si3 */
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7127; /* *avx512f_uminv8si3 */

    case 3:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7119; /* *avx512f_uminv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7135; /* *avx512f_uminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7225; /* *sse4_1_uminv4si3 */

    case 5:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7143; /* *avx512f_uminv8di3 */

    case 6:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7151; /* *avx512f_uminv4di3 */

    case 7:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7159; /* *avx512f_uminv2di3 */

    case 8:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7167; /* *avx512bw_uminv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7175; /* *avx512bw_uminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17900 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7228; /* *uminv16qi3 */

    case 10:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7191; /* *avx512bw_uminv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7207; /* *avx512bw_uminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7221; /* *sse4_1_uminv8hi3 */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7053; /* avx512f_rolvv16si */

    case 1:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7057; /* avx512vl_rolvv8si */

    case 2:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7061; /* avx512vl_rolvv4si */

    case 3:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7065; /* avx512f_rolvv8di */

    case 4:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7069; /* avx512vl_rolvv4di */

    case 5:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7073; /* avx512vl_rolvv2di */

    case 6:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7077; /* avx512f_rolv16si */

    case 7:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7081; /* avx512vl_rolv8si */

    case 8:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7085; /* avx512vl_rolv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8328; /* xop_rotlv4si3 */

    case 9:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7089; /* avx512f_rolv8di */

    case 10:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7093; /* avx512vl_rolv4di */

    case 11:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7097; /* avx512vl_rolv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8329; /* xop_rotlv2di3 */

    case 12:
      if (!
#line 26589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8326; /* xop_rotlv16qi3 */

    case 13:
      if (!
#line 26589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8327; /* xop_rotlv8hi3 */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 105:
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!push_operand (operands[0], E_TImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3928 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2 && TARGET_APX_PPX))
        return -1;
      return 136; /* push2p_di */

    case 40:
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          if (XWINT (x8, 0) == 0L)
            {
              res = recog_343 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x6) != E_CCOmode
              || GET_MODE (x3) != E_CCOmode)
            return -1;
          operands[2] = x8;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (pattern1507 (x9, 
E_QImode) != 0
                  || !
#line 14545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands)
   && mode_signbit_p (QImode, operands[2])))
                return -1;
              return 801; /* *negvqi3 */

            case E_HImode:
              if (pattern1507 (x9, 
E_HImode) != 0
                  || !
#line 14545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands)
   && mode_signbit_p (HImode, operands[2])))
                return -1;
              return 802; /* *negvhi3 */

            case E_SImode:
              if (pattern1507 (x9, 
E_SImode) != 0
                  || !
#line 14545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands)
   && mode_signbit_p (SImode, operands[2])))
                return -1;
              return 803; /* *negvsi3 */

            case E_DImode:
              if (pattern1507 (x9, 
E_DImode) != 0
                  || !(
#line 14545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands)
   && mode_signbit_p (DImode, operands[2])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 804; /* *negvdi3 */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x8, 0) != 0L)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET
              || GET_MODE (x6) != E_CCCmode
              || GET_MODE (x3) != E_CCCmode)
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              x14 = XEXP (x9, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XEXP (x9, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              return 1143; /* lshrsi3_carry */

            case ASHIFTRT:
              x14 = XEXP (x9, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XEXP (x9, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              return 1144; /* ashrsi3_carry */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 98:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern348 (x4) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 21754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      return 1275; /* bmi_bextr_si */

    case 66:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_XFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_XFmode)
          || !
#line 24147 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1381; /* atan2xf3 */

    case 67:
      if (pattern481 (x1) != 0
          || !
#line 24450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1382; /* fyl2xxf3_i387 */

    case 68:
      if (pattern481 (x1) != 0
          || !
#line 24547 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1383; /* fyl2xp1xf3_i387 */

    case 84:
      if (GET_MODE (x3) != E_XFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern746 (x9, 
E_XFmode, 
85, 
2, 
UNSPEC) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_XFmode)
          || pattern1294 (x1) != 0
          || !
#line 24682 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1386; /* fscalexf4_i387 */

    case 93:
      if (GET_MODE (x3) != E_CCZmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!flags_reg_operand (operands[0], E_CCZmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!memory_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !scratch_operand (operands[3], E_SImode)
              || !
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return -1;
          return 1523; /* stack_protect_test_1_si */

        case E_DImode:
          if (!memory_operand (operands[1], E_DImode)
              || !memory_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return -1;
          return 1524; /* stack_protect_test_1_di */

        default:
          return -1;
        }

    case 63:
      if (pattern482 (x1) != 0
          || !
#line 890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1631; /* mmx_ieee_maxv2sf3 */

    case 62:
      if (pattern482 (x1) != 0
          || !
#line 890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 1632; /* mmx_ieee_minv2sf3 */

    case 160:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      operands[5] = x6;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != UNSPEC
          || XVECLEN (x15, 0) != 4
          || XINT (x15, 1) != 154)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x16 = XVECEXP (x15, 0, 0);
      operands[0] = x16;
      x17 = XVECEXP (x15, 0, 1);
      operands[2] = x17;
      x18 = XVECEXP (x15, 0, 2);
      operands[4] = x18;
      if (!const1248_operand (operands[4], E_SImode))
        return -1;
      x19 = XVECEXP (x15, 0, 3);
      operands[6] = x19;
      x8 = XVECEXP (x3, 0, 1);
      operands[3] = x8;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x7, operands[6]))
        return -1;
      switch (GET_MODE (operands[5]))
        {
        case E_V16SImode:
          if (!vsib_mem_operator (operands[5], E_V16SImode)
              || GET_MODE (x3) != E_V16SImode)
            return -1;
          switch (GET_MODE (x15))
            {
            case E_SImode:
              switch (pattern1613 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9131; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9155; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1613 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9143; /* *avx512f_scattersiv16si */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9167; /* *avx512f_scatterdiv16si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!vsib_mem_operator (operands[5], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode)
            return -1;
          switch (GET_MODE (x15))
            {
            case E_SImode:
              switch (pattern1614 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9132; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9156; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1614 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9144; /* *avx512f_scattersiv16sf */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9168; /* *avx512f_scatterdiv16sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8DImode:
          switch (pattern1557 (x2, 
E_V8DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9133; /* *avx512f_scattersiv8di */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9157; /* *avx512f_scatterdiv8di */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9145; /* *avx512f_scattersiv8di */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9169; /* *avx512f_scatterdiv8di */

            default:
              return -1;
            }

        case E_V8DFmode:
          switch (pattern1557 (x2, 
E_V8DFmode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9134; /* *avx512f_scattersiv8df */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9158; /* *avx512f_scatterdiv8df */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9146; /* *avx512f_scattersiv8df */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9170; /* *avx512f_scatterdiv8df */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern1558 (x2, 
E_V8SImode))
            {
            case 0:
              switch (pattern1660 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9135; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9159; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1660 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9147; /* *avx512f_scattersiv8si */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9171; /* *avx512f_scatterdiv8si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V8SFmode:
          switch (pattern1558 (x2, 
E_V8SFmode))
            {
            case 0:
              switch (pattern1661 (
E_SImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9136; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9160; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            case 1:
              switch (pattern1661 (
E_DImode))
                {
                case 0:
                  if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9148; /* *avx512f_scattersiv8sf */

                case 1:
                  if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9172; /* *avx512f_scatterdiv8sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern1560 (x2, 
E_V4DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9137; /* *avx512f_scattersiv4di */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9161; /* *avx512f_scatterdiv4di */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9149; /* *avx512f_scattersiv4di */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9173; /* *avx512f_scatterdiv4di */

            default:
              return -1;
            }

        case E_V4DFmode:
          switch (pattern1560 (x2, 
E_V4DFmode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9138; /* *avx512f_scattersiv4df */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9162; /* *avx512f_scatterdiv4df */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9150; /* *avx512f_scattersiv4df */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9174; /* *avx512f_scatterdiv4df */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern1562 (x2, 
E_V4SImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9139; /* *avx512f_scattersiv4si */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9163; /* *avx512f_scatterdiv4si */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9151; /* *avx512f_scattersiv4si */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9175; /* *avx512f_scatterdiv4si */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1562 (x2, 
E_V4SFmode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9140; /* *avx512f_scattersiv4sf */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9164; /* *avx512f_scatterdiv4sf */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9152; /* *avx512f_scattersiv4sf */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9176; /* *avx512f_scatterdiv4sf */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern1562 (x2, 
E_V2DImode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9141; /* *avx512f_scattersiv2di */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9165; /* *avx512f_scatterdiv2di */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9153; /* *avx512f_scattersiv2di */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9177; /* *avx512f_scatterdiv2di */

            default:
              return -1;
            }

        case E_V2DFmode:
          switch (pattern1562 (x2, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9142; /* *avx512f_scattersiv2df */

            case 1:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9166; /* *avx512f_scatterdiv2df */

            case 2:
              if (!(
#line 29589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && ((((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9154; /* *avx512f_scattersiv2df */

            case 3:
              if (!(
#line 29629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && (((
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9178; /* *avx512f_scatterdiv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern192 (x1))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern635 (x1))
        {
        case 0:
          if ((
#line 16584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 913; /* *lshrdi3_doubleword_mask */
          break;

        case 1:
          if ((
#line 16584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 915; /* *lshrti3_doubleword_mask */
          break;

        case 2:
          if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
            return 2090; /* klshiftrtqi */
          break;

        case 3:
          if (
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return 2092; /* klshiftrthi */
          break;

        case 4:
          if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2094; /* klshiftrtsi */
          break;

        case 5:
          if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return 2096; /* klshiftrtdi */
          break;

        default:
          break;
        }
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern636 (x1))
        {
        case 0:
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x4) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && register_operand (operands[1], E_DImode))
                    return 921; /* lshrdi3_doubleword */
                  if (nonimmediate_operand (operands[0], E_DImode)
                      && nonimmediate_operand (operands[1], E_DImode)
                      && (
#line 17387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 956; /* *lshrdi3_1 */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 17387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
                return 954; /* *lshrsi3_1 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && GET_MODE (x4) == E_QImode
                  && nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 17563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return 982; /* *lshrqi3_1 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 17601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return 984; /* *lshrhi3_1 */
              break;

            case E_V2QImode:
              if (register_operand (operands[0], E_V2QImode)
                  && GET_MODE (x4) == E_V2QImode
                  && register_operand (operands[1], E_V2QImode)
                  && 
#line 4007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return 1748; /* lshrv2qi3 */
              break;

            default:
              break;
            }
          break;

        case 1:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          switch (pattern323 (x4))
            {
            case 0:
              if (
#line 17640 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 985; /* *lshrqi3_1_slp */
              break;

            case 1:
              if (
#line 17640 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 987; /* *lshrhi3_1_slp */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern639 (x1))
        {
        case 0:
          if (!
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          return 1010; /* *lshrsi3_mask */

        case 1:
          if (!(
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1013; /* *lshrdi3_mask */

        case 2:
          if (!
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1022; /* *lshrsi3_add */

        case 3:
          if (!(
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1025; /* *lshrdi3_add */

        case 4:
          if (!
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1034; /* *lshrsi3_sub */

        case 5:
          if (!(
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1037; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case 1:
      if (register_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 16645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 917; /* *lshrdi3_doubleword_mask_1 */
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !(
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1019; /* *lshrdi3_mask_1 */

    case 2:
      if (!(
#line 16645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 919; /* *lshrti3_doubleword_mask_1 */

    case 3:
      if (!
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
        return -1;
      return 1016; /* *lshrsi3_mask_1 */

    case 4:
      if (!
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1028; /* *lshrsi3_add_1 */

    case 5:
      if (!(
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1031; /* *lshrdi3_add_1 */

    case 6:
      if (!
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      return 1040; /* *lshrsi3_sub_1 */

    case 7:
      if (!(
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 1043; /* *lshrdi3_sub_1 */

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          res = recog_339 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          res = recog_341 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          res = recog_347 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTEND:
          res = recog_350 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSIGNED_FIX:
          res = recog_351 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case FIX:
          res = recog_352 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case FLOAT:
          res = recog_353 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSIGNED_FLOAT:
          res = recog_354 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PLUS:
          res = recog_356 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case COMPARE:
          res = recog_364 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
              if (GET_CODE (x3) == EQ)
                {
                  res = recog_365 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[1] = x3;
              switch (pattern503 (x1))
                {
                case 0:
                  if ((
#line 2387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                    return 2114; /* *kortest_cmpqi_setcc */
                  break;

                case 1:
                  if (
#line 2387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                    return 2115; /* *kortest_cmphi_setcc */
                  break;

                case 2:
                  if (
#line 2387 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                    return 2116; /* *kortest_cmpsi_setcc */
                  break;

                default:
                  break;
                }
              break;

            case GT:
              if (pattern318 (x1) == 0
                  && 
#line 1214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
                return 1642; /* mmx_gtv2sf3 */
              break;

            case GE:
              if (pattern318 (x1) == 0
                  && 
#line 1225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW))
                return 1643; /* mmx_gev2sf3 */
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (pattern319 (x1))
            {
            case 0:
              if (
#line 19517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                return 1193; /* *setcc_hi_1_and */
              break;

            case 1:
              if (
#line 19517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL
   && TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
                return 1194; /* *setcc_si_1_and */
              break;

            default:
              break;
            }
          break;

        case MINUS:
          res = recog_368 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IF_THEN_ELSE:
          res = recog_370 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MULT:
          res = recog_371 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case DIV:
          if (pnum_clobbers != NULL)
            {
              switch (pattern209 (x1))
                {
                case 0:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern522 (x1, 
E_HImode) == 0
                          && 
#line 1191 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                        {
                          *pnum_clobbers = 1;
                          return 531; /* *divmodhi4 */
                        }
                      break;

                    case E_SImode:
                      if (pattern522 (x1, 
E_SImode) == 0)
                        {
                          *pnum_clobbers = 1;
                          return 532; /* *divmodsi4 */
                        }
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (const_int_operand (operands[2], E_SImode)
                      && pattern1354 (x1) == 0
                      && 
#line 11907 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 545; /* *divmodsi4_const */
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case UDIV:
          if (pnum_clobbers != NULL)
            {
              switch (pattern210 (x1))
                {
                case 0:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern522 (x1, 
E_HImode) == 0
                          && 
#line 1191 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                        {
                          *pnum_clobbers = 1;
                          return 533; /* *udivmodhi4 */
                        }
                      break;

                    case E_SImode:
                      if (pattern522 (x1, 
E_SImode) == 0)
                        {
                          *pnum_clobbers = 1;
                          return 534; /* *udivmodsi4 */
                        }
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern1355 (x1, 
E_SImode) == 0
                          && 
#line 11660 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
                        {
                          *pnum_clobbers = 1;
                          return 535; /* *udivmodsi4_pow2 */
                        }
                      break;

                    case E_DImode:
                      if (pattern1355 (x1, 
E_DImode) == 0
                          && (
#line 11660 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 536; /* *udivmoddi4_pow2 */
                        }
                      break;

                    default:
                      break;
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        case IOR:
          res = recog_372 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_374 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          res = recog_375 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NOT:
          res = recog_376 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NEG:
          res = recog_377 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ABS:
          res = recog_378 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ASHIFT:
          res = recog_379 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LSHIFTRT:
          res = recog_380 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ASHIFTRT:
          res = recog_382 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ROTATE:
          switch (pattern200 (x1))
            {
            case 0:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) == SUBREG)
                {
                  switch (pattern1054 (x2))
                    {
                    case 0:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
                        return 1048; /* *rotlqi3_mask */
                      break;

                    case 1:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
                        return 1050; /* *rotlhi3_mask */
                      break;

                    case 2:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return 1052; /* *rotlsi3_mask */
                      break;

                    case 3:
                      if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1054; /* *rotldi3_mask */
                      break;

                    case 4:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1064; /* *rotlqi3_add */
                      break;

                    case 5:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1066; /* *rotlhi3_add */
                      break;

                    case 6:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1068; /* *rotlsi3_add */
                      break;

                    case 7:
                      if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1070; /* *rotldi3_add */
                      break;

                    case 8:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1080; /* *rotlqi3_sub */
                      break;

                    case 9:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1082; /* *rotlhi3_sub */
                      break;

                    case 10:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1084; /* *rotlsi3_sub */
                      break;

                    case 11:
                      if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1086; /* *rotldi3_sub */
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x4;
              switch (pattern1055 (x2))
                {
                case 0:
                  if (
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && true))
                    return 1103; /* *rotlsi3_1 */
                  break;

                case 1:
                  if ((
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1107; /* *rotldi3_1 */
                  break;

                case 2:
                  if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands, TARGET_APX_NDD)
   && true))
                    return 1131; /* *rotlqi3_1 */
                  break;

                case 3:
                  if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands, TARGET_APX_NDD)
   && true))
                    return 1135; /* *rotlhi3_1 */
                  break;

                case 4:
                  if (
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1138; /* *rotlqi3_1_slp */
                  break;

                case 5:
                  if (
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1140; /* *rotlhi3_1_slp */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
                return 1056; /* *rotlqi3_mask_1 */
              break;

            case 2:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
                return 1058; /* *rotlhi3_mask_1 */
              break;

            case 3:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return 1060; /* *rotlsi3_mask_1 */
              break;

            case 4:
              if ((
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1062; /* *rotldi3_mask_1 */
              break;

            case 5:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1072; /* *rotlqi3_add_1 */
              break;

            case 6:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1074; /* *rotlhi3_add_1 */
              break;

            case 7:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1076; /* *rotlsi3_add_1 */
              break;

            case 8:
              if ((
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1078; /* *rotldi3_add_1 */
              break;

            case 9:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1088; /* *rotlqi3_sub_1 */
              break;

            case 10:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1090; /* *rotlhi3_sub_1 */
              break;

            case 11:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1092; /* *rotlsi3_sub_1 */
              break;

            case 12:
              if ((
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1094; /* *rotldi3_sub_1 */
              break;

            default:
              break;
            }
          break;

        case ROTATERT:
          switch (pattern200 (x1))
            {
            case 0:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) == SUBREG)
                {
                  switch (pattern1054 (x2))
                    {
                    case 0:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
                        return 1049; /* *rotrqi3_mask */
                      break;

                    case 1:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
                        return 1051; /* *rotrhi3_mask */
                      break;

                    case 2:
                      if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return 1053; /* *rotrsi3_mask */
                      break;

                    case 3:
                      if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1055; /* *rotrdi3_mask */
                      break;

                    case 4:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1065; /* *rotrqi3_add */
                      break;

                    case 5:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1067; /* *rotrhi3_add */
                      break;

                    case 6:
                      if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1069; /* *rotrsi3_add */
                      break;

                    case 7:
                      if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1071; /* *rotrdi3_add */
                      break;

                    case 8:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1081; /* *rotrqi3_sub */
                      break;

                    case 9:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1083; /* *rotrhi3_sub */
                      break;

                    case 10:
                      if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                        return 1085; /* *rotrsi3_sub */
                      break;

                    case 11:
                      if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 1087; /* *rotrdi3_sub */
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x4;
              switch (pattern1055 (x2))
                {
                case 0:
                  if (
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && true))
                    return 1105; /* *rotrsi3_1 */
                  break;

                case 1:
                  if ((
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1109; /* *rotrdi3_1 */
                  break;

                case 2:
                  if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands, TARGET_APX_NDD)
   && true))
                    return 1133; /* *rotrqi3_1 */
                  break;

                case 3:
                  if (
#line 18679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands, TARGET_APX_NDD)
   && true))
                    return 1137; /* *rotrhi3_1 */
                  break;

                case 4:
                  if (
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1139; /* *rotrqi3_1_slp */
                  break;

                case 5:
                  if (
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 1141; /* *rotrhi3_1_slp */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()))
                return 1057; /* *rotrqi3_mask_1 */
              break;

            case 2:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()))
                return 1059; /* *rotrhi3_mask_1 */
              break;

            case 3:
              if (
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return 1061; /* *rotrsi3_mask_1 */
              break;

            case 4:
              if ((
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1063; /* *rotrdi3_mask_1 */
              break;

            case 5:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1073; /* *rotrqi3_add_1 */
              break;

            case 6:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1075; /* *rotrhi3_add_1 */
              break;

            case 7:
              if (
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1077; /* *rotrsi3_add_1 */
              break;

            case 8:
              if ((
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1079; /* *rotrdi3_add_1 */
              break;

            case 9:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1089; /* *rotrqi3_sub_1 */
              break;

            case 10:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1091; /* *rotrhi3_sub_1 */
              break;

            case 11:
              if (
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return 1093; /* *rotrsi3_sub_1 */
              break;

            case 12:
              if ((
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1095; /* *rotrdi3_sub_1 */
              break;

            default:
              break;
            }
          break;

        case CALL:
          res = recog_383 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CTZ:
          switch (pattern201 (x1))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 1);
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) == REG
                  && REGNO (x6) == 17
                  && GET_MODE (x6) == E_CCmode)
                return 1253; /* ctzsi2 */
              break;

            case 1:
              if (pnum_clobbers != NULL)
                {
                  x5 = XVECEXP (x1, 0, 1);
                  if (XVECLEN (x5, 0) == 1
                      && XINT (x5, 1) == 38)
                    {
                      x7 = XVECEXP (x5, 0, 0);
                      operands[2] = x7;
                      if (register_operand (operands[2], E_SImode))
                        {
                          *pnum_clobbers = 1;
                          return 1254; /* *ctzsi2_falsedep */
                        }
                    }
                }
              break;

            default:
              break;
            }
          break;

        case CLZ:
          res = recog_384 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case POPCOUNT:
          res = recog_385 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SMAX:
          switch (pattern205 (x1))
            {
            case 0:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1477; /* *smaxdi3_doubleword */
              if ((
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1497; /* *smaxdi3_1 */
              break;

            case 1:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1481; /* *smaxti3_doubleword */
              break;

            case 2:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1485; /* *smaxqi3_1 */
              break;

            case 3:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1489; /* *smaxhi3_1 */
              break;

            case 4:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1493; /* *smaxsi3_1 */
              break;

            case 5:
              if (
#line 871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (SMAX, V2SFmode, operands)))
                return 1629; /* *mmx_smaxv2sf3 */
              break;

            default:
              break;
            }
          break;

        case SMIN:
          switch (pattern205 (x1))
            {
            case 0:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1478; /* *smindi3_doubleword */
              if ((
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1498; /* *smindi3_1 */
              break;

            case 1:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1482; /* *sminti3_doubleword */
              break;

            case 2:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1486; /* *sminqi3_1 */
              break;

            case 3:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1490; /* *sminhi3_1 */
              break;

            case 4:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1494; /* *sminsi3_1 */
              break;

            case 5:
              if (
#line 871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (SMIN, V2SFmode, operands)))
                return 1630; /* *mmx_sminv2sf3 */
              break;

            default:
              break;
            }
          break;

        case UMAX:
          switch (pattern206 (x1))
            {
            case 0:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1479; /* *umaxdi3_doubleword */
              if ((
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1499; /* *umaxdi3_1 */
              break;

            case 1:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1483; /* *umaxti3_doubleword */
              break;

            case 2:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1487; /* *umaxqi3_1 */
              break;

            case 3:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1491; /* *umaxhi3_1 */
              break;

            case 4:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1495; /* *umaxsi3_1 */
              break;

            default:
              break;
            }
          break;

        case UMIN:
          switch (pattern206 (x1))
            {
            case 0:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 1480; /* *umindi3_doubleword */
              if ((
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1500; /* *umindi3_1 */
              break;

            case 1:
              if ((
#line 26920 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1484; /* *uminti3_doubleword */
              break;

            case 2:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1488; /* *uminqi3_1 */
              break;

            case 3:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1492; /* *uminhi3_1 */
              break;

            case 4:
              if (
#line 26978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
                return 1496; /* *uminsi3_1 */
              break;

            default:
              break;
            }
          break;

        case UNSPEC_VOLATILE:
          res = recog_386 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case VEC_MERGE:
          if (pattern207 (x1) == 0
              && 
#line 8353 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return 4174; /* sse_cvtpi2ps */
          break;

        case VEC_CONCAT:
          res = recog_387 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case VEC_DUPLICATE:
          res = recog_388 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case VEC_SELECT:
          res = recog_389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 38)
        return -1;
      return recog_390 (x1, insn, pnum_clobbers);

    case CALL:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      switch (pattern642 (x5))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (memory_operand (operands[0], E_SImode)
                  && (
#line 20192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
                return 1215; /* *sibcall_memory */
              break;

            case E_DImode:
              if (memory_operand (operands[0], E_DImode)
                  && (
#line 20192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
                return 1216; /* *sibcall_memory */
              break;

            default:
              break;
            }
          break;

        case 1:
          x10 = XEXP (x5, 1);
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          if (immediate_operand (operands[2], E_SImode))
            {
              if (call_insn_operand (operands[0], E_SImode)
                  && 
#line 20243 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
                return 1217; /* *call_pop */
              if (sibcall_insn_operand (operands[0], E_SImode)
                  && 
#line 20253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
                return 1218; /* *sibcall_pop */
            }
          break;

        default:
          break;
        }
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern329 (x5, 
104, 
1) != 0
          || !
#line 27250 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8383; /* avx_vzeroupper_callee_abi */

    case SIMPLE_RETURN:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x5, 1))
            {
            case 101:
              if (!
#line 20655 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 1235; /* interrupt_return */

            case 29:
              if (!
#line 20666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 1236; /* simple_return_internal_long */

            default:
              return -1;
            }

        case USE:
          x6 = XEXP (x5, 0);
          operands[0] = x6;
          switch (GET_CODE (operands[0]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[0], E_SImode)
                  || !
#line 20677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 1237; /* simple_return_pop_internal */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 20695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
                    return -1;
                  return 1238; /* *simple_return_indirect_internalsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 20695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
                    return -1;
                  return 1239; /* *simple_return_indirect_internaldi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 4
          || XINT (x2, 1) != 98
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern300 (x5, 
E_CCmode, 
17) != 0)
        return -1;
      x12 = XVECEXP (x2, 0, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x13 = XVECEXP (x2, 0, 1);
      operands[1] = x13;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x14 = XVECEXP (x2, 0, 2);
      operands[2] = x14;
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      x15 = XVECEXP (x2, 0, 3);
      operands[3] = x15;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 31220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
        return -1;
      return 9645; /* loadiwkey */

    default:
      return -1;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern345 (x1))
    {
    case 0:
      if (!(
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_570 (insn, operands);

    case 1:
      if (!(
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_572 (insn, operands);

    case 2:
      if (!(
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_574 (insn, operands);

    case 3:
      if (!((
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_576 (insn, operands);

    case 4:
      if (!(
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_600 (insn, operands);

    case 5:
      if (!(
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_602 (insn, operands);

    case 6:
      if (!(
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_604 (insn, operands);

    case 7:
      if (!((
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18277 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_606 (insn, operands);

    case 8:
      if (!(
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_628 (insn, operands);

    case 9:
      if (!(
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_630 (insn, operands);

    case 10:
      if (!(
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_632 (insn, operands);

    case 11:
      if (!((
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_634 (insn, operands);

    case 12:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (pattern1061 (x4))
        {
        case 0:
          if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode)-1))
      == GET_MODE_BITSIZE (QImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_554 (insn, operands);
          break;

        case 1:
          if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode)-1))
      == GET_MODE_BITSIZE (HImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_556 (insn, operands);
          break;

        case 2:
          if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 18149 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_558 (insn, operands);
          break;

        case 3:
          if (((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18149 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_560 (insn, operands);
          break;

        case 4:
          if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_586 (insn, operands);
          break;

        case 5:
          if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_588 (insn, operands);
          break;

        case 6:
          if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_590 (insn, operands);
          break;

        case 7:
          if (((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_592 (insn, operands);
          break;

        case 8:
          if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, QImode, operands)
   && (INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_614 (insn, operands);
          break;

        case 9:
          if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, HImode, operands)
   && (INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_616 (insn, operands);
          break;

        case 10:
          if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 18310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_618 (insn, operands);
          break;

        case 11:
          if (((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 18310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_620 (insn, operands);
          break;

        case 12:
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern956 (x4))
                {
                case 0:
                  if (
#line 18543 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)))
                    return gen_split_646 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18543 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return gen_split_647 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (XWINT (x5, 0) == 8L
              && QIreg_operand (operands[0], E_HImode)
              && GET_MODE (x4) == E_HImode)
            {
              x6 = XEXP (x4, 0);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 18743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
  && (TARGET_USE_XCHGB || optimize_function_for_size_p (cfun))))
                return gen_split_656 (insn, operands);
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern1062 (x2))
        {
        case 0:
          if (!(
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_652 (insn, operands);

        case 1:
          if (!(
#line 18710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 18721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_654 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_41 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return NULL;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern882 (x2))
            {
            case 0:
              if ((
#line 1783 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1786 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( reload_completed)))
                return gen_split_840 (insn, operands);
              break;

            case 1:
              if ((
#line 12309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 12311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1335 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (nonimmediate_operand (operands[1], E_V2SImode)
                      && (
#line 5729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 5732 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( reload_completed)))
                    return gen_split_907 (insn, operands);
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 21192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return gen_split_3164 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HFmode:
          switch (pattern883 (x2))
            {
            case 0:
              if (((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 548 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1358 (insn, operands);
              break;

            case 1:
              if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1359 (insn, operands);
              break;

            case 2:
              if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1360 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_BFmode:
          switch (pattern884 (x2))
            {
            case 0:
              if (((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 549 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1361 (insn, operands);
              break;

            case 1:
              if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1362 (insn, operands);
              break;

            case 2:
              if ((
#line 13218 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1363 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && nonimmediate_operand (operands[1], E_V2DFmode)
              && 
#line 14656 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_2952 (insn, operands);
          break;

        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && GET_MODE (x2) == E_QImode
              && register_operand (operands[1], E_V16QImode)
              && ((
#line 21052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1)) && 
#line 21058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3161 (insn, operands);
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode
              && register_operand (operands[1], E_V8HImode)
              && (
#line 21052 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && !TARGET_SSE4_1
   && (TARGET_INTER_UNIT_MOVES_FROM_VEC
       || optimize_function_for_speed_p (cfun))
   && ix86_pre_reload_split ()) && 
#line 21058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3162 (insn, operands);
          break;

        case E_TImode:
          if (nonimmediate_operand (operands[0], E_TImode)
              && GET_MODE (x2) == E_TImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4TImode:
                  if (register_operand (operands[1], E_V4TImode)
                      && (
#line 21426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 21419 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3171 (insn, operands);
                  break;

                case E_V2TImode:
                  if (register_operand (operands[1], E_V2TImode)
                      && 
#line 21426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && reload_completed
   && (TARGET_AVX512VL || !EXT_REX_SSE_REG_P (operands[1]))))
                    return gen_split_3172 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode
              && memory_operand (operands[1], E_V2SFmode)
              && 
#line 1827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_841 (insn, operands);
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && memory_operand (operands[1], E_V2SImode)
              && 
#line 5816 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && reload_completed))
            return gen_split_909 (insn, operands);
          break;

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 14603 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return gen_split_2950 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      if (nonimmediate_operand (operands[0], E_SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && const_0_to_3_operand (operands[2], E_SImode)
          && (
#line 12320 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 12327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && SSE_REG_P (operands[0]))))
        return gen_split_1336 (insn, operands);
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !(
#line 12363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 12365 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1337 (insn, operands);

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !memory_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_VOIDmode)
          || !
#line 21379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3167 (insn, operands);

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !memory_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_VOIDmode)
          || !
#line 21379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3168 (insn, operands);

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !memory_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode)
          || !
#line 21379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
        return NULL;
      return gen_split_3169 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 3
      || XINT (x4, 1) != 59)
    return NULL;
  switch (pattern914 (x2))
    {
    case 0:
      x5 = XVECEXP (x4, 0, 0);
      operands[3] = x5;
      switch (pattern1328 (x2))
        {
        case 0:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1066 (insn, operands);
          break;

        case 1:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1067 (insn, operands);
          break;

        case 2:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1068 (insn, operands);
          break;

        case 3:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1069 (insn, operands);
          break;

        case 4:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1070 (insn, operands);
          break;

        case 5:
          if ((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1071 (insn, operands);
          break;

        case 6:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1072 (insn, operands);
          break;

        case 7:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1073 (insn, operands);
          break;

        case 8:
          if (((
#line 3332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 3339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1074 (insn, operands);
          break;

        case 9:
          if (((
#line 4217 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1111 (insn, operands);
          break;

        case 10:
          if ((
#line 4217 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1112 (insn, operands);
          break;

        case 11:
          if (((
#line 4217 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1113 (insn, operands);
          break;

        case 12:
          if (((
#line 4217 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1114 (insn, operands);
          break;

        case 13:
          if ((
#line 4246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4250 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1115 (insn, operands);
          break;

        case 14:
          if ((
#line 4246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4250 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1116 (insn, operands);
          break;

        case 15:
          if (((
#line 4246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4250 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1117 (insn, operands);
          break;

        case 16:
          if (((
#line 4246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4250 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_1118 (insn, operands);
          break;

        case 17:
          if (((
#line 18013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18018 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3064 (insn, operands);
          break;

        case 18:
          if ((
#line 18013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 18018 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3065 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return NULL;
      switch (pattern1331 (x2))
        {
        case 0:
          if (!(
#line 4281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1119 (insn, operands);

        case 1:
          if (!(
#line 4281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 4285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1120 (insn, operands);

        case 2:
          if (!((
#line 4281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1121 (insn, operands);

        case 3:
          if (!((
#line 4281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1122 (insn, operands);

        case 4:
          if (!((
#line 18042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3066 (insn, operands);

        case 5:
          if (!(
#line 18042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 18049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3067 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!((
#line 18074 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 18079 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3068 (insn, operands);

    case 2:
      if (!(
#line 18074 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 18079 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return NULL;
      return gen_split_3069 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern865 (x2, 
E_V32BFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1267 (insn, operands);

        case E_V16BFmode:
          if (pattern865 (x2, 
E_V16BFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1268 (insn, operands);

        case E_V8BFmode:
          if (pattern865 (x2, 
E_V8BFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1269 (insn, operands);

        case E_V32HFmode:
          if (pattern865 (x2, 
E_V32HFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1270 (insn, operands);

        case E_V16HFmode:
          if (pattern865 (x2, 
E_V16HFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1271 (insn, operands);

        case E_V8HFmode:
          if (pattern865 (x2, 
E_V8HFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1272 (insn, operands);

        case E_V16SFmode:
          if (pattern865 (x2, 
E_V16SFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1273 (insn, operands);

        case E_V8SFmode:
          if (pattern865 (x2, 
E_V8SFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1274 (insn, operands);

        case E_V4SFmode:
          if (pattern865 (x2, 
E_V4SFmode) != 0
              || !(
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1275 (insn, operands);

        case E_V8DFmode:
          if (pattern865 (x2, 
E_V8DFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 416 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1276 (insn, operands);

        case E_V4DFmode:
          if (pattern865 (x2, 
E_V4DFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1277 (insn, operands);

        case E_V2DFmode:
          if (pattern865 (x2, 
E_V2DFmode) != 0
              || !((
#line 5474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()) && 
#line 417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 5476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1278 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern467 (x2))
            {
            case 0:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1438 (insn, operands);

            case 1:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1465 (insn, operands);

            case 2:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1492 (insn, operands);

            case 3:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1519 (insn, operands);

            case 4:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1546 (insn, operands);

            case 5:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1573 (insn, operands);

            case 6:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1600 (insn, operands);

            case 7:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1627 (insn, operands);

            case 8:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1654 (insn, operands);

            case 9:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1681 (insn, operands);

            case 10:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1708 (insn, operands);

            case 11:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1735 (insn, operands);

            case 12:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1441 (insn, operands);

            case 13:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1468 (insn, operands);

            case 14:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1495 (insn, operands);

            case 15:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1522 (insn, operands);

            case 16:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1549 (insn, operands);

            case 17:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1576 (insn, operands);

            case 18:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1603 (insn, operands);

            case 19:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1630 (insn, operands);

            case 20:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1657 (insn, operands);

            case 21:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1684 (insn, operands);

            case 22:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1711 (insn, operands);

            case 23:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1738 (insn, operands);

            case 24:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1444 (insn, operands);

            case 25:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1471 (insn, operands);

            case 26:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1498 (insn, operands);

            case 27:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1525 (insn, operands);

            case 28:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1552 (insn, operands);

            case 29:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1579 (insn, operands);

            case 30:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1606 (insn, operands);

            case 31:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1633 (insn, operands);

            case 32:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1660 (insn, operands);

            case 33:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1687 (insn, operands);

            case 34:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1714 (insn, operands);

            case 35:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1741 (insn, operands);

            case 36:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2734 (insn, operands);

            case 37:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2743 (insn, operands);

            case 38:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2752 (insn, operands);

            case 39:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2761 (insn, operands);

            case 40:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2770 (insn, operands);

            case 41:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2779 (insn, operands);

            case 42:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2788 (insn, operands);

            case 43:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2797 (insn, operands);

            case 44:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2806 (insn, operands);

            case 45:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2815 (insn, operands);

            case 46:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2824 (insn, operands);

            case 47:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2833 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2086 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2113 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2140 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2167 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2194 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2221 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2248 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2275 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2302 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2329 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2356 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2383 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2089 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2116 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2143 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2170 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2197 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2224 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2251 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2278 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2305 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2332 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2359 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2386 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2092 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2119 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2146 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2173 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2200 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2227 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2254 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2281 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2308 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2335 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2362 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2389 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      return split_57 (x1, insn);

    case XOR:
      return split_56 (x1, insn);

    case GT:
      switch (pattern299 (x2))
        {
        case 0:
          if (!((
#line 17311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3014 (insn, operands);

        case 1:
          if (!(
#line 17311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 17313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3015 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DImode:
          if (pattern844 (x2, 
E_V4DImode) != 0)
            return NULL;
          if (((
#line 17328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3016 (insn, operands);
          if (!(
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 776 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3022 (insn, operands);

        case E_V2DImode:
          if (pattern844 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 17328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3017 (insn, operands);
          if (!
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3023 (insn, operands);

        case E_V16HImode:
          if (pattern844 (x2, 
E_V16HImode) != 0
              || !(
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3018 (insn, operands);

        case E_V8HImode:
          if (pattern844 (x2, 
E_V8HImode) != 0
              || !
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3019 (insn, operands);

        case E_V8SImode:
          if (pattern844 (x2, 
E_V8SImode) != 0
              || !(
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return NULL;
          return gen_split_3020 (insn, operands);

        case E_V4SImode:
          if (pattern844 (x2, 
E_V4SImode) != 0
              || !
#line 17340 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return NULL;
          return gen_split_3021 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != NOT)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern960 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return NULL;
          if (register_operand (operands[1], E_SImode)
              && 
#line 18603 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return gen_split_3120 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3130 (insn, operands);

        case E_V2DImode:
          if (pattern960 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return NULL;
          if (register_operand (operands[1], E_DImode)
              && 
#line 18603 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return gen_split_3121 (insn, operands);
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3133 (insn, operands);

        case E_V64QImode:
          if (pattern542 (x2, 
E_V64QImode, 
E_QImode) != 0
              || !(
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3122 (insn, operands);

        case E_V32QImode:
          if (pattern542 (x2, 
E_V32QImode, 
E_QImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3123 (insn, operands);

        case E_V16QImode:
          if (pattern542 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3124 (insn, operands);

        case E_V32HImode:
          if (pattern542 (x2, 
E_V32HImode, 
E_HImode) != 0
              || !(
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 588 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3125 (insn, operands);

        case E_V16HImode:
          if (pattern542 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3126 (insn, operands);

        case E_V8HImode:
          if (pattern542 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3127 (insn, operands);

        case E_V16SImode:
          if (pattern542 (x2, 
E_V16SImode, 
E_SImode) != 0
              || !(
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3128 (insn, operands);

        case E_V8SImode:
          if (pattern542 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3129 (insn, operands);

        case E_V8DImode:
          if (pattern542 (x2, 
E_V8DImode, 
E_DImode) != 0
              || !(
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3131 (insn, operands);

        case E_V4DImode:
          if (pattern542 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 18619 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return NULL;
          return gen_split_3132 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern664 (x2, 
E_V16SImode, 
E_SImode) != 0
              || !(
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3114 (insn, operands);

        case E_V8SImode:
          if (pattern664 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3115 (insn, operands);

        case E_V4SImode:
          if (pattern664 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3116 (insn, operands);

        case E_V8DImode:
          if (pattern664 (x2, 
E_V8DImode, 
E_DImode) != 0
              || !(
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3117 (insn, operands);

        case E_V4DImode:
          if (pattern664 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3118 (insn, operands);

        case E_V2DImode:
          if (pattern664 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 18435 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3119 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || QImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3456 (insn, operands);

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || QImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3457 (insn, operands);

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3458 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3459 (insn, operands);

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || SImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return gen_split_3460 (insn, operands);
          if (!
#line 27979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3466 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || SImode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3461 (insn, operands);

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3462 (insn, operands);

        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || HFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3463 (insn, operands);

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || BFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3464 (insn, operands);

        case E_V8BFmode:
          if (!register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x2) != E_V8BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 27956 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   /* Disable this splitter if avx512vl_vec_dup_gprv*[qhs]i insn is
      available, because then we can broadcast from GPRs directly.
      For V*[QH]I modes it requires both -mavx512vl and -mavx512bw,
      for V*SI mode it requires just -mavx512vl.  */
   && !(TARGET_AVX512VL
	&& (TARGET_AVX512BW || BFmode == SImode))
   && reload_completed && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_3465 (insn, operands);

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 27979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3467 (insn, operands);

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 27979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3468 (insn, operands);

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 27979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !TARGET_AVX2 && reload_completed))
            return NULL;
          return gen_split_3469 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  res = split_73 (x1, insn);
  if (res != NULL_RTX)
    return res;
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return split_71 (x1, insn);

    case VEC_MERGE:
      return split_70 (x1, insn);

    case VEC_SELECT:
      return split_75 (x1, insn);

    case AND:
    case IOR:
    case XOR:
    case NOT:
      return split_72 (x1, insn);

    case PLUS:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != UNSPEC)
        return NULL;
      switch (pattern177 (x2))
        {
        case 0:
          if (!((
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7181 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1279 (insn, operands);

        case 1:
          if (!((
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7181 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1280 (insn, operands);

        case 2:
          if (!((
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7181 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1281 (insn, operands);

        case 3:
          if (!((
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1282 (insn, operands);

        case 4:
          if (!((
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1283 (insn, operands);

        case 5:
          if (!((
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1284 (insn, operands);

        case 6:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1285 (insn, operands);

        case 7:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1287 (insn, operands);

        case 8:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1289 (insn, operands);

        case 9:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1286 (insn, operands);

        case 10:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1288 (insn, operands);

        case 11:
          if (!((
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 7216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1290 (insn, operands);

        default:
          return NULL;
        }

    case VEC_CONCAT:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          switch (pattern172 (x2))
            {
            case 0:
              if (!(
#line 12083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12085 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1328 (insn, operands);

            case 1:
              if (!(
#line 12197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12199 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1332 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          if (pattern350 (x3, 
E_DFmode) != 0
              || !memory_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return NULL;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DFmode))
            return NULL;
          x5 = XEXP (x3, 0);
          if (!rtx_equal_p (x5, operands[0])
              || !
#line 14737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed))
            return NULL;
          return gen_split_2954 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          res = split_69 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x3) != SUBREG
              || pattern544 (x2) != 0
              || !register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode)
            return NULL;
          x5 = XEXP (x3, 0);
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!memory_operand (operands[1], E_V16QImode))
            return NULL;
          x4 = XEXP (x2, 1);
          x7 = XEXP (x4, 0);
          x8 = XVECEXP (x7, 0, 0);
          if (!rtx_equal_p (x8, operands[1])
              || !(
#line 27899 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && ix86_pre_reload_split ()) && 
#line 27901 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3455 (insn, operands);

        case VEC_CONCAT:
          if (pattern351 (x2) != 0)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1343 (x2, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0
                  || !((
#line 30128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3539 (insn, operands);

            case E_V16SFmode:
              if (pattern1343 (x2, 
E_V8SFmode, 
E_V4SFmode, 
E_V16SFmode) != 0
                  || !((
#line 30128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3540 (insn, operands);

            case E_V8DFmode:
              if (pattern1343 (x2, 
E_V4DFmode, 
E_V2DFmode, 
E_V8DFmode) != 0
                  || !((
#line 30128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 30130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return NULL;
              return gen_split_3541 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case EQ:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case US_MINUS:
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V32QImode:
              if (pattern866 (x2, 
E_V32QImode) != 0
                  || !(
#line 16323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V32QImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 735 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_2997 (insn, operands);

            case E_V16QImode:
              if (pattern866 (x2, 
E_V16QImode) != 0
                  || !
#line 16323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V16QImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)))
                return NULL;
              return gen_split_2998 (insn, operands);

            case E_V16HImode:
              if (pattern866 (x2, 
E_V16HImode) != 0
                  || !(
#line 16323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V16HImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 736 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_2999 (insn, operands);

            case E_V8HImode:
              if (pattern866 (x2, 
E_V8HImode) != 0
                  || !
#line 16323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && (V8HImode != V8HImode || TARGET_SSE4_1)
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)))
                return NULL;
              return gen_split_3000 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != LSHIFTRT)
            return NULL;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          x4 = XEXP (x2, 1);
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern1134 (x2, 
E_V16HImode) != 0
                  || !(
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (HImode) - 1) && 
#line 774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3042 (insn, operands);

            case E_V8HImode:
              if (pattern1134 (x2, 
E_V8HImode) != 0
                  || !
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (HImode) - 1))
                return NULL;
              return gen_split_3043 (insn, operands);

            case E_V8SImode:
              if (pattern1134 (x2, 
E_V8SImode) != 0
                  || !(
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (SImode) - 1) && 
#line 775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3044 (insn, operands);

            case E_V4SImode:
              if (pattern1134 (x2, 
E_V4SImode) != 0
                  || !
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (SImode) - 1))
                return NULL;
              return gen_split_3045 (insn, operands);

            case E_V4DImode:
              if (pattern1134 (x2, 
E_V4DImode) != 0
                  || !(
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (DImode) - 1) && 
#line 776 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return NULL;
              return gen_split_3046 (insn, operands);

            case E_V2DImode:
              if (pattern1134 (x2, 
E_V2DImode) != 0
                  || !
#line 17517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(INTVAL (operands[2]) == GET_MODE_PRECISION (DImode) - 1))
                return NULL;
              return gen_split_3047 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern603 (x2, 
E_V16HImode) != 0
              || !((
#line 17113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17115 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3001 (insn, operands);

        case E_V8HImode:
          if (pattern603 (x2, 
E_V8HImode) != 0
              || !(
#line 17113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17115 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3002 (insn, operands);

        case E_V8SImode:
          if (pattern603 (x2, 
E_V8SImode) != 0
              || !((
#line 17113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 744 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 17115 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3003 (insn, operands);

        case E_V4SImode:
          if (pattern603 (x2, 
E_V4SImode) != 0
              || !(
#line 17113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 17115 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3004 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3033 (insn, operands);

        case 1:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3036 (insn, operands);

        case 2:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3039 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern221 (x2))
        {
        case 0:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3034 (insn, operands);

        case 1:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3037 (insn, operands);

        case 2:
          if (!(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3040 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern220 (x2, 
E_V32HImode) != 0
              || !(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V32HImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3035 (insn, operands);

        case E_V16SImode:
          if (pattern220 (x2, 
E_V16SImode) != 0
              || !(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V16SImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3038 (insn, operands);

        case E_V8DImode:
          if (pattern220 (x2, 
E_V8DImode) != 0
              || !(
#line 17380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && GET_MODE_UNIT_BITSIZE (V8DImode)
   > INTVAL (XVECEXP (operands[2], 0, 0))) && 
#line 785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_3041 (insn, operands);

        case E_V2DImode:
          if (pattern663 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !(
#line 26970 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 26972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3452 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      return split_74 (x1, insn);

    case SIGN_EXTEND:
      x3 = XEXP (x2, 0);
      if (pattern222 (x3) != 0)
        return NULL;
      switch (pattern615 (x2))
        {
        case 0:
          if ((
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()) && 
#line 24259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3259 (insn, operands);
          if (!(
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3260 (insn, operands);

        case 1:
          if ((
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3267 (insn, operands);
          if (!(
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3268 (insn, operands);

        case 2:
          if (!(
#line 24772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 24774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3291 (insn, operands);

        case 3:
          if ((
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3283 (insn, operands);
          if (!(
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3284 (insn, operands);

        case 4:
          if ((
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3302 (insn, operands);
          if (!(
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3303 (insn, operands);

        case 5:
          if ((
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3314 (insn, operands);
          if (!(
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3315 (insn, operands);

        case 6:
          if ((
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3271 (insn, operands);
          if (!(
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3272 (insn, operands);

        case 7:
          if ((
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24836 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3295 (insn, operands);
          if (!(
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24836 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3296 (insn, operands);

        case 8:
          if ((
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return gen_split_3306 (insn, operands);
          if (!(
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3307 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x2, 0);
      if (pattern222 (x3) != 0)
        return NULL;
      x5 = XEXP (x3, 0);
      x10 = XEXP (x5, 0);
      switch (GET_CODE (x10))
        {
        case VEC_CONCAT:
          switch (pattern613 (x2))
            {
            case 0:
              if ((
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()) && 
#line 24259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3261 (insn, operands);
              if (!(
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3262 (insn, operands);

            case 1:
              if ((
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3269 (insn, operands);
              if (!(
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3270 (insn, operands);

            case 2:
              if (!(
#line 24772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 24774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3293 (insn, operands);

            case 3:
              if ((
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3285 (insn, operands);
              if (!(
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3286 (insn, operands);

            case 4:
              if ((
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3304 (insn, operands);
              if (!(
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3305 (insn, operands);

            case 5:
              if ((
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3316 (insn, operands);
              if (!(
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3317 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != VEC_DUPLICATE)
            return NULL;
          if (GET_MODE (x12) == E_V4SImode)
            {
              switch (pattern939 (x2))
                {
                case 0:
                  if ((
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 24476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3273 (insn, operands);
                  if ((
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3274 (insn, operands);
                  break;

                case 1:
                  if ((
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()) && 
#line 24836 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3297 (insn, operands);
                  if ((
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 24836 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3298 (insn, operands);
                  break;

                case 2:
                  if ((
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()) && 
#line 25038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3308 (insn, operands);
                  if ((
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ()) && 
#line 25038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_3309 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x13 = XEXP (x10, 2);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern940 (x2))
            {
            case 0:
              if (!(
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3299 (insn, operands);

            case 1:
              if (!(
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3300 (insn, operands);

            case 2:
              if (!(
#line 24909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && ix86_pre_reload_split ()) && 
#line 24911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3301 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = peephole2_4 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = peephole2_5 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (memory_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 27838 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((QImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_239 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case E_HImode:
          if (memory_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 27838 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((HImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_240 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      res = peephole2_6 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case SUBREG:
    case MEM:
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count < 2)
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_HImode:
      if (peep2_current_count >= 3
          && peep2_current_count >= 4)
        {
          operands[2] = x3;
          if (general_reg_operand (operands[2], E_HImode))
            {
              operands[3] = x2;
              if (general_gr_operand (operands[3], E_HImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[0] = x5;
                  if (general_reg_operand (operands[0], E_HImode))
                    {
                      x6 = XEXP (x4, 1);
                      if (pattern872 (x6, 
E_HImode) == 0
                          && 
#line 26545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])))
                        {
                          *pmatch_len_ = 3;
                          res = gen_peephole2_191 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_HImode)
          && general_reg_operand (operands[0], E_HImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_HImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27142 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_214 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern766 (x4, 
E_HImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_HImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1708 (x9, 
E_HImode) != 0
              || !
#line 28403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_306 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1709 (x9, 
E_HImode) != 0
              || !
#line 28447 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_310 (insn, operands);

        default:
          return NULL;
        }

    case E_QImode:
      operands[0] = x3;
      operands[1] = x2;
      if (x86_64_general_operand (operands[1], E_QImode)
          && general_reg_operand (operands[0], E_QImode))
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (general_reg_operand (operands[2], E_QImode))
            {
              x6 = XEXP (x4, 1);
              if (rtx_equal_p (x6, operands[0])
                  && 
#line 27142 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_213 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || pattern766 (x4, 
E_QImode) != 0)
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1708 (x9, 
E_QImode) != 0
              || !
#line 28403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[4]) == REGNO (operands[0])
       || REGNO (operands[4]) == REGNO (operands[3]))
   && (rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
			     ? 3 : 0], operands[5])
       ? rtx_equal_p (operands[2], operands[6])
       : rtx_equal_p (operands[2], operands[5])
	 && rtx_equal_p (operands[REGNO (operands[4]) == REGNO (operands[0])
				  ? 3 : 0], operands[6]))
   && peep2_reg_dead_p (4, operands[4])
   && peep2_reg_dead_p (5, operands[REGNO (operands[4]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_305 (insn, operands);

        case E_SImode:
          x7 = PATTERN (peep2_next_insn (2));
          x8 = XVECEXP (x7, 0, 0);
          x9 = XEXP (x8, 1);
          if (pattern1709 (x9, 
E_QImode) != 0
              || !
#line 28447 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && (REGNO (operands[5]) == REGNO (operands[0])
       || REGNO (operands[5]) == REGNO (operands[3]))
   && REGNO (operands[5]) == REGNO (operands[4])
   && (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
			     ? 3 : 0], operands[6])
       ? (REG_P (operands[2])
	  ? REG_P (operands[7]) && REGNO (operands[2]) == REGNO (operands[7])
	  : rtx_equal_p (operands[2], operands[7]))
       : (rtx_equal_p (operands[REGNO (operands[5]) == REGNO (operands[0])
				? 3 : 0], operands[7])
	  && REG_P (operands[2])
	  && REGNO (operands[2]) == REGNO (operands[6])))
   && peep2_reg_dead_p (4, operands[5])
   && peep2_reg_dead_p (5, operands[REGNO (operands[5]) == REGNO (operands[0])
				    ? 3 : 0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[3], operands[0])
   && !reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], SImode)
       || any_QIreg_operand (operands[2], SImode))))
            return NULL;
          *pmatch_len_ = 4;
          return gen_peephole2_309 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (register_operand (operands[0], E_SImode))
    {
      res = peephole2_10 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) == PARALLEL
      && XVECLEN (x3, 0) == 2)
    {
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) == SET)
        {
          if (memory_operand (operands[1], E_SImode))
            {
              switch (pattern1076 (x3, 
E_SImode, 
E_DImode))
                {
                case 0:
                  if (
#line 8701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_68 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if (
#line 9134 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_84 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if (
#line 9621 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_96 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if (
#line 9987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_108 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 4:
                  if (
#line 8818 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_76 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 5:
                  if (
#line 8844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_80 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 6:
                  if (
#line 9302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_90 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 7:
                  if (
#line 9328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[5])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[5], operands[1])))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_94 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          if (peep2_current_count >= 4)
            {
              x5 = XEXP (x4, 1);
              if (pattern1077 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x4, 0);
                  if (GET_CODE (x6) == REG
                      && REGNO (x6) == 17
                      && GET_MODE (x6) == E_CCCmode
                      && pattern1537 (x3, 
E_SImode) == 0
                      && 
#line 14288 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[2])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[1])))
                    {
                      *pmatch_len_ = 3;
                      res = gen_peephole2_144 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (general_reg_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) == NEG
                  && GET_MODE (x5) == E_SImode
                  && pattern1225 (x3) == 0)
                {
                  x7 = PATTERN (peep2_next_insn (2));
                  if (GET_CODE (x7) == SET
                      && pattern1383 (x7) == 0)
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_150 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (GET_CODE (x3) != SET)
    return NULL;
  if (register_operand (operands[1], E_SImode))
    {
      res = peephole2_11 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!immediate_operand (operands[1], E_SImode))
    return NULL;
  switch (pattern869 (x3, 
E_DImode, 
E_SImode))
    {
    case 0:
      if (!(
#line 11085 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == DX_REG
       || peep2_reg_dead_p (3, operands[0]))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_112 (insn, operands);

    case 1:
      if (!(
#line 11107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[3]) != DX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[0]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5])
       || peep2_reg_dead_p (3, operands[2]))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_114 (insn, operands);

    case 2:
      if (!
#line 11246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_116 (insn, operands);

    case 3:
      if (!
#line 11246 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[3]) != AX_REG
   && REGNO (operands[0]) != REGNO (operands[2])
   && REGNO (operands[0]) != REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || peep2_reg_dead_p (3, operands[0]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_117 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (!ix86_comparison_operator (x3, E_QImode))
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      operands[2] = x3;
      x7 = PATTERN (peep2_next_insn (2));
      switch (GET_CODE (x7))
        {
        case SET:
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != ZERO_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[3] = x9;
          if (!any_QIreg_operand (operands[3], E_VOIDmode))
            return NULL;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 19946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((peep2_reg_dead_p (3, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_155 (insn, operands);

        case PARALLEL:
          if (XVECLEN (x7, 0) != 2)
            return NULL;
          x11 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x11) != SET)
            return NULL;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != AND
              || GET_MODE (x12) != E_SImode)
            return NULL;
          x13 = XEXP (x12, 1);
          if (GET_CODE (x13) != CONST_INT
              || XWINT (x13, 0) != 255L
              || pattern1575 (x7, 
E_SImode) != 0)
            return NULL;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3])
              || !
#line 20018 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[1]) == REGNO (operands[3])
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_158 (insn, operands);

        default:
          return NULL;
        }

    case STRICT_LOW_PART:
      if (peep2_current_count < 4)
        return NULL;
      x15 = XEXP (x6, 0);
      operands[5] = x15;
      if (!register_operand (operands[5], E_QImode))
        return NULL;
      operands[6] = x3;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 1);
      if (!ix86_comparison_operator (x8, E_QImode))
        return NULL;
      operands[2] = x8;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17)
        return NULL;
      x16 = XEXP (x8, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x17 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x17) != SET)
        return NULL;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != ZERO_EXTEND)
        return NULL;
      x19 = XEXP (x17, 0);
      operands[3] = x19;
      if (!any_QIreg_operand (operands[3], E_VOIDmode))
        return NULL;
      x20 = XEXP (x18, 0);
      if (!rtx_equal_p (x20, operands[1])
          || !
#line 20091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((peep2_reg_dead_p (4, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && ! reg_overlap_mentioned_p (operands[3], operands[5])
   && ! reg_overlap_mentioned_p (operands[1], operands[5])
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_161 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (memory_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode))
    {
      res = peephole2_24 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4
      || !general_reg_operand (operands[1], E_SImode)
      || !general_reg_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || pattern1227 (x3, 
E_SImode) != 0
      || !
#line 26511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_189 (insn, operands);
}

 rtx_insn *
peephole2_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || pattern112 (x2) != 0)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!general_reg_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0])
      || !
#line 22673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 0;
  return gen_peephole2_177 (insn, operands);
}

 rtx_insn *
peephole2_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!general_reg_operand (operands[1], E_QImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return NULL;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 27
          || GET_MODE (x8) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCmode)
        return NULL;
      x10 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_179 (insn, operands);

    case E_SImode:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != POPCOUNT
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x12 = XEXP (x8, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x13) != SET
          || pattern1598 (x13) != 0)
        return NULL;
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x17 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x17) != SET)
        return NULL;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != IF_THEN_ELSE)
        return NULL;
      x19 = XEXP (x18, 0);
      if (!bt_comparison_operator (x19, E_VOIDmode))
        return NULL;
      operands[4] = x19;
      if (pattern1710 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      x21 = XEXP (x20, 0);
      operands[5] = x21;
      if (!
#line 22853 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[2]) == REGNO (operands[3])
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_180 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 2)
    {
      x2 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x2) == SET)
        {
          x3 = XEXP (x2, 1);
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x4 = XEXP (x2, 0);
              operands[2] = x4;
              if (memory_operand (operands[2], E_SImode))
                {
                  if (peep2_current_count >= 3)
                    {
                      x5 = PATTERN (peep2_next_insn (2));
                      if (pattern1139 (x5, 
E_SImode) == 0
                          && 
#line 27047 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
                        {
                          *pmatch_len_ = 3;
                          res = gen_peephole2_201 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  if (
#line 27063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_203 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (!
#line 27076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)))
    return NULL;
  *pmatch_len_ = 0;
  return gen_peephole2_205 (insn, operands);
}

 rtx_insn *
peephole2_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!general_operand (operands[1], E_QImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XVECEXP (x3, 0, 1);
  if (pattern1140 (x4) != 0)
    return NULL;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode
      || pattern1387 (x3) != 0
      || !memory_operand (operands[2], E_QImode))
    return NULL;
  x6 = XVECEXP (x3, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 2);
  operands[3] = x8;
  if (!register_operand (operands[3], E_QImode)
      || pattern1672 (x3) != 0
      || !register_operand (operands[5], E_QImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (2));
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 1);
  operands[6] = x11;
  if (!general_operand (operands[6], E_QImode)
      || !
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_379 (insn, operands);
}

 rtx_insn *
peephole2_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || pattern302 (x1) != 0)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) == 0L)
    {
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1142 (x4, 
E_SImode))
            {
            case 0:
              if (
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_27 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_29 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if ((
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_31 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 4937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_39 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 4937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_41 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              if (GET_MODE (x6) == E_SImode
                  && pattern1225 (x4) == 0)
                {
                  x7 = XEXP (x6, 1);
                  operands[1] = x7;
                  if (x86_64_general_operand (operands[1], E_SImode)
                      && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_129 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (rtx_equal_p (x7, operands[0]))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_141 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 6:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              if (GET_MODE (x6) == E_SImode
                  && pattern1225 (x4) == 0)
                {
                  x7 = XEXP (x6, 1);
                  operands[1] = x7;
                  if (x86_64_general_operand (operands[1], E_SImode)
                      && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_130 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (rtx_equal_p (x7, operands[0]))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_142 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 7:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              if (GET_MODE (x6) == E_SImode
                  && pattern1225 (x4) == 0)
                {
                  x7 = XEXP (x6, 1);
                  operands[1] = x7;
                  if (x86_64_general_operand (operands[1], E_SImode)
                      && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_131 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (rtx_equal_p (x7, operands[0]))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_143 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case 8:
              if (pattern1428 (x4, 
E_SImode) == 0
                  && 
#line 14333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_146 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        case E_DImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1142 (x4, 
E_DImode))
            {
            case 0:
              if ((
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_28 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if ((
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_30 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if ((
#line 3643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_32 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if ((
#line 4937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_40 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if ((
#line 4937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_42 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (pattern1429 (x4) == 0
                  && (
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_132 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (pattern1429 (x4) == 0
                  && (
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_133 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (pattern1429 (x4) == 0
                  && (
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_134 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 8:
              if (pattern1428 (x4, 
E_DImode) == 0
                  && (
#line 14333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_147 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        case E_QImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1143 (x4, 
E_QImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_135 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_136 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_QImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_125 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_137 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern1143 (x4, 
E_HImode))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_126 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_138 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_127 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_139 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              x5 = XVECEXP (x4, 0, 0);
              x6 = XEXP (x5, 1);
              x7 = XEXP (x6, 1);
              operands[1] = x7;
              if (general_operand (operands[1], E_HImode)
                  && 
#line 14039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!reg_mentioned_p (operands[0], operands[1])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_128 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (rtx_equal_p (x7, operands[0]))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_140 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern356 (x4, 
UNSPEC_VOLATILE, 
3) != 0)
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = PATTERN (peep2_next_insn (2));
  if (pattern1388 (x9) != 0)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      operands[1] = x3;
      switch (pattern1647 (x4, 
E_SImode))
        {
        case 0:
          if (
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_383 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_385 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_387 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if ((
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_389 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (pattern1605 (x4, 
E_SImode) != 0
          || !
#line 754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_397 (insn, operands);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      operands[1] = x3;
      switch (pattern1647 (x4, 
E_DImode))
        {
        case 0:
          if ((
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_384 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if ((
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_386 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if ((
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_388 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if ((
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(REGNO (operands[0]) == REGNO (operands[2])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_390 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (pattern1605 (x4, 
E_DImode) != 0
          || !(
#line 754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_398 (insn, operands);

    case E_QImode:
      if (pattern1606 (x3, 
E_QImode) != 0
          || !
#line 754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_395 (insn, operands);

    case E_HImode:
      if (pattern1606 (x3, 
E_HImode) != 0
          || !
#line 754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_396 (insn, operands);

    default:
      return NULL;
    }
}
