/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern13 (rtx x1, machine_mode i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3]
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern26 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern26 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern26 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern26 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern26 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern26 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern26 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern26 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern26 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern5 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    case E_V16HImode:
      if (pattern5 (x3, 
E_V16HImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern5 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16SImode:
      if (pattern5 (x3, 
E_V16SImode) != 0)
        return -1;
      return 12;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 13;

    case E_V8DImode:
      if (pattern5 (x3, 
E_V8DImode) != 0)
        return -1;
      return 14;

    case E_V4DImode:
      if (pattern5 (x3, 
E_V4DImode) != 0)
        return -1;
      return 15;

    case E_V2DImode:
      if (pattern5 (x3, 
E_V2DImode) != 0)
        return -1;
      return 16;

    case E_V64QImode:
      if (pattern5 (x3, 
E_V64QImode) != 0)
        return -1;
      return 17;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 18;

    case E_V32HImode:
      if (pattern5 (x3, 
E_V32HImode) != 0)
        return -1;
      return 19;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern27 (x3, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern27 (x3, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern27 (x3, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !const_1_to_63_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern64 (x3, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern64 (x3, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern64 (x3, 
E_DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!x86_64_general_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern87 (x2, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern87 (x2, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern97 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !x86_64_general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i3
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HImode)
      || GET_MODE (x1) != E_V16HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], E_V16HImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V32HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V32HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_V32HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern144 (x3, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern144 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V64QImode:
      if (pattern144 (x3, 
E_V64QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  return pattern161 (x2); /* [-1, 0] */
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern163 (x3, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern163 (x3, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern163 (x3, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern163 (x3, 
E_V16HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern163 (x3, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern163 (x3, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern163 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern163 (x3, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern163 (x3, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 18])
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 20])
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 22])
    return -1;
  x12 = XVECEXP (x3, 0, 8);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x13 = XVECEXP (x3, 0, 9);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x14 = XVECEXP (x3, 0, 10);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x15 = XVECEXP (x3, 0, 11);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x16 = XVECEXP (x3, 0, 12);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
    return -1;
  x17 = XVECEXP (x3, 0, 13);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
    return -1;
  x18 = XVECEXP (x3, 0, 14);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
    return -1;
  x19 = XVECEXP (x3, 0, 15);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
    return -1;
  x20 = XEXP (x1, 1);
  x21 = XEXP (x20, 1);
  if (XVECLEN (x21, 0) != 16)
    return -1;
  x22 = XVECEXP (x21, 0, 0);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x21, 0, 1);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x24 = XVECEXP (x21, 0, 2);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x25 = XVECEXP (x21, 0, 3);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x26 = XVECEXP (x21, 0, 4);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
    return -1;
  x27 = XVECEXP (x21, 0, 5);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 19])
    return -1;
  x28 = XVECEXP (x21, 0, 6);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 21])
    return -1;
  x29 = XVECEXP (x21, 0, 7);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
    return -1;
  x30 = XVECEXP (x21, 0, 8);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x31 = XVECEXP (x21, 0, 9);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x32 = XVECEXP (x21, 0, 10);
  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x33 = XVECEXP (x21, 0, 11);
  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  x34 = XVECEXP (x21, 0, 12);
  if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
    return -1;
  x35 = XVECEXP (x21, 0, 13);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
    return -1;
  x36 = XVECEXP (x21, 0, 14);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
    return -1;
  x37 = XVECEXP (x21, 0, 15);
  if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
      || pattern178 (x1, 
E_V32HImode, 
E_V16HImode) != 0)
    return -1;
  return 0;
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_QImode))
    return -1;
  return pattern196 (x1); /* [-1, 3] */
}

int
pattern201 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      return 0;

    case UNSPEC:
      return 1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMOD)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case CONST_INT:
      return 1;

    default:
      return -1;
    }
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern242 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LTU:
    case UNLT:
      operands[4] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!flags_reg_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !nonimmediate_operand (operands[1], E_HImode)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || !const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !nonimmediate_operand (operands[1], E_V32HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL
      || XVECLEN (x8, 0) != 1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_SELECT)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 1)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != VEC_SELECT)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != PARALLEL
      || XVECLEN (x15, 0) != 1)
    return -1;
  x16 = XVECEXP (x15, 0, 0);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x1, 1);
  if (GET_CODE (x17) != VEC_CONCAT)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != VEC_SELECT)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PARALLEL
      || XVECLEN (x20, 0) != 1)
    return -1;
  x21 = XVECEXP (x20, 0, 0);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XEXP (x18, 1);
  if (GET_CODE (x22) != VEC_SELECT)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PARALLEL
      || XVECLEN (x23, 0) != 1)
    return -1;
  x24 = XVECEXP (x23, 0, 0);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XEXP (x17, 1);
  if (GET_CODE (x25) != i1)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != VEC_SELECT)
    return -1;
  x27 = XEXP (x26, 1);
  if (GET_CODE (x27) != PARALLEL
      || XVECLEN (x27, 0) != 1)
    return -1;
  x28 = XVECEXP (x27, 0, 0);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x29 = XEXP (x25, 1);
  if (GET_CODE (x29) != VEC_SELECT)
    return -1;
  x30 = XEXP (x29, 1);
  if (GET_CODE (x30) != PARALLEL
      || XVECLEN (x30, 0) != 1)
    return -1;
  x31 = XVECEXP (x30, 0, 0);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x32 = XEXP (x4, 0);
  operands[1] = x32;
  x33 = XEXP (x7, 0);
  if (!rtx_equal_p (x33, operands[1]))
    return -1;
  switch (XWINT (x13, 0))
    {
    case 0L:
      if (XWINT (x16, 0) != 1L
          || XWINT (x21, 0) != 2L
          || XWINT (x24, 0) != 3L
          || !register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || GET_MODE (x2) != E_V2DFmode
          || GET_MODE (x3) != E_DFmode
          || GET_MODE (x4) != E_DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || GET_MODE (x7) != E_DFmode
          || GET_MODE (x10) != E_DFmode
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x34 = XEXP (x11, 0);
      operands[2] = x34;
      if (!nonimmediate_operand (operands[2], E_V4DFmode)
          || GET_MODE (x14) != E_DFmode
          || GET_MODE (x17) != E_V2DFmode
          || GET_MODE (x18) != E_DFmode
          || GET_MODE (x19) != E_DFmode
          || GET_MODE (x22) != E_DFmode
          || GET_MODE (x25) != E_DFmode
          || GET_MODE (x26) != E_DFmode
          || GET_MODE (x29) != E_DFmode)
        return -1;
      x35 = XEXP (x14, 0);
      if (!rtx_equal_p (x35, operands[2]))
        return -1;
      x36 = XEXP (x19, 0);
      if (!rtx_equal_p (x36, operands[1]))
        return -1;
      x37 = XEXP (x22, 0);
      if (!rtx_equal_p (x37, operands[1]))
        return -1;
      x38 = XEXP (x26, 0);
      if (!rtx_equal_p (x38, operands[2]))
        return -1;
      x39 = XEXP (x29, 0);
      if (!rtx_equal_p (x39, operands[2]))
        return -1;
      return 0;

    case 2L:
      if (XWINT (x16, 0) != 3L
          || XWINT (x21, 0) != 0L
          || XWINT (x24, 0) != 1L
          || !register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || GET_MODE (x2) != E_V2SFmode
          || GET_MODE (x3) != E_SFmode
          || GET_MODE (x4) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || GET_MODE (x7) != E_SFmode
          || GET_MODE (x10) != E_SFmode
          || GET_MODE (x11) != E_SFmode
          || GET_MODE (x14) != E_SFmode
          || GET_MODE (x17) != E_V2SFmode
          || GET_MODE (x18) != E_SFmode
          || GET_MODE (x19) != E_SFmode)
        return -1;
      x36 = XEXP (x19, 0);
      operands[2] = x36;
      if (!vector_operand (operands[2], E_V4SFmode)
          || GET_MODE (x22) != E_SFmode
          || GET_MODE (x25) != E_SFmode
          || GET_MODE (x26) != E_SFmode
          || GET_MODE (x29) != E_SFmode)
        return -1;
      x34 = XEXP (x11, 0);
      if (!rtx_equal_p (x34, operands[1]))
        return -1;
      x35 = XEXP (x14, 0);
      if (!rtx_equal_p (x35, operands[1]))
        return -1;
      x37 = XEXP (x22, 0);
      if (!rtx_equal_p (x37, operands[2]))
        return -1;
      x38 = XEXP (x26, 0);
      if (!rtx_equal_p (x38, operands[2]))
        return -1;
      x39 = XEXP (x29, 0);
      if (!rtx_equal_p (x39, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode
      || pattern38 (x1) != 0)
    return -1;
  return 0;
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case SIGN_EXTEND:
      res = pattern339 (x1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    case ZERO_EXTEND:
      res = pattern339 (x1);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!general_gr_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 3)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 92)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  x10 = XVECEXP (x4, 0, 0);
  operands[1] = x10;
  x11 = XEXP (x5, 0);
  operands[2] = x11;
  if (!general_reg_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern382 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      return 0;

    case CONST_INT:
      operands[3] = x3;
      if (!const_0_to_31_operand (operands[3], E_QImode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_0_to_31_operand (operands[2], E_QImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern403 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[5], E_QImode))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  x7 = XEXP (x1, 2);
  operands[5] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern417 (x1, 
E_V32HImode, 
E_SImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern417 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern417 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_V16HImode:
      if (pattern417 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern417 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern417 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern417 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern417 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern417 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !nonimm_or_0_operand (operands[2], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_VECTOR
      || XVECLEN (x4, 0) != 2
      || GET_MODE (x4) != E_V2SImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_V2DFmode))
    return -1;
  return pattern441 (x2); /* [-1, 1] */
}

int
pattern447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern455 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!vector_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!vector_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern459 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) < 1)
    return -1;
  operands[4] = x2;
  if (!pmovzx_parallel (operands[4], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern458 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V32SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern458 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V8SImode
          || GET_MODE (x4) != E_V4SImode
          || !vector_operand (operands[1], E_V2SImode)
          || !const0_operand (operands[2], E_V2SImode)
          || !const0_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern472 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern468 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern468 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern468 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern468 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern468 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern468 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern468 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern468 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern468 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern468 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern468 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern468 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return pattern479 (x6); /* [-1, 2] */
}

int
pattern486 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  return pattern485 (x5); /* [-1, 4] */
}

int
pattern490 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  return pattern489 (x5); /* [-1, 4] */
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern502 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern509 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern516 (x4); /* [-1, 0] */
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !const_int_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !const_int_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !const_int_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern543 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern542 (x1, 
E_V16SImode, 
E_SImode); /* [-1, 0] */

    case E_V8DImode:
      if (pattern542 (x1, 
E_V8DImode, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V64QImode:
      if (pattern542 (x1, 
E_V64QImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern542 (x1, 
E_V32QImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern542 (x1, 
E_V16QImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_V32HImode:
      if (pattern542 (x1, 
E_V32HImode, 
E_HImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern542 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern542 (x1, 
E_V8HImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_V8SImode:
      if (pattern542 (x1, 
E_V8SImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_V4SImode:
      if (pattern542 (x1, 
E_V4SImode, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern542 (x1, 
E_V4DImode, 
E_DImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern542 (x1, 
E_V2DImode, 
E_DImode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern569 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern567 (x1, 
E_V16SImode, 
E_HImode, 
E_V16SFmode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern567 (x1, 
E_V8SImode, 
E_QImode, 
E_V8SFmode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern567 (x1, 
E_V4SImode, 
E_QImode, 
E_V4SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern575 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!nonimmediate_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern587 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[4] = x7;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern586 (x1, 
E_QImode, 
E_V8HImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern586 (x1, 
E_HImode, 
E_V16HImode, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V32HImode:
      if (pattern586 (x1, 
E_SImode, 
E_V32HImode, 
E_V32HFmode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8SImode
          || GET_MODE (x3) != E_V8SImode
          || !nonimm_or_0_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 3;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16SImode
          || GET_MODE (x3) != E_V16SImode
          || !nonimm_or_0_operand (operands[2], E_V16SImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode))
            return -1;
          return 5;

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8DImode
          || GET_MODE (x3) != E_V8DImode
          || !nonimm_or_0_operand (operands[2], E_V8DImode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 7;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 8;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern619 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCOmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_CCOmode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  return 0;
}

int
pattern628 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern634 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern644 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  return 0;
}

int
pattern651 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern659 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 32)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode
      || !register_operand (operands[0], E_SImode)
      || pattern658 (x1) != 0)
    return -1;
  return 0;
}

int
pattern671 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonmemory_operand (operands[4], i1)
      || !const0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern686 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || !binary_fp_operator (operands[3], E_XFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !binary_fp_operator (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern694 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (XWINT (x2, 0) != 1L)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 2);
  operands[4] = x8;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x9 = XEXP (x1, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern702 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern702 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern702 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const48_operand (operands[5], E_SImode))
    return -1;
  return pattern711 (x1); /* [-1, 2] */
}

int
pattern730 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern737 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern744 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern743 (x1, 
E_V32HImode, 
E_V32SImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern743 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern743 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern753 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 38)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode
      || !register_operand (operands[0], E_SImode)
      || !nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern759 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern764 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern770 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || peep2_current_count < 5)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != XOR
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i1))
    return -1;
  x10 = XEXP (x6, 1);
  operands[2] = x10;
  if (!x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x6, 0);
  if (!rtx_equal_p (x11, operands[4]))
    return -1;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (!rtx_equal_p (x13, operands[4]))
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x15) != SET)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != COMPARE
      || GET_MODE (x16) != E_CCZmode)
    return -1;
  x17 = XEXP (x15, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 17
      || GET_MODE (x17) != E_CCZmode)
    return -1;
  x18 = XEXP (x16, 0);
  operands[5] = x18;
  if (!register_operand (operands[5], i1))
    return -1;
  x19 = XEXP (x16, 1);
  operands[6] = x19;
  if (!x86_64_nonmemory_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern796 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[2] = x7;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern813 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_V4QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern822 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern825 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern831 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_V8QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 8)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x10 = XVECEXP (x5, 0, 4);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x11 = XVECEXP (x5, 0, 5);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x12 = XVECEXP (x5, 0, 6);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x13 = XVECEXP (x5, 0, 7);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || GET_MODE (x2) != E_V8QImode
      || !nonimmediate_operand (operands[1], E_V8HFmode))
    return -1;
  x14 = XEXP (x4, 0);
  operands[2] = x14;
  if (!nonimm_or_0_operand (operands[2], E_V16QImode))
    return -1;
  x15 = XEXP (x2, 2);
  operands[3] = x15;
  x16 = XEXP (x1, 1);
  operands[4] = x16;
  if (!const0_operand (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_mmxmem_operand (operands[2], E_V8QImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!reg_or_const_vector_operand (operands[4], E_V4SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern860 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern866 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !const0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern872 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x3, 1);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  x8 = XEXP (x5, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = PATTERN (peep2_next_insn (3));
  return pattern871 (x9, 
i1); /* [-1, 0] */
}

int
pattern877 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern882 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SFmode)
      || GET_MODE (x1) != E_SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SFmode:
      if (!nonimmediate_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern885 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SImode)
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SImode
      || !register_operand (operands[1], E_V2SImode)
      || !register_mmxmem_operand (operands[2], E_V2SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 1L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 3L)
        return -1;
      return 0;

    case 0L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 2L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern888 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern892 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern902 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern911 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern910 (x1, 
E_V8HImode, 
E_HImode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern910 (x1, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_V8BFmode:
      if (pattern910 (x1, 
E_V8BFmode, 
E_BFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern923 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern934 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern941 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x11 = XEXP (x8, 0);
  operands[0] = x11;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern952 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern957 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode
      || !register_operand (operands[0], E_XFmode)
      || !register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern964 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern969 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern968 (x1, 
E_HImode); /* [-1, 0] */

    case E_QImode:
      if (pattern968 (x1, 
E_QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern977 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 6;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 7;

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 9;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 10;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1025 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1029 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1035 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1043 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1049 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1058 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      res = pattern498 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1065 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          res = pattern1063 ();
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_HImode:
          res = pattern1064 (x2, 
E_HImode);
          if (res >= 0)
            return res + 6; /* [6, 8] */
          return -1;

        case E_SImode:
          res = pattern1064 (x2, 
E_SImode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1095 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || GET_MODE (x5) != E_V16QImode
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (GET_MODE (x4) != E_V4SImode
              || !const0_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (GET_MODE (x4) != E_V2DImode
              || !const0_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !vector_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x5) != E_V32QImode
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (GET_MODE (x4) != E_V8SImode
              || !const0_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (GET_MODE (x4) != E_V4DImode
              || !const0_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1144 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_all_ones_operand (operands[3], i1)
      || !const0_operand (operands[4], i1)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[0], i1)
      || !const0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern1148 (x1); /* [-1, 4] */

    default:
      return -1;
    }
}

int
pattern1157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1162 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i3)
      || !nonimmediate_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_all_ones_operand (operands[1], i2)
      || !const0_operand (operands[2], i2)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1179 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1198 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  return 0;
}

int
pattern1210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern320 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern320 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!general_gr_operand (operands[3], i1))
    return -1;
  x4 = PATTERN (peep2_next_insn (3));
  return pattern871 (x4, 
i1); /* [-1, 0] */
}

int
pattern1233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1243 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1249 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern1279 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1286 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern1292 (x1); /* [-1, 1] */

    case IOR:
      res = pattern1292 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case XOR:
      res = pattern1292 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern1314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode
      || !const_0_to_31_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1321 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1333 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1332 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern1345 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_SImode:
      return pattern1352 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1352 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1372 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1381 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1332 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 109
      || GET_MODE (x6) != E_CCZmode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCZmode)
    return -1;
  x9 = XVECEXP (x1, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XVECEXP (x10, 0, 0);
  operands[2] = x11;
  return 0;
}

int
pattern1398 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1403 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8SFmode
      || !vector_operand (operands[1], E_V4SFmode))
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  return 0;
}

int
pattern1420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!x86_64_general_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1436 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1444 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x3, 2);
  return pattern1443 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1451 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1462 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1469 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1468 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1468 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1480 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1489 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i3
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1504 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1504 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1519 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const_0_to_15_operand (operands[2], E_VOIDmode)
      || !const_0_to_15_operand (operands[3], E_VOIDmode)
      || !const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1525 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !const_0_to_7_operand (operands[3], E_VOIDmode)
      || pattern1524 () != 0)
    return -1;
  return 0;
}

int
pattern1535 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!bt_comparison_operator (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V16QImode:
      return pattern1534 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1534 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1534 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1534 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern1534 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern1534 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern1534 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern1534 (x1, 
E_V32QImode) != 0)
        return -1;
      return 7;

    case E_V16HImode:
      if (pattern1534 (x1, 
E_V16HImode) != 0)
        return -1;
      return 8;

    case E_V8SImode:
      if (pattern1534 (x1, 
E_V8SImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern1534 (x1, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V2TImode:
      if (pattern1534 (x1, 
E_V2TImode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern1534 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V4DFmode:
      if (pattern1534 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern1562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1561 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1561 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!nonimmediate_operand (operands[3], E_V16QImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!const_0_to_255_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x9 = XEXP (x7, 1);
  x10 = XVECEXP (x9, 0, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (!rtx_equal_p (x12, operands[4]))
    return -1;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 1);
  x15 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x14, 0, 1);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = XVECEXP (x14, 0, 2);
  if (!rtx_equal_p (x17, operands[4]))
    return -1;
  return 0;
}

int
pattern1592 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[11], i1))
    return -1;
  return 0;
}

int
pattern1608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1618 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1625 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != SIGN_EXTEND
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 4)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  return 0;
}

int
pattern1651 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1659 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1667 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, E_SImode))
    return -1;
  return 0;
}

int
pattern1673 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23L)
    return -1;
  return 0;
}

int
pattern1685 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1696 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12L)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 28L)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13L)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 29L)
    return -1;
  return 0;
}

int
pattern1701 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != GTU
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[7] = x5;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != LTU
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 0);
  operands[8] = x10;
  if (!register_operand (operands[8], E_QImode))
    return -1;
  x11 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != COMPARE)
    return -1;
  x13 = XEXP (x11, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 17)
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[7]))
    return -1;
  x15 = XEXP (x12, 1);
  if (!rtx_equal_p (x15, operands[8]))
    return -1;
  return 0;
}

int
pattern1715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1713 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1723 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[5], i1)
      || !general_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1730 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      x4 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x4, E_SImode))
        return -1;
      switch (XVECLEN (x3, 0))
        {
        case 3:
          if (XINT (x3, 1) != 59)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          operands[4] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x3) != E_HImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode)
                      || !nonimmediate_operand (operands[2], E_V16SImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SImode == V16SFmode
									      || V16SImode == V8DFmode
									      || V16SImode == V8DImode
									      || V16SImode == V16SImode
									      || V16SImode == V32HFmode)) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2731; /* avx512f_cmpv16si3_round */

                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !nonimmediate_operand (operands[2], E_V16SFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2755; /* avx512f_cmpv16sf3_round */

                default:
                  return -1;
                }

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || GET_MODE (x3) != E_QImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8DImode:
                  if (!register_operand (operands[1], E_V8DImode)
                      || !nonimmediate_operand (operands[2], E_V8DImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2739; /* avx512f_cmpv8di3_round */

                case E_V8DFmode:
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !nonimmediate_operand (operands[2], E_V8DFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2763; /* avx512f_cmpv8df3_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x3, 1) != 61
              || GET_MODE (x3) != E_CCFPmode
              || pattern773 (x3) != 0
              || pattern334 (x1, 
E_CCFPmode) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          x7 = XVECEXP (x3, 0, 1);
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          operands[2] = x4;
          switch (GET_MODE (x6))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x7) != E_HFmode
                  || !register_operand (operands[1], E_V8HFmode)
                  || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3110; /* avx10_2_comxhf_round */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x7) != E_SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 3114; /* avx10_2_comxsf_round */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x7) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 3118; /* avx10_2_comxdf_round */

            default:
              return -1;
            }

        case 1:
          if (XINT (x3, 1) != 26
              || GET_MODE (x3) != E_CCFPmode
              || pattern334 (x1, 
E_CCFPmode) != 0)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          if (GET_MODE (x6) != E_CCFPmode)
            return -1;
          operands[2] = x4;
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (XVECLEN (x6, 0) != 2
                  || XINT (x6, 1) != 61)
                return -1;
              x11 = XVECEXP (x6, 0, 0);
              if (GET_CODE (x11) != VEC_SELECT)
                return -1;
              x12 = XEXP (x11, 1);
              if (GET_CODE (x12) != PARALLEL
                  || XVECLEN (x12, 0) != 1)
                return -1;
              x13 = XVECEXP (x12, 0, 0);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x14 = XVECEXP (x6, 0, 1);
              if (GET_CODE (x14) != VEC_SELECT)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x16 = XVECEXP (x15, 0, 0);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x17 = XEXP (x11, 0);
              operands[0] = x17;
              x18 = XEXP (x14, 0);
              operands[1] = x18;
              switch (GET_MODE (x11))
                {
                case E_HFmode:
                  if (!register_operand (operands[0], E_V8HFmode)
                      || GET_MODE (x14) != E_HFmode
                      || !register_operand (operands[1], E_V8HFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3112; /* avx10_2_ucomxhf_round */

                case E_SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x14) != E_SFmode
                      || !register_operand (operands[1], E_V4SFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 3116; /* avx10_2_ucomxsf_round */

                case E_DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x14) != E_DFmode
                      || !register_operand (operands[1], E_V2DFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 3120; /* avx10_2_ucomxdf_round */

                default:
                  return -1;
                }

            case COMPARE:
              x9 = XEXP (x6, 0);
              if (GET_CODE (x9) != VEC_SELECT)
                return -1;
              x19 = XEXP (x9, 1);
              if (GET_CODE (x19) != PARALLEL
                  || XVECLEN (x19, 0) != 1)
                return -1;
              x20 = XVECEXP (x19, 0, 0);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x21 = XEXP (x6, 1);
              if (GET_CODE (x21) != VEC_SELECT)
                return -1;
              x22 = XEXP (x21, 1);
              if (GET_CODE (x22) != PARALLEL
                  || XVECLEN (x22, 0) != 1)
                return -1;
              x23 = XVECEXP (x22, 0, 0);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x24 = XEXP (x9, 0);
              operands[0] = x24;
              x25 = XEXP (x21, 0);
              operands[1] = x25;
              switch (GET_MODE (x9))
                {
                case E_HFmode:
                  if (!register_operand (operands[0], E_V8HFmode)
                      || GET_MODE (x21) != E_HFmode
                      || !register_operand (operands[1], E_V8HFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3124; /* avx512fp16_ucomi_round */

                case E_SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x21) != E_SFmode
                      || !register_operand (operands[1], E_V4SFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode)))
                    return -1;
                  return 3128; /* sse_ucomi_round */

                case E_DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x21) != E_DFmode
                      || !register_operand (operands[1], E_V2DFmode)
                      || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode)))
                    return -1;
                  return 3132; /* sse2_ucomi_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x26 = XEXP (x3, 0);
      if (GET_CODE (x26) != UNSPEC
          || XVECLEN (x26, 0) != 3
          || XINT (x26, 1) != 59)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x27 = XVECEXP (x26, 0, 0);
      operands[1] = x27;
      x28 = XVECEXP (x26, 0, 1);
      operands[2] = x28;
      x29 = XVECEXP (x26, 0, 2);
      operands[3] = x29;
      x4 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x4, E_SImode))
        return -1;
      x30 = XEXP (x3, 1);
      switch (GET_CODE (x30))
        {
        case REG:
        case SUBREG:
          operands[4] = x30;
          operands[5] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern1389 (x2, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16SImode:
                  if (!register_operand (operands[1], E_V16SImode)
                      || !nonimmediate_operand (operands[2], E_V16SImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SImode == V16SFmode
									      || V16SImode == V8DFmode
									      || V16SImode == V8DImode
									      || V16SImode == V16SImode
									      || V16SImode == V32HFmode)) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 2733; /* avx512f_cmpv16si3_mask_round */

                case E_V16SFmode:
                  if (!register_operand (operands[1], E_V16SFmode)
                      || !nonimmediate_operand (operands[2], E_V16SFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 2757; /* avx512f_cmpv16sf3_mask_round */

                default:
                  return -1;
                }

            case E_QImode:
              if (pattern1389 (x2, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8DImode:
                  if (!register_operand (operands[1], E_V8DImode)
                      || !nonimmediate_operand (operands[2], E_V8DImode)
                      || !const_0_to_7_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 2741; /* avx512f_cmpv8di3_mask_round */

                case E_V8DFmode:
                  if (!register_operand (operands[1], E_V8DFmode)
                      || !nonimmediate_operand (operands[2], E_V8DFmode)
                      || !const_0_to_31_operand (operands[3], E_SImode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 2765; /* avx512f_cmpv8df3_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x30, 0) != 1L
              || pattern1314 (x2) != 0)
            return -1;
          operands[4] = x4;
          switch (pattern1539 ())
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4822 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3098; /* avx512f_vmcmpv8hf3_round */

            case 1:
              if (!
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3100; /* avx512f_vmcmpv4sf3_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4822 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3102; /* avx512f_vmcmpv2df3_round */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x30) != E_QImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern1314 (x2) != 0)
            return -1;
          x32 = XEXP (x30, 0);
          operands[4] = x32;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          operands[5] = x4;
          switch (pattern1539 ())
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4840 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3104; /* avx512f_vmcmpv8hf3_mask_round */

            case 1:
              if (!
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3106; /* avx512f_vmcmpv4sf3_mask_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4840 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3108; /* avx512f_vmcmpv2df3_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCFPmode)
        return -1;
      x26 = XEXP (x3, 0);
      if (GET_CODE (x26) != VEC_SELECT
          || pattern550 (x3) != 0
          || pattern334 (x1, 
E_CCFPmode) != 0)
        return -1;
      x33 = XEXP (x26, 0);
      operands[0] = x33;
      x30 = XEXP (x3, 1);
      x32 = XEXP (x30, 0);
      operands[1] = x32;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      if (!const48_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (x26))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x30) != E_HFmode
              || !register_operand (operands[1], E_V8HFmode)
              || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3122; /* avx512fp16_comi_round */

        case E_SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x30) != E_SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode)))
            return -1;
          return 3126; /* sse_comi_round */

        case E_DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x30) != E_DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !(
#line 273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode)))
            return -1;
          return 3130; /* sse2_comi_round */

        default:
          return -1;
        }

    case FMA:
      x26 = XEXP (x3, 0);
      if (GET_CODE (x26) != NEG)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != NEG)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x33 = XEXP (x26, 0);
      operands[1] = x33;
      x30 = XEXP (x3, 1);
      operands[2] = x30;
      x35 = XEXP (x34, 0);
      operands[3] = x35;
      x4 = XVECEXP (x2, 0, 1);
      operands[4] = x4;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern1229 (x2, 
E_SFmode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
            return -1;
          return 3423; /* *fma_fnmsub_sf */

        case E_DFmode:
          if (pattern1229 (x2, 
E_DFmode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4)))
            return -1;
          return 3425; /* *fma_fnmsub_df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (nonimm_ssenomem_operand (operands[0], E_SFmode)
          && register_ssemem_operand (operands[1], E_DFmode)
          && 
#line 5530 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 || (TARGET_SSE2 && TARGET_SSE_MATH)))
        return 167; /* truncdfsf2 */
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_XFmode)
          || !
#line 5658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 168; /* truncxfsf2 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_XFmode)
          || !
#line 5658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 169; /* truncxfdf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode))
        return -1;
      switch (pattern365 (x3, 
E_HFmode))
        {
        case 0:
          if (!
#line 5699 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 170; /* *truncsfhf2 */

        case 1:
          if (!
#line 5699 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 171; /* *truncdfhf2 */

        default:
          return -1;
        }

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 5715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE2 && !HONOR_NANS (BFmode) && !flag_rounding_math
   && (flag_unsafe_math_optimizations
       || TARGET_AVXNECONVERT
       || (TARGET_AVX512BF16 && TARGET_AVX512VL))))
        return -1;
      return 172; /* truncsfbf2 */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern367 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 6062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 191; /* floathisf2 */

            case 1:
              if (!
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode))
   || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              return 196; /* *floatsisf2 */

            case 2:
              if (!
#line 6145 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)))
                return -1;
              return 200; /* *floatdisf2_i387 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern367 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 6062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 192; /* floathidf2 */

            case 1:
              if (!
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode))
   || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 197; /* *floatsidf2 */

            case 2:
              if (!
#line 6145 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)))
                return -1;
              return 201; /* *floatdidf2_i387 */

            default:
              return -1;
            }

        case E_XFmode:
          switch (pattern367 (x3, 
E_XFmode))
            {
            case 0:
              if (!
#line 6062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387
   && (!(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
       || TARGET_MIX_SSE_I387)))
                return -1;
              return 193; /* floathixf2 */

            case 1:
              if (!
#line 6074 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 194; /* floatsixf2 */

            case 2:
              if (!
#line 6074 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 195; /* floatdixf2 */

            default:
              return -1;
            }

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 6136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 198; /* floatsihf2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != TRUNCATE
          || GET_MODE (x5) != E_V2HImode
          || !register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V2SImode)
          || !
#line 1624 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_3DNOW_A))
        return -1;
      return 1647; /* mmx_pi2fw */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern1147 (x1))
            {
            case 0:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 593; /* *andqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 596; /* *andqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 599; /* *andqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 615; /* *andqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 618; /* *andqi_extsi_0 */

            default:
              break;
            }
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != SUBREG)
            return -1;
          switch (pattern1149 (x1))
            {
            case 0:
              if (!
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 602; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 605; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 608; /* *andqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 621; /* *andqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 624; /* *andqi_ext2si_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x9 = XEXP (x1, 0);
          operands[0] = x9;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1231 (x2, 
E_QImode) != 0
                  || !
#line 18962 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1160; /* *btrqi_1 */

            case E_HImode:
              if (pattern1231 (x2, 
E_HImode) != 0
                  || !
#line 18962 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1161; /* *btrhi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pnum_clobbers != NULL
              && pattern679 (x2, 
E_TImode) == 0
              && (
#line 13332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 656; /* *andnti3_doubleword */
            }
          break;

        case E_QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_QImode) == 0
              && 
#line 13364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 658; /* *andnqi_1 */
            }
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_HImode) == 0
              && 
#line 13364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
            {
              *pnum_clobbers = 1;
              return 659; /* *andnhi_1 */
            }
          break;

        case E_V2BFmode:
          if (pattern553 (x2, 
E_V2BFmode) == 0
              && 
#line 2568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1659; /* *mmx_andnotv2bf3 */
          break;

        case E_V2HFmode:
          if (pattern553 (x2, 
E_V2HFmode) == 0
              && 
#line 2568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1660; /* *mmx_andnotv2hf3 */
          break;

        case E_V8QImode:
          if (pattern554 (x2, 
E_V8QImode) == 0
              && 
#line 4592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1790; /* mmx_andnotv8qi3 */
          break;

        case E_V4HImode:
          if (pattern554 (x2, 
E_V4HImode) == 0
              && 
#line 4592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1791; /* mmx_andnotv4hi3 */
          break;

        case E_V2SImode:
          if (pattern554 (x2, 
E_V2SImode) == 0
              && 
#line 4592 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return 1792; /* mmx_andnotv2si3 */
          break;

        case E_V4QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V4QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1793; /* *andnotv4qi3 */
            }
          break;

        case E_V2QImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V2QImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1794; /* *andnotv2qi3 */
            }
          break;

        case E_V2HImode:
          if (pnum_clobbers != NULL
              && pattern553 (x2, 
E_V2HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 1795; /* *andnotv2hi3 */
            }
          break;

        case E_BFmode:
          if (pattern553 (x2, 
E_BFmode) == 0
              && 
#line 5535 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3218; /* *andnotbf3 */
          break;

        case E_HFmode:
          if (pattern553 (x2, 
E_HFmode) == 0
              && 
#line 5535 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3219; /* *andnothf3 */
          break;

        case E_SFmode:
          if (pattern553 (x2, 
E_SFmode) == 0
              && 
#line 5535 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3220; /* *andnotsf3 */
          break;

        case E_DFmode:
          if (pattern553 (x2, 
E_DFmode) == 0
              && (
#line 5535 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3221; /* *andnotdf3 */
          break;

        case E_TFmode:
          if (pattern555 (x2, 
E_TFmode) == 0
              && 
#line 5605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3222; /* *andnottf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_QImode)
          || GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != LSHIFTRT
          || x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1183; /* *btsi_setncqi */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1184; /* *btdi_setncqi */

        default:
          return -1;
        }

    case UNSPEC:
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      switch (XVECLEN (x3, 0))
        {
        case 3:
          x12 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 59:
              operands[3] = x12;
              res = recog_32 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              if (XWINT (x12, 0) != 0L)
                return -1;
              switch (pattern878 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2940; /* *avx512vl_eqv16qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2952; /* *avx512vl_eqv16hi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3008; /* *avx512f_eqv16si3_mask_1 */

                case 3:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2956; /* *avx512vl_eqv8hi3_mask_1 */

                case 4:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3012; /* *avx512vl_eqv8si3_mask_1 */

                case 5:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3016; /* *avx512vl_eqv4si3_mask_1 */

                case 6:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3020; /* *avx512f_eqv8di3_mask_1 */

                case 7:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3024; /* *avx512vl_eqv4di3_mask_1 */

                case 8:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3028; /* *avx512vl_eqv2di3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x12, 0) == 0L)
                {
                  switch (pattern878 (x2))
                    {
                    case 0:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2942; /* *avx512vl_eqv16qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2954; /* *avx512vl_eqv16hi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3010; /* *avx512f_eqv16si3_mask_1 */
                      break;

                    case 3:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2958; /* *avx512vl_eqv8hi3_mask_1 */
                      break;

                    case 4:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3014; /* *avx512vl_eqv8si3_mask_1 */
                      break;

                    case 5:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3018; /* *avx512vl_eqv4si3_mask_1 */
                      break;

                    case 6:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 3022; /* *avx512f_eqv8di3_mask_1 */
                      break;

                    case 7:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3026; /* *avx512vl_eqv4di3_mask_1 */
                      break;

                    case 8:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 3030; /* *avx512vl_eqv2di3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x12;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              switch (pattern969 (x2))
                {
                case 0:
                  switch (pattern680 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2962; /* avx512vl_ucmpv16qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2968; /* avx512vl_ucmpv16hi3_mask */

                    case 2:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3032; /* avx512f_ucmpv16si3_mask */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern681 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2970; /* avx512vl_ucmpv8hi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3034; /* avx512vl_ucmpv8si3_mask */

                    case 2:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3036; /* avx512vl_ucmpv4si3_mask */

                    case 3:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3038; /* avx512f_ucmpv8di3_mask */

                    case 4:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3040; /* avx512vl_ucmpv4di3_mask */

                    case 5:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3042; /* avx512vl_ucmpv2di3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x13 = XVECEXP (x3, 0, 0);
          operands[1] = x13;
          x14 = XVECEXP (x3, 0, 1);
          operands[2] = x14;
          switch (XINT (x3, 1))
            {
            case 158:
              switch (pattern682 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7457; /* avx512vl_testmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7461; /* avx512vl_testmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7465; /* avx512f_testmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7463; /* avx512vl_testmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7467; /* avx512vl_testmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7469; /* avx512vl_testmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7471; /* avx512f_testmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7473; /* avx512vl_testmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7475; /* avx512vl_testmv2di3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern682 (x2))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7481; /* avx512vl_testnmv16qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7485; /* avx512vl_testnmv16hi3_mask */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7489; /* avx512f_testnmv16si3_mask */

                case 3:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7487; /* avx512vl_testnmv8hi3_mask */

                case 4:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7491; /* avx512vl_testnmv8si3_mask */

                case 5:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7493; /* avx512vl_testnmv4si3_mask */

                case 6:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7495; /* avx512f_testnmv8di3_mask */

                case 7:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7497; /* avx512vl_testnmv4di3_mask */

                case 8:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7499; /* avx512vl_testnmv2di3_mask */

                default:
                  return -1;
                }

            case 193:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[3] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern251 (x2, 
E_HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V16HFmode:
                          if (!vector_operand (operands[1], E_V16HFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16HFmode)) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9278; /* avx512dq_fpclassv16hf_mask */

                        case E_V16SFmode:
                          if (!vector_operand (operands[1], E_V16SFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V16SFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9282; /* avx512dq_fpclassv16sf_mask */

                        default:
                          return -1;
                        }

                    case E_QImode:
                      if (pattern251 (x2, 
E_QImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V8HFmode:
                          if (!vector_operand (operands[1], E_V8HFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                            return -1;
                          return 9280; /* avx512dq_fpclassv8hf_mask */

                        case E_V8SFmode:
                          if (!vector_operand (operands[1], E_V8SFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8SFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9284; /* avx512dq_fpclassv8sf_mask */

                        case E_V4SFmode:
                          if (!vector_operand (operands[1], E_V4SFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9286; /* avx512dq_fpclassv4sf_mask */

                        case E_V8DFmode:
                          if (!vector_operand (operands[1], E_V8DFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8DFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return -1;
                          return 9288; /* avx512dq_fpclassv8df_mask */

                        case E_V4DFmode:
                          if (!vector_operand (operands[1], E_V4DFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4DFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9290; /* avx512dq_fpclassv4df_mask */

                        case E_V2DFmode:
                          if (!vector_operand (operands[1], E_V2DFmode)
                              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return -1;
                          return 9292; /* avx512dq_fpclassv2df_mask */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x8, 0) != 1L
                      || !register_operand (operands[0], E_QImode)
                      || GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V8HFmode:
                      if (!nonimmediate_operand (operands[1], E_V8HFmode)
                          || !(
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                        return -1;
                      return 9293; /* avx512dq_vmfpclassv8hf */

                    case E_V4SFmode:
                      if (!nonimmediate_operand (operands[1], E_V4SFmode)
                          || !
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode)))
                        return -1;
                      return 9295; /* avx512dq_vmfpclassv4sf */

                    case E_V2DFmode:
                      if (!nonimmediate_operand (operands[1], E_V2DFmode)
                          || !(
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 9297; /* avx512dq_vmfpclassv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 214:
              if (GET_MODE (x3) != E_HImode
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !nonimmediate_operand (operands[2], E_V16QImode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              if (!register_operand (operands[3], E_HImode)
                  || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9612; /* avx512vl_vpshufbitqmbv16qi_mask */

            case 262:
              if (!const_0_to_255_operand (operands[2], E_VOIDmode))
                return -1;
              x8 = XEXP (x2, 1);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern970 (x2, 
E_HImode, 
E_V16BFmode) != 0
                      || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10006; /* avx10_2_fpclassbf16_v16bf_mask */

                case E_QImode:
                  if (pattern970 (x2, 
E_QImode, 
E_V8BFmode) != 0
                      || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                    return -1;
                  return 10008; /* avx10_2_fpclassbf16_v8bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (pattern85 (x4, 
E_QImode, 
193) != 0)
        return -1;
      x15 = XEXP (x3, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x16 = XVECEXP (x4, 0, 0);
      operands[1] = x16;
      x17 = XVECEXP (x4, 0, 1);
      operands[2] = x17;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V8HFmode)) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 9294; /* avx512dq_vmfpclassv8hf_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V4SFmode))))
            return -1;
          return 9296; /* avx512dq_vmfpclassv4sf_mask */

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V2DFmode)) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 9298; /* avx512dq_vmfpclassv2df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      operands[1] = x3;
      if (bt_comparison_operator (operands[1], E_VOIDmode))
        {
          res = recog_74 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x3) != NE
          || GET_MODE (x3) != E_QImode
          || XWINT (x4, 0) != 0L)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMIN
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x3, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[1] = x11;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 22056 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
        return -1;
      *pnum_clobbers = 1;
      return 1290; /* *bmi2_bzhi_si3 */

    case LTU:
    case UNLT:
      operands[1] = x3;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || XWINT (x4, 0) != 0L)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      *pnum_clobbers = 1;
      return 1447; /* *x86_movsicc_0_m1 */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern74 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 12503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *anddi3_doubleword */

        case E_SImode:
          if (pattern378 (x3) != 0)
            return -1;
          if (
#line 12673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 583; /* *andsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 12673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 584; /* *andsi_1 */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern679 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 13314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 654; /* *andndi3_doubleword_bmi */
                }
              if (!(
#line 13332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 655; /* *andndi3_doubleword */

            case E_SImode:
              if (pattern679 (x3, 
E_SImode) != 0
                  || !
#line 13348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
                return -1;
              *pnum_clobbers = 1;
              return 657; /* *andnsi_1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern984 (x3, 
E_SImode) != 0
                  || !
#line 19382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1185; /* *btsi_setncsi */

            case E_DImode:
              if (pattern984 (x3, 
E_DImode) != 0
                  || !(
#line 19382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1186; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22104 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1293; /* *bmi2_bzhi_si3_3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      switch (pattern253 (x3))
        {
        case 0:
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (pattern695 (x3) == 0
              && 
#line 18893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT))
            {
              *pnum_clobbers = 1;
              return 1155; /* *btrsi */
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern696 (x3))
            {
            case 0:
              if (!
#line 18912 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1156; /* *btrsi_mask */

            case 1:
              if (!(
#line 18912 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18940 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1158; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18940 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1159; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern386 (x3) != 0
          || !
#line 21781 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      *pnum_clobbers = 1;
      return 1277; /* *bmi_blsi_si */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != CONST_INT
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x9, 0))
            {
            case -1L:
              x5 = XEXP (x3, 1);
              switch (pattern1087 (x5))
                {
                case 0:
                  if (!
#line 21926 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1286; /* *bmi_blsr_si */

                case 1:
                  if (!
#line 22297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1305; /* *tbm_tzmsk_si */

                default:
                  return -1;
                }

            case 1L:
              x5 = XEXP (x3, 1);
              switch (pattern1087 (x5))
                {
                case 0:
                  if (!
#line 22188 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1297; /* *tbm_blcfill_si */

                case 1:
                  if (!
#line 22216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1299; /* *tbm_blcic_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x9, 0) != -1L)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22090 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1292; /* *bmi2_bzhi_si3_2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x10 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          switch (XINT (x4, 1))
            {
            case 59:
              operands[3] = x10;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern968 (x3, 
E_SImode) == 0)
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V32HFmode:
                          if (register_operand (operands[1], E_V32HFmode)
                              && nonimmediate_operand (operands[2], E_V32HFmode)
                              && const_0_to_31_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                            return 2748; /* avx512bw_cmpv32hf3_mask */
                          break;

                        case E_V32QImode:
                          if (register_operand (operands[1], E_V32QImode)
                              && nonimmediate_operand (operands[2], E_V32QImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return 2880; /* avx512vl_cmpv32qi3_mask */
                          break;

                        case E_V32HImode:
                          if (register_operand (operands[1], E_V32HImode)
                              && nonimmediate_operand (operands[2], E_V32HImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return 2882; /* avx512bw_cmpv32hi3_mask */
                          break;

                        case E_V32BFmode:
                          if (register_operand (operands[1], E_V32BFmode)
                              && nonimmediate_operand (operands[2], E_V32BFmode)
                              && const_0_to_31_operand (operands[3], E_VOIDmode)
                              && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32454 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                            return 10010; /* avx10_2_cmpbf16_v32bf_mask */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case E_DImode:
                  if (pattern891 (x3) == 0
                      && register_operand (operands[4], E_DImode)
                      && (
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4490 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 2876; /* avx512bw_cmpv64qi3_mask */
                  break;

                default:
                  break;
                }
              if (XWINT (x10, 0) != 0L)
                return -1;
              switch (pattern889 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2936; /* *avx512bw_eqv64qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2944; /* *avx512vl_eqv32qi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2948; /* *avx512bw_eqv32hi3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x10, 0) == 0L)
                {
                  switch (pattern889 (x3))
                    {
                    case 0:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2938; /* *avx512bw_eqv64qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2946; /* *avx512vl_eqv32qi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4585 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2950; /* *avx512bw_eqv32hi3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x10;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern985 (x3, 
E_V64QImode, 
E_DImode) != 0
                      || !register_operand (operands[4], E_DImode)
                      || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2960; /* avx512bw_ucmpv64qi3_mask */

                case E_SImode:
                  if (pattern968 (x3, 
E_SImode) != 0)
                    return -1;
                  switch (pattern792 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 2964; /* avx512vl_ucmpv32qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 2966; /* avx512bw_ucmpv32hi3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (XINT (x4, 1))
            {
            case 158:
              switch (pattern795 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7453; /* avx512bw_testmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7455; /* avx512vl_testmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7459; /* avx512bw_testmv32hi3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern795 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7477; /* avx512bw_testnmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7479; /* avx512vl_testnmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7483; /* avx512bw_testnmv32hi3_mask */

                default:
                  return -1;
                }

            case 193:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29844 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 9276; /* avx512dq_fpclassv32hf_mask */

            case 214:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern794 (x3, 
E_DImode, 
E_V64QImode) != 0
                      || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9610; /* avx512vl_vpshufbitqmbv64qi_mask */

                case E_SImode:
                  if (pattern794 (x3, 
E_SImode, 
E_V32QImode) != 0
                      || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30927 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9614; /* avx512vl_vpshufbitqmbv32qi_mask */

                default:
                  return -1;
                }

            case 262:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_V32BFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10004; /* avx10_2_fpclassbf16_v32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern893 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 514 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10230; /* avx10_2_vmovrsbv64qi_mask */

    case E_V32QImode:
      if (pattern893 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10232; /* avx10_2_vmovrsbv32qi_mask */

    case E_V16QImode:
      if (pattern893 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10234; /* avx10_2_vmovrsbv16qi_mask */

    case E_V32HImode:
      if (pattern893 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10236; /* avx10_2_vmovrswv32hi_mask */

    case E_V16HImode:
      if (pattern893 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10238; /* avx10_2_vmovrswv16hi_mask */

    case E_V8HImode:
      if (pattern893 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10240; /* avx10_2_vmovrswv8hi_mask */

    case E_V16SImode:
      if (pattern893 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 516 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10242; /* avx10_2_vmovrsdv16si_mask */

    case E_V8SImode:
      if (pattern893 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10244; /* avx10_2_vmovrsdv8si_mask */

    case E_V4SImode:
      if (pattern893 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10246; /* avx10_2_vmovrsdv4si_mask */

    case E_V8DImode:
      if (pattern893 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS) && 
#line 517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
        return -1;
      return 10248; /* avx10_2_vmovrsqv8di_mask */

    case E_V4DImode:
      if (pattern893 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10250; /* avx10_2_vmovrsqv4di_mask */

    case E_V2DImode:
      if (pattern893 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && TARGET_MOVRS)))
        return -1;
      return 10252; /* avx10_2_vmovrsqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern902 (x2, 
E_V16SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8657; /* *avx512f_vpermi2varv16si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8723; /* avx512f_vpermt2varv16si3_mask */
            }
          break;

        case E_V8DImode:
          if (pattern902 (x2, 
E_V8DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8658; /* *avx512f_vpermi2varv8di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8725; /* avx512f_vpermt2varv8di3_mask */
            }
          break;

        case E_V8SImode:
          if (pattern902 (x2, 
E_V8SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8659; /* *avx512vl_vpermi2varv8si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8727; /* avx512vl_vpermt2varv8si3_mask */
            }
          break;

        case E_V4SImode:
          if (pattern902 (x2, 
E_V4SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8660; /* *avx512vl_vpermi2varv4si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8731; /* avx512vl_vpermt2varv4si3_mask */
            }
          break;

        case E_V4DImode:
          if (pattern902 (x2, 
E_V4DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8661; /* *avx512vl_vpermi2varv4di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8729; /* avx512vl_vpermt2varv4di3_mask */
            }
          break;

        case E_V2DImode:
          if (pattern902 (x2, 
E_V2DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28137 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8662; /* *avx512vl_vpermi2varv2di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8733; /* avx512vl_vpermt2varv2di3_mask */
            }
          break;

        case E_V32HImode:
          if (pattern902 (x2, 
E_V32HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28138 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8663; /* *avx512bw_vpermi2varv32hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8735; /* avx512bw_vpermt2varv32hi3_mask */
            }
          break;

        case E_V16HImode:
          if (pattern902 (x2, 
E_V16HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8664; /* *avx512vl_vpermi2varv16hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8736; /* avx512vl_vpermt2varv16hi3_mask */
            }
          break;

        case E_V8HImode:
          if (pattern902 (x2, 
E_V8HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28140 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8665; /* *avx512vl_vpermi2varv8hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8737; /* avx512vl_vpermt2varv8hi3_mask */
            }
          break;

        case E_V64QImode:
          if (pattern902 (x2, 
E_V64QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28141 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8666; /* *avx512bw_vpermi2varv64qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8738; /* avx512bw_vpermt2varv64qi3_mask */
            }
          break;

        case E_V32QImode:
          if (pattern902 (x2, 
E_V32QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28142 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8667; /* *avx512vl_vpermi2varv32qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8739; /* avx512vl_vpermt2varv32qi3_mask */
            }
          break;

        case E_V16QImode:
          if (pattern902 (x2, 
E_V16QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8668; /* *avx512vl_vpermi2varv16qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8740; /* avx512vl_vpermt2varv16qi3_mask */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          if (rtx_equal_p (x9, operands[2]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1317 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8669; /* *avx512f_vpermi2varv16sf3_mask */
                  break;

                case E_V8SFmode:
                  if (pattern1317 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8670; /* *avx512vl_vpermi2varv8sf3_mask */
                  break;

                case E_V4SFmode:
                  if (pattern1317 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8671; /* *avx512vl_vpermi2varv4sf3_mask */
                  break;

                case E_V8DFmode:
                  if (pattern1317 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8672; /* *avx512f_vpermi2varv8df3_mask */
                  break;

                case E_V4DFmode:
                  if (pattern1317 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8673; /* *avx512vl_vpermi2varv4df3_mask */
                  break;

                case E_V2DFmode:
                  if (pattern1317 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) == 0
                      && (
#line 28187 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8674; /* *avx512vl_vpermi2varv2df3_mask */
                  break;

                default:
                  break;
                }
            }
        }
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1160 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8724; /* avx512f_vpermt2varv16sf3_mask */

        case E_V8DFmode:
          if (pattern1160 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8726; /* avx512f_vpermt2varv8df3_mask */

        case E_V8SFmode:
          if (pattern1160 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8728; /* avx512vl_vpermt2varv8sf3_mask */

        case E_V4DFmode:
          if (pattern1160 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8730; /* avx512vl_vpermt2varv4df3_mask */

        case E_V4SFmode:
          if (pattern1160 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8732; /* avx512vl_vpermt2varv4sf3_mask */

        case E_V2DFmode:
          if (pattern1160 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28247 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8734; /* avx512vl_vpermt2varv2df3_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x5;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x6 = XEXP (x2, 2);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern421 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8676; /* avx512f_vpermt2varv16si3_maskz_1 */

        case E_V16SFmode:
          if (pattern1161 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8678; /* avx512f_vpermt2varv16sf3_maskz_1 */

        case E_V8DImode:
          if (pattern421 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8680; /* avx512f_vpermt2varv8di3_maskz_1 */

        case E_V8DFmode:
          if (pattern1161 (x2, 
E_V8DFmode, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28122 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8682; /* avx512f_vpermt2varv8df3_maskz_1 */

        case E_V8SImode:
          if (pattern421 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8684; /* avx512vl_vpermt2varv8si3_maskz_1 */

        case E_V8SFmode:
          if (pattern1161 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8686; /* avx512vl_vpermt2varv8sf3_maskz_1 */

        case E_V4DImode:
          if (pattern421 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8688; /* avx512vl_vpermt2varv4di3_maskz_1 */

        case E_V4DFmode:
          if (pattern1161 (x2, 
E_V4DFmode, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28124 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8690; /* avx512vl_vpermt2varv4df3_maskz_1 */

        case E_V4SImode:
          if (pattern421 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8692; /* avx512vl_vpermt2varv4si3_maskz_1 */

        case E_V4SFmode:
          if (pattern1161 (x2, 
E_V4SFmode, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8694; /* avx512vl_vpermt2varv4sf3_maskz_1 */

        case E_V2DImode:
          if (pattern421 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8696; /* avx512vl_vpermt2varv2di3_maskz_1 */

        case E_V2DFmode:
          if (pattern1161 (x2, 
E_V2DFmode, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28126 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8698; /* avx512vl_vpermt2varv2df3_maskz_1 */

        case E_V32HImode:
          if (pattern421 (x2, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28127 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8700; /* avx512bw_vpermt2varv32hi3_maskz_1 */

        case E_V16HImode:
          if (pattern421 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8702; /* avx512vl_vpermt2varv16hi3_maskz_1 */

        case E_V8HImode:
          if (pattern421 (x2, 
E_V8HImode, 
E_QImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28129 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8704; /* avx512vl_vpermt2varv8hi3_maskz_1 */

        case E_V64QImode:
          if (pattern421 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28130 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 8706; /* avx512bw_vpermt2varv64qi3_maskz_1 */

        case E_V32QImode:
          if (pattern421 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28131 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8708; /* avx512vl_vpermt2varv32qi3_maskz_1 */

        case E_V16QImode:
          if (pattern421 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 28214 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8710; /* avx512vl_vpermt2varv16qi3_maskz_1 */

        case E_V32HFmode:
          if (pattern1161 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8712; /* avx512bw_vpermt2varv32hf3_maskz_1 */

        case E_V16HFmode:
          if (pattern1161 (x2, 
E_V16HFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8714; /* avx512vl_vpermt2varv16hf3_maskz_1 */

        case E_V8HFmode:
          if (pattern1161 (x2, 
E_V8HFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8716; /* avx512fp16_vpermt2varv8hf3_maskz_1 */

        case E_V32BFmode:
          if (pattern1161 (x2, 
E_V32BFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8718; /* avx512bw_vpermt2varv32bf3_maskz_1 */

        case E_V16BFmode:
          if (pattern1161 (x2, 
E_V16BFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8720; /* avx512vl_vpermt2varv16bf3_maskz_1 */

        case E_V8BFmode:
          if (pattern1161 (x2, 
E_V8BFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28229 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8722; /* avx512vl_vpermt2varv8bf3_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x3;
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[5] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1264 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && nonimmediate_operand (operands[2], E_V4SFmode)
                  && nonimmediate_operand (operands[3], E_V4SFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3427; /* *fma_fnmsub_v4sf */
              if (!bcst_vector_operand (operands[1], E_V4SFmode)
                  || !bcst_vector_operand (operands[2], E_V4SFmode)
                  || !bcst_vector_operand (operands[3], E_V4SFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3459; /* fma_fnmsub_v4sf_maskz_1 */

            case E_V2DFmode:
              if (pattern1264 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && nonimmediate_operand (operands[2], E_V2DFmode)
                  && nonimmediate_operand (operands[3], E_V2DFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3431; /* *fma_fnmsub_v2df */
              if (!bcst_vector_operand (operands[1], E_V2DFmode)
                  || !bcst_vector_operand (operands[2], E_V2DFmode)
                  || !bcst_vector_operand (operands[3], E_V2DFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3468; /* fma_fnmsub_v2df_maskz_1 */

            case E_V8SFmode:
              if (pattern1264 (x2, 
E_V8SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8SFmode)
                  && nonimmediate_operand (operands[2], E_V8SFmode)
                  && nonimmediate_operand (operands[3], E_V8SFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3435; /* *fma_fnmsub_v8sf */
              if (!bcst_vector_operand (operands[1], E_V8SFmode)
                  || !bcst_vector_operand (operands[2], E_V8SFmode)
                  || !bcst_vector_operand (operands[3], E_V8SFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3457; /* fma_fnmsub_v8sf_maskz_1 */

            case E_V4DFmode:
              if (pattern1264 (x2, 
E_V4DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4DFmode)
                  && nonimmediate_operand (operands[2], E_V4DFmode)
                  && nonimmediate_operand (operands[3], E_V4DFmode)
                  && 
#line 6230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
                return 3439; /* *fma_fnmsub_v4df */
              if (!bcst_vector_operand (operands[1], E_V4DFmode)
                  || !bcst_vector_operand (operands[2], E_V4DFmode)
                  || !bcst_vector_operand (operands[3], E_V4DFmode)
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3466; /* fma_fnmsub_v4df_maskz_1 */

            case E_V32HFmode:
              if (pattern1265 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 3443; /* fma_fnmsub_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1265 (x2, 
E_HImode, 
E_V16HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3447; /* fma_fnmsub_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1265 (x2, 
E_QImode, 
E_V8HFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 3449; /* fma_fnmsub_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1265 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3453; /* fma_fnmsub_v16sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1265 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 6263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3462; /* fma_fnmsub_v8df_maskz_1 */

            case E_V32BFmode:
              if (pattern1266 (x2, 
E_SImode, 
E_V32BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9950; /* avx10_2_fnmsubbf16_v32bf_maskz_1 */

            case E_V16BFmode:
              if (pattern1266 (x2, 
E_HImode, 
E_V16BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9952; /* avx10_2_fnmsubbf16_v16bf_maskz_1 */

            case E_V8BFmode:
              if (pattern1266 (x2, 
E_QImode, 
E_V8BFmode) != 0
                  || !
#line 32337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 9954; /* avx10_2_fnmsubbf16_v8bf_maskz_1 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern1267 (x2, 
E_V4SFmode) != 0
                  || !
#line 7008 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4))
                return -1;
              return 3729; /* *fma4i_vmfnmsub_v4sf */

            case E_V2DFmode:
              if (pattern1267 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7008 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3730; /* *fma4i_vmfnmsub_v2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern571 (x2))
        {
        case 0:
          if (pattern1181 (x2, 
E_V32HFmode, 
E_SImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V32HFmode)
              && vector_operand (operands[3], E_V32HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3469; /* avx512bw_fnmsub_v32hf_mask */
          if (!vector_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[3], E_V32HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3481; /* avx512bw_fnmsub_v32hf_mask3 */

        case 1:
          if (pattern1181 (x2, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16HFmode)
              && vector_operand (operands[3], E_V16HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3471; /* avx512vl_fnmsub_v16hf_mask */
          if (!vector_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3483; /* avx512vl_fnmsub_v16hf_mask3 */

        case 2:
          if (pattern1181 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8HFmode)
              && vector_operand (operands[3], E_V8HFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3472; /* avx512fp16_fnmsub_v8hf_mask */
          if (!vector_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3485; /* avx512fp16_fnmsub_v8hf_mask3 */

        case 3:
          if (pattern1181 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16SFmode)
              && vector_operand (operands[3], E_V16SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3473; /* avx512f_fnmsub_v16sf_mask */
          if (!vector_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[3], E_V16SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3487; /* avx512f_fnmsub_v16sf_mask3 */

        case 4:
          if (pattern1181 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && vector_operand (operands[3], E_V8SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3475; /* avx512vl_fnmsub_v8sf_mask */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3489; /* avx512vl_fnmsub_v8sf_mask3 */

        case 5:
          if (pattern1181 (x2, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && vector_operand (operands[3], E_V4SFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3476; /* avx512vl_fnmsub_v4sf_mask */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[3], E_V4SFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3491; /* avx512vl_fnmsub_v4sf_mask3 */

        case 6:
          if (pattern1181 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8DFmode)
              && vector_operand (operands[3], E_V8DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3477; /* avx512f_fnmsub_v8df_mask */
          if (!vector_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[3], E_V8DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3493; /* avx512f_fnmsub_v8df_mask3 */

        case 7:
          if (pattern1181 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && vector_operand (operands[3], E_V4DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3479; /* avx512vl_fnmsub_v4df_mask */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3495; /* avx512vl_fnmsub_v4df_mask3 */

        case 8:
          if (pattern1181 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && vector_operand (operands[3], E_V2DFmode)
              && rtx_equal_p (x3, operands[1])
              && (
#line 6308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3480; /* avx512vl_fnmsub_v2df_mask */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[3], E_V2DFmode)
              || !rtx_equal_p (x3, operands[3])
              || !(
#line 6327 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3497; /* avx512vl_fnmsub_v2df_mask3 */

        case 9:
          if (pattern1182 (x2, 
E_SImode, 
E_V32BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && 
#line 32357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9955; /* avx10_2_fnmsubbf16_v32bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !
#line 32376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9958; /* avx10_2_fnmsubbf16_v32bf_mask3 */

        case 10:
          if (pattern1182 (x2, 
E_HImode, 
E_V16BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && 
#line 32357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9956; /* avx10_2_fnmsubbf16_v16bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !
#line 32376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9959; /* avx10_2_fnmsubbf16_v16bf_mask3 */

        case 11:
          if (pattern1182 (x2, 
E_QImode, 
E_V8BFmode) != 0)
            return -1;
          if (rtx_equal_p (x3, operands[1])
              && 
#line 32357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9957; /* avx10_2_fnmsubbf16_v8bf_mask */
          if (!rtx_equal_p (x3, operands[3])
              || !
#line 32376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9960; /* avx10_2_fnmsubbf16_v8bf_mask3 */

        case 12:
          if (pattern1268 (x2, 
E_V8HFmode) != 0
              || !(
#line 6655 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3645; /* *fmai_fnmsub_v8hf */

        case 13:
          if (pattern1268 (x2, 
E_V4SFmode) != 0
              || !
#line 6655 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
            return -1;
          return 3647; /* *fmai_fnmsub_v4sf */

        case 14:
          if (pattern1268 (x2, 
E_V2DFmode) != 0
              || !(
#line 6655 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3649; /* *fmai_fnmsub_v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XVECLEN (x6, 0))
    {
    case 16:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_145 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x16 = XVECEXP (x6, 0, 8);
      operands[11] = x16;
      x17 = XVECEXP (x6, 0, 9);
      operands[12] = x17;
      x18 = XVECEXP (x6, 0, 10);
      operands[13] = x18;
      x19 = XVECEXP (x6, 0, 11);
      operands[14] = x19;
      x20 = XVECEXP (x6, 0, 12);
      operands[15] = x20;
      x21 = XVECEXP (x6, 0, 13);
      operands[16] = x21;
      x22 = XVECEXP (x6, 0, 14);
      operands[17] = x22;
      x23 = XVECEXP (x6, 0, 15);
      operands[18] = x23;
      x24 = XEXP (x2, 1);
      operands[19] = x24;
      x25 = XEXP (x2, 2);
      operands[20] = x25;
      if (!register_operand (operands[20], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1488 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !nonimm_or_0_operand (operands[19], E_V16SFmode))
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_16_to_19_operand (operands[5], E_VOIDmode)
              && const_16_to_19_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_20_to_23_operand (operands[9], E_VOIDmode)
              && const_20_to_23_operand (operands[10], E_VOIDmode)
              && const_8_to_11_operand (operands[11], E_VOIDmode)
              && const_8_to_11_operand (operands[12], E_VOIDmode)
              && const_24_to_27_operand (operands[13], E_VOIDmode)
              && const_24_to_27_operand (operands[14], E_VOIDmode)
              && const_12_to_15_operand (operands[15], E_VOIDmode)
              && const_12_to_15_operand (operands[16], E_VOIDmode)
              && const_28_to_31_operand (operands[17], E_VOIDmode)
              && const_28_to_31_operand (operands[18], E_VOIDmode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14270 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12)))))
            return 6538; /* avx512f_shufps512_1_mask */
          if (!const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1712 () != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7773; /* avx512f_shuf_f32x4_1_mask */

        case E_V16SImode:
          if (pattern1488 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !const_0_to_15_operand (operands[3], E_VOIDmode)
              || pattern1712 () != 0
              || !nonimm_or_0_operand (operands[19], E_V16SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7775; /* avx512f_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 8:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_146 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x12 = XVECEXP (x6, 0, 4);
      operands[7] = x12;
      x13 = XVECEXP (x6, 0, 5);
      operands[8] = x13;
      x14 = XVECEXP (x6, 0, 6);
      operands[9] = x14;
      x15 = XVECEXP (x6, 0, 7);
      operands[10] = x15;
      x24 = XEXP (x2, 1);
      operands[11] = x24;
      x25 = XEXP (x2, 2);
      operands[12] = x25;
      if (!register_operand (operands[12], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1599 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0)
            return -1;
          if (const_0_to_3_operand (operands[3], E_VOIDmode)
              && const_0_to_3_operand (operands[4], E_VOIDmode)
              && const_8_to_11_operand (operands[5], E_VOIDmode)
              && const_8_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_7_operand (operands[7], E_VOIDmode)
              && const_4_to_7_operand (operands[8], E_VOIDmode)
              && const_12_to_15_operand (operands[9], E_VOIDmode)
              && const_12_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && TARGET_AVX512VL
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)))))
            return 4596; /* avx_shufps256_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1689 () != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 7771; /* avx512vl_shuf_f32x4_1_mask */

        case E_V8DFmode:
          if (pattern1599 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_8_to_9_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_10_to_11_operand (operands[6], E_VOIDmode)
              && const_4_to_5_operand (operands[7], E_VOIDmode)
              && const_12_to_13_operand (operands[8], E_VOIDmode)
              && const_6_to_7_operand (operands[9], E_VOIDmode)
              && const_14_to_15_operand (operands[10], E_VOIDmode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 6540; /* avx512f_shufpd512_1_mask */
          if (!const_0_to_7_operand (operands[3], E_VOIDmode)
              || pattern1689 () != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20223 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7761; /* avx512f_shuf_f64x2_1_mask */

        case E_V8DImode:
          if (pattern1600 (x2, 
E_V8DImode, 
E_V16DImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 20223 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1
   && (INTVAL (operands[7]) & 1) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && (INTVAL (operands[9]) & 1) == 0
   && INTVAL (operands[9]) == INTVAL (operands[10]) - 1) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7763; /* avx512f_shuf_i64x2_1_mask */

        case E_V8SImode:
          if (pattern1600 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3)))
            return -1;
          return 7769; /* avx512vl_shuf_i32x4_1_mask */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_147 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      operands[4] = x8;
      x10 = XVECEXP (x6, 0, 2);
      operands[5] = x10;
      x11 = XVECEXP (x6, 0, 3);
      operands[6] = x11;
      x24 = XEXP (x2, 1);
      operands[7] = x24;
      x25 = XEXP (x2, 2);
      operands[8] = x25;
      if (!register_operand (operands[8], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1487 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 11516 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4597; /* sse_shufps_v4sf_mask */

        case E_V4DFmode:
          if (pattern1488 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !nonimm_or_0_operand (operands[7], E_V4DFmode))
            return -1;
          if (const_0_to_1_operand (operands[3], E_VOIDmode)
              && const_4_to_5_operand (operands[4], E_VOIDmode)
              && const_2_to_3_operand (operands[5], E_VOIDmode)
              && const_6_to_7_operand (operands[6], E_VOIDmode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14384 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return 6542; /* avx_shufpd256_1_mask */
          if (!const_0_to_3_operand (operands[3], E_VOIDmode)
              || !const_0_to_3_operand (operands[4], E_VOIDmode)
              || !const_4_to_7_operand (operands[5], E_VOIDmode)
              || !const_4_to_7_operand (operands[6], E_VOIDmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20165 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 7759; /* avx512dq_shuf_f64x2_1_mask */

        case E_V4DImode:
          if (pattern1487 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20165 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL
   && (INTVAL (operands[3]) & 1) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && (INTVAL (operands[5]) & 1) == 0
   && INTVAL (operands[5]) == INTVAL (operands[6]) - 1)))
            return -1;
          return 7757; /* avx512dq_shuf_i64x2_1_mask */

        default:
          return -1;
        }

    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          res = recog_148 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x7;
      if (!const_0_to_1_operand (operands[3], E_VOIDmode)
          || pattern1099 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0)
        return -1;
      operands[4] = x8;
      if (!const_2_to_3_operand (operands[4], E_VOIDmode))
        return -1;
      x24 = XEXP (x2, 1);
      operands[5] = x24;
      if (!nonimm_or_0_operand (operands[5], E_V2DFmode))
        return -1;
      x25 = XEXP (x2, 2);
      operands[6] = x25;
      if (!register_operand (operands[6], E_QImode)
          || !
#line 14426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return -1;
      return 6543; /* sse2_shufpd_v2df_mask */

    case 64:
      return recog_149 (x1, insn, pnum_clobbers);

    case 32:
      if (pattern810 (x6) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x24 = XEXP (x2, 1);
      operands[3] = x24;
      x25 = XEXP (x2, 2);
      operands[4] = x25;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 8L:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 40L)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 9L)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 41L)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 10L)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 42L)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 11L)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 43L
              || pattern1727 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 24L)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 56L)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 25L)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 57L)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 26L)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 58L)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 27L)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 59L
              || pattern1732 (x6) != 0
              || pattern1432 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7665; /* avx2_interleave_highv32qi_mask */

        case 0L:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 32L)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 33L)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 2L)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 34L)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 3L)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 35L)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 16L)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 48L)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 17L)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 49L)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 18L)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 50L)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 19L)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 51L)
            return -1;
          x16 = XVECEXP (x6, 0, 8);
          switch (XWINT (x16, 0))
            {
            case 4L:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 36L)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 37L)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 38L)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 39L)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 20L)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 52L)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 21L)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 53L)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 22L)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 54L)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 23L)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 55L
                  || pattern1432 (x2, 
E_V32QImode, 
E_V64QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                return -1;
              return 7671; /* avx2_interleave_lowv32qi_mask */

            case 8L:
              x17 = XVECEXP (x6, 0, 9);
              if (XWINT (x17, 0) != 40L)
                return -1;
              x18 = XVECEXP (x6, 0, 10);
              if (XWINT (x18, 0) != 9L)
                return -1;
              x19 = XVECEXP (x6, 0, 11);
              if (XWINT (x19, 0) != 41L)
                return -1;
              x20 = XVECEXP (x6, 0, 12);
              if (XWINT (x20, 0) != 10L)
                return -1;
              x21 = XVECEXP (x6, 0, 13);
              if (XWINT (x21, 0) != 42L)
                return -1;
              x22 = XVECEXP (x6, 0, 14);
              if (XWINT (x22, 0) != 11L)
                return -1;
              x23 = XVECEXP (x6, 0, 15);
              if (XWINT (x23, 0) != 43L)
                return -1;
              x34 = XVECEXP (x6, 0, 24);
              if (XWINT (x34, 0) != 24L)
                return -1;
              x35 = XVECEXP (x6, 0, 25);
              if (XWINT (x35, 0) != 56L)
                return -1;
              x36 = XVECEXP (x6, 0, 26);
              if (XWINT (x36, 0) != 25L)
                return -1;
              x37 = XVECEXP (x6, 0, 27);
              if (XWINT (x37, 0) != 57L)
                return -1;
              x38 = XVECEXP (x6, 0, 28);
              if (XWINT (x38, 0) != 26L)
                return -1;
              x39 = XVECEXP (x6, 0, 29);
              if (XWINT (x39, 0) != 58L)
                return -1;
              x40 = XVECEXP (x6, 0, 30);
              if (XWINT (x40, 0) != 27L)
                return -1;
              x41 = XVECEXP (x6, 0, 31);
              if (XWINT (x41, 0) != 59L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1432 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7693; /* avx512bw_interleave_lowv32hi_mask */

                case E_V32HFmode:
                  if (pattern1432 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7695; /* avx512bw_interleave_lowv32hf_mask */

                case E_V32BFmode:
                  if (pattern1432 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19654 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7697; /* avx512bw_interleave_lowv32bf_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4L:
          x8 = XVECEXP (x6, 0, 1);
          if (XWINT (x8, 0) != 36L)
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (XWINT (x10, 0) != 5L)
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (XWINT (x11, 0) != 37L)
            return -1;
          x12 = XVECEXP (x6, 0, 4);
          if (XWINT (x12, 0) != 6L)
            return -1;
          x13 = XVECEXP (x6, 0, 5);
          if (XWINT (x13, 0) != 38L)
            return -1;
          x14 = XVECEXP (x6, 0, 6);
          if (XWINT (x14, 0) != 7L)
            return -1;
          x15 = XVECEXP (x6, 0, 7);
          if (XWINT (x15, 0) != 39L
              || pattern1727 (x6) != 0)
            return -1;
          x26 = XVECEXP (x6, 0, 16);
          if (XWINT (x26, 0) != 20L)
            return -1;
          x27 = XVECEXP (x6, 0, 17);
          if (XWINT (x27, 0) != 52L)
            return -1;
          x28 = XVECEXP (x6, 0, 18);
          if (XWINT (x28, 0) != 21L)
            return -1;
          x29 = XVECEXP (x6, 0, 19);
          if (XWINT (x29, 0) != 53L)
            return -1;
          x30 = XVECEXP (x6, 0, 20);
          if (XWINT (x30, 0) != 22L)
            return -1;
          x31 = XVECEXP (x6, 0, 21);
          if (XWINT (x31, 0) != 54L)
            return -1;
          x32 = XVECEXP (x6, 0, 22);
          if (XWINT (x32, 0) != 23L)
            return -1;
          x33 = XVECEXP (x6, 0, 23);
          if (XWINT (x33, 0) != 55L
              || pattern1732 (x6) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1432 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7675; /* avx512bw_interleave_highv32hi_mask */

            case E_V32HFmode:
              if (pattern1432 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7677; /* avx512bw_interleave_highv32hf_mask */

            case E_V32BFmode:
              if (pattern1432 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19586 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 7679; /* avx512bw_interleave_highv32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern143 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8050; /* avx2_zero_extendv16qiv16hi2_mask */

    case 1:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24162 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 8058; /* avx512bw_zero_extendv32qiv32hi2_mask */

    case 2:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24232 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
        return -1;
      return 8070; /* *sse4_1_zero_extendv8qiv8hi2_mask_1 */

    case 3:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8082; /* avx512f_zero_extendv16qiv16si2_mask */

    case 4:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8110; /* avx512f_zero_extendv16hiv16si2_mask */

    case 5:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8090; /* *avx2_zero_extendv8qiv8si2_mask_1 */

    case 6:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24553 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8118; /* avx2_zero_extendv8hiv8si2_mask */

    case 7:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8102; /* *sse4_1_zero_extendv4qiv4si2_mask_1 */

    case 8:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24623 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8130; /* *sse4_1_zero_extendv4hiv4si2_mask_1 */

    case 9:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8146; /* *avx512f_zero_extendv8qiv8di2_mask_1 */

    case 10:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8177; /* avx512f_zero_extendv8hiv8di2_mask */

    case 11:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8205; /* avx512f_zero_extendv8siv8di2_mask */

    case 12:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8158; /* *avx2_zero_extendv4qiv4di2_mask_1 */

    case 13:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24955 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8185; /* *avx2_zero_extendv4hiv4di2_mask_1 */

    case 14:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
        return -1;
      return 8211; /* avx2_zero_extendv4siv4di2_mask */

    case 15:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24874 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8170; /* *sse4_1_zero_extendv2qiv2di2_mask_1 */

    case 16:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8197; /* *sse4_1_zero_extendv2hiv2di2_mask_1 */

    case 17:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
        return -1;
      return 8221; /* *sse4_1_zero_extendv2siv2di2_mask_1 */

    case 18:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern814 (x2))
        {
        case 0:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL)))
            return 8066; /* sse4_1_zero_extendv8qiv8hi2_mask */
          break;

        case 1:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24378 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8086; /* avx2_zero_extendv8qiv8si2_mask */
          break;

        case 2:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24744 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return 8142; /* avx512f_zero_extendv8qiv8di2_mask */
          break;

        case 3:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24438 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8098; /* sse4_1_zero_extendv4qiv4si2_mask */
          break;

        case 4:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24611 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8126; /* sse4_1_zero_extendv4hiv4si2_mask */
          break;

        case 5:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24801 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8154; /* avx2_zero_extendv4qiv4di2_mask */
          break;

        case 6:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24944 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return 8181; /* avx2_zero_extendv4hiv4di2_mask */
          break;

        case 7:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8166; /* sse4_1_zero_extendv2qiv2di2_mask */
          break;

        case 8:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25001 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8193; /* sse4_1_zero_extendv2hiv2di2_mask */
          break;

        case 9:
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL)))
            return 8217; /* sse4_1_zero_extendv2siv2di2_mask */
          break;

        default:
          break;
        }
      if (GET_CODE (x5) != SUBREG)
        return -1;
      switch (pattern817 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512BW && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8074; /* *sse4_1_zero_extendv8qiv8hi2_mask_2 */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8094; /* *avx2_zero_extendv8qiv8si2_mask_2 */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ())))
            return -1;
          return 8150; /* *avx512f_zero_extendv8qiv8di2_mask_2 */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8134; /* *sse4_1_zero_extendv4hiv4si2_mask_2 */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8189; /* *avx2_zero_extendv4hiv4di2_mask_2 */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8225; /* *sse4_1_zero_extendv2siv2di2_mask_2 */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8106; /* *sse4_1_zero_extendv4qiv4si2_mask_2 */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 24833 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8162; /* *avx2_zero_extendv4qiv4di2_mask_2 */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 25035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_AVX512VL
   && ix86_pre_reload_split ())))
            return -1;
          return 8201; /* *sse4_1_zero_extendv2hiv2di2_mask_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      switch (pattern124 (x2))
        {
        case 0:
          if (!(
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2310; /* avx512fp16_vmdivv8hf3 */

        case 1:
          if (!
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2318; /* sse_vmdivv4sf3 */

        case 2:
          if (!(
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2326; /* sse2_vmdivv2df3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern912 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2332; /* avx512fp16_divv32hf3_mask */

        case E_V16HFmode:
          if (pattern912 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2335; /* avx512fp16_divv16hf3_mask */

        case E_V8HFmode:
          if (pattern912 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2337; /* avx512fp16_divv8hf3_mask */

        case E_V16SFmode:
          if (pattern912 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2340; /* avx512f_divv16sf3_mask */

        case E_V8SFmode:
          if (pattern912 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2343; /* avx_divv8sf3_mask */

        case E_V4SFmode:
          if (pattern912 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 2345; /* sse_divv4sf3_mask */

        case E_V8DFmode:
          if (pattern912 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2348; /* avx512f_divv8df3_mask */

        case E_V4DFmode:
          if (pattern912 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2351; /* avx_divv4df3_mask */

        case E_V2DFmode:
          if (pattern912 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2353; /* sse2_divv2df3_mask */

        case E_V32BFmode:
          if (pattern122 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9896; /* avx10_2_divbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern122 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9904; /* avx10_2_divbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern122 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
            return -1;
          return 9912; /* avx10_2_divbf16_v8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3963; /* unspec_avx512fp16_fix_truncv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3971; /* unspec_avx512fp16_fix_truncv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3979; /* unspec_avx512fp16_fix_truncv32hi2 */

    case E_V8SImode:
      switch (pattern575 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3987; /* unspec_avx512fp16_fix_truncv8si2 */

        case 1:
          if (!
#line 8774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4262; /* unspec_fix_truncv8sfv8si2 */

        case 2:
          if (!
#line 9547 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4371; /* unspec_fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern576 (x2, 
E_V16SImode))
        {
        case 0:
          if (!(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3995; /* unspec_avx512fp16_fix_truncv16si2 */

        case 1:
          if (!
#line 8754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4246; /* unspec_fix_truncv16sfv16si2 */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern577 (x2))
        {
        case 0:
          if (!(
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4003; /* unspec_avx512fp16_fix_truncv8di2 */

        case 1:
          if (!(
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4400; /* unspec_fix_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4448; /* unspec_fix_truncv8sfv8di2 */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4059; /* unspec_avx512fp16_fix_truncv4si2 */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8793 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4266; /* unspec_fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4392; /* unspec_fix_truncv4dfv4si2 */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 9919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4488; /* unspec_sse2_cvttpd2dq */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern578 (x2))
        {
        case 0:
          if (!
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4063; /* unspec_avx512fp16_fix_truncv4di2 */

        case 1:
          if (!(
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4408; /* unspec_fix_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4456; /* unspec_fix_truncv4sfv4di2 */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern579 (x2))
        {
        case 0:
          if (!
#line 7947 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4083; /* unspec_avx512fp16_fix_truncv2di2 */

        case 1:
          if (!(
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4412; /* unspec_fix_truncv2dfv2di2 */

        case 2:
          if (!
#line 9740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
            return -1;
          return 4472; /* unspec_avx512dq_fix_truncv2sfv2di2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SQRT:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1278 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2420; /* *avx512fp16_vmsqrtv8hf2_round */

        case E_V4SFmode:
          if (pattern1278 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2424; /* *sse_vmsqrtv4sf2_round */

        case E_V2DFmode:
          if (pattern1278 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2428; /* *sse2_vmsqrtv2df2_round */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern820 (x2))
        {
        case 0:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3960; /* avx512fp16_vcvtsi2sh_round */

        case 1:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 4179; /* sse_cvtsi2ss_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern820 (x2))
        {
        case 0:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3962; /* avx512fp16_vcvtusi2sh_round */

        case 1:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8604 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (V4SFmode == V4SFmode))))
            return -1;
          return 4188; /* cvtusi2ss32_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XEXP (x6, 0);
      if (pattern818 (x7, 
1, 
E_HFmode) != 0)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const48_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern1522 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4152; /* avx512fp16_vcvtsh2sd_round */

        case E_V4SFmode:
          if (pattern1522 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4156; /* avx512fp16_vcvtsh2ss_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x9 = XVECEXP (x2, 0, 1);
      operands[3] = x9;
      if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
        return -1;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case VEC_SELECT:
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != PARALLEL
              || XVECLEN (x11, 0) != 1)
            return -1;
          x12 = XVECEXP (x11, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern1279 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          switch (GET_MODE (x7))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4163; /* avx512fp16_vcvtsd2sh_round */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                return -1;
              return 4167; /* avx512fp16_vcvtss2sh_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_V2DFmode)
              || pattern1279 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9990 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4494; /* sse2_cvtsd2ss_round */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 94)
        return -1;
      x13 = XVECEXP (x6, 0, 0);
      operands[2] = x13;
      x14 = XVECEXP (x6, 0, 1);
      operands[3] = x14;
      if (!const_0_to_255_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x9 = XVECEXP (x2, 0, 1);
      operands[4] = x9;
      if (!const48_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1435 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 6532; /* *avx512f_rndscalev8hf_round */

        case E_V4SFmode:
          if (pattern1435 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
            return -1;
          return 6534; /* *avx512f_rndscalev4sf_round */

        case E_V2DFmode:
          if (pattern1435 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 6536; /* *avx512f_rndscalev2df_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern583 (x2))
        {
        case 0:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2165; /* *addv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2173; /* *addv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2181; /* *addv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2189; /* *addv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2197; /* *addv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2205; /* *addv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2213; /* *addv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2221; /* *addv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2229; /* *addv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2241; /* avx512fp16_vmaddv8hf3_round */

        case 10:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2249; /* sse_vmaddv4sf3_round */

        case 11:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2257; /* sse2_vmaddv2df3_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern583 (x2))
        {
        case 0:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2169; /* *subv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2177; /* *subv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2185; /* *subv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2193; /* *subv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2201; /* *subv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2209; /* *subv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2217; /* *subv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2225; /* *subv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2233; /* *subv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2245; /* avx512fp16_vmsubv8hf3_round */

        case 10:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2253; /* sse_vmsubv4sf3_round */

        case 11:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2261; /* sse2_vmsubv2df3_round */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_206 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern583 (x2))
        {
        case 0:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2267; /* *mulv32hf3_mask_round */

        case 1:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V16HFmode == V16SFmode
							      || V16HFmode == V8DFmode
							      || V16HFmode == V8DImode
							      || V16HFmode == V16SImode
							      || V16HFmode == V32HFmode)) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2271; /* *mulv16hf3_mask_round */

        case 2:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V8HFmode == V16SFmode
							      || V8HFmode == V8DFmode
							      || V8HFmode == V8DImode
							      || V8HFmode == V16SImode
							      || V8HFmode == V32HFmode)) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2275; /* *mulv8hf3_mask_round */

        case 3:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2279; /* *mulv16sf3_mask_round */

        case 4:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V8SFmode == V16SFmode
							      || V8SFmode == V8DFmode
							      || V8SFmode == V8DImode
							      || V8SFmode == V16SImode
							      || V8SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2283; /* *mulv8sf3_mask_round */

        case 5:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V4SFmode == V16SFmode
							      || V4SFmode == V8DFmode
							      || V4SFmode == V8DImode
							      || V4SFmode == V16SImode
							      || V4SFmode == V32HFmode)))))
            return -1;
          return 2287; /* *mulv4sf3_mask_round */

        case 6:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2291; /* *mulv8df3_mask_round */

        case 7:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && (V4DFmode == V16SFmode
							      || V4DFmode == V8DFmode
							      || V4DFmode == V8DImode
							      || V4DFmode == V16SImode
							      || V4DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2295; /* *mulv4df3_mask_round */

        case 8:
          if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2753 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && (V2DFmode == V16SFmode
							      || V2DFmode == V8DFmode
							      || V2DFmode == V8DImode
							      || V2DFmode == V16SImode
							      || V2DFmode == V32HFmode)) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2299; /* *mulv2df3_mask_round */

        case 9:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2307; /* avx512fp16_vmmulv8hf3_round */

        case 10:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2315; /* sse_vmmulv4sf3_round */

        case 11:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2323; /* sse2_vmmulv2df3_round */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          switch (pattern582 (x2))
            {
            case 0:
              if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2311; /* avx512fp16_vmdivv8hf3_round */

            case 1:
              if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2319; /* sse_vmdivv4sf3_round */

            case 2:
              if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2327; /* sse2_vmdivv2df3_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern584 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2333; /* avx512fp16_divv32hf3_mask_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2341; /* avx512f_divv16sf3_mask_round */

            case 2:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2902 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2349; /* avx512f_divv8df3_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1276 (x2, 
E_SImode, 
E_V32HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2386; /* avx512fp16_sqrtv32hf2_mask_round */

            case E_V16SFmode:
              if (pattern1276 (x2, 
E_HImode, 
E_V16SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2394; /* avx512f_sqrtv16sf2_mask_round */

            case E_V8DFmode:
              if (pattern1276 (x2, 
E_QImode, 
E_V8DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3068 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2402; /* avx512f_sqrtv8df2_mask_round */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1277 (x2, 
E_V8HFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2408; /* avx512fp16_vmsqrtv8hf2_round */

            case E_V4SFmode:
              if (pattern1277 (x2, 
E_V4SFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2412; /* sse_vmsqrtv4sf2_round */

            case E_V2DFmode:
              if (pattern1277 (x2, 
E_V2DFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2416; /* sse2_vmsqrtv2df2_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_209 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern585 (x2))
        {
        case 0:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2464; /* *smaxv32hf3_mask_round */

        case 1:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2480; /* *smaxv16sf3_mask_round */

        case 2:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2496; /* *smaxv8df3_mask_round */

        case 3:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2578; /* *avx512fp16_vmsmaxv8hf3_round */

        case 4:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2586; /* *sse_vmsmaxv4sf3_round */

        case 5:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2594; /* *sse2_vmsmaxv2df3_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern585 (x2))
        {
        case 0:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2468; /* *sminv32hf3_mask_round */

        case 1:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2484; /* *sminv16sf3_mask_round */

        case 2:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2500; /* *sminv8df3_mask_round */

        case 3:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2582; /* *avx512fp16_vmsminv8hf3_round */

        case 4:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2590; /* *sse_vmsminv4sf3_round */

        case 5:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2598; /* *sse2_vmsminv2df3_round */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_208 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_207 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1193 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3890; /* avx512fp16_vcvtw2ph_v8hi_mask_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3914; /* avx512fp16_vcvtdq2ph_v8si_mask_round */

            case 2:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 3930; /* avx512fp16_vcvtqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1194 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3898; /* avx512fp16_vcvtw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 3922; /* avx512fp16_vcvtdq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern586 (x2, 
E_SImode, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 3906; /* avx512fp16_vcvtw2ph_v32hi_mask_round */

        case E_V16SFmode:
          if (pattern586 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16SImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 433 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 4193; /* floatv16siv16sf2_mask_round */

        case E_V8DFmode:
          if (pattern1195 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4301; /* floatv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1195 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4309; /* floatv4div4df2_mask_round */

        case E_V2DFmode:
          if (pattern1195 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4317; /* floatv2div2df2_mask_round */

        case E_V8SFmode:
          if (pattern1195 (x2, 
E_V8SFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4325; /* floatv8div8sf2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          switch (pattern1193 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3894; /* avx512fp16_vcvtuw2ph_v8hi_mask_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3918; /* avx512fp16_vcvtudq2ph_v8si_mask_round */

            case 2:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 3934; /* avx512fp16_vcvtuqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          switch (pattern1194 (x2))
            {
            case 0:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 3902; /* avx512fp16_vcvtuw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 3926; /* avx512fp16_vcvtudq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern586 (x2, 
E_SImode, 
E_V32HFmode, 
E_V32HImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7650 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 3910; /* avx512fp16_vcvtuw2ph_v32hi_mask_round */

        case E_V16SFmode:
          if (pattern1195 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4201; /* floatunsv16siv16sf2_mask_round */

        case E_V8SFmode:
          if (pattern1196 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4205; /* floatunsv8siv8sf2_mask_round */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
							      || V8DImode == V8DFmode
							      || V8DImode == V8DImode
							      || V8DImode == V16SImode
							      || V8DImode == V32HFmode)) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4329; /* floatunsv8div8sf2_mask_round */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern1195 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 539 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4209; /* floatunsv4siv4sf2_mask_round */

        case E_V8DFmode:
          if (pattern1195 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4305; /* floatunsv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1195 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4313; /* floatunsv4div4df2_mask_round */

        case E_V2DFmode:
          if (pattern1195 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4321; /* floatunsv2div2df2_mask_round */

        default:
          return -1;
        }

    case FIX:
      switch (pattern587 (x2))
        {
        case 0:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4014; /* avx512fp16_fix_truncv8hi2_mask_round */

        case 1:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4022; /* avx512fp16_fix_truncv16hi2_mask_round */

        case 2:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4030; /* avx512fp16_fix_truncv32hi2_mask_round */

        case 3:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4038; /* avx512fp16_fix_truncv8si2_mask_round */

        case 4:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4382; /* fix_truncv8dfv8si2_mask_round */

        case 5:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4046; /* avx512fp16_fix_truncv16si2_mask_round */

        case 6:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4257; /* fix_truncv16sfv16si2_mask_round */

        case 7:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4054; /* avx512fp16_fix_truncv8di2_mask_round */

        case 8:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4419; /* fix_truncv8dfv8di2_mask_round */

        case 9:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4463; /* fix_truncv8sfv8di2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern587 (x2))
        {
        case 0:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4018; /* avx512fp16_fixuns_truncv8hi2_mask_round */

        case 1:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4026; /* avx512fp16_fixuns_truncv16hi2_mask_round */

        case 2:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4034; /* avx512fp16_fixuns_truncv32hi2_mask_round */

        case 3:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4042; /* avx512fp16_fixuns_truncv8si2_mask_round */

        case 4:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4386; /* fixuns_truncv8dfv8si2_mask_round */

        case 5:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4050; /* avx512fp16_fixuns_truncv16si2_mask_round */

        case 6:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4261; /* fixuns_truncv16sfv16si2_mask_round */

        case 7:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4058; /* avx512fp16_fixuns_truncv8di2_mask_round */

        case 8:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4423; /* fixuns_truncv8dfv8di2_mask_round */

        case 9:
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DImode == V16SFmode
									      || V8DImode == V8DFmode
									      || V8DImode == V8DImode
									      || V8DImode == V16SImode
									      || V8DImode == V32HFmode)) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4467; /* fixuns_truncv8sfv8di2_mask_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XVECEXP (x2, 0, 1);
      if (!const48_operand (x7, E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          x8 = XEXP (x3, 2);
          operands[3] = x8;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1196 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (!register_operand (operands[1], E_V8HFmode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                    return -1;
                  return 4108; /* avx512fp16_float_extend_phv8df2_mask_round */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                    return -1;
                  return 4515; /* avx512f_cvtps2pd512_mask_round */

                default:
                  return -1;
                }

            case E_V16SFmode:
              if (pattern586 (x2, 
E_HImode, 
E_V16SFmode, 
E_V16HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4112; /* avx512fp16_float_extend_phv16sf2_mask_round */

            case E_V8SFmode:
              if (pattern586 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4116; /* avx512fp16_float_extend_phv8sf2_mask_round */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x5) != E_V2SFmode)
            return -1;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 2)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x10, 0, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x3, 2);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern1339 (x2) != 0)
            return -1;
          x13 = XEXP (x5, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[1] = x9;
          if (!register_operand (operands[1], E_V2DFmode))
            return -1;
          operands[3] = x7;
          if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10034 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4499; /* sse2_cvtss2sd_round */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1196 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4132; /* avx512fp16_vcvtpd2ph_v8df_mask_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4140; /* avx512fp16_vcvtps2ph_v8sf_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern586 (x2, 
E_HImode, 
E_V16HFmode, 
E_V16SFmode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4136; /* avx512fp16_vcvtps2ph_v16sf_mask_round */

        case E_V8SFmode:
          if (pattern586 (x2, 
E_QImode, 
E_V8SFmode, 
E_V8DFmode) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4506; /* avx512f_cvtpd2ps512_mask_round */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V32HFmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != FLOAT_TRUNCATE
          || GET_MODE (x5) != E_V16HFmode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != FLOAT_TRUNCATE
          || GET_MODE (x6) != E_V16HFmode
          || !register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || GET_MODE (x3) != E_V32HFmode)
        return -1;
      x13 = XEXP (x5, 0);
      operands[2] = x13;
      if (!register_operand (operands[2], E_V16SFmode))
        return -1;
      x14 = XEXP (x6, 0);
      operands[1] = x14;
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!nonimm_or_0_operand (operands[3], E_V32HFmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 1);
      operands[5] = x7;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode)
          || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31714 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 561 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))))
        return -1;
      return 9725; /* avx10_2_cvt2ps2phx_v32hf_mask_round */

    default:
      return -1;
    }
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_261 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  operands[4] = x5;
  x8 = XVECEXP (x3, 0, 2);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 3);
  operands[6] = x9;
  x10 = XVECEXP (x3, 0, 4);
  operands[7] = x10;
  x11 = XVECEXP (x3, 0, 5);
  operands[8] = x11;
  x12 = XVECEXP (x3, 0, 6);
  operands[9] = x12;
  x13 = XVECEXP (x3, 0, 7);
  operands[10] = x13;
  x14 = XVECEXP (x3, 0, 8);
  operands[11] = x14;
  x15 = XVECEXP (x3, 0, 9);
  operands[12] = x15;
  x16 = XVECEXP (x3, 0, 10);
  operands[13] = x16;
  x17 = XVECEXP (x3, 0, 11);
  operands[14] = x17;
  x18 = XVECEXP (x3, 0, 12);
  operands[15] = x18;
  x19 = XVECEXP (x3, 0, 13);
  operands[16] = x19;
  x20 = XVECEXP (x3, 0, 14);
  operands[17] = x20;
  x21 = XVECEXP (x3, 0, 15);
  operands[18] = x21;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (pattern1289 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0)
        return -1;
      if (const_0_to_3_operand (operands[3], E_VOIDmode)
          && const_0_to_3_operand (operands[4], E_VOIDmode)
          && const_16_to_19_operand (operands[5], E_VOIDmode)
          && const_16_to_19_operand (operands[6], E_VOIDmode)
          && const_4_to_7_operand (operands[7], E_VOIDmode)
          && const_4_to_7_operand (operands[8], E_VOIDmode)
          && const_20_to_23_operand (operands[9], E_VOIDmode)
          && const_20_to_23_operand (operands[10], E_VOIDmode)
          && const_8_to_11_operand (operands[11], E_VOIDmode)
          && const_8_to_11_operand (operands[12], E_VOIDmode)
          && const_24_to_27_operand (operands[13], E_VOIDmode)
          && const_24_to_27_operand (operands[14], E_VOIDmode)
          && const_12_to_15_operand (operands[15], E_VOIDmode)
          && const_12_to_15_operand (operands[16], E_VOIDmode)
          && const_28_to_31_operand (operands[17], E_VOIDmode)
          && const_28_to_31_operand (operands[18], E_VOIDmode)
          && 
#line 14270 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && (INTVAL (operands[3]) == (INTVAL (operands[7]) - 4)
       && INTVAL (operands[4]) == (INTVAL (operands[8]) - 4)
       && INTVAL (operands[5]) == (INTVAL (operands[9]) - 4)
       && INTVAL (operands[6]) == (INTVAL (operands[10]) - 4)
       && INTVAL (operands[3]) == (INTVAL (operands[11]) - 8)
       && INTVAL (operands[4]) == (INTVAL (operands[12]) - 8)
       && INTVAL (operands[5]) == (INTVAL (operands[13]) - 8)
       && INTVAL (operands[6]) == (INTVAL (operands[14]) - 8)
       && INTVAL (operands[3]) == (INTVAL (operands[15]) - 12)
       && INTVAL (operands[4]) == (INTVAL (operands[16]) - 12)
       && INTVAL (operands[5]) == (INTVAL (operands[17]) - 12)
       && INTVAL (operands[6]) == (INTVAL (operands[18]) - 12))))
        return 6537; /* avx512f_shufps512_1 */
      if (!const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1698 () != 0
          || !(
#line 20401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7772; /* avx512f_shuf_f32x4_1 */

    case E_V16SImode:
      if (pattern1289 (x2, 
E_V16SImode, 
E_V32SImode) != 0
          || !const_0_to_15_operand (operands[3], E_VOIDmode)
          || pattern1698 () != 0
          || !(
#line 20401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3]) & 3) == 0
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[5]) - 2
   && INTVAL (operands[3]) == INTVAL (operands[6]) - 3
   && (INTVAL (operands[7]) & 3) == 0
   && INTVAL (operands[7]) == INTVAL (operands[8]) - 1
   && INTVAL (operands[7]) == INTVAL (operands[9]) - 2
   && INTVAL (operands[7]) == INTVAL (operands[10]) - 3
   && (INTVAL (operands[11]) & 3) == 0
   && INTVAL (operands[11]) == INTVAL (operands[12]) - 1
   && INTVAL (operands[11]) == INTVAL (operands[13]) - 2
   && INTVAL (operands[11]) == INTVAL (operands[14]) - 3
   && (INTVAL (operands[15]) & 3) == 0
   && INTVAL (operands[15]) == INTVAL (operands[16]) - 1
   && INTVAL (operands[15]) == INTVAL (operands[17]) - 2
   && INTVAL (operands[15]) == INTVAL (operands[18]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7774; /* avx512f_shuf_i32x4_1 */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x2, 1);
      switch (XVECLEN (x5, 0))
        {
        case 4:
          res = recog_258 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_260 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_262 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 2:
          res = recog_263 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 64:
          res = recog_264 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 32:
          res = recog_265 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x4;
      if (XVECLEN (x5, 0) < 1)
        return -1;
      operands[3] = x5;
      x6 = XVECEXP (x5, 0, 0);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern1289 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 28314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SImode)))
            return -1;
          return 8744; /* *avx_vperm2f128v8si_nozero */

        case E_V8SFmode:
          if (pattern1289 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 28314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V8SFmode)))
            return -1;
          return 8745; /* *avx_vperm2f128v8sf_nozero */

        case E_V4DFmode:
          if (pattern1289 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !
#line 28314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && avx_vperm2f128_parallel (operands[3], V4DFmode)))
            return -1;
          return 8746; /* *avx_vperm2f128v4df_nozero */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (pattern739 (x2))
        {
        case 0:
          if (!
#line 24123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8051; /* *avx2_zero_extendv16qiv16hi2_1 */

        case 1:
          if (!
#line 24176 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 8059; /* *avx512bw_zero_extendv32qiv32hi2_1 */

        case 2:
          if (!
#line 24272 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8075; /* *sse4_1_zero_extendv8qiv8hi2_3 */

        case 3:
          if (!
#line 24520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 8111; /* avx512f_zero_extendv16hiv16si2_1 */

        case 4:
          if (!
#line 24574 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 8119; /* avx2_zero_extendv8hiv8si2_1 */

        case 5:
          if (!
#line 24679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return -1;
          return 8135; /* *sse4_1_zero_extendv4hiv4si2_3 */

        case 6:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8206; /* *avx512f_zero_extendv8siv8di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8922; /* *vec_concatv16si_0_1 */

        case 7:
          if (pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25128 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 8212; /* *avx2_zero_extendv4siv4di2_1 */
          if (!movq_parallel (operands[3], E_VOIDmode)
              || !(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8923; /* *vec_concatv8si_0_1 */

        case 8:
          if (vector_operand (operands[1], E_V4SImode)
              && pmovzx_parallel (operands[3], E_VOIDmode)
              && 
#line 25213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
            return 8226; /* *sse4_1_zero_extendv2siv2di2_3 */
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !movq_parallel (operands[3], E_VOIDmode)
              || !
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8924; /* *vec_concatv4si_0_1 */

        case 9:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8925; /* *vec_concatv8di_0_1 */

        case 10:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8926; /* *vec_concatv4di_0_1 */

        case 11:
          if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8927; /* *vec_concatv2di_0_1 */

        case 12:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8928; /* *vec_concatv32hf_0_1 */

        case 13:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8929; /* *vec_concatv16hf_0_1 */

        case 14:
          if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8930; /* *vec_concatv8hf_0_1 */

        case 15:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8931; /* *vec_concatv32bf_0_1 */

        case 16:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8932; /* *vec_concatv16bf_0_1 */

        case 17:
          if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8933; /* *vec_concatv8bf_0_1 */

        case 18:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8934; /* *vec_concatv16sf_0_1 */

        case 19:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8935; /* *vec_concatv8sf_0_1 */

        case 20:
          if (!
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 8936; /* *vec_concatv4sf_0_1 */

        case 21:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8937; /* *vec_concatv8df_0_1 */

        case 22:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8938; /* *vec_concatv4df_0_1 */

        case 23:
          if (!(
#line 29050 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8939; /* *vec_concatv2df_0_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_274 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x4;
  res = recog_276 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x4, 0) != 0L
      || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern764 (x3, 
11, 
10, 
9, 
8) != 0
      || !register_operand (operands[0], E_V16HImode)
      || GET_MODE (x2) != E_V16HImode
      || !nonimmediate_operand (operands[1], E_V16HImode)
      || pattern1348 (x3) != 0)
    return -1;
  x8 = XVECEXP (x3, 0, 12);
  operands[6] = x8;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 13);
  operands[7] = x9;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 14);
  operands[8] = x10;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 15);
  operands[9] = x11;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode)
      || !
#line 20925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2
   && 1 && 1
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9])))
    return -1;
  return 7794; /* avx2_pshufhw_1 */
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4867; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4894; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4921; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4948; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4975; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5002; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5029; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5056; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5083; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5110; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5137; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5164; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4870; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4897; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4924; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4951; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4978; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5005; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5032; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5059; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5086; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5113; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5140; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5167; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4873; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4900; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 4927; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4954; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4981; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5008; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5035; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5062; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5089; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5116; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5143; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5170; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6151; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6160; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6169; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6178; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6187; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6196; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6205; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6214; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6223; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6232; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6241; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6250; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5515; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5542; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5569; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5596; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5623; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5650; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5677; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5704; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5731; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5758; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5785; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5812; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5518; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5545; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5572; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5599; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5626; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5653; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5680; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5707; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5734; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5761; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5788; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5815; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5521; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5548; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5575; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5602; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5629; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5656; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5683; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5710; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5737; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5764; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5791; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5818; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5193; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5220; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5247; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5274; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5301; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5328; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5355; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5382; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5409; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5436; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5463; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5490; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5196; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5223; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5250; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5277; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5304; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5331; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5358; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5385; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5412; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5439; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5466; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5493; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5199; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5226; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5253; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5280; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5307; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5334; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5361; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5388; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5415; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5442; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5469; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5496; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6261; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6270; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6279; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6288; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6297; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6306; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6315; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6324; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6333; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6342; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6351; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6360; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5841; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5868; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5895; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5922; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5949; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5976; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6003; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6030; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6057; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6084; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6111; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6138; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5844; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5871; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5898; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5925; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5952; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5979; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6006; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6033; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6060; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6087; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6114; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6141; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5847; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5874; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5901; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5928; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5955; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5982; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6009; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6036; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6063; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6090; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6117; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6144; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x3) != E_V8DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode)
                  || !(
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4105; /* avx512fp16_float_extend_phv8df2 */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1 && 1) && 
#line 467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4512; /* avx512f_cvtps2pd512 */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x3) != E_V16SFmode
              || !vector_operand (operands[1], E_V16HFmode)
              || !(
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4109; /* avx512fp16_float_extend_phv16sf2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !(
#line 8022 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4113; /* avx512fp16_float_extend_phv8sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode)
                  || !
#line 8061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4121; /* *avx512fp16_float_extend_phv4df2_load */

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode)
                  || !
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1 && 1))
                return -1;
              return 4516; /* avx_cvtps2pd256 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_V4HFmode)
              || !
#line 8061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4123; /* *avx512fp16_float_extend_phv4sf2_load */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode)
                  || !
#line 8100 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4127; /* *avx512fp16_float_extend_phv2df2_load */

            case E_V2SFmode:
              if (!memory_operand (operands[1], E_V2SFmode)
                  || !
#line 10389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                return -1;
              return 4564; /* sse2_cvtps2pd_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          switch (pattern1031 (x5))
            {
            case 0:
              if (XWINT (x9, 0) != 2L
                  || XWINT (x10, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || GET_MODE (x3) != E_V4DFmode)
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_V4HFmode:
                      if (!register_operand (operands[1], E_V8HFmode)
                          || !
#line 8051 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                        return -1;
                      return 4117; /* avx512fp16_float_extend_phv4df2 */

                    case E_V4SFmode:
                      if (!nonimmediate_operand (operands[1], E_V8SFmode)
                          || !
#line 10220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                        return -1;
                      return 4518; /* *avx_cvtps2pd256_2 */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (pattern777 (x3, 
E_V8HFmode, 
E_V4HFmode, 
E_V4SFmode) != 0
                      || !
#line 8051 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                    return -1;
                  return 4119; /* avx512fp16_float_extend_phv4sf2 */

                default:
                  return -1;
                }

            case 1:
              if (XWINT (x9, 0) != 4L
                  || XWINT (x10, 0) != 6L)
                return -1;
              switch (pattern1344 (x3))
                {
                case 0:
                  if (!
#line 31658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9714; /* vcvtneeph2ps_v8hf */

                case 1:
                  if (!
#line 31658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9715; /* vcvtneebf162ps_v8bf */

                default:
                  return -1;
                }

            case 2:
              switch (pattern1344 (x3))
                {
                case 0:
                  if (!
#line 31686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9718; /* vcvtneoph2ps_v8hf */

                case 1:
                  if (!
#line 31686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9719; /* vcvtneobf162ps_v8bf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_V2HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !
#line 8090 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
                return -1;
              return 4125; /* avx512fp16_float_extend_phv2df2 */

            case E_V2SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 10375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
                return -1;
              return 4562; /* sse2_cvtps2pd */

            default:
              return -1;
            }

        case 8:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT
              || pattern839 (x5) != 0)
            return -1;
          switch (pattern1031 (x5))
            {
            case 0:
              if (pattern1409 (x5) != 0
                  || pattern838 (x3, 
E_V16SFmode, 
E_V8SFmode, 
E_V8DFmode) != 0
                  || !
#line 10235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
                return -1;
              return 4519; /* vec_unpacks_lo_v16sf */

            case 1:
              x9 = XVECEXP (x5, 0, 2);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x5, 0, 3);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x11 = XVECEXP (x5, 0, 4);
              if (XWINT (x11, 0) != 8L)
                return -1;
              x12 = XVECEXP (x5, 0, 5);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x5, 0, 6);
              if (XWINT (x13, 0) != 12L)
                return -1;
              x14 = XVECEXP (x5, 0, 7);
              if (XWINT (x14, 0) != 14L)
                return -1;
              switch (pattern1601 (x3))
                {
                case 0:
                  if (!
#line 31673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9716; /* vcvtneeph2ps_v16hf */

                case 1:
                  if (!
#line 31673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9717; /* vcvtneebf162ps_v16bf */

                default:
                  return -1;
                }

            case 2:
              x11 = XVECEXP (x5, 0, 4);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x5, 0, 5);
              if (XWINT (x12, 0) != 11L)
                return -1;
              x13 = XVECEXP (x5, 0, 6);
              if (XWINT (x13, 0) != 13L)
                return -1;
              x14 = XVECEXP (x5, 0, 7);
              if (XWINT (x14, 0) != 15L)
                return -1;
              switch (pattern1601 (x3))
                {
                case 0:
                  if (!
#line 31701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9720; /* vcvtneoph2ps_v16hf */

                case 1:
                  if (!
#line 31701 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT))
                    return -1;
                  return 9721; /* vcvtneobf162ps_v16bf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern31 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6991; /* *ashlv16hi3 */
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7015; /* ashlv16hi3 */
      if (!nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8892; /* avx512vl_ashlvv16hi */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return 6995; /* *ashlv8hi3 */
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7017; /* ashlv8hi3 */
      if (!nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 8888; /* avx512vl_ashlvv8hi */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 6999; /* *ashlv8si3 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7019; /* ashlv8si3 */
      if (!nonimmediate_operand (operands[2], E_V8SImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8868; /* avx2_ashlvv8si */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7003; /* *ashlv4si3 */
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7021; /* ashlv4si3 */
      if (!nonimmediate_operand (operands[2], E_V4SImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8872; /* avx2_ashlvv4si */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7007; /* *ashlv4di3 */
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && (
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 776 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return 7023; /* ashlv4di3 */
      if (!nonimmediate_operand (operands[2], E_V4DImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8880; /* avx2_ashlvv4di */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && 
#line 17276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
        return 7011; /* *ashlv2di3 */
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      if (nonmemory_operand (operands[2], E_DImode)
          && 
#line 17290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return 7025; /* ashlv2di3 */
      if (!nonimmediate_operand (operands[2], E_V2DImode)
          || !
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8884; /* avx2_ashlvv2di */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return 7031; /* ashlv32hi3 */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 28925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 8896; /* avx512bw_ashlvv32hi */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7035; /* ashlv16si3 */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8864; /* avx512f_ashlvv16si */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 17364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7039; /* ashlv8di3 */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 28914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && 1) && 
#line 804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 8876; /* avx512f_ashlvv8di */

    case 9:
      if (!(
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7043; /* avx512bw_ashlv4ti3 */

    case 10:
      if (nonimmediate_operand (operands[1], E_V2TImode)
          && (
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7045; /* avx512bw_ashlv2ti3 */
      if (!register_operand (operands[1], E_V2TImode)
          || !(
#line 17598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 732 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7049; /* avx2_ashlv2ti3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V1TImode)
          && (
#line 17583 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7047; /* avx512bw_ashlv1ti3 */
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 17598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 7051; /* sse2_ashlv1ti3 */

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9426; /* vpopcountv16si */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9428; /* vpopcountv8si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9430; /* vpopcountv4si */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9432; /* vpopcountv8di */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9434; /* vpopcountv4di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9436; /* vpopcountv2di */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !nonimmediate_operand (operands[1], E_V64QImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9438; /* vpopcountv64qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9440; /* vpopcountv16qi */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !nonimmediate_operand (operands[1], E_V32QImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9442; /* vpopcountv32qi */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !nonimmediate_operand (operands[1], E_V32HImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9444; /* vpopcountv32hi */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !nonimmediate_operand (operands[1], E_V16HImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9446; /* vpopcountv16hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode)
          || !(
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9448; /* vpopcountv8hi */

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2461; /* *smaxv32hf3 */

    case 1:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2469; /* *smaxv16hf3 */

    case 2:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2473; /* *smaxv8hf3 */

    case 3:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2477; /* *smaxv16sf3 */

    case 4:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2485; /* *smaxv8sf3 */

    case 5:
      if (!
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 2489; /* *smaxv4sf3 */

    case 6:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2493; /* *smaxv8df3 */

    case 7:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2501; /* *smaxv4df3 */

    case 8:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2505; /* *smaxv2df3 */

    case 9:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7101; /* *avx2_smaxv32qi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7177; /* *avx512bw_smaxv32qi3 */

    case 10:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7105; /* *avx2_smaxv16hi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7193; /* *avx512bw_smaxv16hi3 */

    case 11:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7109; /* *avx2_smaxv8si3 */
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7121; /* *avx512f_smaxv8si3 */

    case 12:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7113; /* *avx512f_smaxv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7129; /* *avx512f_smaxv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7213; /* *sse4_1_smaxv4si3 */

    case 14:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7137; /* *avx512f_smaxv8di3 */

    case 15:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7145; /* *avx512f_smaxv4di3 */

    case 16:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7153; /* *avx512f_smaxv2di3 */

    case 17:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7161; /* *avx512bw_smaxv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7169; /* *avx512bw_smaxv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7209; /* *sse4_1_smaxv16qi3 */

    case 19:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7185; /* *avx512bw_smaxv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7201; /* *avx512bw_smaxv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17816 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7217; /* *smaxv8hi3 */

    case 21:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9877; /* avx10_2_smaxbf16_v32bf */

    case 22:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9881; /* avx10_2_smaxbf16_v16bf */

    case 23:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9885; /* avx10_2_smaxbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7103; /* *avx2_umaxv32qi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7181; /* *avx512bw_umaxv32qi3 */

    case 1:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7107; /* *avx2_umaxv16hi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7197; /* *avx512bw_umaxv16hi3 */

    case 2:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7111; /* *avx2_umaxv8si3 */
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7125; /* *avx512f_umaxv8si3 */

    case 3:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7117; /* *avx512f_umaxv16si3 */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7133; /* *avx512f_umaxv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7223; /* *sse4_1_umaxv4si3 */

    case 5:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7141; /* *avx512f_umaxv8di3 */

    case 6:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7149; /* *avx512f_umaxv4di3 */

    case 7:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7157; /* *avx512f_umaxv2di3 */

    case 8:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7165; /* *avx512bw_umaxv64qi3 */

    case 9:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7173; /* *avx512bw_umaxv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17900 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7227; /* *umaxv16qi3 */

    case 10:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7189; /* *avx512bw_umaxv32hi3 */

    case 11:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7205; /* *avx512bw_umaxv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7219; /* *sse4_1_umaxv8hi3 */

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode)
          || !
#line 23726 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1368; /* sqrtxf2 */

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !nonimmediate_operand (operands[1], E_HFmode)
          || !
#line 23787 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
        return -1;
      return 1371; /* sqrthf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_SFmode)
          || !
#line 23800 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
        return -1;
      return 1372; /* *sqrtsf2_sse */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimmediate_operand (operands[1], E_DFmode)
          || !
#line 23800 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
        return -1;
      return 1373; /* *sqrtdf2_sse */

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (XWINT (x4, 0) != 1L)
        return -1;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 110; /* *extvsi_1_0 */

        case LTU:
        case UNLT:
          if (pattern504 (operands[1]) != 0)
            return -1;
          return 1448; /* *x86_movsicc_0_m1_se */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x3, 1);
      if (XWINT (x4, 0) == 1L)
        {
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) == SUBREG)
            {
              switch (pattern1202 (x2))
                {
                case 0:
                  if (
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                    return 1181; /* *btsi_setcqi */
                  break;

                case 1:
                  if ((
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1182; /* *btdi_setcqi */
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x3, 2);
          if (GET_CODE (x5) == SUBREG)
            {
              switch (pattern1204 (x2))
                {
                case 0:
                  if (
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                    return 1189; /* *btsi_setcsi_mask */
                  break;

                case 1:
                  if ((
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1190; /* *btdi_setcdi_mask */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      if (!const_0_to_255_operand (operands[3], E_QImode)
          || !
#line 22172 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
        return -1;
      return 1296; /* tbm_bextri_si */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern496 (x1))
    {
    case 0:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2815; /* *avx512f_cmpv16si3_zero_extendhi_2 */

    case 1:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2836; /* *avx512vl_cmpv16hf3_zero_extendhi_2 */

    case 2:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2842; /* *avx512f_cmpv16sf3_zero_extendhi_2 */

    case 3:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2908; /* *avx512vl_cmpv16qi3_zero_extendhi_2 */

    case 4:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2917; /* *avx512vl_cmpv16hi3_zero_extendhi_2 */

    case 5:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2818; /* *avx512vl_cmpv8si3_zero_extendhi_2 */

    case 6:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2821; /* *avx512vl_cmpv4si3_zero_extendhi_2 */

    case 7:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2824; /* *avx512f_cmpv8di3_zero_extendhi_2 */

    case 8:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2827; /* *avx512vl_cmpv4di3_zero_extendhi_2 */

    case 9:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2830; /* *avx512vl_cmpv2di3_zero_extendhi_2 */

    case 10:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2839; /* *avx512fp16_cmpv8hf3_zero_extendhi_2 */

    case 11:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2845; /* *avx512vl_cmpv8sf3_zero_extendhi_2 */

    case 12:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2848; /* *avx512vl_cmpv4sf3_zero_extendhi_2 */

    case 13:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2851; /* *avx512f_cmpv8df3_zero_extendhi_2 */

    case 14:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2854; /* *avx512vl_cmpv4df3_zero_extendhi_2 */

    case 15:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2857; /* *avx512vl_cmpv2df3_zero_extendhi_2 */

    case 16:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2920; /* *avx512vl_cmpv8hi3_zero_extendhi_2 */

    case 17:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2833; /* *avx512bw_cmpv32hf3_zero_extendhi_2 */

    case 18:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2911; /* *avx512vl_cmpv32qi3_zero_extendhi_2 */

    case 19:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2914; /* *avx512bw_cmpv32hi3_zero_extendhi_2 */

    case 20:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2905; /* *avx512bw_cmpv64qi3_zero_extendhi_2 */

    case 21:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2816; /* *avx512f_cmpv16si3_zero_extendsi_2 */

    case 22:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2837; /* *avx512vl_cmpv16hf3_zero_extendsi_2 */

    case 23:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2843; /* *avx512f_cmpv16sf3_zero_extendsi_2 */

    case 24:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2909; /* *avx512vl_cmpv16qi3_zero_extendsi_2 */

    case 25:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2918; /* *avx512vl_cmpv16hi3_zero_extendsi_2 */

    case 26:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2819; /* *avx512vl_cmpv8si3_zero_extendsi_2 */

    case 27:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2822; /* *avx512vl_cmpv4si3_zero_extendsi_2 */

    case 28:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2825; /* *avx512f_cmpv8di3_zero_extendsi_2 */

    case 29:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2828; /* *avx512vl_cmpv4di3_zero_extendsi_2 */

    case 30:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2831; /* *avx512vl_cmpv2di3_zero_extendsi_2 */

    case 31:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2840; /* *avx512fp16_cmpv8hf3_zero_extendsi_2 */

    case 32:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2846; /* *avx512vl_cmpv8sf3_zero_extendsi_2 */

    case 33:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2849; /* *avx512vl_cmpv4sf3_zero_extendsi_2 */

    case 34:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2852; /* *avx512f_cmpv8df3_zero_extendsi_2 */

    case 35:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2855; /* *avx512vl_cmpv4df3_zero_extendsi_2 */

    case 36:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2858; /* *avx512vl_cmpv2df3_zero_extendsi_2 */

    case 37:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2921; /* *avx512vl_cmpv8hi3_zero_extendsi_2 */

    case 38:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2834; /* *avx512bw_cmpv32hf3_zero_extendsi_2 */

    case 39:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2912; /* *avx512vl_cmpv32qi3_zero_extendsi_2 */

    case 40:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2915; /* *avx512bw_cmpv32hi3_zero_extendsi_2 */

    case 41:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2906; /* *avx512bw_cmpv64qi3_zero_extendsi_2 */

    case 42:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2817; /* *avx512f_cmpv16si3_zero_extenddi_2 */

    case 43:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2838; /* *avx512vl_cmpv16hf3_zero_extenddi_2 */

    case 44:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2844; /* *avx512f_cmpv16sf3_zero_extenddi_2 */

    case 45:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2910; /* *avx512vl_cmpv16qi3_zero_extenddi_2 */

    case 46:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2919; /* *avx512vl_cmpv16hi3_zero_extenddi_2 */

    case 47:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2820; /* *avx512vl_cmpv8si3_zero_extenddi_2 */

    case 48:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2823; /* *avx512vl_cmpv4si3_zero_extenddi_2 */

    case 49:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2826; /* *avx512f_cmpv8di3_zero_extenddi_2 */

    case 50:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2829; /* *avx512vl_cmpv4di3_zero_extenddi_2 */

    case 51:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2832; /* *avx512vl_cmpv2di3_zero_extenddi_2 */

    case 52:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2841; /* *avx512fp16_cmpv8hf3_zero_extenddi_2 */

    case 53:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2847; /* *avx512vl_cmpv8sf3_zero_extenddi_2 */

    case 54:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2850; /* *avx512vl_cmpv4sf3_zero_extenddi_2 */

    case 55:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2853; /* *avx512f_cmpv8df3_zero_extenddi_2 */

    case 56:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2856; /* *avx512vl_cmpv4df3_zero_extenddi_2 */

    case 57:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2859; /* *avx512vl_cmpv2df3_zero_extenddi_2 */

    case 58:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2922; /* *avx512vl_cmpv8hi3_zero_extenddi_2 */

    case 59:
      if (!(
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2835; /* *avx512bw_cmpv32hf3_zero_extenddi_2 */

    case 60:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2913; /* *avx512vl_cmpv32qi3_zero_extenddi_2 */

    case 61:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2916; /* *avx512bw_cmpv32hi3_zero_extenddi_2 */

    case 62:
      if (!(
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2907; /* *avx512bw_cmpv64qi3_zero_extenddi_2 */

    case 63:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2989; /* *avx512bw_ucmpv64qi3_zero_extendhi_2 */

    case 64:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2992; /* *avx512vl_ucmpv16qi3_zero_extendhi_2 */

    case 65:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3001; /* *avx512vl_ucmpv16hi3_zero_extendhi_2 */

    case 66:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3061; /* *avx512f_ucmpv16si3_zero_extendhi_2 */

    case 67:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2995; /* *avx512vl_ucmpv32qi3_zero_extendhi_2 */

    case 68:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2998; /* *avx512bw_ucmpv32hi3_zero_extendhi_2 */

    case 69:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3004; /* *avx512vl_ucmpv8hi3_zero_extendhi_2 */

    case 70:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3062; /* *avx512vl_ucmpv8si3_zero_extendhi_2 */

    case 71:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3063; /* *avx512vl_ucmpv4si3_zero_extendhi_2 */

    case 72:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3064; /* *avx512f_ucmpv8di3_zero_extendhi_2 */

    case 73:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3065; /* *avx512vl_ucmpv4di3_zero_extendhi_2 */

    case 74:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3066; /* *avx512vl_ucmpv2di3_zero_extendhi_2 */

    case 75:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2990; /* *avx512bw_ucmpv64qi3_zero_extendsi_2 */

    case 76:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2993; /* *avx512vl_ucmpv16qi3_zero_extendsi_2 */

    case 77:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3002; /* *avx512vl_ucmpv16hi3_zero_extendsi_2 */

    case 78:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3067; /* *avx512f_ucmpv16si3_zero_extendsi_2 */

    case 79:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2996; /* *avx512vl_ucmpv32qi3_zero_extendsi_2 */

    case 80:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2999; /* *avx512bw_ucmpv32hi3_zero_extendsi_2 */

    case 81:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3005; /* *avx512vl_ucmpv8hi3_zero_extendsi_2 */

    case 82:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3068; /* *avx512vl_ucmpv8si3_zero_extendsi_2 */

    case 83:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3069; /* *avx512vl_ucmpv4si3_zero_extendsi_2 */

    case 84:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3070; /* *avx512f_ucmpv8di3_zero_extendsi_2 */

    case 85:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3071; /* *avx512vl_ucmpv4di3_zero_extendsi_2 */

    case 86:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3072; /* *avx512vl_ucmpv2di3_zero_extendsi_2 */

    case 87:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2991; /* *avx512bw_ucmpv64qi3_zero_extenddi_2 */

    case 88:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2994; /* *avx512vl_ucmpv16qi3_zero_extenddi_2 */

    case 89:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3003; /* *avx512vl_ucmpv16hi3_zero_extenddi_2 */

    case 90:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3073; /* *avx512f_ucmpv16si3_zero_extenddi_2 */

    case 91:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2997; /* *avx512vl_ucmpv32qi3_zero_extenddi_2 */

    case 92:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3000; /* *avx512bw_ucmpv32hi3_zero_extenddi_2 */

    case 93:
      if (!(
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3006; /* *avx512vl_ucmpv8hi3_zero_extenddi_2 */

    case 94:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3074; /* *avx512vl_ucmpv8si3_zero_extenddi_2 */

    case 95:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3075; /* *avx512vl_ucmpv4si3_zero_extenddi_2 */

    case 96:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3076; /* *avx512f_ucmpv8di3_zero_extenddi_2 */

    case 97:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3077; /* *avx512vl_ucmpv4di3_zero_extenddi_2 */

    case 98:
      if (!(
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3078; /* *avx512vl_ucmpv2di3_zero_extenddi_2 */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern192 (x1))
        {
        case 0:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          switch (pattern635 (x1))
            {
            case 0:
              if ((
#line 15205 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 859; /* *ashldi3_doubleword_mask */
              break;

            case 1:
              if ((
#line 15205 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 860; /* *ashlti3_doubleword_mask */
              break;

            case 2:
              if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ)))
                return 2089; /* kashiftqi */
              break;

            case 3:
              if (
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return 2091; /* kashifthi */
              break;

            case 4:
              if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2093; /* kashiftsi */
              break;

            case 5:
              if ((
#line 2271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2095; /* kashiftdi */
              break;

            default:
              break;
            }
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (pattern636 (x1))
            {
            case 0:
              operands[0] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (GET_MODE (x3) == E_DImode)
                    {
                      if (register_operand (operands[0], E_DImode)
                          && reg_or_pm1_operand (operands[1], E_DImode))
                        return 863; /* ashldi3_doubleword */
                      if (nonimmediate_operand (operands[0], E_DImode)
                          && nonimmediate_operand (operands[1], E_DImode)
                          && (
#line 15911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return 886; /* *ashldi3_1 */
                    }
                  break;

                case E_SImode:
                  if (nonimmediate_operand (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 15911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)
   && true))
                    return 884; /* *ashlsi3_1 */
                  break;

                case E_HImode:
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && GET_MODE (x3) == E_HImode
                      && nonimmediate_operand (operands[1], E_HImode)
                      && 
#line 16097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && true))
                    return 898; /* *ashlhi3_1 */
                  break;

                case E_QImode:
                  if (nonimmediate_operand (operands[0], E_QImode)
                      && GET_MODE (x3) == E_QImode
                      && nonimmediate_operand (operands[1], E_QImode)
                      && 
#line 16156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && true))
                    return 900; /* *ashlqi3_1 */
                  break;

                case E_V2QImode:
                  if (register_operand (operands[0], E_V2QImode)
                      && GET_MODE (x3) == E_V2QImode
                      && register_operand (operands[1], E_V2QImode)
                      && 
#line 4007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                    return 1747; /* ashlv2qi3 */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              switch (pattern323 (x3))
                {
                case 0:
                  if (
#line 16235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 901; /* *ashlqi3_1_slp */
                  break;

                case 1:
                  if (
#line 16235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    return 902; /* *ashlhi3_1_slp */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG)
            return -1;
          switch (pattern639 (x1))
            {
            case 0:
              if (!
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              return 1009; /* *ashlsi3_mask */

            case 1:
              if (!(
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1012; /* *ashldi3_mask */

            case 2:
              if (!
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              return 1021; /* *ashlsi3_add */

            case 3:
              if (!(
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1024; /* *ashldi3_add */

            case 4:
              if (!
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              return 1033; /* *ashlsi3_sub */

            case 5:
              if (!(
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1036; /* *ashldi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 15266 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 861; /* *ashldi3_doubleword_mask_1 */
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1018; /* *ashldi3_mask_1 */

        case 2:
          if (!(
#line 15266 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 862; /* *ashlti3_doubleword_mask_1 */

        case 3:
          if (!
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          return 1015; /* *ashlsi3_mask_1 */

        case 4:
          if (!
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1027; /* *ashlsi3_add_1 */

        case 5:
          if (!(
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1030; /* *ashldi3_add_1 */

        case 6:
          if (!
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          return 1039; /* *ashlsi3_sub_1 */

        case 7:
          if (!(
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1042; /* *ashldi3_sub_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern328 (x1) != 0
          || !(
#line 15367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      return 864; /* *ashldi3_doubleword_highpart */

    case ZERO_EXTEND:
      if (pattern328 (x1) != 0
          || !(
#line 15367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      return 865; /* *ashldi3_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (register_operand (operands[0], E_V64QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V64QImode)
          && register_operand (operands[2], E_V64QImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1911; /* *vmovv64qi_constm1_pternlog_false_dep */
      break;

    case E_V32QImode:
      if (register_operand (operands[0], E_V32QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32QImode)
          && register_operand (operands[2], E_V32QImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1912; /* *vmovv32qi_constm1_pternlog_false_dep */
      break;

    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16QImode)
          && register_operand (operands[2], E_V16QImode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1913; /* *vmovv16qi_constm1_pternlog_false_dep */
      break;

    case E_V32HImode:
      if (register_operand (operands[0], E_V32HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HImode)
          && register_operand (operands[2], E_V32HImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1914; /* *vmovv32hi_constm1_pternlog_false_dep */
      break;

    case E_V16HImode:
      if (register_operand (operands[0], E_V16HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HImode)
          && register_operand (operands[2], E_V16HImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1915; /* *vmovv16hi_constm1_pternlog_false_dep */
      break;

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HImode)
          && register_operand (operands[2], E_V8HImode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1916; /* *vmovv8hi_constm1_pternlog_false_dep */
      break;

    case E_V16SImode:
      if (register_operand (operands[0], E_V16SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SImode)
          && register_operand (operands[2], E_V16SImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 284 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1917; /* *vmovv16si_constm1_pternlog_false_dep */
      break;

    case E_V8SImode:
      if (register_operand (operands[0], E_V8SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SImode)
          && register_operand (operands[2], E_V8SImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 284 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1918; /* *vmovv8si_constm1_pternlog_false_dep */
      break;

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SImode)
          && register_operand (operands[2], E_V4SImode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1919; /* *vmovv4si_constm1_pternlog_false_dep */
      break;

    case E_V8DImode:
      if (register_operand (operands[0], E_V8DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DImode)
          && register_operand (operands[2], E_V8DImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1920; /* *vmovv8di_constm1_pternlog_false_dep */
      break;

    case E_V4DImode:
      if (register_operand (operands[0], E_V4DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DImode)
          && register_operand (operands[2], E_V4DImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1921; /* *vmovv4di_constm1_pternlog_false_dep */
      break;

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DImode)
          && register_operand (operands[2], E_V2DImode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1922; /* *vmovv2di_constm1_pternlog_false_dep */
      break;

    case E_V4TImode:
      if (register_operand (operands[0], E_V4TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V4TImode)
          && register_operand (operands[2], E_V4TImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 286 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1923; /* *vmovv4ti_constm1_pternlog_false_dep */
      break;

    case E_V2TImode:
      if (register_operand (operands[0], E_V2TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V2TImode)
          && register_operand (operands[2], E_V2TImode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 286 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1924; /* *vmovv2ti_constm1_pternlog_false_dep */
      break;

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && int_float_vector_all_ones_operand (operands[1], E_V1TImode)
          && register_operand (operands[2], E_V1TImode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1925; /* *vmovv1ti_constm1_pternlog_false_dep */
      break;

    case E_V32HFmode:
      if (register_operand (operands[0], E_V32HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32HFmode)
          && register_operand (operands[2], E_V32HFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1926; /* *vmovv32hf_constm1_pternlog_false_dep */
      break;

    case E_V16HFmode:
      if (register_operand (operands[0], E_V16HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16HFmode)
          && register_operand (operands[2], E_V16HFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1927; /* *vmovv16hf_constm1_pternlog_false_dep */
      break;

    case E_V8HFmode:
      if (register_operand (operands[0], E_V8HFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1928; /* *vmovv8hf_constm1_pternlog_false_dep */
      break;

    case E_V32BFmode:
      if (register_operand (operands[0], E_V32BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V32BFmode)
          && register_operand (operands[2], E_V32BFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 288 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1929; /* *vmovv32bf_constm1_pternlog_false_dep */
      break;

    case E_V16BFmode:
      if (register_operand (operands[0], E_V16BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16BFmode)
          && register_operand (operands[2], E_V16BFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 288 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1930; /* *vmovv16bf_constm1_pternlog_false_dep */
      break;

    case E_V8BFmode:
      if (register_operand (operands[0], E_V8BFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8BFmode)
          && register_operand (operands[2], E_V8BFmode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1931; /* *vmovv8bf_constm1_pternlog_false_dep */
      break;

    case E_V16SFmode:
      if (register_operand (operands[0], E_V16SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V16SFmode)
          && register_operand (operands[2], E_V16SFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1932; /* *vmovv16sf_constm1_pternlog_false_dep */
      break;

    case E_V8SFmode:
      if (register_operand (operands[0], E_V8SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8SFmode)
          && register_operand (operands[2], E_V8SFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1933; /* *vmovv8sf_constm1_pternlog_false_dep */
      break;

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1934; /* *vmovv4sf_constm1_pternlog_false_dep */
      break;

    case E_V8DFmode:
      if (register_operand (operands[0], E_V8DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V8DFmode)
          && register_operand (operands[2], E_V8DFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 64 == 64) && 
#line 290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1935; /* *vmovv8df_constm1_pternlog_false_dep */
      break;

    case E_V4DFmode:
      if (register_operand (operands[0], E_V4DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V4DFmode)
          && register_operand (operands[2], E_V4DFmode)
          && (
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 32 == 64) && 
#line 290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1936; /* *vmovv4df_constm1_pternlog_false_dep */
      break;

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && int_float_vector_all_ones_operand (operands[1], E_V2DFmode)
          && register_operand (operands[2], E_V2DFmode)
          && 
#line 1571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL || 16 == 64))
        return 1937; /* *vmovv2df_constm1_pternlog_false_dep */
      break;

    default:
      break;
    }
  switch (GET_CODE (x4))
    {
    case VEC_MERGE:
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1217 (x4, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4556; /* *avx512f_cvtmask2dv16si_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1217 (x4, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4557; /* *avx512vl_cvtmask2dv8si_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1217 (x4, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4558; /* *avx512vl_cvtmask2dv4si_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1217 (x4, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4559; /* *avx512f_cvtmask2qv8di_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1217 (x4, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4560; /* *avx512vl_cvtmask2qv4di_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1217 (x4, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 10347 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !TARGET_AVX512DQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4561; /* *avx512vl_cvtmask2qv2di_pternlog_false_dep */

        default:
          return -1;
        }

    case XOR:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1122 (x4, 
E_V16SImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7317; /* *one_cmplv16si2_pternlog_false_dep */

        case E_V8DImode:
          if (pattern1122 (x4, 
E_V8DImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7318; /* *one_cmplv8di2_pternlog_false_dep */

        case E_V64QImode:
          if (pattern1122 (x4, 
E_V64QImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7319; /* *one_cmplv64qi2_pternlog_false_dep */

        case E_V32QImode:
          if (pattern1122 (x4, 
E_V32QImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7320; /* *one_cmplv32qi2_pternlog_false_dep */

        case E_V16QImode:
          if (pattern1122 (x4, 
E_V16QImode) != 0
              || !
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7321; /* *one_cmplv16qi2_pternlog_false_dep */

        case E_V32HImode:
          if (pattern1122 (x4, 
E_V32HImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7322; /* *one_cmplv32hi2_pternlog_false_dep */

        case E_V16HImode:
          if (pattern1122 (x4, 
E_V16HImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7323; /* *one_cmplv16hi2_pternlog_false_dep */

        case E_V8HImode:
          if (pattern1122 (x4, 
E_V8HImode) != 0
              || !
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7324; /* *one_cmplv8hi2_pternlog_false_dep */

        case E_V8SImode:
          if (pattern1122 (x4, 
E_V8SImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7325; /* *one_cmplv8si2_pternlog_false_dep */

        case E_V4SImode:
          if (pattern1122 (x4, 
E_V4SImode) != 0
              || !
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7326; /* *one_cmplv4si2_pternlog_false_dep */

        case E_V4DImode:
          if (pattern1122 (x4, 
E_V4DImode) != 0
              || !(
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7327; /* *one_cmplv4di2_pternlog_false_dep */

        case E_V2DImode:
          if (pattern1122 (x4, 
E_V2DImode) != 0
              || !
#line 18412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)))
            return -1;
          return 7328; /* *one_cmplv2di2_pternlog_false_dep */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      switch (pattern532 (x3))
        {
        case 0:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
   == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_563 (insn, operands);

        case 1:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
   == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_565 (insn, operands);

        case 2:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
   == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_567 (insn, operands);

        case 3:
          if (!(
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
   == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_569 (insn, operands);

        case 4:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_595 (insn, operands);

        case 5:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_597 (insn, operands);

        case 6:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_599 (insn, operands);

        case 7:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_623 (insn, operands);

        case 8:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_625 (insn, operands);

        case 9:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_627 (insn, operands);

        case 10:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
  == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_579 (insn, operands);

        case 11:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
  == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_581 (insn, operands);

        case 12:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
  == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_583 (insn, operands);

        case 13:
          if (!(
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
  == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_585 (insn, operands);

        case 14:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_609 (insn, operands);

        case 15:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_611 (insn, operands);

        case 16:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_613 (insn, operands);

        case 17:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_637 (insn, operands);

        case 18:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_639 (insn, operands);

        case 19:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_641 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !(
#line 18447 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT) && 
#line 18449 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_645 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return split_6 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) != 17
              || pattern59 (x1, 
E_CCCmode) != 0
              || !(
#line 9883 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_161 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x2), 0))
            return NULL;
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NOT:
              if (GET_MODE (x3) != E_QImode)
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x4), 0)
                  || GET_MODE (x4) != E_QImode)
                return NULL;
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case SIGN_EXTRACT:
                case ZERO_EXTRACT:
                  operands[2] = x5;
                  if (pattern230 (x1) != 0)
                    return NULL;
                  x6 = XEXP (x1, 0);
                  switch (GET_MODE (x6))
                    {
                    case E_HImode:
                      if (GET_MODE (x2) != E_HImode
                          || !extract_operator (operands[2], E_HImode)
                          || !
#line 15145 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                        return NULL;
                      return gen_split_454 (insn, operands);

                    case E_SImode:
                      if (GET_MODE (x2) != E_SImode
                          || !extract_operator (operands[2], E_SImode)
                          || !
#line 15145 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                        return NULL;
                      return gen_split_455 (insn, operands);

                    case E_DImode:
                      if (GET_MODE (x2) != E_DImode
                          || !extract_operator (operands[2], E_DImode)
                          || !(
#line 15145 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return NULL;
                      return gen_split_456 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case LSHIFTRT:
              if (pattern529 (x1) != 0
                  || !((
#line 16738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_493 (insn, operands);

            case ASHIFTRT:
              if (pattern529 (x1) != 0
                  || !((
#line 16738 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_494 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_8 (x1, insn);

    case IOR:
      return split_7 (x1, insn);

    case XOR:
      return split_10 (x1, insn);

    case FLOAT_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case SUBREG:
        case MEM:
          if (memory_operand (operands[1], E_VOIDmode)
              && any_fp_register_operand (operands[0], E_VOIDmode)
              && 
#line 4614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
            return gen_split_33 (insn, operands);
          break;

        case REG:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !sse_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return NULL;
      if (
#line 5339 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_51 (insn, operands);
      if (!
#line 5402 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_52 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case SUBREG:
            case MEM:
              if (memory_operand (operands[1], E_SImode)
                  && memory_operand (operands[0], E_DImode)
                  && 
#line 4784 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return gen_split_37 (insn, operands);
              break;

            case REG:
              if (general_reg_operand (operands[1], E_SImode)
                  && general_reg_operand (operands[0], E_DImode)
                  && 
#line 4791 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && REGNO (operands[0]) == REGNO (operands[1])))
                return gen_split_38 (insn, operands);
              break;

            default:
              break;
            }
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !nonimmediate_gr_operand (operands[0], E_DImode)
              || !
#line 4799 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return NULL;
          return gen_split_39 (insn, operands);

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 19
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XVECEXP (x3, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || !(
#line 23213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_754 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!sse_reg_operand (operands[0], E_SFmode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return NULL;
      if (
#line 5578 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_53 (insn, operands);
      if (!
#line 5632 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_54 (insn, operands);

    case FLOAT:
      return split_12 (x1, insn);

    case MULT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!general_reg_operand (operands[0], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      if (!const1248_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 6428 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed))
        return NULL;
      return gen_split_76 (insn, operands);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x8 = XEXP (x2, 1);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = split_3 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (nonimmediate_operand (operands[0], E_QImode))
        {
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode)
              || !(
#line 19534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19537 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_713 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !ix86_comparison_operator (operands[1], E_SImode)
              || !(
#line 19534 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19537 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_714 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          switch (XINT (x2, 1))
            {
            case 40:
              if (GET_MODE (x2) != E_CCCmode)
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x9) != LTU
                  || pattern648 (x9) != 0
                  || pattern228 (x1) != 0)
                return NULL;
              x10 = XEXP (x9, 0);
              switch (GET_MODE (x10))
                {
                case E_CCmode:
                  if (!(
#line 9904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case E_CCCmode:
                  if (!(
#line 9904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                default:
                  return NULL;
                }

            case 45:
              if (pattern260 (x2) != 0)
                return NULL;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x11 = XVECEXP (x2, 0, 1);
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode)
                  || !(
#line 19576 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 19578 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_715 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          switch (XINT (x2, 1))
            {
            case 97:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              operands[1] = x9;
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !((
#line 21666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 21668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_736 (insn, operands);

            case 96:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              operands[1] = x9;
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !((
#line 21666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 21668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                return NULL;
              return gen_split_737 (insn, operands);

            case 19:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern57 (x2))
                {
                case 0:
                  if (!
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return NULL;
                  return gen_split_752 (insn, operands);

                case 1:
                  if (!
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return NULL;
                  return gen_split_753 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern344 (x2))
            {
            case 0:
              return gen_split_332 (insn, operands);

            case 1:
              return gen_split_335 (insn, operands);

            case 2:
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern344 (x2))
            {
            case 0:
              return gen_split_333 (insn, operands);

            case 1:
              return gen_split_336 (insn, operands);

            case 2:
              return gen_split_339 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern344 (x2))
            {
            case 0:
              return gen_split_334 (insn, operands);

            case 1:
              return gen_split_337 (insn, operands);

            case 2:
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      switch (pattern42 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14980 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_445 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14978 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14980 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_446 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 15061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_447 (insn, operands);

        case 2:
          if (!(
#line 15061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_448 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (pattern649 (x2, 
E_QImode) != 0
              || !
#line 15980 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_468 (insn, operands);

        case CONST_INT:
          if (!const_0_to_3_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!general_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !index_reg_operand (operands[1], E_QImode)
                  || !
#line 16302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_476 (insn, operands);

            case E_HImode:
              if (!general_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !index_reg_operand (operands[1], E_HImode)
                  || !
#line 16302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_477 (insn, operands);

            case E_SImode:
              if (!general_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !index_reg_operand (operands[1], E_SImode)
                  || !
#line 16302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_478 (insn, operands);

            case E_DImode:
              if (!general_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !index_reg_operand (operands[1], E_DImode)
                  || !(
#line 16302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_479 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 17427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
        return NULL;
      return gen_split_501 (insn, operands);

    case ASHIFTRT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return NULL;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 17427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_502 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x3) != E_V2DImode
              || pattern238 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 18008 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_STV && TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32) && 
#line 18012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_552 (insn, operands);
          if (!(
#line 18025 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32
   && ix86_pre_reload_split ()) && 
#line 18030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_553 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      return split_9 (x1, insn);

    case ROTATERT:
      return split_11 (x1, insn);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
          operands[5] = x3;
          if (bt_comparison_operator (operands[5], E_VOIDmode))
            {
              res = split_5 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          x4 = XEXP (x3, 0);
          if (!ix86_comparison_operator (x4, E_VOIDmode))
            return NULL;
          operands[0] = x4;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 17)
            return NULL;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x13 = XEXP (x3, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return NULL;
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return NULL;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != PC)
            return NULL;
          x15 = XEXP (x8, 0);
          operands[1] = x15;
          switch (GET_CODE (x3))
            {
            case NE:
              return gen_split_723 (insn, operands);

            case EQ:
              return gen_split_724 (insn, operands);

            default:
              return NULL;
            }

        case GEU:
        case LTU:
          operands[1] = x3;
          if (!add_comparison_operator (operands[1], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != NOT)
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return NULL;
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return NULL;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != PC)
            return NULL;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x13 = XEXP (x3, 1);
          operands[3] = x13;
          x15 = XEXP (x8, 0);
          operands[0] = x15;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode)
                  || !nonimmediate_operand (operands[3], E_QImode))
                return NULL;
              return gen_split_720 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[2], E_HImode)
                  || !nonimmediate_operand (operands[3], E_HImode))
                return NULL;
              return gen_split_721 (insn, operands);

            case E_SImode:
              if (!register_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[3], E_SImode))
                return NULL;
              return gen_split_722 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != XOR
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x15 = XEXP (x8, 0);
      if (GET_CODE (x15) != MINUS
          || GET_MODE (x15) != E_SImode)
        return NULL;
      x16 = XEXP (x15, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return NULL;
      x17 = XEXP (x15, 1);
      if (GET_CODE (x17) != CLZ
          || GET_MODE (x17) != E_SImode)
        return NULL;
      x18 = XEXP (x8, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x19 = XEXP (x17, 0);
      operands[1] = x19;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 21403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_LZCNT && ix86_pre_reload_split ()))
        return NULL;
      return gen_split_733 (insn, operands);

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 21505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 21507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_734 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 22306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 22314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_747 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LEU:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!int_nonimmediate_operand (operands[1], E_VOIDmode))
        return NULL;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !
#line 26302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(x86_64_immediate_operand (operands[2], VOIDmode)
   && INTVAL (operands[2]) != -1
   && INTVAL (operands[2]) != 2147483647))
            return NULL;
          return gen_split_770 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !(
#line 26302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(x86_64_immediate_operand (operands[2], VOIDmode)
   && INTVAL (operands[2]) != -1
   && INTVAL (operands[2]) != 2147483647) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_771 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern349 (x3))
        {
        case 0:
          return gen_split_772 (insn, operands);

        case 1:
          return gen_split_773 (insn, operands);

        case 2:
          return gen_split_774 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern349 (x3))
        {
        case 0:
          return gen_split_775 (insn, operands);

        case 1:
          return gen_split_776 (insn, operands);

        case 2:
          return gen_split_777 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 51:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          switch (GET_CODE (x6))
            {
            case LT:
              switch (pattern674 (x2))
                {
                case 0:
                  if ((
#line 26806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_786 (insn, operands);
                  if (!(
#line 26827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_788 (insn, operands);

                case 1:
                  if ((
#line 26806 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[3])
      && rtx_equal_p (operands[2], operands[4]))
  && ix86_pre_reload_split ()) && 
#line 26811 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return gen_split_787 (insn, operands);
                  if (!(
#line 26827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH
  && (rtx_equal_p (operands[1], operands[4])
      && rtx_equal_p (operands[2], operands[3]))
  && ix86_pre_reload_split ()) && 
#line 26832 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_789 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern676 (x2))
                {
                case 0:
                  if (!(
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_859 (insn, operands);

                case 1:
                  if (!(
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_860 (insn, operands);

                case 2:
                  if (!(
#line 4414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4416 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( 1)))
                    return NULL;
                  return gen_split_861 (insn, operands);

                default:
                  return NULL;
                }

            case SUBREG:
              if (pattern774 (x2) != 0
                  || !(
#line 4442 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 4444 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( 1)))
                return NULL;
              return gen_split_862 (insn, operands);

            default:
              return NULL;
            }

        case 59:
          switch (pattern538 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1255 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1257 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1263 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1259 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1261 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 3) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1265 (insn, operands);

            default:
              return NULL;
            }

        case 157:
          switch (pattern538 (x2))
            {
            case 0:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1256 (insn, operands);

            case 1:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1258 (insn, operands);

            case 2:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1264 (insn, operands);

            case 3:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1260 (insn, operands);

            case 4:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1262 (insn, operands);

            case 5:
              if (!((
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()
  && ix86_binary_operator_ok (US_MINUS, V8HImode, operands)
  && (INTVAL (operands[4]) & 1) == 0) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4796 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1266 (insn, operands);

            default:
              return NULL;
            }

        case 121:
          if (pattern264 (x2) != 0
              || !
#line 23274 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_SSSE3 && reload_completed
    && SSE_REGNO_P (REGNO (operands[0])))
   || operands[3] == const0_rtx
   || INTVAL (operands[3]) == 64))
            return NULL;
          return gen_split_3214 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 57:
          if (pattern67 (x1, 
E_V4HImode) != 0
              || !(
#line 4792 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE) && 
#line 4797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
( reload_completed
   && SSE_REGNO_P (REGNO (operands[0])))))
            return NULL;
          return gen_split_897 (insn, operands);

        case 130:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 17)
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              switch (pattern551 (x1))
                {
                case 0:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3320 (insn, operands);

                case 1:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3321 (insn, operands);

                case 2:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3322 (insn, operands);

                case 3:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3323 (insn, operands);

                case 4:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3324 (insn, operands);

                case 5:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3325 (insn, operands);

                case 6:
                  if (!(
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3326 (insn, operands);

                case 7:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3327 (insn, operands);

                case 8:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3328 (insn, operands);

                case 9:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3329 (insn, operands);

                case 10:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3330 (insn, operands);

                case 11:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3331 (insn, operands);

                case 12:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3332 (insn, operands);

                case 13:
                  if (!((
#line 25364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ix86_pre_reload_split ()) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 25367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3333 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[0] = x4;
              if (GET_MODE (x3) != E_CCCmode
                  || GET_MODE (x2) != E_CCCmode)
                return NULL;
              x5 = XVECEXP (x2, 0, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[0], E_V16QImode)
                      || !register_operand (operands[1], E_V16QImode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3334 (insn, operands);

                case E_V8HImode:
                  if (!register_operand (operands[0], E_V8HImode)
                      || !register_operand (operands[1], E_V8HImode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3335 (insn, operands);

                case E_V4SImode:
                  if (!register_operand (operands[0], E_V4SImode)
                      || !register_operand (operands[1], E_V4SImode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3336 (insn, operands);

                case E_V2DImode:
                  if (!register_operand (operands[0], E_V2DImode)
                      || !register_operand (operands[1], E_V2DImode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3337 (insn, operands);

                case E_V1TImode:
                  if (!register_operand (operands[0], E_V1TImode)
                      || !register_operand (operands[1], E_V1TImode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3338 (insn, operands);

                case E_V4SFmode:
                  if (!register_operand (operands[0], E_V4SFmode)
                      || !register_operand (operands[1], E_V4SFmode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3339 (insn, operands);

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || !register_operand (operands[1], E_V2DFmode)
                      || !
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_3340 (insn, operands);

                case E_V32QImode:
                  if (!register_operand (operands[0], E_V32QImode)
                      || !register_operand (operands[1], E_V32QImode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3341 (insn, operands);

                case E_V16HImode:
                  if (!register_operand (operands[0], E_V16HImode)
                      || !register_operand (operands[1], E_V16HImode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3342 (insn, operands);

                case E_V8SImode:
                  if (!register_operand (operands[0], E_V8SImode)
                      || !register_operand (operands[1], E_V8SImode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3343 (insn, operands);

                case E_V4DImode:
                  if (!register_operand (operands[0], E_V4DImode)
                      || !register_operand (operands[1], E_V4DImode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3344 (insn, operands);

                case E_V2TImode:
                  if (!register_operand (operands[0], E_V2TImode)
                      || !register_operand (operands[1], E_V2TImode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3345 (insn, operands);

                case E_V8SFmode:
                  if (!register_operand (operands[0], E_V8SFmode)
                      || !register_operand (operands[1], E_V8SFmode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3346 (insn, operands);

                case E_V4DFmode:
                  if (!register_operand (operands[0], E_V4DFmode)
                      || !register_operand (operands[1], E_V4DFmode)
                      || !(
#line 25377 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && rtx_equal_p (operands[0], operands[1])) && 
#line 607 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return NULL;
                  return gen_split_3347 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 49:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 6829 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed
   && SSE_REGNO_P (REGNO (operands[1]))))
                return gen_split_916 (insn, operands);
              if (GET_CODE (x4) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x4), 0))
                return NULL;
              x7 = XEXP (x4, 0);
              switch (GET_CODE (x7))
                {
                case VEC_MERGE:
                  switch (pattern988 (x4))
                    {
                    case 0:
                      if (!((
#line 21972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3181 (insn, operands);

                    case 1:
                      if (!(
#line 21972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3182 (insn, operands);

                    case 2:
                      if (!((
#line 21972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3183 (insn, operands);

                    case 3:
                      if (!((
#line 21972 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21974 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3184 (insn, operands);

                    default:
                      return NULL;
                    }

                case ASHIFTRT:
                  switch (pattern989 (x4))
                    {
                    case 0:
                      if (!((
#line 22035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3185 (insn, operands);

                    case 1:
                      if (!(
#line 22035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 22037 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3186 (insn, operands);

                    case 2:
                      if (!((
#line 22035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 22037 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3187 (insn, operands);

                    case 3:
                      if (!((
#line 22035 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 22037 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                        return NULL;
                      return gen_split_3188 (insn, operands);

                    default:
                      return NULL;
                    }

                case NOT:
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_VOIDmode))
                    return NULL;
                  switch (GET_MODE (x4))
                    {
                    case E_V32QImode:
                      if (!(
#line 22174 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 32) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                        return NULL;
                      return gen_split_3193 (insn, operands);

                    case E_V16QImode:
                      if (!
#line 22174 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_VECTOR_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) == 16))
                        return NULL;
                      return gen_split_3194 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case LT:
              switch (pattern698 (x4))
                {
                case 0:
                  if (!((
#line 21948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3177 (insn, operands);

                case 1:
                  if (!(
#line 21948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 21950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3178 (insn, operands);

                case 2:
                  if (!((
#line 21948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 21950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3179 (insn, operands);

                case 3:
                  if (!((
#line 21948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 21950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                    return NULL;
                  return gen_split_3180 (insn, operands);

                case 4:
                  if (!((
#line 22200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3195 (insn, operands);

                case 5:
                  if (!(
#line 22200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3196 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              switch (GET_MODE (x4))
                {
                case E_V32QImode:
                  if (!register_operand (operands[1], E_V32QImode)
                      || !(
#line 22152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return NULL;
                  return gen_split_3191 (insn, operands);

                case E_V16QImode:
                  if (!register_operand (operands[1], E_V16QImode)
                      || !
#line 22152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return NULL;
                  return gen_split_3192 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_MERGE:
              switch (pattern700 (x4))
                {
                case 0:
                  if (!((
#line 22228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 629 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)) && 
#line 22230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3197 (insn, operands);

                case 1:
                  if (!(
#line 22228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2) && 
#line 22230 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3198 (insn, operands);

                case 2:
                  if (!(
#line 22356 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22358 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3199 (insn, operands);

                case 3:
                  if (!(
#line 22370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 22372 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_3200 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 172:
          if (GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[0], E_V2SImode))
            return NULL;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && reload_completed
   && SSE_REG_P (operands[0])))
            return NULL;
          return gen_split_1299 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern471 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1780 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1807 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1834 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1861 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1888 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1942 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1969 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1996 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2023 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2050 (insn, operands);

        case 11:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2077 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1783 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1810 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1837 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1864 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1891 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1918 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1945 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1972 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1999 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2026 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2053 (insn, operands);

        case 23:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2080 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1786 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1813 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1840 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1867 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1894 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1921 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1948 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1975 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2002 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2029 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2056 (insn, operands);

        case 35:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2083 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2848 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2857 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2866 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2875 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2884 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2893 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2902 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2911 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2920 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2929 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2938 (insn, operands);

        case 47:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2947 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2428 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2455 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2482 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2509 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2536 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2563 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2590 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2644 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2671 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2725 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2431 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2458 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2485 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2512 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2539 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2566 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2593 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2620 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2647 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2674 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2701 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2728 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2434 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2461 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2488 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2515 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2542 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2569 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2596 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2623 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2650 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2677 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2704 (insn, operands);

        case 11:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2731 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MINUS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PLUS)
        return NULL;
      operands[6] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1308 (x2, 
E_V8SFmode) != 0
              || !(
#line 3541 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1079 (insn, operands);

        case E_V4SFmode:
          if (pattern1308 (x2, 
E_V4SFmode) != 0
              || !
#line 3541 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
            return NULL;
          return gen_split_1080 (insn, operands);

        case E_V4DFmode:
          if (pattern1308 (x2, 
E_V4DFmode) != 0
              || !(
#line 3541 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1081 (insn, operands);

        case E_V2DFmode:
          if (pattern1308 (x2, 
E_V2DFmode) != 0
              || !(
#line 3541 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return NULL;
          return gen_split_1082 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != MINUS)
        return NULL;
      operands[6] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      x9 = XEXP (x2, 2);
      operands[5] = x9;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1309 (x2, 
E_V8SFmode) != 0
              || !(
#line 3563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1083 (insn, operands);

        case E_V4SFmode:
          if (pattern1309 (x2, 
E_V4SFmode) != 0
              || !
#line 3563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))))
            return NULL;
          return gen_split_1084 (insn, operands);

        case E_V4DFmode:
          if (pattern1309 (x2, 
E_V4DFmode) != 0
              || !(
#line 3563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_1085 (insn, operands);

        case E_V2DFmode:
          if (pattern1309 (x2, 
E_V2DFmode) != 0
              || !(
#line 3563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE3
   && can_create_pseudo_p ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return NULL;
          return gen_split_1086 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = split_49 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          switch (pattern277 (x2))
            {
            case 0:
              res = split_50 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case 1:
              if (vector_all_ones_operand (operands[1], E_V16QImode)
                  && const0_operand (operands[2], E_V16QImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3071 (insn, operands);
              if (const0_operand (operands[1], E_V16QImode)
                  && vector_all_ones_operand (operands[2], E_V16QImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3094 (insn, operands);
              break;

            case 2:
              if (vector_all_ones_operand (operands[1], E_V8HImode)
                  && const0_operand (operands[2], E_V8HImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3073 (insn, operands);
              if (const0_operand (operands[1], E_V8HImode)
                  && vector_all_ones_operand (operands[2], E_V8HImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3095 (insn, operands);
              break;

            case 3:
              if (vector_all_ones_operand (operands[1], E_V4SImode)
                  && const0_operand (operands[2], E_V4SImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3075 (insn, operands);
              if (const0_operand (operands[1], E_V4SImode)
                  && vector_all_ones_operand (operands[2], E_V4SImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3096 (insn, operands);
              break;

            case 4:
              if (vector_all_ones_operand (operands[1], E_V2DImode)
                  && const0_operand (operands[2], E_V2DImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3077 (insn, operands);
              if (const0_operand (operands[1], E_V2DImode)
                  && vector_all_ones_operand (operands[2], E_V2DImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3097 (insn, operands);
              break;

            case 5:
              if (vector_all_ones_operand (operands[1], E_V32QImode)
                  && const0_operand (operands[2], E_V32QImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3079 (insn, operands);
              if (const0_operand (operands[1], E_V32QImode)
                  && vector_all_ones_operand (operands[2], E_V32QImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3098 (insn, operands);
              break;

            case 6:
              if (vector_all_ones_operand (operands[1], E_V16HImode)
                  && const0_operand (operands[2], E_V16HImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3081 (insn, operands);
              if (const0_operand (operands[1], E_V16HImode)
                  && vector_all_ones_operand (operands[2], E_V16HImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3099 (insn, operands);
              break;

            case 7:
              if (vector_all_ones_operand (operands[1], E_V8SImode)
                  && const0_operand (operands[2], E_V8SImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3083 (insn, operands);
              if (const0_operand (operands[1], E_V8SImode)
                  && vector_all_ones_operand (operands[2], E_V8SImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3100 (insn, operands);
              break;

            case 8:
              if (vector_all_ones_operand (operands[1], E_V4DImode)
                  && const0_operand (operands[2], E_V4DImode)
                  && (
#line 18106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   && (INTVAL (operands[5]) == 2 || INTVAL (operands[5]) == 5)) && 
#line 18109 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3085 (insn, operands);
              if (const0_operand (operands[1], E_V4DImode)
                  && vector_all_ones_operand (operands[2], E_V4DImode)
                  && (
#line 18164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
     /* NE is commutative.  */
   && INTVAL (operands[5]) == 4) && 
#line 18169 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3101 (insn, operands);
              break;

            case 9:
              if (((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1099 (insn, operands);
              break;

            case 10:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3062 (insn, operands);
              break;

            case 11:
              if ((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1100 (insn, operands);
              break;

            case 12:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3058 (insn, operands);
              break;

            case 13:
              if (((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1101 (insn, operands);
              break;

            case 14:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3063 (insn, operands);
              break;

            case 15:
              if (((
#line 4148 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4150 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_1102 (insn, operands);
              break;

            case 16:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3059 (insn, operands);
              break;

            case 17:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3056 (insn, operands);
              break;

            case 18:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3057 (insn, operands);
              break;

            case 19:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3060 (insn, operands);
              break;

            case 20:
              if ((
#line 17981 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
   /* NE is commutative.  */
   && ((INTVAL (operands[5]) == 4
	&& !(MEM_P (operands[3]) && MEM_P (operands[4])))
	  /* LE, 3 must be register.  */
       || (INTVAL (operands[5]) == 2
	   && !MEM_P (operands[3]))
	  /* NLT aka GE, 4 must be register and we swap operands.  */
       || (INTVAL (operands[5]) == 5
	   && !MEM_P (operands[4])))) && 
#line 17992 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_3061 (insn, operands);
              break;

            case 21:
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (register_operand (operands[0], E_V16SImode)
                      && GET_MODE (x2) == E_V16SImode
                      && register_operand (operands[1], E_HImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V16SImode)
                          && const0_operand (operands[3], E_V16SImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1301 (insn, operands);
                      if (const0_operand (operands[2], E_V16SImode)
                          && vector_all_ones_operand (operands[3], E_V16SImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1313 (insn, operands);
                    }
                  break;

                case E_V8SImode:
                  if (register_operand (operands[0], E_V8SImode)
                      && GET_MODE (x2) == E_V8SImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V8SImode)
                          && const0_operand (operands[3], E_V8SImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1302 (insn, operands);
                      if (const0_operand (operands[2], E_V8SImode)
                          && vector_all_ones_operand (operands[3], E_V8SImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1314 (insn, operands);
                    }
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x2) == E_V4SImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V4SImode)
                          && const0_operand (operands[3], E_V4SImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1303 (insn, operands);
                      if (const0_operand (operands[2], E_V4SImode)
                          && vector_all_ones_operand (operands[3], E_V4SImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1315 (insn, operands);
                    }
                  break;

                case E_V8DImode:
                  if (register_operand (operands[0], E_V8DImode)
                      && GET_MODE (x2) == E_V8DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V8DImode)
                          && const0_operand (operands[3], E_V8DImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1304 (insn, operands);
                      if (const0_operand (operands[2], E_V8DImode)
                          && vector_all_ones_operand (operands[3], E_V8DImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1316 (insn, operands);
                    }
                  break;

                case E_V4DImode:
                  if (register_operand (operands[0], E_V4DImode)
                      && GET_MODE (x2) == E_V4DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V4DImode)
                          && const0_operand (operands[3], E_V4DImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1305 (insn, operands);
                      if (const0_operand (operands[2], E_V4DImode)
                          && vector_all_ones_operand (operands[3], E_V4DImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1317 (insn, operands);
                    }
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x2) == E_V2DImode
                      && register_operand (operands[1], E_QImode))
                    {
                      if (vector_all_ones_operand (operands[2], E_V2DImode)
                          && const0_operand (operands[3], E_V2DImode)
                          && ((
#line 10302 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( !TARGET_AVX512DQ && reload_completed
   && optimize_function_for_speed_p (cfun))))
                        return gen_split_1306 (insn, operands);
                      if (const0_operand (operands[2], E_V2DImode)
                          && vector_all_ones_operand (operands[3], E_V2DImode)
                          && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                        return gen_split_1318 (insn, operands);
                    }
                  break;

                case E_V64QImode:
                  if (pattern1067 (x2, 
E_DImode, 
E_V64QImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1307 (insn, operands);
                  break;

                case E_V32QImode:
                  if (pattern1067 (x2, 
E_SImode, 
E_V32QImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1308 (insn, operands);
                  break;

                case E_V16QImode:
                  if (pattern1067 (x2, 
E_HImode, 
E_V16QImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1309 (insn, operands);
                  break;

                case E_V32HImode:
                  if (pattern1067 (x2, 
E_SImode, 
E_V32HImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1310 (insn, operands);
                  break;

                case E_V16HImode:
                  if (pattern1067 (x2, 
E_HImode, 
E_V16HImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1311 (insn, operands);
                  break;

                case E_V8HImode:
                  if (pattern1067 (x2, 
E_QImode, 
E_V8HImode) == 0
                      && ((
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 10330 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1312 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (pattern280 (x2))
        {
        case 0:
          if (!((
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1103 (insn, operands);

        case 1:
          if (!(
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1104 (insn, operands);

        case 2:
          if (!((
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1105 (insn, operands);

        case 3:
          if (!((
#line 4175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1106 (insn, operands);

        case 4:
          if (!((
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1107 (insn, operands);

        case 5:
          if (!(
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 4198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1108 (insn, operands);

        case 6:
          if (!((
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 4198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1109 (insn, operands);

        case 7:
          if (!((
#line 4196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 4198 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1110 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return NULL;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x2, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          switch (pattern911 (x2))
            {
            case 0:
              if (!(
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12025 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1319 (insn, operands);

            case 1:
              if (!(
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12025 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1320 (insn, operands);

            case 2:
              if (!(
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12025 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1321 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern272 (x2))
            {
            case 0:
              if (!((
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1322 (insn, operands);

            case 1:
              if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1323 (insn, operands);

            case 2:
              if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1324 (insn, operands);

            case 3:
              if (!((
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1325 (insn, operands);

            case 4:
              if (!((
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 12179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1329 (insn, operands);

            case 5:
              if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1326 (insn, operands);

            case 6:
              if (!((
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 12179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1330 (insn, operands);

            case 7:
              if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 12065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1327 (insn, operands);

            case 8:
              if (!(
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 12179 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1331 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (!rtx_equal_p (x4, operands[0]))
                return NULL;
              x9 = XEXP (x2, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1068 (x2, 
E_SImode, 
E_V4SImode) != 0
                      || !
#line 12253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return NULL;
                  return gen_split_1333 (insn, operands);

                case E_V4SFmode:
                  if (pattern1068 (x2, 
E_SFmode, 
E_V4SFmode) != 0
                      || !
#line 12253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && reload_completed))
                    return NULL;
                  return gen_split_1334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
              operands[1] = x4;
              operands[2] = x5;
              x9 = XEXP (x2, 2);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern959 (x2, 
E_V8HImode, 
E_HImode) != 0
                      || !
#line 19935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HImode))))
                    return NULL;
                  return gen_split_3158 (insn, operands);

                case E_V8HFmode:
                  if (pattern959 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 19935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HFmode))))
                    return NULL;
                  return gen_split_3159 (insn, operands);

                case E_V8BFmode:
                  if (pattern959 (x2, 
E_V8BFmode, 
E_BFmode) != 0
                      || !
#line 19935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && reload_completed
   && INTVAL (operands[3]) > 1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8BFmode))))
                    return NULL;
                  return gen_split_3160 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return NULL;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      if (GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LTU
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCCmode)
        return NULL;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != GEU
          || GET_MODE (x8) != E_QImode)
        return NULL;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCCmode)
        return NULL;
      x10 = XEXP (x8, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCCmode
          || GET_MODE (x3) != E_CCCmode
          || !
#line 2162 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SLOW_STC && !optimize_insn_for_size_p ()))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_2 (insn, operands);

    case AND:
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x2) != E_CCZmode
          || GET_MODE (x3) != E_CCZmode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return NULL;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || !
#line 12414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL
   && !MEM_VOLATILE_P (operands[0])
   && offsettable_memref_p (operands[0])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_120 (insn, operands);

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !
#line 12414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL
   && !MEM_VOLATILE_P (operands[0])
   && offsettable_memref_p (operands[0])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_121 (insn, operands);

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !(
#line 12414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_MEMORY_READ_STALL
   && !MEM_VOLATILE_P (operands[0])
   && offsettable_memref_p (operands[0])) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_122 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern352 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 5965 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (SFmode)
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_54 (insn, operands);

        case 1:
          if (!
#line 5965 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (DFmode)
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_56 (insn, operands);

        default:
          return NULL;
        }

    case E_DImode:
      switch (pattern352 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 5965 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (SFmode)
   && optimize_insn_for_speed_p ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_55 (insn, operands);

        case 1:
          if (!(
#line 5965 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVOID_VECTOR_DECODE
   && SSE_FLOAT_MODE_P (DFmode)
   && optimize_insn_for_speed_p ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_57 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
      if (peep2_current_count < 2)
        return NULL;
      operands[0] = x2;
      x3 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x3) != SET)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != STRICT_LOW_PART)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode))
            return NULL;
          switch (pattern1141 ())
            {
            case 0:
              if (!
#line 4948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_43 (insn, operands);

            case 1:
              if (!
#line 4948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (SImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_45 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode))
            return NULL;
          switch (pattern1141 ())
            {
            case 0:
              if (!(
#line 4948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_44 (insn, operands);

            case 1:
              if (!(
#line 4948 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) == REGNO (operands[1])
   && (DImode != SImode
       || !TARGET_ZERO_EXTEND_WITH_AND
       || !optimize_function_for_speed_p (cfun))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_46 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SUBREG:
    case MEM:
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || !
#line 27822 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((QImode == HImode
       && TARGET_LCP_STALL)
       || (!TARGET_USE_MOV0
          && TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_236 (insn, operands);

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || !
#line 27822 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((HImode == HImode
       && TARGET_LCP_STALL)
       || (!TARGET_USE_MOV0
          && TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_237 (insn, operands);

        default:
          return NULL;
        }

    case STRICT_LOW_PART:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || !
#line 28509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((! TARGET_USE_MOV0 || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_313 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || !
#line 28509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((! TARGET_USE_MOV0 || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_314 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_CODE (operands[0]))
    {
    case REG:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern665 (x4, 
E_QImode))
            {
            case 0:
              if (pattern1223 (x4, 
E_QImode) != 0
                  || !
#line 3385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_13 (insn, operands);

            case 1:
              if (XVECLEN (x4, 0) != 2)
                return NULL;
              x5 = XVECEXP (x4, 0, 0);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) != NEG
                  || pattern1384 (x4, 
E_QImode) != 0)
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_148 (insn, operands);

            default:
              return NULL;
            }

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern665 (x4, 
E_HImode))
            {
            case 0:
              if (pattern1223 (x4, 
E_HImode) != 0
                  || !
#line 3385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (XVECLEN (x4, 0) != 2)
                return NULL;
              x5 = XVECEXP (x4, 0, 0);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) == NEG
                  && pattern1384 (x4, 
E_HImode) == 0)
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_149 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (peep2_current_count < 4)
                return NULL;
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 17)
                return NULL;
              x8 = XVECEXP (x4, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              operands[5] = x6;
              x9 = XEXP (x8, 1);
              operands[6] = x9;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return NULL;
              x11 = PATTERN (peep2_next_insn (2));
              if (pattern1226 (x11, 
E_HImode) != 0
                  || !
#line 26511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (1, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_188 (insn, operands);

            default:
              return NULL;
            }

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || !general_reg_operand (operands[1], E_SImode))
            return NULL;
          if (peep2_current_count >= 2)
            {
              x4 = PATTERN (peep2_next_insn (1));
              if (pattern962 (x4, 
E_SImode) == 0
                  && 
#line 3385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_15 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!
#line 3418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_size > 1
  && ((REGNO (operands[0]) == AX_REG)
      != (REGNO (operands[1]) == AX_REG))
  && optimize_insn_for_size_p ()
  && peep2_reg_dead_p (1, operands[1])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_25 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || !general_reg_operand (operands[1], E_DImode))
            return NULL;
          if (peep2_current_count >= 2)
            {
              x4 = PATTERN (peep2_next_insn (1));
              if (pattern962 (x4, 
E_DImode) == 0
                  && (
#line 3385 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (3, operands[0])
   && optimize_insn_for_size_p ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_16 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if ((
#line 3418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_size > 1
  && ((REGNO (operands[0]) == AX_REG)
      != (REGNO (operands[1]) == AX_REG))
  && optimize_insn_for_size_p ()
  && peep2_reg_dead_p (1, operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_26 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4)
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != PARALLEL
              || XVECLEN (x4, 0) != 2)
            return NULL;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != ASHIFTRT
              || GET_MODE (x6) != E_DImode)
            return NULL;
          x12 = XEXP (x6, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 63]
              || pattern1225 (x4) != 0)
            return NULL;
          x11 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x11) != SET)
            return NULL;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          if (!general_reg_operand (operands[2], E_DImode))
            return NULL;
          x14 = XEXP (x11, 1);
          if (!rtx_equal_p (x14, operands[1]))
            return NULL;
          x15 = PATTERN (peep2_next_insn (3));
          if (GET_CODE (x15) != SET)
            return NULL;
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          if (!general_reg_operand (operands[3], E_DImode))
            return NULL;
          x17 = XEXP (x15, 1);
          if (!rtx_equal_p (x17, operands[0])
              || !
#line 5116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((optimize_function_for_size_p (cfun) || TARGET_USE_CLTD)
   && REGNO (operands[2]) == AX_REG
   && REGNO (operands[3]) == DX_REG
   && peep2_reg_dead_p (4, operands[0])
   && !reg_mentioned_p (operands[0], operands[1])
   && !reg_mentioned_p (operands[2], operands[0])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_51 (insn, operands);

        default:
          return NULL;
        }

    case SUBREG:
    case MEM:
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern868 (x4, 
E_SImode))
            {
            case 0:
              if (!(
#line 5039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[1]) != REGNO (operands[2])
   && INTVAL (operands[4]) == (4 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (4, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_47 (insn, operands);

            case 1:
              if (!(
#line 5057 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(/* cltd is shorter than sarl $31, %eax */
   !optimize_function_for_size_p (cfun)
   && REGNO (operands[1]) == AX_REG
   && REGNO (operands[2]) == DX_REG
   && INTVAL (operands[4]) == (4 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_49 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          x4 = PATTERN (peep2_next_insn (1));
          switch (pattern868 (x4, 
E_DImode))
            {
            case 0:
              if (!(
#line 5039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[1]) != REGNO (operands[2])
   && INTVAL (operands[4]) == (8 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (4, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 3;
              return gen_peephole2_48 (insn, operands);

            case 1:
              if (!(
#line 5057 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(/* cltd is shorter than sarl $31, %eax */
   !optimize_function_for_size_p (cfun)
   && REGNO (operands[1]) == AX_REG
   && REGNO (operands[2]) == DX_REG
   && INTVAL (operands[4]) == (8 * BITS_PER_UNIT - 1)
   && peep2_reg_dead_p (2, operands[1])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_mentioned_p (operands[2], operands[3])) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_50 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IOR
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != -65536L)
    return NULL;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LSHIFTRT
      || GET_MODE (x6) != E_SImode)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != BSWAP
      || GET_MODE (x7) != E_SImode)
    return NULL;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return NULL;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return NULL;
  x10 = XEXP (x7, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x2, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[2] = x13;
  if (!general_reg_operand (operands[2], E_SImode))
    return NULL;
  x14 = XEXP (x12, 1);
  if (!rtx_equal_p (x14, operands[0])
      || !
#line 22691 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)
   && peep2_reg_dead_p(3, operands[0])))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_178 (insn, operands);
}

 rtx_insn *
peephole2_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  if (!general_reg_operand (x3, E_SImode))
    return NULL;
  operands[8] = x3;
  switch (pattern870 (x1, 
E_SImode, 
E_DImode))
    {
    case 0:
      if (
#line 9660 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_98 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case 1:
      if (
#line 9715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (6, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && !reg_overlap_mentioned_p (operands[0], operands[10])
   && !reg_overlap_mentioned_p (operands[10], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[11])
   && !reg_overlap_mentioned_p (operands[11], operands[1])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))))
        {
          *pmatch_len_ = 5;
          res = gen_peephole2_100 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (pattern873 (x1, 
E_SImode) != 0
      || !
#line 26545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_192 (insn, operands);
}

 rtx_insn *
peephole2_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (address_no_seg_operand (operands[1], E_DImode)
      && (
#line 6392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_hardreg_mov_ok (operands[0], operands[1])
   && peep2_regno_dead_p (0, FLAGS_REG)
   && ix86_avoid_lea_for_addr (peep2_next_insn (0), operands)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_59 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !memory_operand (operands[1], E_DImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return NULL;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !(
#line 20201 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_163 (insn, operands);

    case UNSPEC_VOLATILE:
      if (pattern767 (x2) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (2));
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          x9 = XEXP (x7, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !(
#line 20215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_165 (insn, operands);

        case SET:
          if (pattern1224 (x6) != 0
              || !(
#line 20422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (2))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (2)))) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_173 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      switch (pattern768 (x2))
        {
        case 0:
          if (!(
#line 20312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER
   && peep2_reg_dead_p (2, operands[0])) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_169 (insn, operands);

        case 1:
          if (!(
#line 20406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (peep2_next_insn (1))
   && !reg_mentioned_p (operands[0],
			CALL_INSN_FUNCTION_USAGE (peep2_next_insn (1)))) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_171 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 0);
  if (!general_reg_operand (x3, E_DImode))
    return NULL;
  operands[8] = x3;
  switch (pattern870 (x1, 
E_DImode, 
E_TImode))
    {
    case 0:
      if ((
#line 9660 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_99 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case 1:
      if ((
#line 9715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (6, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !reg_overlap_mentioned_p (operands[6], operands[9])
   && !reg_overlap_mentioned_p (operands[0], operands[10])
   && !reg_overlap_mentioned_p (operands[10], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[11])
   && !reg_overlap_mentioned_p (operands[11], operands[1])
   && (rtx_equal_p (operands[6], operands[0])
       ? (rtx_equal_p (operands[7], operands[1])
	  && rtx_equal_p (operands[8], operands[2]))
       : (rtx_equal_p (operands[8], operands[0])
	  && rtx_equal_p (operands[9], operands[1])
	  && rtx_equal_p (operands[6], operands[2])))) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 5;
          res = gen_peephole2_101 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (pattern873 (x1, 
E_DImode) != 0
      || !(
#line 26545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
  && REGNO (operands[2]) != REGNO (operands[0])
  && REGNO (operands[2]) != REGNO (operands[1])
  && peep2_reg_dead_p (2, operands[1])
  && peep2_reg_dead_p (4, operands[2])
  && !reg_overlap_mentioned_p (operands[0], operands[3])
  && !reg_mentioned_p (operands[2], operands[6])) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_193 (insn, operands);
}

 rtx_insn *
peephole2_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (!binary_fp_operator (x3, E_VOIDmode))
    return NULL;
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return NULL;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!memory_operand (operands[3], E_VOIDmode)
          || !
#line 26853 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_195 (insn, operands);

    case SUBREG:
    case MEM:
      operands[3] = x5;
      if (!memory_operand (operands[3], E_VOIDmode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (!rtx_equal_p (x6, operands[0])
          || !
#line 26875 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_196 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 3)
    {
      res = peephole2_21 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (fp_register_operand (operands[1], E_VOIDmode)
      && fp_register_operand (operands[0], E_VOIDmode))
    {
      res = peephole2_22 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (general_reg_operand (operands[1], E_QImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern355 (x4, 
E_QImode) == 0
          && 
#line 28000 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (QImode != QImode
       || any_QIreg_operand (operands[1], QImode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_259 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (general_reg_operand (operands[1], E_HImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern355 (x4, 
E_HImode) == 0
          && 
#line 28000 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (HImode != QImode
       || any_QIreg_operand (operands[1], QImode))))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_260 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (general_reg_operand (operands[1], E_DImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern355 (x4, 
E_DImode) == 0
          && (
#line 28000 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(REGNO (operands[0]) != REGNO (operands[1])
   && (DImode != QImode
       || any_QIreg_operand (operands[1], QImode))) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_262 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count < 3
      || peep2_current_count < 4)
    return NULL;
  if (memory_operand (operands[1], E_QImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern667 (x4, 
E_QImode) == 0)
        {
          x5 = PATTERN (peep2_next_insn (2));
          x6 = XEXP (x5, 0);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = PATTERN (peep2_next_insn (3));
              if (pattern1643 (x7) == 0
                  && 
#line 28091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_273 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 5
              && pattern1644 (x6, 
E_QImode) == 0
              && 
#line 28289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (QImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
            {
              *pmatch_len_ = 4;
              res = gen_peephole2_295 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (memory_operand (operands[1], E_HImode))
    {
      x4 = PATTERN (peep2_next_insn (1));
      if (pattern667 (x4, 
E_HImode) == 0)
        {
          x5 = PATTERN (peep2_next_insn (2));
          x6 = XEXP (x5, 0);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = PATTERN (peep2_next_insn (3));
              if (pattern1643 (x7) == 0
                  && 
#line 28091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
                {
                  *pmatch_len_ = 3;
                  res = gen_peephole2_274 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 5
              && pattern1644 (x6, 
E_HImode) == 0
              && 
#line 28289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (HImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)))
            {
              *pmatch_len_ = 4;
              res = gen_peephole2_296 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (!memory_operand (operands[1], E_DImode)
      || !register_operand (operands[0], E_DImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return NULL;
  x8 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x8, 1);
  if (!plusminuslogic_operator (x9, E_DImode))
    return NULL;
  operands[3] = x9;
  x10 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x10) != CLOBBER)
    return NULL;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 17
      || GET_MODE (x11) != E_CCmode)
    return NULL;
  x12 = XEXP (x9, 1);
  operands[2] = x12;
  if (!x86_64_nonmemory_operand (operands[2], E_DImode)
      || pattern666 (x8) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (2));
  x6 = XEXP (x5, 0);
  if (rtx_equal_p (x6, operands[1]))
    {
      x7 = PATTERN (peep2_next_insn (3));
      if (pattern1643 (x7) == 0
          && (
#line 28091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && (DImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (3),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pmatch_len_ = 3;
          res = gen_peephole2_276 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
    }
  if (peep2_current_count < 5
      || pattern1644 (x6, 
E_DImode) != 0
      || !(
#line 28289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (5, operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[4], operands[1])
   && (DImode != QImode
       || immediate_operand (operands[2], QImode)
       || any_QIreg_operand (operands[2], QImode))
   && ix86_match_ccmode (peep2_next_insn (4),
			 (GET_CODE (operands[3]) == PLUS
			  || GET_CODE (operands[3]) == MINUS)
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
    return NULL;
  *pmatch_len_ = 4;
  return gen_peephole2_298 (insn, operands);
}

 rtx_insn *
peephole2_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count >= 2)
    {
      res = peephole2_33 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (const0_operand (operands[1], E_VOIDmode)
      && general_reg_operand (operands[0], E_VOIDmode)
      && 
#line 28499 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE_SIZE (GET_MODE (operands[0])) <= UNITS_PER_WORD
   && (! TARGET_USE_MOV0 || optimize_insn_for_size_p ())
   && peep2_regno_dead_p (0, FLAGS_REG)))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_312 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !memory_operand (operands[1], E_DFmode)
      || !sse_reg_operand (operands[0], E_DFmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!sse_reg_operand (operands[2], E_V2DFmode))
    return NULL;
  x7 = XEXP (x5, 0);
  operands[4] = x7;
  if (!sse_reg_operand (operands[4], E_DFmode))
    return NULL;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  if (!memory_operand (operands[3], E_DFmode)
      || !
#line 1966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_SSE_UNALIGNED_LOAD_OPTIMAL
   && REGNO (operands[4]) == REGNO (operands[2])
   && ix86_operands_ok_for_move_multiple (operands, true, DFmode)))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_377 (insn, operands);
}

 rtx_insn *
peephole2_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return NULL;
  x8 = XEXP (x6, 1);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!register_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern356 (x9, 
PLUS, 
2) != 0)
        return NULL;
      x10 = XVECEXP (x9, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return NULL;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XVECEXP (x9, 0, 0);
      x13 = XEXP (x12, 1);
      x14 = XEXP (x13, 1);
      operands[2] = x14;
      if (!x86_64_immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[0]))
        return NULL;
      x16 = XEXP (x12, 0);
      if (!rtx_equal_p (x16, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x13) != E_SImode
              || !
#line 6442 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || GET_MODE (x13) != E_DImode
              || !(
#line 6442 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 3
          || XWINT (x8, 0) != -1L)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern1135 (x9, 
-1) != 0)
        return NULL;
      x17 = PATTERN (peep2_next_insn (2));
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      operands[1] = x19;
      if (pattern1624 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      operands[2] = x20;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !
#line 8725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_70 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !
#line 8725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_71 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 8725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_72 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 8725 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_73 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) == 1
          && XINT (x2, 1) == 41
          && pattern60 (x1, 
E_CCCmode) == 0
          && 
#line 2136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SLOW_STC && !optimize_insn_for_size_p ()))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case COMPARE:
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case FLOAT_EXTEND:
      if (GET_MODE (x2) == E_DFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (sse_reg_operand (operands[0], E_DFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (memory_operand (operands[1], E_SFmode)
                  && 
#line 5388 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_52 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (sse_reg_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 5618 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_53 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case FIX:
      res = peephole2_2 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case NE:
    case EQ:
      res = peephole2_3 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = peephole2_8 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case VEC_SELECT:
      res = peephole2_9 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      res = peephole2_14 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case E_DImode:
      res = peephole2_19 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_23 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  operands[0] = x3;
  res = peephole2_27 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  switch (GET_CODE (x2))
    {
    case BSWAP:
      if (GET_MODE (x2) == E_HImode)
        {
          operands[0] = x3;
          if (general_reg_operand (operands[0], E_HImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && 
#line 22646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_176 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case IOR:
      res = peephole2_28 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case ZERO_EXTEND:
      res = peephole2_29 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case IF_THEN_ELSE:
      res = peephole2_30 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = peephole2_32 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[1] = x2;
      if (immediate_operand (operands[1], E_SImode))
        {
          operands[0] = x3;
          if (memory_operand (operands[0], E_SImode)
              && 
#line 27838 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_241 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x3) == REG)
    {
      res = peephole2_34 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_36 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case COMPARE:
      operands[1] = x2;
      if (!compare_operator (operands[1], E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT
          || !flags_reg_operand (operands[0], E_VOIDmode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode)
              && XWINT (x5, 0) == 0L
              && 
#line 27853 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p () && ix86_match_ccmode (insn, CCNOmode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_242 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 28756 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((((!TARGET_FUSE_CMP_AND_BRANCH || optimize_insn_for_size_p ())
     && incdec_operand (operands[3], GET_MODE (operands[3])))
    || (!TARGET_FUSE_CMP_AND_BRANCH
	&& INTVAL (operands[3]) == 128))
   && ix86_match_ccmode (insn, CCGCmode)
   && peep2_reg_dead_p (1, operands[2])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_364 (insn, operands);

        case AND:
          if (XWINT (x5, 0) != 0L)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && immediate_operand (operands[3], E_SImode)
                  && 
#line 27895 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && (REGNO (operands[2]) != AX_REG
       || satisfies_constraint_K (operands[3]))
   && peep2_reg_dead_p (1, operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_246 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_QImode:
              if (register_operand (operands[2], E_QImode)
                  && immediate_operand (operands[3], E_QImode)
                  && 
#line 27915 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_247 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG
              || maybe_ne (SUBREG_BYTE (x6), 0)
              || GET_MODE (x6) != E_QImode)
            return NULL;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTRACT:
            case ZERO_EXTRACT:
              operands[4] = x8;
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return NULL;
              x10 = XEXP (x8, 2);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
                  || GET_MODE (x4) != E_QImode)
                return NULL;
              x11 = XEXP (x8, 0);
              operands[2] = x11;
              if (!int248_register_operand (operands[2], E_VOIDmode))
                return NULL;
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return NULL;
              switch (GET_MODE (operands[4]))
                {
                case E_HImode:
                  if (!extract_operator (operands[4], E_HImode)
                      || !
#line 27937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_248 (insn, operands);

                case E_SImode:
                  if (!extract_operator (operands[4], E_SImode)
                      || !
#line 27937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_249 (insn, operands);

                case E_DImode:
                  if (!extract_operator (operands[4], E_DImode)
                      || !(
#line 27937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_250 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_gr_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_gr_operand (operands[1], E_QImode)
              || !
#line 27871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], QImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], QImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_243 (insn, operands);

        case E_HImode:
          if (!nonimmediate_gr_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_gr_operand (operands[1], E_HImode)
              || !
#line 27871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], HImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], HImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_244 (insn, operands);

        case E_SImode:
          if (!nonimmediate_gr_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_gr_operand (operands[1], E_SImode)
              || !
#line 27871 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], SImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], SImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_245 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (GET_CODE (x2) == CONST_INT)
        {
          res = peephole2_37 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      operands[1] = x2;
      x12 = PATTERN (peep2_next_insn (1));
      if (pattern547 (x12, 
109, 
4) != 0)
        return NULL;
      x13 = XVECEXP (x12, 0, 1);
      if (pattern1140 (x13) != 0
          || pattern1387 (x12) != 0)
        return NULL;
      x14 = XVECEXP (x12, 0, 0);
      x15 = XEXP (x14, 1);
      x16 = XVECEXP (x15, 0, 2);
      operands[3] = x16;
      if (pattern1672 (x12) != 0)
        return NULL;
      x17 = PATTERN (peep2_next_insn (2));
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 1);
      operands[6] = x19;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1723 (x12, 
E_HImode) != 0
              || !
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_380 (insn, operands);

        case E_SImode:
          if (pattern1723 (x12, 
E_SImode) != 0
              || !
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_381 (insn, operands);

        case E_DImode:
          if (pattern1723 (x12, 
E_DImode) != 0
              || !(
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_382 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern57 (x2))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (x86_64_nonmemory_operand (operands[1], E_SImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && 
#line 28536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_318 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!x86_64_nonmemory_operand (operands[1], E_SImode)
              || !rtx_equal_p (x5, operands[0])
              || !
#line 28545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_320 (insn, operands);

        case 1:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (x86_64_nonmemory_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && (
#line 28536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_319 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!x86_64_nonmemory_operand (operands[1], E_DImode)
              || !rtx_equal_p (x5, operands[0])
              || !(
#line 28545 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_321 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x4 = XEXP (x2, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 28578 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(pow2p_hwi (INTVAL (operands[1]))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_322 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const_int_operand (operands[1], E_DImode)
              || !(
#line 28578 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(pow2p_hwi (INTVAL (operands[1]))
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_323 (insn, operands);

        default:
          return NULL;
        }

    case VEC_CONCAT:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_V2DFmode
          || !sse_reg_operand (operands[0], E_V2DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_DFmode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      if (!const0_operand (operands[4], E_DFmode))
        return NULL;
      x12 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x12) != SET)
        return NULL;
      x20 = XEXP (x12, 1);
      if (GET_CODE (x20) != VEC_CONCAT
          || GET_MODE (x20) != E_V2DFmode)
        return NULL;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != VEC_SELECT
          || GET_MODE (x21) != E_DFmode)
        return NULL;
      x22 = XEXP (x21, 1);
      if (GET_CODE (x22) != PARALLEL
          || XVECLEN (x22, 0) != 1)
        return NULL;
      x23 = XVECEXP (x22, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x24 = XEXP (x12, 0);
      operands[2] = x24;
      if (!sse_reg_operand (operands[2], E_V2DFmode))
        return NULL;
      x25 = XEXP (x20, 1);
      operands[3] = x25;
      if (!memory_operand (operands[3], E_DFmode))
        return NULL;
      x26 = XEXP (x21, 0);
      if (!rtx_equal_p (x26, operands[2])
          || !
#line 1955 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_SSE_UNALIGNED_LOAD_OPTIMAL
   && ix86_operands_ok_for_move_multiple (operands, true, DFmode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_376 (insn, operands);

    default:
      return NULL;
    }
}
