/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern6 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern6 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern27 (x3, 
E_V16SImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern27 (x3, 
E_V8SImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern27 (x3, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8DImode:
          if (pattern27 (x3, 
E_V8DImode) != 0)
            return -1;
          return 3;

        case E_V4DImode:
          if (pattern27 (x3, 
E_V4DImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern27 (x3, 
E_V2DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern32 (x3, 
E_V16SImode) != 0)
            return -1;
          return 6;

        case E_V8SImode:
          if (pattern32 (x3, 
E_V8SImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 8;

        case E_V8DImode:
          if (pattern32 (x3, 
E_V8DImode) != 0)
            return -1;
          return 9;

        case E_V4DImode:
          if (pattern32 (x3, 
E_V4DImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 11;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !nonimmediate_operand (operands[1], E_V16QImode)
              || !const_0_to_7_operand (operands[2], E_SImode))
            return -1;
          return 12;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !nonimmediate_operand (operands[1], E_V8HImode)
              || !const_0_to_15_operand (operands[2], E_SImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern26 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern26 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern26 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern26 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern26 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern26 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!register_mmxmem_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !nonimmediate_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  return pattern69 (x3); /* [-1, 8] */
}

int
pattern73 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern72 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern72 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!memory_operand (operands[1], E_XImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2QImode:
      return pattern95 (x1, 
E_V2QImode); /* [-1, 0] */

    case E_V4QImode:
      res = pattern96 (x1, 
E_V4QImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || GET_MODE (x2) != E_V8QImode)
        return -1;
      res = pattern97 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      res = pattern96 (x1, 
E_V4HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_V2HImode:
      if (pattern95 (x1, 
E_V2HImode) != 0)
        return -1;
      return 8;

    case E_V2SImode:
      if (pattern95 (x1, 
E_V2SImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern127 (x1, 
E_V8HImode, 
E_QImode, 
E_V8HFmode); /* [-1, 0] */

        case E_V16HImode:
          if (pattern127 (x1, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V32HImode:
          if (pattern127 (x1, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0)
            return -1;
          return 2;

        case E_V8SImode:
          if (pattern128 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x1) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode
              || !nonimm_or_0_operand (operands[2], E_V16SImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16HFmode:
              if (!vector_operand (operands[1], E_V16HFmode))
                return -1;
              return 4;

            case E_V16SFmode:
              if (!vector_operand (operands[1], E_V16SFmode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x1) != E_V8DImode
              || GET_MODE (x4) != E_V8DImode
              || !nonimm_or_0_operand (operands[2], E_V8DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!vector_operand (operands[1], E_V8HFmode))
                return -1;
              return 6;

            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode))
                return -1;
              return 7;

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode))
                return -1;
              return 8;

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern128 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 9;

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x1) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || !nonimm_or_0_operand (operands[2], E_V4DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4HFmode:
              if (!memory_operand (operands[1], E_V4HFmode))
                return -1;
              return 10;

            case E_V4DFmode:
              if (!vector_operand (operands[1], E_V4DFmode))
                return -1;
              return 11;

            case E_V4SFmode:
              if (!vector_operand (operands[1], E_V4SFmode))
                return -1;
              return 12;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode)
              || !register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2HFmode:
              if (!memory_operand (operands[1], E_V2HFmode))
                return -1;
              return 13;

            case E_V2DFmode:
              if (!vector_operand (operands[1], E_V2DFmode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (XVECLEN (x6, 0))
        {
        case 4:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XVECEXP (x6, 0, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x6, 0, 3);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || GET_MODE (x5) != E_V4HFmode
              || !register_operand (operands[1], E_V8HFmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern129 (x1, 
E_V4SImode) != 0)
                return -1;
              return 15;

            case E_V4DImode:
              if (pattern129 (x1, 
E_V4DImode) != 0)
                return -1;
              return 16;

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x6, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x6, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || !nonimm_or_0_operand (operands[2], E_V2DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              return 17;

            case E_V2SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode))
                return -1;
              return 18;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern189 (x3); /* [-1, 1] */
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern195 (x1); /* [-1, 3] */
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern196 (x1); /* [-1, 3] */
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonimmediate_operand (operands[2], E_QImode))
    return -1;
  return pattern195 (x1); /* [-1, 3] */
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 110)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern203 (x5, 
E_V2SFmode); /* [-1, 0] */
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_1_to_31_operand (operands[2], E_QImode))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern220 (x1, 
E_V32HImode); /* [-1, 0] */

    case E_V16SImode:
      if (pattern220 (x1, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern220 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x5, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x11 = XEXP (x8, 0);
  operands[0] = x11;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!int248_register_operand (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      res = pattern252 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern270 (x1, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern270 (x1, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern270 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8DImode:
      res = pattern271 (x1, 
E_V8DImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case E_V4DImode:
      res = pattern271 (x1, 
E_V4DImode);
      if (res >= 0)
        return res + 5; /* [5, 6] */
      return -1;

    case E_V2DImode:
      res = pattern271 (x1, 
E_V2DImode);
      if (res >= 0)
        return res + 7; /* [7, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 1;

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 3;

        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 4;

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode))
            return -1;
          return 6;

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4DFmode:
          if (!vector_operand (operands[1], E_V4DFmode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode))
            return -1;
          return 10;

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  x10 = XEXP (x3, 1);
  operands[1] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    case E_DImode:
      return 3;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      return 0;

    case UNSPEC_VOLATILE:
      res = pattern313 (x1, 
i1);
      if (res >= 0)
        return res + 1; /* [1, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern320 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          return 0;

        case USE:
          return 1;

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      res = pattern323 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const248_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern336 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern336 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XWINT (x2, 0) != 0L)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 147)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 147)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V16QImode:
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !const0_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!vector_operand (operands[1], E_V16HImode)
          || !vector_operand (operands[2], E_V16HImode)
          || !const0_operand (operands[3], E_V16HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const248_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern371 (x1); /* [-1, 1] */
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (pattern378 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern19 (x1); /* [-1, 1] */
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[4] = x6;
  if (!const_0_to_7_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern360 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      res = pattern393 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V32HImode
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x1) != E_V32HImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_V32HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_0_to_255_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!nonimm_or_0_operand (operands[3], E_V32HImode))
    return -1;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_0_to_255_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  x7 = XEXP (x1, 2);
  operands[5] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern412 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern412 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern412 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern430 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern428 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern428 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 1;

    case E_V8DFmode:
      if (pattern428 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern435 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!vector_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!vector_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SFmode
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[3], E_V2SFmode)
      || !const0_operand (operands[4], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_V4QImode:
          return pattern450 (
E_V12QImode); /* [-1, 1] */

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V14QImode))
            return -1;
          return 2;

        case E_V8QImode:
          if (!const0_operand (operands[2], E_V8QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              return 3;

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              return 4;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_V4HImode:
          res = pattern450 (
E_V4HImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V6HImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2SImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern475 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return pattern473 (x1); /* [-1, 2] */

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          res = pattern474 (x1, 
E_V4SImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case E_V4DImode:
          res = pattern474 (x1, 
E_V4DImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 7;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 8;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern501 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x2;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern506 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern505 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern510 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !nonimmediate_operand (operands[1], E_SImode)
      || !x86_64_general_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 174)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern512 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern512 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern512 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern512 (x5, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern523 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 32)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern522 (x1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern524 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern524 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  return pattern391 (x2); /* [-1, 0] */
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x4) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SUBREG
      || maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      return 0;

    default:
      return -1;
    }
}

int
pattern551 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_CCZmode
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !vector_operand (operands[1], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !vector_operand (operands[1], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !vector_operand (operands[1], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !vector_operand (operands[1], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode)
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !vector_operand (operands[1], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 5;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !vector_operand (operands[1], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      return 6;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !vector_operand (operands[1], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode)
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !vector_operand (operands[1], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode)
        return -1;
      return 8;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !vector_operand (operands[1], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      return 9;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !vector_operand (operands[1], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode)
        return -1;
      return 10;

    case E_V2TImode:
      if (!register_operand (operands[0], E_V2TImode)
          || !vector_operand (operands[1], E_V2TImode)
          || GET_MODE (x3) != E_V2TImode)
        return -1;
      return 11;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !vector_operand (operands[1], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode)
        return -1;
      return 12;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !vector_operand (operands[1], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      return pattern594 (x1, 
E_V8SImode, 
E_V8SFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern594 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V4DFmode:
      if (pattern594 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
        return -1;
      return 2;

    case E_V2DFmode:
      if (pattern594 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
        return -1;
      return 3;

    case E_V32QImode:
      if (pattern595 (x1, 
E_V32QImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern595 (x1, 
E_V16QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern605 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  return 0;
}

int
pattern617 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern623 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern625 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern623 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern623 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern624 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern624 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case STRICT_LOW_PART:
      return 1;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 37)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != PLUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 7
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 7
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern652 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[2], i1)
      || pattern651 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern662 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (XVECLEN (x4, 0) < 1)
    return -1;
  operands[5] = x4;
  if (!addsub_vs_parallel (operands[5], E_VOIDmode))
    return -1;
  operands[7] = x1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  x10 = XVECEXP (x4, 0, 0);
  operands[6] = x10;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    case E_V2DFmode:
      return 3;

    default:
      return -1;
    }
}

int
pattern673 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern680 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern693 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[3] = x4;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern702 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern710 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern715 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern724 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern741 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!movq_parallel (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[4] = x6;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern737 (x1, 
E_V64QImode, 
E_V128QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern737 (x1, 
E_V32QImode, 
E_V64QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern737 (x1, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern737 (x1, 
E_V32HImode, 
E_V64HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern737 (x1, 
E_V16HImode, 
E_V32HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern737 (x1, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern756 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE
      || !register_operand (operands[1], E_XFmode))
    return -1;
  return pattern755 (x1, pnum_clobbers); /* [-1, 2] */
}

int
pattern758 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern763 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern772 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[0], E_QImode)
          || !nonmemory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || !x86_64_szext_nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 3;

    case E_TImode:
      if (GET_MODE (x2) != E_TImode
          || !nonimmediate_operand (operands[0], E_TImode)
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern783 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern797 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern803 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern809 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!nonimmediate_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern820 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  operands[3] = x7;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern819 (x1, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern819 (x1, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern828 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern827 (x1, 
E_V16SImode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern827 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 1;

    case E_V8DImode:
      if (pattern827 (x1, 
E_V8DImode) != 0)
        return -1;
      return 2;

    case E_V8DFmode:
      if (pattern827 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 3;

    case E_V8SImode:
      if (pattern827 (x1, 
E_V8SImode) != 0)
        return -1;
      return 4;

    case E_V8SFmode:
      if (pattern827 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern827 (x1, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern827 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern827 (x1, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V4SFmode:
      if (pattern827 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern827 (x1, 
E_V2DImode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern827 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    case E_V64QImode:
      if (pattern827 (x1, 
E_V64QImode) != 0)
        return -1;
      return 12;

    case E_V16QImode:
      if (pattern827 (x1, 
E_V16QImode) != 0)
        return -1;
      return 13;

    case E_V32QImode:
      if (pattern827 (x1, 
E_V32QImode) != 0)
        return -1;
      return 14;

    case E_V32HImode:
      if (pattern827 (x1, 
E_V32HImode) != 0)
        return -1;
      return 15;

    case E_V16HImode:
      if (pattern827 (x1, 
E_V16HImode) != 0)
        return -1;
      return 16;

    case E_V8HImode:
      if (pattern827 (x1, 
E_V8HImode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern850 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern857 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      x5 = XEXP (x3, 1);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern868 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 4)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != ASHIFTRT
          || GET_MODE (x6) != i1)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], i1))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 0;

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ASHIFTRT
          || GET_MODE (x16) != i1)
        return -1;
      x17 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x20 = XEXP (x16, 1);
      operands[4] = x20;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x21 = XEXP (x16, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != SET)
        return -1;
      x22 = XEXP (x4, 0);
      operands[3] = x22;
      if (!memory_operand (operands[3], i1))
        return -1;
      x23 = XEXP (x4, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern891 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[1], E_V64QImode)
      || !nonimmediate_operand (operands[2], E_V64QImode)
      || !const_0_to_7_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern895 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern903 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern910 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1)
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern919 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern924 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern921 (x1, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern921 (x1, 
E_V16HFmode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V32HImode:
      if (pattern921 (x1, 
E_V32HFmode, 
E_V32HImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      res = pattern922 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case E_V16SImode:
      res = pattern923 (x1);
      if (res >= 0)
        return res + 5; /* [5, 6] */
      return -1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_V8DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 7;

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode))
            return -1;
          return 8;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern950 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern954 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_CODE (x3))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x3), 0))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern320 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern320 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern320 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern320 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern978 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern977 (x2); /* [-1, 11] */
}

int
pattern986 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  return pattern792 (); /* [-1, 1] */
}

int
pattern991 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1001 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  x4 = XEXP (x2, 2);
  operands[5] = x4;
  if (!register_operand (operands[5], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1000 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1000 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1000 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1009 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern1015 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !nonimmediate_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern1014 (x4, 
i1, 
i2, 
i3, 
i4); /* [-1, 0] */
}

int
pattern1022 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern1021 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16SFmode:
      if (pattern1021 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 1;

    case E_V8DFmode:
      if (pattern1021 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1030 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1037 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i1)
      || !immediate_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1042 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  return pattern303 (x1); /* [-1, 1] */
}

int
pattern1051 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern1050 (x3, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern1050 (x3, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1061 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      return pattern1053 (x1); /* [-1, 11] */

    case CONST_INT:
      return 12;

    default:
      return -1;
    }
}

int
pattern1067 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !const0_operand (operands[2], i2)
      || !vector_all_ones_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1073 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case REG:
      if (peep2_current_count < 4)
        return -1;
      operands[5] = x3;
      if (!general_reg_operand (operands[5], i1))
        return -1;
      x4 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[5]))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1084 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1091 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  if (!const_4_or_8_to_11_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      return pattern1112 (x1); /* [-1, 1] */

    default:
      return -1;
    }
}

int
pattern1124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      return 0;

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      return 1;

    default:
      return -1;
    }
}

int
pattern1131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!mask_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !mask_reg_operand (operands[1], i1)
      || !mask_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!plusminuslogic_operator (x4, i1))
    return -1;
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  if (!x86_64_nonmemory_operand (operands[2], i1))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x7, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  return 0;
}

int
pattern1152 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern1155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !ix86_carry_flag_operator (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !ix86_carry_flag_operator (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1163 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !bcst_vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[5], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 3;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 4;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 5;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 6;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 2);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern1203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], E_QImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1218 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (pnum_clobbers == NULL
          || pattern523 (x1) != 0)
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern522 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern522 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case USE:
      res = pattern525 (x1);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x2, 0);
      return pattern1235 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x2, 0);
      if (pattern1235 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1245 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i2))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  if (!register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  if (!nonimm_or_0_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x1, 2);
  operands[4] = x8;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern1258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1257 (x3, 
i1); /* [-1, 0] */
}

int
pattern1267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1257 (x4, 
i1); /* [-1, 0] */
}

int
pattern1277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1284 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1291 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vector_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1300 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vm_operator (operands[6], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1320 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i3))
    return -1;
  return 0;
}

int
pattern1330 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], E_VOIDmode)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1341 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1369 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1375 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  return pattern1383 (x8); /* [-1, 0] */
}

int
pattern1393 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1400 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1409 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2L)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 3L)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4L)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 5L)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6L)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 7L)
    return -1;
  return 0;
}

int
pattern1421 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1430 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !general_reg_operand (operands[4], i1)
      || !general_reg_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1437 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1445 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1452 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  return 0;
}

int
pattern1466 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1474 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1482 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_mmxmem_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1495 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1502 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1511 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x2, 0);
      return pattern1510 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x2, 0);
      if (pattern1510 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1522 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1549 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1548 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1548 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1559 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1559 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1571 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1580 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1587 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1595 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[7], E_QImode)
      || !vsib_mem_operator (operands[6], i1)
      || !scratch_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1594 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1594 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1606 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  operands[2] = x1;
  x2 = PATTERN (peep2_next_insn (1));
  return pattern1605 (x2, 
i1); /* [-1, 0] */
}

int
pattern1612 (machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i3)
      || !register_operand (operands[6], i1)
      || !register_operand (operands[3], i2)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1617 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1616 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1616 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1627 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1634 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1633 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1633 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1647 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 109)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 109)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC_VOLATILE
      || XVECLEN (x8, 0) != 1
      || XINT (x8, 1) != 109
      || GET_MODE (x8) != E_CCZmode)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x7, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCZmode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 0);
  operands[3] = x12;
  x13 = XVECEXP (x3, 0, 2);
  operands[4] = x13;
  x14 = XVECEXP (x3, 0, 3);
  operands[5] = x14;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x15 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x4, 0);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = PATTERN (peep2_next_insn (2));
  x18 = XEXP (x17, 1);
  x19 = XEXP (x18, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x18, 1);
  if (!rtx_equal_p (x20, operands[1]))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      return pattern1646 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1646 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1646 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1646 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1676 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vsib_mem_operator (operands[6], i2)
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1683 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return pattern1682 (x1, 
i1); /* [-1, 1] */
}

int
pattern1689 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_7_operand (operands[4], E_VOIDmode)
      || !const_0_to_7_operand (operands[5], E_VOIDmode)
      || !const_0_to_7_operand (operands[6], E_VOIDmode)
      || !const_8_to_15_operand (operands[7], E_VOIDmode)
      || !const_8_to_15_operand (operands[8], E_VOIDmode)
      || !const_8_to_15_operand (operands[9], E_VOIDmode)
      || !const_8_to_15_operand (operands[10], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1693 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[5] = x5;
  if (!const_0_to_1_operand (operands[5], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[6] = x8;
  if (!const_0_to_1_operand (operands[6], E_SImode))
    return -1;
  x9 = XEXP (x1, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x6, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern1703 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1706 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

int
pattern1718 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1725 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12L)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 44L)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13L)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 45L)
    return -1;
  x6 = XVECEXP (x1, 0, 12);
  if (XWINT (x6, 0) != 14L)
    return -1;
  x7 = XVECEXP (x1, 0, 13);
  if (XWINT (x7, 0) != 46L)
    return -1;
  x8 = XVECEXP (x1, 0, 14);
  if (XWINT (x8, 0) != 15L)
    return -1;
  x9 = XVECEXP (x1, 0, 15);
  if (XWINT (x9, 0) != 47L)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || !bt_comparison_operator (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (XWINT (x4, 0))
            {
            case 0L:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_HImode)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return -1;
              x8 = XEXP (x1, 0);
              operands[0] = x8;
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              operands[1] = x3;
              operands[2] = x5;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x9 = XEXP (x2, 2);
              operands[3] = x9;
              if (!nonimmediate_operand (operands[3], E_HImode))
                return -1;
              x10 = XEXP (x6, 0);
              if (!rtx_equal_p (x10, operands[2])
                  || !
#line 8750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE))
                return -1;
              *pnum_clobbers = 1;
              return 373; /* *dec_cmovhi */

            case -1L:
              x6 = XEXP (x2, 1);
              switch (GET_CODE (x6))
                {
                case LABEL_REF:
                  x9 = XEXP (x2, 2);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  x8 = XEXP (x1, 0);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  operands[0] = x3;
                  operands[1] = x5;
                  x10 = XEXP (x6, 0);
                  operands[2] = x10;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[1], E_QImode)
                          || !(
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2117; /* *kortest_cmpqi_jcc */

                    case E_HImode:
                      if (!register_operand (operands[1], E_HImode)
                          || !
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2118; /* *kortest_cmphi_jcc */

                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                        return -1;
                      *pnum_clobbers = 1;
                      return 2119; /* *kortest_cmpsi_jcc */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                case MEM:
                  operands[2] = x6;
                  x8 = XEXP (x1, 0);
                  operands[0] = x8;
                  operands[1] = x3;
                  operands[4] = x5;
                  x9 = XEXP (x2, 2);
                  operands[3] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode)
                          || GET_MODE (x2) != E_QImode
                          || !register_operand (operands[2], E_QImode)
                          || !register_operand (operands[3], E_QImode))
                        return -1;
                      switch (pattern1391 ())
                        {
                        case 0:
                          if (!(
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2120; /* *kortest_cmpqi_movqicc */

                        case 1:
                          if (!
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2121; /* *kortest_cmphi_movqicc */

                        case 2:
                          if (!(
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2122; /* *kortest_cmpsi_movqicc */

                        default:
                          return -1;
                        }

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode)
                          || GET_MODE (x2) != E_HImode
                          || !nonimmediate_operand (operands[2], E_HImode)
                          || !nonimmediate_operand (operands[3], E_HImode))
                        return -1;
                      switch (pattern1391 ())
                        {
                        case 0:
                          if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2123; /* *kortest_cmpqi_movhicc */

                        case 1:
                          if (!
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2125; /* *kortest_cmphi_movhicc */

                        case 2:
                          if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                            return -1;
                          *pnum_clobbers = 1;
                          return 2127; /* *kortest_cmpsi_movhicc */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x4, 0) != 0L)
            return -1;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_CODE (x9) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          x12 = XEXP (x5, 0);
          operands[1] = x12;
          x13 = XEXP (x5, 2);
          switch (GET_CODE (x13))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x13;
              if (nonmemory_operand (operands[2], E_QImode))
                {
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (nonimmediate_operand (operands[1], E_SImode)
                          && 
#line 19209 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], SImode))
   && ix86_pre_reload_split ()))
                        {
                          *pnum_clobbers = 1;
                          return 1171; /* *jcc_btsi */
                        }
                      break;

                    case E_DImode:
                      if (nonimmediate_operand (operands[1], E_DImode)
                          && (
#line 19209 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], DImode))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 1172; /* *jcc_btdi */
                        }
                      break;

                    default:
                      break;
                    }
                }
              if (GET_CODE (x13) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x13), 0)
                  || GET_MODE (x13) != E_QImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != AND)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              x16 = XEXP (x14, 1);
              operands[3] = x16;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 0);
              operands[4] = x10;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  switch (pattern1607 (x14, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1175; /* *jcc_btsi_mask_1 */

                    case 1:
                      if (!
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1177; /* *jcc_btsi_mask_1 */

                    case 2:
                      if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1179; /* *jcc_btsi_mask_1 */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern1607 (x14, 
E_DImode))
                    {
                    case 0:
                      if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1176; /* *jcc_btdi_mask_1 */

                    case 1:
                      if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1178; /* *jcc_btdi_mask_1 */

                    case 2:
                      if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1180; /* *jcc_btdi_mask_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              if (GET_MODE (x13) != E_QImode)
                return -1;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x17 = XEXP (x13, 1);
              operands[3] = x17;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 0);
              operands[4] = x10;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !
#line 19248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1173; /* *jcc_btsi_mask */

                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !(
#line 19248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1174; /* *jcc_btdi_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern225 (x2, 
E_SFmode) != 0
              || !
#line 26728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_XOP))
            return -1;
          return 1459; /* *xop_pcmov_sf */

        case E_DFmode:
          if (pattern225 (x2, 
E_DFmode) != 0
              || !
#line 26728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_XOP))
            return -1;
          return 1460; /* *xop_pcmov_df */

        case E_V4QImode:
          if (pattern226 (x2, 
E_V4QImode) != 0
              || !
#line 4488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1781; /* *xop_pcmov_v4qi */

        case E_V2QImode:
          if (pattern226 (x2, 
E_V2QImode) != 0
              || !
#line 4488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1782; /* *xop_pcmov_v2qi */

        case E_V2HImode:
          if (pattern226 (x2, 
E_V2HImode) != 0
              || !
#line 4488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1783; /* *xop_pcmov_v2hi */

        case E_V2HFmode:
          if (pattern226 (x2, 
E_V2HFmode) != 0
              || !
#line 4499 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1784; /* *xop_pcmov_v2hf */

        case E_V2BFmode:
          if (pattern226 (x2, 
E_V2BFmode) != 0
              || !
#line 4499 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1785; /* *xop_pcmov_v2bf */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 1);
      if (pattern227 (x6) != 0)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x9 = XEXP (x2, 2);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern1311 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 1740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
            return -1;
          return 1992; /* avx512f_storehf_mask */

        case E_SFmode:
          if (pattern1311 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 1740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 1993; /* avx512f_storesf_mask */

        case E_DFmode:
          if (pattern1311 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 1740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 1994; /* avx512f_storedf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (pattern979 (x3))
            {
            case 0:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2770; /* *avx512f_cmpv16si3_zero_extendhi */

            case 1:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 2791; /* *avx512vl_cmpv16hf3_zero_extendhi */

            case 2:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2797; /* *avx512f_cmpv16sf3_zero_extendhi */

            case 3:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V16QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2890; /* *avx512vl_cmpv16qi3_zero_extendhi */

            case 4:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V16HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2899; /* *avx512vl_cmpv16hi3_zero_extendhi */

            case 5:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2773; /* *avx512vl_cmpv8si3_zero_extendhi */

            case 6:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2776; /* *avx512vl_cmpv4si3_zero_extendhi */

            case 7:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2779; /* *avx512f_cmpv8di3_zero_extendhi */

            case 8:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2782; /* *avx512vl_cmpv4di3_zero_extendhi */

            case 9:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2785; /* *avx512vl_cmpv2di3_zero_extendhi */

            case 10:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 2794; /* *avx512fp16_cmpv8hf3_zero_extendhi */

            case 11:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2800; /* *avx512vl_cmpv8sf3_zero_extendhi */

            case 12:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2803; /* *avx512vl_cmpv4sf3_zero_extendhi */

            case 13:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2806; /* *avx512f_cmpv8df3_zero_extendhi */

            case 14:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2809; /* *avx512vl_cmpv4df3_zero_extendhi */

            case 15:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2812; /* *avx512vl_cmpv2df3_zero_extendhi */

            case 16:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V8HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2902; /* *avx512vl_cmpv8hi3_zero_extendhi */

            case 17:
              if (!(
#line 4415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
      < GET_MODE_PRECISION (HImode))) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 2788; /* *avx512bw_cmpv32hf3_zero_extendhi */

            case 18:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V32QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2893; /* *avx512vl_cmpv32qi3_zero_extendhi */

            case 19:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V32HImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2896; /* *avx512bw_cmpv32hi3_zero_extendhi */

            case 20:
              if (!(
#line 4505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (GET_MODE_NUNITS (V64QImode)
       < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2887; /* *avx512bw_cmpv64qi3_zero_extendhi */

            default:
              return -1;
            }

        case 157:
          switch (pattern981 (x3))
            {
            case 0:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2971; /* *avx512bw_ucmpv64qi3_zero_extendhi */

            case 1:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2974; /* *avx512vl_ucmpv16qi3_zero_extendhi */

            case 2:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2983; /* *avx512vl_ucmpv16hi3_zero_extendhi */

            case 3:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3043; /* *avx512f_ucmpv16si3_zero_extendhi */

            case 4:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2977; /* *avx512vl_ucmpv32qi3_zero_extendhi */

            case 5:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 2980; /* *avx512bw_ucmpv32hi3_zero_extendhi */

            case 6:
              if (!(
#line 4615 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 2986; /* *avx512vl_ucmpv8hi3_zero_extendhi */

            case 7:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3044; /* *avx512vl_ucmpv8si3_zero_extendhi */

            case 8:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3045; /* *avx512vl_ucmpv4si3_zero_extendhi */

            case 9:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3046; /* *avx512f_ucmpv8di3_zero_extendhi */

            case 10:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3047; /* *avx512vl_ucmpv4di3_zero_extendhi */

            case 11:
              if (!(
#line 4704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
      < GET_MODE_PRECISION (HImode))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 3048; /* *avx512vl_ucmpv2di3_zero_extendhi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 158:
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !nonimmediate_operand (operands[2], E_V64QImode)
                  || !(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7502; /* *avx512bw_testmv64qi3_zext */

            case E_SImode:
              switch (pattern792 ())
                {
                case 0:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7505; /* *avx512vl_testmv32qi3_zext */

                case 1:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7511; /* *avx512bw_testmv32hi3_zext */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern680 ())
                {
                case 0:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7508; /* *avx512vl_testmv16qi3_zext */

                case 1:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7514; /* *avx512vl_testmv16hi3_zext */

                case 2:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7520; /* *avx512f_testmv16si3_zext */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern681 ())
                {
                case 0:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7517; /* *avx512vl_testmv8hi3_zext */

                case 1:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7523; /* *avx512vl_testmv8si3_zext */

                case 2:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7526; /* *avx512vl_testmv4si3_zext */

                case 3:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7529; /* *avx512f_testmv8di3_zext */

                case 4:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7532; /* *avx512vl_testmv4di3_zext */

                case 5:
                  if (!(
#line 19061 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7535; /* *avx512vl_testmv2di3_zext */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 159:
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !nonimmediate_operand (operands[2], E_V64QImode)
                  || !(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (DImode))) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7574; /* *avx512bw_testnmv64qi3_zext */

            case E_SImode:
              switch (pattern792 ())
                {
                case 0:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7577; /* *avx512vl_testnmv32qi3_zext */

                case 1:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (SImode))) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7583; /* *avx512bw_testnmv32hi3_zext */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern680 ())
                {
                case 0:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7580; /* *avx512vl_testnmv16qi3_zext */

                case 1:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7586; /* *avx512vl_testnmv16hi3_zext */

                case 2:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (HImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7592; /* *avx512f_testnmv16si3_zext */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern681 ())
                {
                case 0:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7589; /* *avx512vl_testnmv8hi3_zext */

                case 1:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7595; /* *avx512vl_testnmv8si3_zext */

                case 2:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7598; /* *avx512vl_testnmv4si3_zext */

                case 3:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 7601; /* *avx512f_testnmv8di3_zext */

                case 4:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7604; /* *avx512vl_testnmv4di3_zext */

                case 5:
                  if (!(
#line 19091 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (2
       > GET_MODE_SIZE (QImode))) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 7607; /* *avx512vl_testnmv2di3_zext */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_52 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case DIV:
      if (GET_MODE (x2) == E_HFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_HFmode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (nonimmediate_operand (operands[2], E_HFmode)
                      && 
#line 23465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return 1339; /* *divhf */
                }
            }
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !binary_fp_operator (operands[3], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !register_operand (operands[2], E_XFmode))
                return -1;
              if (
#line 23417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387
   && COMMUTATIVE_ARITH_P (operands[3])))
                return 1333; /* *fop_xf_comm_i387 */
              if (!
#line 23515 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387
   && !COMMUTATIVE_ARITH_P (operands[3])))
                return -1;
              return 1342; /* *fop_xf_1_i387 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !binary_fp_operator (operands[3], E_SFmode)
                  || !nonimmediate_operand (operands[2], E_SFmode))
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && 
#line 23431 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (SFmode)))
   && COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 1334; /* *fop_sf_comm */
              if (!x87nonimm_ssenomem_operand (operands[1], E_SFmode)
                  || !
#line 23531 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (SFmode)))
   && !COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 1343; /* *fop_sf_1 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !binary_fp_operator (operands[3], E_DFmode)
                  || !nonimmediate_operand (operands[2], E_DFmode))
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && 
#line 23431 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (DFmode)))
   && COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 1335; /* *fop_df_comm */
              if (!x87nonimm_ssenomem_operand (operands[1], E_DFmode)
                  || !
#line 23531 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (DFmode)))
   && !COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 1344; /* *fop_df_1 */

            default:
              return -1;
            }

        case FLOAT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              switch (pattern782 (x5, 
E_SFmode))
                {
                case 0:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, HImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1351; /* *fop_sf_3_i387 */

                case 1:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1354; /* *fop_sf_3_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern782 (x5, 
E_DFmode))
                {
                case 0:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, HImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1352; /* *fop_df_3_i387 */

                case 1:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1355; /* *fop_df_3_i387 */

                default:
                  return -1;
                }

            case E_XFmode:
              switch (pattern782 (x5, 
E_XFmode))
                {
                case 0:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, HImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1353; /* *fop_xf_3_i387 */

                case 1:
                  if (!
#line 23587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, SImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1356; /* *fop_xf_3_i387 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (pattern686 ())
            {
            case 0:
              if (!register_operand (operands[1], E_XFmode)
                  || GET_MODE (x5) != E_XFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_SFmode:
                  if (!nonimmediate_operand (operands[2], E_SFmode)
                      || !
#line 23643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1360; /* *fop_xf_5_i387 */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 23643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1361; /* *fop_xf_5_i387 */

                default:
                  return -1;
                }

            case 1:
              if (!register_operand (operands[1], E_DFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[2], E_SFmode)
                  || !
#line 23660 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1362; /* *fop_df_5_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern687 (x4, 
E_SFmode))
            {
            case 0:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, HImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1345; /* *fop_sf_2_i387 */

            case 1:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1348; /* *fop_sf_2_i387 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern687 (x4, 
E_DFmode))
            {
            case 0:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, HImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1346; /* *fop_df_2_i387 */

            case 1:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1349; /* *fop_df_2_i387 */

            default:
              return -1;
            }

        case E_XFmode:
          switch (pattern687 (x4, 
E_XFmode))
            {
            case 0:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, HImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1347; /* *fop_xf_2_i387 */

            case 1:
              if (!
#line 23566 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, SImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1350; /* *fop_xf_2_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (pattern686 ())
            {
            case 0:
              if (GET_MODE (x4) != E_XFmode
                  || !register_operand (operands[2], E_XFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !
#line 23608 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1357; /* *fop_xf_4_i387 */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !
#line 23608 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1358; /* *fop_xf_4_i387 */

                default:
                  return -1;
                }

            case 1:
              if (GET_MODE (x4) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 23625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1359; /* *fop_df_4_i387 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !binary_fp_operator (operands[3], E_XFmode)
                  || GET_MODE (x4) != E_XFmode
                  || GET_MODE (x5) != E_XFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!register_operand (operands[1], E_SFmode)
                      || !nonimmediate_operand (operands[2], E_SFmode)
                      || !
#line 23679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1363; /* *fop_xf_6_i387 */

                case E_DFmode:
                  if (!register_operand (operands[1], E_DFmode)
                      || !nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 23679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1364; /* *fop_xf_6_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !binary_fp_operator (operands[3], E_DFmode)
                  || GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_SFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[2], E_SFmode)
                  || !
#line 23697 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1365; /* *fop_df_6_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern691 (x2, 
E_SImode))
            {
            case 0:
              if (
#line 6677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 228; /* *addqi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 229; /* *addqi_1_zextsi */

            case 1:
              if (
#line 6715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 232; /* *addhi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 233; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern691 (x2, 
E_DImode))
            {
            case 0:
              if (
#line 6677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 230; /* *addqi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6677 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 231; /* *addqi_1_zextdi */

            case 1:
              if (
#line 6715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 234; /* *addhi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6715 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 235; /* *addhi_1_zextdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LTU:
        case UNLT:
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern1236 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 8895 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 388; /* *addqi3_carry_zextsi */

                case 1:
                  if (!
#line 8914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 390; /* *addhi3_carry_zextsi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1236 (x2, 
E_DImode))
                {
                case 0:
                  if (!
#line 8895 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 389; /* *addqi3_carry_zextdi */

                case 1:
                  if (!
#line 8914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 391; /* *addhi3_carry_zextdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern248 (x3, pnum_clobbers))
        {
        case 0:
          switch (pattern1085 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 8952 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 393; /* *addqi3_carry_zextsi_0 */

            case 1:
              if (!
#line 8966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 395; /* *addhi3_carry_zextsi_0 */

            default:
              return -1;
            }

        case 1:
          switch (pattern1085 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 8952 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 394; /* *addqi3_carry_zextdi_0 */

            case 1:
              if (!
#line 8966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 396; /* *addhi3_carry_zextdi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern248 (x3, pnum_clobbers))
        {
        case 0:
          switch (pattern1086 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 8997 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 398; /* *addqi3_carry_zextsi_0r */

            case 1:
              if (!
#line 9011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 400; /* *addhi3_carry_zextsi_0r */

            default:
              return -1;
            }

        case 1:
          switch (pattern1086 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 8997 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 399; /* *addqi3_carry_zextdi_0r */

            case 1:
              if (!
#line 9011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 401; /* *addhi3_carry_zextdi_0r */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 19
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23251 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      *pnum_clobbers = 1;
      return 1329; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      switch (pattern379 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 8069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 309; /* *subdi3_doubleword */
            }
          if (!x86_64_general_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 319; /* *subdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 320; /* *subdi_1 */

        case 1:
          if (
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 317; /* *subsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 318; /* *subsi_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode
          || pattern694 (x2, 
E_SImode, 
E_DImode) != 0
          || !(
#line 8103 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 311; /* *subdi3_doubleword_zext */

    case LTU:
    case UNLT:
      switch (pattern383 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1088 (x2, 
E_SImode) != 0
              || !
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 412; /* *subsi3_carry_0 */

        case 1:
          if (pattern1088 (x2, 
E_DImode) != 0
              || !(
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 413; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern383 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1089 (x2, 
E_SImode) != 0
              || !
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 416; /* *subsi3_carry_0r */

        case 1:
          if (pattern1089 (x2, 
E_DImode) != 0
              || !(
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 417; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern385 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *subsi3_eq_0 */

        case 1:
          if (!(
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern385 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *subsi3_ne_0 */

        case 1:
          if (!(
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[3] = x3;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case 0L:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != PLUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[2])
          || !
#line 8750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE))
        return -1;
      *pnum_clobbers = 1;
      return 374; /* *dec_cmovsi */

    case -1L:
      x8 = XEXP (x4, 0);
      operands[4] = x8;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      switch (pattern1391 ())
        {
        case 0:
          if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
            return -1;
          *pnum_clobbers = 1;
          return 2124; /* *kortest_cmpqi_movsicc */

        case 1:
          if (!
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2126; /* *kortest_cmphi_movsicc */

        case 2:
          if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
            return -1;
          *pnum_clobbers = 1;
          return 2128; /* *kortest_cmpsi_movsicc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!x86_64_general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 10604 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF))
        return 501; /* *mulsi3_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 10604 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 502; /* *mulsi3_1 */

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || pattern113 (x3, 
E_SImode, 
E_DImode, 
ZERO_EXTEND) != 0
          || !(
#line 10994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 518; /* *umulsidi3_1 */

    case SIGN_EXTEND:
      if (pattern113 (x3, 
E_SImode, 
E_DImode, 
SIGN_EXTEND) != 0)
        return -1;
      if ((
#line 11040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 519; /* *mulsidi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 11040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 520; /* *mulsidi3_1 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !general_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 14602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 805; /* *absdi2_doubleword */
        }
      if (!(
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 812; /* *absdi2_1 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !general_operand (operands[1], E_SImode)
          || !
#line 14689 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 811; /* *abssi2_1 */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern48 (x3, pnum_clobbers))
        {
        case 0:
          if (pnum_clobbers != NULL
              && pattern387 (x3) == 0
              && (
#line 15205 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 859; /* *ashldi3_doubleword_mask */
            }
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          res = recog_83 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern390 (x3))
            {
            case 0:
              if (!
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1009; /* *ashlsi3_mask */

            case 1:
              if (!(
#line 17842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1012; /* *ashldi3_mask */

            case 2:
              if (!
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1021; /* *ashlsi3_add */

            case 3:
              if (!(
#line 17890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1024; /* *ashldi3_add */

            case 4:
              if (!
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1033; /* *ashlsi3_sub */

            case 5:
              if (!(
#line 17936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1036; /* *ashldi3_sub */

            default:
              return -1;
            }

        case 1:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 15266 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 861; /* *ashldi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1018; /* *ashldi3_mask_1 */

        case 2:
          if (!
#line 17867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1015; /* *ashlsi3_mask_1 */

        case 3:
          if (!
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1027; /* *ashlsi3_add_1 */

        case 4:
          if (!(
#line 17914 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *ashldi3_add_1 */

        case 5:
          if (!
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1039; /* *ashlsi3_sub_1 */

        case 6:
          if (!(
#line 17966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1042; /* *ashldi3_sub_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern115 (x3, pnum_clobbers) != 0
          || !(
#line 15367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 864; /* *ashldi3_doubleword_highpart */

    case ZERO_EXTEND:
      if (pattern115 (x3, pnum_clobbers) != 0
          || !(
#line 15367 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) >= 4 * BITS_PER_UNIT
   && INTVAL (operands[2]) < 4 * BITS_PER_UNIT * 2) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 865; /* *ashldi3_doubleword_highpart */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1061; /* *rotrsi3_mask_1 */

    case 1:
      if (!(
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1063; /* *rotrdi3_mask_1 */

    case 2:
      if (!
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1077; /* *rotrsi3_add_1 */

    case 3:
      if (!(
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1079; /* *rotrdi3_add_1 */

    case 4:
      if (!
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1093; /* *rotrsi3_sub_1 */

    case 5:
      if (!(
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1095; /* *rotrdi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern392 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1053; /* *rotrsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1055; /* *rotrdi3_mask */
                }
              break;

            case 2:
              if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1069; /* *rotrsi3_add */
                }
              break;

            case 3:
              if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1071; /* *rotrdi3_add */
                }
              break;

            case 4:
              if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1085; /* *rotrsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1087; /* *rotrdi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern556 (x2, pnum_clobbers, 
E_DImode) == 0
                  && const_1_to_31_operand (operands[2], E_QImode))
                {
                  *pnum_clobbers = 2;
                  return 1097; /* ix86_rotrdi3_doubleword */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && const_0_to_31_operand (operands[2], E_QImode)
                  && 
#line 18488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)))
                return 1100; /* *bmi2_rorxsi3_1 */
              break;

            default:
              break;
            }
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode)
            {
              if (XWINT (x3, 0) == 32L
                  && register_operand (operands[1], E_DImode))
                return 1099; /* rotr32di2_doubleword */
              if (nonimmediate_operand (operands[1], E_DImode))
                {
                  operands[2] = x3;
                  if (const_0_to_63_operand (operands[2], E_QImode)
                      && (
#line 18488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && !optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1101; /* *bmi2_rorxdi3_1 */
                }
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern19 (x2))
        {
        case 0:
          if (
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1104; /* *rotrsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1105; /* *rotrsi3_1 */

        case 1:
          if ((
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1108; /* *rotrdi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATERT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1109; /* *rotrdi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern567 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3965; /* unspec_avx512fp16_fix_truncv8hi2_mask */

    case E_V16HImode:
      if (pattern567 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3973; /* unspec_avx512fp16_fix_truncv16hi2_mask */

    case E_V32HImode:
      if (pattern567 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3981; /* unspec_avx512fp16_fix_truncv32hi2_mask */

    case E_V8SImode:
      switch (pattern894 (x2, 
E_V8SImode))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3989; /* unspec_avx512fp16_fix_truncv8si2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8774 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4263; /* unspec_fix_truncv8sfv8si2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9547 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4373; /* unspec_fix_truncv8dfv8si2_mask */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern895 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3997; /* unspec_avx512fp16_fix_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4248; /* unspec_fix_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern896 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4005; /* unspec_avx512fp16_fix_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4402; /* unspec_fix_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4450; /* unspec_fix_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case E_V4SImode:
      if (pattern128 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4060; /* unspec_avx512fp16_fix_truncv4si2_mask */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8793 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4267; /* unspec_fix_truncv4sfv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F))))
            return -1;
          return 4393; /* unspec_fix_truncv4dfv4si2_mask */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4489; /* unspec_sse2_cvttpd2dq_mask */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern897 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4064; /* unspec_avx512fp16_fix_truncv4di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4409; /* unspec_fix_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4457; /* unspec_fix_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern898 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7947 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4084; /* unspec_avx512fp16_fix_truncv2di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4413; /* unspec_fix_truncv2dfv2di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
            return -1;
          return 4473; /* unspec_avx512dq_fix_truncv2sfv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_15_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern407 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 9301; /* avx512bw_getmantv32hf_mask */

    case E_V16HFmode:
      if (pattern407 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9305; /* avx512vl_getmantv16hf_mask */

    case E_V8HFmode:
      if (pattern407 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 9309; /* avx512fp16_getmantv8hf_mask */

    case E_V16SFmode:
      if (pattern407 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9313; /* avx512f_getmantv16sf_mask */

    case E_V8SFmode:
      if (pattern407 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9317; /* avx512vl_getmantv8sf_mask */

    case E_V4SFmode:
      if (pattern407 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9321; /* avx512vl_getmantv4sf_mask */

    case E_V8DFmode:
      if (pattern407 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9325; /* avx512f_getmantv8df_mask */

    case E_V4DFmode:
      if (pattern407 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9329; /* avx512vl_getmantv4df_mask */

    case E_V2DFmode:
      if (pattern407 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9333; /* avx512vl_getmantv2df_mask */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern422 (x2))
    {
    case 0:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9540; /* vpshldv_v32hi_mask */

    case 1:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9541; /* vpshldv_v16si_mask */

    case 2:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9542; /* vpshldv_v8di_mask */

    case 3:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9543; /* vpshldv_v16hi_mask */

    case 4:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9544; /* vpshldv_v8si_mask */

    case 5:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9545; /* vpshldv_v4di_mask */

    case 6:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9546; /* vpshldv_v8hi_mask */

    case 7:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9547; /* vpshldv_v4si_mask */

    case 8:
      if (!(
#line 30480 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9548; /* vpshldv_v2di_mask */

    case 9:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9549; /* vpshldv_v32hi_maskz_1 */

    case 10:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9550; /* vpshldv_v16si_maskz_1 */

    case 11:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9551; /* vpshldv_v8di_maskz_1 */

    case 12:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9552; /* vpshldv_v16hi_maskz_1 */

    case 13:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9553; /* vpshldv_v8si_maskz_1 */

    case 14:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9554; /* vpshldv_v4di_maskz_1 */

    case 15:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9555; /* vpshldv_v8hi_maskz_1 */

    case 16:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9556; /* vpshldv_v4si_maskz_1 */

    case 17:
      if (!(
#line 30510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9557; /* vpshldv_v2di_maskz_1 */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern418 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9469; /* vpshrd_v32hi_mask */

    case 1:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9471; /* vpshrd_v16si_mask */

    case 2:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9473; /* vpshrd_v8di_mask */

    case 3:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9475; /* vpshrd_v16hi_mask */

    case 4:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9477; /* vpshrd_v8si_mask */

    case 5:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9479; /* vpshrd_v4di_mask */

    case 6:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9481; /* vpshrd_v8hi_mask */

    case 7:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9483; /* vpshrd_v4si_mask */

    case 8:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30386 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9485; /* vpshrd_v2di_mask */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (XWINT (x3, 0))
        {
        case 3L:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern907 (x2, 
E_V8HFmode, 
E_V2HFmode) == 0
                  && 
#line 11847 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 4619; /* *vec_concatv8hf_movss */
              break;

            case E_V8BFmode:
              if (pattern907 (x2, 
E_V8BFmode, 
E_V2BFmode) == 0
                  && 
#line 11847 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 4620; /* *vec_concatv8bf_movss */
              break;

            case E_V8HImode:
              if (pattern907 (x2, 
E_V8HImode, 
E_V2HImode) == 0
                  && 
#line 11847 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 4621; /* *vec_concatv8hi_movss */
              break;

            default:
              break;
            }
          break;

        case 1L:
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern908 (x2, 
E_V4SImode, 
E_SImode) == 0
                  && 
#line 11869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 4622; /* vec_setv4si_0 */
              break;

            case E_V4SFmode:
              if (pattern908 (x2, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 11869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return 4623; /* vec_setv4sf_0 */
              break;

            case E_V8HImode:
              if (pattern907 (x2, 
E_V8HImode, 
E_HImode) == 0
                  && 
#line 11950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 4624; /* vec_setv8hi_0 */
              break;

            case E_V8HFmode:
              if (pattern907 (x2, 
E_V8HFmode, 
E_HFmode) == 0
                  && 
#line 11950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 4625; /* vec_setv8hf_0 */
              break;

            case E_V8BFmode:
              if (pattern907 (x2, 
E_V8BFmode, 
E_BFmode) == 0
                  && 
#line 11950 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 4626; /* vec_setv8bf_0 */
              break;

            case E_V16HImode:
              if (pattern909 (x2, 
E_V16HImode, 
E_HImode) == 0
                  && 
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 4630; /* vec_setv16hi_0 */
              break;

            case E_V32HImode:
              if (pattern909 (x2, 
E_V32HImode, 
E_HImode) == 0
                  && (
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 984 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4631; /* vec_setv32hi_0 */
              break;

            case E_V16HFmode:
              if (pattern909 (x2, 
E_V16HFmode, 
E_HFmode) == 0
                  && 
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 4632; /* vec_setv16hf_0 */
              break;

            case E_V32HFmode:
              if (pattern909 (x2, 
E_V32HFmode, 
E_HFmode) == 0
                  && (
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 985 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4633; /* vec_setv32hf_0 */
              break;

            case E_V16BFmode:
              if (pattern909 (x2, 
E_V16BFmode, 
E_BFmode) == 0
                  && 
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return 4634; /* vec_setv16bf_0 */
              break;

            case E_V32BFmode:
              if (pattern909 (x2, 
E_V32BFmode, 
E_BFmode) == 0
                  && (
#line 12045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 986 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4635; /* vec_setv32bf_0 */
              break;

            case E_V8SImode:
              if (pattern909 (x2, 
E_V8SImode, 
E_SImode) == 0
                  && 
#line 12152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 4647; /* vec_setv8si_0 */
              break;

            case E_V8SFmode:
              if (pattern909 (x2, 
E_V8SFmode, 
E_SFmode) == 0
                  && 
#line 12152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 4648; /* vec_setv8sf_0 */
              break;

            case E_V16SImode:
              if (pattern909 (x2, 
E_V16SImode, 
E_SImode) == 0
                  && (
#line 12152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 993 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 4649; /* vec_setv16si_0 */
              break;

            case E_V16SFmode:
              if (pattern909 (x2, 
E_V16SFmode, 
E_SFmode) == 0
                  && (
#line 12152 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 994 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 4650; /* vec_setv16sf_0 */
              break;

            case E_V2DFmode:
              if (pattern785 (x2, 
E_V2DFmode, 
E_DFmode) == 0
                  && 
#line 12266 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return 4657; /* vec_setv2df_0 */
              break;

            case E_V8DFmode:
              if (pattern909 (x2, 
E_V8DFmode, 
E_DFmode) == 0
                  && (
#line 14944 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 6569; /* vec_setv8df_0 */
              break;

            case E_V4DFmode:
              if (pattern909 (x2, 
E_V4DFmode, 
E_DFmode) == 0
                  && 
#line 14944 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 6570; /* vec_setv4df_0 */
              break;

            case E_V8DImode:
              if (pattern909 (x2, 
E_V8DImode, 
E_DImode) == 0
                  && (
#line 21734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX) && 
#line 710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 7827; /* vec_setv8di_0 */
              break;

            case E_V4DImode:
              if (pattern909 (x2, 
E_V4DImode, 
E_DImode) == 0
                  && 
#line 21734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
                return 7828; /* vec_setv4di_0 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[3] = x3;
      if (const_int_operand (operands[3], E_SImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern801 (x2, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 12119 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4SFmode))))
                return 4646; /* *vec_setv4sf_sse4_1 */
              break;

            case E_V16QImode:
              if (pattern801 (x2, 
E_V16QImode, 
E_QImode) == 0
                  && (
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V16QImode))) && 
#line 19847 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 7722; /* sse4_1_pinsrb */
              break;

            case E_V8HImode:
              if (pattern801 (x2, 
E_V8HImode, 
E_HImode) == 0
                  && 
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HImode))))
                return 7723; /* sse2_pinsrw */
              break;

            case E_V8HFmode:
              if (pattern801 (x2, 
E_V8HFmode, 
E_HFmode) == 0
                  && 
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8HFmode))))
                return 7724; /* sse2_pinsrph */
              break;

            case E_V8BFmode:
              if (pattern801 (x2, 
E_V8BFmode, 
E_BFmode) == 0
                  && 
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V8BFmode))))
                return 7725; /* sse2_pinsrbf */
              break;

            case E_V4SImode:
              if (pattern801 (x2, 
E_V4SImode, 
E_SImode) == 0
                  && (
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V4SImode))) && 
#line 19848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1)))
                return 7726; /* sse4_1_pinsrd */
              break;

            case E_V2DImode:
              if (pattern801 (x2, 
E_V2DImode, 
E_DImode) == 0
                  && (
#line 19867 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2
   && ((unsigned) exact_log2 (INTVAL (operands[3]))
       < GET_MODE_NUNITS (V2DImode))) && 
#line 19849 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1 && TARGET_64BIT)))
                return 7727; /* sse4_1_pinsrq */
              break;

            case E_V8DFmode:
              if (pattern802 (x2, 
E_V8DFmode, 
E_V2DFmode) == 0
                  && (
#line 19971 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V8DFmode) == 4 ? 0xF : 0x3))) && 
#line 12379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
                return 7728; /* *avx512dq_vinsertf64x2_0 */
              break;

            case E_V8DImode:
              if (pattern802 (x2, 
E_V8DImode, 
E_V2DImode) == 0
                  && (
#line 19971 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V8DImode) == 4 ? 0xF : 0x3))) && 
#line 12380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
                return 7729; /* *avx512dq_vinserti64x2_0 */
              break;

            case E_V16SFmode:
              if (pattern802 (x2, 
E_V16SFmode, 
E_V4SFmode) == 0
                  && (
#line 19971 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V16SFmode) == 4 ? 0xF : 0x3))) && 
#line 12381 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7730; /* *avx512f_vinsertf32x4_0 */
              break;

            case E_V16SImode:
              if (pattern802 (x2, 
E_V16SImode, 
E_V4SImode) == 0
                  && (
#line 19971 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[3])
       == (GET_MODE_UNIT_SIZE (V16SImode) == 4 ? 0xF : 0x3))) && 
#line 12381 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 7731; /* *avx512f_vinserti32x4_0 */
              break;

            default:
              break;
            }
        }
      if (XWINT (x3, 0) != 1L
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      operands[2] = x5;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x6;
      if (!reg_or_0_operand (operands[1], E_V4SImode)
          || !
#line 21026 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 7798; /* sse2_loadld */

    case REG:
    case SUBREG:
      operands[3] = x3;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern141 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0)
            return -1;
          if ((
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 6567; /* vec_dupv2df_mask */
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8582; /* avx512vl_vec_dup_gprv2df_mask */

        case E_V16SFmode:
          if (pattern128 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8528; /* avx512f_broadcastv16sf_mask */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8572; /* avx512f_vec_dup_gprv16sf_mask */

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28053 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8628; /* avx512dq_broadcastv16sf_mask_1 */

            default:
              return -1;
            }

        case E_V16SImode:
          if (pattern128 (x2, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8530; /* avx512f_broadcastv16si_mask */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8560; /* avx512f_vec_dup_gprv16si_mask */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28053 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8630; /* avx512dq_broadcastv16si_mask_1 */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DFmode:
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8532; /* avx512f_broadcastv8df_mask */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8578; /* avx512f_vec_dup_gprv8df_mask */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8634; /* avx512dq_broadcastv8df_mask_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (pattern128 (x2, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8534; /* avx512f_broadcastv8di_mask */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8566; /* avx512f_vec_dup_gprv8di_mask */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8632; /* avx512dq_broadcastv8di_mask_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (pattern141 (x2, 
E_V64QImode, 
E_QImode, 
E_DImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8536; /* avx512bw_vec_dup_gprv64qi_mask */

        case E_V16QImode:
          if (pattern141 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8538; /* avx512vl_vec_dup_gprv16qi_mask */

        case E_V32QImode:
          if (pattern141 (x2, 
E_V32QImode, 
E_QImode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8540; /* avx512vl_vec_dup_gprv32qi_mask */

        case E_V32HImode:
          if (pattern141 (x2, 
E_V32HImode, 
E_HImode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8542; /* avx512bw_vec_dup_gprv32hi_mask */

        case E_V16HImode:
          if (pattern139 (x2, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8544; /* avx512vl_vec_dup_gprv16hi_mask */

        case E_V8HImode:
          if (pattern141 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8546; /* avx512vl_vec_dup_gprv8hi_mask */

        case E_V32HFmode:
          if (pattern141 (x2, 
E_V32HFmode, 
E_HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8548; /* avx512bw_vec_dup_gprv32hf_mask */

        case E_V16HFmode:
          if (pattern141 (x2, 
E_V16HFmode, 
E_HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8550; /* avx512vl_vec_dup_gprv16hf_mask */

        case E_V8HFmode:
          if (pattern141 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8552; /* avx512fp16_vec_dup_gprv8hf_mask */

        case E_V32BFmode:
          if (pattern141 (x2, 
E_V32BFmode, 
E_BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8554; /* avx512bw_vec_dup_gprv32bf_mask */

        case E_V16BFmode:
          if (pattern141 (x2, 
E_V16BFmode, 
E_BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8556; /* avx512vl_vec_dup_gprv16bf_mask */

        case E_V8BFmode:
          if (pattern141 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8558; /* avx512vl_vec_dup_gprv8bf_mask */

        case E_V8SImode:
          if (pattern128 (x2, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8562; /* avx512vl_vec_dup_gprv8si_mask */

            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8624; /* avx512vl_broadcastv8si_mask_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern141 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8564; /* avx512vl_vec_dup_gprv4si_mask */

        case E_V4DImode:
          if (pattern128 (x2, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8568; /* avx512vl_vec_dup_gprv4di_mask */

            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8636; /* avx512dq_broadcastv4di_mask_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern141 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8570; /* avx512vl_vec_dup_gprv2di_mask */

        case E_V8SFmode:
          if (pattern128 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8574; /* avx512vl_vec_dup_gprv8sf_mask */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28040 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 8626; /* avx512vl_broadcastv8sf_mask_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern141 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8576; /* avx512vl_vec_dup_gprv4sf_mask */

        case E_V4DFmode:
          if (pattern128 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8580; /* avx512vl_vec_dup_gprv4df_mask */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28071 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28065 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8638; /* avx512dq_broadcastv4df_mask_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x6) != CONST_INT
      || pattern1183 (x4) != 0)
    return -1;
  x7 = XVECEXP (x4, 0, 12);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x4, 0, 13);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x4, 0, 14);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x4, 0, 15);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x2, 2);
  if (!register_operand (x11, E_HImode))
    return -1;
  x12 = XVECEXP (x4, 0, 0);
  switch (XWINT (x12, 0))
    {
    case 2L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 18L
          || XWINT (x5, 0) != 3L
          || XWINT (x6, 0) != 19L
          || pattern1680 (x4) != 0)
        return -1;
      x14 = XVECEXP (x4, 0, 8);
      if (XWINT (x14, 0) != 10L)
        return -1;
      x15 = XVECEXP (x4, 0, 9);
      if (XWINT (x15, 0) != 26L)
        return -1;
      x16 = XVECEXP (x4, 0, 10);
      if (XWINT (x16, 0) != 11L)
        return -1;
      x17 = XVECEXP (x4, 0, 11);
      if (XWINT (x17, 0) != 27L
          || pattern1711 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1432 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11138 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4572; /* avx512f_unpckhps512_mask */

        case E_V16SImode:
          if (pattern1432 (x2, 
E_V16SImode, 
E_V32SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19730 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7713; /* avx512f_interleave_highv16si_mask */

        default:
          return -1;
        }

    case 0L:
      x13 = XVECEXP (x4, 0, 1);
      switch (XWINT (x13, 0))
        {
        case 16L:
          if (XWINT (x5, 0) != 1L
              || XWINT (x6, 0) != 17L)
            return -1;
          x18 = XEXP (x3, 0);
          x19 = XEXP (x18, 1);
          operands[2] = x19;
          x20 = XEXP (x2, 1);
          operands[3] = x20;
          operands[4] = x11;
          x21 = XVECEXP (x4, 0, 4);
          switch (XWINT (x21, 0))
            {
            case 4L:
              x22 = XVECEXP (x4, 0, 5);
              if (XWINT (x22, 0) != 20L)
                return -1;
              x23 = XVECEXP (x4, 0, 6);
              if (XWINT (x23, 0) != 5L)
                return -1;
              x24 = XVECEXP (x4, 0, 7);
              if (XWINT (x24, 0) != 21L)
                return -1;
              x14 = XVECEXP (x4, 0, 8);
              if (XWINT (x14, 0) != 8L)
                return -1;
              x15 = XVECEXP (x4, 0, 9);
              if (XWINT (x15, 0) != 24L)
                return -1;
              x16 = XVECEXP (x4, 0, 10);
              if (XWINT (x16, 0) != 9L)
                return -1;
              x17 = XVECEXP (x4, 0, 11);
              if (XWINT (x17, 0) != 25L
                  || XWINT (x7, 0) != 12L
                  || XWINT (x8, 0) != 28L
                  || XWINT (x9, 0) != 13L
                  || XWINT (x10, 0) != 29L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1432 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11226 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 4578; /* avx512f_unpcklps512_mask */

                case E_V16SImode:
                  if (pattern1432 (x2, 
E_V16SImode, 
E_V32SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19785 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 7719; /* avx512f_interleave_lowv16si_mask */

                default:
                  return -1;
                }

            case 2L:
              x22 = XVECEXP (x4, 0, 5);
              if (XWINT (x22, 0) != 18L)
                return -1;
              x23 = XVECEXP (x4, 0, 6);
              if (XWINT (x23, 0) != 3L)
                return -1;
              x24 = XVECEXP (x4, 0, 7);
              if (XWINT (x24, 0) != 19L)
                return -1;
              x14 = XVECEXP (x4, 0, 8);
              switch (XWINT (x14, 0))
                {
                case 4L:
                  x15 = XVECEXP (x4, 0, 9);
                  if (XWINT (x15, 0) != 20L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 10);
                  if (XWINT (x16, 0) != 5L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 11);
                  if (XWINT (x17, 0) != 21L
                      || XWINT (x7, 0) != 6L
                      || XWINT (x8, 0) != 22L
                      || XWINT (x9, 0) != 7L
                      || XWINT (x10, 0) != 23L
                      || pattern1433 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                    return -1;
                  return 7673; /* vec_interleave_lowv16qi_mask */

                case 8L:
                  x15 = XVECEXP (x4, 0, 9);
                  if (XWINT (x15, 0) != 24L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 10);
                  if (XWINT (x16, 0) != 9L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 11);
                  if (XWINT (x17, 0) != 25L
                      || XWINT (x7, 0) != 10L
                      || XWINT (x8, 0) != 26L
                      || XWINT (x9, 0) != 11L
                      || XWINT (x10, 0) != 27L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16HImode:
                      if (pattern1432 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7699; /* avx2_interleave_lowv16hi_mask */

                    case E_V16HFmode:
                      if (pattern1432 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7701; /* avx2_interleave_lowv16hf_mask */

                    case E_V16BFmode:
                      if (pattern1432 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19674 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7703; /* avx2_interleave_lowv16bf_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (pattern1518 (x4) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 8);
          if (XWINT (x14, 0) != 8L)
            return -1;
          x15 = XVECEXP (x4, 0, 9);
          if (XWINT (x15, 0) != 8L)
            return -1;
          x16 = XVECEXP (x4, 0, 10);
          if (XWINT (x16, 0) != 10L)
            return -1;
          x17 = XVECEXP (x4, 0, 11);
          if (XWINT (x17, 0) != 10L
              || XWINT (x7, 0) != 12L
              || XWINT (x8, 0) != 12L
              || XWINT (x9, 0) != 14L
              || XWINT (x10, 0) != 14L
              || pattern1648 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11419 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4594; /* avx512f_movsldup512_mask */

        default:
          return -1;
        }

    case 1L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 1L
          || XWINT (x5, 0) != 3L
          || XWINT (x6, 0) != 3L)
        return -1;
      x21 = XVECEXP (x4, 0, 4);
      if (XWINT (x21, 0) != 5L)
        return -1;
      x22 = XVECEXP (x4, 0, 5);
      if (XWINT (x22, 0) != 5L)
        return -1;
      x23 = XVECEXP (x4, 0, 6);
      if (XWINT (x23, 0) != 7L)
        return -1;
      x24 = XVECEXP (x4, 0, 7);
      if (XWINT (x24, 0) != 7L)
        return -1;
      x14 = XVECEXP (x4, 0, 8);
      if (XWINT (x14, 0) != 9L)
        return -1;
      x15 = XVECEXP (x4, 0, 9);
      if (XWINT (x15, 0) != 9L)
        return -1;
      x16 = XVECEXP (x4, 0, 10);
      if (XWINT (x16, 0) != 11L)
        return -1;
      x17 = XVECEXP (x4, 0, 11);
      if (XWINT (x17, 0) != 11L
          || XWINT (x7, 0) != 13L
          || XWINT (x8, 0) != 13L
          || XWINT (x9, 0) != 15L
          || XWINT (x10, 0) != 15L
          || pattern1648 (x2, 
E_V16SFmode, 
E_V32SFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4588; /* avx512f_movshdup512_mask */

    case 8L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 24L
          || XWINT (x5, 0) != 9L
          || XWINT (x6, 0) != 25L)
        return -1;
      x21 = XVECEXP (x4, 0, 4);
      if (XWINT (x21, 0) != 10L)
        return -1;
      x22 = XVECEXP (x4, 0, 5);
      if (XWINT (x22, 0) != 26L)
        return -1;
      x23 = XVECEXP (x4, 0, 6);
      if (XWINT (x23, 0) != 11L)
        return -1;
      x24 = XVECEXP (x4, 0, 7);
      if (XWINT (x24, 0) != 27L
          || pattern1696 (x4) != 0
          || XWINT (x7, 0) != 14L
          || XWINT (x8, 0) != 30L
          || XWINT (x9, 0) != 15L
          || XWINT (x10, 0) != 31L
          || pattern707 (x2, 
E_V32QImode, 
E_V16QImode) != 0
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      x18 = XEXP (x3, 0);
      x19 = XEXP (x18, 1);
      operands[2] = x19;
      if (!vector_operand (operands[2], E_V16QImode))
        return -1;
      x20 = XEXP (x2, 1);
      operands[3] = x20;
      if (!nonimm_or_0_operand (operands[3], E_V16QImode))
        return -1;
      operands[4] = x11;
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
        return -1;
      return 7667; /* vec_interleave_highv16qi_mask */

    case 4L:
      x13 = XVECEXP (x4, 0, 1);
      if (XWINT (x13, 0) != 20L
          || XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 21L
          || pattern1680 (x4) != 0
          || pattern1696 (x4) != 0
          || pattern1711 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HImode:
          if (pattern1432 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7681; /* avx2_interleave_highv16hi_mask */

        case E_V16HFmode:
          if (pattern1432 (x2, 
E_V16HFmode, 
E_V32HFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7683; /* avx2_interleave_highv16hf_mask */

        case E_V16BFmode:
          if (pattern1432 (x2, 
E_V16BFmode, 
E_V32BFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19606 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7685; /* avx2_interleave_highv16bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern269 (x2))
        {
        case 0:
          if (!(
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2234; /* *avx512fp16_vmaddv8hf3 */

        case 1:
          if (!
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2236; /* *sse_vmaddv4sf3 */

        case 2:
          if (!(
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2238; /* *sse2_vmaddv2df3 */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern269 (x2))
        {
        case 0:
          if (!(
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2235; /* *avx512fp16_vmsubv8hf3 */

        case 1:
          if (!
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2237; /* *sse_vmsubv4sf3 */

        case 2:
          if (!(
#line 2687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2239; /* *sse2_vmsubv2df3 */

        default:
          return -1;
        }

    case MULT:
      switch (pattern269 (x2))
        {
        case 0:
          if (!(
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2300; /* *avx512fp16_vmmulv8hf3 */

        case 1:
          if (!
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2302; /* *sse_vmmulv4sf3 */

        case 2:
          if (!(
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2304; /* *sse2_vmmulv2df3 */

        default:
          return -1;
        }

    case DIV:
      switch (pattern269 (x2))
        {
        case 0:
          if (!(
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2301; /* *avx512fp16_vmdivv8hf3 */

        case 1:
          if (!
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2303; /* *sse_vmdivv4sf3 */

        case 2:
          if (!(
#line 2777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2305; /* *sse2_vmdivv2df3 */

        default:
          return -1;
        }

    case UNSPEC:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (XINT (x4, 1))
            {
            case 54:
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1005 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 2952 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2357; /* *sse_vmrcpv4sf2 */

                case E_V8HFmode:
                  if (pattern1005 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 2996 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 2366; /* *avx512fp16_vmrcpv8hf2 */

                default:
                  return -1;
                }

            case 55:
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1005 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 3223 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2456; /* *sse_vmrsqrtv4sf2 */

                case E_V8HFmode:
                  if (pattern1005 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                      || !
#line 3254 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 2459; /* *avx512fp16_vmrsqrtv8hf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          switch (XINT (x4, 1))
            {
            case 63:
              switch (pattern706 (x2))
                {
                case 0:
                  if (!(
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 2570; /* *ieee_maxv8hf3 */

                case 1:
                  if (!
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2572; /* *ieee_maxv4sf3 */

                case 2:
                  if (!(
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 2574; /* *ieee_maxv2df3 */

                default:
                  return -1;
                }

            case 62:
              switch (pattern706 (x2))
                {
                case 0:
                  if (!(
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 2571; /* *ieee_minv8hf3 */

                case 1:
                  if (!
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                    return -1;
                  return 2573; /* *ieee_minv4sf3 */

                case 2:
                  if (!(
#line 3423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 2575; /* *ieee_minv2df3 */

                default:
                  return -1;
                }

            case 94:
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              x8 = XVECEXP (x4, 0, 1);
              operands[3] = x8;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (pattern906 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_HFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && (
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return 6531; /* *avx512f_rndscalev8hf */
                  if (!nonimmediate_operand (operands[2], E_HFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !(
#line 25600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 8268; /* *sse4_1_roundsh */

                case E_V4SFmode:
                  if (pattern906 (x2, 
E_V4SFmode, 
E_SFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_SFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && 
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                    return 6533; /* *avx512f_rndscalev4sf */
                  if (!nonimmediate_operand (operands[2], E_SFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !
#line 25600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                    return -1;
                  return 8269; /* *sse4_1_roundss */

                case E_V2DFmode:
                  if (pattern906 (x2, 
E_V2DFmode, 
E_DFmode) != 0)
                    return -1;
                  if (vector_operand (operands[2], E_DFmode)
                      && const_0_to_255_operand (operands[3], E_SImode)
                      && (
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 6535; /* *avx512f_rndscalev2df */
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !const_0_to_15_operand (operands[3], E_SImode)
                      || !(
#line 25600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return -1;
                  return 8270; /* *sse4_1_roundsd */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern800 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !(
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2419; /* *avx512fp16_vmsqrtv8hf2 */

        case E_V4SFmode:
          if (pattern800 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2423; /* *sse_vmsqrtv4sf2 */

        case E_V2DFmode:
          if (pattern800 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2427; /* *sse2_vmsqrtv2df2 */

        default:
          return -1;
        }

    case FLOAT:
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (XWINT (x5, 0))
        {
        case 1L:
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern906 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !
#line 7842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 3959; /* avx512fp16_vcvtsi2sh */

            case E_V4SFmode:
              if (pattern906 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 8508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 4178; /* sse_cvtsi2ss */

            case E_V2DFmode:
              if (pattern906 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 8969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 4274; /* sse2_cvtsi2sd */

            default:
              return -1;
            }

        case 3L:
          if (pnum_clobbers == NULL
              || pattern707 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !register_mmxmem_operand (operands[2], E_V2SImode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 8353 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return -1;
          *pnum_clobbers = 1;
          return 4174; /* sse_cvtpi2ps */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      if (!nonimmediate_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern906 (x2, 
E_V8HFmode, 
E_HFmode) != 0
              || !
#line 7842 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
            return -1;
          return 3961; /* avx512fp16_vcvtusi2sh */

        case E_V4SFmode:
          if (pattern906 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 8604 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1))
            return -1;
          return 4187; /* cvtusi2ss32 */

        case E_V2DFmode:
          if (pattern906 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 8604 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4189; /* cvtusi2sd32 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      switch (GET_CODE (x9))
        {
        case VEC_SELECT:
          if (GET_MODE (x9) != E_HFmode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern1324 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4150; /* avx512fp16_vcvtsh2sd */

            case E_V4SFmode:
              if (pattern1324 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4154; /* avx512fp16_vcvtsh2ss */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern707 (x2, 
E_DFmode, 
E_V2DFmode) != 0)
                return -1;
              x7 = XEXP (x2, 1);
              if (!register_operand (x7, E_V2DFmode))
                return -1;
              switch (GET_MODE (x9))
                {
                case E_HFmode:
                  operands[1] = x9;
                  if (!memory_operand (operands[1], E_HFmode))
                    return -1;
                  operands[2] = x7;
                  if (!
#line 8303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4158; /* avx512fp16_vcvtsh2sd_mem */

                case E_SFmode:
                  operands[2] = x9;
                  if (!nonimmediate_operand (operands[2], E_SFmode))
                    return -1;
                  operands[1] = x7;
                  if (!
#line 10055 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4502; /* *sse2_vd_cvtss2sd */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern707 (x2, 
E_SFmode, 
E_V4SFmode) != 0)
                return -1;
              operands[1] = x9;
              if (!memory_operand (operands[1], E_HFmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 8303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4160; /* avx512fp16_vcvtsh2ss_mem */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x2, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      switch (GET_CODE (x9))
        {
        case VEC_SELECT:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern707 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V8HFmode))
            return -1;
          switch (GET_MODE (x9))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4162; /* avx512fp16_vcvtsd2sh */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                return -1;
              return 4166; /* avx512fp16_vcvtss2sh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || GET_MODE (x3) != E_V8HFmode
                  || GET_MODE (x4) != E_HFmode)
                return -1;
              operands[1] = x9;
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!memory_operand (operands[1], E_SFmode)
                      || !
#line 8333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4170; /* avx512fp16_vcvtss2sh_mem */

                case E_DFmode:
                  if (!memory_operand (operands[1], E_DFmode)
                      || !
#line 8333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))
                    return -1;
                  return 4172; /* avx512fp16_vcvtsd2sh_mem */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || GET_MODE (x3) != E_V4SFmode)
                return -1;
              operands[2] = x9;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_V2SFmode:
                  if (!nonimmediate_operand (operands[2], E_V2DFmode)
                      || !
#line 9990 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4493; /* sse2_cvtsd2ss */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 10011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                    return -1;
                  return 4497; /* *sse2_vd_cvtsd2ss */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_132 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_133 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern272 (x2))
        {
        case 0:
          if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4636; /* *vec_setv16si_0_zero_extendhi */

        case 1:
          if (!
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4637; /* *vec_setv8si_0_zero_extendhi */

        case 2:
          if (!
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4638; /* *vec_setv4si_0_zero_extendhi */

        case 3:
          if (!(
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()) && 
#line 804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4639; /* *vec_setv8di_0_zero_extendhi */

        case 4:
          if (!(
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4651; /* *vec_setv8di_0_zero_extendsi */

        case 5:
          if (!
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4640; /* *vec_setv4di_0_zero_extendhi */

        case 6:
          if (!(
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4652; /* *vec_setv4di_0_zero_extendsi */

        case 7:
          if (!
#line 12063 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ix86_pre_reload_split ()))
            return -1;
          return 4641; /* *vec_setv2di_0_zero_extendhi */

        case 8:
          if (!
#line 12177 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 4653; /* *vec_setv2di_0_zero_extendsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern125 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2463; /* *smaxv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2470; /* *smaxv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2474; /* *smaxv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2479; /* *smaxv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2486; /* *smaxv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1)))
        return -1;
      return 2490; /* *smaxv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2495; /* *smaxv8df3_mask */

    case 7:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2502; /* *smaxv4df3_mask */

    case 8:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL)
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 2506; /* *smaxv2df3_mask */

    case 9:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7114; /* *avx512f_smaxv16si3_mask */

    case 10:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7122; /* *avx512f_smaxv8si3_mask */

    case 11:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7130; /* *avx512f_smaxv4si3_mask */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7214; /* *sse4_1_smaxv4si3_mask */

    case 12:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7138; /* *avx512f_smaxv8di3_mask */

    case 13:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7146; /* *avx512f_smaxv4di3_mask */

    case 14:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7154; /* *avx512f_smaxv2di3_mask */

    case 15:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7162; /* *avx512bw_smaxv64qi3_mask */

    case 16:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return 7170; /* *avx512bw_smaxv16qi3_mask */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
        return -1;
      return 7210; /* *sse4_1_smaxv16qi3_mask */

    case 17:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7178; /* *avx512bw_smaxv32qi3_mask */

    case 18:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 7186; /* *avx512bw_smaxv32hi3_mask */

    case 19:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7194; /* *avx512bw_smaxv16hi3_mask */

    case 20:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 7202; /* *avx512bw_smaxv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 9878; /* avx10_2_smaxbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 9882; /* avx10_2_smaxbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
        return -1;
      return 9886; /* avx10_2_smaxbf16_v8bf_mask */

    case 24:
      if (!(
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 2576; /* *avx512fp16_vmsmaxv8hf3 */

    case 25:
      if (!
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2584; /* *sse_vmsmaxv4sf3 */

    case 26:
      if (!(
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2592; /* *sse2_vmsmaxv2df3 */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 6367; /* avx512bw_getexpv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6371; /* avx512vl_getexpv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 6375; /* avx512fp16_getexpv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6379; /* avx512f_getexpv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6383; /* avx512vl_getexpv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6387; /* avx512vl_getexpv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6391; /* avx512f_getexpv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6395; /* avx512vl_getexpv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 14017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6399; /* avx512vl_getexpv2df */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9979; /* avx10_2_getexpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9981; /* avx10_2_getexpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9983; /* avx10_2_getexpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 2);
  if (!register_operand (x6, E_QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x11;
          switch (pattern1371 (x2))
            {
            case 0:
              if (pattern1520 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6675 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                        return 3652; /* avx512f_vmfmadd_v8hf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3658; /* avx512f_vmfmadd_v8hf_mask3_round */

            case 1:
              if (pattern1520 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && 
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return 3654; /* avx512f_vmfmadd_v4sf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3660; /* avx512f_vmfmadd_v4sf_mask3_round */

            case 2:
              if (pattern1520 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && register_operand (operands[3], E_V2DFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6675 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                        return 3656; /* avx512f_vmfmadd_v2df_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3662; /* avx512f_vmfmadd_v2df_mask3_round */

            case 3:
              if (pattern1579 (x2, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6727 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3664; /* avx512f_vmfmadd_v8hf_maskz_1_round */

            case 4:
              if (pattern1579 (x2, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3666; /* avx512f_vmfmadd_v4sf_maskz_1_round */

            case 5:
              if (pattern1579 (x2, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6727 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3668; /* avx512f_vmfmadd_v2df_maskz_1_round */

            default:
              return -1;
            }

        case NEG:
          x14 = XEXP (x11, 0);
          operands[3] = x14;
          switch (pattern1371 (x2))
            {
            case 0:
              if (pattern1521 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6748 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                        return 3670; /* *avx512f_vmfmsub_v8hf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3676; /* avx512f_vmfmsub_v8hf_mask3_round */

            case 1:
              if (pattern1521 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && 
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return 3672; /* *avx512f_vmfmsub_v4sf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3678; /* avx512f_vmfmsub_v4sf_mask3_round */

            case 2:
              if (pattern1521 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && register_operand (operands[3], E_V2DFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6748 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                        return 3674; /* *avx512f_vmfmsub_v2df_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6769 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3680; /* avx512f_vmfmsub_v2df_mask3_round */

            case 3:
              if (pattern1580 (x2, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6788 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3682; /* *avx512f_vmfmsub_v8hf_maskz_1_round */

            case 4:
              if (pattern1580 (x2, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3684; /* *avx512f_vmfmsub_v4sf_maskz_1_round */

            case 5:
              if (pattern1580 (x2, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6788 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3686; /* *avx512f_vmfmsub_v2df_maskz_1_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x11;
          switch (pattern1275 (x2))
            {
            case 0:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1651 (x3, 
E_V8HFmode) == 0
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6809 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return 3688; /* avx512f_vmfnmadd_v8hf_mask_round */
              operands[1] = x10;
              if (pattern1652 (x3, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6830 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3694; /* avx512f_vmfnmadd_v8hf_mask3_round */

            case 1:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1651 (x3, 
E_V4SFmode) == 0
                  && 
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return 3690; /* avx512f_vmfnmadd_v4sf_mask_round */
              operands[1] = x10;
              if (pattern1652 (x3, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3696; /* avx512f_vmfnmadd_v4sf_mask3_round */

            case 2:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1651 (x3, 
E_V2DFmode) == 0
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6809 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return 3692; /* avx512f_vmfnmadd_v2df_mask_round */
              operands[1] = x10;
              if (pattern1652 (x3, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6830 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3698; /* avx512f_vmfnmadd_v2df_mask3_round */

            case 3:
              if (pattern1581 (x2, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6863 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3700; /* avx512f_vmfnmadd_v8hf_maskz_1_round */

            case 4:
              if (pattern1581 (x2, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3702; /* avx512f_vmfnmadd_v4sf_maskz_1_round */

            case 5:
              if (pattern1581 (x2, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6863 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3704; /* avx512f_vmfnmadd_v2df_maskz_1_round */

            default:
              return -1;
            }

        case NEG:
          x14 = XEXP (x11, 0);
          operands[3] = x14;
          switch (pattern1275 (x2))
            {
            case 0:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1653 (x3, 
E_V8HFmode) == 0
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return 3706; /* *avx512f_vmfnmsub_v8hf_mask_round */
              operands[1] = x10;
              if (pattern1654 (x3, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6907 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3712; /* *avx512f_vmfnmsub_v8hf_mask3_round */

            case 1:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1653 (x3, 
E_V4SFmode) == 0
                  && 
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return 3708; /* *avx512f_vmfnmsub_v4sf_mask_round */
              operands[1] = x10;
              if (pattern1654 (x3, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3714; /* *avx512f_vmfnmsub_v4sf_mask3_round */

            case 2:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1653 (x3, 
E_V2DFmode) == 0
                  && (
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return 3710; /* *avx512f_vmfnmsub_v2df_mask_round */
              operands[1] = x10;
              if (pattern1654 (x3, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6907 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3716; /* *avx512f_vmfnmsub_v2df_mask3_round */

            case 3:
              if (pattern1582 (x2, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6927 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3718; /* *avx512f_vmfnmsub_v8hf_maskz_1_round */

            case 4:
              if (pattern1582 (x2, 
E_V4SFmode) != 0
                  || !
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3720; /* *avx512f_vmfnmsub_v4sf_maskz_1_round */

            case 5:
              if (pattern1582 (x2, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6927 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3722; /* *avx512f_vmfnmsub_v2df_maskz_1_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[3] = x6;
      switch (XINT (x3, 1))
        {
        case 63:
          switch (pattern1022 (x2))
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2523; /* ieee_maxv32hf3_round */

            case 1:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2539; /* ieee_maxv16sf3_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2555; /* ieee_maxv8df3_round */

            default:
              return -1;
            }

        case 62:
          switch (pattern1022 (x2))
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V32HFmode == V16SFmode
									      || V32HFmode == V8DFmode
									      || V32HFmode == V8DImode
									      || V32HFmode == V16SImode
									      || V32HFmode == V32HFmode)) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2527; /* ieee_minv32hf3_round */

            case 1:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2543; /* ieee_minv16sf3_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2559; /* ieee_minv8df3_round */

            default:
              return -1;
            }

        case 192:
          if (!const_0_to_255_operand (operands[2], E_SImode)
              || !const48_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1105 (x2, 
E_V32HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2639; /* *reducepv32hf_round */

            case E_V16HFmode:
              if (pattern1105 (x2, 
E_V16HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2643; /* *reducepv16hf_round */

            case E_V8HFmode:
              if (pattern1105 (x2, 
E_V8HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2647; /* *reducepv8hf_round */

            case E_V16SFmode:
              if (pattern1105 (x2, 
E_V16SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2651; /* *reducepv16sf_round */

            case E_V8SFmode:
              if (pattern1105 (x2, 
E_V8SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2655; /* *reducepv8sf_round */

            case E_V4SFmode:
              if (pattern1105 (x2, 
E_V4SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2659; /* *reducepv4sf_round */

            case E_V8DFmode:
              if (pattern1105 (x2, 
E_V8DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2663; /* *reducepv8df_round */

            case E_V4DFmode:
              if (pattern1105 (x2, 
E_V4DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2667; /* *reducepv4df_round */

            case E_V2DFmode:
              if (pattern1105 (x2, 
E_V2DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2671; /* *reducepv2df_round */

            default:
              return -1;
            }

        case 221:
          if (pattern1023 (x2) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3781; /* avx512bw_fmulc_v32hf_round */

        case 222:
          if (pattern1023 (x2) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3785; /* avx512bw_fcmulc_v32hf_round */

        case 58:
          if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1197 (x2, 
E_V32HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 4754; /* avx512bw_scalefv32hf_round */

            case E_V16HFmode:
              if (pattern1197 (x2, 
E_V16HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 4758; /* avx512vl_scalefv16hf_round */

            case E_V8HFmode:
              if (pattern1197 (x2, 
E_V8HFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 4762; /* avx512fp16_scalefv8hf_round */

            case E_V16SFmode:
              if (pattern1197 (x2, 
E_V16SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4766; /* avx512f_scalefv16sf_round */

            case E_V8SFmode:
              if (pattern1197 (x2, 
E_V8SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4770; /* avx512vl_scalefv8sf_round */

            case E_V4SFmode:
              if (pattern1197 (x2, 
E_V4SFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4774; /* avx512vl_scalefv4sf_round */

            case E_V8DFmode:
              if (pattern1197 (x2, 
E_V8DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4778; /* avx512f_scalefv8df_round */

            case E_V4DFmode:
              if (pattern1197 (x2, 
E_V4DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4782; /* avx512vl_scalefv4df_round */

            case E_V2DFmode:
              if (pattern1197 (x2, 
E_V2DFmode) != 0
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4786; /* avx512vl_scalefv2df_round */

            default:
              return -1;
            }

        case 94:
          if (!const_0_to_255_operand (operands[2], E_SImode))
            return -1;
          switch (pattern1103 (x2))
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 6484; /* avx512bw_rndscalev32hf_round */

            case 1:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 6488; /* avx512vl_rndscalev16hf_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 6492; /* avx512fp16_rndscalev8hf_round */

            case 3:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6496; /* avx512f_rndscalev16sf_round */

            case 4:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6500; /* avx512vl_rndscalev8sf_round */

            case 5:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6504; /* avx512vl_rndscalev4sf_round */

            case 6:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6508; /* avx512f_rndscalev8df_round */

            case 7:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6512; /* avx512vl_rndscalev4df_round */

            case 8:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6516; /* avx512vl_rndscalev2df_round */

            default:
              return -1;
            }

        case 150:
          if (GET_MODE (x3) != E_V16HImode
              || !register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !register_operand (operands[1], E_V16SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const48_operand (operands[3], E_SImode)
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29208 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8958; /* *avx512f_vcvtps2ph512_round */

        case 166:
          if (!const_0_to_15_operand (operands[2], E_SImode))
            return -1;
          switch (pattern1103 (x2))
            {
            case 0:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 9300; /* avx512bw_getmantv32hf_round */

            case 1:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 9304; /* avx512vl_getmantv16hf_round */

            case 2:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 9308; /* avx512fp16_getmantv8hf_round */

            case 3:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9312; /* avx512f_getmantv16sf_round */

            case 4:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9316; /* avx512vl_getmantv8sf_round */

            case 5:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9320; /* avx512vl_getmantv4sf_round */

            case 6:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9324; /* avx512f_getmantv8df_round */

            case 7:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9328; /* avx512vl_getmantv4df_round */

            case 8:
              if (!(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9332; /* avx512vl_getmantv2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      switch (XINT (x3, 1))
        {
        case 133:
          if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1340 (x2, 
E_V32HFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3505; /* *fma_fmaddsub_v32hf_round */

                case E_V16SFmode:
                  if (pattern1340 (x2, 
E_V16SFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3513; /* *fma_fmaddsub_v16sf_round */

                case E_V8DFmode:
                  if (pattern1340 (x2, 
E_V8DFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3521; /* *fma_fmaddsub_v8df_round */

                default:
                  return -1;
                }

            case NEG:
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1341 (x2, 
E_V32HFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3569; /* *fma_fmsubadd_v32hf_round */

                case E_V16SFmode:
                  if (pattern1341 (x2, 
E_V16SFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V16SFmode == V16SFmode
							      || V16SFmode == V8DFmode
							      || V16SFmode == V8DImode
							      || V16SFmode == V16SImode
							      || V16SFmode == V32HFmode)) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3577; /* *fma_fmsubadd_v16sf_round */

                case E_V8DFmode:
                  if (pattern1341 (x2, 
E_V8DFmode) != 0
                      || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && (V8DFmode == V16SFmode
							      || V8DFmode == V8DFmode
							      || V8DFmode == V8DImode
							      || V8DFmode == V16SImode
							      || V8DFmode == V32HFmode)) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3585; /* *fma_fmsubadd_v8df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 217:
          if (pattern1024 (x2) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3732; /* fma_fmaddc_v32hf_round */

        case 219:
          if (pattern1024 (x2) != 0
              || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && (V32HFmode == V16SFmode
							      || V32HFmode == V8DFmode
							      || V32HFmode == V8DImode
							      || V32HFmode == V16SImode
							      || V32HFmode == V32HFmode)) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3736; /* fma_fcmaddc_v32hf_round */

        case 194:
          x7 = XVECEXP (x3, 0, 2);
          operands[3] = x7;
          if (!const_0_to_15_operand (operands[3], E_SImode)
              || !const48_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1021 (x2, 
E_V16SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V16SFmode == V16SFmode
									      || V16SFmode == V8DFmode
									      || V16SFmode == V8DImode
									      || V16SFmode == V16SImode
									      || V16SFmode == V32HFmode)) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9252; /* avx512dq_rangepv16sf_round */

            case E_V8DFmode:
              if (pattern1021 (x2, 
E_V8DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29802 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && (V8DFmode == V16SFmode
									      || V8DFmode == V8DFmode
									      || V8DFmode == V8DImode
									      || V8DFmode == V16SImode
									      || V8DFmode == V32HFmode)) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9260; /* avx512dq_rangepv8df_round */

            default:
              return -1;
            }

        case 278:
          x7 = XVECEXP (x3, 0, 2);
          operands[3] = x7;
          if (!const_0_to_255_operand (operands[3], E_SImode)
              || !const48_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1021 (x2, 
E_V32HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10182; /* avx10_2_minmaxpv32hf_round */

            case E_V16HFmode:
              if (pattern1021 (x2, 
E_V16HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10186; /* avx10_2_minmaxpv16hf_round */

            case E_V8HFmode:
              if (pattern1021 (x2, 
E_V8HFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10190; /* avx10_2_minmaxpv8hf_round */

            case E_V16SFmode:
              if (pattern1021 (x2, 
E_V16SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10194; /* avx10_2_minmaxpv16sf_round */

            case E_V8SFmode:
              if (pattern1021 (x2, 
E_V8SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10198; /* avx10_2_minmaxpv8sf_round */

            case E_V4SFmode:
              if (pattern1021 (x2, 
E_V4SFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10202; /* avx10_2_minmaxpv4sf_round */

            case E_V8DFmode:
              if (pattern1021 (x2, 
E_V8DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10206; /* avx10_2_minmaxpv8df_round */

            case E_V4DFmode:
              if (pattern1021 (x2, 
E_V4DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10210; /* avx10_2_minmaxpv4df_round */

            case E_V2DFmode:
              if (pattern1021 (x2, 
E_V2DFmode) != 0
                  || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2)))
                return -1;
              return 10214; /* avx10_2_minmaxpv2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_210 (x1, insn, pnum_clobbers);

    case 4:
      if (XINT (x3, 1) != 163)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      x9 = XVECEXP (x3, 0, 3);
      operands[4] = x9;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[5] = x6;
      if (!const48_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1372 (x2, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6436; /* avx512f_fixupimmv16sf_round */

        case E_V8SFmode:
          if (pattern1372 (x2, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6440; /* avx512vl_fixupimmv8sf_round */

        case E_V4SFmode:
          if (pattern1372 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6444; /* avx512vl_fixupimmv4sf_round */

        case E_V8DFmode:
          if (pattern1372 (x2, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6448; /* avx512f_fixupimmv8df_round */

        case E_V4DFmode:
          if (pattern1372 (x2, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6452; /* avx512vl_fixupimmv4df_round */

        case E_V2DFmode:
          if (pattern1372 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6456; /* avx512vl_fixupimmv2df_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern826 (x3, 
E_HImode, 
E_V16SImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9197; /* avx512f_compressstorev16si_mask */

    case E_V16SFmode:
      if (pattern826 (x3, 
E_HImode, 
E_V16SFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1009 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9198; /* avx512f_compressstorev16sf_mask */

    case E_V8DImode:
      if (pattern826 (x3, 
E_QImode, 
E_V8DImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9199; /* avx512f_compressstorev8di_mask */

    case E_V8DFmode:
      if (pattern826 (x3, 
E_QImode, 
E_V8DFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9200; /* avx512f_compressstorev8df_mask */

    case E_V8SImode:
      if (pattern826 (x3, 
E_QImode, 
E_V8SImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9201; /* avx512vl_compressstorev8si_mask */

    case E_V8SFmode:
      if (pattern826 (x3, 
E_QImode, 
E_V8SFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9202; /* avx512vl_compressstorev8sf_mask */

    case E_V4DImode:
      if (pattern826 (x3, 
E_QImode, 
E_V4DImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9203; /* avx512vl_compressstorev4di_mask */

    case E_V4DFmode:
      if (pattern826 (x3, 
E_QImode, 
E_V4DFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1012 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9204; /* avx512vl_compressstorev4df_mask */

    case E_V4SImode:
      if (pattern826 (x3, 
E_QImode, 
E_V4SImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9205; /* avx512vl_compressstorev4si_mask */

    case E_V4SFmode:
      if (pattern826 (x3, 
E_QImode, 
E_V4SFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9206; /* avx512vl_compressstorev4sf_mask */

    case E_V2DImode:
      if (pattern826 (x3, 
E_QImode, 
E_V2DImode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9207; /* avx512vl_compressstorev2di_mask */

    case E_V2DFmode:
      if (pattern826 (x3, 
E_QImode, 
E_V2DFmode) != 0
          || !(
#line 29670 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 1014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9208; /* avx512vl_compressstorev2df_mask */

    case E_V64QImode:
      if (pattern826 (x3, 
E_DImode, 
E_V64QImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9209; /* compressstorev64qi_mask */

    case E_V16QImode:
      if (pattern826 (x3, 
E_HImode, 
E_V16QImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9210; /* compressstorev16qi_mask */

    case E_V32QImode:
      if (pattern826 (x3, 
E_SImode, 
E_V32QImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9211; /* compressstorev32qi_mask */

    case E_V32HImode:
      if (pattern826 (x3, 
E_SImode, 
E_V32HImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9212; /* compressstorev32hi_mask */

    case E_V16HImode:
      if (pattern826 (x3, 
E_HImode, 
E_V16HImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9213; /* compressstorev16hi_mask */

    case E_V8HImode:
      if (pattern826 (x3, 
E_QImode, 
E_V8HImode) != 0
          || !(
#line 29684 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9214; /* compressstorev8hi_mask */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (pattern146 (x3, 
E_V8SFmode) != 0
          || !(
#line 23745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8007; /* avx_dpps256 */

    case E_V4SFmode:
      if (pattern146 (x3, 
E_V4SFmode) != 0
          || !
#line 23745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1))
        return -1;
      return 8008; /* sse4_1_dpps */

    case E_V4DFmode:
      if (pattern146 (x3, 
E_V4DFmode) != 0
          || !(
#line 23745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 8009; /* avx_dppd256 */

    case E_V2DFmode:
      if (pattern146 (x3, 
E_V2DFmode) != 0
          || !(
#line 23745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 8010; /* sse4_1_dppd */

    default:
      return -1;
    }
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 164:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1025 (x3, 
E_V16SImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4789; /* avx512f_vternlogv16si */
          if (!(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16SImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4807; /* *avx512f_vternlogv16si_all */

        case E_V8SImode:
          if (pattern1025 (x3, 
E_V8SImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4791; /* avx512vl_vternlogv8si */
          if (!(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8SImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4808; /* *avx512vl_vternlogv8si_all */

        case E_V4SImode:
          if (pattern1025 (x3, 
E_V4SImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4793; /* avx512vl_vternlogv4si */
          if (!
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V4SImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4809; /* *avx512vl_vternlogv4si_all */

        case E_V8DImode:
          if (pattern1025 (x3, 
E_V8DImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 4795; /* avx512f_vternlogv8di */
          if (!(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8DImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4810; /* *avx512f_vternlogv8di_all */

        case E_V4DImode:
          if (pattern1025 (x3, 
E_V4DImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4797; /* avx512vl_vternlogv4di */
          if (!(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V4DImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4811; /* *avx512vl_vternlogv4di_all */

        case E_V2DImode:
          if (pattern1025 (x3, 
E_V2DImode) != 0)
            return -1;
          if ((
#line 13637 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 4799; /* avx512vl_vternlogv2di */
          if (!
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V2DImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4812; /* *avx512vl_vternlogv2di_all */

        case E_V64QImode:
          if (pattern1025 (x3, 
E_V64QImode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V64QImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4801; /* *avx512bw_vternlogv64qi_all */

        case E_V32QImode:
          if (pattern1025 (x3, 
E_V32QImode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V32QImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4802; /* *avx512vl_vternlogv32qi_all */

        case E_V16QImode:
          if (pattern1025 (x3, 
E_V16QImode) != 0
              || !
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16QImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4803; /* *avx512vl_vternlogv16qi_all */

        case E_V32HImode:
          if (pattern1025 (x3, 
E_V32HImode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V32HImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4804; /* *avx512bw_vternlogv32hi_all */

        case E_V16HImode:
          if (pattern1025 (x3, 
E_V16HImode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16HImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4805; /* *avx512vl_vternlogv16hi_all */

        case E_V8HImode:
          if (pattern1025 (x3, 
E_V8HImode) != 0
              || !
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8HImode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4806; /* *avx512vl_vternlogv8hi_all */

        case E_V32HFmode:
          if (pattern1025 (x3, 
E_V32HFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V32HFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4813; /* *avx512bw_vternlogv32hf_all */

        case E_V16HFmode:
          if (pattern1025 (x3, 
E_V16HFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16HFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4814; /* *avx512vl_vternlogv16hf_all */

        case E_V8HFmode:
          if (pattern1025 (x3, 
E_V8HFmode) != 0
              || !
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8HFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4815; /* *avx512fp16_vternlogv8hf_all */

        case E_V32BFmode:
          if (pattern1025 (x3, 
E_V32BFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V32BFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4816; /* *avx512bw_vternlogv32bf_all */

        case E_V16BFmode:
          if (pattern1025 (x3, 
E_V16BFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16BFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4817; /* *avx512vl_vternlogv16bf_all */

        case E_V8BFmode:
          if (pattern1025 (x3, 
E_V8BFmode) != 0
              || !
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8BFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4818; /* *avx512vl_vternlogv8bf_all */

        case E_V16SFmode:
          if (pattern1025 (x3, 
E_V16SFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V16SFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4819; /* *avx512f_vternlogv16sf_all */

        case E_V8SFmode:
          if (pattern1025 (x3, 
E_V8SFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8SFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4820; /* *avx512vl_vternlogv8sf_all */

        case E_V4SFmode:
          if (pattern1025 (x3, 
E_V4SFmode) != 0
              || !
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V4SFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)))
            return -1;
          return 4821; /* *avx512vl_vternlogv4sf_all */

        case E_V8DFmode:
          if (pattern1025 (x3, 
E_V8DFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V8DFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4822; /* *avx512f_vternlogv8df_all */

        case E_V4DFmode:
          if (pattern1025 (x3, 
E_V4DFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V4DFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4823; /* *avx512vl_vternlogv4df_all */

        case E_V2DFmode:
          if (pattern1025 (x3, 
E_V2DFmode) != 0
              || !(
#line 13651 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
/* Disallow embeded broadcast for vector HFmode since
   it's not real AVX512FP16 instruction.  */
  && (GET_MODE_SIZE (GET_MODE_INNER (V2DFmode)) >= 4
     || GET_CODE (operands[3]) != VEC_DUPLICATE)) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4824; /* *avx512vl_vternlogv2df_all */

        default:
          return -1;
        }

    case 163:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1026 (x3, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 6435; /* avx512f_fixupimmv16sf */

        case E_V8SFmode:
          if (pattern1026 (x3, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6439; /* avx512vl_fixupimmv8sf */

        case E_V4SFmode:
          if (pattern1026 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6443; /* avx512vl_fixupimmv4sf */

        case E_V8DFmode:
          if (pattern1026 (x3, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 6447; /* avx512f_fixupimmv8df */

        case E_V4DFmode:
          if (pattern1026 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6451; /* avx512vl_fixupimmv4df */

        case E_V2DFmode:
          if (pattern1026 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 14132 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 6455; /* avx512vl_fixupimmv2df */

        default:
          return -1;
        }

    case 124:
      if (GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_255_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_VOIDmode)
          || !
#line 23450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 7971; /* sse4a_insertqi */

    case 145:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_3_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1027 (x3, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 27076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8371; /* xop_vpermil2v8sf3 */

        case E_V4SFmode:
          if (pattern1027 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 27076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8372; /* xop_vpermil2v4sf3 */

        case E_V4DFmode:
          if (pattern1027 (x3, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 27076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8373; /* xop_vpermil2v4df3 */

        case E_V2DFmode:
          if (pattern1027 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 27076 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8374; /* xop_vpermil2v2df3 */

        default:
          return -1;
        }

    case 153:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 154)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != SCRATCH)
        return -1;
      x10 = XVECEXP (x8, 0, 2);
      if (!const1248_operand (x10, E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          operands[7] = x5;
          x11 = XVECEXP (x8, 0, 0);
          operands[3] = x11;
          x12 = XVECEXP (x8, 0, 1);
          operands[4] = x12;
          operands[6] = x10;
          x7 = XVECEXP (x3, 0, 3);
          operands[5] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              switch (pattern1586 (x3, 
E_V2DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8963; /* *avx2_gathersiv2di */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8995; /* *avx2_gatherdiv2di */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8971; /* *avx2_gathersiv2di */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9003; /* *avx2_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1586 (x3, 
E_V2DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8964; /* *avx2_gathersiv2df */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8996; /* *avx2_gatherdiv2df */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8972; /* *avx2_gathersiv2df */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9004; /* *avx2_gatherdiv2df */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1588 (x3, 
E_V4DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8965; /* *avx2_gathersiv4di */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8997; /* *avx2_gatherdiv4di */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8973; /* *avx2_gathersiv4di */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9005; /* *avx2_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1588 (x3, 
E_V4DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8966; /* *avx2_gathersiv4df */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8998; /* *avx2_gatherdiv4df */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8974; /* *avx2_gathersiv4df */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9006; /* *avx2_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1586 (x3, 
E_V4SImode, 
E_SImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8967; /* *avx2_gathersiv4si */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8999; /* *avx2_gatherdiv4si */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8975; /* *avx2_gathersiv4si */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9007; /* *avx2_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1586 (x3, 
E_V4SFmode, 
E_SFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8968; /* *avx2_gathersiv4sf */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9000; /* *avx2_gatherdiv4sf */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8976; /* *avx2_gathersiv4sf */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9008; /* *avx2_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || !vsib_mem_operator (operands[7], E_SImode))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[2], E_V8SImode)
                      || !register_operand (operands[4], E_V8SImode))
                    return -1;
                  switch (pattern1655 (x8, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8969; /* *avx2_gathersiv8si */

                    case 1:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8977; /* *avx2_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern1656 (x8, 
E_V4SImode, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9001; /* *avx2_gatherdiv8si */

                    case 1:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9009; /* *avx2_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || !vsib_mem_operator (operands[7], E_SFmode))
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8SFmode:
                  switch (pattern1656 (x8, 
E_V8SFmode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8970; /* *avx2_gathersiv8sf */

                    case 1:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8978; /* *avx2_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1656 (x8, 
E_V4SFmode, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9002; /* *avx2_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9010; /* *avx2_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          operands[6] = x5;
          x11 = XVECEXP (x8, 0, 0);
          operands[2] = x11;
          x12 = XVECEXP (x8, 0, 1);
          operands[3] = x12;
          operands[5] = x10;
          x7 = XVECEXP (x3, 0, 3);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              switch (pattern1549 (x3, 
E_V2DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8979; /* *avx2_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9011; /* *avx2_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8987; /* *avx2_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9019; /* *avx2_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1549 (x3, 
E_V2DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8980; /* *avx2_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9012; /* *avx2_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8988; /* *avx2_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9020; /* *avx2_gatherdiv2df_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1551 (x3, 
E_V4DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8981; /* *avx2_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9013; /* *avx2_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8989; /* *avx2_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9021; /* *avx2_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1551 (x3, 
E_V4DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8982; /* *avx2_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9014; /* *avx2_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8990; /* *avx2_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9022; /* *avx2_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1549 (x3, 
E_V4SImode, 
E_SImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8983; /* *avx2_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9015; /* *avx2_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8991; /* *avx2_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9023; /* *avx2_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1549 (x3, 
E_V4SFmode, 
E_SFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8984; /* *avx2_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9016; /* *avx2_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 8992; /* *avx2_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9024; /* *avx2_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1552 (x3, 
E_SImode, 
E_V8SImode))
                {
                case 0:
                  switch (pattern1628 (
E_SImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8985; /* *avx2_gathersiv8si_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9017; /* *avx2_gatherdiv8si_2 */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern1628 (
E_DImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8993; /* *avx2_gathersiv8si_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9025; /* *avx2_gatherdiv8si_2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1552 (x3, 
E_SFmode, 
E_V8SFmode))
                {
                case 0:
                  switch (pattern1629 (
E_SImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8986; /* *avx2_gathersiv8sf_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9018; /* *avx2_gatherdiv8sf_2 */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern1629 (
E_DImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 8994; /* *avx2_gathersiv8sf_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 9026; /* *avx2_gatherdiv8sf_2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 226:
      if (GET_MODE (x3) != E_V4SImode
          || pattern161 (x3) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode)
          || !
#line 30055 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SM3))
        return -1;
      return 9386; /* vsm3rnds2 */

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          switch (GET_MODE (operands[0]))
            {
            case E_V16BFmode:
              if (pattern26 (x2, 
E_V16BFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3154; /* *xorv16bf3 */

            case E_V8BFmode:
              if (pattern26 (x2, 
E_V8BFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3157; /* *xorv8bf3 */

            case E_V16HFmode:
              if (pattern26 (x2, 
E_V16HFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3160; /* *xorv16hf3 */

            case E_V8HFmode:
              if (pattern26 (x2, 
E_V8HFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3163; /* *xorv8hf3 */

            case E_V8SFmode:
              if (pattern26 (x2, 
E_V8SFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3168; /* *xorv8sf3 */

            case E_V4SFmode:
              if (pattern26 (x2, 
E_V4SFmode) != 0
                  || !
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 3174; /* *xorv4sf3 */

            case E_V4DFmode:
              if (pattern26 (x2, 
E_V4DFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3180; /* *xorv4df3 */

            case E_V2DFmode:
              if (pattern26 (x2, 
E_V2DFmode) != 0
                  || !(
#line 5366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3186; /* *xorv2df3 */

            case E_V32BFmode:
              if (pattern5 (x2, 
E_V32BFmode) != 0
                  || !(
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3190; /* *xorv32bf3 */

            case E_V32HFmode:
              if (pattern5 (x2, 
E_V32HFmode) != 0
                  || !(
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 16 != 16)) && 
#line 492 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3193; /* *xorv32hf3 */

            case E_V16SFmode:
              if (pattern5 (x2, 
E_V16SFmode) != 0
                  || !(
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 32 != 16)) && 
#line 493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3198; /* *xorv16sf3 */

            case E_V8DFmode:
              if (pattern5 (x2, 
E_V8DFmode) != 0
                  || !(
#line 5436 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!false || 64 != 16)) && 
#line 494 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3204; /* *xorv8df3 */

            case E_V16SImode:
              if (pattern173 (x2, 
E_V16SImode) != 0
                  || !(
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V16SImode, operands)) && 
#line 807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7351; /* *xorv16si3 */

            case E_V8SImode:
              if (pattern173 (x2, 
E_V8SImode) != 0
                  || !(
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V8SImode, operands)) && 
#line 807 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7357; /* *xorv8si3 */

            case E_V4SImode:
              if (pattern173 (x2, 
E_V4SImode) != 0
                  || !
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V4SImode, operands)))
                return -1;
              return 7363; /* *xorv4si3 */

            case E_V8DImode:
              if (pattern173 (x2, 
E_V8DImode) != 0
                  || !(
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V8DImode, operands)) && 
#line 808 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7369; /* *xorv8di3 */

            case E_V4DImode:
              if (pattern173 (x2, 
E_V4DImode) != 0
                  || !(
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V4DImode, operands)) && 
#line 808 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7375; /* *xorv4di3 */

            case E_V2DImode:
              if (pattern173 (x2, 
E_V2DImode) != 0
                  || !
#line 18717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && ix86_binary_operator_ok (XOR, V2DImode, operands)))
                return -1;
              return 7381; /* *xorv2di3 */

            case E_V64QImode:
              if (pattern26 (x2, 
E_V64QImode) != 0
                  || !(
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7385; /* *xorv64qi3 */

            case E_V32QImode:
              if (pattern26 (x2, 
E_V32QImode) != 0
                  || !(
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 811 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7388; /* *xorv32qi3 */

            case E_V16QImode:
              if (pattern26 (x2, 
E_V16QImode) != 0
                  || !
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 7391; /* *xorv16qi3 */

            case E_V32HImode:
              if (pattern26 (x2, 
E_V32HImode) != 0
                  || !(
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7394; /* *xorv32hi3 */

            case E_V16HImode:
              if (pattern26 (x2, 
E_V16HImode) != 0
                  || !(
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7397; /* *xorv16hi3 */

            case E_V8HImode:
              if (pattern26 (x2, 
E_V8HImode) != 0
                  || !
#line 18819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 7400; /* *xorv8hi3 */

            case E_V1TImode:
              if (pattern604 (x2, 
E_V1TImode) != 0
                  || !
#line 18916 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
                return -1;
              return 7403; /* xorv1ti3 */

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern845 (x2, 
E_V16SImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7299; /* *one_cmplv16si2 */

            case E_V8DImode:
              if (pattern845 (x2, 
E_V8DImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7301; /* *one_cmplv8di2 */

            case E_V64QImode:
              if (pattern845 (x2, 
E_V64QImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7303; /* *one_cmplv64qi2 */

            case E_V32QImode:
              if (pattern845 (x2, 
E_V32QImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7304; /* *one_cmplv32qi2 */

            case E_V16QImode:
              if (pattern845 (x2, 
E_V16QImode) != 0
                  || !
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)))
                return -1;
              return 7305; /* *one_cmplv16qi2 */

            case E_V32HImode:
              if (pattern845 (x2, 
E_V32HImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7306; /* *one_cmplv32hi2 */

            case E_V16HImode:
              if (pattern845 (x2, 
E_V16HImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7307; /* *one_cmplv16hi2 */

            case E_V8HImode:
              if (pattern845 (x2, 
E_V8HImode) != 0
                  || !
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)))
                return -1;
              return 7308; /* *one_cmplv8hi2 */

            case E_V8SImode:
              if (pattern845 (x2, 
E_V8SImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7309; /* *one_cmplv8si2 */

            case E_V4SImode:
              if (pattern845 (x2, 
E_V4SImode) != 0
                  || !
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)))
                return -1;
              return 7311; /* *one_cmplv4si2 */

            case E_V4DImode:
              if (pattern845 (x2, 
E_V4DImode) != 0
                  || !(
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7313; /* *one_cmplv4di2 */

            case E_V2DImode:
              if (pattern845 (x2, 
E_V2DImode) != 0
                  || !
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)))
                return -1;
              return 7315; /* *one_cmplv2di2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern467 (x2))
            {
            case 0:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4851; /* *avx512bw_vpternlogv64qi_1 */

            case 1:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4878; /* *avx512vl_vpternlogv32qi_1 */

            case 2:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4905; /* *avx512vl_vpternlogv16qi_1 */

            case 3:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4932; /* *avx512bw_vpternlogv32hi_1 */

            case 4:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4959; /* *avx512vl_vpternlogv16hi_1 */

            case 5:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4986; /* *avx512vl_vpternlogv8hi_1 */

            case 6:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5013; /* *avx512f_vpternlogv16si_1 */

            case 7:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5040; /* *avx512vl_vpternlogv8si_1 */

            case 8:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5067; /* *avx512vl_vpternlogv4si_1 */

            case 9:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5094; /* *avx512f_vpternlogv8di_1 */

            case 10:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5121; /* *avx512vl_vpternlogv4di_1 */

            case 11:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5148; /* *avx512vl_vpternlogv2di_1 */

            case 12:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4854; /* *avx512bw_vpternlogv64qi_1 */

            case 13:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4881; /* *avx512vl_vpternlogv32qi_1 */

            case 14:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4908; /* *avx512vl_vpternlogv16qi_1 */

            case 15:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4935; /* *avx512bw_vpternlogv32hi_1 */

            case 16:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4962; /* *avx512vl_vpternlogv16hi_1 */

            case 17:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4989; /* *avx512vl_vpternlogv8hi_1 */

            case 18:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5016; /* *avx512f_vpternlogv16si_1 */

            case 19:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5043; /* *avx512vl_vpternlogv8si_1 */

            case 20:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5070; /* *avx512vl_vpternlogv4si_1 */

            case 21:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5097; /* *avx512f_vpternlogv8di_1 */

            case 22:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5124; /* *avx512vl_vpternlogv4di_1 */

            case 23:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5151; /* *avx512vl_vpternlogv2di_1 */

            case 24:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4857; /* *avx512bw_vpternlogv64qi_1 */

            case 25:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4884; /* *avx512vl_vpternlogv32qi_1 */

            case 26:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4911; /* *avx512vl_vpternlogv16qi_1 */

            case 27:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4938; /* *avx512bw_vpternlogv32hi_1 */

            case 28:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4965; /* *avx512vl_vpternlogv16hi_1 */

            case 29:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4992; /* *avx512vl_vpternlogv8hi_1 */

            case 30:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5019; /* *avx512f_vpternlogv16si_1 */

            case 31:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5046; /* *avx512vl_vpternlogv8si_1 */

            case 32:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5073; /* *avx512vl_vpternlogv4si_1 */

            case 33:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5100; /* *avx512f_vpternlogv8di_1 */

            case 34:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5127; /* *avx512vl_vpternlogv4di_1 */

            case 35:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5154; /* *avx512vl_vpternlogv2di_1 */

            case 36:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6147; /* *avx512bw_vpternlogv64qi_3 */

            case 37:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6156; /* *avx512vl_vpternlogv32qi_3 */

            case 38:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6165; /* *avx512vl_vpternlogv16qi_3 */

            case 39:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6174; /* *avx512bw_vpternlogv32hi_3 */

            case 40:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6183; /* *avx512vl_vpternlogv16hi_3 */

            case 41:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6192; /* *avx512vl_vpternlogv8hi_3 */

            case 42:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6201; /* *avx512f_vpternlogv16si_3 */

            case 43:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6210; /* *avx512vl_vpternlogv8si_3 */

            case 44:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6219; /* *avx512vl_vpternlogv4si_3 */

            case 45:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6228; /* *avx512f_vpternlogv8di_3 */

            case 46:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6237; /* *avx512vl_vpternlogv4di_3 */

            case 47:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6246; /* *avx512vl_vpternlogv2di_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5499; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5526; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5553; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5580; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5607; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5634; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5661; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5688; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5715; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5742; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5769; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5796; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5502; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5529; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5556; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5583; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5610; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5637; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5664; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5691; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5718; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5745; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5772; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5799; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5505; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5532; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5559; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5586; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5613; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5640; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5667; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5694; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5721; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5748; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5775; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5802; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_289 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_288 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      return recog_168 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_165 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_188 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_176 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_163 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_170 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_187 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_182 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_180 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_181 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_162 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern915 (x3, 
E_V4SFmode) != 0
              || !
#line 4369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2728; /* sse_vmmaskcmpv4sf3 */

        case E_V2DFmode:
          if (pattern915 (x3, 
E_V2DFmode) != 0
              || !(
#line 4369 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2729; /* sse2_vmmaskcmpv2df3 */

        default:
          return -1;
        }

    case AND:
      return recog_175 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_189 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_179 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_166 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_184 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_183 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_186 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_185 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_173 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern128 (x3, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4131; /* avx512fp16_vcvtpd2ph_v8df_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4139; /* avx512fp16_vcvtps2ph_v8sf_mask */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern127 (x3, 
E_V16HFmode, 
E_HImode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4135; /* avx512fp16_vcvtps2ph_v16sf_mask */

        case E_V8SFmode:
          if (pattern127 (x3, 
E_V8SFmode, 
E_QImode, 
E_V8DFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4505; /* avx512f_cvtpd2ps512_mask */

        case E_V4SFmode:
          if (pattern141 (x3, 
E_V4SFmode, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4508; /* avx_cvtpd2ps256_mask */

        case E_V16BFmode:
          if (pattern141 (x3, 
E_V16BFmode, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31173 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9633; /* avx512f_cvtneps2bf16_v16sf_mask */

        case E_V8BFmode:
          if (pattern141 (x3, 
E_V8BFmode, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31173 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9635; /* avx512f_cvtneps2bf16_v8sf_mask */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_164 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      switch (pattern132 (x3))
        {
        case 0:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6588; /* avx512f_ss_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6624; /* avx512vl_ss_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6591; /* avx512f_ss_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6594; /* avx512f_ss_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6597; /* avx512f_ss_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6621; /* avx512vl_ss_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15193 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 6604; /* avx512bw_ss_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6618; /* avx512vl_ss_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_174 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      switch (pattern132 (x3))
        {
        case 0:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6590; /* avx512f_us_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6626; /* avx512vl_us_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6593; /* avx512f_us_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6596; /* avx512f_us_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6599; /* avx512f_us_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6623; /* avx512vl_us_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15193 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 6606; /* avx512bw_us_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6620; /* avx512vl_us_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern133 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6859; /* *avx512bw_ssaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6867; /* *avx2_ssaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands))))
            return -1;
          return 6875; /* *sse2_ssaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6883; /* *avx512bw_ssaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6891; /* *avx2_ssaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands))))
            return -1;
          return 6899; /* *sse2_ssaddv8hi3_mask */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern133 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V64QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6861; /* *avx512bw_usaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6869; /* *avx2_usaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16QImode, operands))))
            return -1;
          return 6877; /* *sse2_usaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6885; /* *avx512bw_usaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6893; /* *avx2_usaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V8HImode, operands))))
            return -1;
          return 6901; /* *sse2_usaddv8hi3_mask */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern133 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V64QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6863; /* *avx512bw_sssubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6871; /* *avx2_sssubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16QImode, operands))))
            return -1;
          return 6879; /* *sse2_sssubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6887; /* *avx512bw_sssubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6895; /* *avx2_sssubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V8HImode, operands))))
            return -1;
          return 6903; /* *sse2_sssubv8hi3_mask */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern133 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6865; /* *avx512bw_ussubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6873; /* *avx2_ussubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands))))
            return -1;
          return 6881; /* *sse2_ussubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 6889; /* *avx512bw_ussubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 6897; /* *avx2_ussubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16304 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands))))
            return -1;
          return 6905; /* *sse2_ussubv8hi3_mask */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_169 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_172 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_171 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern136 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7054; /* avx512f_rolvv16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7058; /* avx512vl_rolvv8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7062; /* avx512vl_rolvv4si_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7066; /* avx512f_rolvv8di_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7070; /* avx512vl_rolvv4di_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7074; /* avx512vl_rolvv2di_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7078; /* avx512f_rolv16si_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7082; /* avx512vl_rolv8si_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7086; /* avx512vl_rolv4si_mask */

        case 9:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7090; /* avx512f_rolv8di_mask */

        case 10:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7094; /* avx512vl_rolv4di_mask */

        case 11:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7098; /* avx512vl_rolv2di_mask */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern136 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7056; /* avx512f_rorvv16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7060; /* avx512vl_rorvv8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7064; /* avx512vl_rorvv4si_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7068; /* avx512f_rorvv8di_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7072; /* avx512vl_rorvv4di_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7076; /* avx512vl_rorvv2di_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7080; /* avx512f_rorv16si_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7084; /* avx512vl_rorv8si_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7088; /* avx512vl_rorv4si_mask */

        case 9:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7092; /* avx512f_rorv8di_mask */

        case 10:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7096; /* avx512vl_rorv4di_mask */

        case 11:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7100; /* avx512vl_rorv2di_mask */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern137 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7118; /* *avx512f_umaxv16si3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7126; /* *avx512f_umaxv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7134; /* *avx512f_umaxv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7224; /* *sse4_1_umaxv4si3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7142; /* *avx512f_umaxv8di3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7150; /* *avx512f_umaxv4di3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7158; /* *avx512f_umaxv2di3_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7166; /* *avx512bw_umaxv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7174; /* *avx512bw_umaxv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7182; /* *avx512bw_umaxv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7190; /* *avx512bw_umaxv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7198; /* *avx512bw_umaxv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7206; /* *avx512bw_umaxv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7220; /* *sse4_1_umaxv8hi3_mask */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern137 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7120; /* *avx512f_uminv16si3_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7128; /* *avx512f_uminv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7136; /* *avx512f_uminv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7226; /* *sse4_1_uminv4si3_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7144; /* *avx512f_uminv8di3_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7152; /* *avx512f_uminv4di3_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7160; /* *avx512f_uminv2di3_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7168; /* *avx512bw_uminv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7176; /* *avx512bw_uminv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7184; /* *avx512bw_uminv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7192; /* *avx512bw_uminv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7200; /* *avx512bw_uminv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7208; /* *avx512bw_uminv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17881 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7222; /* *sse4_1_uminv8hi3_mask */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_167 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern140 (x3))
        {
        case 0:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7953; /* absv16si2_mask */

        case 1:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7954; /* absv8si2_mask */

        case 2:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7955; /* absv4si2_mask */

        case 3:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7956; /* absv8di2_mask */

        case 4:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7957; /* absv4di2_mask */

        case 5:
          if (!(
#line 23357 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7958; /* absv2di2_mask */

        case 6:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7959; /* absv64qi2_mask */

        case 7:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7960; /* absv16qi2_mask */

        case 8:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7961; /* absv32qi2_mask */

        case 9:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7962; /* absv32hi2_mask */

        case 10:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7963; /* absv16hi2_mask */

        case 11:
          if (!(
#line 23370 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7964; /* absv8hi2_mask */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_178 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_177 (x1, insn, pnum_clobbers);

    case CLZ:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern138 (x3, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9354; /* clzv16si2_mask */

        case E_V8SImode:
          if (pattern138 (x3, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9356; /* clzv8si2_mask */

        case E_V4SImode:
          if (pattern138 (x3, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9358; /* clzv4si2_mask */

        case E_V8DImode:
          if (pattern138 (x3, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9360; /* clzv8di2_mask */

        case E_V4DImode:
          if (pattern138 (x3, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9362; /* clzv4di2_mask */

        case E_V2DImode:
          if (pattern138 (x3, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9364; /* clzv2di2_mask */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern140 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9427; /* vpopcountv16si_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9429; /* vpopcountv8si_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9431; /* vpopcountv4si_mask */

        case 3:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9433; /* vpopcountv8di_mask */

        case 4:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9435; /* vpopcountv4di_mask */

        case 5:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30276 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9437; /* vpopcountv2di_mask */

        case 6:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9439; /* vpopcountv64qi_mask */

        case 7:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9441; /* vpopcountv16qi_mask */

        case 8:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9443; /* vpopcountv32qi_mask */

        case 9:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 9445; /* vpopcountv32hi_mask */

        case 10:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9447; /* vpopcountv16hi_mask */

        case 11:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 9449; /* vpopcountv8hi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern30 (x1))
    {
    case 0:
      if (!(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4015; /* avx512fp16_fixuns_truncv8hi2 */

    case 1:
      if (!(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4023; /* avx512fp16_fixuns_truncv16hi2 */

    case 2:
      if (!(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4031; /* avx512fp16_fixuns_truncv32hi2 */

    case 3:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4039; /* avx512fp16_fixuns_truncv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4383; /* fixuns_truncv8dfv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 9900 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4484; /* *fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case 4:
      if (!(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4047; /* avx512fp16_fixuns_truncv16si2 */

    case 5:
      if (!
#line 8764 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 4258; /* fixuns_truncv16sfv16si2 */

    case 6:
      if (!(
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4055; /* avx512fp16_fixuns_truncv8di2 */

    case 7:
      if (!(
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4420; /* fixuns_truncv8dfv8di2 */

    case 8:
      if (!(
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4464; /* fixuns_truncv8sfv8di2 */

    case 9:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4077; /* *avx512fp16_fixuns_truncv4si2_load */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9665 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F))
            return -1;
          return 4398; /* fixuns_truncv4dfv4si2 */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 9900 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4486; /* *fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case 10:
      if (!
#line 7919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4081; /* *avx512fp16_fixuns_truncv4di2_load */

    case 11:
      if (!(
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4426; /* fixuns_truncv4dfv4di2 */

    case 12:
      if (!(
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4470; /* fixuns_truncv4sfv4di2 */

    case 13:
      if (!
#line 7969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4093; /* *avx512fp16_fixuns_truncv2di2_load */

    case 14:
      if (!(
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4430; /* fixuns_truncv2dfv2di2 */

    case 15:
      if (!
#line 7909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4069; /* avx512fp16_fixuns_truncv4si2 */

    case 16:
      if (!
#line 7909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4073; /* avx512fp16_fixuns_truncv4di2 */

    case 17:
      if (!
#line 7959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4089; /* avx512fp16_fixuns_truncv2di2 */

    case 18:
      if (!
#line 9752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 4478; /* avx512dq_fixuns_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7055; /* avx512f_rorvv16si */

    case 1:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7059; /* avx512vl_rorvv8si */

    case 2:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7063; /* avx512vl_rorvv4si */

    case 3:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7067; /* avx512f_rorvv8di */

    case 4:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7071; /* avx512vl_rorvv4di */

    case 5:
      if (!(
#line 17625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7075; /* avx512vl_rorvv2di */

    case 6:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7079; /* avx512f_rorv16si */

    case 7:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7083; /* avx512vl_rorv8si */

    case 8:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7087; /* avx512vl_rorv4si */
      if (!const_0_to_31_operand (operands[2], E_SImode)
          || !
#line 26602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8332; /* xop_rotrv4si3 */

    case 9:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7091; /* avx512f_rorv8di */

    case 10:
      if (!(
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7095; /* avx512vl_rorv4di */

    case 11:
      if (const_0_to_255_operand (operands[2], E_SImode)
          && (
#line 17635 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7099; /* avx512vl_rorv2di */
      if (!const_0_to_63_operand (operands[2], E_SImode)
          || !
#line 26602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8333; /* xop_rotrv2di3 */

    case 12:
      if (!
#line 26602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8330; /* xop_rotrv16qi3 */

    case 13:
      if (!
#line 26602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
        return -1;
      return 8331; /* xop_rotrv8hi3 */

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (pattern1036 (x1))
    {
    case 0:
      if (!(
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1513; /* stack_protect_set_1_si_si */

    case 1:
      if (!(
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1515; /* stack_protect_set_1_si_di */

    case 2:
      if (!(
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1514; /* stack_protect_set_1_di_si */

    case 3:
      if (!(
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 1516; /* stack_protect_set_1_di_di */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XINT (x5, 1))
    {
    case 22:
      if (pattern747 (x5) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCmode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      operands[1] = x7;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 23308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1331; /* *tls_dynamic_gnu2_call_32 */

    case 23:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      switch (pattern1038 (x1))
        {
        case 0:
          if (!(
#line 26135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 1445; /* *strlenqi_1 */

        case 1:
          if (!(
#line 26135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 1446; /* *strlenqi_1 */

        default:
          return -1;
        }

    case 153:
      x8 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x8) != MEM)
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != UNSPEC
          || XVECLEN (x10, 0) != 3
          || XINT (x10, 1) != 154)
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_BLKmode)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != SCRATCH)
        return -1;
      x12 = XVECEXP (x10, 0, 2);
      if (!const1248_operand (x12, E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          operands[7] = x8;
          x13 = XVECEXP (x10, 0, 0);
          operands[3] = x13;
          x14 = XVECEXP (x10, 0, 1);
          operands[4] = x14;
          operands[6] = x12;
          x15 = XVECEXP (x5, 0, 3);
          operands[5] = x15;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              switch (pattern1632 (x5, 
E_V2DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8963; /* *avx2_gathersiv2di */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8995; /* *avx2_gatherdiv2di */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8971; /* *avx2_gathersiv2di */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9003; /* *avx2_gatherdiv2di */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1632 (x5, 
E_V2DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8964; /* *avx2_gathersiv2df */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8996; /* *avx2_gatherdiv2df */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8972; /* *avx2_gathersiv2df */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9004; /* *avx2_gatherdiv2df */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1634 (x5, 
E_V4DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8965; /* *avx2_gathersiv4di */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8997; /* *avx2_gatherdiv4di */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8973; /* *avx2_gathersiv4di */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9005; /* *avx2_gatherdiv4di */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1634 (x5, 
E_V4DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8966; /* *avx2_gathersiv4df */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8998; /* *avx2_gatherdiv4df */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8974; /* *avx2_gathersiv4df */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9006; /* *avx2_gatherdiv4df */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1632 (x5, 
E_V4SImode, 
E_SImode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8967; /* *avx2_gathersiv4si */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8999; /* *avx2_gatherdiv4si */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8975; /* *avx2_gathersiv4si */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9007; /* *avx2_gatherdiv4si */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1632 (x5, 
E_V4SFmode, 
E_SFmode))
                {
                case 0:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8968; /* *avx2_gathersiv4sf */

                case 1:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9000; /* *avx2_gatherdiv4sf */

                case 2:
                  if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8976; /* *avx2_gathersiv4sf */

                case 3:
                  if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9008; /* *avx2_gatherdiv4sf */

                default:
                  return -1;
                }

            case E_V8SImode:
              if (pattern1635 (x5, 
E_V8SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8SImode:
                  if (!register_operand (operands[2], E_V8SImode)
                      || !register_operand (operands[4], E_V8SImode))
                    return -1;
                  switch (pattern1682 (x10, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 8969; /* *avx2_gathersiv8si */

                    case 1:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 8977; /* *avx2_gathersiv8si */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern1683 (x10, 
E_V4SImode, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 9001; /* *avx2_gatherdiv8si */

                    case 1:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 9009; /* *avx2_gatherdiv8si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              if (pattern1635 (x5, 
E_V8SFmode, 
E_SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8SFmode:
                  switch (pattern1683 (x10, 
E_V8SFmode, 
E_V8SImode))
                    {
                    case 0:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 8970; /* *avx2_gathersiv8sf */

                    case 1:
                      if (!(
#line 29282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 8978; /* *avx2_gathersiv8sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  switch (pattern1683 (x10, 
E_V4SFmode, 
E_V4DImode))
                    {
                    case 0:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 9002; /* *avx2_gatherdiv8sf */

                    case 1:
                      if (!(
#line 29345 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 9010; /* *avx2_gatherdiv8sf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PC:
          operands[6] = x8;
          x13 = XVECEXP (x10, 0, 0);
          operands[2] = x13;
          x14 = XVECEXP (x10, 0, 1);
          operands[3] = x14;
          operands[5] = x12;
          x15 = XVECEXP (x5, 0, 3);
          operands[4] = x15;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              switch (pattern1617 (x5, 
E_V2DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8979; /* *avx2_gathersiv2di_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9011; /* *avx2_gatherdiv2di_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8987; /* *avx2_gathersiv2di_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9019; /* *avx2_gatherdiv2di_2 */

                default:
                  return -1;
                }

            case E_V2DFmode:
              switch (pattern1617 (x5, 
E_V2DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8980; /* *avx2_gathersiv2df_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9012; /* *avx2_gatherdiv2df_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8988; /* *avx2_gathersiv2df_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9020; /* *avx2_gatherdiv2df_2 */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern1619 (x5, 
E_V4DImode, 
E_DImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8981; /* *avx2_gathersiv4di_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9013; /* *avx2_gatherdiv4di_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8989; /* *avx2_gathersiv4di_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9021; /* *avx2_gatherdiv4di_2 */

                default:
                  return -1;
                }

            case E_V4DFmode:
              switch (pattern1619 (x5, 
E_V4DFmode, 
E_DFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8982; /* *avx2_gathersiv4df_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9014; /* *avx2_gatherdiv4df_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8990; /* *avx2_gathersiv4df_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9022; /* *avx2_gatherdiv4df_2 */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern1617 (x5, 
E_V4SImode, 
E_SImode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8983; /* *avx2_gathersiv4si_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9015; /* *avx2_gatherdiv4si_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8991; /* *avx2_gathersiv4si_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9023; /* *avx2_gatherdiv4si_2 */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern1617 (x5, 
E_V4SFmode, 
E_SFmode))
                {
                case 0:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 8984; /* *avx2_gathersiv4sf_2 */

                case 1:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 9016; /* *avx2_gatherdiv4sf_2 */

                case 2:
                  if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 8992; /* *avx2_gathersiv4sf_2 */

                case 3:
                  if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 9024; /* *avx2_gatherdiv4sf_2 */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern1620 (x5, 
E_V8SImode, 
E_SImode))
                {
                case 0:
                  switch (pattern1678 (
E_SImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 8985; /* *avx2_gathersiv8si_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 9017; /* *avx2_gatherdiv8si_2 */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern1678 (
E_DImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 8993; /* *avx2_gathersiv8si_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 9025; /* *avx2_gatherdiv8si_2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case E_V8SFmode:
              switch (pattern1620 (x5, 
E_V8SFmode, 
E_SFmode))
                {
                case 0:
                  switch (pattern1679 (
E_SImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 8986; /* *avx2_gathersiv8sf_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                        return -1;
                      return 9018; /* *avx2_gatherdiv8sf_2 */

                    default:
                      return -1;
                    }

                case 1:
                  switch (pattern1679 (
E_DImode))
                    {
                    case 0:
                      if (!(
#line 29303 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 8994; /* *avx2_gathersiv8sf_2 */

                    case 1:
                      if (!(
#line 29366 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                        return -1;
                      return 9026; /* *avx2_gatherdiv8sf_2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      res = recog_366 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != SUBREG
          || pattern751 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern300 (x5, 
E_CCmode, 
17) != 0
          || GET_MODE (x3) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case STRICT_LOW_PART:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_QImode))
            return -1;
          switch (pattern1639 ())
            {
            case 0:
              if (!
#line 8215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 333; /* *subqi_exthi_1_slp */

            case 1:
              if (!
#line 8215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 334; /* *subqi_extsi_1_slp */

            case 2:
              if (!(
#line 8215 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 335; /* *subqi_extdi_1_slp */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x8;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_HImode:
              if (!extract_operator (operands[3], E_HImode))
                return -1;
              return 343; /* *subqi_exthi_0 */

            case E_SImode:
              if (!extract_operator (operands[3], E_SImode))
                return -1;
              return 344; /* *subqi_extsi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern348 (x5) != 0)
        return -1;
      switch (pattern1051 (x2))
        {
        case 0:
          if (!(
#line 8103 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 311; /* *subdi3_doubleword_zext */

        case 1:
          if (!(
#line 8103 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 312; /* *subti3_doubleword_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern622 (x1))
        {
        case 0:
          if (pattern1417 (x3, 
E_QImode) != 0
              || !
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 410; /* *subqi3_carry_0 */

        case 1:
          if (pattern1417 (x3, 
E_HImode) != 0
              || !
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 411; /* *subhi3_carry_0 */

        case 2:
          if (pattern1417 (x3, 
E_SImode) != 0
              || !
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 412; /* *subsi3_carry_0 */

        case 3:
          if (pattern1417 (x3, 
E_DImode) != 0
              || !(
#line 9349 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 413; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern622 (x1))
        {
        case 0:
          if (pattern1418 (x3, 
E_QImode) != 0
              || !
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 414; /* *subqi3_carry_0r */

        case 1:
          if (pattern1418 (x3, 
E_HImode) != 0
              || !
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 415; /* *subhi3_carry_0r */

        case 2:
          if (pattern1418 (x3, 
E_SImode) != 0
              || !
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          return 416; /* *subsi3_carry_0r */

        case 3:
          if (pattern1418 (x3, 
E_DImode) != 0
              || !(
#line 9363 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 417; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern626 (x1))
        {
        case 0:
          if (!
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 491; /* *subqi3_eq_0 */

        case 1:
          if (!
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 492; /* *subhi3_eq_0 */

        case 2:
          if (!
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 493; /* *subsi3_eq_0 */

        case 3:
          if (!(
#line 10307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 494; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern626 (x1))
        {
        case 0:
          if (!
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, QImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 495; /* *subqi3_ne_0 */

        case 1:
          if (!
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, HImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 496; /* *subhi3_ne_0 */

        case 2:
          if (!
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          return 497; /* *subsi3_ne_0 */

        case 3:
          if (!(
#line 10328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 498; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern500 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG
              && REGNO (x6) == 17
              && GET_MODE (x6) == E_CCmode)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern508 (x3, 
E_DImode) == 0
                      && (
#line 12503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                    return 569; /* *anddi3_doubleword */
                  break;

                case E_TImode:
                  if (pattern508 (x3, 
E_TImode) == 0
                      && (
#line 12503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 570; /* *andti3_doubleword */
                  break;

                case E_HImode:
                  if (pattern509 (x3, 
E_HImode) == 0
                      && 
#line 12673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)
   && true))
                    return 582; /* *andhi_1 */
                  break;

                case E_SImode:
                  if (pattern510 (x3) == 0
                      && 
#line 12673 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
                    return 584; /* *andsi_1 */
                  break;

                case E_QImode:
                  if (pattern509 (x3, 
E_QImode) == 0
                      && 
#line 12711 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && true))
                    return 586; /* *andqi_1 */
                  break;

                case E_V4QImode:
                  if (pattern511 (x3, 
E_V4QImode) == 0
                      && 
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V4QImode, operands)))
                    return 1805; /* *andv4qi3 */
                  break;

                case E_V2QImode:
                  if (pattern511 (x3, 
E_V2QImode) == 0
                      && 
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2QImode, operands)))
                    return 1808; /* *andv2qi3 */
                  break;

                case E_V2HImode:
                  if (pattern511 (x3, 
E_V2HImode) == 0
                      && 
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (AND, V2HImode, operands)))
                    return 1811; /* *andv2hi3 */
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          switch (pattern513 (x1))
            {
            case 0:
              if (
#line 2097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return 2060; /* kandqi */
              break;

            case 1:
              if (
#line 2097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return 2063; /* kandhi */
              break;

            case 2:
              if ((
#line 2097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2066; /* kandsi */
              break;

            case 3:
              if ((
#line 2097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
                return 2069; /* kanddi */
              break;

            default:
              break;
            }
          break;

        case 2:
          if (
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 587; /* *andqi_1_slp */
          break;

        case 3:
          if (
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return 590; /* *andhi_1_slp */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x7;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x9 = XEXP (x7, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          switch (pattern1475 (x2))
            {
            case 0:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 593; /* *andqi_exthi_1_slp */
              break;

            case 1:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return 596; /* *andqi_extsi_1_slp */
              break;

            case 2:
              if ((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 599; /* *andqi_extdi_1_slp */
              break;

            case 3:
              return 615; /* *andqi_exthi_0 */

            case 4:
              return 618; /* *andqi_extsi_0 */

            default:
              break;
            }
          x11 = XEXP (x3, 1);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          switch (pattern1476 (x2))
            {
            case 0:
              if (!
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 602; /* *andqi_exthi_2_slp */

            case 1:
              if (!
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 605; /* *andqi_extsi_2_slp */

            case 2:
              if (!(
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 608; /* *andqi_extdi_2_slp */

            case 3:
              return 621; /* *andqi_ext2hi_0 */

            case 4:
              return 624; /* *andqi_ext2si_0 */

            default:
              return -1;
            }

        case ROTATE:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x7, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern348 (x5) != 0)
            return -1;
          switch (pattern1299 (x2))
            {
            case 0:
              if (!
#line 18962 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1160; /* *btrqi_1 */

            case 1:
              if (!
#line 18962 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1161; /* *btrhi_1 */

            default:
              return -1;
            }

        case CLZ:
          if (pnum_clobbers == NULL
              || GET_MODE (x7) != E_SImode)
            return -1;
          x11 = XEXP (x3, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 38)
            return -1;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x13 = XVECEXP (x5, 0, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 21605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          *pnum_clobbers = 1;
          return 1261; /* *clzsi2_lzcnt_zext_falsedep */

        default:
          return -1;
        }

    case NOT:
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = recog_373 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_QImode)
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != LSHIFTRT)
            return -1;
          x11 = XEXP (x3, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1379 (x3))
            {
            case 0:
              if (!
#line 19364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1183; /* *btsi_setncqi */

            case 1:
              if (!(
#line 19364 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1184; /* *btdi_setncqi */

            default:
              return -1;
            }

        case LSHIFTRT:
          x11 = XEXP (x3, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1120 (x3))
            {
            case 0:
              if (!
#line 19382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              return 1185; /* *btsi_setncsi */

            case 1:
              if (!(
#line 19382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1186; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x7, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x11 = XEXP (x3, 1);
          operands[1] = x11;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22104 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1293; /* *bmi2_bzhi_si3_3 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern322 (x1, 
-2))
        {
        case 0:
          x14 = XEXP (x4, 1);
          operands[2] = x14;
          if (pattern1209 (x3) == 0
              && 
#line 18893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT))
            return 1155; /* *btrsi */
          if (GET_CODE (x14) != SUBREG)
            return -1;
          switch (pattern1210 (x3))
            {
            case 0:
              if (!
#line 18912 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1156; /* *btrsi_mask */

            case 1:
              if (!(
#line 18912 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1157; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18940 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1158; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18940 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1159; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x4) != E_SImode
          || pattern517 (x1) != 0
          || !
#line 21781 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      return 1277; /* *bmi_blsi_si */

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != CONST_INT
          || pattern537 (x1) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x14, 0))
            {
            case -1L:
              x11 = XEXP (x3, 1);
              switch (pattern1422 (x11))
                {
                case 0:
                  if (!
#line 21926 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  return 1286; /* *bmi_blsr_si */

                case 1:
                  if (!
#line 22297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1305; /* *tbm_tzmsk_si */

                default:
                  return -1;
                }

            case 1L:
              x11 = XEXP (x3, 1);
              switch (pattern1422 (x11))
                {
                case 0:
                  if (!
#line 22188 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1297; /* *tbm_blcfill_si */

                case 1:
                  if (!
#line 22216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  return 1299; /* *tbm_blcic_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x7, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x14, 0) != -1L)
            return -1;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x11 = XEXP (x3, 1);
          operands[1] = x11;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22090 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          return 1292; /* *bmi2_bzhi_si3_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !(
#line 27216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1505; /* allocate_stack_worker_probe_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 27216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1506; /* allocate_stack_worker_probe_di */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern616 (x5, 
E_SImode, 
10, 
UNSPEC_VOLATILE) != 0
              || !register_operand (operands[0], E_DImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 1535; /* rdtscp */

        case 44:
          switch (pattern640 (x1, 
44))
            {
            case 0:
              if (!
#line 29503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1557; /* rdrandhi */

            case 1:
              if (!
#line 29503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_RDRND))
                return -1;
              return 1558; /* rdrandsi */

            default:
              return -1;
            }

        case 45:
          switch (pattern640 (x1, 
45))
            {
            case 0:
              if (!
#line 29513 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1559; /* rdseedhi */

            case 1:
              if (!
#line 29513 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_RDSEED))
                return -1;
              return 1560; /* rdseedsi */

            default:
              return -1;
            }

        case 56:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 29756 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_PKU))
            return -1;
          return 1582; /* *rdpkru */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x4, 1))
        {
        case 3:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1302 (x4, 
E_SImode) != 0
                  || !
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))
                return -1;
              return 1511; /* probe_stack_range_si */

            case E_DImode:
              if (pattern1302 (x4, 
E_DImode) != 0
                  || !
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))
                return -1;
              return 1512; /* probe_stack_range_di */

            default:
              return -1;
            }

        case 99:
          if (pattern641 (x1, 
99) != 0
              || !
#line 31354 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9648; /* aesdec128klu8 */

        case 101:
          if (pattern641 (x1, 
101) != 0
              || !
#line 31354 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9649; /* aesdec256klu8 */

        case 100:
          if (pattern641 (x1, 
100) != 0
              || !
#line 31354 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9650; /* aesenc128klu8 */

        case 102:
          if (pattern641 (x1, 
102) != 0
              || !
#line 31354 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_KL))
            return -1;
          return 9651; /* aesenc256klu8 */

        case 110:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          x9 = XVECEXP (x4, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              x11 = XEXP (x8, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1423 (x1, 
E_QImode) != 0
                      || !
#line 703 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10270; /* atomic_fetch_addqi */

                case E_HImode:
                  if (pattern1423 (x1, 
E_HImode) != 0
                      || !
#line 703 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10271; /* atomic_fetch_addhi */

                case E_SImode:
                  if (pattern1423 (x1, 
E_SImode) != 0
                      || !
#line 703 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(TARGET_XADD))
                    return -1;
                  *pnum_clobbers = 1;
                  return 10272; /* atomic_fetch_addsi */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern1357 (x4, 
E_QImode) != 0)
                    return -1;
                  return 10276; /* atomic_exchangeqi */

                case E_HImode:
                  if (pattern1357 (x4, 
E_HImode) != 0)
                    return -1;
                  return 10277; /* atomic_exchangehi */

                case E_SImode:
                  if (pattern1357 (x4, 
E_SImode) != 0)
                    return -1;
                  return 10278; /* atomic_exchangesi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 111:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern300 (x5, 
E_CCmode, 
17) != 0)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x6))
            {
            case PLUS:
              switch (pattern1304 (x4))
                {
                case 0:
                  return 10283; /* atomic_addqi */

                case 1:
                  return 10284; /* atomic_addhi */

                case 2:
                  return 10285; /* atomic_addsi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern1304 (x4))
                {
                case 0:
                  return 10286; /* atomic_subqi */

                case 1:
                  return 10287; /* atomic_subhi */

                case 2:
                  return 10288; /* atomic_subsi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern1304 (x4))
                {
                case 0:
                  return 10289; /* atomic_andqi */

                case 1:
                  return 10292; /* atomic_andhi */

                case 2:
                  return 10295; /* atomic_andsi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern1304 (x4))
                {
                case 0:
                  return 10290; /* atomic_orqi */

                case 1:
                  return 10293; /* atomic_orhi */

                case 2:
                  return 10296; /* atomic_orsi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern1304 (x4))
                {
                case 0:
                  return 10291; /* atomic_xorqi */

                case 1:
                  return 10294; /* atomic_xorhi */

                case 2:
                  return 10297; /* atomic_xorsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_CODE (operands[0]))
    {
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (push_operand (operands[0], E_DImode))
            {
              if (general_gr_operand (operands[1], E_DImode)
                  && (
#line 2199 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return gen_split_3 (insn, operands);
              if (sse_reg_operand (operands[1], E_DImode))
                {
                  if ((
#line 2269 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_5 (insn, operands);
                  if ((
#line 2269 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_7 (insn, operands);
                }
            }
          break;

        case E_SImode:
          if (push_operand (operands[0], E_SImode)
              && sse_reg_operand (operands[1], E_SImode))
            {
              if ((
#line 2269 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_4 (insn, operands);
              if ((
#line 2269 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_6 (insn, operands);
            }
          break;

        case E_TFmode:
          if (push_operand (operands[0], E_TFmode)
              && sse_reg_operand (operands[1], E_TFmode))
            {
              if ((
#line 3779 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_15 (insn, operands);
              if ((
#line 3779 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE && reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_16 (insn, operands);
            }
          break;

        case E_XFmode:
          if (push_operand (operands[0], E_XFmode)
              && fp_register_operand (operands[1], E_XFmode))
            {
              if ((
#line 3814 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_17 (insn, operands);
              if ((
#line 3814 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_18 (insn, operands);
            }
          break;

        case E_DFmode:
          if (push_operand (operands[0], E_DFmode)
              && any_fp_register_operand (operands[1], E_DFmode))
            {
              if ((
#line 3848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_19 (insn, operands);
              if ((
#line 3848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_20 (insn, operands);
            }
          break;

        case E_SFmode:
          if (push_operand (operands[0], E_SFmode))
            {
              if (any_fp_register_operand (operands[1], E_SFmode))
                {
                  if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return gen_split_21 (insn, operands);
                  if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return gen_split_24 (insn, operands);
                }
              if (memory_operand (operands[1], E_SFmode)
                  && 
#line 4002 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && find_constant_src (insn)))
                return gen_split_27 (insn, operands);
            }
          break;

        case E_HFmode:
          if (push_operand (operands[0], E_HFmode)
              && any_fp_register_operand (operands[1], E_HFmode))
            {
              if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_22 (insn, operands);
              if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_25 (insn, operands);
            }
          break;

        case E_BFmode:
          if (push_operand (operands[0], E_BFmode)
              && any_fp_register_operand (operands[1], E_BFmode))
            {
              if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return gen_split_23 (insn, operands);
              if ((
#line 3979 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return gen_split_26 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    case REG:
      if (general_reg_operand (operands[0], E_DImode)
          && sse_reg_operand (operands[1], E_DImode)
          && (
#line 2755 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE4_1
   && reload_completed) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return gen_split_8 (insn, operands);
      break;

    default:
      break;
    }
  if (nonimmediate_gr_operand (operands[0], E_DImode)
      && general_gr_operand (operands[1], E_DImode)
      && (
#line 2772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
    return gen_split_9 (insn, operands);
  if (sse_reg_operand (operands[0], E_DImode)
      && general_reg_operand (operands[1], E_DImode)
      && 
#line 2779 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_SSE4_1
   && reload_completed))
    return gen_split_10 (insn, operands);
  if (push_operand (operands[0], E_VOIDmode)
      && general_gr_operand (operands[1], E_VOIDmode)
      && 
#line 4010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)))
    return gen_split_28 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_gr_operand (operands[0], E_TFmode)
          && general_gr_operand (operands[1], E_TFmode)
          && 
#line 4083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_29 (insn, operands);
      break;

    case E_XFmode:
      if (nonimmediate_gr_operand (operands[0], E_XFmode)
          && general_gr_operand (operands[1], E_XFmode)
          && 
#line 4156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
        return gen_split_30 (insn, operands);
      break;

    case E_DFmode:
      if (nonimmediate_gr_operand (operands[0], E_DFmode)
          && general_gr_operand (operands[1], E_DFmode)
          && 
#line 4334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_31 (insn, operands);
      break;

    default:
      break;
    }
  if (any_fp_register_operand (operands[0], E_VOIDmode)
      && memory_operand (operands[1], E_VOIDmode)
      && 
#line 4602 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode
       || GET_MODE (operands[0]) == SFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
    return gen_split_32 (insn, operands);
  if (fp_register_operand (operands[0], E_SFmode)
      && immediate_operand (operands[1], E_SFmode)
      && 
#line 4626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_34 (insn, operands);
  if (fp_register_operand (operands[0], E_DFmode)
      && immediate_operand (operands[1], E_DFmode)
      && 
#line 4626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return gen_split_35 (insn, operands);
  if (!fp_register_operand (operands[0], E_XFmode)
      || !immediate_operand (operands[1], E_XFmode)
      || !
#line 4626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && (standard_80387_constant_p (operands[1]) == 8
       || standard_80387_constant_p (operands[1]) == 9)))
    return NULL;
  return gen_split_36 (insn, operands);
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      switch (pattern532 (x3))
        {
        case 0:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
   == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_562 (insn, operands);

        case 1:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
   == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_564 (insn, operands);

        case 2:
          if (!
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
   == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_566 (insn, operands);

        case 3:
          if (!(
#line 18175 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
   == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_568 (insn, operands);

        case 4:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_594 (insn, operands);

        case 5:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_596 (insn, operands);

        case 6:
          if (!
#line 18259 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_598 (insn, operands);

        case 7:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_622 (insn, operands);

        case 8:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_624 (insn, operands);

        case 9:
          if (!
#line 18328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_626 (insn, operands);

        case 10:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (QImode) - 1))
  == GET_MODE_BITSIZE (QImode) - 1))
            return NULL;
          return gen_split_578 (insn, operands);

        case 11:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (HImode) - 1))
  == GET_MODE_BITSIZE (HImode) - 1))
            return NULL;
          return gen_split_580 (insn, operands);

        case 12:
          if (!
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1))
  == GET_MODE_BITSIZE (SImode) - 1))
            return NULL;
          return gen_split_582 (insn, operands);

        case 13:
          if (!(
#line 18220 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1))
  == GET_MODE_BITSIZE (DImode) - 1) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 14:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_608 (insn, operands);

        case 15:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_610 (insn, operands);

        case 16:
          if (!
#line 18291 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_612 (insn, operands);

        case 17:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (1 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_636 (insn, operands);

        case 18:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (2 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_638 (insn, operands);

        case 19:
          if (!
#line 18360 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0))
            return NULL;
          return gen_split_640 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      if (XWINT (x5, 0) == 32L
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[1], E_DImode)
          && (
#line 18447 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT) && 
#line 18449 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
        return gen_split_644 (insn, operands);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 18556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD))
            return NULL;
          return gen_split_648 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 18556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed && !optimize_function_for_size_p (cfun)
   && !TARGET_APX_NDD) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_649 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return NULL;
      return gen_split_11 (insn, operands);

    case ZERO_EXTRACT:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) == SUBREG)
        {
          switch (pattern1202 (x4))
            {
            case 0:
              if ((
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 19346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return gen_split_698 (insn, operands);
              break;

            case 1:
              if (((
#line 19344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19346 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return gen_split_699 (insn, operands);
              break;

            default:
              break;
            }
        }
      x7 = XEXP (x5, 2);
      if (GET_CODE (x7) != SUBREG)
        return NULL;
      switch (pattern1204 (x4))
        {
        case 0:
          if (!(
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 19430 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_706 (insn, operands);

        case 1:
          if (!((
#line 19425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 19430 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_707 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (rtx_equal_p (x5, operands[0]))
    {
      x6 = XEXP (x4, 1);
      switch (XWINT (x6, 0))
        {
        case -65536L:
          switch (pattern1306 (x4))
            {
            case 0:
              if (
#line 12862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)))
                return gen_split_259 (insn, operands);
              break;

            case 1:
              if ((
#line 12862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_FAST_PREFIX && !TARGET_PARTIAL_REG_STALL)
    || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_260 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case -256L:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (any_QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_261 (insn, operands);
              break;

            case E_SImode:
              if (any_QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_262 (insn, operands);
              break;

            case E_DImode:
              if (any_QIreg_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && (
#line 12872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_263 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case -65281L:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (QIreg_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode
                  && 
#line 12882 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_264 (insn, operands);
              break;

            case E_SImode:
              if (QIreg_operand (operands[0], E_SImode)
                  && GET_MODE (x4) == E_SImode
                  && 
#line 12882 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed))
                return gen_split_265 (insn, operands);
              break;

            case E_DImode:
              if (QIreg_operand (operands[0], E_DImode)
                  && GET_MODE (x4) == E_DImode
                  && (
#line 12882 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && reload_completed) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return gen_split_266 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x4) != E_HImode
          || !const_int_operand (operands[2], E_HImode))
        return NULL;
      if (QIreg_operand (operands[0], E_HImode)
          && register_operand (operands[1], E_HImode)
          && 
#line 13263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_306 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode)
          || !
#line 13292 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_309 (insn, operands);

    case E_SImode:
      if (GET_MODE (x4) != E_SImode
          || !const_int_operand (operands[2], E_SImode))
        return NULL;
      if (QIreg_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 13263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))))
        return gen_split_307 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 13292 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_310 (insn, operands);

    case E_DImode:
      if (GET_MODE (x4) != E_DImode
          || !const_int_operand (operands[2], E_DImode))
        return NULL;
      if (QIreg_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 13263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~(255 << 8))
    && !(TARGET_APX_NDD && REGNO (operands[0]) != REGNO (operands[1]))) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return gen_split_308 (insn, operands);
      if (!any_QIreg_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode)
          || !(
#line 13292 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
    && (!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
    && !(~INTVAL (operands[2]) & ~255)
    && !(INTVAL (operands[2]) & 128)
    && !(TARGET_APX_NDD
	 && !rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_311 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern300 (x2, 
E_CCmode, 
17) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      res = split_15 (x1, insn);
      if (res != NULL_RTX)
        return res;
      if (GET_CODE (x5) != SUBREG
          || pattern1059 (x4) != 0)
        return NULL;
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      switch (pattern1529 (x3))
        {
        case 0:
          if ((
#line 6995 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6999 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_89 (insn, operands);
          break;

        case 1:
          if ((
#line 6995 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 6999 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_90 (insn, operands);
          break;

        case 2:
          if (((
#line 6995 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6999 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !rtx_equal_p (operands[0], operands[1]))))
            return gen_split_91 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x7;
      switch (pattern1530 (x3))
        {
        case 0:
          if (!(
#line 7028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_92 (insn, operands);

        case 1:
          if (!(
#line 7028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 7030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_93 (insn, operands);

        case 2:
          if (!((
#line 7028 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 7030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_94 (insn, operands);

        case 3:
          if (!
#line 7483 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_105 (insn, operands);

        case 4:
          if (!
#line 7483 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed))
            return NULL;
          return gen_split_106 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern849 (x3))
        {
        case 0:
          if (!((
#line 6511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6513 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_79 (insn, operands);

        case 1:
          if (!((
#line 6511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 6513 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_80 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          switch (pattern1042 (x4))
            {
            case 0:
              if (!((
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            case 1:
              if (!((
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern1045 (x4))
            {
            case 0:
              if (!(
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_168 (insn, operands);

            case 1:
              if (!(
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_169 (insn, operands);

            case 2:
              if (!(
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_170 (insn, operands);

            case 3:
              if (!((
#line 10136 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_171 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern1048 (x4))
            {
            case 0:
              if (!(
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_172 (insn, operands);

            case 1:
              if (!(
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_173 (insn, operands);

            case 2:
              if (!(
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10163 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_174 (insn, operands);

            case 3:
              if (!((
#line 10157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10163 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_175 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      switch (pattern953 (x3))
        {
        case 0:
          if (!((
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_82 (insn, operands);

        case 1:
          if (!((
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_85 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern953 (x3))
        {
        case 0:
          if (!((
#line 6542 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6544 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_83 (insn, operands);

        case 1:
          if (!((
#line 6573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 6575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern309 (x3))
        {
        case 0:
          if (!(
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 1:
          if (!(
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 2:
          if (!(
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10186 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 3:
          if (!((
#line 10183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10186 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_179 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern309 (x3))
        {
        case 0:
          if (!(
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, QImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 1:
          if (!(
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, HImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 2:
          if (!(
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()) && 
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 3:
          if (!((
#line 10204 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10207 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_183 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      switch (pattern853 (x3))
        {
        case 0:
          if (!(
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 1:
          if (!(
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 2:
          if (!(
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 3:
          if (!((
#line 10252 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 4:
          if (!(
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (QImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 5:
          if (!(
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (HImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_193 (insn, operands);

        case 6:
          if (!(
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 10287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 7:
          if (!((
#line 10281 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_195 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (pattern856 (x3))
        {
        case 0:
          if (!
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))
            return NULL;
          return gen_split_755 (insn, operands);

        case 1:
          if (!
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))
            return NULL;
          return gen_split_756 (insn, operands);

        case 2:
          if (!(
#line 23326 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 23328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_758 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !ix86_comparison_operator (operands[1], E_VOIDmode))
        return NULL;
      if (nonimmediate_operand (operands[2], E_HImode)
          && nonimmediate_operand (operands[3], E_HImode)
          && 
#line 26395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return gen_split_778 (insn, operands);
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode)
          || !
#line 26425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL
   && reload_completed))
        return NULL;
      return gen_split_782 (insn, operands);

    case E_SImode:
      if (pattern1078 (x2, 
E_SImode) != 0
          || !
#line 26395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_779 (insn, operands);

    case E_DImode:
      if (pattern1078 (x2, 
E_DImode) != 0
          || !(
#line 26395 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_780 (insn, operands);

    case E_QImode:
      if (pattern1079 (x2) != 0
          || !
#line 26425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL
   && reload_completed))
        return NULL;
      return gen_split_781 (insn, operands);

    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode
          || !nonimmediate_operand (operands[2], E_DFmode)
          || !nonimmediate_operand (operands[3], E_DFmode))
        return NULL;
      if (general_reg_operand (operands[0], E_DFmode)
          && fcmov_comparison_operator (operands[1], E_VOIDmode)
          && 
#line 26641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_783 (insn, operands);
      if (!register_operand (operands[0], E_DFmode)
          || !ix86_comparison_operator (operands[1], E_VOIDmode)
          || !
#line 26675 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_785 (insn, operands);

    case E_SFmode:
      if (pattern1078 (x2, 
E_SFmode) != 0
          || !
#line 26675 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && can_create_pseudo_p ()
   && optimize_insn_for_speed_p ()))
        return NULL;
      return gen_split_784 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_39 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
      operands[1] = x4;
      if (general_reg_operand (operands[1], E_VOIDmode)
          && general_reg_operand (operands[0], E_VOIDmode)
          && 
#line 27765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL && reload_completed
   && (GET_MODE (operands[0]) == HImode
       || (GET_MODE (operands[0]) == QImode && TARGET_PROMOTE_QImode))))
        return gen_split_818 (insn, operands);
      if (general_reg_operand (operands[1], E_V4QImode)
          && general_reg_operand (operands[0], E_V4QImode)
          && GET_MODE (x3) == E_V4QImode
          && 
#line 4557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_863 (insn, operands);
      if (general_reg_operand (operands[1], E_V2QImode)
          && general_reg_operand (operands[0], E_V2QImode)
          && GET_MODE (x3) == E_V2QImode
          && 
#line 4557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_864 (insn, operands);
      if (general_reg_operand (operands[1], E_V2HImode)
          && general_reg_operand (operands[0], E_V2HImode)
          && GET_MODE (x3) == E_V2HImode
          && 
#line 4557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(reload_completed))
        return gen_split_865 (insn, operands);
      if (sse_reg_operand (operands[1], E_V4QImode)
          && sse_reg_operand (operands[0], E_V4QImode)
          && GET_MODE (x3) == E_V4QImode
          && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_866 (insn, operands);
      if (sse_reg_operand (operands[1], E_V2QImode)
          && sse_reg_operand (operands[0], E_V2QImode)
          && GET_MODE (x3) == E_V2QImode
          && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_867 (insn, operands);
      if (sse_reg_operand (operands[1], E_V2HImode)
          && sse_reg_operand (operands[0], E_V2HImode)
          && GET_MODE (x3) == E_V2HImode
          && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2 && reload_completed))
        return gen_split_868 (insn, operands);
      if (mask_reg_operand (operands[1], E_QImode)
          && mask_reg_operand (operands[0], E_QImode)
          && GET_MODE (x3) == E_QImode
          && 
#line 2222 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
        return gen_split_999 (insn, operands);
      if (mask_reg_operand (operands[1], E_HImode)
          && mask_reg_operand (operands[0], E_HImode)
          && GET_MODE (x3) == E_HImode
          && 
#line 2222 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed))
        return gen_split_1000 (insn, operands);
      if (mask_reg_operand (operands[1], E_SImode)
          && mask_reg_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && (
#line 2222 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return gen_split_1001 (insn, operands);
      if (!mask_reg_operand (operands[1], E_DImode)
          || !mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !(
#line 2222 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && reload_completed) && 
#line 2078 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
        return NULL;
      return gen_split_1002 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return NULL;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[3] = x7;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern879 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1168 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1175 (insn, operands);

                case 2:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1177 (insn, operands);

                case 3:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1203 (insn, operands);

                case 4:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1209 (insn, operands);

                default:
                  return NULL;
                }

            case E_QImode:
              switch (pattern880 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1169 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1170 (insn, operands);

                case 2:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1171 (insn, operands);

                case 3:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1172 (insn, operands);

                case 4:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1173 (insn, operands);

                case 5:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1176 (insn, operands);

                case 6:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1178 (insn, operands);

                case 7:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1179 (insn, operands);

                case 8:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1180 (insn, operands);

                case 9:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1181 (insn, operands);

                case 10:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1182 (insn, operands);

                case 11:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1211 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              switch (pattern890 (x3))
                {
                case 0:
                  if (!((
#line 4472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1174 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1205 (insn, operands);

                case 2:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1207 (insn, operands);

                default:
                  return NULL;
                }

            case E_DImode:
              if (pattern891 (x3) != 0
                  || !((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1201 (insn, operands);

            default:
              return NULL;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern985 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1202 (insn, operands);

            case E_HImode:
              switch (pattern971 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1204 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1210 (insn, operands);

                case 2:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1249 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              switch (pattern986 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1206 (insn, operands);

                case 1:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1208 (insn, operands);

                default:
                  return NULL;
                }

            case E_QImode:
              switch (pattern972 (x3))
                {
                case 0:
                  if (!((
#line 4567 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1212 (insn, operands);

                case 1:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1250 (insn, operands);

                case 2:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1251 (insn, operands);

                case 3:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1252 (insn, operands);

                case 4:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1253 (insn, operands);

                case 5:
                  if (!((
#line 4765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4767 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return NULL;
                  return gen_split_1254 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern762 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 4);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return NULL;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return NULL;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return NULL;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return NULL;
  switch (pattern1382 (x2))
    {
    case 0:
      if (!(
#line 12827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1344 (insn, operands);

    case 1:
      if (!(
#line 12827 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1345 (insn, operands);

    case 2:
      if (!(
#line 13067 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1353 (insn, operands);

    case 3:
      if (!(
#line 13067 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1354 (insn, operands);

    case 4:
      if (!(
#line 13067 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1355 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      res = split_52 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 4:
      res = split_53 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 8:
      res = split_54 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case 16:
      if (pattern763 (x3, 
6, 
5, 
4) == 0
          && pattern1363 (x3, 
11, 
10, 
9, 
8, 
7) == 0)
        {
          switch (pattern1623 (x2))
            {
            case 0:
              if (((
#line 13011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1350 (insn, operands);
              break;

            case 1:
              if (((
#line 13011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1351 (insn, operands);
              break;

            case 2:
              if (((
#line 13011 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 1032 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 13020 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
                return gen_split_1352 (insn, operands);
              break;

            case 3:
              if ((
#line 13181 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
                return gen_split_1357 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case 32:
      if (pattern765 (x3, 
11, 
10, 
9, 
8) == 0
          && pattern1536 (x3, 
15, 
14, 
13, 
12, 
16) == 0
          && pattern1642 (x3, 
21, 
20, 
19, 
18, 
17) == 0
          && pattern1687 (x3, 
26, 
25, 
24, 
23, 
22) == 0)
        {
          x4 = XVECEXP (x3, 0, 27);
          if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 27]
              && pattern1704 (x3, 
31, 
30, 
29, 
28) == 0
              && nonimmediate_operand (operands[0], E_V32QImode)
              && GET_MODE (x2) == E_V32QImode
              && nonimmediate_operand (operands[1], E_V64QImode)
              && (
#line 13113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1])))))
            return gen_split_1356 (insn, operands);
        }
      break;

    default:
      break;
    }
  if (XVECLEN (x3, 0) < 1)
    return NULL;
  operands[2] = x3;
  if (!avx_vbroadcast_operand (operands[2], E_VOIDmode))
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !(
#line 27379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V8SFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3453 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !(
#line 27379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX
   && (V4DFmode != V4DFmode || !TARGET_AVX2 || operands[3] == const0_rtx)) && 
#line 27382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_3454 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern467 (x2))
        {
        case 0:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1440 (insn, operands);

        case 1:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1467 (insn, operands);

        case 2:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1494 (insn, operands);

        case 3:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 4:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1548 (insn, operands);

        case 5:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1575 (insn, operands);

        case 6:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1602 (insn, operands);

        case 7:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1629 (insn, operands);

        case 8:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1656 (insn, operands);

        case 9:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1683 (insn, operands);

        case 10:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1710 (insn, operands);

        case 11:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1737 (insn, operands);

        case 12:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1443 (insn, operands);

        case 13:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1470 (insn, operands);

        case 14:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1497 (insn, operands);

        case 15:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 16:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1551 (insn, operands);

        case 17:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1578 (insn, operands);

        case 18:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1605 (insn, operands);

        case 19:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1632 (insn, operands);

        case 20:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1659 (insn, operands);

        case 21:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1686 (insn, operands);

        case 22:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1713 (insn, operands);

        case 23:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1740 (insn, operands);

        case 24:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1446 (insn, operands);

        case 25:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1473 (insn, operands);

        case 26:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1500 (insn, operands);

        case 27:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 28:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1554 (insn, operands);

        case 29:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1581 (insn, operands);

        case 30:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1608 (insn, operands);

        case 31:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1635 (insn, operands);

        case 32:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1662 (insn, operands);

        case 33:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1689 (insn, operands);

        case 34:
          if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1716 (insn, operands);

        case 35:
          if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1743 (insn, operands);

        case 36:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2736 (insn, operands);

        case 37:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2745 (insn, operands);

        case 38:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2754 (insn, operands);

        case 39:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2763 (insn, operands);

        case 40:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2772 (insn, operands);

        case 41:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2781 (insn, operands);

        case 42:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2790 (insn, operands);

        case 43:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case 44:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2808 (insn, operands);

        case 45:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2817 (insn, operands);

        case 46:
          if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2826 (insn, operands);

        case 47:
          if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2835 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2088 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2115 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2142 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2169 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2196 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2223 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2250 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2277 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2304 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2331 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2358 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2385 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern469 (x2))
        {
        case 0:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2091 (insn, operands);

        case 1:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2118 (insn, operands);

        case 2:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2145 (insn, operands);

        case 3:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2172 (insn, operands);

        case 4:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2199 (insn, operands);

        case 5:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2226 (insn, operands);

        case 6:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2253 (insn, operands);

        case 7:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2280 (insn, operands);

        case 8:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2307 (insn, operands);

        case 9:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2334 (insn, operands);

        case 10:
          if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2361 (insn, operands);

        case 11:
          if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2388 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern1069 (x2, 
E_V64QImode) != 0
              || !((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2094 (insn, operands);

        case E_V32QImode:
          if (pattern903 (x2, 
E_V32QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V32QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V32QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V32QImode)
                  && ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2121 (insn, operands);
            }
          if (!register_operand (operands[1], E_V32QImode)
              || !register_operand (operands[2], E_V32QImode)
              || !nonimmediate_operand (operands[3], E_V32QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3420 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3436 (insn, operands);

        case E_V16QImode:
          if (pattern903 (x2, 
E_V16QImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16QImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16QImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16QImode)
                  && (
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2148 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !nonimmediate_operand (operands[3], E_V16QImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3421 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3437 (insn, operands);

        case E_V32HImode:
          if (pattern1069 (x2, 
E_V32HImode) != 0
              || !((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2175 (insn, operands);

        case E_V16HImode:
          if (pattern903 (x2, 
E_V16HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V16HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V16HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V16HImode)
                  && ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2202 (insn, operands);
            }
          if (!register_operand (operands[1], E_V16HImode)
              || !register_operand (operands[2], E_V16HImode)
              || !nonimmediate_operand (operands[3], E_V16HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3422 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3438 (insn, operands);

        case E_V8HImode:
          if (pattern903 (x2, 
E_V8HImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8HImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8HImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8HImode)
                  && (
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2229 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !nonimmediate_operand (operands[3], E_V8HImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3423 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3439 (insn, operands);

        case E_V16SImode:
          if (pattern1069 (x2, 
E_V16SImode) != 0
              || !((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2256 (insn, operands);

        case E_V8SImode:
          if (pattern903 (x2, 
E_V8SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V8SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V8SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V8SImode)
                  && ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2283 (insn, operands);
            }
          if (!register_operand (operands[1], E_V8SImode)
              || !register_operand (operands[2], E_V8SImode)
              || !nonimmediate_operand (operands[3], E_V8SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3424 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3440 (insn, operands);

        case E_V4SImode:
          if (pattern903 (x2, 
E_V4SImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4SImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4SImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4SImode)
                  && (
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2310 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !nonimmediate_operand (operands[3], E_V4SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3425 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3441 (insn, operands);

        case E_V8DImode:
          if (pattern1069 (x2, 
E_V8DImode) != 0
              || !((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2337 (insn, operands);

        case E_V4DImode:
          if (pattern903 (x2, 
E_V4DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V4DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V4DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V4DImode)
                  && ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2364 (insn, operands);
            }
          if (!register_operand (operands[1], E_V4DImode)
              || !register_operand (operands[2], E_V4DImode)
              || !nonimmediate_operand (operands[3], E_V4DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3426 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3442 (insn, operands);

        case E_V2DImode:
          if (pattern903 (x2, 
E_V2DImode) != 0)
            return NULL;
          if (regmem_or_bitnot_regmem_operand (operands[1], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[2], E_V2DImode)
              && regmem_or_bitnot_regmem_operand (operands[3], E_V2DImode))
            {
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              if (regmem_or_bitnot_regmem_operand (operands[4], E_V2DImode)
                  && (
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return gen_split_2391 (insn, operands);
            }
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !nonimmediate_operand (operands[3], E_V2DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3427 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3443 (insn, operands);

        case E_V2TImode:
          if (pattern1070 (x2, 
E_V2TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3428 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3444 (insn, operands);

        case E_V1TImode:
          if (pattern1070 (x2, 
E_V1TImode) != 0)
            return NULL;
          x8 = XEXP (x2, 1);
          if (rtx_equal_p (x8, operands[1])
              && 
#line 26216 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return gen_split_3429 (insn, operands);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 26228 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return NULL;
          return gen_split_3445 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = split_58 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
      res = split_65 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          res = split_60 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          res = split_61 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case XOR:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
            case MEM:
            case NOT:
              switch (pattern467 (x2))
                {
                case 0:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1458 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1485 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1512 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1539 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1566 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1593 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1620 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1647 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1674 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1701 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1728 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1755 (insn, operands);
                  break;

                case 12:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1461 (insn, operands);
                  break;

                case 13:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1488 (insn, operands);
                  break;

                case 14:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1515 (insn, operands);
                  break;

                case 15:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1542 (insn, operands);
                  break;

                case 16:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1569 (insn, operands);
                  break;

                case 17:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1596 (insn, operands);
                  break;

                case 18:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1623 (insn, operands);
                  break;

                case 19:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1650 (insn, operands);
                  break;

                case 20:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1677 (insn, operands);
                  break;

                case 21:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1704 (insn, operands);
                  break;

                case 22:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1731 (insn, operands);
                  break;

                case 23:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1758 (insn, operands);
                  break;

                case 24:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1464 (insn, operands);
                  break;

                case 25:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1491 (insn, operands);
                  break;

                case 26:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1518 (insn, operands);
                  break;

                case 27:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1545 (insn, operands);
                  break;

                case 28:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1572 (insn, operands);
                  break;

                case 29:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1599 (insn, operands);
                  break;

                case 30:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1626 (insn, operands);
                  break;

                case 31:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1653 (insn, operands);
                  break;

                case 32:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1680 (insn, operands);
                  break;

                case 33:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1707 (insn, operands);
                  break;

                case 34:
                  if (((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1734 (insn, operands);
                  break;

                case 35:
                  if ((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_1761 (insn, operands);
                  break;

                case 36:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2742 (insn, operands);
                  break;

                case 37:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2751 (insn, operands);
                  break;

                case 38:
                  if ((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2760 (insn, operands);
                  break;

                case 39:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2769 (insn, operands);
                  break;

                case 40:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2778 (insn, operands);
                  break;

                case 41:
                  if ((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2787 (insn, operands);
                  break;

                case 42:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2796 (insn, operands);
                  break;

                case 43:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2805 (insn, operands);
                  break;

                case 44:
                  if ((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2814 (insn, operands);
                  break;

                case 45:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2823 (insn, operands);
                  break;

                case 46:
                  if (((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2832 (insn, operands);
                  break;

                case 47:
                  if ((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2841 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2133 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2160 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2187 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2214 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2241 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2268 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2295 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2322 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2349 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2376 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2403 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case IOR:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2109 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2136 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2163 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2190 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2217 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2244 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2271 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2298 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2325 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2352 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2379 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2406 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case XOR:
              switch (pattern469 (x2))
                {
                case 0:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2112 (insn, operands);
                  break;

                case 1:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2139 (insn, operands);
                  break;

                case 2:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2166 (insn, operands);
                  break;

                case 3:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2193 (insn, operands);
                  break;

                case 4:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2220 (insn, operands);
                  break;

                case 5:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2247 (insn, operands);
                  break;

                case 6:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2274 (insn, operands);
                  break;

                case 7:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2301 (insn, operands);
                  break;

                case 8:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2328 (insn, operands);
                  break;

                case 9:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2355 (insn, operands);
                  break;

                case 10:
                  if (((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2382 (insn, operands);
                  break;

                case 11:
                  if ((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                    return gen_split_2409 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
        case VEC_DUPLICATE:
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern845 (x2, 
E_V16SImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3102 (insn, operands);
              break;

            case E_V8DImode:
              if (pattern845 (x2, 
E_V8DImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3103 (insn, operands);
              break;

            case E_V64QImode:
              if (pattern845 (x2, 
E_V64QImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3104 (insn, operands);
              break;

            case E_V32QImode:
              if (pattern845 (x2, 
E_V32QImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3105 (insn, operands);
              break;

            case E_V16QImode:
              if (pattern845 (x2, 
E_V16QImode) == 0
                  && (
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || QImode == SImode
       || QImode == DImode)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3106 (insn, operands);
              break;

            case E_V32HImode:
              if (pattern845 (x2, 
E_V32HImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (64 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3107 (insn, operands);
              break;

            case E_V16HImode:
              if (pattern845 (x2, 
E_V16HImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3108 (insn, operands);
              break;

            case E_V8HImode:
              if (pattern845 (x2, 
E_V8HImode) == 0
                  && (
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || HImode == SImode
       || HImode == DImode)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3109 (insn, operands);
              break;

            case E_V8SImode:
              if (pattern845 (x2, 
E_V8SImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3110 (insn, operands);
              break;

            case E_V4SImode:
              if (pattern845 (x2, 
E_V4SImode) == 0
                  && (
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || SImode == SImode
       || SImode == DImode)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3111 (insn, operands);
              break;

            case E_V4DImode:
              if (pattern845 (x2, 
E_V4DImode) == 0
                  && ((
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (32 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3112 (insn, operands);
              break;

            case E_V2DImode:
              if (pattern845 (x2, 
E_V2DImode) == 0
                  && (
#line 18344 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (16 == 64 || TARGET_AVX512VL || TARGET_EVEX512)
   && (!false
       || DImode == SImode
       || DImode == DImode)) && 
#line 18355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( reload_completed && !REG_P (operands[1]) && !false
   && optimize_insn_for_speed_p ())))
                return gen_split_3113 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x3) == VEC_DUPLICATE)
            {
              switch (pattern543 (x2))
                {
                case 0:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3146 (insn, operands);
                  break;

                case 1:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return gen_split_3147 (insn, operands);
                  break;

                case 2:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3148 (insn, operands);
                  break;

                case 3:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3149 (insn, operands);
                  break;

                case 4:
                  if (
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3150 (insn, operands);
                  break;

                case 5:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return gen_split_3151 (insn, operands);
                  break;

                case 6:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3152 (insn, operands);
                  break;

                case 7:
                  if (
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3153 (insn, operands);
                  break;

                case 8:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3154 (insn, operands);
                  break;

                case 9:
                  if (
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3155 (insn, operands);
                  break;

                case 10:
                  if ((
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return gen_split_3156 (insn, operands);
                  break;

                case 11:
                  if (
#line 18649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
                    return gen_split_3157 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern186 ())
    {
    case 0:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1426 (insn, operands);
      break;

    case 1:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1427 (insn, operands);
      break;

    case 2:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1428 (insn, operands);
      break;

    case 3:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1429 (insn, operands);
      break;

    case 4:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1430 (insn, operands);
      break;

    case 5:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1431 (insn, operands);
      break;

    case 6:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1432 (insn, operands);
      break;

    case 7:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1433 (insn, operands);
      break;

    case 8:
      if ((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1434 (insn, operands);
      break;

    case 9:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1435 (insn, operands);
      break;

    case 10:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1436 (insn, operands);
      break;

    case 11:
      if (((
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13737 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
        return gen_split_1437 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case AND:
      return split_68 (x1, insn);

    case IOR:
      return split_67 (x1, insn);

    case XOR:
      return split_66 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MINUS
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x5) != E_CCmode)
        return NULL;
      x8 = XEXP (x5, 1);
      operands[1] = x8;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return NULL;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || !general_gr_operand (operands[1], E_QImode)
              || GET_MODE (x7) != E_QImode
              || !
#line 8688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_62 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || !general_gr_operand (operands[1], E_HImode)
              || GET_MODE (x7) != E_HImode
              || !
#line 8688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_63 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || !general_gr_operand (operands[1], E_SImode)
              || GET_MODE (x7) != E_SImode
              || !
#line 8688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_64 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || !general_gr_operand (operands[1], E_DImode)
              || GET_MODE (x7) != E_DImode
              || !(
#line 8688 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(find_regno_note (peep2_next_insn (0), REG_UNUSED, REGNO (operands[0])) != 0) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_65 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      if (GET_CODE (x12) != PLUS)
        return NULL;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != PLUS)
        return NULL;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case LTU:
        case UNLT:
          operands[4] = x14;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != PLUS)
            return NULL;
          x16 = XEXP (x8, 0);
          switch (GET_CODE (x16))
            {
            case LTU:
            case UNLT:
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x18 = XEXP (x8, 1);
              if (GET_CODE (x18) != ZERO_EXTEND)
                return NULL;
              x7 = XEXP (x4, 1);
              if (GET_CODE (x7) != PLUS)
                return NULL;
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != PLUS)
                return NULL;
              x19 = XEXP (x9, 0);
              switch (GET_CODE (x19))
                {
                case LTU:
                case UNLT:
                  if (!rtx_equal_p (x19, operands[4])
                      || GET_MODE (x3) != E_CCCmode
                      || GET_MODE (x5) != E_CCCmode)
                    return NULL;
                  x20 = XEXP (x14, 0);
                  operands[2] = x20;
                  if (!flags_reg_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x21 = XEXP (x13, 1);
                  operands[0] = x21;
                  x22 = XEXP (x12, 1);
                  operands[1] = x22;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2]))
                    return NULL;
                  x24 = XEXP (x18, 0);
                  if (!rtx_equal_p (x24, operands[1]))
                    return NULL;
                  x25 = XEXP (x9, 1);
                  if (!rtx_equal_p (x25, operands[0]))
                    return NULL;
                  x10 = XEXP (x7, 1);
                  if (!rtx_equal_p (x10, operands[1]))
                    return NULL;
                  x11 = XEXP (x4, 0);
                  if (!rtx_equal_p (x11, operands[0]))
                    return NULL;
                  x26 = PATTERN (peep2_next_insn (1));
                  if (GET_CODE (x26) != SET)
                    return NULL;
                  switch (GET_MODE (x6))
                    {
                    case E_DImode:
                      switch (pattern1705 (x1, 
E_SImode, 
E_DImode))
                        {
                        case 0:
                          if (!
#line 9089 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_82 (insn, operands);

                        case 1:
                          if (!
#line 9183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_86 (insn, operands);

                        default:
                          return NULL;
                        }

                    case E_TImode:
                      switch (pattern1705 (x1, 
E_DImode, 
E_TImode))
                        {
                        case 0:
                          if (!(
#line 9089 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 1;
                          return gen_peephole2_83 (insn, operands);

                        case 1:
                          if (!(
#line 9183 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && peep2_reg_dead_p (4, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[5])
   && !reg_overlap_mentioned_p (operands[5], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[6])
   && !reg_overlap_mentioned_p (operands[6], operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            return NULL;
                          *pmatch_len_ = 3;
                          return gen_peephole2_87 (insn, operands);

                        default:
                          return NULL;
                        }

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      if (peep2_current_count < 2)
        return NULL;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      x27 = XEXP (x6, 1);
      operands[1] = x27;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      x26 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x26) != SET)
        return NULL;
      x28 = XEXP (x26, 1);
      if (!rtx_equal_p (x28, operands[0]))
        return NULL;
      x29 = XEXP (x26, 0);
      if (!rtx_equal_p (x29, operands[1]))
        return NULL;
      if (GET_CODE (x6) == PLUS)
        {
          res = peephole2_41 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x6;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return NULL;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!plusminuslogic_operator (operands[2], E_QImode)
              || !register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_QImode)
              || !
#line 28221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_289 (insn, operands);

        case E_HImode:
          if (!plusminuslogic_operator (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_HImode)
              || !
#line 28221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_290 (insn, operands);

        case E_SImode:
          if (!plusminuslogic_operator (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode)
              || !
#line 28221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_291 (insn, operands);

        case E_DImode:
          if (!plusminuslogic_operator (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode)
              || !(
#line 28221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_READ_MODIFY_WRITE || optimize_insn_for_size_p ())
   && COMMUTATIVE_ARITH_P (operands[2])
   && peep2_reg_dead_p (2, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && ix86_match_ccmode (peep2_next_insn (0),
			 GET_CODE (operands[2]) == PLUS
			 ? CCGOCmode : CCNOmode)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_292 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
