/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_mmxmem_operand (operands[1], i1)
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case VEC_CONCAT:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (XVECLEN (x3, 0))
        {
        case 8:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XVECEXP (x3, 0, 4);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x3, 0, 5);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XVECEXP (x3, 0, 7);
          if (GET_CODE (x15) != CONST_INT
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || GET_MODE (x5) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode)
              || !register_mmxmem_operand (operands[2], E_V8QImode))
            return -1;
          switch (XWINT (x8, 0))
            {
            case 4L:
              if (XWINT (x9, 0) != 12L
                  || XWINT (x10, 0) != 5L
                  || XWINT (x11, 0) != 13L
                  || XWINT (x12, 0) != 6L
                  || XWINT (x13, 0) != 14L
                  || XWINT (x14, 0) != 7L
                  || XWINT (x15, 0) != 15L)
                return -1;
              return 1;

            case 0L:
              if (XWINT (x9, 0) != 8L
                  || XWINT (x10, 0) != 1L
                  || XWINT (x11, 0) != 9L
                  || XWINT (x12, 0) != 2L
                  || XWINT (x13, 0) != 10L
                  || XWINT (x14, 0) != 3L
                  || XWINT (x15, 0) != 11L)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 4:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 2L:
              if (XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              res = pattern12 (x2);
              if (res >= 0)
                return res + 3; /* [3, 4] */
              return -1;

            case 0L:
              if (XWINT (x9, 0) != 4L
                  || XWINT (x10, 0) != 1L
                  || XWINT (x11, 0) != 5L)
                return -1;
              res = pattern12 (x2);
              if (res >= 0)
                return res + 5; /* [5, 6] */
              return -1;

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          return 7;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 46
          || GET_MODE (x5) != E_V4SImode
          || XVECLEN (x3, 0) != 2)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      x16 = XVECEXP (x5, 0, 0);
      operands[1] = x16;
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case FIX:
      if (GET_MODE (x5) != E_V4SImode
          || XVECLEN (x3, 0) != 2
          || pattern13 (x2, 
E_V4SFmode, 
E_V2SImode, 
1) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_mmxmem_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V8HImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 4)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_CONCAT
      || GET_MODE (x11) != E_V8HImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 4)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x12, 0, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x15 = XVECEXP (x12, 0, 2);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x16 = XVECEXP (x12, 0, 3);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x17 = XEXP (x1, 0);
  operands[0] = x17;
  if (!register_operand (operands[0], E_V4HImode)
      || pattern55 (x2) != 0)
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case VEC_CONCAT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != VEC_CONCAT)
        return -1;
      res = pattern53 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  return pattern99 (x1); /* [-1, 1] */
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 49
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  switch (GET_MODE (x3))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern119 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern119 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern119 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern119 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern119 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern119 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i3))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern146 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern146 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern146 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern144 (x3, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern144 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern144 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!vector_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern163 (x3, 
E_V8SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern163 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V16SImode:
      if (pattern163 (x3, 
E_V16SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern182 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern186 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || !ternlog_operand (operands[1], E_V32HFmode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || !ternlog_operand (operands[1], E_V16HFmode))
        return -1;
      return 1;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || !ternlog_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || !ternlog_operand (operands[1], E_V32BFmode))
        return -1;
      return 3;

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || !ternlog_operand (operands[1], E_V16BFmode))
        return -1;
      return 4;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || !ternlog_operand (operands[1], E_V8BFmode))
        return -1;
      return 5;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || !ternlog_operand (operands[1], E_V16SFmode))
        return -1;
      return 6;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !ternlog_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !ternlog_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || !ternlog_operand (operands[1], E_V8DFmode))
        return -1;
      return 9;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !ternlog_operand (operands[1], E_V4DFmode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !ternlog_operand (operands[1], E_V2DFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern202 (x6, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern202 (x6, 
E_TImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern202 (x6, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (pattern202 (x6, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_SImode:
      if (pattern202 (x6, 
E_SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != COMPARE
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != MEM
      || GET_MODE (x8) != E_BLKmode)
    return -1;
  x9 = XEXP (x3, 2);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 17
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != USE)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x4, 0);
  operands[6] = x15;
  return 0;
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[2] = x2;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 0;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  return pattern249 (x6); /* [-1, 1] */
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern257 (x1); /* [-1, 2] */

    case E_DImode:
      res = pattern258 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_mmxmem_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_to_255_mul_8_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern274 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != VEC_SELECT)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x7, 0);
  operands[2] = x10;
  x11 = XEXP (x1, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[4] = x12;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 8:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x5, 0, 4);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x18 = XVECEXP (x5, 0, 5);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x19 = XVECEXP (x5, 0, 6);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x20 = XVECEXP (x5, 0, 7);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x8, 0) != 8)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x25 = XVECEXP (x8, 0, 4);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x26 = XVECEXP (x8, 0, 5);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x27 = XVECEXP (x8, 0, 6);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x28 = XVECEXP (x8, 0, 7);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern273 (x1, 
E_V8DImode, 
E_V16SImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case 4:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x5, 0, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x16 = XVECEXP (x5, 0, 3);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x8, 0) != 4)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x23 = XVECEXP (x8, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x24 = XVECEXP (x8, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern273 (x1, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case 2:
      x13 = XVECEXP (x5, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x8, 0) != 2)
        return -1;
      x21 = XVECEXP (x8, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x8, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2DImode
          || GET_MODE (x3) != E_V2DImode
          || GET_MODE (x4) != E_V2SImode
          || !vector_operand (operands[1], E_V4SImode)
          || GET_MODE (x6) != E_V2DImode
          || GET_MODE (x7) != E_V2SImode
          || !vector_operand (operands[2], E_V4SImode)
          || !nonimm_or_0_operand (operands[3], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern307 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern307 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern308 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern308 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 110)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern325 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern329 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  return 0;
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern331 (x6, 
37); /* [-1, 0] */
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case STRICT_LOW_PART:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!memory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !immediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern389 (x1); /* [-1, 1] */

    case PLUS:
      res = pattern389 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern19 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern395 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern395 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern395 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern419 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern429 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern428 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern428 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern428 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern428 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern428 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern428 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern428 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern428 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern428 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case VEC_SELECT:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL)
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (XVECLEN (x7, 0))
        {
        case 4:
          x10 = XVECEXP (x7, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XVECEXP (x7, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XVECEXP (x7, 0, 2);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x13 = XVECEXP (x7, 0, 3);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V4HFmode
              || GET_MODE (x3) != E_V4HFmode
              || GET_MODE (x6) != E_V4HFmode
              || !nonimm_or_0_operand (operands[2], E_V8HFmode))
            return -1;
          return pattern435 (); /* [-1, 1] */

        case 2:
          res = pattern437 (x1, 
E_V2DImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[3] = x6;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_V4HFmode:
              if (GET_MODE (x3) != E_V4HFmode
                  || !const0_operand (operands[3], E_V4HFmode))
                return -1;
              res = pattern435 ();
              if (res >= 0)
                return res + 4; /* [4, 5] */
              return -1;

            case E_V2HFmode:
              if (pattern438 (x3, 
E_V2DImode) != 0)
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_V4SFmode:
          if (pattern439 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern466 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern464 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern464 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern464 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern464 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern464 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern464 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern464 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern464 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern464 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern464 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern464 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern464 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern477 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_XFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_XFmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_XFmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 110)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SFmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern492 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1)
    return -1;
  return 0;
}

int
pattern498 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XEXP (x1, 1);
      return pattern497 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XEXP (x1, 1);
      if (pattern497 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_hilo_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern511 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern515 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode)
    return -1;
  return 0;
}

int
pattern518 (machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[3], i2)
      || !nonimmediate_operand (operands[4], i1)
      || !scratch_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern526 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x13))
    {
    case UNSPEC:
      return pattern523 (x1); /* [-1, 0] */

    case USE:
      res = pattern525 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern536 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0))
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != i1
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != SUBREG
          || maybe_ne (SUBREG_BYTE (x13), 0)
          || GET_MODE (x13) != E_QImode)
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != ZERO_EXTRACT)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x15, 2);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x18 = XEXP (x2, 0);
          operands[4] = x18;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode))
            return -1;
          return pattern535 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern560 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern568 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HImode:
      return pattern567 (x1, 
E_V32HImode, 
E_SImode, 
i1); /* [-1, 0] */

    case E_V16HImode:
      if (pattern567 (x1, 
E_V16HImode, 
E_HImode, 
i2) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern567 (x1, 
E_V8HImode, 
E_QImode, 
i3) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!vector_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8DFmode:
      if (!vector_operand (operands[1], E_V8DFmode))
        return -1;
      return 1;

    case E_V8SFmode:
      if (!vector_operand (operands[1], E_V8SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[4] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          return pattern580 (x1, 
E_V32HFmode, 
E_SImode); /* [-1, 0] */

        case E_V16HFmode:
          if (pattern580 (x1, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern580 (x1, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V16SFmode:
          if (pattern580 (x1, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_V8SFmode:
          if (pattern580 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern580 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        case E_V8DFmode:
          if (pattern580 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 6;

        case E_V4DFmode:
          if (pattern580 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V2DFmode:
          if (pattern580 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case CONST_INT:
      res = pattern582 (x1);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern603 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  return pattern608 (x2); /* [-1, 0] */
}

int
pattern613 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (XVECLEN (x7, 0))
    {
    case 8:
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x7, 0, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x7, 0, 3);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x7, 0, 4);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x7, 0, 5);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x14 = XVECEXP (x7, 0, 6);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x15 = XVECEXP (x7, 0, 7);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return pattern473 (x1); /* [-1, 2] */

    case 4:
      res = pattern611 (x1, 
E_V8HImode, 
E_V4HImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case 2:
      if (pattern612 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 17
          || GET_MODE (x7) != E_CCmode)
        return -1;
      return pattern634 (x3); /* [-1, 1] */

    case CONST_INT:
      operands[2] = x4;
      if (!const_0_to_255_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern629 (x1);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!memory_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  return pattern520 (x3); /* [-1, 2] */
}

int
pattern656 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern211 (x6, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (GET_MODE (x6) != E_SFmode)
        return -1;
      return 1;

    case E_DFmode:
      if (GET_MODE (x6) != E_DFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern665 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || !general_reg_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      return 0;

    case PARALLEL:
      return 1;

    default:
      return -1;
    }
}

int
pattern672 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern678 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern684 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern690 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern689 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern689 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern698 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SImode)
          || !const0_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SImode)
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DImode)
          || !const0_operand (operands[2], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !const0_operand (operands[2], E_V32QImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const0_operand (operands[2], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern716 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern723 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x2, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern722 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern722 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern722 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern722 (x1, 
E_V32HImode, 
E_SImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern722 (x1, 
E_V16HImode, 
E_HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern722 (x1, 
E_V8HImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern722 (x1, 
E_V16SImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern722 (x1, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern722 (x1, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern722 (x1, 
E_V8DImode, 
E_QImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern722 (x1, 
E_V4DImode, 
E_QImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern722 (x1, 
E_V2DImode, 
E_QImode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern722 (x1, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      if (pattern722 (x1, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      if (pattern722 (x1, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      return 14;

    case E_V32BFmode:
      if (pattern722 (x1, 
E_V32BFmode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_V16BFmode:
      if (pattern722 (x1, 
E_V16BFmode, 
E_HImode) != 0)
        return -1;
      return 16;

    case E_V8BFmode:
      if (pattern722 (x1, 
E_V8BFmode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V16SFmode:
      if (pattern722 (x1, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern722 (x1, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4SFmode:
      if (pattern722 (x1, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern722 (x1, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern722 (x1, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V2DFmode:
      if (pattern722 (x1, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern765 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern764 (x1, 
i1, 
i2, 
i3, 
i4) != 0)
    return -1;
  return 0;
}

int
pattern774 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V4QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != EQ
      || GET_MODE (x3) != E_V2HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != EQ
      || GET_MODE (x4) != E_V2HImode
      || !register_operand (operands[0], E_V4QImode)
      || GET_MODE (x1) != E_V4QImode
      || !register_operand (operands[1], E_V4QImode)
      || !register_operand (operands[2], E_V4QImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!nonmemory_operand (operands[4], E_V2HImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  if (!const0_operand (operands[5], E_V2HImode))
    return -1;
  return 0;
}

int
pattern786 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern791 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern800 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern808 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!nonimmediate_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!nonimmediate_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern819 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern824 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const_4_or_8_to_11_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      if (XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 223
          || GET_MODE (x7) != E_SImode
          || !register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || GET_MODE (x2) != E_V32HFmode
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !register_operand (operands[2], E_V32HFmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      if (!nonimm_or_0_operand (operands[3], E_V32HFmode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[4] = x9;
      if (!register_operand (operands[4], E_HImode))
        return -1;
      operands[5] = x6;
      return 0;

    case CONST_INT:
      if (XWINT (x7, 0) != 3L
          || !register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V8HFmode
          || GET_MODE (x3) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !register_operand (operands[2], E_V8HFmode))
        return -1;
      operands[3] = x6;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern841 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  return 0;
}

int
pattern861 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_QImode:
      return pattern859 (x4, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern859 (x4, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern860 (x4, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern860 (x4, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern874 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern879 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[2], E_V16HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[2], E_V16SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !nonimmediate_operand (operands[2], E_V16QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 3;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern889 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_DImode
          || !nonimm_or_0_operand (operands[1], E_V64QImode)
          || !nonimm_or_0_operand (operands[2], E_V64QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!nonimm_or_0_operand (operands[1], E_V32QImode)
              || !nonimm_or_0_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!nonimm_or_0_operand (operands[1], E_V32HImode)
              || !nonimm_or_0_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern901 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 2);
  if (!register_operand (x3, i1))
    return -1;
  return 0;
}

int
pattern909 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i2)
      || !const0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !vector_all_ones_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern926 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_4_or_8_to_11_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern935 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern942 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      return pattern941 (x1); /* [-1, 0] */

    default:
      return -1;
    }
}

int
pattern949 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern948 (x3, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern948 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern948 (x3, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern958 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[1], E_XFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern479 (x5); /* [-1, 2] */
}

int
pattern963 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !general_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !x86_64_general_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern973 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern983 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern993 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern997 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern1004 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1010 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1016 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !vector_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern1014 (x4, 
i1, 
i2, 
i3, 
i4); /* [-1, 0] */
}

int
pattern1024 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V32HFmode
      || !register_operand (operands[0], E_V32HFmode)
      || GET_MODE (x1) != E_V32HFmode
      || !register_operand (operands[1], E_V32HFmode)
      || !register_operand (operands[2], E_V32HFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  if (!register_operand (operands[3], E_V32HFmode)
      || !const_4_or_8_to_11_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern1032 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !palignr_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1038 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 3);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1037 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1037 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1048 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1046 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1046 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1047 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1047 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1062 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != STRICT_LOW_PART)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  return pattern323 (x4); /* [-1, 1] */
}

int
pattern1069 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[4] = x4;
  if (!regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1078 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ix86_comparison_operator (operands[1], E_VOIDmode)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1083 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1090 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1098 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        case E_V2DFmode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x3;
      x4 = XEXP (x2, 2);
      operands[5] = x4;
      x5 = XEXP (x1, 1);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 3;

        case E_V4SFmode:
          return 4;

        case E_V2DFmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1111 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_0_to_31_operand (operands[3], E_QImode)
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!nonimmediate_operand (operands[4], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_0_to_31_operand (operands[2], E_QImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[1] = x7;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern1121 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern1126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      return pattern1125 (x1); /* [-1, 2] */

    default:
      return -1;
    }
}

int
pattern1147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case STRICT_LOW_PART:
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!extract_operator (operands[3], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!extract_operator (operands[3], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!extract_operator (operands[3], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1175 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1185 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8HFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      x9 = XEXP (x3, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      switch (XWINT (x4, 0))
        {
        case 64L:
          return pattern1207 (x1, 
E_DImode); /* [-1, 0] */

        case 32L:
          if (pattern1207 (x1, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
      if (pattern1117 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!extract_operator (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_0_to_63_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1253 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!bcst_vector_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !bcst_vector_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1260 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !bcst_vector_operand (operands[1], i1)
      || pattern1247 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern1280 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern1280 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern1280 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 12);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x3 = XVECEXP (x1, 0, 13);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x5 = XVECEXP (x1, 0, 15);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

int
pattern1298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_SImode
          || !const_int_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || !const_int_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1326 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vector_operand (operands[1], i2)
      || !vector_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1336 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1344 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V4HFmode:
      if (!memory_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4BFmode:
      if (!memory_operand (operands[1], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (maybe_ne (SUBREG_BYTE (x1), 0)
      || GET_MODE (x1) != E_QImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  return pattern1128 (x2); /* [-1, 2] */
}

int
pattern1370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1391 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1408 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  switch (GET_CODE (x13))
    {
    case SIGN_EXTEND:
      x14 = XEXP (x13, 0);
      operands[2] = x14;
      x15 = XEXP (x8, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          return pattern1414 (x1, 
E_QImode, 
E_HImode); /* [-1, 0] */

        case E_SImode:
          if (pattern1414 (x1, 
E_HImode, 
E_SImode) != 0)
            return -1;
          return 1;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x13) != E_DImode
              || !x86_64_sext_operand (operands[2], E_SImode)
              || pattern651 (x1, 
E_SImode, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_TImode:
          if (GET_MODE (x5) != E_TImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x13) != E_TImode
              || pattern651 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 3;

        case E_POImode:
          if (pattern652 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x13;
      x15 = XEXP (x8, 1);
      operands[2] = x15;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern1415 (x1, 
E_QImode, 
E_HImode) != 0)
            return -1;
          return 5;

        case E_SImode:
          if (pattern1415 (x1, 
E_HImode, 
E_SImode) != 0)
            return -1;
          return 6;

        case E_DImode:
          if (pattern1415 (x1, 
E_SImode, 
E_DImode) != 0)
            return -1;
          return 7;

        case E_TImode:
          if (GET_MODE (x5) != E_TImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || pattern651 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 8;

        case E_POImode:
          if (pattern653 (x1, 
E_TImode, 
E_POImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i2)
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!vsib_address_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!vsib_address_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1479 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern1488 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 2L)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 2L)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 4L)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 4L)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 6L)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (XWINT (x7, 0) != 6L)
    return -1;
  return 0;
}

int
pattern1516 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vs_operator (operands[7], i1)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_0_to_63_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1538 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1388 (x11); /* [-1, 0] */
}

int
pattern1552 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !vsib_mem_operator (operands[6], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1568 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1567 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1567 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1586 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1585 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1585 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !const_int_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1602 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_HImode
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1614 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16SImode:
      return pattern1612 (
E_HImode, 
E_V16SFmode, 
E_V16SImode); /* [-1, 0] */

    case E_V8DImode:
      if (pattern1612 (
E_QImode, 
E_V8SFmode, 
E_V8DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1628 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1636 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1645 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  if (!register_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern1653 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1663 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || pattern1398 (x1, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      return 0;

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || pattern1398 (x1, 
E_V8SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1670 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_V2DImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  switch (XWINT (x5, 0))
    {
    case 0L:
      x6 = XVECEXP (x4, 0, 1);
      if (XWINT (x6, 0) != 2L)
        return -1;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (XWINT (x10, 0) != 0L)
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (XWINT (x11, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x6 = XVECEXP (x4, 0, 1);
      if (XWINT (x6, 0) != 3L)
        return -1;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (XWINT (x10, 0) != 1L)
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (XWINT (x11, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1679 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !register_operand (operands[4], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || !register_operand (operands[4], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1688 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  return 0;
}

int
pattern1692 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], i1)
      || !register_operand (operands[4], i1)
      || !register_operand (operands[5], i1)
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1698 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_16_to_31_operand (operands[11], E_VOIDmode)
      || !const_16_to_31_operand (operands[12], E_VOIDmode)
      || !const_16_to_31_operand (operands[13], E_VOIDmode)
      || !const_16_to_31_operand (operands[14], E_VOIDmode)
      || !const_16_to_31_operand (operands[15], E_VOIDmode)
      || !const_16_to_31_operand (operands[16], E_VOIDmode)
      || !const_16_to_31_operand (operands[17], E_VOIDmode)
      || !const_16_to_31_operand (operands[18], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1708 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  x4 = PATTERN (peep2_next_insn (4));
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 1);
  operands[6] = x7;
  return 0;
}

int
pattern1712 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_15_operand (operands[4], E_VOIDmode)
      || !const_0_to_15_operand (operands[5], E_VOIDmode)
      || !const_0_to_15_operand (operands[6], E_VOIDmode)
      || !const_0_to_15_operand (operands[7], E_VOIDmode)
      || !const_0_to_15_operand (operands[8], E_VOIDmode)
      || !const_0_to_15_operand (operands[9], E_VOIDmode)
      || !const_0_to_15_operand (operands[10], E_VOIDmode)
      || !const_16_to_31_operand (operands[11], E_VOIDmode)
      || !const_16_to_31_operand (operands[12], E_VOIDmode)
      || !const_16_to_31_operand (operands[13], E_VOIDmode)
      || !const_16_to_31_operand (operands[14], E_VOIDmode)
      || !const_16_to_31_operand (operands[15], E_VOIDmode)
      || !const_16_to_31_operand (operands[16], E_VOIDmode)
      || !const_16_to_31_operand (operands[17], E_VOIDmode)
      || !const_16_to_31_operand (operands[18], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1724 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pattern59 (x1, 
E_CCFPmode) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != E_CCFPmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case COMPARE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 2029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && TARGET_CMOVE))
                return -1;
              return 48; /* *cmpiuxf_i387 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !register_ssemem_operand (operands[1], E_SFmode)
                  || !
#line 2069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return -1;
              return 56; /* *cmpiusf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !register_ssemem_operand (operands[1], E_DFmode)
                  || !
#line 2069 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   || (TARGET_80387 && TARGET_CMOVE)))
                return -1;
              return 58; /* *cmpiudf */

            case E_HFmode:
              if (!register_operand (operands[0], E_HFmode)
                  || !nonimmediate_operand (operands[1], E_HFmode)
                  || !
#line 2106 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              return 60; /* *cmpiuhf */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern550 (x3) != 0)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          x5 = XEXP (x3, 1);
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          switch (GET_MODE (x4))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x5) != E_HFmode
                  || !nonimmediate_operand (operands[1], E_V8HFmode)
                  || !(
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3123; /* avx512fp16_ucomi */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x5) != E_SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode))
                return -1;
              return 3127; /* sse_ucomi */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 4872 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode))
                return -1;
              return 3131; /* sse2_ucomi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (XINT (x3, 1) != 44)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != COMPARE
              || GET_MODE (x8) != E_CCFPmode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          x10 = XEXP (x8, 1);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !
#line 2045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 50; /* *cmpxusf */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 2045 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 52; /* *cmpxudf */

            case E_HFmode:
              if (!register_operand (operands[0], E_HFmode)
                  || !nonimmediate_operand (operands[1], E_HFmode)
                  || !
#line 2058 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX10_2))
                return -1;
              return 54; /* *cmpxuhf */

            default:
              return -1;
            }

        case 2:
          if (XINT (x3, 1) != 61
              || pattern773 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          x11 = XVECEXP (x3, 0, 1);
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          switch (GET_MODE (x8))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x11) != E_HFmode
                  || !nonimmediate_operand (operands[1], E_V8HFmode)
                  || !(
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 1355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16)))
                return -1;
              return 3111; /* avx10_2_ucomxhf */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x11) != E_SFmode
                  || !nonimmediate_operand (operands[1], E_V4SFmode)
                  || !
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 3115; /* avx10_2_ucomxsf */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x11) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_V2DFmode)
                  || !
#line 4857 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
                return -1;
              return 3119; /* avx10_2_ucomxdf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!general_operand (operands[1], E_HImode))
        return -1;
      return 115; /* insvhi_1 */

    case E_SImode:
      if (!general_operand (operands[1], E_SImode))
        return -1;
      return 116; /* insvsi_1 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTRACT:
      x4 = XEXP (x2, 1);
      switch (XWINT (x4, 0))
        {
        case 8L:
          switch (pattern677 (x2))
            {
            case 0:
              return 108; /* *extvhi */

            case 1:
              return 109; /* *extvsi */

            default:
              return -1;
            }

        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 2);
          if (XWINT (x5, 0) != 0L
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 110; /* *extvsi_1_0 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x2, 1);
      if (XWINT (x4, 0) != 8L)
        return -1;
      switch (pattern677 (x2))
        {
        case 0:
          return 111; /* *extzvhi */

        case 1:
          return 112; /* *extzvsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1, pnum_clobbers))
    {
    case 0:
      if (!(
#line 16645 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 919; /* *lshrti3_doubleword_mask_1 */

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          switch (pattern236 (x1))
            {
            case 0:
              return 121; /* *insvqi_3 */

            case 1:
              return 123; /* *insvqi_3 */

            default:
              break;
            }
          break;

        case SUBREG:
          if (pnum_clobbers != NULL
              && pattern364 (x1) == 0
              && (
#line 16584 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 915; /* *lshrti3_doubleword_mask */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      switch (pattern237 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern678 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 17563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 981; /* *lshrqi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17563 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 982; /* *lshrqi3_1 */

            case E_HImode:
              if (pattern678 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 17601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 983; /* *lshrhi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 17601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 984; /* *lshrhi3_1 */

            case E_V4HImode:
              if (pattern663 (x2, 
E_V4HImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1736; /* mmx_lshrv4hi3 */

            case E_V2SImode:
              if (pattern663 (x2, 
E_V2SImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1738; /* mmx_lshrv2si3 */

            case E_V1DImode:
              if (pattern663 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1740; /* mmx_lshrv1di3 */

            case E_V1SImode:
              if (pattern663 (x2, 
E_V1SImode, 
E_DImode) != 0
                  || !
#line 3928 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1742; /* mmx_lshrv1si3 */

            case E_V2HImode:
              if (pattern663 (x2, 
E_V2HImode, 
E_DImode) != 0
                  || !
#line 3945 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1744; /* lshrv2hi3 */

            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern663 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 4007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return -1;
              *pnum_clobbers = 1;
              return 1748; /* lshrv2qi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 17640 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 985; /* *lshrqi3_1_slp */

        case 2:
          if (!
#line 17640 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 987; /* *lshrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      if (pattern39 (x1) != 0
          || !
#line 3748 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll))
        return -1;
      return 126; /* *insvdi_lowpart_1 */

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern775 (x2, 
E_QImode) != 0
                  || !
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 303; /* *leaqi_general_4 */

            case E_HImode:
              if (pattern775 (x2, 
E_HImode) != 0
                  || !
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 305; /* *leahi_general_4 */

            case E_TImode:
              if (pattern776 (x2, 
E_TImode) != 0
                  || !(
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 747; /* *concatditi3_5 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case TRUNCATE:
              if (GET_MODE (x8) != E_QImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != MOD
                  || GET_MODE (x9) != E_HImode)
                return -1;
              x6 = XEXP (x3, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              x7 = XEXP (x2, 1);
              if (GET_CODE (x7) != ZERO_EXTEND
                  || GET_MODE (x7) != E_HImode)
                return -1;
              x10 = XEXP (x7, 0);
              if (pattern1081 (x10, 
E_HImode, 
DIV, 
E_QImode, 
TRUNCATE) != 0
                  || pattern903 (x2, 
E_HImode) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_HImode))
                return -1;
              x12 = XEXP (x9, 1);
              if (GET_MODE (x12) != E_HImode)
                return -1;
              x13 = XEXP (x10, 0);
              x14 = XEXP (x13, 1);
              if (GET_MODE (x14) != E_HImode)
                return -1;
              x15 = XEXP (x13, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_CODE (x12))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x14) != SIGN_EXTEND)
                    return -1;
                  x16 = XEXP (x12, 0);
                  operands[2] = x16;
                  if (!nonimmediate_operand (operands[2], E_QImode))
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  if (
#line 12017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && TARGET_APX_NF))
                    return 546; /* divmodhiqi3_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 12017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 547; /* divmodhiqi3 */

                case ZERO_EXTEND:
                  if (GET_CODE (x14) != ZERO_EXTEND)
                    return -1;
                  x16 = XEXP (x12, 0);
                  operands[2] = x16;
                  if (!nonimmediate_operand (operands[2], E_QImode))
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[2]))
                    return -1;
                  if (
#line 12017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && TARGET_APX_NF))
                    return 548; /* udivmodhiqi3_nf */
                  if (pnum_clobbers == NULL
                      || !
#line 12017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                    return -1;
                  *pnum_clobbers = 1;
                  return 549; /* udivmodhiqi3 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x8;
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || GET_MODE (x3) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              x6 = XEXP (x3, 1);
              operands[2] = x6;
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              if (!const_scalar_int_operand (operands[3], E_TImode)
                  || !(
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 759; /* *concatditi3_6 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_TImode
              || !nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode
              || GET_MODE (x3) != E_TImode)
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_QImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!const_scalar_int_operand (operands[3], E_TImode)
              || !(
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 756; /* *concatditi3_6 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (pattern77 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 588; /* *iorqi_1_slp */
            }
          break;

        case 1:
          if (
#line 12743 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 591; /* *iorhi_1_slp */
            }
          break;

        case 2:
          if ((
#line 13529 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 664; /* *iorti3_doubleword */
            }
          break;

        case 3:
          if (
#line 13587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 666; /* *iorhi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 13587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, HImode, operands, TARGET_APX_NDD)
   && true))
            {
              *pnum_clobbers = 1;
              return 667; /* *iorhi_1 */
            }
          break;

        case 4:
          if (
#line 2582 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1662; /* iorv2bf3 */
          break;

        case 5:
          if (
#line 2582 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1665; /* iorv2hf3 */
          break;

        case 6:
          if (
#line 4687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V8QImode, operands)))
            return 1797; /* *mmx_iorv8qi3 */
          break;

        case 7:
          if (
#line 4687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V4HImode, operands)))
            return 1800; /* *mmx_iorv4hi3 */
          break;

        case 8:
          if (
#line 4687 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (IOR, V2SImode, operands)))
            return 1803; /* *mmx_iorv2si3 */
          break;

        case 9:
          if (
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V4QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1806; /* *iorv4qi3 */
            }
          break;

        case 10:
          if (
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1809; /* *iorv2qi3 */
            }
          break;

        case 11:
          if (
#line 4713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (IOR, V2HImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1812; /* *iorv2hi3 */
            }
          break;

        case 12:
          if (
#line 5666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3225; /* iorbf3 */
          break;

        case 13:
          if (
#line 5666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3228; /* iorhf3 */
          break;

        case 14:
          if (
#line 5666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3231; /* iorsf3 */
          break;

        case 15:
          if ((
#line 5666 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3234; /* iordf3 */
          break;

        case 16:
          if (
#line 5740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 3237; /* *iortf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL
          && pattern78 (x2) == 0)
        {
          x5 = XEXP (x3, 0);
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          switch (pattern1147 (x1))
            {
            case 0:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 594; /* *iorqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 597; /* *iorqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12770 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 600; /* *iorqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 616; /* *iorqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 619; /* *iorqi_extsi_0 */

            default:
              break;
            }
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) == SUBREG)
            {
              switch (pattern1149 (x1))
                {
                case 0:
                  if (
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 603; /* *iorqi_exthi_2_slp */
                    }
                  break;

                case 1:
                  if (
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 606; /* *iorqi_extsi_2_slp */
                    }
                  break;

                case 2:
                  if ((
#line 12803 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 609; /* *iorqi_extdi_2_slp */
                    }
                  break;

                case 3:
                  *pnum_clobbers = 1;
                  return 622; /* *iorqi_ext2hi_0 */

                case 4:
                  *pnum_clobbers = 1;
                  return 625; /* *iorqi_ext2si_0 */

                default:
                  break;
                }
            }
        }
      operands[1] = x3;
      if (pattern79 (x1) != 0)
        return -1;
      if (
#line 13777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 704; /* *iorqi_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 13777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (IOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 705; /* *iorqi_1 */

    case ZERO_EXTEND:
      if (pattern40 (x1) != 0
          || !(
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 765; /* *concatditi3_7 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (pnum_clobbers != NULL
          && GET_CODE (x4) == SUBREG
          && pattern364 (x1) == 0
          && (
#line 15205 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 860; /* *ashlti3_doubleword_mask */
        }
      operands[2] = x4;
      switch (pattern237 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern678 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 16097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 897; /* *ashlhi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 16097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 898; /* *ashlhi3_1 */

            case E_QImode:
              if (pattern678 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 16156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
                return 899; /* *ashlqi3_1_nf */
              if (pnum_clobbers == NULL
                  || !
#line 16156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFT, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              *pnum_clobbers = 1;
              return 900; /* *ashlqi3_1 */

            case E_V4HImode:
              if (pattern663 (x2, 
E_V4HImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1735; /* mmx_ashlv4hi3 */

            case E_V2SImode:
              if (pattern663 (x2, 
E_V2SImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1737; /* mmx_ashlv2si3 */

            case E_V1DImode:
              if (pattern663 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 3891 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
                return -1;
              return 1739; /* mmx_ashlv1di3 */

            case E_V1SImode:
              if (pattern663 (x2, 
E_V1SImode, 
E_DImode) != 0
                  || !
#line 3928 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1741; /* mmx_ashlv1si3 */

            case E_V2HImode:
              if (pattern663 (x2, 
E_V2HImode, 
E_DImode) != 0
                  || !
#line 3945 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
                return -1;
              return 1743; /* ashlv2hi3 */

            case E_V2QImode:
              if (pnum_clobbers == NULL
                  || pattern663 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 4007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
                return -1;
              *pnum_clobbers = 1;
              return 1747; /* ashlv2qi3 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 16235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 901; /* *ashlqi3_1_slp */

        case 2:
          if (!
#line 16235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          *pnum_clobbers = 1;
          return 902; /* *ashlhi3_1_slp */

        default:
          return -1;
        }

    case AND:
      if (pattern0 (x1, pnum_clobbers) != 0
          || !(
#line 15266 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (8 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 8 * BITS_PER_UNIT - 1))
	 == (2 * 8 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 862; /* *ashlti3_doubleword_mask_1 */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 19404 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1187; /* *btsi_setncqi_2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 19404 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1188; /* *btdi_setncqi_2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern7 (x2, 
E_V8QImode) != 0
              || !
#line 4141 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V8QImode, operands)))
            return -1;
          return 1750; /* *mmx_eqv8qi3 */

        case E_V4HImode:
          if (pattern7 (x2, 
E_V4HImode) != 0
              || !
#line 4141 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V4HImode, operands)))
            return -1;
          return 1751; /* *mmx_eqv4hi3 */

        case E_V2SImode:
          if (pattern7 (x2, 
E_V2SImode) != 0
              || !
#line 4141 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (EQ, V2SImode, operands)))
            return -1;
          return 1752; /* *mmx_eqv2si3 */

        case E_V4QImode:
          if (pattern8 (x2, 
E_V4QImode) != 0
              || !
#line 4157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1753; /* *eqv4qi3 */

        case E_V2QImode:
          if (pattern8 (x2, 
E_V2QImode) != 0
              || !
#line 4157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1754; /* *eqv2qi3 */

        case E_V2HImode:
          if (pattern8 (x2, 
E_V2HImode) != 0
              || !
#line 4157 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1755; /* *eqv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern84 (x1, pnum_clobbers))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          x2 = XEXP (x1, 1);
          if (pattern74 (x2, pnum_clobbers, 
E_TImode) != 0
              || !(
#line 6465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 213; /* *addti3_doubleword */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern75 (x2, 
E_HImode) != 0)
            return -1;
          if (
#line 6813 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 236; /* *addhi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6813 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 237; /* *addhi_1 */

        case E_QImode:
          x2 = XEXP (x1, 1);
          if (pattern75 (x2, 
E_QImode) != 0)
            return -1;
          if (
#line 6870 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 238; /* *addqi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 6870 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 239; /* *addqi_1 */

        case E_HFmode:
          x2 = XEXP (x1, 1);
          if (pattern5 (x2, 
E_HFmode) != 0
              || !
#line 23465 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 1336; /* *addhf */

        case E_V8QImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V8QImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V8QImode, operands)))
            return -1;
          return 1668; /* *mmx_addv8qi3 */

        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V4HImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V4HImode, operands)))
            return -1;
          return 1670; /* *mmx_addv4hi3 */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V2SImode) != 0
              || !
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V2SImode, operands)))
            return -1;
          return 1672; /* *mmx_addv2si3 */

        case E_V1DImode:
          x2 = XEXP (x1, 1);
          if (pattern7 (x2, 
E_V1DImode) != 0
              || !(
#line 3211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (PLUS, V1DImode, operands)) && 
#line 50 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2)))
            return -1;
          return 1674; /* *mmx_addv1di3 */

        case E_V4QImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V4QImode) != 0
              || !
#line 3227 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1676; /* addv4qi3 */

        case E_V2HImode:
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V2HImode) != 0
              || !
#line 3227 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 1678; /* addv2hi3 */

        case E_V2QImode:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XEXP (x1, 1);
          if (pattern8 (x2, 
E_V2QImode) != 0
              || !
#line 3241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
            return -1;
          *pnum_clobbers = 1;
          return 1680; /* addv2qi3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 6946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 240; /* *addqi_1_slp */

    case 2:
      if (!
#line 6946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
        return -1;
      *pnum_clobbers = 1;
      return 241; /* *addhi_1_slp */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 20:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode)
              || !
#line 29154 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_FXSR))
            return -1;
          return 1536; /* fxsave */

        case 24:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 29234 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE))
            return -1;
          return 1538; /* xsave */

        case 28:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 29234 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE) && 
#line 29195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_XSAVEOPT)))
            return -1;
          return 1539; /* xsaveopt */

        case 34:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 29234 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE) && 
#line 29196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_XSAVEC)))
            return -1;
          return 1540; /* xsavec */

        case 30:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 29234 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE) && 
#line 29197 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_XSAVES)))
            return -1;
          return 1541; /* xsaves */

        case 40:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode)
              || !
#line 29365 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          *pnum_clobbers = 8;
          return 1546; /* fnstenv */

        case 42:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !
#line 29393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 1548; /* fnstsw */

        case 49:
          if (pattern60 (x1, 
E_CCZmode) != 0
              || !
#line 29679 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_RTM))
            return -1;
          return 1574; /* xtest_1 */

        case 88:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!memory_operand (operands[0], E_BLKmode)
              || !
#line 30092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AMX_TILE))
            return -1;
          return 1606; /* sttilecfg */

        default:
          return -1;
        }

    case 3:
      if (XINT (x2, 1) != 15
          || pattern58 (x1, 
E_SImode, 
E_CCCmode) != 0)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 29450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LWP))
        return -1;
      return 1555; /* lwp_lwpinssi */

    case 2:
      switch (XINT (x2, 1))
        {
        case 79:
          switch (pattern90 (x1))
            {
            case 0:
              if (!(
#line 29846 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ENQCMD) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1592; /* enqcmd_si */

            case 1:
              if (!(
#line 29846 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ENQCMD) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1594; /* enqcmd_di */

            default:
              return -1;
            }

        case 80:
          switch (pattern90 (x1))
            {
            case 0:
              if (!(
#line 29846 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ENQCMD) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1593; /* enqcmds_si */

            case 1:
              if (!(
#line 29846 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ENQCMD) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1595; /* enqcmds_di */

            default:
              return -1;
            }

        case 69:
          if (pattern91 (x1) != 0
              || !
#line 29885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_WAITPKG))
            return -1;
          return 1596; /* umwait */

        case 71:
          if (pattern91 (x1) != 0
              || !
#line 29912 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_WAITPKG))
            return -1;
          return 1599; /* tpause */

        case 111:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern784 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 10283; /* atomic_addqi */

                case 1:
                  *pnum_clobbers = 1;
                  return 10284; /* atomic_addhi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern784 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 10286; /* atomic_subqi */

                case 1:
                  *pnum_clobbers = 1;
                  return 10287; /* atomic_subhi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern784 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 10289; /* atomic_andqi */

                case 1:
                  *pnum_clobbers = 1;
                  return 10292; /* atomic_andhi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern784 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 10290; /* atomic_orqi */

                case 1:
                  *pnum_clobbers = 1;
                  return 10293; /* atomic_orhi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern784 (x2))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 10291; /* atomic_xorqi */

                case 1:
                  *pnum_clobbers = 1;
                  return 10294; /* atomic_xorhi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern105 (x2))
        {
        case 0:
          if (
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 573; /* *andqi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 574; /* *andqi_1_zextsi */

        case 1:
          if (
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 577; /* *andhi_1_zextsi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 578; /* *andhi_1_zextsi */

        case 2:
          if (
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 575; /* *andqi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 576; /* *andqi_1_zextdi */

        case 3:
          if (
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 579; /* *andhi_1_zextdi_nf */
          if (pnum_clobbers == NULL
              || !
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 580; /* *andhi_1_zextdi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (XINT (x4, 1))
        {
        case 158:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern978 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (DImode))) && 
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7536; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7539; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && 
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7545; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7542; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7548; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7554; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7551; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7557; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7560; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7563; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7566; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7569; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern978 (x2, 
E_SImode))
                {
                case 0:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (DImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7537; /* *avx512bw_testmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7540; /* *avx512vl_testmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7546; /* *avx512bw_testmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7543; /* *avx512vl_testmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7549; /* *avx512vl_testmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7555; /* *avx512f_testmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7552; /* *avx512vl_testmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7558; /* *avx512vl_testmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7561; /* *avx512vl_testmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7564; /* *avx512f_testmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7567; /* *avx512vl_testmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19077 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7570; /* *avx512vl_testmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 159:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern978 (x2, 
E_DImode))
                {
                case 0:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (DImode))) && 
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7608; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7611; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (SImode))) && 
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                    return -1;
                  return 7617; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7614; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7620; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7626; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7623; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7629; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7632; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7635; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7638; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (8
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7641; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern978 (x2, 
E_SImode))
                {
                case 0:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (DImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 504 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7609; /* *avx512bw_testnmv64qi3_zext_mask */

                case 1:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 505 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7612; /* *avx512vl_testnmv32qi3_zext_mask */

                case 2:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (SImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)) && 
#line 507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7618; /* *avx512bw_testnmv32hi3_zext_mask */

                case 3:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7615; /* *avx512vl_testnmv16qi3_zext_mask */

                case 4:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 508 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7621; /* *avx512vl_testnmv16hi3_zext_mask */

                case 5:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (HImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7627; /* *avx512f_testnmv16si3_zext_mask */

                case 6:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW)) && 
#line 509 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7624; /* *avx512vl_testnmv8hi3_zext_mask */

                case 7:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7630; /* *avx512vl_testnmv8si3_zext_mask */

                case 8:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 510 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7633; /* *avx512vl_testnmv4si3_zext_mask */

                case 9:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 7636; /* *avx512f_testnmv8di3_zext_mask */

                case 10:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7639; /* *avx512vl_testnmv4di3_zext_mask */

                case 11:
                  if (!(
#line 19107 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && (4
       > GET_MODE_SIZE (QImode))) && ((
#line 19030 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 7642; /* *avx512vl_testnmv2di3_zext_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern22 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1060; /* *rotlsi3_mask_1 */

    case 1:
      if (!(
#line 18192 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1062; /* *rotldi3_mask_1 */

    case 2:
      if (!
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1076; /* *rotlsi3_add_1 */

    case 3:
      if (!(
#line 18273 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1078; /* *rotldi3_add_1 */

    case 4:
      if (!
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1092; /* *rotlsi3_sub_1 */

    case 5:
      if (!(
#line 18342 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1094; /* *rotldi3_sub_1 */

    case 6:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern392 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1052; /* *rotlsi3_mask */
                }
              break;

            case 1:
              if ((
#line 18144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1054; /* *rotldi3_mask */
                }
              break;

            case 2:
              if (
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1068; /* *rotlsi3_add */
                }
              break;

            case 3:
              if ((
#line 18237 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1070; /* *rotldi3_add */
                }
              break;

            case 4:
              if (
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 1084; /* *rotlsi3_sub */
                }
              break;

            case 5:
              if ((
#line 18306 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1086; /* *rotldi3_sub */
                }
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          if (pnum_clobbers != NULL)
            {
              operands[2] = x3;
              if (const_1_to_31_operand (operands[2], E_QImode)
                  && register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && register_operand (operands[1], E_DImode))
                {
                  *pnum_clobbers = 2;
                  return 1096; /* ix86_rotldi3_doubleword */
                }
            }
          if (XWINT (x3, 0) == 32L
              && register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 1098; /* rotl32di2_doubleword */
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern19 (x2))
        {
        case 0:
          if (
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 1102; /* *rotlsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 1103; /* *rotlsi3_1 */

        case 1:
          if ((
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1106; /* *rotldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 18498 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ROTATE, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1107; /* *rotldi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  res = recog_102 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (register_operand (operands[0], E_DImode))
    {
      res = recog_103 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!nonimmediate_operand (operands[0], E_DImode)
      || XWINT (x4, 0) != 0L
      || GET_MODE (x2) != E_DImode)
    return -1;
  operands[1] = x6;
  if (!nonimmediate_operand (operands[1], E_V2DImode)
      || !
#line 21159 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && !TARGET_64BIT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
    return -1;
  return 7809; /* *vec_extractv2di_0_sse */
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern567 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3969; /* unspec_avx512fp16_fixuns_truncv8hi2_mask */

    case E_V16HImode:
      if (pattern567 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 3977; /* unspec_avx512fp16_fixuns_truncv16hi2_mask */

    case E_V32HImode:
      if (pattern567 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 3985; /* unspec_avx512fp16_fixuns_truncv32hi2_mask */

    case E_V8SImode:
      if (pattern128 (x2, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 3993; /* unspec_avx512fp16_fixuns_truncv8si2_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9547 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4377; /* unspec_fixuns_truncv8dfv8si2_mask */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 4481; /* unspec_fixuns_truncv8sfv8si2_mask */

        default:
          return -1;
        }

    case E_V16SImode:
      switch (pattern895 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4001; /* unspec_avx512fp16_fixuns_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8754 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4252; /* unspec_fixuns_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case E_V8DImode:
      switch (pattern896 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7859 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4009; /* unspec_avx512fp16_fixuns_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4406; /* unspec_fixuns_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4454; /* unspec_fixuns_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case E_V4SImode:
      if (pattern128 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4062; /* unspec_avx512fp16_fixuns_truncv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9656 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 4397; /* unspec_fixuns_truncv4dfv4si2_mask */

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9890 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4483; /* unspec_fixuns_truncv4sfv4si2_mask */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern897 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7897 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4066; /* unspec_avx512fp16_fixuns_truncv4di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4411; /* unspec_fixuns_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9719 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4459; /* unspec_fixuns_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern898 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7947 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4086; /* unspec_avx512fp16_fixuns_truncv2di2_mask */

        case 1:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9676 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4415; /* unspec_fixuns_truncv2dfv2di2_mask */

        case 2:
          if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
            return -1;
          return 4475; /* unspec_avx512dq_fixuns_truncv2sfv2di2_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      if (XWINT (x6, 0) != 1L)
        return -1;
      switch (pattern397 (x2))
        {
        case 0:
          if (!(
#line 13598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4741; /* avx512f_vmscalefv8hf */

        case 1:
          if (!
#line 13598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F))
            return -1;
          return 4745; /* avx512f_vmscalefv4sf */

        case 2:
          if (!(
#line 13598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4749; /* avx512f_vmscalefv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern998 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 4755; /* avx512bw_scalefv32hf_mask */

        case E_V16HFmode:
          if (pattern998 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 4759; /* avx512vl_scalefv16hf_mask */

        case E_V8HFmode:
          if (pattern998 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 4763; /* avx512fp16_scalefv8hf_mask */

        case E_V16SFmode:
          if (pattern998 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4767; /* avx512f_scalefv16sf_mask */

        case E_V8SFmode:
          if (pattern998 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4771; /* avx512vl_scalefv8sf_mask */

        case E_V4SFmode:
          if (pattern998 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4775; /* avx512vl_scalefv4sf_mask */

        case E_V8DFmode:
          if (pattern998 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4779; /* avx512f_scalefv8df_mask */

        case E_V4DFmode:
          if (pattern998 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4783; /* avx512vl_scalefv4df_mask */

        case E_V2DFmode:
          if (pattern998 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13609 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4787; /* avx512vl_scalefv2df_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern422 (x2))
    {
    case 0:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9513; /* vpshrdv_v32hi_mask */

    case 1:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9514; /* vpshrdv_v16si_mask */

    case 2:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9515; /* vpshrdv_v8di_mask */

    case 3:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9516; /* vpshrdv_v16hi_mask */

    case 4:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9517; /* vpshrdv_v8si_mask */

    case 5:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9518; /* vpshrdv_v4di_mask */

    case 6:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9519; /* vpshrdv_v8hi_mask */

    case 7:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9520; /* vpshrdv_v4si_mask */

    case 8:
      if (!(
#line 30423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9521; /* vpshrdv_v2di_mask */

    case 9:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9522; /* vpshrdv_v32hi_maskz_1 */

    case 10:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9523; /* vpshrdv_v16si_maskz_1 */

    case 11:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9524; /* vpshrdv_v8di_maskz_1 */

    case 12:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9525; /* vpshrdv_v16hi_maskz_1 */

    case 13:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9526; /* vpshrdv_v8si_maskz_1 */

    case 14:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9527; /* vpshrdv_v4di_maskz_1 */

    case 15:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9528; /* vpshrdv_v8hi_maskz_1 */

    case 16:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9529; /* vpshrdv_v4si_maskz_1 */

    case 17:
      if (!(
#line 30453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9530; /* vpshrdv_v2di_maskz_1 */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern418 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9487; /* vpshld_v32hi_mask */

    case 1:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9489; /* vpshld_v16si_mask */

    case 2:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 9491; /* vpshld_v8di_mask */

    case 3:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9493; /* vpshld_v16hi_mask */

    case 4:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9495; /* vpshld_v8si_mask */

    case 5:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9497; /* vpshld_v4di_mask */

    case 6:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9499; /* vpshld_v8hi_mask */

    case 7:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9501; /* vpshld_v4si_mask */

    case 8:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 9503; /* vpshld_v2di_mask */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 1L)
            return -1;
          switch (pattern911 (x2))
            {
            case 0:
              if (!
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 4627; /* *vec_setv8hi_0_1 */

            case 1:
              if (!
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 4628; /* *vec_setv8hf_0_1 */

            case 2:
              if (!
#line 12023 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
                return -1;
              return 4629; /* *vec_setv8bf_0_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x7;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SImode:
              if (pattern1169 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8480; /* avx512f_vec_dupv16si_mask */

            case E_V8SImode:
              if (pattern1169 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_SImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8482; /* avx512vl_vec_dupv8si_mask */

            case E_V4SImode:
              if (pattern1170 (x2, 
E_V4SImode, 
E_SImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8484; /* avx512vl_vec_dupv4si_mask */

            case E_V8DImode:
              if (pattern1169 (x2, 
E_V8DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8486; /* avx512f_vec_dupv8di_mask */

            case E_V4DImode:
              if (pattern1169 (x2, 
E_V4DImode, 
E_QImode, 
E_V2DImode, 
E_DImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8488; /* avx512vl_vec_dupv4di_mask */

            case E_V2DImode:
              if (pattern1170 (x2, 
E_V2DImode, 
E_DImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8490; /* avx512vl_vec_dupv2di_mask */

            case E_V16SFmode:
              if (pattern1169 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8492; /* avx512f_vec_dupv16sf_mask */

            case E_V8SFmode:
              if (pattern1169 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8494; /* avx512vl_vec_dupv8sf_mask */

            case E_V4SFmode:
              if (pattern1170 (x2, 
E_V4SFmode, 
E_SFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8496; /* avx512vl_vec_dupv4sf_mask */

            case E_V8DFmode:
              if (pattern1169 (x2, 
E_V8DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8498; /* avx512f_vec_dupv8df_mask */

            case E_V4DFmode:
              if (pattern1169 (x2, 
E_V4DFmode, 
E_QImode, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8500; /* avx512vl_vec_dupv4df_mask */

            case E_V2DFmode:
              if (pattern1170 (x2, 
E_V2DFmode, 
E_DFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8502; /* avx512vl_vec_dupv2df_mask */

            case E_V64QImode:
              if (pattern1169 (x2, 
E_V64QImode, 
E_DImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8504; /* avx512bw_vec_dupv64qi_mask */

            case E_V16QImode:
              if (pattern1170 (x2, 
E_V16QImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8506; /* avx512vl_vec_dupv16qi_mask */

            case E_V32QImode:
              if (pattern1169 (x2, 
E_V32QImode, 
E_SImode, 
E_V16QImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8508; /* avx512vl_vec_dupv32qi_mask */

            case E_V32HImode:
              if (pattern1169 (x2, 
E_V32HImode, 
E_SImode, 
E_V8HImode, 
E_HImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8510; /* avx512bw_vec_dupv32hi_mask */

            case E_V16HImode:
              if (pattern707 (x2, 
E_HImode, 
E_V16HImode) != 0
                  || !nonimmediate_operand (operands[1], E_V8HImode)
                  || !nonimm_or_0_operand (operands[2], E_V16HImode)
                  || !register_operand (operands[3], E_HImode)
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8512; /* avx512vl_vec_dupv16hi_mask */

            case E_V8HImode:
              if (pattern1170 (x2, 
E_V8HImode, 
E_HImode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8514; /* avx512vl_vec_dupv8hi_mask */

            case E_V32HFmode:
              if (pattern1169 (x2, 
E_V32HFmode, 
E_SImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8516; /* avx512bw_vec_dupv32hf_mask */

            case E_V16HFmode:
              if (pattern1169 (x2, 
E_V16HFmode, 
E_HImode, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8518; /* avx512vl_vec_dupv16hf_mask */

            case E_V8HFmode:
              if (pattern1170 (x2, 
E_V8HFmode, 
E_HFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8520; /* avx512fp16_vec_dupv8hf_mask */

            case E_V32BFmode:
              if (pattern1169 (x2, 
E_V32BFmode, 
E_SImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 8522; /* avx512bw_vec_dupv32bf_mask */

            case E_V16BFmode:
              if (pattern1169 (x2, 
E_V16BFmode, 
E_HImode, 
E_V8BFmode, 
E_BFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8524; /* avx512vl_vec_dupv16bf_mask */

            case E_V8BFmode:
              if (pattern1170 (x2, 
E_V8BFmode, 
E_BFmode, 
E_QImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 27723 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 8526; /* avx512vl_vec_dupv8bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x5, 0, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern1169 (x2, 
E_V16SImode, 
E_HImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8614; /* avx512dq_broadcastv16si_mask */

        case E_V8SImode:
          if (pattern1169 (x2, 
E_V8SImode, 
E_QImode, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8616; /* avx512dq_broadcastv8si_mask */

        case E_V4SImode:
          if (pattern1170 (x2, 
E_V4SImode, 
E_V2SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28013 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8618; /* avx512dq_broadcastv4si_mask */

        case E_V16SFmode:
          if (pattern1169 (x2, 
E_V16SFmode, 
E_HImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 8620; /* avx512dq_broadcastv16sf_mask */

        case E_V8SFmode:
          if (pattern1169 (x2, 
E_V8SFmode, 
E_QImode, 
E_V4SFmode, 
E_V2SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28029 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 8622; /* avx512dq_broadcastv8sf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern572 (x2))
    {
    case 0:
      if (pattern1254 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3309; /* fma_fmsub_v32hf_maskz_1 */

    case 1:
      if (pattern1254 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3313; /* fma_fmsub_v16hf_maskz_1 */

    case 2:
      if (pattern1254 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3315; /* fma_fmsub_v8hf_maskz_1 */

    case 3:
      if (pattern1254 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3319; /* fma_fmsub_v16sf_maskz_1 */

    case 4:
      if (pattern1254 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3323; /* fma_fmsub_v8sf_maskz_1 */

    case 5:
      if (pattern1254 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3325; /* fma_fmsub_v4sf_maskz_1 */

    case 6:
      if (pattern1254 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3328; /* fma_fmsub_v8df_maskz_1 */

    case 7:
      if (pattern1254 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3332; /* fma_fmsub_v4df_maskz_1 */

    case 8:
      if (pattern1254 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3334; /* fma_fmsub_v2df_maskz_1 */

    case 9:
      if (pattern1256 (x2, 
E_SImode, 
E_V32BFmode) != 0
          || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9938; /* avx10_2_fmsubbf16_v32bf_maskz_1 */

    case 10:
      if (pattern1256 (x2, 
E_HImode, 
E_V16BFmode) != 0
          || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9940; /* avx10_2_fmsubbf16_v16bf_maskz_1 */

    case 11:
      if (pattern1256 (x2, 
E_QImode, 
E_V8BFmode) != 0
          || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9942; /* avx10_2_fmsubbf16_v8bf_maskz_1 */

    case 12:
      if (pattern1258 (x2, 
E_V4SFmode) != 0
          || !
#line 6975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4))
        return -1;
      return 3725; /* *fma4i_vmfmsub_v4sf */

    case 13:
      if (pattern1258 (x2, 
E_V2DFmode) != 0
          || !(
#line 6975 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3726; /* *fma4i_vmfmsub_v2df */

    case 14:
      if (pattern1176 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && vector_operand (operands[3], E_V32HFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3335; /* avx512bw_fmsub_v32hf_mask */
        }
      if (!vector_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3353; /* avx512bw_fmsub_v32hf_mask3 */

    case 15:
      if (pattern1176 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[3], E_V16HFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3337; /* avx512vl_fmsub_v16hf_mask */
        }
      if (!vector_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3355; /* avx512vl_fmsub_v16hf_mask3 */

    case 16:
      if (pattern1176 (x2, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[3], E_V8HFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3339; /* avx512fp16_fmsub_v8hf_mask */
        }
      if (!vector_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[3], E_V8HFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3356; /* avx512fp16_fmsub_v8hf_mask3 */

    case 17:
      if (pattern1176 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && vector_operand (operands[3], E_V16SFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3341; /* avx512f_fmsub_v16sf_mask */
        }
      if (!vector_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3357; /* avx512f_fmsub_v16sf_mask3 */

    case 18:
      if (pattern1176 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[3], E_V8SFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3343; /* avx512vl_fmsub_v8sf_mask */
        }
      if (!vector_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3359; /* avx512vl_fmsub_v8sf_mask3 */

    case 19:
      if (pattern1176 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[3], E_V4SFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3345; /* avx512vl_fmsub_v4sf_mask */
        }
      if (!vector_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[3], E_V4SFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3360; /* avx512vl_fmsub_v4sf_mask3 */

    case 20:
      if (pattern1176 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && vector_operand (operands[3], E_V8DFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3347; /* avx512f_fmsub_v8df_mask */
        }
      if (!vector_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3361; /* avx512f_fmsub_v8df_mask3 */

    case 21:
      if (pattern1176 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[3], E_V4DFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3349; /* avx512vl_fmsub_v4df_mask */
        }
      if (!vector_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3363; /* avx512vl_fmsub_v4df_mask3 */

    case 22:
      if (pattern1176 (x2, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[3], E_V2DFmode))
        {
          x3 = XEXP (x2, 1);
          if (rtx_equal_p (x3, operands[1])
              && (
#line 6092 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3351; /* avx512vl_fmsub_v2df_mask */
        }
      if (!vector_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[3], E_V2DFmode))
        return -1;
      x3 = XEXP (x2, 1);
      if (!rtx_equal_p (x3, operands[3])
          || !(
#line 6110 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3364; /* avx512vl_fmsub_v2df_mask3 */

    case 23:
      if (pattern1178 (x2, 
E_SImode, 
E_V32BFmode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      if (rtx_equal_p (x3, operands[1])
          && 
#line 32290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9943; /* avx10_2_fmsubbf16_v32bf_mask */
      if (!rtx_equal_p (x3, operands[3])
          || !
#line 32308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9946; /* avx10_2_fmsubbf16_v32bf_mask3 */

    case 24:
      if (pattern1178 (x2, 
E_HImode, 
E_V16BFmode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      if (rtx_equal_p (x3, operands[1])
          && 
#line 32290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9944; /* avx10_2_fmsubbf16_v16bf_mask */
      if (!rtx_equal_p (x3, operands[3])
          || !
#line 32308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9947; /* avx10_2_fmsubbf16_v16bf_mask3 */

    case 25:
      if (pattern1178 (x2, 
E_QImode, 
E_V8BFmode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      if (rtx_equal_p (x3, operands[1])
          && 
#line 32290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return 9945; /* avx10_2_fmsubbf16_v8bf_mask */
      if (!rtx_equal_p (x3, operands[3])
          || !
#line 32308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9948; /* avx10_2_fmsubbf16_v8bf_mask3 */

    case 26:
      if (pattern1259 (x2, 
E_V8HFmode) != 0
          || !(
#line 6618 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3633; /* *fmai_fmsub_v8hf */

    case 27:
      if (pattern1259 (x2, 
E_V4SFmode) != 0
          || !
#line 6618 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
        return -1;
      return 3635; /* *fmai_fmsub_v4sf */

    case 28:
      if (pattern1259 (x2, 
E_V2DFmode) != 0
          || !(
#line 6618 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3637; /* *fmai_fmsub_v2df */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (pattern839 (x4) != 0)
    return -1;
  x5 = XEXP (x2, 2);
  if (!register_operand (x5, E_QImode))
    return -1;
  x6 = XVECEXP (x4, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 2L:
      x7 = XVECEXP (x4, 0, 1);
      if (XWINT (x7, 0) != 10L)
        return -1;
      x8 = XVECEXP (x4, 0, 2);
      if (XWINT (x8, 0) != 3L)
        return -1;
      x9 = XVECEXP (x4, 0, 3);
      if (XWINT (x9, 0) != 11L
          || pattern1577 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1432 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11155 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4574; /* avx_unpckhps256_mask */

        case E_V8SImode:
          if (pattern1432 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19710 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
            return -1;
          return 7711; /* avx2_interleave_highv8si_mask */

        default:
          return -1;
        }

    case 0L:
      x7 = XVECEXP (x4, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 8L:
          x8 = XVECEXP (x4, 0, 2);
          switch (XWINT (x8, 0))
            {
            case 1L:
              x9 = XVECEXP (x4, 0, 3);
              if (XWINT (x9, 0) != 9L)
                return -1;
              x10 = XEXP (x3, 0);
              x11 = XEXP (x10, 1);
              operands[2] = x11;
              x12 = XEXP (x2, 1);
              operands[3] = x12;
              operands[4] = x5;
              x13 = XVECEXP (x4, 0, 4);
              switch (XWINT (x13, 0))
                {
                case 4L:
                  x14 = XVECEXP (x4, 0, 5);
                  if (XWINT (x14, 0) != 12L)
                    return -1;
                  x15 = XVECEXP (x4, 0, 6);
                  if (XWINT (x15, 0) != 5L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 7);
                  if (XWINT (x16, 0) != 13L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SFmode:
                      if (pattern1432 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11243 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                        return -1;
                      return 4580; /* avx_unpcklps256_mask */

                    case E_V8SImode:
                      if (pattern1432 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19765 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
                        return -1;
                      return 7717; /* avx2_interleave_lowv8si_mask */

                    default:
                      return -1;
                    }

                case 2L:
                  x14 = XVECEXP (x4, 0, 5);
                  if (XWINT (x14, 0) != 10L)
                    return -1;
                  x15 = XVECEXP (x4, 0, 6);
                  if (XWINT (x15, 0) != 3L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 7);
                  if (XWINT (x16, 0) != 11L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1433 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7705; /* vec_interleave_lowv8hi_mask */

                    case E_V8HFmode:
                      if (pattern1433 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7707; /* vec_interleave_lowv8hf_mask */

                    case E_V8BFmode:
                      if (pattern1433 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
                          || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19690 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
                        return -1;
                      return 7709; /* vec_interleave_lowv8bf_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x4, 0, 3);
              if (XWINT (x9, 0) != 10L)
                return -1;
              x13 = XVECEXP (x4, 0, 4);
              if (XWINT (x13, 0) != 4L)
                return -1;
              x14 = XVECEXP (x4, 0, 5);
              if (XWINT (x14, 0) != 12L)
                return -1;
              x15 = XVECEXP (x4, 0, 6);
              if (XWINT (x15, 0) != 6L)
                return -1;
              x16 = XVECEXP (x4, 0, 7);
              if (XWINT (x16, 0) != 14L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8DFmode:
                  if (pattern1485 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0)
                    return -1;
                  x12 = XEXP (x2, 1);
                  operands[2] = x12;
                  if (nonimmediate_operand (operands[1], E_V8DFmode))
                    {
                      operands[3] = x5;
                      x10 = XEXP (x3, 0);
                      x11 = XEXP (x10, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13424 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                        return 4732; /* avx512f_movddup512_mask */
                    }
                  operands[3] = x12;
                  if (!register_operand (operands[1], E_V8DFmode))
                    return -1;
                  x10 = XEXP (x3, 0);
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  if (!nonimmediate_operand (operands[2], E_V8DFmode))
                    return -1;
                  operands[4] = x5;
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 4734; /* avx512f_unpcklpd512_mask */

                case E_V8DImode:
                  if (pattern1486 (x2, 
E_V8DImode, 
E_V16DImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14517 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return -1;
                  return 6553; /* avx512f_interleave_lowv8di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (pattern1518 (x4) != 0
              || pattern1648 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11382 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4590; /* avx_movsldup256_mask */

        default:
          return -1;
        }

    case 1L:
      x8 = XVECEXP (x4, 0, 2);
      if (XWINT (x8, 0) != 3L)
        return -1;
      x13 = XVECEXP (x4, 0, 4);
      if (XWINT (x13, 0) != 5L)
        return -1;
      x15 = XVECEXP (x4, 0, 6);
      if (XWINT (x15, 0) != 7L)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      switch (XWINT (x7, 0))
        {
        case 1L:
          x9 = XVECEXP (x4, 0, 3);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x14 = XVECEXP (x4, 0, 5);
          if (XWINT (x14, 0) != 5L)
            return -1;
          x16 = XVECEXP (x4, 0, 7);
          if (XWINT (x16, 0) != 7L
              || pattern1648 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11329 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4584; /* avx_movshdup256_mask */

        case 9L:
          x9 = XVECEXP (x4, 0, 3);
          if (XWINT (x9, 0) != 11L)
            return -1;
          x14 = XVECEXP (x4, 0, 5);
          if (XWINT (x14, 0) != 13L)
            return -1;
          x16 = XVECEXP (x4, 0, 7);
          if (XWINT (x16, 0) != 15L)
            return -1;
          x10 = XEXP (x3, 0);
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x2, 1);
          operands[3] = x12;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8DFmode:
              if (pattern1432 (x2, 
E_V8DFmode, 
E_V16DFmode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4726; /* avx512f_unpckhpd512_mask */

            case E_V8DImode:
              if (pattern1432 (x2, 
E_V8DImode, 
E_V16DImode) != 0
                  || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14467 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6547; /* avx512f_interleave_highv8di_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4L:
      x7 = XVECEXP (x4, 0, 1);
      if (XWINT (x7, 0) != 12L)
        return -1;
      x8 = XVECEXP (x4, 0, 2);
      if (XWINT (x8, 0) != 5L)
        return -1;
      x9 = XVECEXP (x4, 0, 3);
      if (XWINT (x9, 0) != 13L
          || pattern1577 (x2) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern1433 (x2, 
E_V8HImode, 
E_V16HImode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7687; /* vec_interleave_highv8hi_mask */

        case E_V8HFmode:
          if (pattern1433 (x2, 
E_V8HFmode, 
E_V16HFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7689; /* vec_interleave_highv8hf_mask */

        case E_V8BFmode:
          if (pattern1433 (x2, 
E_V8BFmode, 
E_V16BFmode) != 0
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19622 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL && TARGET_AVX512BW)))
            return -1;
          return 7691; /* vec_interleave_highv8bf_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      switch (pattern573 (x2))
        {
        case 0:
          if (pattern1248 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3246; /* fma_fmadd_v32hf_maskz_1 */

        case 1:
          if (pattern1248 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3250; /* fma_fmadd_v16hf_maskz_1 */

        case 2:
          if (pattern1248 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3252; /* fma_fmadd_v8hf_maskz_1 */

        case 3:
          if (pattern1248 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3256; /* fma_fmadd_v16sf_maskz_1 */

        case 4:
          if (pattern1248 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3260; /* fma_fmadd_v8sf_maskz_1 */

        case 5:
          if (pattern1248 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3262; /* fma_fmadd_v4sf_maskz_1 */

        case 6:
          if (pattern1248 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3265; /* fma_fmadd_v8df_maskz_1 */

        case 7:
          if (pattern1248 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3269; /* fma_fmadd_v4df_maskz_1 */

        case 8:
          if (pattern1248 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3271; /* fma_fmadd_v2df_maskz_1 */

        case 9:
          if (pattern1250 (x2, 
E_SImode, 
E_V32BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9914; /* avx10_2_fmaddbf16_v32bf_maskz_1 */

        case 10:
          if (pattern1250 (x2, 
E_HImode, 
E_V16BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9916; /* avx10_2_fmaddbf16_v16bf_maskz_1 */

        case 11:
          if (pattern1250 (x2, 
E_QImode, 
E_V8BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9918; /* avx10_2_fmaddbf16_v8bf_maskz_1 */

        case 12:
          if (pattern1251 (x2, 
E_V4SFmode) != 0
              || !
#line 6959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4))
            return -1;
          return 3723; /* *fma4i_vmfmadd_v4sf */

        case 13:
          if (pattern1251 (x2, 
E_V2DFmode) != 0
              || !(
#line 6959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3724; /* *fma4i_vmfmadd_v2df */

        case 14:
          if (pattern1174 (x2, 
E_V32HFmode, 
E_SImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V32HFmode)
              && vector_operand (operands[3], E_V32HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 3272; /* avx512bw_fmadd_v32hf_mask */
            }
          if (!vector_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[3], E_V32HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3284; /* avx512bw_fmadd_v32hf_mask3 */

        case 15:
          if (pattern1174 (x2, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16HFmode)
              && vector_operand (operands[3], E_V16HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3274; /* avx512vl_fmadd_v16hf_mask */
            }
          if (!vector_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3286; /* avx512vl_fmadd_v16hf_mask3 */

        case 16:
          if (pattern1174 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8HFmode)
              && vector_operand (operands[3], E_V8HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3275; /* avx512fp16_fmadd_v8hf_mask */
            }
          if (!vector_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[3], E_V8HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3288; /* avx512fp16_fmadd_v8hf_mask3 */

        case 17:
          if (pattern1174 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16SFmode)
              && vector_operand (operands[3], E_V16SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3276; /* avx512f_fmadd_v16sf_mask */
            }
          if (!vector_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[3], E_V16SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3290; /* avx512f_fmadd_v16sf_mask3 */

        case 18:
          if (pattern1174 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && vector_operand (operands[3], E_V8SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3278; /* avx512vl_fmadd_v8sf_mask */
            }
          if (!vector_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3292; /* avx512vl_fmadd_v8sf_mask3 */

        case 19:
          if (pattern1174 (x2, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && vector_operand (operands[3], E_V4SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3279; /* avx512vl_fmadd_v4sf_mask */
            }
          if (!vector_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[3], E_V4SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3294; /* avx512vl_fmadd_v4sf_mask3 */

        case 20:
          if (pattern1174 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8DFmode)
              && vector_operand (operands[3], E_V8DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3280; /* avx512f_fmadd_v8df_mask */
            }
          if (!vector_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[3], E_V8DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3296; /* avx512f_fmadd_v8df_mask3 */

        case 21:
          if (pattern1174 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && vector_operand (operands[3], E_V4DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3282; /* avx512vl_fmadd_v4df_mask */
            }
          if (!vector_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3298; /* avx512vl_fmadd_v4df_mask3 */

        case 22:
          if (pattern1174 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && vector_operand (operands[3], E_V2DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5987 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3283; /* avx512vl_fmadd_v2df_mask */
            }
          if (!vector_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[3], E_V2DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6004 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3300; /* avx512vl_fmadd_v2df_mask3 */

        case 23:
          if (pattern1175 (x2, 
E_SImode, 
E_V32BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 32161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9919; /* avx10_2_fmaddbf16_v32bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !
#line 32178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9922; /* avx10_2_fmaddbf16_v32bf_mask3 */

        case 24:
          if (pattern1175 (x2, 
E_HImode, 
E_V16BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 32161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9920; /* avx10_2_fmaddbf16_v16bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !
#line 32178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9923; /* avx10_2_fmaddbf16_v16bf_mask3 */

        case 25:
          if (pattern1175 (x2, 
E_QImode, 
E_V8BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 32161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return 9921; /* avx10_2_fmaddbf16_v8bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !
#line 32178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9924; /* avx10_2_fmaddbf16_v8bf_mask3 */

        case 26:
          if (pattern1252 (x2, 
E_V8HFmode) != 0
              || !(
#line 6600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 3627; /* *fmai_fmadd_v8hf */

        case 27:
          if (pattern1252 (x2, 
E_V4SFmode) != 0
              || !
#line 6600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
            return -1;
          return 3629; /* *fmai_fmadd_v4sf */

        case 28:
          if (pattern1252 (x2, 
E_V2DFmode) != 0
              || !(
#line 6600 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3631; /* *fmai_fmadd_v2df */

        case 29:
          return recog_142 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case NEG:
      return recog_144 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern132 (x2))
        {
        case 0:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6589; /* avx512f_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15210 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 6625; /* avx512vl_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6592; /* avx512f_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6595; /* avx512f_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 6598; /* avx512f_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6622; /* avx512vl_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15193 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 6605; /* avx512bw_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15293 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 6619; /* avx512vl_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          if (XWINT (x5, 0) != 16L)
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              switch (pattern1012 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 6913; /* *smulv32hi3_highpart_mask */

                case 1:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                    return -1;
                  return 6917; /* *smulv16hi3_highpart_mask */

                case 2:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
                    return -1;
                  return 6921; /* *smulv8hi3_highpart_mask */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern1012 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 6915; /* *umulv32hi3_highpart_mask */

                case 1:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                    return -1;
                  return 6919; /* *umulv16hi3_highpart_mask */

                case 2:
                  if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16406 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW)))
                    return -1;
                  return 6923; /* *umulv8hi3_highpart_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (GET_CODE (x11) != ZERO_EXTEND)
                return -1;
              x12 = XEXP (x10, 0);
              operands[1] = x12;
              x13 = XEXP (x11, 0);
              operands[2] = x13;
              x14 = XEXP (x6, 1);
              operands[5] = x14;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V64QImode:
                  if (pattern1401 (x2, 
E_DImode, 
E_V64QImode, 
E_V64HImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7830; /* *avx512bw_uavgv64qi3_mask */

                case E_V32QImode:
                  if (pattern1401 (x2, 
E_SImode, 
E_V32QImode, 
E_V32HImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 739 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                    return -1;
                  return 7832; /* *avx2_uavgv32qi3_mask */

                case E_V16QImode:
                  if (pattern1401 (x2, 
E_HImode, 
E_V16QImode, 
E_V16HImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
                    return -1;
                  return 7834; /* *sse2_uavgv16qi3_mask */

                case E_V32HImode:
                  if (pattern1401 (x2, 
E_SImode, 
E_V32HImode, 
E_V32SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7836; /* *avx512bw_uavgv32hi3_mask */

                case E_V16HImode:
                  if (pattern1401 (x2, 
E_HImode, 
E_V16HImode, 
E_V16SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 740 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                    return -1;
                  return 7838; /* *avx2_uavgv16hi3_mask */

                case E_V8HImode:
                  if (pattern1401 (x2, 
E_QImode, 
E_V8HImode, 
E_V8SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 21876 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
                    return -1;
                  return 7840; /* *sse2_uavgv8hi3_mask */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != MULT)
                return -1;
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != SIGN_EXTEND)
                return -1;
              x15 = XEXP (x10, 1);
              if (GET_CODE (x15) != SIGN_EXTEND)
                return -1;
              x11 = XEXP (x9, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
                return -1;
              x16 = XEXP (x12, 0);
              operands[1] = x16;
              if (nonimmediate_operand (operands[1], E_V32HImode))
                {
                  res = recog_161 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x17 = XEXP (x15, 0);
              operands[2] = x17;
              x14 = XEXP (x6, 1);
              operands[3] = x14;
              x7 = XEXP (x2, 1);
              operands[4] = x7;
              x8 = XEXP (x2, 2);
              operands[5] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HImode:
                  if (pattern1489 (x2, 
E_SImode, 
E_V32HImode, 
E_V32SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7911; /* *avx512bw_pmulhrswv32hi3_mask */

                case E_V16HImode:
                  if (pattern1489 (x2, 
E_HImode, 
E_V16HImode, 
E_V16SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 22982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 652 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))))
                    return -1;
                  return 7913; /* *avx2_pmulhrswv16hi3_mask */

                case E_V8HImode:
                  if (pattern1489 (x2, 
E_QImode, 
E_V8HImode, 
E_V8SImode) != 0
                      || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 22982 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
                    return -1;
                  return 7915; /* *ssse3_pmulhrswv8hi3_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern130 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4013; /* avx512fp16_fix_truncv8hi2_mask */

    case 1:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4021; /* avx512fp16_fix_truncv16hi2_mask */

    case 2:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 693 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4029; /* avx512fp16_fix_truncv32hi2_mask */

    case 3:
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4037; /* avx512fp16_fix_truncv8si2_mask */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8783 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4265; /* fix_truncv8sfv8si2_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4381; /* fix_truncv8dfv8si2_mask */

        default:
          return -1;
        }

    case 4:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4045; /* avx512fp16_fix_truncv16si2_mask */

    case 5:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8764 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4256; /* fix_truncv16sfv16si2_mask */

    case 6:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7869 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4053; /* avx512fp16_fix_truncv8di2_mask */

    case 7:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4418; /* fix_truncv8dfv8di2_mask */

    case 8:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4462; /* fix_truncv8sfv8di2_mask */

    case 9:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4076; /* *avx512fp16_fix_truncv4si2_load_mask */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8813 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4269; /* fix_truncv4sfv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F))))
            return -1;
          return 4395; /* fix_truncv4dfv4si2_mask */

        default:
          return -1;
        }

    case 10:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7919 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4080; /* *avx512fp16_fix_truncv4di2_load_mask */

    case 11:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4425; /* fix_truncv4dfv4di2_mask */

    case 12:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9729 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 626 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4469; /* fix_truncv4sfv4di2_mask */

    case 13:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4092; /* *avx512fp16_fix_truncv2di2_load_mask */

    case 14:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9686 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4429; /* fix_truncv2dfv2di2_mask */

    case 15:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4068; /* avx512fp16_fix_truncv4si2_mask */

    case 16:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7909 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4072; /* avx512fp16_fix_truncv4di2_mask */

    case 17:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4088; /* avx512fp16_fix_truncv2di2_mask */

    case 18:
      if (!(
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 4477; /* avx512dq_fix_truncv2sfv2di2_mask */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 2915 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2354; /* avx_rcpv8sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !
#line 2915 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2355; /* sse_rcpv4sf2 */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !nonimmediate_operand (operands[1], E_V32HFmode)
          || !(
#line 2969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2358; /* avx512fp16_rcpv32hf2 */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !nonimmediate_operand (operands[1], E_V16HFmode)
          || !(
#line 2969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2360; /* avx512fp16_rcpv16hf2 */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !nonimmediate_operand (operands[1], E_V8HFmode)
          || !(
#line 2969 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2362; /* avx512fp16_rcpv8hf2 */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !
#line 32404 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9973; /* avx10_2_rcpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32404 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9975; /* avx10_2_rcpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32404 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9977; /* avx10_2_rcpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2243; /* avx512fp16_vmaddv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2251; /* sse_vmaddv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2259; /* sse2_vmaddv2df3_mask_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2247; /* avx512fp16_vmsubv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2255; /* sse_vmsubv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2263; /* sse2_vmsubv2df3_mask_round */

        default:
          return -1;
        }

    case MULT:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2309; /* avx512fp16_vmmulv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2317; /* sse_vmmulv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2325; /* sse2_vmmulv2df3_mask_round */

        default:
          return -1;
        }

    case DIV:
      switch (pattern712 (x2))
        {
        case 0:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2313; /* avx512fp16_vmdivv8hf3_mask_round */

        case 1:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2321; /* sse_vmdivv4sf3_mask_round */

        case 2:
          if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2804 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2329; /* sse2_vmdivv2df3_mask_round */

        default:
          return -1;
        }

    case SQRT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 2);
      operands[4] = x9;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1402 (x2, 
E_V8HFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2410; /* avx512fp16_vmsqrtv8hf2_mask_round */

        case E_V4SFmode:
          if (pattern1402 (x2, 
E_V4SFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2414; /* sse_vmsqrtv4sf2_mask_round */

        case E_V2DFmode:
          if (pattern1402 (x2, 
E_V2DFmode) != 0
              || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3086 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2418; /* sse2_vmsqrtv2df2_mask_round */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SQRT:
          x6 = XEXP (x3, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1434 (x2, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                return -1;
              return 2422; /* *avx512fp16_vmsqrtv8hf2_mask_round */

            case E_V4SFmode:
              if (pattern1434 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
                return -1;
              return 2426; /* *sse_vmsqrtv4sf2_mask_round */

            case E_V2DFmode:
              if (pattern1434 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3105 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                return -1;
              return 2430; /* *sse2_vmsqrtv2df2_mask_round */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_HFmode
              || pattern1101 (x3) != 0)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 2);
          operands[4] = x9;
          if (!register_operand (operands[4], E_QImode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!const48_operand (operands[5], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern1608 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4153; /* avx512fp16_vcvtsh2sd_mask_round */

            case E_V4SFmode:
              if (pattern1608 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 4157; /* avx512fp16_vcvtsh2ss_mask_round */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (pattern1101 (x3) != 0
                  || pattern1336 (x2, 
E_HFmode, 
E_V8HFmode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              if (!nonimm_or_0_operand (operands[3], E_V8HFmode))
                return -1;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HFmode))
                return -1;
              switch (GET_MODE (x12))
                {
                case E_DFmode:
                  if (!register_operand (operands[1], E_V2DFmode)
                      || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4165; /* avx512fp16_vcvtsd2sh_mask_round */

                case E_SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8319 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 4169; /* avx512fp16_vcvtss2sh_mask_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              operands[2] = x12;
              if (!nonimmediate_operand (operands[2], E_V2DFmode))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern1336 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0)
                return -1;
              x8 = XEXP (x4, 1);
              operands[1] = x8;
              if (!register_operand (operands[1], E_V4SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              if (!nonimm_or_0_operand (operands[3], E_V4SFmode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_QImode)
                  || !(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9990 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 4496; /* sse2_cvtsd2ss_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2579; /* *avx512fp16_vmsmaxv8hf3_mask_round */

        case 1:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2587; /* *sse_vmsmaxv4sf3_mask_round */

        case 2:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2595; /* *sse2_vmsmaxv2df3_mask_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
            return -1;
          return 2583; /* *avx512fp16_vmsminv8hf3_mask_round */

        case 1:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
            return -1;
          return 2591; /* *sse_vmsminv4sf3_mask_round */

        case 2:
          if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3470 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2599; /* *sse2_vmsminv2df3_mask_round */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          switch (XINT (x5, 1))
            {
            case 63:
              switch (pattern1018 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2603; /* avx512fp16_ieee_vmmaxv8hf3_mask_round */

                case 1:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2611; /* sse_ieee_vmmaxv4sf3_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2619; /* sse2_ieee_vmmaxv2df3_mask_round */

                default:
                  return -1;
                }

            case 62:
              switch (pattern1018 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2607; /* avx512fp16_ieee_vmminv8hf3_mask_round */

                case 1:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))))
                    return -1;
                  return 2615; /* sse_ieee_vmminv4sf3_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3489 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2623; /* sse2_ieee_vmminv2df3_mask_round */

                default:
                  return -1;
                }

            case 221:
              if (pattern1019 (x2) != 0
                  || !(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3810; /* avx512fp16_fmulcsh_v8hf_mask_round */

            case 222:
              if (pattern1019 (x2) != 0
                  || !(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3814; /* avx512fp16_fcmulcsh_v8hf_mask_round */

            case 58:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1491 (x2))
                {
                case 0:
                  if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 4744; /* avx512f_vmscalefv8hf_mask_round */

                case 1:
                  if (!
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 4748; /* avx512f_vmscalefv4sf_mask_round */

                case 2:
                  if (!(
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13598 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 4752; /* avx512f_vmscalefv2df_mask_round */

                default:
                  return -1;
                }

            case 165:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[1] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[2] = x15;
              x8 = XEXP (x4, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (!register_operand (operands[4], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[5] = x11;
              if (!const48_operand (operands[5], E_SImode))
                return -1;
              switch (pattern1491 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14031 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6406; /* avx512f_sgetexpv8hf_mask_round */

                case 1:
                  if (!
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6410; /* avx512f_sgetexpv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14031 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6414; /* avx512f_sgetexpv2df_mask_round */

                default:
                  return -1;
                }

            case 94:
              if (XWINT (x6, 0) != 1L)
                return -1;
              x14 = XVECEXP (x5, 0, 0);
              operands[2] = x14;
              x15 = XVECEXP (x5, 0, 1);
              operands[3] = x15;
              if (!const_0_to_255_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[1] = x10;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HFmode:
                  if (pattern1578 (x2, 
E_V8HFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 6522; /* avx512f_rndscalev8hf_mask_round */

                case E_V4SFmode:
                  if (pattern1578 (x2, 
E_V4SFmode) != 0
                      || !
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6526; /* avx512f_rndscalev4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1578 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14225 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6530; /* avx512f_rndscalev2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          switch (XINT (x5, 1))
            {
            case 192:
              switch (pattern1272 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8HFmode))) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 2677; /* reducesv8hf_mask_round */

                case 1:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4SFmode))))))
                    return -1;
                  return 2681; /* reducesv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4044 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V2DFmode))) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 2685; /* reducesv2df_mask_round */

                default:
                  return -1;
                }

            case 217:
              switch (pattern1273 (x2))
                {
                case 0:
                  if (!(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 371 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3798; /* avx512fp16_fma_fmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3804; /* avx512fp16_fmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 219:
              switch (pattern1273 (x2))
                {
                case 0:
                  if (!(
#line 437 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 371 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                    return -1;
                  return 3802; /* avx512fp16_fma_fcmaddcsh_v8hf_maskz_round */

                case 1:
                  if (!(
#line 221 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7511 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
                    return -1;
                  return 3806; /* avx512fp16_fcmaddcsh_v8hf_mask_round */

                default:
                  return -1;
                }

            case 194:
              if (XWINT (x6, 0) != 1L
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x4, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 2);
              operands[5] = x9;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[6] = x11;
              if (!const48_operand (operands[6], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1270 (x2, 
E_V4SFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ))))
                    return -1;
                  return 9270; /* avx512dq_rangesv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1270 (x2, 
E_V2DFmode) != 0
                      || !(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9274; /* avx512dq_rangesv2df_mask_round */

                default:
                  return -1;
                }

            case 166:
              if (XWINT (x6, 0) != 1L
                  || !const_0_to_15_operand (operands[3], E_SImode))
                return -1;
              switch (pattern1271 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 9338; /* avx512f_vgetmantv8hf_mask_round */

                case 1:
                  if (!
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 9342; /* avx512f_vgetmantv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 9346; /* avx512f_vgetmantv2df_mask_round */

                default:
                  return -1;
                }

            case 278:
              switch (pattern1272 (x2))
                {
                case 0:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 478 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))))
                    return -1;
                  return 10220; /* avx10_2_minmaxsv8hf_mask_round */

                case 1:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))))
                    return -1;
                  return 10224; /* avx10_2_minmaxsv4sf_mask_round */

                case 2:
                  if (!(
#line 463 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 355 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32658 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2) && 
#line 479 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 10228; /* avx10_2_minmaxsv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          if (XINT (x5, 1) != 163)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x5, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x5, 0, 2);
          operands[3] = x16;
          x17 = XVECEXP (x5, 0, 3);
          operands[4] = x17;
          if (!const_0_to_255_operand (operands[4], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (!const48_operand (x11, E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x6 = XEXP (x3, 2);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x4, 2);
              operands[6] = x9;
              if (!register_operand (operands[6], E_QImode))
                return -1;
              operands[7] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1609 (x2, 
E_V4SFmode, 
E_V4SImode) != 0
                      || !
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6474; /* avx512f_sfixupimmv4sf_maskz_1_round */

                case E_V2DFmode:
                  if (pattern1609 (x2, 
E_V2DFmode, 
E_V2DImode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 154 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14180 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))))
                    return -1;
                  return 6478; /* avx512f_sfixupimmv2df_maskz_1_round */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[2]))
                return -1;
              x9 = XEXP (x4, 2);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x6 = XEXP (x3, 2);
              operands[5] = x6;
              if (!register_operand (operands[5], E_QImode))
                return -1;
              operands[6] = x11;
              x10 = XEXP (x3, 1);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1610 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F))
                    return -1;
                  return 6480; /* avx512f_sfixupimmv4sf_mask_round */

                case E_V2DFmode:
                  if (pattern1610 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14199 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
                    return -1;
                  return 6482; /* avx512f_sfixupimmv2df_mask_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      return recog_201 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x5) != E_V2DFmode)
        return -1;
      x7 = XEXP (x5, 0);
      if (pattern818 (x7, 
2, 
E_V2SFmode) != 0)
        return -1;
      x18 = XEXP (x7, 1);
      x19 = XVECEXP (x18, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern1339 (x2) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      if (!nonimm_or_0_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[4] = x6;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x11 = XVECEXP (x2, 0, 1);
      operands[5] = x11;
      if (!const48_operand (operands[5], E_SImode)
          || !(
#line 263 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10034 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 4501; /* sse2_cvtss2sd_mask_round */

    default:
      return -1;
    }
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern719 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8779; /* avx_maskloadps */

    case E_V2DFmode:
      if (pattern719 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8780; /* avx_maskloadpd */

    case E_V4DImode:
      if (pattern720 (x3, 
E_V4DImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8781; /* avx2_maskloadq256 */

    case E_V2DImode:
      if (pattern720 (x3, 
E_V2DImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8782; /* avx2_maskloadq */

    case E_V8SFmode:
      if (pattern719 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8783; /* avx_maskloadps256 */

    case E_V4DFmode:
      if (pattern719 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8784; /* avx_maskloadpd256 */

    case E_V8SImode:
      if (pattern720 (x3, 
E_V8SImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8785; /* avx2_maskloadd256 */

    case E_V4SImode:
      if (pattern720 (x3, 
E_V4SImode) != 0
          || !
#line 28612 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8786; /* avx2_maskloadd */

    default:
      return -1;
    }
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6407 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3499; /* *fma_fmaddsub_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3515; /* *fma_fmaddsub_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6407 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3500; /* *fma_fmaddsub_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3517; /* *fma_fmaddsub_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6407 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3501; /* *fma_fmaddsub_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3523; /* *fma_fmaddsub_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6407 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 3502; /* *fma_fmaddsub_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3525; /* *fma_fmaddsub_v2df */

        case E_V32HFmode:
          if (pattern599 (x3, 
E_V32HFmode) != 0
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3503; /* *fma_fmaddsub_v32hf */

        case E_V16HFmode:
          if (pattern599 (x3, 
E_V16HFmode) != 0
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3507; /* *fma_fmaddsub_v16hf */

        case E_V8HFmode:
          if (pattern599 (x3, 
E_V8HFmode) != 0
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3509; /* *fma_fmaddsub_v8hf */

        case E_V16SFmode:
          if (pattern599 (x3, 
E_V16SFmode) != 0
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3511; /* *fma_fmaddsub_v16sf */

        case E_V8DFmode:
          if (pattern599 (x3, 
E_V8DFmode) != 0
              || !(
#line 6425 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3519; /* *fma_fmaddsub_v8df */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || GET_MODE (x6) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && (
#line 6476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 421 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3563; /* *fma_fmsubadd_v8sf */
          if (!vector_operand (operands[1], E_V8SFmode)
              || !vector_operand (operands[2], E_V8SFmode)
              || !vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3579; /* *fma_fmsubadd_v8sf */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x6) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3564; /* *fma_fmsubadd_v4sf */
          if (!vector_operand (operands[1], E_V4SFmode)
              || !vector_operand (operands[2], E_V4SFmode)
              || !vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3581; /* *fma_fmsubadd_v4sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || GET_MODE (x6) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && (
#line 6476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return 3565; /* *fma_fmsubadd_v4df */
          if (!vector_operand (operands[1], E_V4DFmode)
              || !vector_operand (operands[2], E_V4DFmode)
              || !vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3587; /* *fma_fmsubadd_v4df */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || GET_MODE (x6) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && (
#line 6476 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4) && 
#line 422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return 3566; /* *fma_fmsubadd_v2df */
          if (!vector_operand (operands[1], E_V2DFmode)
              || !vector_operand (operands[2], E_V2DFmode)
              || !vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3589; /* *fma_fmsubadd_v2df */

        case E_V32HFmode:
          if (pattern932 (x3, 
E_V32HFmode) != 0
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 524 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3567; /* *fma_fmsubadd_v32hf */

        case E_V16HFmode:
          if (pattern932 (x3, 
E_V16HFmode) != 0
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 525 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3571; /* *fma_fmsubadd_v16hf */

        case E_V8HFmode:
          if (pattern932 (x3, 
E_V8HFmode) != 0
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 526 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3573; /* *fma_fmsubadd_v8hf */

        case E_V16SFmode:
          if (pattern932 (x3, 
E_V16SFmode) != 0
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 527 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3575; /* *fma_fmsubadd_v16sf */

        case E_V8DFmode:
          if (pattern932 (x3, 
E_V8DFmode) != 0
              || !(
#line 6495 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3583; /* *fma_fmsubadd_v8df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern144 (x3, 
E_V32HFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10181; /* avx10_2_minmaxpv32hf */

    case E_V16HFmode:
      if (pattern144 (x3, 
E_V16HFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10185; /* avx10_2_minmaxpv16hf */

    case E_V8HFmode:
      if (pattern144 (x3, 
E_V8HFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10189; /* avx10_2_minmaxpv8hf */

    case E_V16SFmode:
      if (pattern144 (x3, 
E_V16SFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10193; /* avx10_2_minmaxpv16sf */

    case E_V8SFmode:
      if (pattern144 (x3, 
E_V8SFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10197; /* avx10_2_minmaxpv8sf */

    case E_V4SFmode:
      if (pattern144 (x3, 
E_V4SFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10201; /* avx10_2_minmaxpv4sf */

    case E_V8DFmode:
      if (pattern144 (x3, 
E_V8DFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10205; /* avx10_2_minmaxpv8df */

    case E_V4DFmode:
      if (pattern144 (x3, 
E_V4DFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10209; /* avx10_2_minmaxpv4df */

    case E_V2DFmode:
      if (pattern144 (x3, 
E_V2DFmode) != 0
          || !
#line 32643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 10213; /* avx10_2_minmaxpv2df */

    default:
      return -1;
    }
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (pattern64 (x3, 
E_V16SImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6415; /* *avx512f_alignv16si */

    case E_V8SImode:
      if (pattern64 (x3, 
E_V8SImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6417; /* *avx512vl_alignv8si */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6419; /* *avx512vl_alignv4si */

    case E_V8DImode:
      if (pattern64 (x3, 
E_V8DImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6421; /* *avx512f_alignv8di */

    case E_V4DImode:
      if (pattern64 (x3, 
E_V4DImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6423; /* *avx512vl_alignv4di */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !(
#line 14042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6425; /* *avx512vl_alignv2di */

    default:
      return -1;
    }
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9504; /* vpshrdv_v32hi */

    case 1:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9505; /* vpshrdv_v16si */

    case 2:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9506; /* vpshrdv_v8di */

    case 3:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9507; /* vpshrdv_v16hi */

    case 4:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9508; /* vpshrdv_v8si */

    case 5:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9509; /* vpshrdv_v4di */

    case 6:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9510; /* vpshrdv_v8hi */

    case 7:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9511; /* vpshrdv_v4si */

    case 8:
      if (!(
#line 30408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9512; /* vpshrdv_v2di */

    default:
      return -1;
    }
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !nonimmediate_operand (operands[2], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 11661 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 4603; /* sse_loadlps */

        case E_V4DImode:
          if (pattern1110 (x2, 
E_V4DImode, 
E_V2DImode) != 0
              || !
#line 28423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 8755; /* vec_set_lo_v4di */

        case E_V4DFmode:
          if (pattern1110 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
              || !
#line 28423 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 8757; /* vec_set_lo_v4df */

        default:
          return -1;
        }

    case 1:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !nonimmediate_operand (operands[2], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !nonimm_or_0_operand (operands[1], E_V2DFmode)
          || !
#line 14773 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 6563; /* sse2_loadlpd */

    case 8:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 10]
          || pattern1111 (x4, 
15, 
14, 
13, 
12, 
11) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1110 (x2, 
E_V16SFmode, 
E_V8SFmode) != 0
              || !(
#line 20081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7740; /* vec_set_lo_v16sf */

        case E_V16SImode:
          if (pattern1110 (x2, 
E_V16SImode, 
E_V8SImode) != 0
              || !(
#line 20081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7742; /* vec_set_lo_v16si */

        case E_V16HImode:
          if (pattern1110 (x2, 
E_V16HImode, 
E_V8HImode) != 0
              || !
#line 28520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8771; /* vec_set_lo_v16hi */

        case E_V16HFmode:
          if (pattern1110 (x2, 
E_V16HFmode, 
E_V8HFmode) != 0
              || !
#line 28520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8772; /* vec_set_lo_v16hf */

        case E_V16BFmode:
          if (pattern1110 (x2, 
E_V16BFmode, 
E_V8BFmode) != 0
              || !
#line 28520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8773; /* vec_set_lo_v16bf */

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1110 (x2, 
E_V8DFmode, 
E_V4DFmode) != 0
              || !(
#line 20113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7748; /* vec_set_lo_v8df */

        case E_V8DImode:
          if (pattern1110 (x2, 
E_V8DImode, 
E_V4DImode) != 0
              || !(
#line 20113 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7750; /* vec_set_lo_v8di */

        case E_V8SImode:
          if (pattern1110 (x2, 
E_V8SImode, 
E_V4SImode) != 0
              || !
#line 28472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8763; /* vec_set_lo_v8si */

        case E_V8SFmode:
          if (pattern1110 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
              || !
#line 28472 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 8765; /* vec_set_lo_v8sf */

        default:
          return -1;
        }

    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 17])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 18]
          || pattern1111 (x4, 
23, 
22, 
21, 
20, 
19) != 0)
        return -1;
      x11 = XVECEXP (x4, 0, 8);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
        return -1;
      x12 = XVECEXP (x4, 0, 9);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 25])
        return -1;
      x13 = XVECEXP (x4, 0, 10);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 26])
        return -1;
      x14 = XVECEXP (x4, 0, 11);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 27])
        return -1;
      x15 = XVECEXP (x4, 0, 12);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 28])
        return -1;
      x16 = XVECEXP (x4, 0, 13);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 29])
        return -1;
      x17 = XVECEXP (x4, 0, 14);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 30])
        return -1;
      x18 = XVECEXP (x4, 0, 15);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || pattern1110 (x2, 
E_V32QImode, 
E_V16QImode) != 0
          || !
#line 28568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
        return -1;
      return 8777; /* vec_set_lo_v32qi */

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 46:
          if (GET_MODE (x3) == E_V4SImode
              && pattern727 (x2, 
E_V4SImode, 
E_V4DFmode, 
E_V8SImode) == 0
              && 
#line 9419 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX))
            return 4356; /* *avx_cvtpd2dq256_2 */
          if (GET_MODE (x3) != E_V2SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || pattern449 (x5, 
E_V2SImode, 
2) != 0
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vector_operand (operands[1], E_V2DFmode)
              || !
#line 9432 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4357; /* sse2_cvtpd2dq */

        case 156:
          if (pattern602 (x2) != 0
              || !
#line 9502 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4368; /* fixuns_notruncv2dfv2si2 */

        case 173:
          if (pattern602 (x2) != 0
              || !
#line 9569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 4387; /* *unspec_fixuns_truncv2dfv2si2 */

        case 253:
          if (GET_MODE (x3) != E_V8QImode
              || pattern727 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9778; /* *vcvtph2bf8v8hf */

        case 254:
          if (GET_MODE (x3) != E_V8QImode
              || pattern727 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9779; /* *vcvtph2bf8sv8hf */

        case 255:
          if (GET_MODE (x3) != E_V8QImode
              || pattern727 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9780; /* *vcvtph2hf8v8hf */

        case 256:
          if (GET_MODE (x3) != E_V8QImode
              || pattern727 (x2, 
E_V8QImode, 
E_V8HFmode, 
E_V16QImode) != 0
              || !
#line 31862 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9781; /* *vcvtph2hf8sv8hf */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const0_operand (operands[3], E_V4HImode)
              || !
#line 29135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((TARGET_F16C || TARGET_AVX512VL) && 1))
            return -1;
          return 8950; /* *vcvtps2ph */

        case 245:
          if (pattern832 (x2) != 0
              || !
#line 31772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9754; /* *vcvtbiasph2bf8v8hf */

        case 246:
          if (pattern832 (x2) != 0
              || !
#line 31772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9755; /* *vcvtbiasph2bf8sv8hf */

        case 247:
          if (pattern832 (x2) != 0
              || !
#line 31772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9756; /* *vcvtbiasph2hf8v8hf */

        case 248:
          if (pattern832 (x2) != 0
              || !
#line 31772 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9757; /* *vcvtbiasph2hf8sv8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 5918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3241; /* *fma_fmadd_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3261; /* *fma_fmadd_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 5918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3242; /* *fma_fmadd_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3270; /* *fma_fmadd_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 5918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3243; /* *fma_fmadd_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3259; /* *fma_fmadd_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 5918 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3244; /* *fma_fmadd_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3268; /* *fma_fmadd_v4df */

        case E_V32HFmode:
          if (pattern787 (x2, 
E_V32HFmode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3245; /* *fma_fmadd_v32hf */

        case E_V16HFmode:
          if (pattern787 (x2, 
E_V16HFmode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3249; /* *fma_fmadd_v16hf */

        case E_V8HFmode:
          if (pattern787 (x2, 
E_V8HFmode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3251; /* *fma_fmadd_v8hf */

        case E_V16SFmode:
          if (pattern787 (x2, 
E_V16SFmode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3255; /* *fma_fmadd_v16sf */

        case E_V8DFmode:
          if (pattern787 (x2, 
E_V8DFmode) != 0
              || !(
#line 5946 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3264; /* *fma_fmadd_v8df */

        case E_V32BFmode:
          if (pattern834 (x2, 
E_V32BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9913; /* avx10_2_fmaddbf16_v32bf */

        case E_V16BFmode:
          if (pattern834 (x2, 
E_V16BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9915; /* avx10_2_fmaddbf16_v16bf */

        case E_V8BFmode:
          if (pattern834 (x2, 
E_V8BFmode) != 0
              || !
#line 32143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9917; /* avx10_2_fmaddbf16_v8bf */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x4) != E_V4SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && nonimmediate_operand (operands[2], E_V4SFmode)
              && nonimmediate_operand (operands[3], E_V4SFmode)
              && 
#line 6017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3304; /* *fma_fmsub_v4sf */
          if (!bcst_vector_operand (operands[1], E_V4SFmode)
              || !bcst_vector_operand (operands[2], E_V4SFmode)
              || !bcst_vector_operand (operands[3], E_V4SFmode)
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3324; /* *fma_fmsub_v4sf */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x4) != E_V2DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && nonimmediate_operand (operands[2], E_V2DFmode)
              && nonimmediate_operand (operands[3], E_V2DFmode)
              && 
#line 6017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3305; /* *fma_fmsub_v2df */
          if (!bcst_vector_operand (operands[1], E_V2DFmode)
              || !bcst_vector_operand (operands[2], E_V2DFmode)
              || !bcst_vector_operand (operands[3], E_V2DFmode)
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3333; /* *fma_fmsub_v2df */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x4) != E_V8SFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && nonimmediate_operand (operands[2], E_V8SFmode)
              && nonimmediate_operand (operands[3], E_V8SFmode)
              && 
#line 6017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3306; /* *fma_fmsub_v8sf */
          if (!bcst_vector_operand (operands[1], E_V8SFmode)
              || !bcst_vector_operand (operands[2], E_V8SFmode)
              || !bcst_vector_operand (operands[3], E_V8SFmode)
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3322; /* *fma_fmsub_v8sf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x4) != E_V4DFmode)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && nonimmediate_operand (operands[2], E_V4DFmode)
              && nonimmediate_operand (operands[3], E_V4DFmode)
              && 
#line 6017 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_FMA4))
            return 3307; /* *fma_fmsub_v4df */
          if (!bcst_vector_operand (operands[1], E_V4DFmode)
              || !bcst_vector_operand (operands[2], E_V4DFmode)
              || !bcst_vector_operand (operands[3], E_V4DFmode)
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5938 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3331; /* *fma_fmsub_v4df */

        case E_V32HFmode:
          if (pattern788 (x2, 
E_V32HFmode) != 0
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5931 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3308; /* *fma_fmsub_v32hf */

        case E_V16HFmode:
          if (pattern788 (x2, 
E_V16HFmode) != 0
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3312; /* *fma_fmsub_v16hf */

        case E_V8HFmode:
          if (pattern788 (x2, 
E_V8HFmode) != 0
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5933 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3314; /* *fma_fmsub_v8hf */

        case E_V16SFmode:
          if (pattern788 (x2, 
E_V16SFmode) != 0
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5935 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3318; /* *fma_fmsub_v16sf */

        case E_V8DFmode:
          if (pattern788 (x2, 
E_V8DFmode) != 0
              || !(
#line 6049 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && 1) && 
#line 5937 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3327; /* *fma_fmsub_v8df */

        case E_V32BFmode:
          if (pattern835 (x2, 
E_V32BFmode) != 0
              || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9937; /* avx10_2_fmsubbf16_v32bf */

        case E_V16BFmode:
          if (pattern835 (x2, 
E_V16BFmode) != 0
              || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9939; /* avx10_2_fmsubbf16_v16bf */

        case E_V8BFmode:
          if (pattern835 (x2, 
E_V8BFmode) != 0
              || !
#line 32271 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9941; /* avx10_2_fmsubbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern607 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 32);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 33);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 34);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 35);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 36);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 37);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 38);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 39);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 40);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 41);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 42);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 43);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 44);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 45);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 46);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 47);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x3, 0, 48);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x3, 0, 49);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x3, 0, 50);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x3, 0, 51);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x3, 0, 52);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x3, 0, 53);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x3, 0, 54);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x3, 0, 55);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x3, 0, 56);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x3, 0, 57);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x3, 0, 58);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x3, 0, 59);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x3, 0, 60);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x3, 0, 61);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  x34 = XVECEXP (x3, 0, 62);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XVECEXP (x3, 0, 63);
  if (GET_CODE (x35) != CONST_INT
      || pattern1470 (x2, 
E_V64QImode, 
E_V128QImode) != 0)
    return -1;
  x36 = XVECEXP (x3, 0, 0);
  switch (XWINT (x36, 0))
    {
    case 8L:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 72L)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 9L)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 73L)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 10L)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 74L)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 11L)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 75L)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 12L)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 76L)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 13L)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 77L)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 14L)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 78L)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 15L)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 79L)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 24L)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 88L)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 25L)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 89L)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 26L)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 90L)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 27L)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 91L)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 28L)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 92L)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 29L)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 93L)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 30L)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 94L)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 31L)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 95L
          || XWINT (x4, 0) != 40L
          || XWINT (x5, 0) != 104L
          || XWINT (x6, 0) != 41L
          || XWINT (x7, 0) != 105L
          || XWINT (x8, 0) != 42L
          || XWINT (x9, 0) != 106L
          || XWINT (x10, 0) != 43L
          || XWINT (x11, 0) != 107L
          || XWINT (x12, 0) != 44L
          || XWINT (x13, 0) != 108L
          || XWINT (x14, 0) != 45L
          || XWINT (x15, 0) != 109L
          || XWINT (x16, 0) != 46L
          || XWINT (x17, 0) != 110L
          || XWINT (x18, 0) != 47L
          || XWINT (x19, 0) != 111L
          || XWINT (x20, 0) != 56L
          || XWINT (x21, 0) != 120L
          || XWINT (x22, 0) != 57L
          || XWINT (x23, 0) != 121L
          || XWINT (x24, 0) != 58L
          || XWINT (x25, 0) != 122L
          || XWINT (x26, 0) != 59L
          || XWINT (x27, 0) != 123L
          || XWINT (x28, 0) != 60L
          || XWINT (x29, 0) != 124L
          || XWINT (x30, 0) != 61L
          || XWINT (x31, 0) != 125L
          || XWINT (x32, 0) != 62L
          || XWINT (x33, 0) != 126L
          || XWINT (x34, 0) != 63L
          || XWINT (x35, 0) != 127L
          || !
#line 19410 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7662; /* avx512bw_interleave_highv64qi */

    case 0L:
      x37 = XVECEXP (x3, 0, 1);
      if (XWINT (x37, 0) != 64L)
        return -1;
      x38 = XVECEXP (x3, 0, 2);
      if (XWINT (x38, 0) != 1L)
        return -1;
      x39 = XVECEXP (x3, 0, 3);
      if (XWINT (x39, 0) != 65L)
        return -1;
      x40 = XVECEXP (x3, 0, 4);
      if (XWINT (x40, 0) != 2L)
        return -1;
      x41 = XVECEXP (x3, 0, 5);
      if (XWINT (x41, 0) != 66L)
        return -1;
      x42 = XVECEXP (x3, 0, 6);
      if (XWINT (x42, 0) != 3L)
        return -1;
      x43 = XVECEXP (x3, 0, 7);
      if (XWINT (x43, 0) != 67L)
        return -1;
      x44 = XVECEXP (x3, 0, 8);
      if (XWINT (x44, 0) != 4L)
        return -1;
      x45 = XVECEXP (x3, 0, 9);
      if (XWINT (x45, 0) != 68L)
        return -1;
      x46 = XVECEXP (x3, 0, 10);
      if (XWINT (x46, 0) != 5L)
        return -1;
      x47 = XVECEXP (x3, 0, 11);
      if (XWINT (x47, 0) != 69L)
        return -1;
      x48 = XVECEXP (x3, 0, 12);
      if (XWINT (x48, 0) != 6L)
        return -1;
      x49 = XVECEXP (x3, 0, 13);
      if (XWINT (x49, 0) != 70L)
        return -1;
      x50 = XVECEXP (x3, 0, 14);
      if (XWINT (x50, 0) != 7L)
        return -1;
      x51 = XVECEXP (x3, 0, 15);
      if (XWINT (x51, 0) != 71L)
        return -1;
      x52 = XVECEXP (x3, 0, 16);
      if (XWINT (x52, 0) != 16L)
        return -1;
      x53 = XVECEXP (x3, 0, 17);
      if (XWINT (x53, 0) != 80L)
        return -1;
      x54 = XVECEXP (x3, 0, 18);
      if (XWINT (x54, 0) != 17L)
        return -1;
      x55 = XVECEXP (x3, 0, 19);
      if (XWINT (x55, 0) != 81L)
        return -1;
      x56 = XVECEXP (x3, 0, 20);
      if (XWINT (x56, 0) != 18L)
        return -1;
      x57 = XVECEXP (x3, 0, 21);
      if (XWINT (x57, 0) != 82L)
        return -1;
      x58 = XVECEXP (x3, 0, 22);
      if (XWINT (x58, 0) != 19L)
        return -1;
      x59 = XVECEXP (x3, 0, 23);
      if (XWINT (x59, 0) != 83L)
        return -1;
      x60 = XVECEXP (x3, 0, 24);
      if (XWINT (x60, 0) != 20L)
        return -1;
      x61 = XVECEXP (x3, 0, 25);
      if (XWINT (x61, 0) != 84L)
        return -1;
      x62 = XVECEXP (x3, 0, 26);
      if (XWINT (x62, 0) != 21L)
        return -1;
      x63 = XVECEXP (x3, 0, 27);
      if (XWINT (x63, 0) != 85L)
        return -1;
      x64 = XVECEXP (x3, 0, 28);
      if (XWINT (x64, 0) != 22L)
        return -1;
      x65 = XVECEXP (x3, 0, 29);
      if (XWINT (x65, 0) != 86L)
        return -1;
      x66 = XVECEXP (x3, 0, 30);
      if (XWINT (x66, 0) != 23L)
        return -1;
      x67 = XVECEXP (x3, 0, 31);
      if (XWINT (x67, 0) != 87L
          || XWINT (x4, 0) != 32L
          || XWINT (x5, 0) != 96L
          || XWINT (x6, 0) != 33L
          || XWINT (x7, 0) != 97L
          || XWINT (x8, 0) != 34L
          || XWINT (x9, 0) != 98L
          || XWINT (x10, 0) != 35L
          || XWINT (x11, 0) != 99L
          || XWINT (x12, 0) != 36L
          || XWINT (x13, 0) != 100L
          || XWINT (x14, 0) != 37L
          || XWINT (x15, 0) != 101L
          || XWINT (x16, 0) != 38L
          || XWINT (x17, 0) != 102L
          || XWINT (x18, 0) != 39L
          || XWINT (x19, 0) != 103L
          || XWINT (x20, 0) != 48L
          || XWINT (x21, 0) != 112L
          || XWINT (x22, 0) != 49L
          || XWINT (x23, 0) != 113L
          || XWINT (x24, 0) != 50L
          || XWINT (x25, 0) != 114L
          || XWINT (x26, 0) != 51L
          || XWINT (x27, 0) != 115L
          || XWINT (x28, 0) != 52L
          || XWINT (x29, 0) != 116L
          || XWINT (x30, 0) != 53L
          || XWINT (x31, 0) != 117L
          || XWINT (x32, 0) != 54L
          || XWINT (x33, 0) != 118L
          || XWINT (x34, 0) != 55L
          || XWINT (x35, 0) != 119L
          || !
#line 19506 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7668; /* avx512bw_interleave_lowv64qi */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[5] = x6;
  x7 = XVECEXP (x3, 0, 5);
  operands[7] = x7;
  x8 = XVECEXP (x3, 0, 6);
  operands[8] = x8;
  x9 = XVECEXP (x3, 0, 7);
  operands[9] = x9;
  x10 = XVECEXP (x3, 0, 8);
  operands[10] = x10;
  x11 = XVECEXP (x3, 0, 9);
  operands[11] = x11;
  x12 = XVECEXP (x3, 0, 10);
  operands[12] = x12;
  x13 = XVECEXP (x3, 0, 11);
  operands[13] = x13;
  x14 = XVECEXP (x3, 0, 12);
  operands[14] = x14;
  x15 = XVECEXP (x3, 0, 13);
  operands[15] = x15;
  x16 = XVECEXP (x3, 0, 14);
  operands[16] = x16;
  x17 = XVECEXP (x3, 0, 15);
  operands[17] = x17;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode)
          || pattern1675 () != 0
          || !(
#line 20453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7776; /* *avx512f_shuf_f32x4_1_1 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x2) != E_V16SImode)
        return -1;
      if (register_operand (operands[1], E_V16SImode)
          && pattern1675 () == 0
          && (
#line 20453 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (INTVAL (operands[2]) & 3) == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[2]) == INTVAL (operands[4]) - 2
   && INTVAL (operands[2]) == INTVAL (operands[5]) - 3
   && (INTVAL (operands[6]) & 3) == 0
   && INTVAL (operands[6]) == INTVAL (operands[7]) - 1
   && INTVAL (operands[6]) == INTVAL (operands[8]) - 2
   && INTVAL (operands[6]) == INTVAL (operands[9]) - 3
   && (INTVAL (operands[10]) & 3) == 0
   && INTVAL (operands[10]) == INTVAL (operands[11]) - 1
   && INTVAL (operands[10]) == INTVAL (operands[12]) - 2
   && INTVAL (operands[10]) == INTVAL (operands[13]) - 3
   && (INTVAL (operands[14]) & 3) == 0
   && INTVAL (operands[14]) == INTVAL (operands[15]) - 1
   && INTVAL (operands[14]) == INTVAL (operands[16]) - 2
   && INTVAL (operands[14]) == INTVAL (operands[17]) - 3) && 
#line 721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 7778; /* *avx512f_shuf_i32x4_1_1 */
      if (!nonimmediate_operand (operands[1], E_V16SImode)
          || pattern1555 () != 0
          || !const_8_to_11_operand (operands[10], E_VOIDmode)
          || !const_8_to_11_operand (operands[11], E_VOIDmode)
          || !const_8_to_11_operand (operands[12], E_VOIDmode)
          || !const_8_to_11_operand (operands[13], E_VOIDmode)
          || !const_12_to_15_operand (operands[14], E_VOIDmode)
          || !const_12_to_15_operand (operands[15], E_VOIDmode)
          || !const_12_to_15_operand (operands[16], E_VOIDmode)
          || !const_12_to_15_operand (operands[17], E_VOIDmode)
          || !
#line 20535 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
   && INTVAL (operands[2]) + 8 == INTVAL (operands[10])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[11])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[12])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[13])
   && INTVAL (operands[2]) + 12 == INTVAL (operands[14])
   && INTVAL (operands[3]) + 12 == INTVAL (operands[15])
   && INTVAL (operands[4]) + 12 == INTVAL (operands[16])
   && INTVAL (operands[5]) + 12 == INTVAL (operands[17])))
        return -1;
      return 7780; /* avx512f_pshufd_1 */

    default:
      return -1;
    }
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      switch (pattern297 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_V16BFmode:
              if (pattern555 (x2, 
E_V16BFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3134; /* avx512bf16_andnotv16bf3 */

            case E_V8BFmode:
              if (pattern555 (x2, 
E_V8BFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 426 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3135; /* avx512bf16_andnotv8bf3 */

            case E_V16HFmode:
              if (pattern555 (x2, 
E_V16HFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3136; /* avx512fp16_andnotv16hf3 */

            case E_V8HFmode:
              if (pattern555 (x2, 
E_V8HFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 16 != 16)) && 
#line 427 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3137; /* avx512fp16_andnotv8hf3 */

            case E_V8SFmode:
              if (pattern555 (x2, 
E_V8SFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)) && 
#line 428 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3138; /* avx_andnotv8sf3 */

            case E_V4SFmode:
              if (pattern555 (x2, 
E_V4SFmode) != 0
                  || !
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 32 != 16)))
                return -1;
              return 3140; /* sse_andnotv4sf3 */

            case E_V4DFmode:
              if (pattern555 (x2, 
E_V4DFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 3142; /* avx_andnotv4df3 */

            case E_V2DFmode:
              if (pattern555 (x2, 
E_V2DFmode) != 0
                  || !(
#line 5239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && 1
   && (!false || 64 != 16)) && 
#line 429 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 3144; /* sse2_andnotv2df3 */

            case E_V32BFmode:
              if (pattern679 (x2, 
E_V32BFmode) != 0
                  || !(
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 491 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3146; /* avx512bf16_andnotv32bf3 */

            case E_V32HFmode:
              if (pattern679 (x2, 
E_V32HFmode) != 0
                  || !(
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 16 != 16)) && 
#line 492 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3147; /* avx512fp16_andnotv32hf3 */

            case E_V16SFmode:
              if (pattern679 (x2, 
E_V16SFmode) != 0
                  || !(
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 32 != 16)) && 
#line 493 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3148; /* avx512f_andnotv16sf3 */

            case E_V8DFmode:
              if (pattern679 (x2, 
E_V8DFmode) != 0
                  || !(
#line 5314 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && (!false || 64 != 16)) && 
#line 494 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3150; /* avx512f_andnotv8df3 */

            case E_V1TImode:
              if (pattern555 (x2, 
E_V1TImode) != 0
                  || !
#line 5605 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 3223; /* *andnotv1ti3 */

            case E_V16SImode:
              if (pattern843 (x2, 
E_V16SImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7329; /* *andnotv16si3 */

            case E_V8DImode:
              if (pattern843 (x2, 
E_V8DImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 7330; /* *andnotv8di3 */

            case E_V64QImode:
              if (pattern843 (x2, 
E_V64QImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7331; /* *andnotv64qi3 */

            case E_V32QImode:
              if (pattern843 (x2, 
E_V32QImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7332; /* *andnotv32qi3 */

            case E_V16QImode:
              if (pattern843 (x2, 
E_V16QImode) != 0
                  || !
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
                return -1;
              return 7333; /* *andnotv16qi3 */

            case E_V32HImode:
              if (pattern843 (x2, 
E_V32HImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 7334; /* *andnotv32hi3 */

            case E_V16HImode:
              if (pattern843 (x2, 
E_V16HImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7335; /* *andnotv16hi3 */

            case E_V8HImode:
              if (pattern843 (x2, 
E_V8HImode) != 0
                  || !
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
                return -1;
              return 7336; /* *andnotv8hi3 */

            case E_V8SImode:
              if (pattern843 (x2, 
E_V8SImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7337; /* *andnotv8si3 */

            case E_V4SImode:
              if (pattern843 (x2, 
E_V4SImode) != 0
                  || !
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
                return -1;
              return 7338; /* *andnotv4si3 */

            case E_V4DImode:
              if (pattern843 (x2, 
E_V4DImode) != 0
                  || !(
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 7339; /* *andnotv4di3 */

            case E_V2DImode:
              if (pattern843 (x2, 
E_V2DImode) != 0
                  || !
#line 18473 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
                return -1;
              return 7340; /* *andnotv2di3 */

            default:
              return -1;
            }

        case 1:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16SImode)
       || register_operand (operands[2], V16SImode))) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7428; /* *norv16si3 */

        case 2:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8DImode)
       || register_operand (operands[2], V8DImode))) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7430; /* *norv8di3 */

        case 3:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V64QImode)
       || register_operand (operands[2], V64QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7432; /* *norv64qi3 */

        case 4:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32QImode)
       || register_operand (operands[2], V32QImode))) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7434; /* *norv32qi3 */

        case 5:
          if (!
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16QImode)
       || register_operand (operands[2], V16QImode))))
            return -1;
          return 7436; /* *norv16qi3 */

        case 6:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V32HImode)
       || register_operand (operands[2], V32HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7438; /* *norv32hi3 */

        case 7:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V16HImode)
       || register_operand (operands[2], V16HImode))) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7440; /* *norv16hi3 */

        case 8:
          if (!
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8HImode)
       || register_operand (operands[2], V8HImode))))
            return -1;
          return 7442; /* *norv8hi3 */

        case 9:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V8SImode)
       || register_operand (operands[2], V8SImode))) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7444; /* *norv8si3 */

        case 10:
          if (!
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4SImode)
       || register_operand (operands[2], V4SImode))))
            return -1;
          return 7446; /* *norv4si3 */

        case 11:
          if (!(
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V4DImode)
       || register_operand (operands[2], V4DImode))) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7448; /* *norv4di3 */

        case 12:
          if (!
#line 19007 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && (register_operand (operands[1], V2DImode)
       || register_operand (operands[2], V2DImode))))
            return -1;
          return 7450; /* *norv2di3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      return recog_282 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern467 (x2))
            {
            case 0:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4849; /* *avx512bw_vpternlogv64qi_1 */

            case 1:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4876; /* *avx512vl_vpternlogv32qi_1 */

            case 2:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4903; /* *avx512vl_vpternlogv16qi_1 */

            case 3:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4930; /* *avx512bw_vpternlogv32hi_1 */

            case 4:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4957; /* *avx512vl_vpternlogv16hi_1 */

            case 5:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4984; /* *avx512vl_vpternlogv8hi_1 */

            case 6:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5011; /* *avx512f_vpternlogv16si_1 */

            case 7:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5038; /* *avx512vl_vpternlogv8si_1 */

            case 8:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5065; /* *avx512vl_vpternlogv4si_1 */

            case 9:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5092; /* *avx512f_vpternlogv8di_1 */

            case 10:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5119; /* *avx512vl_vpternlogv4di_1 */

            case 11:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5146; /* *avx512vl_vpternlogv2di_1 */

            case 12:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4852; /* *avx512bw_vpternlogv64qi_1 */

            case 13:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4879; /* *avx512vl_vpternlogv32qi_1 */

            case 14:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4906; /* *avx512vl_vpternlogv16qi_1 */

            case 15:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4933; /* *avx512bw_vpternlogv32hi_1 */

            case 16:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4960; /* *avx512vl_vpternlogv16hi_1 */

            case 17:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4987; /* *avx512vl_vpternlogv8hi_1 */

            case 18:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5014; /* *avx512f_vpternlogv16si_1 */

            case 19:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5041; /* *avx512vl_vpternlogv8si_1 */

            case 20:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5068; /* *avx512vl_vpternlogv4si_1 */

            case 21:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5095; /* *avx512f_vpternlogv8di_1 */

            case 22:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5122; /* *avx512vl_vpternlogv4di_1 */

            case 23:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5149; /* *avx512vl_vpternlogv2di_1 */

            case 24:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4855; /* *avx512bw_vpternlogv64qi_1 */

            case 25:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4882; /* *avx512vl_vpternlogv32qi_1 */

            case 26:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4909; /* *avx512vl_vpternlogv16qi_1 */

            case 27:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 4936; /* *avx512bw_vpternlogv32hi_1 */

            case 28:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 4963; /* *avx512vl_vpternlogv16hi_1 */

            case 29:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 4990; /* *avx512vl_vpternlogv8hi_1 */

            case 30:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5017; /* *avx512f_vpternlogv16si_1 */

            case 31:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5044; /* *avx512vl_vpternlogv8si_1 */

            case 32:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5071; /* *avx512vl_vpternlogv4si_1 */

            case 33:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5098; /* *avx512f_vpternlogv8di_1 */

            case 34:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5125; /* *avx512vl_vpternlogv4di_1 */

            case 35:
              if (!
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5152; /* *avx512vl_vpternlogv2di_1 */

            case 36:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6145; /* *avx512bw_vpternlogv64qi_3 */

            case 37:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6154; /* *avx512vl_vpternlogv32qi_3 */

            case 38:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6163; /* *avx512vl_vpternlogv16qi_3 */

            case 39:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6172; /* *avx512bw_vpternlogv32hi_3 */

            case 40:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6181; /* *avx512vl_vpternlogv16hi_3 */

            case 41:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6190; /* *avx512vl_vpternlogv8hi_3 */

            case 42:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6199; /* *avx512f_vpternlogv16si_3 */

            case 43:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6208; /* *avx512vl_vpternlogv8si_3 */

            case 44:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6217; /* *avx512vl_vpternlogv4si_3 */

            case 45:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6226; /* *avx512f_vpternlogv8di_3 */

            case 46:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6235; /* *avx512vl_vpternlogv4di_3 */

            case 47:
              if (!
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6244; /* *avx512vl_vpternlogv2di_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5497; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5524; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5551; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5578; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5605; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5632; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5659; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5686; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5713; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5740; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5767; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5794; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5500; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5527; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5554; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5581; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5608; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5635; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5662; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5689; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5716; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5743; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5770; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5797; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5503; /* *avx512bw_vpternlogv64qi_2 */

            case 1:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5530; /* *avx512vl_vpternlogv32qi_2 */

            case 2:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5557; /* *avx512vl_vpternlogv16qi_2 */

            case 3:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5584; /* *avx512bw_vpternlogv32hi_2 */

            case 4:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5611; /* *avx512vl_vpternlogv16hi_2 */

            case 5:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5638; /* *avx512vl_vpternlogv8hi_2 */

            case 6:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5665; /* *avx512f_vpternlogv16si_2 */

            case 7:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5692; /* *avx512vl_vpternlogv8si_2 */

            case 8:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5719; /* *avx512vl_vpternlogv4si_2 */

            case 9:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5746; /* *avx512f_vpternlogv8di_2 */

            case 10:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5773; /* *avx512vl_vpternlogv4di_2 */

            case 11:
              if (!
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5800; /* *avx512vl_vpternlogv2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_284 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_283 (x1, insn, pnum_clobbers);

    case GT:
      switch (pattern299 (x2))
        {
        case 0:
          if (!(
#line 17311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()) && 
#line 704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7027; /* *avx2_lshrv4di3_1 */

        case 1:
          if (!
#line 17311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_2 && ix86_pre_reload_split ()))
            return -1;
          return 7028; /* *avx2_lshrv2di3_1 */

        default:
          return -1;
        }

    case LT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4DImode:
          if (pattern844 (x2, 
E_V4DImode) != 0
              || !(
#line 17328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()) && 
#line 704 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7029; /* *avx2_lshrv4di3_2 */

        case E_V2DImode:
          if (pattern844 (x2, 
E_V2DImode) != 0
              || !
#line 17328 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_pre_reload_split ()))
            return -1;
          return 7030; /* *avx2_lshrv2di3_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      switch (pattern174 (x3))
        {
        case 0:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && 1 && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2162; /* *addv32hf3 */

        case 1:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && 1 && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2170; /* *addv16hf3 */

        case 2:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && 1 && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2178; /* *addv8hf3 */

        case 3:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2186; /* *addv16sf3 */

        case 4:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && 1 && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2194; /* *addv8sf3 */

        case 5:
          if (!
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && 1 && 1))
            return -1;
          return 2202; /* *addv4sf3 */

        case 6:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2210; /* *addv8df3 */

        case 7:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && 1 && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2218; /* *addv4df3 */

        case 8:
          if (!(
#line 2664 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && 1 && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2226; /* *addv2df3 */

        case 9:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6810; /* *addv64qi3 */

        case 10:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 587 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6812; /* *addv32qi3 */

        case 11:
          if (!
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 6814; /* *addv16qi3 */

        case 12:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V32HImode, operands)) && 
#line 588 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 6816; /* *addv32hi3 */

        case 13:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16HImode, operands)) && 
#line 588 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6818; /* *addv16hi3 */

        case 14:
          if (!
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8HImode, operands)))
            return -1;
          return 6820; /* *addv8hi3 */

        case 15:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V16SImode, operands)) && 
#line 589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6822; /* *addv16si3 */

        case 16:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8SImode, operands)) && 
#line 589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6824; /* *addv8si3 */

        case 17:
          if (!
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4SImode, operands)))
            return -1;
          return 6826; /* *addv4si3 */

        case 18:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V8DImode, operands)) && 
#line 590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6828; /* *addv8di3 */

        case 19:
          if (!(
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V4DImode, operands)) && 
#line 590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 6830; /* *addv4di3 */

        case 20:
          if (!
#line 16253 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && ix86_binary_operator_ok (PLUS, V2DImode, operands)))
            return -1;
          return 6832; /* *addv2di3 */

        case 21:
          if (!
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9889; /* avx10_2_addbf16_v32bf */

        case 22:
          if (!
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9897; /* avx10_2_addbf16_v16bf */

        case 23:
          if (!
#line 32118 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
            return -1;
          return 9905; /* avx10_2_addbf16_v8bf */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern177 (x3))
        {
        case 0:
          if (!(
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3747; /* fma_v32hf_fadd_fmul */

        case 1:
          if (!(
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3748; /* fma_v16hf_fadd_fmul */

        case 2:
          if (!(
#line 7178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3749; /* fma_v8hf_fadd_fmul */

        case 3:
          if (!(
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3750; /* fma_v32hf_fadd_fcmul */

        case 4:
          if (!(
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3751; /* fma_v16hf_fadd_fcmul */

        case 5:
          if (!(
#line 7195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3752; /* fma_v8hf_fadd_fcmul */

        case 6:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3753; /* fma_fmaddc_v32hf_fma_zero */

        case 7:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3755; /* fma_fmaddc_v16hf_fma_zero */

        case 8:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3757; /* fma_fmaddc_v8hf_fma_zero */

        case 9:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3754; /* fma_fcmaddc_v32hf_fma_zero */

        case 10:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3756; /* fma_fcmaddc_v16hf_fma_zero */

        case 11:
          if (!(
#line 7213 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && flag_unsafe_math_optimizations
  && ix86_pre_reload_split ()) && 
#line 554 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3758; /* fma_fcmaddc_v8hf_fma_zero */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern289 (x4) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 1);
          switch (XVECLEN (x7, 0))
            {
            case 8:
              if (pattern1199 (x4) != 0)
                return -1;
              x8 = XEXP (x3, 1);
              if (GET_CODE (x8) != MULT
                  || GET_MODE (x8) != E_V8SImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_V8SImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != VEC_SELECT
                  || GET_MODE (x10) != E_V8HImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != PARALLEL
                  || pattern1706 (x11, 
8) != 0)
                return -1;
              x12 = XEXP (x8, 1);
              if (pattern1688 (x12, 
E_V8HImode, 
E_V8SImode) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              x14 = XEXP (x13, 1);
              if (pattern1724 (x14, 
8) != 0
                  || !register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_V8SImode
                  || GET_MODE (x5) != E_V8SImode
                  || GET_MODE (x6) != E_V8HImode
                  || !nonimmediate_operand (operands[1], E_V16HImode))
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V8SImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V8HImode
                  || !nonimmediate_operand (operands[2], E_V16HImode))
                return -1;
              x17 = XEXP (x10, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              x18 = XEXP (x13, 0);
              if (!rtx_equal_p (x18, operands[2])
                  || !
#line 16728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 6942; /* *avx2_pmaddwd */

            case 4:
              x19 = XVECEXP (x7, 0, 0);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              x20 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x20) != CONST_INT)
                return -1;
              x21 = XVECEXP (x7, 0, 2);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x22 = XVECEXP (x7, 0, 3);
              if (GET_CODE (x22) != CONST_INT)
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x23 = XEXP (x16, 1);
              if (XVECLEN (x23, 0) != 4)
                return -1;
              x24 = XVECEXP (x23, 0, 0);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XVECEXP (x23, 0, 1);
              if (GET_CODE (x25) != CONST_INT)
                return -1;
              x26 = XVECEXP (x23, 0, 2);
              if (GET_CODE (x26) != CONST_INT)
                return -1;
              x27 = XVECEXP (x23, 0, 3);
              if (GET_CODE (x27) != CONST_INT
                  || pattern799 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                  || GET_MODE (x15) != E_V4SImode
                  || GET_MODE (x16) != E_V4HImode)
                return -1;
              switch (XWINT (x19, 0))
                {
                case 0L:
                  if (XWINT (x20, 0) != 2L
                      || XWINT (x21, 0) != 4L
                      || XWINT (x22, 0) != 6L
                      || XWINT (x24, 0) != 0L
                      || XWINT (x25, 0) != 2L
                      || XWINT (x26, 0) != 4L
                      || XWINT (x27, 0) != 6L)
                    return -1;
                  x8 = XEXP (x3, 1);
                  if (pattern1625 (x8, 
E_V4HImode, 
E_V4SImode, 
SIGN_EXTEND) != 0
                      || !vector_operand (operands[1], E_V8HImode)
                      || !vector_operand (operands[2], E_V8HImode))
                    return -1;
                  x9 = XEXP (x8, 0);
                  x10 = XEXP (x9, 0);
                  x17 = XEXP (x10, 0);
                  if (!rtx_equal_p (x17, operands[1]))
                    return -1;
                  x12 = XEXP (x8, 1);
                  x13 = XEXP (x12, 0);
                  x18 = XEXP (x13, 0);
                  if (!rtx_equal_p (x18, operands[2])
                      || !
#line 16783 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 6943; /* *sse2_pmaddwd */

                case 1L:
                  if (XWINT (x20, 0) != 3L
                      || XWINT (x21, 0) != 5L
                      || XWINT (x22, 0) != 7L
                      || XWINT (x24, 0) != 1L
                      || XWINT (x25, 0) != 3L
                      || XWINT (x26, 0) != 5L
                      || XWINT (x27, 0) != 7L
                      || !nonimmediate_operand (operands[1], E_V8HImode)
                      || !nonimmediate_operand (operands[2], E_V8HImode))
                    return -1;
                  x8 = XEXP (x3, 1);
                  operands[3] = x8;
                  if (!register_operand (operands[3], E_V4SImode)
                      || !
#line 26156 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8287; /* xop_pmacswd */

                default:
                  return -1;
                }

            case 2:
              if (pattern1200 (x3) != 0)
                return -1;
              x15 = XEXP (x4, 1);
              if (GET_MODE (x15) != E_V2DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_V2SImode
                  || !nonimmediate_operand (operands[2], E_V4SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              switch (pattern1670 (x4))
                {
                case 0:
                  if (!
#line 26115 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8283; /* xop_pmacsdql */

                case 1:
                  if (!
#line 26134 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                    return -1;
                  return 8285; /* xop_pmacsdqh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern291 (x3))
            {
            case 0:
              if (!
#line 26096 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8279; /* xop_pmacsww */

            case 1:
              if (!
#line 26096 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8281; /* xop_pmacsdd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern181 (x3))
        {
        case 0:
          if (!
#line 22557 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7881; /* avx2_phaddwv16hi3 */

        case 1:
          if (!
#line 22580 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7885; /* ssse3_phaddwv8hi3 */

        case 2:
          if (!
#line 22647 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2))
            return -1;
          return 7893; /* avx2_phadddv8si3 */

        case 3:
          if (!
#line 22668 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
            return -1;
          return 7895; /* ssse3_phadddv4si3 */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
          if (pattern292 (x5) != 0)
            return -1;
          x28 = XEXP (x5, 1);
          if (GET_MODE (x28) != E_V4SImode)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != VEC_SELECT
              || GET_MODE (x29) != E_V4HImode)
            return -1;
          x30 = XEXP (x29, 1);
          if (GET_CODE (x30) != PARALLEL
              || XVECLEN (x30, 0) != 4)
            return -1;
          x31 = XVECEXP (x30, 0, 0);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x32 = XVECEXP (x30, 0, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x33 = XVECEXP (x30, 0, 2);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x34 = XVECEXP (x30, 0, 3);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != MULT
              || GET_MODE (x15) != E_V4SImode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SIGN_EXTEND
              || GET_MODE (x16) != E_V4SImode)
            return -1;
          x35 = XEXP (x16, 0);
          if (GET_CODE (x35) != VEC_SELECT
              || GET_MODE (x35) != E_V4HImode)
            return -1;
          x36 = XEXP (x35, 1);
          if (GET_CODE (x36) != PARALLEL
              || XVECLEN (x36, 0) != 4)
            return -1;
          x37 = XVECEXP (x36, 0, 0);
          if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x38 = XVECEXP (x36, 0, 1);
          if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x39 = XVECEXP (x36, 0, 2);
          if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x40 = XVECEXP (x36, 0, 3);
          if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          x41 = XEXP (x15, 1);
          if (GET_CODE (x41) != SIGN_EXTEND
              || GET_MODE (x41) != E_V4SImode)
            return -1;
          x42 = XEXP (x41, 0);
          if (GET_CODE (x42) != VEC_SELECT
              || GET_MODE (x42) != E_V4HImode)
            return -1;
          x43 = XEXP (x42, 1);
          if (GET_CODE (x43) != PARALLEL
              || XVECLEN (x43, 0) != 4)
            return -1;
          x44 = XVECEXP (x43, 0, 0);
          if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x45 = XVECEXP (x43, 0, 1);
          if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x46 = XVECEXP (x43, 0, 2);
          if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x47 = XVECEXP (x43, 0, 3);
          if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode
              || pattern1726 (x3) != 0
              || !
#line 26189 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8289; /* xop_pmadcswd */

        case SIGN_EXTEND:
          switch (pattern295 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 26283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8309; /* xop_phaddbd */

            case 1:
              if (!
#line 26379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8315; /* xop_phaddwq */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern295 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 26283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8310; /* xop_phaddubd */

            case 1:
              if (!
#line 26379 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8316; /* xop_phadduwq */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x5) != E_V2DImode)
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_V2DImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_V2DImode
              || pattern937 (x8, 
E_V2DImode, 
PLUS) != 0
              || !register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_V2DImode
              || pattern1406 (x3, 
E_V2DImode) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              if (pattern1658 (x3, 
SIGN_EXTEND) != 0
                  || !
#line 26331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8311; /* xop_phaddbq */

            case ZERO_EXTEND:
              if (pattern1658 (x3, 
ZERO_EXTEND) != 0
                  || !
#line 26331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
                return -1;
              return 8312; /* xop_phaddubq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern183 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 26251 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8307; /* xop_phaddbw */

        case 1:
          if (!
#line 26351 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8313; /* xop_phaddwd */

        case 2:
          if (!
#line 26397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8317; /* xop_phadddq */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern183 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 26251 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8308; /* xop_phaddubw */

        case 1:
          if (!
#line 26351 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8314; /* xop_phadduwd */

        case 2:
          if (!
#line 26397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8318; /* xop_phaddudq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (nonimmediate_operand (operands[0], E_V64QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V64QImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V64QImode)
       || register_operand (operands[1], V64QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1884; /* movv64qi_internal */
      if (!register_operand (operands[0], E_V64QImode)
          || !ternlog_operand (operands[1], E_V64QImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4825; /* *avx512bw_vpternlogv64qi_0 */

    case E_V32QImode:
      if (nonimmediate_operand (operands[0], E_V32QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32QImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 282 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1885; /* movv32qi_internal */
      if (!register_operand (operands[0], E_V32QImode)
          || !ternlog_operand (operands[1], E_V32QImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 4826; /* *avx512vl_vpternlogv32qi_0 */

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16QImode)
          && 
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1886; /* movv16qi_internal */
      if (!register_operand (operands[0], E_V16QImode)
          || !ternlog_operand (operands[1], E_V16QImode)
          || !
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 4827; /* *avx512vl_vpternlogv16qi_0 */

    case E_V32HImode:
      if (nonimmediate_operand (operands[0], E_V32HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V32HImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HImode)
       || register_operand (operands[1], V32HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1887; /* movv32hi_internal */
      if (!register_operand (operands[0], E_V32HImode)
          || !ternlog_operand (operands[1], E_V32HImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4828; /* *avx512bw_vpternlogv32hi_0 */

    case E_V16HImode:
      if (nonimmediate_operand (operands[0], E_V16HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16HImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 283 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1888; /* movv16hi_internal */
      if (!register_operand (operands[0], E_V16HImode)
          || !ternlog_operand (operands[1], E_V16HImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 4829; /* *avx512vl_vpternlogv16hi_0 */

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8HImode)
          && 
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1889; /* movv8hi_internal */
      if (!register_operand (operands[0], E_V8HImode)
          || !ternlog_operand (operands[1], E_V8HImode)
          || !
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 4830; /* *avx512vl_vpternlogv8hi_0 */

    case E_V16SImode:
      if (nonimmediate_operand (operands[0], E_V16SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V16SImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1890; /* movv16si_internal */
      if (!register_operand (operands[0], E_V16SImode)
          || !ternlog_operand (operands[1], E_V16SImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4831; /* *avx512f_vpternlogv16si_0 */

    case E_V8SImode:
      if (nonimmediate_operand (operands[0], E_V8SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8SImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 284 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1891; /* movv8si_internal */
      if (!register_operand (operands[0], E_V8SImode)
          || !ternlog_operand (operands[1], E_V8SImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 4832; /* *avx512vl_vpternlogv8si_0 */

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4SImode)
          && 
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1892; /* movv4si_internal */
      if (!register_operand (operands[0], E_V4SImode)
          || !ternlog_operand (operands[1], E_V4SImode)
          || !
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 4833; /* *avx512vl_vpternlogv4si_0 */

    case E_V8DImode:
      if (nonimmediate_operand (operands[0], E_V8DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V8DImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DImode)
       || register_operand (operands[1], V8DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return 1893; /* movv8di_internal */
      if (!register_operand (operands[0], E_V8DImode)
          || !ternlog_operand (operands[1], E_V8DImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 4834; /* *avx512f_vpternlogv8di_0 */

    case E_V4DImode:
      if (nonimmediate_operand (operands[0], E_V4DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V4DImode)
          && (
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return 1894; /* movv4di_internal */
      if (!register_operand (operands[0], E_V4DImode)
          || !ternlog_operand (operands[1], E_V4DImode)
          || !(
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 4835; /* *avx512vl_vpternlogv4di_0 */

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && nonimmediate_or_sse_const_operand (operands[1], E_V2DImode)
          && 
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return 1895; /* movv2di_internal */
      if (!register_operand (operands[0], E_V2DImode)
          || !ternlog_operand (operands[1], E_V2DImode)
          || !
#line 13733 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
        return -1;
      return 4836; /* *avx512vl_vpternlogv2di_0 */

    case E_V4TImode:
      if (!nonimmediate_operand (operands[0], E_V4TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4TImode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4TImode)
       || register_operand (operands[1], V4TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 1896; /* movv4ti_internal */

    case E_V2TImode:
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2TImode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2TImode)
       || register_operand (operands[1], V2TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 286 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 1897; /* movv2ti_internal */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V1TImode)
          || !
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V1TImode)
       || register_operand (operands[1], V1TImode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 1898; /* movv1ti_internal */

    case E_V32HFmode:
      if (!nonimmediate_operand (operands[0], E_V32HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32HFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32HFmode)
       || register_operand (operands[1], V32HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 1899; /* movv32hf_internal */

    case E_V16HFmode:
      if (!nonimmediate_operand (operands[0], E_V16HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16HFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16HFmode)
       || register_operand (operands[1], V16HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 287 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 1900; /* movv16hf_internal */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8HFmode)
          || !
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 1901; /* movv8hf_internal */

    case E_V32BFmode:
      if (!nonimmediate_operand (operands[0], E_V32BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V32BFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V32BFmode)
       || register_operand (operands[1], V32BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 1902; /* movv32bf_internal */

    case E_V16BFmode:
      if (!nonimmediate_operand (operands[0], E_V16BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16BFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16BFmode)
       || register_operand (operands[1], V16BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 288 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 1903; /* movv16bf_internal */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8BFmode)
          || !
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[1], V8BFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 1904; /* movv8bf_internal */

    case E_V16SFmode:
      if (!nonimmediate_operand (operands[0], E_V16SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V16SFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 1905; /* movv16sf_internal */

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8SFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 289 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 1906; /* movv8sf_internal */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4SFmode)
          || !
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 1907; /* movv4sf_internal */

    case E_V8DFmode:
      if (!nonimmediate_operand (operands[0], E_V8DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V8DFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 1908; /* movv8df_internal */

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V4DFmode)
          || !(
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])) && 
#line 290 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 1909; /* movv4df_internal */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !nonimmediate_or_sse_const_operand (operands[1], E_V2DFmode)
          || !
#line 1507 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))
   && ix86_hardreg_mov_ok (operands[0], operands[1])))
        return -1;
      return 1910; /* movv2df_internal */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32QImode:
          if (pattern745 (x3, 
E_V32QImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8291; /* xop_pcmov_v32qi256 */

        case E_V16QImode:
          if (pattern745 (x3, 
E_V16QImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8292; /* xop_pcmov_v16qi */

        case E_V16HImode:
          if (pattern745 (x3, 
E_V16HImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8293; /* xop_pcmov_v16hi256 */

        case E_V8HImode:
          if (pattern745 (x3, 
E_V8HImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8294; /* xop_pcmov_v8hi */

        case E_V8SImode:
          if (pattern745 (x3, 
E_V8SImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8295; /* xop_pcmov_v8si256 */

        case E_V4SImode:
          if (pattern745 (x3, 
E_V4SImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8296; /* xop_pcmov_v4si */

        case E_V4DImode:
          if (pattern745 (x3, 
E_V4DImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8297; /* xop_pcmov_v4di256 */

        case E_V2DImode:
          if (pattern745 (x3, 
E_V2DImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8298; /* xop_pcmov_v2di */

        case E_V2TImode:
          if (pattern745 (x3, 
E_V2TImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8299; /* xop_pcmov_v2ti256 */

        case E_V1TImode:
          if (pattern745 (x3, 
E_V1TImode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8300; /* xop_pcmov_v1ti */

        case E_V16HFmode:
          if (pattern745 (x3, 
E_V16HFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8301; /* xop_pcmov_v16hf256 */

        case E_V8HFmode:
          if (pattern745 (x3, 
E_V8HFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8302; /* xop_pcmov_v8hf */

        case E_V8SFmode:
          if (pattern745 (x3, 
E_V8SFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8303; /* xop_pcmov_v8sf256 */

        case E_V4SFmode:
          if (pattern745 (x3, 
E_V4SFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8304; /* xop_pcmov_v4sf */

        case E_V4DFmode:
          if (pattern745 (x3, 
E_V4DFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8305; /* xop_pcmov_v4df256 */

        case E_V2DFmode:
          if (pattern745 (x3, 
E_V2DFmode) != 0
              || !
#line 26202 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 8306; /* xop_pcmov_v2df */

        default:
          return -1;
        }

    case GE:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x3, 2);
          if (GET_CODE (x6) != ROTATERT)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != NEG)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (pattern1034 (x3))
            {
            case 0:
              if (!
#line 26648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8334; /* xop_vrotlv16qi3 */

            case 1:
              if (!
#line 26648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8335; /* xop_vrotlv8hi3 */

            case 2:
              if (!
#line 26648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8336; /* xop_vrotlv4si3 */

            case 3:
              if (!
#line 26648 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 8337; /* xop_vrotlv2di3 */

            default:
              return -1;
            }

        case ASHIFT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x6 = XEXP (x3, 2);
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1034 (x3))
                {
                case 0:
                  if (!
#line 26885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8338; /* xop_shav16qi3 */

                case 1:
                  if (!
#line 26885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8339; /* xop_shav8hi3 */

                case 2:
                  if (!
#line 26885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8340; /* xop_shav4si3 */

                case 3:
                  if (!
#line 26885 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8341; /* xop_shav2di3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x9 = XEXP (x6, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              switch (pattern1034 (x3))
                {
                case 0:
                  if (!
#line 26904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8342; /* xop_shlv16qi3 */

                case 1:
                  if (!
#line 26904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8343; /* xop_shlv8hi3 */

                case 2:
                  if (!
#line 26904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8344; /* xop_shlv4si3 */

                case 3:
                  if (!
#line 26904 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_XOP && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 8345; /* xop_shlv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x3) != E_V64QImode
          || !vector_operand (operands[1], E_V64QImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 7941; /* *absv64qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !vector_operand (operands[1], E_V32QImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7942; /* *absv32qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !vector_operand (operands[1], E_V16QImode)
          || !
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 7943; /* *absv16qi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x3) != E_V32HImode
          || !vector_operand (operands[1], E_V32HImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
        return -1;
      return 7944; /* *absv32hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !vector_operand (operands[1], E_V16HImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7945; /* *absv16hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vector_operand (operands[1], E_V8HImode)
          || !
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 7946; /* *absv8hi2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !vector_operand (operands[1], E_V16SImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7947; /* *absv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !vector_operand (operands[1], E_V8SImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2)))
        return -1;
      return 7948; /* *absv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vector_operand (operands[1], E_V4SImode)
          || !
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3))
        return -1;
      return 7949; /* *absv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !vector_operand (operands[1], E_V8DImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 7950; /* *absv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !vector_operand (operands[1], E_V4DImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7951; /* *absv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vector_operand (operands[1], E_V2DImode)
          || !(
#line 23341 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSSE3) && 
#line 23335 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7952; /* *absv2di2 */

    default:
      return -1;
    }
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 389 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2465; /* *sminv32hf3 */

    case 1:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 390 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2471; /* *sminv16hf3 */

    case 2:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 391 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2475; /* *sminv8hf3 */

    case 3:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2481; /* *sminv16sf3 */

    case 4:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 392 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2487; /* *sminv8sf3 */

    case 5:
      if (!
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1))
        return -1;
      return 2491; /* *sminv4sf3 */

    case 6:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2497; /* *sminv8df3 */

    case 7:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 393 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2503; /* *sminv4df3 */

    case 8:
      if (!(
#line 3309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && 1
   && 1) && 
#line 394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2507; /* *sminv2df3 */

    case 9:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7102; /* *avx2_sminv32qi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7179; /* *avx512bw_sminv32qi3 */

    case 10:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7106; /* *avx2_sminv16hi3 */
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7195; /* *avx512bw_sminv16hi3 */

    case 11:
      if (
#line 17653 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return 7110; /* *avx2_sminv8si3 */
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7123; /* *avx512f_sminv8si3 */

    case 12:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7115; /* *avx512f_sminv16si3 */

    case 13:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonimmediate_operand (operands[2], E_V4SImode)
          && (
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7131; /* *avx512f_sminv4si3 */
      if (!vector_operand (operands[1], E_V4SImode)
          || !vector_operand (operands[2], E_V4SImode)
          || !
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7215; /* *sse4_1_sminv4si3 */

    case 14:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7139; /* *avx512f_sminv8di3 */

    case 15:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7147; /* *avx512f_sminv4di3 */

    case 16:
      if (!(
#line 17694 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7155; /* *avx512f_sminv2di3 */

    case 17:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7163; /* *avx512bw_sminv64qi3 */

    case 18:
      if (nonimmediate_operand (operands[1], E_V16QImode)
          && nonimmediate_operand (operands[2], E_V16QImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7171; /* *avx512bw_sminv16qi3 */
      if (!vector_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || !
#line 17797 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && 1
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7211; /* *sse4_1_sminv16qi3 */

    case 19:
      if (!(
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7187; /* *avx512bw_sminv32hi3 */

    case 20:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonimmediate_operand (operands[2], E_V8HImode)
          && (
#line 17705 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7203; /* *avx512bw_sminv8hi3 */
      if (!vector_operand (operands[1], E_V8HImode)
          || !vector_operand (operands[2], E_V8HImode)
          || !
#line 17816 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2 && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
        return -1;
      return 7218; /* *sminv8hi3 */

    case 21:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9879; /* avx10_2_sminbf16_v32bf */

    case 22:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9883; /* avx10_2_sminbf16_v16bf */

    case 23:
      if (!
#line 32108 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX10_2))
        return -1;
      return 9887; /* avx10_2_sminbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4129; /* avx512fp16_vcvtpd2ph_v8df */

        case E_V8SFmode:
          if (!vector_operand (operands[1], E_V8SFmode)
              || !(
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4137; /* avx512fp16_vcvtps2ph_v8sf */

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 8116 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16) && 
#line 1003 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4133; /* avx512fp16_vcvtps2ph_v16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !
#line 10073 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 4503; /* *avx512f_cvtpd2ps512 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4DFmode)
          || !
#line 10083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX && 1))
        return -1;
      return 4507; /* avx_cvtpd2ps256 */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode))
        return -1;
      if (
#line 31135 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVXNECONVERT || (TARGET_AVX512BF16 && TARGET_AVX512VL)))
        return 9631; /* vcvtneps2bf16_v8sf */
      if (!(
#line 31173 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9634; /* avx512f_cvtneps2bf16_v8sf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x3) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16SFmode)
          || !(
#line 31173 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31101 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9632; /* avx512f_cvtneps2bf16_v16sf */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x3) != E_V16SImode
          || !nonimmediate_operand (operands[1], E_V16SImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9353; /* clzv16si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9355; /* clzv8si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9357; /* clzv4si2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x3) != E_V8DImode
          || !nonimmediate_operand (operands[1], E_V8DImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9359; /* clzv8di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !nonimmediate_operand (operands[1], E_V4DImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9361; /* clzv4di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode)
          || !(
#line 29925 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9363; /* clzv2di2 */

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!indirect_branch_operand (operands[0], E_SImode)
          || !
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode))
        return -1;
      return 1207; /* *tablejump_1 */

    case E_DImode:
      if (!indirect_branch_operand (operands[0], E_DImode)
          || !
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode))
        return -1;
      return 1208; /* *tablejump_1 */

    default:
      return -1;
    }
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_337 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x4 = XVECEXP (x1, 0, 1);
      if (pattern300 (x4, 
E_CCmode, 
17) == 0)
        {
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && 
#line 3450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return 103; /* *movstrictqi_xor */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 3450 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed))
                return 104; /* *movstricthi_xor */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      res = recog_338 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 17
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x6), 0))
        return -1;
      switch (pattern943 (x2))
        {
        case 0:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1112 (x2))
                {
                case 0:
                  return 267; /* *addqi_exthi_1 */

                case 1:
                  return 268; /* *addqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1664 (x2))
            {
            case 0:
              return 269; /* *addqi_exthi_2 */

            case 1:
              return 271; /* *addqi_extsi_2 */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) == SUBREG)
            {
              switch (pattern1664 (x2))
                {
                case 0:
                  return 270; /* *subqi_exthi_2 */

                case 1:
                  return 272; /* *subqi_extsi_2 */

                default:
                  break;
                }
            }
          operands[2] = x9;
          if (!general_operand (operands[2], E_QImode))
            return -1;
          switch (pattern1112 (x2))
            {
            case 0:
              return 347; /* *subqi_exthi_1 */

            case 1:
              return 348; /* *subqi_extsi_1 */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1112 (x2))
                {
                case 0:
                  return 627; /* *andqi_exthi_1 */

                case 1:
                  return 630; /* *andqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1664 (x2))
            {
            case 0:
              return 642; /* *andqi_exthi_2 */

            case 1:
              return 645; /* *andqi_extsi_2 */

            default:
              return -1;
            }

        case 3:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1112 (x2))
                {
                case 0:
                  return 628; /* *iorqi_exthi_1 */

                case 1:
                  return 631; /* *iorqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1664 (x2))
            {
            case 0:
              return 643; /* *iorqi_exthi_2 */

            case 1:
              return 646; /* *iorqi_extsi_2 */

            default:
              return -1;
            }

        case 4:
          x8 = XEXP (x6, 0);
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          if (general_operand (operands[2], E_QImode))
            {
              switch (pattern1112 (x2))
                {
                case 0:
                  return 629; /* *xorqi_exthi_1 */

                case 1:
                  return 632; /* *xorqi_extsi_1 */

                default:
                  break;
                }
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern1664 (x2))
            {
            case 0:
              return 644; /* *xorqi_exthi_2 */

            case 1:
              return 647; /* *xorqi_extsi_2 */

            default:
              return -1;
            }

        case 5:
          switch (GET_MODE (x3))
            {
            case E_HImode:
              if (GET_MODE (x6) != E_HImode
                  || !extract_operator (operands[2], E_HImode))
                return -1;
              return 799; /* *negqi_exthi_1 */

            case E_SImode:
              if (GET_MODE (x6) != E_SImode
                  || !extract_operator (operands[2], E_SImode))
                return -1;
              return 800; /* *negqi_extsi_1 */

            default:
              return -1;
            }

        case 6:
          switch (pattern1113 (x2))
            {
            case 0:
              return 911; /* *ashlqi_exthi_1 */

            case 1:
              return 912; /* *ashlqi_extsi_1 */

            default:
              return -1;
            }

        case 7:
          x8 = XEXP (x6, 0);
          if (GET_MODE (x8) == E_DImode
              && pattern1114 (x2) == 0
              && (
#line 16759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 925; /* lshrdi3_doubleword_lowpart */
          if (GET_MODE (x8) != E_QImode)
            return -1;
          switch (pattern1113 (x2))
            {
            case 0:
              return 1005; /* *lshrqi_exthi_1 */

            case 1:
              return 1007; /* *lshrqi_extsi_1 */

            default:
              return -1;
            }

        case 8:
          x8 = XEXP (x6, 0);
          if (GET_MODE (x8) == E_DImode
              && pattern1114 (x2) == 0
              && (
#line 16759 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 926; /* ashrdi3_doubleword_lowpart */
          if (GET_MODE (x8) != E_QImode)
            return -1;
          switch (pattern1113 (x2))
            {
            case 0:
              return 1006; /* *ashrqi_exthi_1 */

            case 1:
              return 1008; /* *ashrqi_extsi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pattern346 (x2) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x10 = XEXP (x3, 2);
      operands[1] = x10;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || !
#line 18983 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          return 1162; /* *btrqi_2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !
#line 18983 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
            return -1;
          return 1163; /* *btrhi_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern300 (x6, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern1039 (x4))
        {
        case 0:
          if (!
#line 4839 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 147; /* zero_extendqisi2_and */

        case 1:
          if (!
#line 4839 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 148; /* zero_extendhisi2_and */

        case 2:
          if (!
#line 4893 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 151; /* zero_extendqihi2_and */

        default:
          return -1;
        }

    case PLUS:
      return recog_349 (x1, insn, pnum_clobbers);

    case MINUS:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern300 (x6, 
E_CCmode, 
17) != 0)
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x8;
          switch (GET_CODE (operands[2]))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              switch (pattern485 (x4))
                {
                case 0:
                  if (!
#line 8144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 322; /* *subqi_1_zexthi */

                case 1:
                  if (!
#line 8144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 324; /* *subqi_1_zextsi */

                case 2:
                  if (!
#line 8158 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 328; /* *subhi_1_zextsi */

                case 3:
                  if (!
#line 8144 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 326; /* *subqi_1_zextdi */

                case 4:
                  if (!
#line 8158 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 330; /* *subhi_1_zextdi */

                default:
                  return -1;
                }

            case LTU:
            case UNLT:
              switch (pattern1296 (x7))
                {
                case 0:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x4) != E_HImode
                      || GET_MODE (x5) != E_QImode
                      || !nonimmediate_operand (operands[1], E_QImode)
                      || !ix86_carry_flag_operator (operands[2], E_QImode)
                      || !
#line 9440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                    return -1;
                  return 423; /* *subqi3_carry_zexthi_0 */

                case 1:
                  switch (pattern1472 (x4, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 9440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 424; /* *subqi3_carry_zextsi_0 */

                    case 1:
                      if (!
#line 9455 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 426; /* *subhi3_carry_zextsi_0 */

                    default:
                      return -1;
                    }

                case 2:
                  switch (pattern1472 (x4, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 9440 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 425; /* *subqi3_carry_zextdi_0 */

                    case 1:
                      if (!
#line 9455 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 427; /* *subhi3_carry_zextdi_0 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case GE:
            case GEU:
              switch (pattern1296 (x7))
                {
                case 0:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x4) != E_HImode
                      || GET_MODE (x5) != E_QImode
                      || !nonimmediate_operand (operands[1], E_QImode)
                      || !ix86_carry_flag_unset_operator (operands[2], E_QImode)
                      || !
#line 9488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                    return -1;
                  return 428; /* *subqi3_carry_zexthi_0r */

                case 1:
                  switch (pattern1473 (x4, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 9488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 429; /* *subqi3_carry_zextsi_0r */

                    case 1:
                      if (!
#line 9503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 431; /* *subhi3_carry_zextsi_0r */

                    default:
                      return -1;
                    }

                case 2:
                  switch (pattern1473 (x4, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 9488 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 430; /* *subqi3_carry_zextdi_0r */

                    case 1:
                      if (!
#line 9503 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                        return -1;
                      return 432; /* *subhi3_carry_zextdi_0r */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x9 = XEXP (x8, 1);
          switch (GET_CODE (x9))
            {
            case LTU:
            case UNLT:
              operands[3] = x9;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 17)
                return -1;
              x11 = XEXP (x9, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x12 = XEXP (x8, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x4) != E_HImode
                      || GET_MODE (x5) != E_QImode
                      || pattern1510 (x8, 
E_QImode) != 0
                      || !
#line 9380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  return 418; /* *subqi3_carry_zexthi */

                case E_SImode:
                  switch (pattern1511 (x4, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 9380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 419; /* *subqi3_carry_zextsi */

                    case 1:
                      if (!
#line 9400 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 421; /* *subhi3_carry_zextsi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern1511 (x4, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 9380 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 420; /* *subqi3_carry_zextdi */

                    case 1:
                      if (!
#line 9400 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                        return -1;
                      return 422; /* *subhi3_carry_zextdi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern300 (x6, 
E_CCmode, 
17) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!immediate_operand (operands[2], E_HImode))
        return -1;
      switch (pattern1306 (x4))
        {
        case 0:
          if (!
#line 10643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
            return -1;
          return 504; /* *imulhisizu */

        case 1:
          if (!
#line 10643 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
            return -1;
          return 506; /* *imulhidizu */

        default:
          return -1;
        }

    case AND:
      switch (pattern486 (x1))
        {
        case 0:
          if (!
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 572; /* *andqi_1_zexthi */

        case 1:
          if (!
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 574; /* *andqi_1_zextsi */

        case 2:
          if (!
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 578; /* *andhi_1_zextsi */

        case 3:
          if (!
#line 12628 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 576; /* *andqi_1_zextdi */

        case 4:
          if (!
#line 12642 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 580; /* *andhi_1_zextdi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern486 (x1))
        {
        case 0:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 685; /* *iorqi_1_zexthi */

        case 1:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 689; /* *iorqi_1_zextsi */

        case 2:
          if (!
#line 13731 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 697; /* *iorhi_1_zextsi */

        case 3:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 693; /* *iorqi_1_zextdi */

        case 4:
          if (!
#line 13731 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 701; /* *iorhi_1_zextdi */

        default:
          return -1;
        }

    case XOR:
      switch (pattern486 (x1))
        {
        case 0:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 687; /* *xorqi_1_zexthi */

        case 1:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 691; /* *xorqi_1_zextsi */

        case 2:
          if (!
#line 13731 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 699; /* *xorhi_1_zextsi */

        case 3:
          if (!
#line 13717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 695; /* *xorqi_1_zextdi */

        case 4:
          if (!
#line 13731 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 703; /* *xorhi_1_zextdi */

        default:
          return -1;
        }

    case NEG:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern300 (x6, 
E_CCmode, 
17) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      switch (pattern488 (x4))
        {
        case 0:
          if (!
#line 14362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 778; /* *negqi_1_zexthi */

        case 1:
          if (!
#line 14362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 780; /* *negqi_1_zextsi */

        case 2:
          if (!
#line 14372 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 784; /* *neghi_1_zextsi */

        case 3:
          if (!
#line 14362 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 782; /* *negqi_1_zextdi */

        case 4:
          if (!
#line 14372 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 786; /* *neghi_1_zextdi */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern490 (x1))
        {
        case 0:
          if (!
#line 16010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 888; /* *ashlqi3_1_zexthi */

        case 1:
          if (!
#line 16010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 890; /* *ashlqi3_1_zextsi */

        case 2:
          if (!
#line 16021 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 894; /* *ashlhi3_1_zextsi */

        case 3:
          if (!
#line 16010 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 892; /* *ashlqi3_1_zextdi */

        case 4:
          if (!
#line 16021 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 896; /* *ashlhi3_1_zextdi */

        default:
          return -1;
        }

    case LSHIFTRT:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x13 = XEXP (x6, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 17
              || GET_MODE (x13) != E_CCmode)
            return -1;
          switch (pattern489 (x4))
            {
            case 0:
              if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 958; /* *lshrqi3_1_zexthi */

            case 1:
              if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 962; /* *lshrqi3_1_zextsi */

            case 2:
              if (!
#line 17468 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 970; /* *lshrhi3_1_zextsi */

            case 3:
              if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 966; /* *lshrqi3_1_zextdi */

            case 4:
              if (!
#line 17468 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 974; /* *lshrhi3_1_zextdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 174)
            return -1;
          x14 = XVECEXP (x6, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_VOIDmode)
              || !
#line 2310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
            return -1;
          return 2097; /* *klshrsi3_1_zext */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern490 (x1))
        {
        case 0:
          if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 960; /* *ashrqi3_1_zexthi */

        case 1:
          if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 964; /* *ashrqi3_1_zextsi */

        case 2:
          if (!
#line 17468 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 972; /* *ashrhi3_1_zextsi */

        case 3:
          if (!
#line 17457 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 968; /* *ashrqi3_1_zextdi */

        case 4:
          if (!
#line 17468 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 976; /* *ashrhi3_1_zextdi */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern490 (x1))
        {
        case 0:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1111; /* *rotlqi3_1_zexthi */

        case 1:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1115; /* *rotlqi3_1_zextsi */

        case 2:
          if (!
#line 18601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1123; /* *rotlhi3_1_zextsi */

        case 3:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1119; /* *rotlqi3_1_zextdi */

        case 4:
          if (!
#line 18601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1127; /* *rotlhi3_1_zextdi */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern490 (x1))
        {
        case 0:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1113; /* *rotrqi3_1_zexthi */

        case 1:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1117; /* *rotrqi3_1_zextsi */

        case 2:
          if (!
#line 18601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1125; /* *rotrhi3_1_zextsi */

        case 3:
          if (!
#line 18590 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1121; /* *rotrqi3_1_zextdi */

        case 4:
          if (!
#line 18601 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1129; /* *rotrhi3_1_zextdi */

        default:
          return -1;
        }

    case CLZ:
      if (pnum_clobbers == NULL
          || pattern492 (x1, 
38) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x14 = XVECEXP (x6, 0, 0);
      operands[2] = x14;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 21641 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_LZCNT))
        return -1;
      *pnum_clobbers = 1;
      return 1262; /* *clzsi2_lzcnt_zext_2_falsedep */

    case POPCOUNT:
      if (pattern491 (x1, 
E_HImode) != 0
          || !
#line 22519 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
        return -1;
      return 1311; /* *popcounthi2_2 */

    case NOT:
      if (pattern492 (x1, 
174) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x14 = XVECEXP (x6, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2233 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
        return -1;
      return 2084; /* *knotsi_1_zext */

    case UNSPEC:
      return recog_348 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (pattern627 (x1))
    {
    case 0:
      switch (XWINT (x5, 0))
        {
        case 0L:
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != PLUS)
            return -1;
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          operands[1] = x4;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          switch (pattern1426 (x3))
            {
            case 0:
              if (!
#line 8750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE))
                return -1;
              return 373; /* *dec_cmovhi */

            case 1:
              if (!
#line 8750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE))
                return -1;
              return 374; /* *dec_cmovsi */

            default:
              return -1;
            }

        case -1L:
          switch (pattern1065 (x2))
            {
            case 0:
              if (!(
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2117; /* *kortest_cmpqi_jcc */

            case 1:
              if (!
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2118; /* *kortest_cmphi_jcc */

            case 2:
              if (!
#line 2422 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2119; /* *kortest_cmpsi_jcc */

            case 3:
              if (!(
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2120; /* *kortest_cmpqi_movqicc */

            case 4:
              if (!
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL))
                return -1;
              return 2121; /* *kortest_cmphi_movqicc */

            case 5:
              if (!(
#line 2458 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE && !TARGET_PARTIAL_REG_STALL) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                return -1;
              return 2122; /* *kortest_cmpsi_movqicc */

            case 6:
              if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2123; /* *kortest_cmpqi_movhicc */

            case 7:
              if (!
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
                return -1;
              return 2125; /* *kortest_cmphi_movhicc */

            case 8:
              if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                return -1;
              return 2127; /* *kortest_cmpsi_movhicc */

            case 9:
              if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1555 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
                return -1;
              return 2124; /* *kortest_cmpqi_movsicc */

            case 10:
              if (!
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))))
                return -1;
              return 2126; /* *kortest_cmphi_movsicc */

            case 11:
              if (!(
#line 2501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_CMOVE
   && !(MEM_P (operands[2]) && MEM_P (operands[3]))) && 
#line 1556 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512BW)))
                return -1;
              return 2128; /* *kortest_cmpsi_movsicc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x9 = XEXP (x4, 0);
      x10 = XEXP (x9, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || XWINT (x5, 0) != 0L)
        return -1;
      switch (pattern1220 (x2))
        {
        case 0:
          x11 = XEXP (x9, 2);
          operands[2] = x11;
          switch (pattern1531 (x3))
            {
            case 0:
              if (
#line 19209 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], SImode))
   && ix86_pre_reload_split ()))
                return 1171; /* *jcc_btsi */
              break;

            case 1:
              if ((
#line 19209 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (CONST_INT_P (operands[2])
       ? (INTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)
	  && INTVAL (operands[2])
	       >= (optimize_function_for_size_p (cfun) ? 8 : 32))
       : !memory_operand (operands[1], DImode))
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1172; /* *jcc_btdi */
              break;

            default:
              break;
            }
          if (GET_CODE (x11) != SUBREG)
            return -1;
          switch (pattern1533 (x3))
            {
            case 0:
              if (!
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1175; /* *jcc_btsi_mask_1 */

            case 1:
              if (!
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1177; /* *jcc_btsi_mask_1 */

            case 2:
              if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1179; /* *jcc_btsi_mask_1 */

            case 3:
              if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1176; /* *jcc_btdi_mask_1 */

            case 4:
              if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1178; /* *jcc_btdi_mask_1 */

            case 5:
              if (!(
#line 19285 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1180; /* *jcc_btdi_mask_1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 19248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1173; /* *jcc_btsi_mask */

        case 2:
          if (!(
#line 19248 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_USE_BT || optimize_function_for_size_p (cfun))
   && (INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1174; /* *jcc_btdi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern324 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 14239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 767; /* *negdi2_doubleword */
              if (!(
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* *negdi_1 */

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x3) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 768; /* *negti2_doubleword */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 770; /* *negqi_1 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 772; /* *neghi_1 */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 14348 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 774; /* *negsi_1 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 14812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              return 821; /* *negsf2_i387_1 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 14812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 823; /* *negdf2_i387_1 */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || GET_MODE (x3) != E_XFmode
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 14812 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
                return -1;
              return 825; /* *negxf2_i387_1 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x3) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode)
                  || !
#line 3134 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
                return -1;
              return 1667; /* negv2qi2 */

            default:
              return -1;
            }

        case 1:
          switch (pattern633 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 14750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 818; /* *negtf2_1 */

            case 1:
              if (!
#line 14836 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              *pnum_clobbers = 1;
              return 827; /* *neghf2_1 */

            case 2:
              if (!
#line 14852 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 829; /* *negsf2_1 */

            case 3:
              if (!
#line 14852 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 831; /* *negdf2_1 */

            case 4:
              if (!
#line 2239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1654; /* *mmx_negv2bf */

            case 5:
              if (!
#line 2239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1656; /* *mmx_negv2hf */

            case 6:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 411 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2133; /* *negv32bf2 */

            case 7:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2135; /* *negv16bf2 */

            case 8:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2137; /* *negv8bf2 */

            case 9:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 413 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2139; /* *negv32hf2 */

            case 10:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2141; /* *negv16hf2 */

            case 11:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2143; /* *negv8hf2 */

            case 12:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2145; /* *negv16sf2 */

            case 13:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2147; /* *negv8sf2 */

            case 14:
              if (!
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2149; /* *negv4sf2 */

            case 15:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 416 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2151; /* *negv8df2 */

            case 16:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2153; /* *negv4df2 */

            case 17:
              if (!(
#line 2589 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2155; /* *negv2df2 */

            default:
              return -1;
            }

        case 2:
          if (!
#line 14397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 787; /* *negqi_1_slp */

        case 3:
          if (!
#line 14397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 788; /* *neghi_1_slp */

        default:
          return -1;
        }

    case ABS:
      switch (pattern326 (x1))
        {
        case 0:
          if ((
#line 14646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 807; /* *nabsdi2_doubleword */
          if (!(
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 816; /* *nabsdi2_1 */

        case 1:
          if (!(
#line 14646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 808; /* *nabsti2_doubleword */

        case 2:
          if (!
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 813; /* *nabsqi2_1 */

        case 3:
          if (!
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 814; /* *nabshi2_1 */

        case 4:
          if (!
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 815; /* *nabssi2_1 */

        case 5:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern950 (x3, 
E_TFmode) != 0
                  || !
#line 14775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 819; /* *nabstf2_1 */

            case E_SFmode:
              if (pattern951 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 14911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
                return -1;
              return 832; /* *nabssf2_1 */

            case E_DFmode:
              if (pattern951 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 14911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
                return -1;
              return 833; /* *nabsdf2_1 */

            case E_V2BFmode:
              if (pattern952 (x3, 
E_V2BFmode) != 0
                  || !
#line 2256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1657; /* *mmx_nabsv2bf2 */

            case E_V2HFmode:
              if (pattern952 (x3, 
E_V2HFmode) != 0
                  || !
#line 2256 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1658; /* *mmx_nabsv2hf2 */

            case E_V16SFmode:
              if (pattern950 (x3, 
E_V16SFmode) != 0
                  || !(
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2156; /* *nabsv16sf2 */

            case E_V8SFmode:
              if (pattern950 (x3, 
E_V8SFmode) != 0
                  || !(
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2157; /* *nabsv8sf2 */

            case E_V4SFmode:
              if (pattern950 (x3, 
E_V4SFmode) != 0
                  || !
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2158; /* *nabsv4sf2 */

            case E_V8DFmode:
              if (pattern950 (x3, 
E_V8DFmode) != 0
                  || !(
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2159; /* *nabsv8df2 */

            case E_V4DFmode:
              if (pattern950 (x3, 
E_V4DFmode) != 0
                  || !(
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2160; /* *nabsv4df2 */

            case E_V2DFmode:
              if (pattern950 (x3, 
E_V2DFmode) != 0
                  || !(
#line 2614 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 376 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2161; /* *nabsv2df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x4;
      if (pattern504 (operands[1]) != 0
          || pattern302 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          return 1449; /* *x86_movqicc_0_m1_neg */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          return 1450; /* *x86_movhicc_0_m1_neg */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 1451; /* *x86_movsicc_0_m1_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 153)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != 154)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SCRATCH)
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 4)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x13 = XVECEXP (x9, 0, 3);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XVECEXP (x6, 0, 1);
  if (!register_operand (x16, E_V4DImode))
    return -1;
  x17 = XVECEXP (x6, 0, 2);
  if (!const1248_operand (x17, E_SImode))
    return -1;
  x18 = XEXP (x14, 0);
  operands[1] = x18;
  x19 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x19))
    {
    case REG:
    case SUBREG:
      operands[2] = x19;
      operands[7] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[3] = x20;
      operands[4] = x16;
      operands[6] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[5] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1695 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9027; /* *avx2_gatherdiv8si_3 */

            case 1:
              if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9029; /* *avx2_gatherdiv8si_3 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1695 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9028; /* *avx2_gatherdiv8sf_3 */

            case 1:
              if (!(
#line 29394 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9030; /* *avx2_gatherdiv8sf_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PC:
      operands[6] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[2] = x20;
      operands[3] = x16;
      operands[5] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[4] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1691 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9031; /* *avx2_gatherdiv8si_4 */

            case 1:
              if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9033; /* *avx2_gatherdiv8si_4 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1691 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9032; /* *avx2_gatherdiv8sf_4 */

            case 1:
              if (!(
#line 29418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9034; /* *avx2_gatherdiv8sf_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x7) != USE)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case ASHIFT:
          x10 = XEXP (x9, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          switch (pattern1124 (x1))
            {
            case 0:
              x12 = XEXP (x6, 1);
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != ASHIFT)
                return -1;
              x14 = XEXP (x13, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
                  || pattern1219 (x1) != 0)
                return -1;
              x15 = XEXP (x9, 0);
              operands[5] = x15;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              x17 = XEXP (x12, 1);
              operands[4] = x17;
              x18 = XEXP (x13, 0);
              if (!rtx_equal_p (x18, operands[5]))
                return -1;
              switch (pattern1603 (x1))
                {
                case 0:
                  if (pattern1686 (x1, 
E_SImode) != 0
                      || !(
#line 25745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1427; /* *rep_movsi */

                case 1:
                  if (pattern1686 (x1, 
E_DImode) != 0
                      || !(
#line 25745 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1428; /* *rep_movsi */

                default:
                  return -1;
                }

            case 1:
              x15 = XEXP (x9, 0);
              operands[4] = x15;
              switch (pattern1514 (x1, 
E_SImode))
                {
                case 0:
                  if (pattern1641 (x5, 
E_SImode) != 0
                      || !(
#line 25942 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1437; /* *rep_stossi */

                case 1:
                  if (pattern1641 (x5, 
E_DImode) != 0
                      || !(
#line 25942 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1438; /* *rep_stossi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (pattern1124 (x1))
            {
            case 0:
              if (pattern1219 (x1) != 0)
                return -1;
              x11 = XEXP (x5, 1);
              operands[5] = x11;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              x12 = XEXP (x6, 1);
              x13 = XEXP (x12, 0);
              operands[4] = x13;
              x17 = XEXP (x12, 1);
              if (!rtx_equal_p (x17, operands[5]))
                return -1;
              switch (pattern1603 (x1))
                {
                case 0:
                  if (pattern1668 (x1, 
E_SImode) != 0
                      || !(
#line 25763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1429; /* *rep_movqi */

                case 1:
                  if (pattern1668 (x1, 
E_DImode) != 0
                      || !(
#line 25763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1430; /* *rep_movqi */

                default:
                  return -1;
                }

            case 1:
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              switch (pattern1514 (x1, 
E_QImode))
                {
                case 0:
                  if (pattern1622 (x5, 
E_SImode) != 0
                      || !(
#line 25959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
                    return -1;
                  return 1439; /* *rep_stosqi */

                case 1:
                  if (pattern1622 (x5, 
E_DImode) != 0
                      || !(
#line 25959 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
                    return -1;
                  return 1440; /* *rep_stosqi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      if (pattern217 (x1) != 0)
        return -1;
      x19 = XEXP (x3, 1);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 0);
      operands[4] = x21;
      x22 = XEXP (x19, 1);
      x23 = XEXP (x22, 0);
      operands[5] = x23;
      x4 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x6, 0);
      operands[0] = x16;
      x24 = XVECEXP (x1, 0, 3);
      x25 = XEXP (x24, 0);
      operands[1] = x25;
      x7 = XVECEXP (x1, 0, 4);
      x26 = XEXP (x7, 0);
      operands[2] = x26;
      switch (GET_MODE (operands[6]))
        {
        case E_SImode:
          if (pattern1692 (
E_SImode) != 0
              || !(
#line 26090 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1443; /* *cmpstrnqi_1 */

        case E_DImode:
          if (pattern1692 (
E_DImode) != 0
              || !(
#line 26090 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!(fixed_regs[CX_REG] || fixed_regs[SI_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1444; /* *cmpstrnqi_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!push_operand (operands[0], E_DFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DFmode
          || !fp_register_operand (operands[1], E_SFmode))
        return NULL;
      if ((
#line 5258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
        return gen_split_45 (insn, operands);
      if (!(
#line 5258 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_46 (insn, operands);

    case E_XFmode:
      if (!push_operand (operands[0], E_XFmode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_XFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fp_register_operand (operands[1], E_SFmode))
            return NULL;
          if ((
#line 5265 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_47 (insn, operands);
          if (!(
#line 5265 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_48 (insn, operands);

        case E_DFmode:
          if (!fp_register_operand (operands[1], E_DFmode))
            return NULL;
          if ((
#line 5265 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_49 (insn, operands);
          if (!(
#line 5265 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)))
            return NULL;
          return gen_split_50 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pattern335 (x3) != 0
          || !(
#line 3748 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_13 (insn, operands);

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x7;
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern775 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_130 (insn, operands);

                case E_HImode:
                  if (pattern775 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_132 (insn, operands);

                case E_SImode:
                  if (pattern775 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_134 (insn, operands);

                case E_DImode:
                  if (pattern776 (x3, 
E_DImode) != 0
                      || !((
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14153 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_372 (insn, operands);

                case E_TImode:
                  if (pattern776 (x3, 
E_TImode) != 0
                      || !((
#line 14139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14153 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_375 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return NULL;
              operands[1] = x6;
              if (!register_operand (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_QImode))
                return NULL;
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !((
#line 14062 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14064 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            case LSHIFTRT:
              if (pattern759 (x3, 
E_SImode) != 0)
                return NULL;
              operands[4] = x6;
              if (!nonimmediate_operand (operands[4], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return NULL;
              x9 = XEXP (x7, 1);
              operands[3] = x9;
              if (!const_0_to_31_operand (operands[3], E_QImode)
                  || !(
#line 15709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 15713 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_465 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern339 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_360 (insn, operands);

            case 1:
              if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_378 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_384 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern339 (x3))
            {
            case 0:
              if (!((
#line 14098 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14100 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_363 (insn, operands);

            case 1:
              if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_381 (insn, operands);

            case 2:
              if (!((
#line 14171 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14185 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_387 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern342 (x3))
        {
        case 0:
          if (!((
#line 14079 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_357 (insn, operands);

        case 1:
          if (!((
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_366 (insn, operands);

        case 2:
          if (!((
#line 14123 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14125 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_369 (insn, operands);

        case 3:
          if (!((
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_390 (insn, operands);

        case 4:
          if (!((
#line 14200 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14211 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_393 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_SImode))
        return NULL;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_0_to_31_operand (operands[2], E_QImode))
        return NULL;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x7, 1);
      operands[3] = x9;
      if (!const_0_to_31_operand (operands[3], E_QImode)
          || !(
#line 17093 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 17097 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_498 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern533 (x1, 
E_CCCmode) != 0
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return NULL;
      x10 = XEXP (x7, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return NULL;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return NULL;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern1515 (x10, 
E_DImode) != 0
              || !((
#line 10081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 10083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_166 (insn, operands);

        case E_TImode:
          if (pattern1515 (x10, 
E_TImode) != 0
              || !((
#line 10081 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10083 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_167 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
          switch (pattern748 (x1))
            {
            case 0:
              if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_282 (insn, operands);

            case 1:
              if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_285 (insn, operands);

            case 2:
              if (!((
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          operands[1] = x3;
          if (!compare_operator (operands[1], E_VOIDmode)
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[2] = x14;
          if (!general_reg_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return NULL;
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 13418 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && LEGACY_INT_REG_P (operands[2])
   && !REX_INT_REG_P (operands[3])
   && !reg_overlap_mentioned_p (operands[2], operands[3])))
            return NULL;
          return gen_split_316 (insn, operands);

        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return NULL;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != AND)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != NEG)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[3] = x13;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return NULL;
          operands[4] = x3;
          if (!compare_operator (operands[4], E_VOIDmode))
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x6 = XEXP (x4, 1);
          if (!rtx_equal_p (x6, operands[1]))
            return NULL;
          switch (pattern1353 (x1))
            {
            case 0:
              if (!
#line 21825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
                return NULL;
              return gen_split_741 (insn, operands);

            case 1:
              if (!(
#line 21825 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_742 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || pattern617 (x1, 
SET, 
E_CCZmode, 
17) != 0)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          if (pattern1305 (x10) != 0
              || GET_MODE (x3) != E_CCZmode
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          if (!rtx_equal_p (x6, operands[1]))
            return NULL;
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return NULL;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 21962 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21964 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_746 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern536 (x1, 
IOR))
        {
        case 0:
          if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_283 (insn, operands);

        case 1:
          if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_286 (insn, operands);

        case 2:
          if (!((
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern536 (x1, 
XOR))
        {
        case 0:
          if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_284 (insn, operands);

        case 1:
          if (!(
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_287 (insn, operands);

        case 2:
          if (!((
#line 13139 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13143 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_290 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return NULL;
      x13 = XEXP (x2, 0);
      operands[0] = x13;
      if (!flags_reg_operand (operands[0], E_VOIDmode))
        return NULL;
      operands[2] = x3;
      if (!compare_operator (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return NULL;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[3], E_QImode)
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || GET_MODE (x10) != E_QImode
                  || !
#line 15094 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_449 (insn, operands);

            case E_HImode:
              if (!nonimmediate_operand (operands[3], E_HImode)
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || GET_MODE (x10) != E_HImode
                  || !
#line 15094 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_450 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || GET_MODE (x10) != E_SImode
                  || !
#line 15094 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_451 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[3], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || GET_MODE (x10) != E_DImode
                  || !(
#line 15094 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_452 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_DImode)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != NOT
              || GET_MODE (x11) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !nonimmediate_operand (operands[3], E_SImode)
              || !register_operand (operands[1], E_DImode))
            return NULL;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[3])
              || !
#line 15121 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return NULL;
          return gen_split_453 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 17
          || GET_MODE (x13) != E_CCCmode)
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return NULL;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != CTZ
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !(
#line 21014 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21016 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_728 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern324 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_395 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x3) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14239 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14241 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_396 (insn, operands);

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_SFmode)
                  && fp_register_operand (operands[1], E_SFmode)
                  && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_418 (insn, operands);
              if (!general_reg_operand (operands[0], E_SFmode)
                  || !general_reg_operand (operands[1], E_SFmode)
                  || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_424 (insn, operands);

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_DFmode)
                  && fp_register_operand (operands[1], E_DFmode)
                  && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_420 (insn, operands);
              if (!general_reg_operand (operands[0], E_DFmode)
                  || !general_reg_operand (operands[1], E_DFmode)
                  || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_426 (insn, operands);

            case E_XFmode:
              if (GET_MODE (x3) != E_XFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_XFmode)
                  && fp_register_operand (operands[1], E_XFmode)
                  && 
#line 14819 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_422 (insn, operands);
              if (!general_reg_operand (operands[0], E_XFmode)
                  || !general_reg_operand (operands[1], E_XFmode)
                  || !
#line 14826 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_428 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (pattern760 (x1) != 0
              || !(
#line 14750 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14752 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 2:
          if (!(
#line 14397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 14401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_397 (insn, operands);

        case 3:
          if (!(
#line 14397 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 14401 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_398 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      switch (pattern326 (x1))
        {
        case 0:
          if (((
#line 14646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return gen_split_404 (insn, operands);
          if (!((
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_413 (insn, operands);

        case 1:
          if (!((
#line 14646 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14649 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 2:
          if (!(
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_410 (insn, operands);

        case 3:
          if (!(
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_411 (insn, operands);

        case 4:
          if (!(
#line 14717 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14721 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_412 (insn, operands);

        case 5:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern950 (x3, 
E_TFmode) != 0
                  || !(
#line 14775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14777 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_416 (insn, operands);

            case E_SFmode:
              if (pattern951 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 14911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH) && 
#line 14913 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_443 (insn, operands);

            case E_DFmode:
              if (pattern951 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 14911 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH) && 
#line 14913 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_444 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern300 (x6, 
E_CCmode, 
17) != 0
          || !mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!mask_reg_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_0_to_31_operand (operands[2], E_VOIDmode)
          || !
#line 2323 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && reload_completed))
        return NULL;
      return gen_split_1020 (insn, operands);

    case UNSPEC:
      switch (pattern496 (x1))
        {
        case 0:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1123 (insn, operands);

        case 1:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1144 (insn, operands);

        case 2:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1150 (insn, operands);

        case 3:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1186 (insn, operands);

        case 4:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1195 (insn, operands);

        case 5:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1126 (insn, operands);

        case 6:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1129 (insn, operands);

        case 7:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1132 (insn, operands);

        case 8:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1135 (insn, operands);

        case 9:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1138 (insn, operands);

        case 10:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1147 (insn, operands);

        case 11:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1153 (insn, operands);

        case 12:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1156 (insn, operands);

        case 13:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1159 (insn, operands);

        case 14:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1162 (insn, operands);

        case 15:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1165 (insn, operands);

        case 16:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1198 (insn, operands);

        case 17:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1141 (insn, operands);

        case 18:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1189 (insn, operands);

        case 19:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1192 (insn, operands);

        case 20:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1183 (insn, operands);

        case 21:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1124 (insn, operands);

        case 22:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1145 (insn, operands);

        case 23:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1151 (insn, operands);

        case 24:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1187 (insn, operands);

        case 25:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 26:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1127 (insn, operands);

        case 27:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1130 (insn, operands);

        case 28:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1133 (insn, operands);

        case 29:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1136 (insn, operands);

        case 30:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1139 (insn, operands);

        case 31:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1148 (insn, operands);

        case 32:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1154 (insn, operands);

        case 33:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1157 (insn, operands);

        case 34:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1160 (insn, operands);

        case 35:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1163 (insn, operands);

        case 36:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1166 (insn, operands);

        case 37:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 38:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1142 (insn, operands);

        case 39:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1190 (insn, operands);

        case 40:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1193 (insn, operands);

        case 41:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1184 (insn, operands);

        case 42:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1125 (insn, operands);

        case 43:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1146 (insn, operands);

        case 44:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1152 (insn, operands);

        case 45:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1188 (insn, operands);

        case 46:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 47:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1128 (insn, operands);

        case 48:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1131 (insn, operands);

        case 49:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1134 (insn, operands);

        case 50:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1137 (insn, operands);

        case 51:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1140 (insn, operands);

        case 52:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1149 (insn, operands);

        case 53:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1155 (insn, operands);

        case 54:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1158 (insn, operands);

        case 55:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1161 (insn, operands);

        case 56:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1164 (insn, operands);

        case 57:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1167 (insn, operands);

        case 58:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 59:
          if (!((
#line 4439 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4445 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1143 (insn, operands);

        case 60:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1191 (insn, operands);

        case 61:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1194 (insn, operands);

        case 62:
          if (!((
#line 4528 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4533 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1185 (insn, operands);

        case 63:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1213 (insn, operands);

        case 64:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1216 (insn, operands);

        case 65:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1225 (insn, operands);

        case 66:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1231 (insn, operands);

        case 67:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1219 (insn, operands);

        case 68:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1222 (insn, operands);

        case 69:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1228 (insn, operands);

        case 70:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1232 (insn, operands);

        case 71:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1233 (insn, operands);

        case 72:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1234 (insn, operands);

        case 73:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1235 (insn, operands);

        case 74:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1236 (insn, operands);

        case 75:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1214 (insn, operands);

        case 76:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1217 (insn, operands);

        case 77:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1226 (insn, operands);

        case 78:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1237 (insn, operands);

        case 79:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1220 (insn, operands);

        case 80:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1223 (insn, operands);

        case 81:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1229 (insn, operands);

        case 82:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1238 (insn, operands);

        case 83:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1239 (insn, operands);

        case 84:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1240 (insn, operands);

        case 85:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1241 (insn, operands);

        case 86:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1242 (insn, operands);

        case 87:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1215 (insn, operands);

        case 88:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1218 (insn, operands);

        case 89:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1227 (insn, operands);

        case 90:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1243 (insn, operands);

        case 91:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1221 (insn, operands);

        case 92:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1224 (insn, operands);

        case 93:
          if (!((
#line 4638 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4644 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1230 (insn, operands);

        case 94:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1244 (insn, operands);

        case 95:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1245 (insn, operands);

        case 96:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1246 (insn, operands);

        case 97:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1247 (insn, operands);

        case 98:
          if (!((
#line 4728 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4734 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1248 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern467 (x2))
            {
            case 0:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1439 (insn, operands);

            case 1:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1466 (insn, operands);

            case 2:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1493 (insn, operands);

            case 3:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1520 (insn, operands);

            case 4:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 5:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1574 (insn, operands);

            case 6:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1601 (insn, operands);

            case 7:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1628 (insn, operands);

            case 8:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1655 (insn, operands);

            case 9:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1682 (insn, operands);

            case 10:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1709 (insn, operands);

            case 11:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1736 (insn, operands);

            case 12:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1442 (insn, operands);

            case 13:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1469 (insn, operands);

            case 14:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1496 (insn, operands);

            case 15:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1523 (insn, operands);

            case 16:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 17:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1577 (insn, operands);

            case 18:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1604 (insn, operands);

            case 19:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1631 (insn, operands);

            case 20:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1658 (insn, operands);

            case 21:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1685 (insn, operands);

            case 22:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1712 (insn, operands);

            case 23:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1739 (insn, operands);

            case 24:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1445 (insn, operands);

            case 25:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1472 (insn, operands);

            case 26:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1499 (insn, operands);

            case 27:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1526 (insn, operands);

            case 28:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1553 (insn, operands);

            case 29:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1580 (insn, operands);

            case 30:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1607 (insn, operands);

            case 31:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1634 (insn, operands);

            case 32:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1661 (insn, operands);

            case 33:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1688 (insn, operands);

            case 34:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1715 (insn, operands);

            case 35:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1742 (insn, operands);

            case 36:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2735 (insn, operands);

            case 37:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2744 (insn, operands);

            case 38:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2753 (insn, operands);

            case 39:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2762 (insn, operands);

            case 40:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2771 (insn, operands);

            case 41:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2780 (insn, operands);

            case 42:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2789 (insn, operands);

            case 43:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2798 (insn, operands);

            case 44:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2807 (insn, operands);

            case 45:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2816 (insn, operands);

            case 46:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2825 (insn, operands);

            case 47:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2834 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2114 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2195 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2276 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2330 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2357 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2384 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2144 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2225 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2306 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2333 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2360 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2387 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2093 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2120 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2147 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2174 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2201 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2228 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2255 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2282 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2309 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2336 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2363 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2390 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern467 (x2))
            {
            case 0:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1448 (insn, operands);

            case 1:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1475 (insn, operands);

            case 2:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1502 (insn, operands);

            case 3:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1529 (insn, operands);

            case 4:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1556 (insn, operands);

            case 5:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1583 (insn, operands);

            case 6:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1610 (insn, operands);

            case 7:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1637 (insn, operands);

            case 8:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1664 (insn, operands);

            case 9:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1691 (insn, operands);

            case 10:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1718 (insn, operands);

            case 11:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1745 (insn, operands);

            case 12:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1451 (insn, operands);

            case 13:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1478 (insn, operands);

            case 14:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1505 (insn, operands);

            case 15:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1532 (insn, operands);

            case 16:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1559 (insn, operands);

            case 17:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1586 (insn, operands);

            case 18:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1613 (insn, operands);

            case 19:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1640 (insn, operands);

            case 20:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1667 (insn, operands);

            case 21:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1694 (insn, operands);

            case 22:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1721 (insn, operands);

            case 23:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1748 (insn, operands);

            case 24:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1454 (insn, operands);

            case 25:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1481 (insn, operands);

            case 26:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1508 (insn, operands);

            case 27:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1535 (insn, operands);

            case 28:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1562 (insn, operands);

            case 29:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1589 (insn, operands);

            case 30:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1616 (insn, operands);

            case 31:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1643 (insn, operands);

            case 32:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1670 (insn, operands);

            case 33:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1697 (insn, operands);

            case 34:
              if (!((
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1724 (insn, operands);

            case 35:
              if (!(
#line 13763 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13775 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1751 (insn, operands);

            case 36:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2738 (insn, operands);

            case 37:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2747 (insn, operands);

            case 38:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2756 (insn, operands);

            case 39:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2765 (insn, operands);

            case 40:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2774 (insn, operands);

            case 41:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2783 (insn, operands);

            case 42:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2792 (insn, operands);

            case 43:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2801 (insn, operands);

            case 44:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2810 (insn, operands);

            case 45:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2819 (insn, operands);

            case 46:
              if (!((
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2828 (insn, operands);

            case 47:
              if (!(
#line 13932 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13936 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2837 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2096 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2123 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2150 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2177 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2204 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2231 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2258 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2285 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2312 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2339 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2366 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2099 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2126 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2153 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2180 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2207 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2234 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2261 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2288 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2315 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2342 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2369 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2396 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern469 (x2))
            {
            case 0:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 1:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 2:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2156 (insn, operands);

            case 3:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 4:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 5:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 6:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2264 (insn, operands);

            case 7:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 8:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2318 (insn, operands);

            case 9:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2345 (insn, operands);

            case 10:
              if (!((
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2372 (insn, operands);

            case 11:
              if (!(
#line 13848 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13860 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2399 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      return split_59 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern543 (x2))
        {
        case 0:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3134 (insn, operands);

        case 1:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3135 (insn, operands);

        case 2:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3136 (insn, operands);

        case 3:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3137 (insn, operands);

        case 4:
          if (!
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3138 (insn, operands);

        case 5:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3139 (insn, operands);

        case 6:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3140 (insn, operands);

        case 7:
          if (!
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3141 (insn, operands);

        case 8:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3142 (insn, operands);

        case 9:
          if (!
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3143 (insn, operands);

        case 10:
          if (!(
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3144 (insn, operands);

        case 11:
          if (!
#line 18634 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3145 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1078 (x2, 
E_HImode) != 0
              || !
#line 26443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_185 (insn, operands);

        case E_SImode:
          if (pattern1078 (x2, 
E_SImode) != 0
              || !
#line 26443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_186 (insn, operands);

        case E_DImode:
          if (pattern1078 (x2, 
E_DImode) != 0
              || !(
#line 26443 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_CMOVE && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()) && 
#line 1164 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_187 (insn, operands);

        case E_SFmode:
          if (!general_reg_operand (operands[0], E_SFmode)
              || pattern1138 (x2, 
E_SFmode) != 0
              || !
#line 26695 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((SFmode != DFmode || TARGET_64BIT)
   && TARGET_80387 && TARGET_CMOVE
   && TARGET_AVOID_MEM_OPND_FOR_CMOVE
   && (MEM_P (operands[2]) || MEM_P (operands[3]))
   && optimize_insn_for_speed_p ()))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_194 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_QImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (pattern356 (x3, 
UNSPEC_VOLATILE, 
3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) == 4
      && XINT (x5, 1) == 109
      && GET_MODE (x5) == E_QImode)
    {
      res = peephole2_35 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 110
      || GET_MODE (x5) != E_QImode)
    return NULL;
  x6 = XEXP (x1, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x7 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_QImode
      || pattern1364 (x3) != 0
      || !memory_operand (operands[1], E_QImode)
      || pattern1538 (x3) != 0)
    return NULL;
  x9 = PATTERN (peep2_next_insn (2));
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 1);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_QImode))
    return NULL;
  x12 = XEXP (x10, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 724 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/sync.md"
(peep2_reg_dead_p (3, operands[0])
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2])
      == -(unsigned HOST_WIDE_INT) INTVAL (operands[3])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_391 (insn, operands);
}

 rtx_insn *
peephole2_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UMUL_HIGHPART)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return NULL;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  x14 = XEXP (x12, 1);
  operands[5] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern1430 (x1, 
E_SImode) != 0
          || !(
#line 10970 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1235 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_110 (insn, operands);

    case E_DImode:
      if (pattern1430 (x1, 
E_DImode) != 0
          || !(
#line 10970 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_BMI2
   && ((REGNO (operands[5]) == REGNO (operands[0])
        && REGNO (operands[1]) != REGNO (operands[4]))
       || (REGNO (operands[5]) == REGNO (operands[1])
	   && REGNO (operands[0]) != REGNO (operands[4])))
   && peep2_reg_dead_p (2, operands[5])) && 
#line 1236 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_111 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!flags_reg_operand (operands[5], E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[4] = x5;
  x6 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  if (!ix86_comparison_operator (x7, E_QImode))
    return NULL;
  operands[2] = x7;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17)
    return NULL;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x10 = XEXP (x6, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x11 = PATTERN (peep2_next_insn (2));
  switch (GET_CODE (x11))
    {
    case SET:
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ZERO_EXTEND)
        return NULL;
      x13 = XEXP (x11, 0);
      operands[3] = x13;
      if (!any_QIreg_operand (operands[3], E_VOIDmode))
        return NULL;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[1])
          || !
#line 19966 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((peep2_reg_dead_p (3, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && ! reg_overlap_mentioned_p (operands[3], operands[4])
   && ! reg_set_p (operands[3], operands[4])
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_156 (insn, operands);

    case PARALLEL:
      if (XVECLEN (x11, 0) != 2)
        return NULL;
      x15 = XVECEXP (x11, 0, 0);
      if (GET_CODE (x15) != SET)
        return NULL;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ZERO_EXTEND
          || pattern1575 (x11, 
E_VOIDmode) != 0)
        return NULL;
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1])
          || !
#line 20038 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((peep2_reg_dead_p (3, operands[1])
    || operands_match_p (operands[1], operands[3]))
   && ! reg_overlap_mentioned_p (operands[3], operands[0])
   && ! reg_overlap_mentioned_p (operands[3], operands[4])
   && ! reg_set_p (operands[3], operands[4])
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_159 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return peephole2_48 (x1, insn, pmatch_len_);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return peephole2_47 (x1, insn, pmatch_len_);

        case 6:
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4
              || pattern36 (x1) != 0
              || !register_operand (operands[4], E_VOIDmode))
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          x3 = XEXP (x2, 1);
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 0);
          operands[5] = x5;
          if (!register_operand (operands[5], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          operands[6] = x7;
          if (!register_operand (operands[6], E_VOIDmode))
            return NULL;
          x8 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!immediate_operand (operands[3], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 3);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x12 = XVECEXP (x1, 0, 4);
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x14 = XVECEXP (x1, 0, 5);
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          x16 = PATTERN (peep2_next_insn (1));
          if (pattern1701 (x16) != 0
              || !
#line 26178 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (4, operands[7]) && peep2_reg_dead_p (4, operands[8])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_183 (insn, operands);

        case 5:
          if (peep2_current_count < 2
              || peep2_current_count < 3
              || peep2_current_count < 4)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != IF_THEN_ELSE
              || pattern217 (x1) != 0
              || !register_operand (operands[6], E_VOIDmode))
            return NULL;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 0);
          x17 = XEXP (x5, 0);
          operands[4] = x17;
          if (!register_operand (operands[4], E_VOIDmode))
            return NULL;
          x18 = XEXP (x4, 1);
          x19 = XEXP (x18, 0);
          operands[5] = x19;
          if (!register_operand (operands[5], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!immediate_operand (operands[3], E_SImode))
            return NULL;
          x8 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x10 = XVECEXP (x1, 0, 3);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          x12 = XVECEXP (x1, 0, 4);
          x13 = XEXP (x12, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          x16 = PATTERN (peep2_next_insn (1));
          if (pattern1701 (x16) != 0
              || !
#line 26209 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(peep2_reg_dead_p (4, operands[7]) && peep2_reg_dead_p (4, operands[8])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_184 (insn, operands);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case UNSPEC:
              if (peep2_current_count < 2
                  || XVECLEN (x3, 0) != 1
                  || XINT (x3, 1) != 92)
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return NULL;
              x20 = XEXP (x6, 1);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 17
                  || GET_MODE (x9) != E_CCmode)
                return NULL;
              x21 = XEXP (x2, 0);
              operands[0] = x21;
              x22 = XVECEXP (x3, 0, 0);
              operands[1] = x22;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!general_reg_operand (operands[2], E_VOIDmode))
                return NULL;
              x16 = PATTERN (peep2_next_insn (1));
              if (GET_CODE (x16) != SET)
                return NULL;
              x23 = XEXP (x16, 0);
              operands[3] = x23;
              x24 = XEXP (x16, 1);
              operands[4] = x24;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!memory_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !memory_operand (operands[1], E_SImode))
                    return NULL;
                  if (general_reg_operand (operands[3], E_VOIDmode)
                      && const0_operand (operands[4], E_VOIDmode)
                      && (
#line 27459 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && GET_MODE_SIZE (GET_MODE (operands[3])) <= UNITS_PER_WORD
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_217 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_SImode)
                      && general_gr_operand (operands[4], E_SImode)
                      && (
#line 27520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_219 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_DImode)
                      && general_gr_operand (operands[4], E_DImode)
                      && (
#line 27520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_220 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_SImode)
                      && address_no_seg_operand (operands[4], E_SImode)
                      && (
#line 27575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_227 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!general_reg_operand (operands[3], E_DImode)
                      || !address_no_seg_operand (operands[4], E_DImode)
                      || !(
#line 27575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == SImode))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_228 (insn, operands);

                case E_DImode:
                  if (!memory_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !memory_operand (operands[1], E_DImode))
                    return NULL;
                  if (general_reg_operand (operands[3], E_VOIDmode)
                      && const0_operand (operands[4], E_VOIDmode)
                      && (
#line 27459 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && GET_MODE_SIZE (GET_MODE (operands[3])) <= UNITS_PER_WORD
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_218 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_SImode)
                      && general_gr_operand (operands[4], E_SImode)
                      && (
#line 27520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_221 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_DImode)
                      && general_gr_operand (operands[4], E_DImode)
                      && (
#line 27520 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_222 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (general_reg_operand (operands[3], E_SImode)
                      && address_no_seg_operand (operands[4], E_SImode)
                      && (
#line 27575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_229 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!general_reg_operand (operands[3], E_DImode)
                      || !address_no_seg_operand (operands[4], E_DImode)
                      || !(
#line 27575 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(GET_MODE (operands[2]) == word_mode
   && peep2_reg_dead_p (0, operands[3])
   && peep2_reg_dead_p (1, operands[2])) && (((
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1167 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 1408 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(ptr_mode == DImode))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_230 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (pattern358 (x2) != 0)
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern300 (x6, 
E_CCmode, 
17) != 0)
                return NULL;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != MEM
                  || GET_MODE (x9) != E_BLKmode)
                return NULL;
              x25 = XEXP (x9, 0);
              if (GET_CODE (x25) != SCRATCH)
                return NULL;
              switch (pattern1310 (x2))
                {
                case 0:
                  if ((
#line 28625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_324 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_325 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_328 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_329 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28681 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_340 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28681 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_341 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28696 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_344 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28696 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_345 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_348 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!(
#line 28709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == SImode))))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_349 (insn, operands);

                case 1:
                  if ((
#line 28625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_326 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28625 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_327 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_330 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28639 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_PUSH || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == -2*GET_MODE_SIZE (word_mode)
   && !ix86_red_zone_used) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_331 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28681 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_342 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28681 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_SINGLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == GET_MODE_SIZE (word_mode)) && (((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_343 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28696 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_346 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28696 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
((TARGET_DOUBLE_POP || optimize_insn_for_size_p ())
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_347 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 28709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == SImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_350 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!(
#line 28709 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(optimize_insn_for_size_p ()
   && INTVAL (operands[0]) == 2*GET_MODE_SIZE (word_mode)) && ((((((((((
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1403 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(word_mode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode)) && 
#line 1398 "../../../../../../../work-shared/gcc-15.1.0-r0/gcc-15.1.0/gcc/config/i386/i386.md"
(Pmode == DImode))))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_351 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
